(function(){function r(e,n,t){function o(i,f){if(!n[i]){if(!e[i]){var c="function"==typeof require&&require;if(!f&&c)return c(i,!0);if(u)return u(i,!0);var a=new Error("Cannot find module '"+i+"'");throw a.code="MODULE_NOT_FOUND",a}var p=n[i]={exports:{}};e[i][0].call(p.exports,function(r){var n=e[i][1][r];return o(n||r)},p,p.exports,r,e,n,t)}return n[i].exports}for(var u="function"==typeof require&&require,i=0;i<t.length;i++)o(t[i]);return o}return r})()({1:[function(require,module,exports){
module.exports = require('./lib/axios');
},{"./lib/axios":3}],2:[function(require,module,exports){
'use strict';

var utils = require('./../utils');
var settle = require('./../core/settle');
var buildURL = require('./../helpers/buildURL');
var parseHeaders = require('./../helpers/parseHeaders');
var isURLSameOrigin = require('./../helpers/isURLSameOrigin');
var createError = require('../core/createError');

module.exports = function xhrAdapter(config) {
  return new Promise(function dispatchXhrRequest(resolve, reject) {
    var requestData = config.data;
    var requestHeaders = config.headers;

    if (utils.isFormData(requestData)) {
      delete requestHeaders['Content-Type']; // Let the browser set it
    }

    var request = new XMLHttpRequest();

    // HTTP basic authentication
    if (config.auth) {
      var username = config.auth.username || '';
      var password = config.auth.password || '';
      requestHeaders.Authorization = 'Basic ' + btoa(username + ':' + password);
    }

    request.open(config.method.toUpperCase(), buildURL(config.url, config.params, config.paramsSerializer), true);

    // Set the request timeout in MS
    request.timeout = config.timeout;

    // Listen for ready state
    request.onreadystatechange = function handleLoad() {
      if (!request || request.readyState !== 4) {
        return;
      }

      // The request errored out and we didn't get a response, this will be
      // handled by onerror instead
      // With one exception: request that using file: protocol, most browsers
      // will return status as 0 even though it's a successful request
      if (request.status === 0 && !(request.responseURL && request.responseURL.indexOf('file:') === 0)) {
        return;
      }

      // Prepare the response
      var responseHeaders = 'getAllResponseHeaders' in request ? parseHeaders(request.getAllResponseHeaders()) : null;
      var responseData = !config.responseType || config.responseType === 'text' ? request.responseText : request.response;
      var response = {
        data: responseData,
        status: request.status,
        statusText: request.statusText,
        headers: responseHeaders,
        config: config,
        request: request
      };

      settle(resolve, reject, response);

      // Clean up request
      request = null;
    };

    // Handle low level network errors
    request.onerror = function handleError() {
      // Real errors are hidden from us by the browser
      // onerror should only fire if it's a network error
      reject(createError('Network Error', config, null, request));

      // Clean up request
      request = null;
    };

    // Handle timeout
    request.ontimeout = function handleTimeout() {
      reject(createError('timeout of ' + config.timeout + 'ms exceeded', config, 'ECONNABORTED',
        request));

      // Clean up request
      request = null;
    };

    // Add xsrf header
    // This is only done if running in a standard browser environment.
    // Specifically not if we're in a web worker, or react-native.
    if (utils.isStandardBrowserEnv()) {
      var cookies = require('./../helpers/cookies');

      // Add xsrf header
      var xsrfValue = (config.withCredentials || isURLSameOrigin(config.url)) && config.xsrfCookieName ?
          cookies.read(config.xsrfCookieName) :
          undefined;

      if (xsrfValue) {
        requestHeaders[config.xsrfHeaderName] = xsrfValue;
      }
    }

    // Add headers to the request
    if ('setRequestHeader' in request) {
      utils.forEach(requestHeaders, function setRequestHeader(val, key) {
        if (typeof requestData === 'undefined' && key.toLowerCase() === 'content-type') {
          // Remove Content-Type if data is undefined
          delete requestHeaders[key];
        } else {
          // Otherwise add header to the request
          request.setRequestHeader(key, val);
        }
      });
    }

    // Add withCredentials to request if needed
    if (config.withCredentials) {
      request.withCredentials = true;
    }

    // Add responseType to request if needed
    if (config.responseType) {
      try {
        request.responseType = config.responseType;
      } catch (e) {
        // Expected DOMException thrown by browsers not compatible XMLHttpRequest Level 2.
        // But, this can be suppressed for 'json' type as it can be parsed by default 'transformResponse' function.
        if (config.responseType !== 'json') {
          throw e;
        }
      }
    }

    // Handle progress if needed
    if (typeof config.onDownloadProgress === 'function') {
      request.addEventListener('progress', config.onDownloadProgress);
    }

    // Not all browsers support upload events
    if (typeof config.onUploadProgress === 'function' && request.upload) {
      request.upload.addEventListener('progress', config.onUploadProgress);
    }

    if (config.cancelToken) {
      // Handle cancellation
      config.cancelToken.promise.then(function onCanceled(cancel) {
        if (!request) {
          return;
        }

        request.abort();
        reject(cancel);
        // Clean up request
        request = null;
      });
    }

    if (requestData === undefined) {
      requestData = null;
    }

    // Send the request
    request.send(requestData);
  });
};

},{"../core/createError":9,"./../core/settle":12,"./../helpers/buildURL":16,"./../helpers/cookies":18,"./../helpers/isURLSameOrigin":20,"./../helpers/parseHeaders":22,"./../utils":24}],3:[function(require,module,exports){
'use strict';

var utils = require('./utils');
var bind = require('./helpers/bind');
var Axios = require('./core/Axios');
var defaults = require('./defaults');

/**
 * Create an instance of Axios
 *
 * @param {Object} defaultConfig The default config for the instance
 * @return {Axios} A new instance of Axios
 */
function createInstance(defaultConfig) {
  var context = new Axios(defaultConfig);
  var instance = bind(Axios.prototype.request, context);

  // Copy axios.prototype to instance
  utils.extend(instance, Axios.prototype, context);

  // Copy context to instance
  utils.extend(instance, context);

  return instance;
}

// Create the default instance to be exported
var axios = createInstance(defaults);

// Expose Axios class to allow class inheritance
axios.Axios = Axios;

// Factory for creating new instances
axios.create = function create(instanceConfig) {
  return createInstance(utils.merge(defaults, instanceConfig));
};

// Expose Cancel & CancelToken
axios.Cancel = require('./cancel/Cancel');
axios.CancelToken = require('./cancel/CancelToken');
axios.isCancel = require('./cancel/isCancel');

// Expose all/spread
axios.all = function all(promises) {
  return Promise.all(promises);
};
axios.spread = require('./helpers/spread');

module.exports = axios;

// Allow use of default import syntax in TypeScript
module.exports.default = axios;

},{"./cancel/Cancel":4,"./cancel/CancelToken":5,"./cancel/isCancel":6,"./core/Axios":7,"./defaults":14,"./helpers/bind":15,"./helpers/spread":23,"./utils":24}],4:[function(require,module,exports){
'use strict';

/**
 * A `Cancel` is an object that is thrown when an operation is canceled.
 *
 * @class
 * @param {string=} message The message.
 */
function Cancel(message) {
  this.message = message;
}

Cancel.prototype.toString = function toString() {
  return 'Cancel' + (this.message ? ': ' + this.message : '');
};

Cancel.prototype.__CANCEL__ = true;

module.exports = Cancel;

},{}],5:[function(require,module,exports){
'use strict';

var Cancel = require('./Cancel');

/**
 * A `CancelToken` is an object that can be used to request cancellation of an operation.
 *
 * @class
 * @param {Function} executor The executor function.
 */
function CancelToken(executor) {
  if (typeof executor !== 'function') {
    throw new TypeError('executor must be a function.');
  }

  var resolvePromise;
  this.promise = new Promise(function promiseExecutor(resolve) {
    resolvePromise = resolve;
  });

  var token = this;
  executor(function cancel(message) {
    if (token.reason) {
      // Cancellation has already been requested
      return;
    }

    token.reason = new Cancel(message);
    resolvePromise(token.reason);
  });
}

/**
 * Throws a `Cancel` if cancellation has been requested.
 */
CancelToken.prototype.throwIfRequested = function throwIfRequested() {
  if (this.reason) {
    throw this.reason;
  }
};

/**
 * Returns an object that contains a new `CancelToken` and a function that, when called,
 * cancels the `CancelToken`.
 */
CancelToken.source = function source() {
  var cancel;
  var token = new CancelToken(function executor(c) {
    cancel = c;
  });
  return {
    token: token,
    cancel: cancel
  };
};

module.exports = CancelToken;

},{"./Cancel":4}],6:[function(require,module,exports){
'use strict';

module.exports = function isCancel(value) {
  return !!(value && value.__CANCEL__);
};

},{}],7:[function(require,module,exports){
'use strict';

var defaults = require('./../defaults');
var utils = require('./../utils');
var InterceptorManager = require('./InterceptorManager');
var dispatchRequest = require('./dispatchRequest');

/**
 * Create a new instance of Axios
 *
 * @param {Object} instanceConfig The default config for the instance
 */
function Axios(instanceConfig) {
  this.defaults = instanceConfig;
  this.interceptors = {
    request: new InterceptorManager(),
    response: new InterceptorManager()
  };
}

/**
 * Dispatch a request
 *
 * @param {Object} config The config specific for this request (merged with this.defaults)
 */
Axios.prototype.request = function request(config) {
  /*eslint no-param-reassign:0*/
  // Allow for axios('example/url'[, config]) a la fetch API
  if (typeof config === 'string') {
    config = utils.merge({
      url: arguments[0]
    }, arguments[1]);
  }

  config = utils.merge(defaults, {method: 'get'}, this.defaults, config);
  config.method = config.method.toLowerCase();

  // Hook up interceptors middleware
  var chain = [dispatchRequest, undefined];
  var promise = Promise.resolve(config);

  this.interceptors.request.forEach(function unshiftRequestInterceptors(interceptor) {
    chain.unshift(interceptor.fulfilled, interceptor.rejected);
  });

  this.interceptors.response.forEach(function pushResponseInterceptors(interceptor) {
    chain.push(interceptor.fulfilled, interceptor.rejected);
  });

  while (chain.length) {
    promise = promise.then(chain.shift(), chain.shift());
  }

  return promise;
};

// Provide aliases for supported request methods
utils.forEach(['delete', 'get', 'head', 'options'], function forEachMethodNoData(method) {
  /*eslint func-names:0*/
  Axios.prototype[method] = function(url, config) {
    return this.request(utils.merge(config || {}, {
      method: method,
      url: url
    }));
  };
});

utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  /*eslint func-names:0*/
  Axios.prototype[method] = function(url, data, config) {
    return this.request(utils.merge(config || {}, {
      method: method,
      url: url,
      data: data
    }));
  };
});

module.exports = Axios;

},{"./../defaults":14,"./../utils":24,"./InterceptorManager":8,"./dispatchRequest":10}],8:[function(require,module,exports){
'use strict';

var utils = require('./../utils');

function InterceptorManager() {
  this.handlers = [];
}

/**
 * Add a new interceptor to the stack
 *
 * @param {Function} fulfilled The function to handle `then` for a `Promise`
 * @param {Function} rejected The function to handle `reject` for a `Promise`
 *
 * @return {Number} An ID used to remove interceptor later
 */
InterceptorManager.prototype.use = function use(fulfilled, rejected) {
  this.handlers.push({
    fulfilled: fulfilled,
    rejected: rejected
  });
  return this.handlers.length - 1;
};

/**
 * Remove an interceptor from the stack
 *
 * @param {Number} id The ID that was returned by `use`
 */
InterceptorManager.prototype.eject = function eject(id) {
  if (this.handlers[id]) {
    this.handlers[id] = null;
  }
};

/**
 * Iterate over all the registered interceptors
 *
 * This method is particularly useful for skipping over any
 * interceptors that may have become `null` calling `eject`.
 *
 * @param {Function} fn The function to call for each interceptor
 */
InterceptorManager.prototype.forEach = function forEach(fn) {
  utils.forEach(this.handlers, function forEachHandler(h) {
    if (h !== null) {
      fn(h);
    }
  });
};

module.exports = InterceptorManager;

},{"./../utils":24}],9:[function(require,module,exports){
'use strict';

var enhanceError = require('./enhanceError');

/**
 * Create an Error with the specified message, config, error code, request and response.
 *
 * @param {string} message The error message.
 * @param {Object} config The config.
 * @param {string} [code] The error code (for example, 'ECONNABORTED').
 * @param {Object} [request] The request.
 * @param {Object} [response] The response.
 * @returns {Error} The created error.
 */
module.exports = function createError(message, config, code, request, response) {
  var error = new Error(message);
  return enhanceError(error, config, code, request, response);
};

},{"./enhanceError":11}],10:[function(require,module,exports){
'use strict';

var utils = require('./../utils');
var transformData = require('./transformData');
var isCancel = require('../cancel/isCancel');
var defaults = require('../defaults');
var isAbsoluteURL = require('./../helpers/isAbsoluteURL');
var combineURLs = require('./../helpers/combineURLs');

/**
 * Throws a `Cancel` if cancellation has been requested.
 */
function throwIfCancellationRequested(config) {
  if (config.cancelToken) {
    config.cancelToken.throwIfRequested();
  }
}

/**
 * Dispatch a request to the server using the configured adapter.
 *
 * @param {object} config The config that is to be used for the request
 * @returns {Promise} The Promise to be fulfilled
 */
module.exports = function dispatchRequest(config) {
  throwIfCancellationRequested(config);

  // Support baseURL config
  if (config.baseURL && !isAbsoluteURL(config.url)) {
    config.url = combineURLs(config.baseURL, config.url);
  }

  // Ensure headers exist
  config.headers = config.headers || {};

  // Transform request data
  config.data = transformData(
    config.data,
    config.headers,
    config.transformRequest
  );

  // Flatten headers
  config.headers = utils.merge(
    config.headers.common || {},
    config.headers[config.method] || {},
    config.headers || {}
  );

  utils.forEach(
    ['delete', 'get', 'head', 'post', 'put', 'patch', 'common'],
    function cleanHeaderConfig(method) {
      delete config.headers[method];
    }
  );

  var adapter = config.adapter || defaults.adapter;

  return adapter(config).then(function onAdapterResolution(response) {
    throwIfCancellationRequested(config);

    // Transform response data
    response.data = transformData(
      response.data,
      response.headers,
      config.transformResponse
    );

    return response;
  }, function onAdapterRejection(reason) {
    if (!isCancel(reason)) {
      throwIfCancellationRequested(config);

      // Transform response data
      if (reason && reason.response) {
        reason.response.data = transformData(
          reason.response.data,
          reason.response.headers,
          config.transformResponse
        );
      }
    }

    return Promise.reject(reason);
  });
};

},{"../cancel/isCancel":6,"../defaults":14,"./../helpers/combineURLs":17,"./../helpers/isAbsoluteURL":19,"./../utils":24,"./transformData":13}],11:[function(require,module,exports){
'use strict';

/**
 * Update an Error with the specified config, error code, and response.
 *
 * @param {Error} error The error to update.
 * @param {Object} config The config.
 * @param {string} [code] The error code (for example, 'ECONNABORTED').
 * @param {Object} [request] The request.
 * @param {Object} [response] The response.
 * @returns {Error} The error.
 */
module.exports = function enhanceError(error, config, code, request, response) {
  error.config = config;
  if (code) {
    error.code = code;
  }
  error.request = request;
  error.response = response;
  return error;
};

},{}],12:[function(require,module,exports){
'use strict';

var createError = require('./createError');

/**
 * Resolve or reject a Promise based on response status.
 *
 * @param {Function} resolve A function that resolves the promise.
 * @param {Function} reject A function that rejects the promise.
 * @param {object} response The response.
 */
module.exports = function settle(resolve, reject, response) {
  var validateStatus = response.config.validateStatus;
  // Note: status is not exposed by XDomainRequest
  if (!response.status || !validateStatus || validateStatus(response.status)) {
    resolve(response);
  } else {
    reject(createError(
      'Request failed with status code ' + response.status,
      response.config,
      null,
      response.request,
      response
    ));
  }
};

},{"./createError":9}],13:[function(require,module,exports){
'use strict';

var utils = require('./../utils');

/**
 * Transform the data for a request or a response
 *
 * @param {Object|String} data The data to be transformed
 * @param {Array} headers The headers for the request or response
 * @param {Array|Function} fns A single function or Array of functions
 * @returns {*} The resulting transformed data
 */
module.exports = function transformData(data, headers, fns) {
  /*eslint no-param-reassign:0*/
  utils.forEach(fns, function transform(fn) {
    data = fn(data, headers);
  });

  return data;
};

},{"./../utils":24}],14:[function(require,module,exports){
(function (process){(function (){
'use strict';

var utils = require('./utils');
var normalizeHeaderName = require('./helpers/normalizeHeaderName');

var DEFAULT_CONTENT_TYPE = {
  'Content-Type': 'application/x-www-form-urlencoded'
};

function setContentTypeIfUnset(headers, value) {
  if (!utils.isUndefined(headers) && utils.isUndefined(headers['Content-Type'])) {
    headers['Content-Type'] = value;
  }
}

function getDefaultAdapter() {
  var adapter;
  if (typeof XMLHttpRequest !== 'undefined') {
    // For browsers use XHR adapter
    adapter = require('./adapters/xhr');
  } else if (typeof process !== 'undefined') {
    // For node use HTTP adapter
    adapter = require('./adapters/http');
  }
  return adapter;
}

var defaults = {
  adapter: getDefaultAdapter(),

  transformRequest: [function transformRequest(data, headers) {
    normalizeHeaderName(headers, 'Content-Type');
    if (utils.isFormData(data) ||
      utils.isArrayBuffer(data) ||
      utils.isBuffer(data) ||
      utils.isStream(data) ||
      utils.isFile(data) ||
      utils.isBlob(data)
    ) {
      return data;
    }
    if (utils.isArrayBufferView(data)) {
      return data.buffer;
    }
    if (utils.isURLSearchParams(data)) {
      setContentTypeIfUnset(headers, 'application/x-www-form-urlencoded;charset=utf-8');
      return data.toString();
    }
    if (utils.isObject(data)) {
      setContentTypeIfUnset(headers, 'application/json;charset=utf-8');
      return JSON.stringify(data);
    }
    return data;
  }],

  transformResponse: [function transformResponse(data) {
    /*eslint no-param-reassign:0*/
    if (typeof data === 'string') {
      try {
        data = JSON.parse(data);
      } catch (e) { /* Ignore */ }
    }
    return data;
  }],

  /**
   * A timeout in milliseconds to abort a request. If set to 0 (default) a
   * timeout is not created.
   */
  timeout: 0,

  xsrfCookieName: 'XSRF-TOKEN',
  xsrfHeaderName: 'X-XSRF-TOKEN',

  maxContentLength: -1,

  validateStatus: function validateStatus(status) {
    return status >= 200 && status < 300;
  }
};

defaults.headers = {
  common: {
    'Accept': 'application/json, text/plain, */*'
  }
};

utils.forEach(['delete', 'get', 'head'], function forEachMethodNoData(method) {
  defaults.headers[method] = {};
});

utils.forEach(['post', 'put', 'patch'], function forEachMethodWithData(method) {
  defaults.headers[method] = utils.merge(DEFAULT_CONTENT_TYPE);
});

module.exports = defaults;

}).call(this)}).call(this,require('_process'))
},{"./adapters/http":2,"./adapters/xhr":2,"./helpers/normalizeHeaderName":21,"./utils":24,"_process":52}],15:[function(require,module,exports){
'use strict';

module.exports = function bind(fn, thisArg) {
  return function wrap() {
    var args = new Array(arguments.length);
    for (var i = 0; i < args.length; i++) {
      args[i] = arguments[i];
    }
    return fn.apply(thisArg, args);
  };
};

},{}],16:[function(require,module,exports){
'use strict';

var utils = require('./../utils');

function encode(val) {
  return encodeURIComponent(val).
    replace(/%40/gi, '@').
    replace(/%3A/gi, ':').
    replace(/%24/g, '$').
    replace(/%2C/gi, ',').
    replace(/%20/g, '+').
    replace(/%5B/gi, '[').
    replace(/%5D/gi, ']');
}

/**
 * Build a URL by appending params to the end
 *
 * @param {string} url The base of the url (e.g., http://www.google.com)
 * @param {object} [params] The params to be appended
 * @returns {string} The formatted url
 */
module.exports = function buildURL(url, params, paramsSerializer) {
  /*eslint no-param-reassign:0*/
  if (!params) {
    return url;
  }

  var serializedParams;
  if (paramsSerializer) {
    serializedParams = paramsSerializer(params);
  } else if (utils.isURLSearchParams(params)) {
    serializedParams = params.toString();
  } else {
    var parts = [];

    utils.forEach(params, function serialize(val, key) {
      if (val === null || typeof val === 'undefined') {
        return;
      }

      if (utils.isArray(val)) {
        key = key + '[]';
      } else {
        val = [val];
      }

      utils.forEach(val, function parseValue(v) {
        if (utils.isDate(v)) {
          v = v.toISOString();
        } else if (utils.isObject(v)) {
          v = JSON.stringify(v);
        }
        parts.push(encode(key) + '=' + encode(v));
      });
    });

    serializedParams = parts.join('&');
  }

  if (serializedParams) {
    url += (url.indexOf('?') === -1 ? '?' : '&') + serializedParams;
  }

  return url;
};

},{"./../utils":24}],17:[function(require,module,exports){
'use strict';

/**
 * Creates a new URL by combining the specified URLs
 *
 * @param {string} baseURL The base URL
 * @param {string} relativeURL The relative URL
 * @returns {string} The combined URL
 */
module.exports = function combineURLs(baseURL, relativeURL) {
  return relativeURL
    ? baseURL.replace(/\/+$/, '') + '/' + relativeURL.replace(/^\/+/, '')
    : baseURL;
};

},{}],18:[function(require,module,exports){
'use strict';

var utils = require('./../utils');

module.exports = (
  utils.isStandardBrowserEnv() ?

  // Standard browser envs support document.cookie
  (function standardBrowserEnv() {
    return {
      write: function write(name, value, expires, path, domain, secure) {
        var cookie = [];
        cookie.push(name + '=' + encodeURIComponent(value));

        if (utils.isNumber(expires)) {
          cookie.push('expires=' + new Date(expires).toGMTString());
        }

        if (utils.isString(path)) {
          cookie.push('path=' + path);
        }

        if (utils.isString(domain)) {
          cookie.push('domain=' + domain);
        }

        if (secure === true) {
          cookie.push('secure');
        }

        document.cookie = cookie.join('; ');
      },

      read: function read(name) {
        var match = document.cookie.match(new RegExp('(^|;\\s*)(' + name + ')=([^;]*)'));
        return (match ? decodeURIComponent(match[3]) : null);
      },

      remove: function remove(name) {
        this.write(name, '', Date.now() - 86400000);
      }
    };
  })() :

  // Non standard browser env (web workers, react-native) lack needed support.
  (function nonStandardBrowserEnv() {
    return {
      write: function write() {},
      read: function read() { return null; },
      remove: function remove() {}
    };
  })()
);

},{"./../utils":24}],19:[function(require,module,exports){
'use strict';

/**
 * Determines whether the specified URL is absolute
 *
 * @param {string} url The URL to test
 * @returns {boolean} True if the specified URL is absolute, otherwise false
 */
module.exports = function isAbsoluteURL(url) {
  // A URL is considered absolute if it begins with "<scheme>://" or "//" (protocol-relative URL).
  // RFC 3986 defines scheme name as a sequence of characters beginning with a letter and followed
  // by any combination of letters, digits, plus, period, or hyphen.
  return /^([a-z][a-z\d\+\-\.]*:)?\/\//i.test(url);
};

},{}],20:[function(require,module,exports){
'use strict';

var utils = require('./../utils');

module.exports = (
  utils.isStandardBrowserEnv() ?

  // Standard browser envs have full support of the APIs needed to test
  // whether the request URL is of the same origin as current location.
  (function standardBrowserEnv() {
    var msie = /(msie|trident)/i.test(navigator.userAgent);
    var urlParsingNode = document.createElement('a');
    var originURL;

    /**
    * Parse a URL to discover it's components
    *
    * @param {String} url The URL to be parsed
    * @returns {Object}
    */
    function resolveURL(url) {
      var href = url;

      if (msie) {
        // IE needs attribute set twice to normalize properties
        urlParsingNode.setAttribute('href', href);
        href = urlParsingNode.href;
      }

      urlParsingNode.setAttribute('href', href);

      // urlParsingNode provides the UrlUtils interface - http://url.spec.whatwg.org/#urlutils
      return {
        href: urlParsingNode.href,
        protocol: urlParsingNode.protocol ? urlParsingNode.protocol.replace(/:$/, '') : '',
        host: urlParsingNode.host,
        search: urlParsingNode.search ? urlParsingNode.search.replace(/^\?/, '') : '',
        hash: urlParsingNode.hash ? urlParsingNode.hash.replace(/^#/, '') : '',
        hostname: urlParsingNode.hostname,
        port: urlParsingNode.port,
        pathname: (urlParsingNode.pathname.charAt(0) === '/') ?
                  urlParsingNode.pathname :
                  '/' + urlParsingNode.pathname
      };
    }

    originURL = resolveURL(window.location.href);

    /**
    * Determine if a URL shares the same origin as the current location
    *
    * @param {String} requestURL The URL to test
    * @returns {boolean} True if URL shares the same origin, otherwise false
    */
    return function isURLSameOrigin(requestURL) {
      var parsed = (utils.isString(requestURL)) ? resolveURL(requestURL) : requestURL;
      return (parsed.protocol === originURL.protocol &&
            parsed.host === originURL.host);
    };
  })() :

  // Non standard browser envs (web workers, react-native) lack needed support.
  (function nonStandardBrowserEnv() {
    return function isURLSameOrigin() {
      return true;
    };
  })()
);

},{"./../utils":24}],21:[function(require,module,exports){
'use strict';

var utils = require('../utils');

module.exports = function normalizeHeaderName(headers, normalizedName) {
  utils.forEach(headers, function processHeader(value, name) {
    if (name !== normalizedName && name.toUpperCase() === normalizedName.toUpperCase()) {
      headers[normalizedName] = value;
      delete headers[name];
    }
  });
};

},{"../utils":24}],22:[function(require,module,exports){
'use strict';

var utils = require('./../utils');

// Headers whose duplicates are ignored by node
// c.f. https://nodejs.org/api/http.html#http_message_headers
var ignoreDuplicateOf = [
  'age', 'authorization', 'content-length', 'content-type', 'etag',
  'expires', 'from', 'host', 'if-modified-since', 'if-unmodified-since',
  'last-modified', 'location', 'max-forwards', 'proxy-authorization',
  'referer', 'retry-after', 'user-agent'
];

/**
 * Parse headers into an object
 *
 * ```
 * Date: Wed, 27 Aug 2014 08:58:49 GMT
 * Content-Type: application/json
 * Connection: keep-alive
 * Transfer-Encoding: chunked
 * ```
 *
 * @param {String} headers Headers needing to be parsed
 * @returns {Object} Headers parsed into an object
 */
module.exports = function parseHeaders(headers) {
  var parsed = {};
  var key;
  var val;
  var i;

  if (!headers) { return parsed; }

  utils.forEach(headers.split('\n'), function parser(line) {
    i = line.indexOf(':');
    key = utils.trim(line.substr(0, i)).toLowerCase();
    val = utils.trim(line.substr(i + 1));

    if (key) {
      if (parsed[key] && ignoreDuplicateOf.indexOf(key) >= 0) {
        return;
      }
      if (key === 'set-cookie') {
        parsed[key] = (parsed[key] ? parsed[key] : []).concat([val]);
      } else {
        parsed[key] = parsed[key] ? parsed[key] + ', ' + val : val;
      }
    }
  });

  return parsed;
};

},{"./../utils":24}],23:[function(require,module,exports){
'use strict';

/**
 * Syntactic sugar for invoking a function and expanding an array for arguments.
 *
 * Common use case would be to use `Function.prototype.apply`.
 *
 *  ```js
 *  function f(x, y, z) {}
 *  var args = [1, 2, 3];
 *  f.apply(null, args);
 *  ```
 *
 * With `spread` this example can be re-written.
 *
 *  ```js
 *  spread(function(x, y, z) {})([1, 2, 3]);
 *  ```
 *
 * @param {Function} callback
 * @returns {Function}
 */
module.exports = function spread(callback) {
  return function wrap(arr) {
    return callback.apply(null, arr);
  };
};

},{}],24:[function(require,module,exports){
'use strict';

var bind = require('./helpers/bind');
var isBuffer = require('is-buffer');

/*global toString:true*/

// utils is a library of generic helper functions non-specific to axios

var toString = Object.prototype.toString;

/**
 * Determine if a value is an Array
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an Array, otherwise false
 */
function isArray(val) {
  return toString.call(val) === '[object Array]';
}

/**
 * Determine if a value is an ArrayBuffer
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an ArrayBuffer, otherwise false
 */
function isArrayBuffer(val) {
  return toString.call(val) === '[object ArrayBuffer]';
}

/**
 * Determine if a value is a FormData
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an FormData, otherwise false
 */
function isFormData(val) {
  return (typeof FormData !== 'undefined') && (val instanceof FormData);
}

/**
 * Determine if a value is a view on an ArrayBuffer
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a view on an ArrayBuffer, otherwise false
 */
function isArrayBufferView(val) {
  var result;
  if ((typeof ArrayBuffer !== 'undefined') && (ArrayBuffer.isView)) {
    result = ArrayBuffer.isView(val);
  } else {
    result = (val) && (val.buffer) && (val.buffer instanceof ArrayBuffer);
  }
  return result;
}

/**
 * Determine if a value is a String
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a String, otherwise false
 */
function isString(val) {
  return typeof val === 'string';
}

/**
 * Determine if a value is a Number
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Number, otherwise false
 */
function isNumber(val) {
  return typeof val === 'number';
}

/**
 * Determine if a value is undefined
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if the value is undefined, otherwise false
 */
function isUndefined(val) {
  return typeof val === 'undefined';
}

/**
 * Determine if a value is an Object
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is an Object, otherwise false
 */
function isObject(val) {
  return val !== null && typeof val === 'object';
}

/**
 * Determine if a value is a Date
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Date, otherwise false
 */
function isDate(val) {
  return toString.call(val) === '[object Date]';
}

/**
 * Determine if a value is a File
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a File, otherwise false
 */
function isFile(val) {
  return toString.call(val) === '[object File]';
}

/**
 * Determine if a value is a Blob
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Blob, otherwise false
 */
function isBlob(val) {
  return toString.call(val) === '[object Blob]';
}

/**
 * Determine if a value is a Function
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Function, otherwise false
 */
function isFunction(val) {
  return toString.call(val) === '[object Function]';
}

/**
 * Determine if a value is a Stream
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a Stream, otherwise false
 */
function isStream(val) {
  return isObject(val) && isFunction(val.pipe);
}

/**
 * Determine if a value is a URLSearchParams object
 *
 * @param {Object} val The value to test
 * @returns {boolean} True if value is a URLSearchParams object, otherwise false
 */
function isURLSearchParams(val) {
  return typeof URLSearchParams !== 'undefined' && val instanceof URLSearchParams;
}

/**
 * Trim excess whitespace off the beginning and end of a string
 *
 * @param {String} str The String to trim
 * @returns {String} The String freed of excess whitespace
 */
function trim(str) {
  return str.replace(/^\s*/, '').replace(/\s*$/, '');
}

/**
 * Determine if we're running in a standard browser environment
 *
 * This allows axios to run in a web worker, and react-native.
 * Both environments support XMLHttpRequest, but not fully standard globals.
 *
 * web workers:
 *  typeof window -> undefined
 *  typeof document -> undefined
 *
 * react-native:
 *  navigator.product -> 'ReactNative'
 */
function isStandardBrowserEnv() {
  if (typeof navigator !== 'undefined' && navigator.product === 'ReactNative') {
    return false;
  }
  return (
    typeof window !== 'undefined' &&
    typeof document !== 'undefined'
  );
}

/**
 * Iterate over an Array or an Object invoking a function for each item.
 *
 * If `obj` is an Array callback will be called passing
 * the value, index, and complete array for each item.
 *
 * If 'obj' is an Object callback will be called passing
 * the value, key, and complete object for each property.
 *
 * @param {Object|Array} obj The object to iterate
 * @param {Function} fn The callback to invoke for each item
 */
function forEach(obj, fn) {
  // Don't bother if no value provided
  if (obj === null || typeof obj === 'undefined') {
    return;
  }

  // Force an array if not already something iterable
  if (typeof obj !== 'object') {
    /*eslint no-param-reassign:0*/
    obj = [obj];
  }

  if (isArray(obj)) {
    // Iterate over array values
    for (var i = 0, l = obj.length; i < l; i++) {
      fn.call(null, obj[i], i, obj);
    }
  } else {
    // Iterate over object keys
    for (var key in obj) {
      if (Object.prototype.hasOwnProperty.call(obj, key)) {
        fn.call(null, obj[key], key, obj);
      }
    }
  }
}

/**
 * Accepts varargs expecting each argument to be an object, then
 * immutably merges the properties of each object and returns result.
 *
 * When multiple objects contain the same key the later object in
 * the arguments list will take precedence.
 *
 * Example:
 *
 * ```js
 * var result = merge({foo: 123}, {foo: 456});
 * console.log(result.foo); // outputs 456
 * ```
 *
 * @param {Object} obj1 Object to merge
 * @returns {Object} Result of all merge properties
 */
function merge(/* obj1, obj2, obj3, ... */) {
  var result = {};
  function assignValue(val, key) {
    if (typeof result[key] === 'object' && typeof val === 'object') {
      result[key] = merge(result[key], val);
    } else {
      result[key] = val;
    }
  }

  for (var i = 0, l = arguments.length; i < l; i++) {
    forEach(arguments[i], assignValue);
  }
  return result;
}

/**
 * Extends object a by mutably adding to it the properties of object b.
 *
 * @param {Object} a The object to be extended
 * @param {Object} b The object to copy properties from
 * @param {Object} thisArg The object to bind function to
 * @return {Object} The resulting value of object a
 */
function extend(a, b, thisArg) {
  forEach(b, function assignValue(val, key) {
    if (thisArg && typeof val === 'function') {
      a[key] = bind(val, thisArg);
    } else {
      a[key] = val;
    }
  });
  return a;
}

module.exports = {
  isArray: isArray,
  isArrayBuffer: isArrayBuffer,
  isBuffer: isBuffer,
  isFormData: isFormData,
  isArrayBufferView: isArrayBufferView,
  isString: isString,
  isNumber: isNumber,
  isObject: isObject,
  isUndefined: isUndefined,
  isDate: isDate,
  isFile: isFile,
  isBlob: isBlob,
  isFunction: isFunction,
  isStream: isStream,
  isURLSearchParams: isURLSearchParams,
  isStandardBrowserEnv: isStandardBrowserEnv,
  forEach: forEach,
  merge: merge,
  extend: extend,
  trim: trim
};

},{"./helpers/bind":15,"is-buffer":48}],25:[function(require,module,exports){

},{}],26:[function(require,module,exports){
'use strict';

var GetIntrinsic = require('get-intrinsic');

var callBind = require('./');

var $indexOf = callBind(GetIntrinsic('String.prototype.indexOf'));

module.exports = function callBoundIntrinsic(name, allowMissing) {
	var intrinsic = GetIntrinsic(name, !!allowMissing);
	if (typeof intrinsic === 'function' && $indexOf(name, '.prototype.') > -1) {
		return callBind(intrinsic);
	}
	return intrinsic;
};

},{"./":27,"get-intrinsic":30}],27:[function(require,module,exports){
'use strict';

var bind = require('function-bind');
var GetIntrinsic = require('get-intrinsic');

var $apply = GetIntrinsic('%Function.prototype.apply%');
var $call = GetIntrinsic('%Function.prototype.call%');
var $reflectApply = GetIntrinsic('%Reflect.apply%', true) || bind.call($call, $apply);

var $gOPD = GetIntrinsic('%Object.getOwnPropertyDescriptor%', true);
var $defineProperty = GetIntrinsic('%Object.defineProperty%', true);
var $max = GetIntrinsic('%Math.max%');

if ($defineProperty) {
	try {
		$defineProperty({}, 'a', { value: 1 });
	} catch (e) {
		// IE 8 has a broken defineProperty
		$defineProperty = null;
	}
}

module.exports = function callBind(originalFunction) {
	var func = $reflectApply(bind, $call, arguments);
	if ($gOPD && $defineProperty) {
		var desc = $gOPD(func, 'length');
		if (desc.configurable) {
			// original length, plus the receiver, minus any additional arguments (after the receiver)
			$defineProperty(
				func,
				'length',
				{ value: 1 + $max(0, originalFunction.length - (arguments.length - 1)) }
			);
		}
	}
	return func;
};

var applyBind = function applyBind() {
	return $reflectApply(bind, $apply, arguments);
};

if ($defineProperty) {
	$defineProperty(module.exports, 'apply', { value: applyBind });
} else {
	module.exports.apply = applyBind;
}

},{"function-bind":29,"get-intrinsic":30}],28:[function(require,module,exports){
'use strict';

/* eslint no-invalid-this: 1 */

var ERROR_MESSAGE = 'Function.prototype.bind called on incompatible ';
var slice = Array.prototype.slice;
var toStr = Object.prototype.toString;
var funcType = '[object Function]';

module.exports = function bind(that) {
    var target = this;
    if (typeof target !== 'function' || toStr.call(target) !== funcType) {
        throw new TypeError(ERROR_MESSAGE + target);
    }
    var args = slice.call(arguments, 1);

    var bound;
    var binder = function () {
        if (this instanceof bound) {
            var result = target.apply(
                this,
                args.concat(slice.call(arguments))
            );
            if (Object(result) === result) {
                return result;
            }
            return this;
        } else {
            return target.apply(
                that,
                args.concat(slice.call(arguments))
            );
        }
    };

    var boundLength = Math.max(0, target.length - args.length);
    var boundArgs = [];
    for (var i = 0; i < boundLength; i++) {
        boundArgs.push('$' + i);
    }

    bound = Function('binder', 'return function (' + boundArgs.join(',') + '){ return binder.apply(this,arguments); }')(binder);

    if (target.prototype) {
        var Empty = function Empty() {};
        Empty.prototype = target.prototype;
        bound.prototype = new Empty();
        Empty.prototype = null;
    }

    return bound;
};

},{}],29:[function(require,module,exports){
'use strict';

var implementation = require('./implementation');

module.exports = Function.prototype.bind || implementation;

},{"./implementation":28}],30:[function(require,module,exports){
'use strict';

var undefined;

var $SyntaxError = SyntaxError;
var $Function = Function;
var $TypeError = TypeError;

// eslint-disable-next-line consistent-return
var getEvalledConstructor = function (expressionSyntax) {
	try {
		return $Function('"use strict"; return (' + expressionSyntax + ').constructor;')();
	} catch (e) {}
};

var $gOPD = Object.getOwnPropertyDescriptor;
if ($gOPD) {
	try {
		$gOPD({}, '');
	} catch (e) {
		$gOPD = null; // this is IE 8, which has a broken gOPD
	}
}

var throwTypeError = function () {
	throw new $TypeError();
};
var ThrowTypeError = $gOPD
	? (function () {
		try {
			// eslint-disable-next-line no-unused-expressions, no-caller, no-restricted-properties
			arguments.callee; // IE 8 does not throw here
			return throwTypeError;
		} catch (calleeThrows) {
			try {
				// IE 8 throws on Object.getOwnPropertyDescriptor(arguments, '')
				return $gOPD(arguments, 'callee').get;
			} catch (gOPDthrows) {
				return throwTypeError;
			}
		}
	}())
	: throwTypeError;

var hasSymbols = require('has-symbols')();

var getProto = Object.getPrototypeOf || function (x) { return x.__proto__; }; // eslint-disable-line no-proto

var needsEval = {};

var TypedArray = typeof Uint8Array === 'undefined' ? undefined : getProto(Uint8Array);

var INTRINSICS = {
	'%AggregateError%': typeof AggregateError === 'undefined' ? undefined : AggregateError,
	'%Array%': Array,
	'%ArrayBuffer%': typeof ArrayBuffer === 'undefined' ? undefined : ArrayBuffer,
	'%ArrayIteratorPrototype%': hasSymbols ? getProto([][Symbol.iterator]()) : undefined,
	'%AsyncFromSyncIteratorPrototype%': undefined,
	'%AsyncFunction%': needsEval,
	'%AsyncGenerator%': needsEval,
	'%AsyncGeneratorFunction%': needsEval,
	'%AsyncIteratorPrototype%': needsEval,
	'%Atomics%': typeof Atomics === 'undefined' ? undefined : Atomics,
	'%BigInt%': typeof BigInt === 'undefined' ? undefined : BigInt,
	'%Boolean%': Boolean,
	'%DataView%': typeof DataView === 'undefined' ? undefined : DataView,
	'%Date%': Date,
	'%decodeURI%': decodeURI,
	'%decodeURIComponent%': decodeURIComponent,
	'%encodeURI%': encodeURI,
	'%encodeURIComponent%': encodeURIComponent,
	'%Error%': Error,
	'%eval%': eval, // eslint-disable-line no-eval
	'%EvalError%': EvalError,
	'%Float32Array%': typeof Float32Array === 'undefined' ? undefined : Float32Array,
	'%Float64Array%': typeof Float64Array === 'undefined' ? undefined : Float64Array,
	'%FinalizationRegistry%': typeof FinalizationRegistry === 'undefined' ? undefined : FinalizationRegistry,
	'%Function%': $Function,
	'%GeneratorFunction%': needsEval,
	'%Int8Array%': typeof Int8Array === 'undefined' ? undefined : Int8Array,
	'%Int16Array%': typeof Int16Array === 'undefined' ? undefined : Int16Array,
	'%Int32Array%': typeof Int32Array === 'undefined' ? undefined : Int32Array,
	'%isFinite%': isFinite,
	'%isNaN%': isNaN,
	'%IteratorPrototype%': hasSymbols ? getProto(getProto([][Symbol.iterator]())) : undefined,
	'%JSON%': typeof JSON === 'object' ? JSON : undefined,
	'%Map%': typeof Map === 'undefined' ? undefined : Map,
	'%MapIteratorPrototype%': typeof Map === 'undefined' || !hasSymbols ? undefined : getProto(new Map()[Symbol.iterator]()),
	'%Math%': Math,
	'%Number%': Number,
	'%Object%': Object,
	'%parseFloat%': parseFloat,
	'%parseInt%': parseInt,
	'%Promise%': typeof Promise === 'undefined' ? undefined : Promise,
	'%Proxy%': typeof Proxy === 'undefined' ? undefined : Proxy,
	'%RangeError%': RangeError,
	'%ReferenceError%': ReferenceError,
	'%Reflect%': typeof Reflect === 'undefined' ? undefined : Reflect,
	'%RegExp%': RegExp,
	'%Set%': typeof Set === 'undefined' ? undefined : Set,
	'%SetIteratorPrototype%': typeof Set === 'undefined' || !hasSymbols ? undefined : getProto(new Set()[Symbol.iterator]()),
	'%SharedArrayBuffer%': typeof SharedArrayBuffer === 'undefined' ? undefined : SharedArrayBuffer,
	'%String%': String,
	'%StringIteratorPrototype%': hasSymbols ? getProto(''[Symbol.iterator]()) : undefined,
	'%Symbol%': hasSymbols ? Symbol : undefined,
	'%SyntaxError%': $SyntaxError,
	'%ThrowTypeError%': ThrowTypeError,
	'%TypedArray%': TypedArray,
	'%TypeError%': $TypeError,
	'%Uint8Array%': typeof Uint8Array === 'undefined' ? undefined : Uint8Array,
	'%Uint8ClampedArray%': typeof Uint8ClampedArray === 'undefined' ? undefined : Uint8ClampedArray,
	'%Uint16Array%': typeof Uint16Array === 'undefined' ? undefined : Uint16Array,
	'%Uint32Array%': typeof Uint32Array === 'undefined' ? undefined : Uint32Array,
	'%URIError%': URIError,
	'%WeakMap%': typeof WeakMap === 'undefined' ? undefined : WeakMap,
	'%WeakRef%': typeof WeakRef === 'undefined' ? undefined : WeakRef,
	'%WeakSet%': typeof WeakSet === 'undefined' ? undefined : WeakSet
};

var doEval = function doEval(name) {
	var value;
	if (name === '%AsyncFunction%') {
		value = getEvalledConstructor('async function () {}');
	} else if (name === '%GeneratorFunction%') {
		value = getEvalledConstructor('function* () {}');
	} else if (name === '%AsyncGeneratorFunction%') {
		value = getEvalledConstructor('async function* () {}');
	} else if (name === '%AsyncGenerator%') {
		var fn = doEval('%AsyncGeneratorFunction%');
		if (fn) {
			value = fn.prototype;
		}
	} else if (name === '%AsyncIteratorPrototype%') {
		var gen = doEval('%AsyncGenerator%');
		if (gen) {
			value = getProto(gen.prototype);
		}
	}

	INTRINSICS[name] = value;

	return value;
};

var LEGACY_ALIASES = {
	'%ArrayBufferPrototype%': ['ArrayBuffer', 'prototype'],
	'%ArrayPrototype%': ['Array', 'prototype'],
	'%ArrayProto_entries%': ['Array', 'prototype', 'entries'],
	'%ArrayProto_forEach%': ['Array', 'prototype', 'forEach'],
	'%ArrayProto_keys%': ['Array', 'prototype', 'keys'],
	'%ArrayProto_values%': ['Array', 'prototype', 'values'],
	'%AsyncFunctionPrototype%': ['AsyncFunction', 'prototype'],
	'%AsyncGenerator%': ['AsyncGeneratorFunction', 'prototype'],
	'%AsyncGeneratorPrototype%': ['AsyncGeneratorFunction', 'prototype', 'prototype'],
	'%BooleanPrototype%': ['Boolean', 'prototype'],
	'%DataViewPrototype%': ['DataView', 'prototype'],
	'%DatePrototype%': ['Date', 'prototype'],
	'%ErrorPrototype%': ['Error', 'prototype'],
	'%EvalErrorPrototype%': ['EvalError', 'prototype'],
	'%Float32ArrayPrototype%': ['Float32Array', 'prototype'],
	'%Float64ArrayPrototype%': ['Float64Array', 'prototype'],
	'%FunctionPrototype%': ['Function', 'prototype'],
	'%Generator%': ['GeneratorFunction', 'prototype'],
	'%GeneratorPrototype%': ['GeneratorFunction', 'prototype', 'prototype'],
	'%Int8ArrayPrototype%': ['Int8Array', 'prototype'],
	'%Int16ArrayPrototype%': ['Int16Array', 'prototype'],
	'%Int32ArrayPrototype%': ['Int32Array', 'prototype'],
	'%JSONParse%': ['JSON', 'parse'],
	'%JSONStringify%': ['JSON', 'stringify'],
	'%MapPrototype%': ['Map', 'prototype'],
	'%NumberPrototype%': ['Number', 'prototype'],
	'%ObjectPrototype%': ['Object', 'prototype'],
	'%ObjProto_toString%': ['Object', 'prototype', 'toString'],
	'%ObjProto_valueOf%': ['Object', 'prototype', 'valueOf'],
	'%PromisePrototype%': ['Promise', 'prototype'],
	'%PromiseProto_then%': ['Promise', 'prototype', 'then'],
	'%Promise_all%': ['Promise', 'all'],
	'%Promise_reject%': ['Promise', 'reject'],
	'%Promise_resolve%': ['Promise', 'resolve'],
	'%RangeErrorPrototype%': ['RangeError', 'prototype'],
	'%ReferenceErrorPrototype%': ['ReferenceError', 'prototype'],
	'%RegExpPrototype%': ['RegExp', 'prototype'],
	'%SetPrototype%': ['Set', 'prototype'],
	'%SharedArrayBufferPrototype%': ['SharedArrayBuffer', 'prototype'],
	'%StringPrototype%': ['String', 'prototype'],
	'%SymbolPrototype%': ['Symbol', 'prototype'],
	'%SyntaxErrorPrototype%': ['SyntaxError', 'prototype'],
	'%TypedArrayPrototype%': ['TypedArray', 'prototype'],
	'%TypeErrorPrototype%': ['TypeError', 'prototype'],
	'%Uint8ArrayPrototype%': ['Uint8Array', 'prototype'],
	'%Uint8ClampedArrayPrototype%': ['Uint8ClampedArray', 'prototype'],
	'%Uint16ArrayPrototype%': ['Uint16Array', 'prototype'],
	'%Uint32ArrayPrototype%': ['Uint32Array', 'prototype'],
	'%URIErrorPrototype%': ['URIError', 'prototype'],
	'%WeakMapPrototype%': ['WeakMap', 'prototype'],
	'%WeakSetPrototype%': ['WeakSet', 'prototype']
};

var bind = require('function-bind');
var hasOwn = require('has');
var $concat = bind.call(Function.call, Array.prototype.concat);
var $spliceApply = bind.call(Function.apply, Array.prototype.splice);
var $replace = bind.call(Function.call, String.prototype.replace);
var $strSlice = bind.call(Function.call, String.prototype.slice);

/* adapted from https://github.com/lodash/lodash/blob/4.17.15/dist/lodash.js#L6735-L6744 */
var rePropName = /[^%.[\]]+|\[(?:(-?\d+(?:\.\d+)?)|(["'])((?:(?!\2)[^\\]|\\.)*?)\2)\]|(?=(?:\.|\[\])(?:\.|\[\]|%$))/g;
var reEscapeChar = /\\(\\)?/g; /** Used to match backslashes in property paths. */
var stringToPath = function stringToPath(string) {
	var first = $strSlice(string, 0, 1);
	var last = $strSlice(string, -1);
	if (first === '%' && last !== '%') {
		throw new $SyntaxError('invalid intrinsic syntax, expected closing `%`');
	} else if (last === '%' && first !== '%') {
		throw new $SyntaxError('invalid intrinsic syntax, expected opening `%`');
	}
	var result = [];
	$replace(string, rePropName, function (match, number, quote, subString) {
		result[result.length] = quote ? $replace(subString, reEscapeChar, '$1') : number || match;
	});
	return result;
};
/* end adaptation */

var getBaseIntrinsic = function getBaseIntrinsic(name, allowMissing) {
	var intrinsicName = name;
	var alias;
	if (hasOwn(LEGACY_ALIASES, intrinsicName)) {
		alias = LEGACY_ALIASES[intrinsicName];
		intrinsicName = '%' + alias[0] + '%';
	}

	if (hasOwn(INTRINSICS, intrinsicName)) {
		var value = INTRINSICS[intrinsicName];
		if (value === needsEval) {
			value = doEval(intrinsicName);
		}
		if (typeof value === 'undefined' && !allowMissing) {
			throw new $TypeError('intrinsic ' + name + ' exists, but is not available. Please file an issue!');
		}

		return {
			alias: alias,
			name: intrinsicName,
			value: value
		};
	}

	throw new $SyntaxError('intrinsic ' + name + ' does not exist!');
};

module.exports = function GetIntrinsic(name, allowMissing) {
	if (typeof name !== 'string' || name.length === 0) {
		throw new $TypeError('intrinsic name must be a non-empty string');
	}
	if (arguments.length > 1 && typeof allowMissing !== 'boolean') {
		throw new $TypeError('"allowMissing" argument must be a boolean');
	}

	var parts = stringToPath(name);
	var intrinsicBaseName = parts.length > 0 ? parts[0] : '';

	var intrinsic = getBaseIntrinsic('%' + intrinsicBaseName + '%', allowMissing);
	var intrinsicRealName = intrinsic.name;
	var value = intrinsic.value;
	var skipFurtherCaching = false;

	var alias = intrinsic.alias;
	if (alias) {
		intrinsicBaseName = alias[0];
		$spliceApply(parts, $concat([0, 1], alias));
	}

	for (var i = 1, isOwn = true; i < parts.length; i += 1) {
		var part = parts[i];
		var first = $strSlice(part, 0, 1);
		var last = $strSlice(part, -1);
		if (
			(
				(first === '"' || first === "'" || first === '`')
				|| (last === '"' || last === "'" || last === '`')
			)
			&& first !== last
		) {
			throw new $SyntaxError('property names with quotes must have matching quotes');
		}
		if (part === 'constructor' || !isOwn) {
			skipFurtherCaching = true;
		}

		intrinsicBaseName += '.' + part;
		intrinsicRealName = '%' + intrinsicBaseName + '%';

		if (hasOwn(INTRINSICS, intrinsicRealName)) {
			value = INTRINSICS[intrinsicRealName];
		} else if (value != null) {
			if (!(part in value)) {
				if (!allowMissing) {
					throw new $TypeError('base intrinsic for ' + name + ' exists, but the property is not available.');
				}
				return void undefined;
			}
			if ($gOPD && (i + 1) >= parts.length) {
				var desc = $gOPD(value, part);
				isOwn = !!desc;

				// By convention, when a data property is converted to an accessor
				// property to emulate a data property that does not suffer from
				// the override mistake, that accessor's getter is marked with
				// an `originalValue` property. Here, when we detect this, we
				// uphold the illusion by pretending to see that original data
				// property, i.e., returning the value rather than the getter
				// itself.
				if (isOwn && 'get' in desc && !('originalValue' in desc.get)) {
					value = desc.get;
				} else {
					value = value[part];
				}
			} else {
				isOwn = hasOwn(value, part);
				value = value[part];
			}

			if (isOwn && !skipFurtherCaching) {
				INTRINSICS[intrinsicRealName] = value;
			}
		}
	}
	return value;
};

},{"function-bind":29,"has":33,"has-symbols":31}],31:[function(require,module,exports){
'use strict';

var origSymbol = typeof Symbol !== 'undefined' && Symbol;
var hasSymbolSham = require('./shams');

module.exports = function hasNativeSymbols() {
	if (typeof origSymbol !== 'function') { return false; }
	if (typeof Symbol !== 'function') { return false; }
	if (typeof origSymbol('foo') !== 'symbol') { return false; }
	if (typeof Symbol('bar') !== 'symbol') { return false; }

	return hasSymbolSham();
};

},{"./shams":32}],32:[function(require,module,exports){
'use strict';

/* eslint complexity: [2, 18], max-statements: [2, 33] */
module.exports = function hasSymbols() {
	if (typeof Symbol !== 'function' || typeof Object.getOwnPropertySymbols !== 'function') { return false; }
	if (typeof Symbol.iterator === 'symbol') { return true; }

	var obj = {};
	var sym = Symbol('test');
	var symObj = Object(sym);
	if (typeof sym === 'string') { return false; }

	if (Object.prototype.toString.call(sym) !== '[object Symbol]') { return false; }
	if (Object.prototype.toString.call(symObj) !== '[object Symbol]') { return false; }

	// temp disabled per https://github.com/ljharb/object.assign/issues/17
	// if (sym instanceof Symbol) { return false; }
	// temp disabled per https://github.com/WebReflection/get-own-property-symbols/issues/4
	// if (!(symObj instanceof Symbol)) { return false; }

	// if (typeof Symbol.prototype.toString !== 'function') { return false; }
	// if (String(sym) !== Symbol.prototype.toString.call(sym)) { return false; }

	var symVal = 42;
	obj[sym] = symVal;
	for (sym in obj) { return false; } // eslint-disable-line no-restricted-syntax, no-unreachable-loop
	if (typeof Object.keys === 'function' && Object.keys(obj).length !== 0) { return false; }

	if (typeof Object.getOwnPropertyNames === 'function' && Object.getOwnPropertyNames(obj).length !== 0) { return false; }

	var syms = Object.getOwnPropertySymbols(obj);
	if (syms.length !== 1 || syms[0] !== sym) { return false; }

	if (!Object.prototype.propertyIsEnumerable.call(obj, sym)) { return false; }

	if (typeof Object.getOwnPropertyDescriptor === 'function') {
		var descriptor = Object.getOwnPropertyDescriptor(obj, sym);
		if (descriptor.value !== symVal || descriptor.enumerable !== true) { return false; }
	}

	return true;
};

},{}],33:[function(require,module,exports){
'use strict';

var bind = require('function-bind');

module.exports = bind.call(Function.call, Object.prototype.hasOwnProperty);

},{"function-bind":29}],34:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _utils = require('./utils.js');

var utils = _interopRequireWildcard(_utils);

var _logger = require('./logger.js');

var _logger2 = _interopRequireDefault(_logger);

var _EventEmitter2 = require('./EventEmitter.js');

var _EventEmitter3 = _interopRequireDefault(_EventEmitter2);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

function remove(arr, what) {
  var found = arr.indexOf(what);

  while (found !== -1) {
    arr.splice(found, 1);
    found = arr.indexOf(what);
  }
}

var Connector = function (_EventEmitter) {
  _inherits(Connector, _EventEmitter);

  function Connector(backend, store, services) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    _classCallCheck(this, Connector);

    var _this = _possibleConstructorReturn(this, _EventEmitter.call(this));

    _this.backend = backend;
    _this.store = store;
    _this.languageUtils = services.languageUtils;
    _this.options = options;
    _this.logger = _logger2.default.create('backendConnector');

    _this.state = {};
    _this.queue = [];

    if (_this.backend && _this.backend.init) {
      _this.backend.init(services, options.backend, options);
    }
    return _this;
  }

  Connector.prototype.queueLoad = function queueLoad(languages, namespaces, options, callback) {
    var _this2 = this;

    // find what needs to be loaded
    var toLoad = [];
    var pending = [];
    var toLoadLanguages = [];
    var toLoadNamespaces = [];

    languages.forEach(function (lng) {
      var hasAllNamespaces = true;

      namespaces.forEach(function (ns) {
        var name = lng + '|' + ns;

        if (!options.reload && _this2.store.hasResourceBundle(lng, ns)) {
          _this2.state[name] = 2; // loaded
        } else if (_this2.state[name] < 0) {
          // nothing to do for err
        } else if (_this2.state[name] === 1) {
          if (pending.indexOf(name) < 0) pending.push(name);
        } else {
          _this2.state[name] = 1; // pending

          hasAllNamespaces = false;

          if (pending.indexOf(name) < 0) pending.push(name);
          if (toLoad.indexOf(name) < 0) toLoad.push(name);
          if (toLoadNamespaces.indexOf(ns) < 0) toLoadNamespaces.push(ns);
        }
      });

      if (!hasAllNamespaces) toLoadLanguages.push(lng);
    });

    if (toLoad.length || pending.length) {
      this.queue.push({
        pending: pending,
        loaded: {},
        errors: [],
        callback: callback
      });
    }

    return {
      toLoad: toLoad,
      pending: pending,
      toLoadLanguages: toLoadLanguages,
      toLoadNamespaces: toLoadNamespaces
    };
  };

  Connector.prototype.loaded = function loaded(name, err, data) {
    var _name$split = name.split('|'),
        _name$split2 = _slicedToArray(_name$split, 2),
        lng = _name$split2[0],
        ns = _name$split2[1];

    if (err) this.emit('failedLoading', lng, ns, err);

    if (data) {
      this.store.addResourceBundle(lng, ns, data);
    }

    // set loaded
    this.state[name] = err ? -1 : 2;

    // consolidated loading done in this run - only emit once for a loaded namespace
    var loaded = {};

    // callback if ready
    this.queue.forEach(function (q) {
      utils.pushPath(q.loaded, [lng], ns);
      remove(q.pending, name);

      if (err) q.errors.push(err);

      if (q.pending.length === 0 && !q.done) {
        // only do once per loaded -> this.emit('loaded', q.loaded);
        Object.keys(q.loaded).forEach(function (l) {
          if (!loaded[l]) loaded[l] = [];
          if (q.loaded[l].length) {
            q.loaded[l].forEach(function (ns) {
              if (loaded[l].indexOf(ns) < 0) loaded[l].push(ns);
            });
          }
        });

        /* eslint no-param-reassign: 0 */
        q.done = true;
        if (q.errors.length) {
          q.callback(q.errors);
        } else {
          q.callback();
        }
      }
    });

    // emit consolidated loaded event
    this.emit('loaded', loaded);

    // remove done load requests
    this.queue = this.queue.filter(function (q) {
      return !q.done;
    });
  };

  Connector.prototype.read = function read(lng, ns, fcName) {
    var tried = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : 0;

    var _this3 = this;

    var wait = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : 250;
    var callback = arguments[5];

    if (!lng.length) return callback(null, {}); // noting to load

    return this.backend[fcName](lng, ns, function (err, data) {
      if (err && data /* = retryFlag */ && tried < 5) {
        setTimeout(function () {
          _this3.read.call(_this3, lng, ns, fcName, tried + 1, wait * 2, callback);
        }, wait);
        return;
      }
      callback(err, data);
    });
  };

  /* eslint consistent-return: 0 */


  Connector.prototype.prepareLoading = function prepareLoading(languages, namespaces) {
    var _this4 = this;

    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    var callback = arguments[3];

    if (!this.backend) {
      this.logger.warn('No backend was added via i18next.use. Will not load resources.');
      return callback && callback();
    }

    if (typeof languages === 'string') languages = this.languageUtils.toResolveHierarchy(languages);
    if (typeof namespaces === 'string') namespaces = [namespaces];

    var toLoad = this.queueLoad(languages, namespaces, options, callback);
    if (!toLoad.toLoad.length) {
      if (!toLoad.pending.length) callback(); // nothing to load and no pendings...callback now
      return null; // pendings will trigger callback
    }

    toLoad.toLoad.forEach(function (name) {
      _this4.loadOne(name);
    });
  };

  Connector.prototype.load = function load(languages, namespaces, callback) {
    this.prepareLoading(languages, namespaces, {}, callback);
  };

  Connector.prototype.reload = function reload(languages, namespaces, callback) {
    this.prepareLoading(languages, namespaces, { reload: true }, callback);
  };

  Connector.prototype.loadOne = function loadOne(name) {
    var _this5 = this;

    var prefix = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

    var _name$split3 = name.split('|'),
        _name$split4 = _slicedToArray(_name$split3, 2),
        lng = _name$split4[0],
        ns = _name$split4[1];

    this.read(lng, ns, 'read', null, null, function (err, data) {
      if (err) _this5.logger.warn(prefix + 'loading namespace ' + ns + ' for language ' + lng + ' failed', err);
      if (!err && data) _this5.logger.log(prefix + 'loaded namespace ' + ns + ' for language ' + lng, data);

      _this5.loaded(name, err, data);
    });
  };

  Connector.prototype.saveMissing = function saveMissing(languages, namespace, key, fallbackValue, isUpdate) {
    var options = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : {};

    if (this.backend && this.backend.create) {
      this.backend.create(languages, namespace, key, fallbackValue, null /* unused callback */, _extends({}, options, { isUpdate: isUpdate }));
    }

    // write to store to avoid resending
    if (!languages || !languages[0]) return;
    this.store.addResource(languages[0], namespace, key, fallbackValue);
  };

  return Connector;
}(_EventEmitter3.default);

exports.default = Connector;
},{"./EventEmitter.js":35,"./logger.js":44,"./utils.js":46}],35:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var EventEmitter = function () {
  function EventEmitter() {
    _classCallCheck(this, EventEmitter);

    this.observers = {};
  }

  EventEmitter.prototype.on = function on(events, listener) {
    var _this = this;

    events.split(' ').forEach(function (event) {
      _this.observers[event] = _this.observers[event] || [];
      _this.observers[event].push(listener);
    });
    return this;
  };

  EventEmitter.prototype.off = function off(event, listener) {
    var _this2 = this;

    if (!this.observers[event]) {
      return;
    }

    this.observers[event].forEach(function () {
      if (!listener) {
        delete _this2.observers[event];
      } else {
        var index = _this2.observers[event].indexOf(listener);
        if (index > -1) {
          _this2.observers[event].splice(index, 1);
        }
      }
    });
  };

  EventEmitter.prototype.emit = function emit(event) {
    for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
      args[_key - 1] = arguments[_key];
    }

    if (this.observers[event]) {
      var cloned = [].concat(this.observers[event]);
      cloned.forEach(function (observer) {
        observer.apply(undefined, args);
      });
    }

    if (this.observers['*']) {
      var _cloned = [].concat(this.observers['*']);
      _cloned.forEach(function (observer) {
        observer.apply(observer, [event].concat(args));
      });
    }
  };

  return EventEmitter;
}();

exports.default = EventEmitter;
},{}],36:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _utils = require('./utils.js');

var utils = _interopRequireWildcard(_utils);

var _logger = require('./logger.js');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Interpolator = function () {
  function Interpolator() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};

    _classCallCheck(this, Interpolator);

    this.logger = _logger2.default.create('interpolator');

    this.init(options, true);
  }

  /* eslint no-param-reassign: 0 */


  Interpolator.prototype.init = function init() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var reset = arguments[1];

    if (reset) {
      this.options = options;
      this.format = options.interpolation && options.interpolation.format || function (value) {
        return value;
      };
    }
    if (!options.interpolation) options.interpolation = { escapeValue: true };

    var iOpts = options.interpolation;

    this.escape = iOpts.escape !== undefined ? iOpts.escape : utils.escape;
    this.escapeValue = iOpts.escapeValue !== undefined ? iOpts.escapeValue : true;
    this.useRawValueToEscape = iOpts.useRawValueToEscape !== undefined ? iOpts.useRawValueToEscape : false;

    this.prefix = iOpts.prefix ? utils.regexEscape(iOpts.prefix) : iOpts.prefixEscaped || '{{';
    this.suffix = iOpts.suffix ? utils.regexEscape(iOpts.suffix) : iOpts.suffixEscaped || '}}';

    this.formatSeparator = iOpts.formatSeparator ? iOpts.formatSeparator : iOpts.formatSeparator || ',';

    this.unescapePrefix = iOpts.unescapeSuffix ? '' : iOpts.unescapePrefix || '-';
    this.unescapeSuffix = this.unescapePrefix ? '' : iOpts.unescapeSuffix || '';

    this.nestingPrefix = iOpts.nestingPrefix ? utils.regexEscape(iOpts.nestingPrefix) : iOpts.nestingPrefixEscaped || utils.regexEscape('$t(');
    this.nestingSuffix = iOpts.nestingSuffix ? utils.regexEscape(iOpts.nestingSuffix) : iOpts.nestingSuffixEscaped || utils.regexEscape(')');

    this.maxReplaces = iOpts.maxReplaces ? iOpts.maxReplaces : 1000;

    // the regexp
    this.resetRegExp();
  };

  Interpolator.prototype.reset = function reset() {
    if (this.options) this.init(this.options);
  };

  Interpolator.prototype.resetRegExp = function resetRegExp() {
    // the regexp
    var regexpStr = this.prefix + '(.+?)' + this.suffix;
    this.regexp = new RegExp(regexpStr, 'g');

    var regexpUnescapeStr = '' + this.prefix + this.unescapePrefix + '(.+?)' + this.unescapeSuffix + this.suffix;
    this.regexpUnescape = new RegExp(regexpUnescapeStr, 'g');

    var nestingRegexpStr = this.nestingPrefix + '(.+?)' + this.nestingSuffix;
    this.nestingRegexp = new RegExp(nestingRegexpStr, 'g');
  };

  Interpolator.prototype.interpolate = function interpolate(str, data, lng, options) {
    var _this = this;

    var match = void 0;
    var value = void 0;
    var replaces = void 0;

    function regexSafe(val) {
      return val.replace(/\$/g, '$$$$');
    }

    var handleFormat = function handleFormat(key) {
      if (key.indexOf(_this.formatSeparator) < 0) return utils.getPath(data, key);

      var p = key.split(_this.formatSeparator);
      var k = p.shift().trim();
      var f = p.join(_this.formatSeparator).trim();

      return _this.format(utils.getPath(data, k), f, lng);
    };

    this.resetRegExp();

    var missingInterpolationHandler = options && options.missingInterpolationHandler || this.options.missingInterpolationHandler;

    replaces = 0;
    // unescape if has unescapePrefix/Suffix
    /* eslint no-cond-assign: 0 */
    while (match = this.regexpUnescape.exec(str)) {
      value = handleFormat(match[1].trim());
      str = str.replace(match[0], value);
      this.regexpUnescape.lastIndex = 0;
      replaces++;
      if (replaces >= this.maxReplaces) {
        break;
      }
    }

    replaces = 0;
    // regular escape on demand
    while (match = this.regexp.exec(str)) {
      value = handleFormat(match[1].trim());
      if (value === undefined) {
        if (typeof missingInterpolationHandler === 'function') {
          var temp = missingInterpolationHandler(str, match);
          value = typeof temp === 'string' ? temp : '';
        } else {
          this.logger.warn('missed to pass in variable ' + match[1] + ' for interpolating ' + str);
          value = '';
        }
      } else if (typeof value !== 'string' && !this.useRawValueToEscape) {
        value = utils.makeString(value);
      }
      value = this.escapeValue ? regexSafe(this.escape(value)) : regexSafe(value);
      str = str.replace(match[0], value);
      this.regexp.lastIndex = 0;
      replaces++;
      if (replaces >= this.maxReplaces) {
        break;
      }
    }
    return str;
  };

  Interpolator.prototype.nest = function nest(str, fc) {
    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};

    var match = void 0;
    var value = void 0;

    var clonedOptions = _extends({}, options);
    clonedOptions.applyPostProcessor = false; // avoid post processing on nested lookup

    // if value is something like "myKey": "lorem $(anotherKey, { "count": {{aValueInOptions}} })"
    function handleHasOptions(key, inheritedOptions) {
      if (key.indexOf(',') < 0) return key;

      var p = key.split(',');
      key = p.shift();
      var optionsString = p.join(',');
      optionsString = this.interpolate(optionsString, clonedOptions);
      optionsString = optionsString.replace(/'/g, '"');

      try {
        clonedOptions = JSON.parse(optionsString);

        if (inheritedOptions) clonedOptions = _extends({}, inheritedOptions, clonedOptions);
      } catch (e) {
        this.logger.error('failed parsing options string in nesting for key ' + key, e);
      }

      return key;
    }

    // regular escape on demand
    while (match = this.nestingRegexp.exec(str)) {
      value = fc(handleHasOptions.call(this, match[1].trim(), clonedOptions), clonedOptions);

      // is only the nesting key (key1 = '$(key2)') return the value without stringify
      if (value && match[0] === str && typeof value !== 'string') return value;

      // no string to include or empty
      if (typeof value !== 'string') value = utils.makeString(value);
      if (!value) {
        this.logger.warn('missed to resolve ' + match[1] + ' for nesting ' + str);
        value = '';
      }
      // Nested keys should not be escaped by default #854
      // value = this.escapeValue ? regexSafe(utils.escape(value)) : regexSafe(value);
      str = str.replace(match[0], value);
      this.regexp.lastIndex = 0;
    }
    return str;
  };

  return Interpolator;
}();

exports.default = Interpolator;
},{"./logger.js":44,"./utils.js":46}],37:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _logger = require('./logger.js');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function capitalize(string) {
  return string.charAt(0).toUpperCase() + string.slice(1);
}

var LanguageUtil = function () {
  function LanguageUtil(options) {
    _classCallCheck(this, LanguageUtil);

    this.options = options;

    this.whitelist = this.options.whitelist || false;
    this.logger = _logger2.default.create('languageUtils');
  }

  LanguageUtil.prototype.getScriptPartFromCode = function getScriptPartFromCode(code) {
    if (!code || code.indexOf('-') < 0) return null;

    var p = code.split('-');
    if (p.length === 2) return null;
    p.pop();
    return this.formatLanguageCode(p.join('-'));
  };

  LanguageUtil.prototype.getLanguagePartFromCode = function getLanguagePartFromCode(code) {
    if (!code || code.indexOf('-') < 0) return code;

    var p = code.split('-');
    return this.formatLanguageCode(p[0]);
  };

  LanguageUtil.prototype.formatLanguageCode = function formatLanguageCode(code) {
    // http://www.iana.org/assignments/language-tags/language-tags.xhtml
    if (typeof code === 'string' && code.indexOf('-') > -1) {
      var specialCases = ['hans', 'hant', 'latn', 'cyrl', 'cans', 'mong', 'arab'];
      var p = code.split('-');

      if (this.options.lowerCaseLng) {
        p = p.map(function (part) {
          return part.toLowerCase();
        });
      } else if (p.length === 2) {
        p[0] = p[0].toLowerCase();
        p[1] = p[1].toUpperCase();

        if (specialCases.indexOf(p[1].toLowerCase()) > -1) p[1] = capitalize(p[1].toLowerCase());
      } else if (p.length === 3) {
        p[0] = p[0].toLowerCase();

        // if lenght 2 guess it's a country
        if (p[1].length === 2) p[1] = p[1].toUpperCase();
        if (p[0] !== 'sgn' && p[2].length === 2) p[2] = p[2].toUpperCase();

        if (specialCases.indexOf(p[1].toLowerCase()) > -1) p[1] = capitalize(p[1].toLowerCase());
        if (specialCases.indexOf(p[2].toLowerCase()) > -1) p[2] = capitalize(p[2].toLowerCase());
      }

      return p.join('-');
    }

    return this.options.cleanCode || this.options.lowerCaseLng ? code.toLowerCase() : code;
  };

  LanguageUtil.prototype.isWhitelisted = function isWhitelisted(code) {
    if (this.options.load === 'languageOnly' || this.options.nonExplicitWhitelist) {
      code = this.getLanguagePartFromCode(code);
    }
    return !this.whitelist || !this.whitelist.length || this.whitelist.indexOf(code) > -1;
  };

  LanguageUtil.prototype.getFallbackCodes = function getFallbackCodes(fallbacks, code) {
    if (!fallbacks) return [];
    if (typeof fallbacks === 'string') fallbacks = [fallbacks];
    if (Object.prototype.toString.apply(fallbacks) === '[object Array]') return fallbacks;

    if (!code) return fallbacks.default || [];

    // asume we have an object defining fallbacks
    var found = fallbacks[code];
    if (!found) found = fallbacks[this.getScriptPartFromCode(code)];
    if (!found) found = fallbacks[this.formatLanguageCode(code)];
    if (!found) found = fallbacks.default;

    return found || [];
  };

  LanguageUtil.prototype.toResolveHierarchy = function toResolveHierarchy(code, fallbackCode) {
    var _this = this;

    var fallbackCodes = this.getFallbackCodes(fallbackCode || this.options.fallbackLng || [], code);

    var codes = [];
    var addCode = function addCode(c) {
      if (!c) return;
      if (_this.isWhitelisted(c)) {
        codes.push(c);
      } else {
        _this.logger.warn('rejecting non-whitelisted language code: ' + c);
      }
    };

    if (typeof code === 'string' && code.indexOf('-') > -1) {
      if (this.options.load !== 'languageOnly') addCode(this.formatLanguageCode(code));
      if (this.options.load !== 'languageOnly' && this.options.load !== 'currentOnly') addCode(this.getScriptPartFromCode(code));
      if (this.options.load !== 'currentOnly') addCode(this.getLanguagePartFromCode(code));
    } else if (typeof code === 'string') {
      addCode(this.formatLanguageCode(code));
    }

    fallbackCodes.forEach(function (fc) {
      if (codes.indexOf(fc) < 0) addCode(_this.formatLanguageCode(fc));
    });

    return codes;
  };

  return LanguageUtil;
}();

exports.default = LanguageUtil;
},{"./logger.js":44}],38:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _logger = require('./logger.js');

var _logger2 = _interopRequireDefault(_logger);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

// definition http://translate.sourceforge.net/wiki/l10n/pluralforms
/* eslint-disable */
var sets = [{ lngs: ['ach', 'ak', 'am', 'arn', 'br', 'fil', 'gun', 'ln', 'mfe', 'mg', 'mi', 'oc', 'pt', 'pt-BR', 'tg', 'ti', 'tr', 'uz', 'wa'], nr: [1, 2], fc: 1 }, { lngs: ['af', 'an', 'ast', 'az', 'bg', 'bn', 'ca', 'da', 'de', 'dev', 'el', 'en', 'eo', 'es', 'et', 'eu', 'fi', 'fo', 'fur', 'fy', 'gl', 'gu', 'ha', 'he', 'hi', 'hu', 'hy', 'ia', 'it', 'kn', 'ku', 'lb', 'mai', 'ml', 'mn', 'mr', 'nah', 'nap', 'nb', 'ne', 'nl', 'nn', 'no', 'nso', 'pa', 'pap', 'pms', 'ps', 'pt-PT', 'rm', 'sco', 'se', 'si', 'so', 'son', 'sq', 'sv', 'sw', 'ta', 'te', 'tk', 'ur', 'yo'], nr: [1, 2], fc: 2 }, { lngs: ['ay', 'bo', 'cgg', 'fa', 'id', 'ja', 'jbo', 'ka', 'kk', 'km', 'ko', 'ky', 'lo', 'ms', 'sah', 'su', 'th', 'tt', 'ug', 'vi', 'wo', 'zh'], nr: [1], fc: 3 }, { lngs: ['be', 'bs', 'dz', 'hr', 'ru', 'sr', 'uk'], nr: [1, 2, 5], fc: 4 }, { lngs: ['ar'], nr: [0, 1, 2, 3, 11, 100], fc: 5 }, { lngs: ['cs', 'sk'], nr: [1, 2, 5], fc: 6 }, { lngs: ['csb', 'pl'], nr: [1, 2, 5], fc: 7 }, { lngs: ['cy'], nr: [1, 2, 3, 8], fc: 8 }, { lngs: ['fr'], nr: [1, 2], fc: 9 }, { lngs: ['ga'], nr: [1, 2, 3, 7, 11], fc: 10 }, { lngs: ['gd'], nr: [1, 2, 3, 20], fc: 11 }, { lngs: ['is'], nr: [1, 2], fc: 12 }, { lngs: ['jv'], nr: [0, 1], fc: 13 }, { lngs: ['kw'], nr: [1, 2, 3, 4], fc: 14 }, { lngs: ['lt'], nr: [1, 2, 10], fc: 15 }, { lngs: ['lv'], nr: [1, 2, 0], fc: 16 }, { lngs: ['mk'], nr: [1, 2], fc: 17 }, { lngs: ['mnk'], nr: [0, 1, 2], fc: 18 }, { lngs: ['mt'], nr: [1, 2, 11, 20], fc: 19 }, { lngs: ['or'], nr: [2, 1], fc: 2 }, { lngs: ['ro'], nr: [1, 2, 20], fc: 20 }, { lngs: ['sl'], nr: [5, 1, 2, 3], fc: 21 }];

var _rulesPluralsTypes = {
  1: function _(n) {
    return Number(n > 1);
  },
  2: function _(n) {
    return Number(n != 1);
  },
  3: function _(n) {
    return 0;
  },
  4: function _(n) {
    return Number(n % 10 == 1 && n % 100 != 11 ? 0 : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20) ? 1 : 2);
  },
  5: function _(n) {
    return Number(n === 0 ? 0 : n == 1 ? 1 : n == 2 ? 2 : n % 100 >= 3 && n % 100 <= 10 ? 3 : n % 100 >= 11 ? 4 : 5);
  },
  6: function _(n) {
    return Number(n == 1 ? 0 : n >= 2 && n <= 4 ? 1 : 2);
  },
  7: function _(n) {
    return Number(n == 1 ? 0 : n % 10 >= 2 && n % 10 <= 4 && (n % 100 < 10 || n % 100 >= 20) ? 1 : 2);
  },
  8: function _(n) {
    return Number(n == 1 ? 0 : n == 2 ? 1 : n != 8 && n != 11 ? 2 : 3);
  },
  9: function _(n) {
    return Number(n >= 2);
  },
  10: function _(n) {
    return Number(n == 1 ? 0 : n == 2 ? 1 : n < 7 ? 2 : n < 11 ? 3 : 4);
  },
  11: function _(n) {
    return Number(n == 1 || n == 11 ? 0 : n == 2 || n == 12 ? 1 : n > 2 && n < 20 ? 2 : 3);
  },
  12: function _(n) {
    return Number(n % 10 != 1 || n % 100 == 11);
  },
  13: function _(n) {
    return Number(n !== 0);
  },
  14: function _(n) {
    return Number(n == 1 ? 0 : n == 2 ? 1 : n == 3 ? 2 : 3);
  },
  15: function _(n) {
    return Number(n % 10 == 1 && n % 100 != 11 ? 0 : n % 10 >= 2 && (n % 100 < 10 || n % 100 >= 20) ? 1 : 2);
  },
  16: function _(n) {
    return Number(n % 10 == 1 && n % 100 != 11 ? 0 : n !== 0 ? 1 : 2);
  },
  17: function _(n) {
    return Number(n == 1 || n % 10 == 1 ? 0 : 1);
  },
  18: function _(n) {
    return Number(n == 0 ? 0 : n == 1 ? 1 : 2);
  },
  19: function _(n) {
    return Number(n == 1 ? 0 : n === 0 || n % 100 > 1 && n % 100 < 11 ? 1 : n % 100 > 10 && n % 100 < 20 ? 2 : 3);
  },
  20: function _(n) {
    return Number(n == 1 ? 0 : n === 0 || n % 100 > 0 && n % 100 < 20 ? 1 : 2);
  },
  21: function _(n) {
    return Number(n % 100 == 1 ? 1 : n % 100 == 2 ? 2 : n % 100 == 3 || n % 100 == 4 ? 3 : 0);
  },
  22: function _(n) {
    return Number(n === 1 ? 0 : n === 2 ? 1 : (n < 0 || n > 10) && n % 10 == 0 ? 2 : 3);
  }
};
/* eslint-enable */

function createRules() {
  var rules = {};
  sets.forEach(function (set) {
    set.lngs.forEach(function (l) {
      rules[l] = {
        numbers: set.nr,
        plurals: _rulesPluralsTypes[set.fc]
      };
    });
  });
  return rules;
}

var PluralResolver = function () {
  function PluralResolver(languageUtils) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, PluralResolver);

    this.languageUtils = languageUtils;
    this.options = options;

    this.logger = _logger2.default.create('pluralResolver');

    this.rules = createRules();
  }

  PluralResolver.prototype.addRule = function addRule(lng, obj) {
    this.rules[lng] = obj;
  };

  PluralResolver.prototype.getRule = function getRule(code) {
    return this.rules[code] || this.rules[this.languageUtils.getLanguagePartFromCode(code)];
  };

  PluralResolver.prototype.needsPlural = function needsPlural(code) {
    var rule = this.getRule(code);

    return rule && rule.numbers.length > 1;
  };

  PluralResolver.prototype.getPluralFormsOfKey = function getPluralFormsOfKey(code, key) {
    var _this = this;

    var ret = [];

    var rule = this.getRule(code);

    if (!rule) return ret;

    rule.numbers.forEach(function (n) {
      var suffix = _this.getSuffix(code, n);
      ret.push('' + key + suffix);
    });

    return ret;
  };

  PluralResolver.prototype.getSuffix = function getSuffix(code, count) {
    var _this2 = this;

    var rule = this.getRule(code);

    if (rule) {
      // if (rule.numbers.length === 1) return ''; // only singular

      var idx = rule.noAbs ? rule.plurals(count) : rule.plurals(Math.abs(count));
      var suffix = rule.numbers[idx];

      // special treatment for lngs only having singular and plural
      if (this.options.simplifyPluralSuffix && rule.numbers.length === 2 && rule.numbers[0] === 1) {
        if (suffix === 2) {
          suffix = 'plural';
        } else if (suffix === 1) {
          suffix = '';
        }
      }

      var returnSuffix = function returnSuffix() {
        return _this2.options.prepend && suffix.toString() ? _this2.options.prepend + suffix.toString() : suffix.toString();
      };

      // COMPATIBILITY JSON
      // v1
      if (this.options.compatibilityJSON === 'v1') {
        if (suffix === 1) return '';
        if (typeof suffix === 'number') return '_plural_' + suffix.toString();
        return returnSuffix();
      } else if ( /* v2 */this.options.compatibilityJSON === 'v2' && rule.numbers.length === 2 && rule.numbers[0] === 1) {
        return returnSuffix();
      } else if ( /* v3 - gettext index */this.options.simplifyPluralSuffix && rule.numbers.length === 2 && rule.numbers[0] === 1) {
        return returnSuffix();
      }
      return this.options.prepend && idx.toString() ? this.options.prepend + idx.toString() : idx.toString();
    }

    this.logger.warn('no plural rule found for: ' + code);
    return '';
  };

  return PluralResolver;
}();

exports.default = PluralResolver;
},{"./logger.js":44}],39:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _EventEmitter2 = require('./EventEmitter.js');

var _EventEmitter3 = _interopRequireDefault(_EventEmitter2);

var _utils = require('./utils.js');

var utils = _interopRequireWildcard(_utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var ResourceStore = function (_EventEmitter) {
  _inherits(ResourceStore, _EventEmitter);

  function ResourceStore(data) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { ns: ['translation'], defaultNS: 'translation' };

    _classCallCheck(this, ResourceStore);

    var _this = _possibleConstructorReturn(this, _EventEmitter.call(this));

    _this.data = data || {};
    _this.options = options;
    if (_this.options.keySeparator === undefined) {
      _this.options.keySeparator = '.';
    }
    return _this;
  }

  ResourceStore.prototype.addNamespaces = function addNamespaces(ns) {
    if (this.options.ns.indexOf(ns) < 0) {
      this.options.ns.push(ns);
    }
  };

  ResourceStore.prototype.removeNamespaces = function removeNamespaces(ns) {
    var index = this.options.ns.indexOf(ns);
    if (index > -1) {
      this.options.ns.splice(index, 1);
    }
  };

  ResourceStore.prototype.getResource = function getResource(lng, ns, key) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    var keySeparator = options.keySeparator !== undefined ? options.keySeparator : this.options.keySeparator;

    var path = [lng, ns];
    if (key && typeof key !== 'string') path = path.concat(key);
    if (key && typeof key === 'string') path = path.concat(keySeparator ? key.split(keySeparator) : key);

    if (lng.indexOf('.') > -1) {
      path = lng.split('.');
    }

    return utils.getPath(this.data, path);
  };

  ResourceStore.prototype.addResource = function addResource(lng, ns, key, value) {
    var options = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : { silent: false };

    var keySeparator = this.options.keySeparator;
    if (keySeparator === undefined) keySeparator = '.';

    var path = [lng, ns];
    if (key) path = path.concat(keySeparator ? key.split(keySeparator) : key);

    if (lng.indexOf('.') > -1) {
      path = lng.split('.');
      value = ns;
      ns = path[1];
    }

    this.addNamespaces(ns);

    utils.setPath(this.data, path, value);

    if (!options.silent) this.emit('added', lng, ns, key, value);
  };

  ResourceStore.prototype.addResources = function addResources(lng, ns, resources) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : { silent: false };

    /* eslint no-restricted-syntax: 0 */
    for (var m in resources) {
      if (typeof resources[m] === 'string') this.addResource(lng, ns, m, resources[m], { silent: true });
    }
    if (!options.silent) this.emit('added', lng, ns, resources);
  };

  ResourceStore.prototype.addResourceBundle = function addResourceBundle(lng, ns, resources, deep, overwrite) {
    var options = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : { silent: false };

    var path = [lng, ns];
    if (lng.indexOf('.') > -1) {
      path = lng.split('.');
      deep = resources;
      resources = ns;
      ns = path[1];
    }

    this.addNamespaces(ns);

    var pack = utils.getPath(this.data, path) || {};

    if (deep) {
      utils.deepExtend(pack, resources, overwrite);
    } else {
      pack = _extends({}, pack, resources);
    }

    utils.setPath(this.data, path, pack);

    if (!options.silent) this.emit('added', lng, ns, resources);
  };

  ResourceStore.prototype.removeResourceBundle = function removeResourceBundle(lng, ns) {
    if (this.hasResourceBundle(lng, ns)) {
      delete this.data[lng][ns];
    }
    this.removeNamespaces(ns);

    this.emit('removed', lng, ns);
  };

  ResourceStore.prototype.hasResourceBundle = function hasResourceBundle(lng, ns) {
    return this.getResource(lng, ns) !== undefined;
  };

  ResourceStore.prototype.getResourceBundle = function getResourceBundle(lng, ns) {
    if (!ns) ns = this.options.defaultNS;

    // COMPATIBILITY: remove extend in v2.1.0
    if (this.options.compatibilityAPI === 'v1') return _extends({}, this.getResource(lng, ns));

    return this.getResource(lng, ns);
  };

  ResourceStore.prototype.getDataByLanguage = function getDataByLanguage(lng) {
    return this.data[lng];
  };

  ResourceStore.prototype.toJSON = function toJSON() {
    return this.data;
  };

  return ResourceStore;
}(_EventEmitter3.default);

exports.default = ResourceStore;
},{"./EventEmitter.js":35,"./utils.js":46}],40:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _logger = require('./logger.js');

var _logger2 = _interopRequireDefault(_logger);

var _EventEmitter2 = require('./EventEmitter.js');

var _EventEmitter3 = _interopRequireDefault(_EventEmitter2);

var _postProcessor = require('./postProcessor.js');

var _postProcessor2 = _interopRequireDefault(_postProcessor);

var _utils = require('./utils.js');

var utils = _interopRequireWildcard(_utils);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

var Translator = function (_EventEmitter) {
  _inherits(Translator, _EventEmitter);

  function Translator(services) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Translator);

    var _this = _possibleConstructorReturn(this, _EventEmitter.call(this));

    utils.copy(['resourceStore', 'languageUtils', 'pluralResolver', 'interpolator', 'backendConnector', 'i18nFormat'], services, _this);

    _this.options = options;
    if (_this.options.keySeparator === undefined) {
      _this.options.keySeparator = '.';
    }

    _this.logger = _logger2.default.create('translator');
    return _this;
  }

  Translator.prototype.changeLanguage = function changeLanguage(lng) {
    if (lng) this.language = lng;
  };

  Translator.prototype.exists = function exists(key) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : { interpolation: {} };

    var resolved = this.resolve(key, options);
    return resolved && resolved.res !== undefined;
  };

  Translator.prototype.extractFromKey = function extractFromKey(key, options) {
    var nsSeparator = options.nsSeparator || this.options.nsSeparator;
    if (nsSeparator === undefined) nsSeparator = ':';

    var keySeparator = options.keySeparator !== undefined ? options.keySeparator : this.options.keySeparator;

    var namespaces = options.ns || this.options.defaultNS;
    if (nsSeparator && key.indexOf(nsSeparator) > -1) {
      var parts = key.split(nsSeparator);
      if (nsSeparator !== keySeparator || nsSeparator === keySeparator && this.options.ns.indexOf(parts[0]) > -1) namespaces = parts.shift();
      key = parts.join(keySeparator);
    }
    if (typeof namespaces === 'string') namespaces = [namespaces];

    return {
      key: key,
      namespaces: namespaces
    };
  };

  Translator.prototype.translate = function translate(keys, options) {
    var _this2 = this;

    if ((typeof options === 'undefined' ? 'undefined' : _typeof(options)) !== 'object' && this.options.overloadTranslationOptionHandler) {
      /* eslint prefer-rest-params: 0 */
      options = this.options.overloadTranslationOptionHandler(arguments);
    }
    if (!options) options = {};

    // non valid keys handling
    if (keys === undefined || keys === null || keys === '') return '';
    if (typeof keys === 'number') keys = String(keys);
    if (typeof keys === 'string') keys = [keys];

    // separators
    var keySeparator = options.keySeparator !== undefined ? options.keySeparator : this.options.keySeparator;

    // get namespace(s)

    var _extractFromKey = this.extractFromKey(keys[keys.length - 1], options),
        key = _extractFromKey.key,
        namespaces = _extractFromKey.namespaces;

    var namespace = namespaces[namespaces.length - 1];

    // return key on CIMode
    var lng = options.lng || this.language;
    var appendNamespaceToCIMode = options.appendNamespaceToCIMode || this.options.appendNamespaceToCIMode;
    if (lng && lng.toLowerCase() === 'cimode') {
      if (appendNamespaceToCIMode) {
        var nsSeparator = options.nsSeparator || this.options.nsSeparator;
        return namespace + nsSeparator + key;
      }

      return key;
    }

    // resolve from store
    var resolved = this.resolve(keys, options);
    var res = resolved && resolved.res;
    var resUsedKey = resolved && resolved.usedKey || key;

    var resType = Object.prototype.toString.apply(res);
    var noObject = ['[object Number]', '[object Function]', '[object RegExp]'];
    var joinArrays = options.joinArrays !== undefined ? options.joinArrays : this.options.joinArrays;

    // object
    var handleAsObjectInI18nFormat = !this.i18nFormat || this.i18nFormat.handleAsObject;
    var handleAsObject = typeof res !== 'string' && typeof res !== 'boolean' && typeof res !== 'number';
    if (handleAsObjectInI18nFormat && res && handleAsObject && noObject.indexOf(resType) < 0 && !(joinArrays && resType === '[object Array]')) {
      if (!options.returnObjects && !this.options.returnObjects) {
        this.logger.warn('accessing an object - but returnObjects options is not enabled!');
        return this.options.returnedObjectHandler ? this.options.returnedObjectHandler(resUsedKey, res, options) : 'key \'' + key + ' (' + this.language + ')\' returned an object instead of string.';
      }

      // if we got a separator we loop over children - else we just return object as is
      // as having it set to false means no hierarchy so no lookup for nested values
      if (keySeparator) {
        var copy = resType === '[object Array]' ? [] : {}; // apply child translation on a copy

        /* eslint no-restricted-syntax: 0 */
        for (var m in res) {
          if (Object.prototype.hasOwnProperty.call(res, m)) {
            var deepKey = '' + resUsedKey + keySeparator + m;
            copy[m] = this.translate(deepKey, _extends({}, options, { joinArrays: false, ns: namespaces }));
            if (copy[m] === deepKey) copy[m] = res[m]; // if nothing found use orginal value as fallback
          }
        }
        res = copy;
      }
    } else if (handleAsObjectInI18nFormat && joinArrays && resType === '[object Array]') {
      // array special treatment
      res = res.join(joinArrays);
      if (res) res = this.extendTranslation(res, keys, options);
    } else {
      // string, empty or null
      var usedDefault = false;
      var usedKey = false;

      // fallback value
      if (!this.isValidLookup(res) && options.defaultValue !== undefined) {
        usedDefault = true;

        if (options.count !== undefined) {
          var suffix = this.pluralResolver.getSuffix(lng, options.count);
          res = options['defaultValue' + suffix];
        }
        if (!res) res = options.defaultValue;
      }
      if (!this.isValidLookup(res)) {
        usedKey = true;
        res = key;
      }

      // save missing
      var updateMissing = options.defaultValue && options.defaultValue !== res && this.options.updateMissing;
      if (usedKey || usedDefault || updateMissing) {
        this.logger.log(updateMissing ? 'updateKey' : 'missingKey', lng, namespace, key, updateMissing ? options.defaultValue : res);

        var lngs = [];
        var fallbackLngs = this.languageUtils.getFallbackCodes(this.options.fallbackLng, options.lng || this.language);
        if (this.options.saveMissingTo === 'fallback' && fallbackLngs && fallbackLngs[0]) {
          for (var i = 0; i < fallbackLngs.length; i++) {
            lngs.push(fallbackLngs[i]);
          }
        } else if (this.options.saveMissingTo === 'all') {
          lngs = this.languageUtils.toResolveHierarchy(options.lng || this.language);
        } else {
          lngs.push(options.lng || this.language);
        }

        var send = function send(l, k) {
          if (_this2.options.missingKeyHandler) {
            _this2.options.missingKeyHandler(l, namespace, k, updateMissing ? options.defaultValue : res, updateMissing, options);
          } else if (_this2.backendConnector && _this2.backendConnector.saveMissing) {
            _this2.backendConnector.saveMissing(l, namespace, k, updateMissing ? options.defaultValue : res, updateMissing, options);
          }
          _this2.emit('missingKey', l, namespace, k, res);
        };

        if (this.options.saveMissing) {
          var needsPluralHandling = options.count !== undefined && typeof options.count !== 'string';
          if (this.options.saveMissingPlurals && needsPluralHandling) {
            lngs.forEach(function (l) {
              var plurals = _this2.pluralResolver.getPluralFormsOfKey(l, key);

              plurals.forEach(function (p) {
                return send([l], p);
              });
            });
          } else {
            send(lngs, key);
          }
        }
      }

      // extend
      res = this.extendTranslation(res, keys, options, resolved);

      // append namespace if still key
      if (usedKey && res === key && this.options.appendNamespaceToMissingKey) res = namespace + ':' + key;

      // parseMissingKeyHandler
      if (usedKey && this.options.parseMissingKeyHandler) res = this.options.parseMissingKeyHandler(res);
    }

    // return
    return res;
  };

  Translator.prototype.extendTranslation = function extendTranslation(res, key, options, resolved) {
    var _this3 = this;

    if (this.i18nFormat && this.i18nFormat.parse) {
      res = this.i18nFormat.parse(res, options, resolved.usedLng, resolved.usedNS, resolved.usedKey, { resolved: resolved });
    } else if (!options.skipInterpolation) {
      // i18next.parsing
      if (options.interpolation) this.interpolator.init(_extends({}, options, { interpolation: _extends({}, this.options.interpolation, options.interpolation) }));

      // interpolate
      var data = options.replace && typeof options.replace !== 'string' ? options.replace : options;
      if (this.options.interpolation.defaultVariables) data = _extends({}, this.options.interpolation.defaultVariables, data);
      res = this.interpolator.interpolate(res, data, options.lng || this.language, options);

      // nesting
      if (options.nest !== false) res = this.interpolator.nest(res, function () {
        return _this3.translate.apply(_this3, arguments);
      }, options);

      if (options.interpolation) this.interpolator.reset();
    }

    // post process
    var postProcess = options.postProcess || this.options.postProcess;
    var postProcessorNames = typeof postProcess === 'string' ? [postProcess] : postProcess;

    if (res !== undefined && res !== null && postProcessorNames && postProcessorNames.length && options.applyPostProcessor !== false) {
      res = _postProcessor2.default.handle(postProcessorNames, res, key, options, this);
    }

    return res;
  };

  Translator.prototype.resolve = function resolve(keys) {
    var _this4 = this;

    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    var found = void 0;
    var usedKey = void 0;
    var usedLng = void 0;
    var usedNS = void 0;

    if (typeof keys === 'string') keys = [keys];

    // forEach possible key
    keys.forEach(function (k) {
      if (_this4.isValidLookup(found)) return;
      var extracted = _this4.extractFromKey(k, options);
      var key = extracted.key;
      usedKey = key;
      var namespaces = extracted.namespaces;
      if (_this4.options.fallbackNS) namespaces = namespaces.concat(_this4.options.fallbackNS);

      var needsPluralHandling = options.count !== undefined && typeof options.count !== 'string';
      var needsContextHandling = options.context !== undefined && typeof options.context === 'string' && options.context !== '';

      var codes = options.lngs ? options.lngs : _this4.languageUtils.toResolveHierarchy(options.lng || _this4.language, options.fallbackLng);

      namespaces.forEach(function (ns) {
        if (_this4.isValidLookup(found)) return;
        usedNS = ns;

        codes.forEach(function (code) {
          if (_this4.isValidLookup(found)) return;
          usedLng = code;

          var finalKey = key;
          var finalKeys = [finalKey];

          if (_this4.i18nFormat && _this4.i18nFormat.addLookupKeys) {
            _this4.i18nFormat.addLookupKeys(finalKeys, key, code, ns, options);
          } else {
            var pluralSuffix = void 0;
            if (needsPluralHandling) pluralSuffix = _this4.pluralResolver.getSuffix(code, options.count);

            // fallback for plural if context not found
            if (needsPluralHandling && needsContextHandling) finalKeys.push(finalKey + pluralSuffix);

            // get key for context if needed
            if (needsContextHandling) finalKeys.push(finalKey += '' + _this4.options.contextSeparator + options.context);

            // get key for plural if needed
            if (needsPluralHandling) finalKeys.push(finalKey += pluralSuffix);
          }

          // iterate over finalKeys starting with most specific pluralkey (-> contextkey only) -> singularkey only
          var possibleKey = void 0;
          /* eslint no-cond-assign: 0 */
          while (possibleKey = finalKeys.pop()) {
            if (!_this4.isValidLookup(found)) {
              found = _this4.getResource(code, ns, possibleKey, options);
            }
          }
        });
      });
    });

    return { res: found, usedKey: usedKey, usedLng: usedLng, usedNS: usedNS };
  };

  Translator.prototype.isValidLookup = function isValidLookup(res) {
    return res !== undefined && !(!this.options.returnNull && res === null) && !(!this.options.returnEmptyString && res === '');
  };

  Translator.prototype.getResource = function getResource(code, ns, key) {
    var options = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};

    if (this.i18nFormat && this.i18nFormat.getResource) return this.i18nFormat.getResource(code, ns, key, options);
    return this.resourceStore.getResource(code, ns, key, options);
  };

  return Translator;
}(_EventEmitter3.default);

exports.default = Translator;
},{"./EventEmitter.js":35,"./logger.js":44,"./postProcessor.js":45,"./utils.js":46}],41:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.transformOptions = transformOptions;
function get() {
  return {
    debug: false,
    initImmediate: true,

    ns: ['translation'],
    defaultNS: ['translation'],
    fallbackLng: ['dev'],
    fallbackNS: false, // string or array of namespaces

    whitelist: false, // array with whitelisted languages
    nonExplicitWhitelist: false,
    load: 'all', // | currentOnly | languageOnly
    preload: false, // array with preload languages

    simplifyPluralSuffix: true,
    keySeparator: '.',
    nsSeparator: ':',
    pluralSeparator: '_',
    contextSeparator: '_',

    saveMissing: false, // enable to send missing values
    updateMissing: false, // enable to update default values if different from translated value (only useful on initial development, or when keeping code as source of truth)
    saveMissingTo: 'fallback', // 'current' || 'all'
    saveMissingPlurals: true, // will save all forms not only singular key
    missingKeyHandler: false, // function(lng, ns, key, fallbackValue) -> override if prefer on handling
    missingInterpolationHandler: false, // function(str, match)

    postProcess: false, // string or array of postProcessor names
    returnNull: true, // allows null value as valid translation
    returnEmptyString: true, // allows empty string value as valid translation
    returnObjects: false,
    joinArrays: false, // or string to join array
    returnedObjectHandler: function returnedObjectHandler() {}, // function(key, value, options) triggered if key returns object but returnObjects is set to false
    parseMissingKeyHandler: false, // function(key) parsed a key that was not found in t() before returning
    appendNamespaceToMissingKey: false,
    appendNamespaceToCIMode: false,
    overloadTranslationOptionHandler: function handle(args) {
      var ret = {};
      if (args[1]) ret.defaultValue = args[1];
      if (args[2]) ret.tDescription = args[2];
      return ret;
    },
    interpolation: {
      escapeValue: true,
      format: function format(value, _format, lng) {
        return value;
      },
      prefix: '{{',
      suffix: '}}',
      formatSeparator: ',',
      // prefixEscaped: '{{',
      // suffixEscaped: '}}',
      // unescapeSuffix: '',
      unescapePrefix: '-',

      nestingPrefix: '$t(',
      nestingSuffix: ')',
      // nestingPrefixEscaped: '$t(',
      // nestingSuffixEscaped: ')',
      // defaultVariables: undefined // object that can have values to interpolate on - extends passed in interpolation data
      maxReplaces: 1000 // max replaces to prevent endless loop
    }
  };
}

/* eslint no-param-reassign: 0 */
exports.get = get;
function transformOptions(options) {
  // create namespace object if namespace is passed in as string
  if (typeof options.ns === 'string') options.ns = [options.ns];
  if (typeof options.fallbackLng === 'string') options.fallbackLng = [options.fallbackLng];
  if (typeof options.fallbackNS === 'string') options.fallbackNS = [options.fallbackNS];

  // extend whitelist with cimode
  if (options.whitelist && options.whitelist.indexOf('cimode') < 0) {
    options.whitelist = options.whitelist.concat(['cimode']);
  }

  return options;
}
},{}],42:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _logger = require('./logger.js');

var _logger2 = _interopRequireDefault(_logger);

var _EventEmitter2 = require('./EventEmitter.js');

var _EventEmitter3 = _interopRequireDefault(_EventEmitter2);

var _ResourceStore = require('./ResourceStore.js');

var _ResourceStore2 = _interopRequireDefault(_ResourceStore);

var _Translator = require('./Translator.js');

var _Translator2 = _interopRequireDefault(_Translator);

var _LanguageUtils = require('./LanguageUtils.js');

var _LanguageUtils2 = _interopRequireDefault(_LanguageUtils);

var _PluralResolver = require('./PluralResolver.js');

var _PluralResolver2 = _interopRequireDefault(_PluralResolver);

var _Interpolator = require('./Interpolator.js');

var _Interpolator2 = _interopRequireDefault(_Interpolator);

var _BackendConnector = require('./BackendConnector.js');

var _BackendConnector2 = _interopRequireDefault(_BackendConnector);

var _defaults2 = require('./defaults.js');

var _postProcessor = require('./postProcessor.js');

var _postProcessor2 = _interopRequireDefault(_postProcessor);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defaults(obj, defaults) { var keys = Object.getOwnPropertyNames(defaults); for (var i = 0; i < keys.length; i++) { var key = keys[i]; var value = Object.getOwnPropertyDescriptor(defaults, key); if (value && value.configurable && obj[key] === undefined) { Object.defineProperty(obj, key, value); } } return obj; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : _defaults(subClass, superClass); }

function noop() {}

var I18n = function (_EventEmitter) {
  _inherits(I18n, _EventEmitter);

  function I18n() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var callback = arguments[1];

    _classCallCheck(this, I18n);

    var _this = _possibleConstructorReturn(this, _EventEmitter.call(this));

    _this.options = (0, _defaults2.transformOptions)(options);
    _this.services = {};
    _this.logger = _logger2.default;
    _this.modules = { external: [] };

    if (callback && !_this.isInitialized && !options.isClone) {
      var _ret;

      // https://github.com/i18next/i18next/issues/879
      if (!_this.options.initImmediate) return _ret = _this.init(options, callback), _possibleConstructorReturn(_this, _ret);
      setTimeout(function () {
        _this.init(options, callback);
      }, 0);
    }
    return _this;
  }

  I18n.prototype.init = function init() {
    var _this2 = this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var callback = arguments[1];

    if (typeof options === 'function') {
      callback = options;
      options = {};
    }
    this.options = _extends({}, (0, _defaults2.get)(), this.options, (0, _defaults2.transformOptions)(options));

    this.format = this.options.interpolation.format;
    if (!callback) callback = noop;

    function createClassOnDemand(ClassOrObject) {
      if (!ClassOrObject) return null;
      if (typeof ClassOrObject === 'function') return new ClassOrObject();
      return ClassOrObject;
    }

    // init services
    if (!this.options.isClone) {
      if (this.modules.logger) {
        _logger2.default.init(createClassOnDemand(this.modules.logger), this.options);
      } else {
        _logger2.default.init(null, this.options);
      }

      var lu = new _LanguageUtils2.default(this.options);
      this.store = new _ResourceStore2.default(this.options.resources, this.options);

      var s = this.services;
      s.logger = _logger2.default;
      s.resourceStore = this.store;
      s.languageUtils = lu;
      s.pluralResolver = new _PluralResolver2.default(lu, { prepend: this.options.pluralSeparator, compatibilityJSON: this.options.compatibilityJSON, simplifyPluralSuffix: this.options.simplifyPluralSuffix });
      s.interpolator = new _Interpolator2.default(this.options);

      s.backendConnector = new _BackendConnector2.default(createClassOnDemand(this.modules.backend), s.resourceStore, s, this.options);
      // pipe events from backendConnector
      s.backendConnector.on('*', function (event) {
        for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
          args[_key - 1] = arguments[_key];
        }

        _this2.emit.apply(_this2, [event].concat(args));
      });

      if (this.modules.languageDetector) {
        s.languageDetector = createClassOnDemand(this.modules.languageDetector);
        s.languageDetector.init(s, this.options.detection, this.options);
      }

      if (this.modules.i18nFormat) {
        s.i18nFormat = createClassOnDemand(this.modules.i18nFormat);
        if (s.i18nFormat.init) s.i18nFormat.init(this);
      }

      this.translator = new _Translator2.default(this.services, this.options);
      // pipe events from translator
      this.translator.on('*', function (event) {
        for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
          args[_key2 - 1] = arguments[_key2];
        }

        _this2.emit.apply(_this2, [event].concat(args));
      });

      this.modules.external.forEach(function (m) {
        if (m.init) m.init(_this2);
      });
    }

    // append api
    var storeApi = ['getResource', 'addResource', 'addResources', 'addResourceBundle', 'removeResourceBundle', 'hasResourceBundle', 'getResourceBundle', 'getDataByLanguage'];
    storeApi.forEach(function (fcName) {
      _this2[fcName] = function () {
        var _store;

        return (_store = _this2.store)[fcName].apply(_store, arguments);
      };
    });

    var load = function load() {
      _this2.changeLanguage(_this2.options.lng, function (err, t) {
        _this2.isInitialized = true;
        _this2.logger.log('initialized', _this2.options);
        _this2.emit('initialized', _this2.options);

        callback(err, t);
      });
    };

    if (this.options.resources || !this.options.initImmediate) {
      load();
    } else {
      setTimeout(load, 0);
    }

    return this;
  };

  /* eslint consistent-return: 0 */


  I18n.prototype.loadResources = function loadResources() {
    var _this3 = this;

    var callback = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : noop;

    if (!this.options.resources) {
      if (this.language && this.language.toLowerCase() === 'cimode') return callback(); // avoid loading resources for cimode

      var toLoad = [];

      var append = function append(lng) {
        if (!lng) return;
        var lngs = _this3.services.languageUtils.toResolveHierarchy(lng);
        lngs.forEach(function (l) {
          if (toLoad.indexOf(l) < 0) toLoad.push(l);
        });
      };

      if (!this.language) {
        // at least load fallbacks in this case
        var fallbacks = this.services.languageUtils.getFallbackCodes(this.options.fallbackLng);
        fallbacks.forEach(function (l) {
          return append(l);
        });
      } else {
        append(this.language);
      }

      if (this.options.preload) {
        this.options.preload.forEach(function (l) {
          return append(l);
        });
      }

      this.services.backendConnector.load(toLoad, this.options.ns, callback);
    } else {
      callback(null);
    }
  };

  I18n.prototype.reloadResources = function reloadResources(lngs, ns, callback) {
    if (!lngs) lngs = this.languages;
    if (!ns) ns = this.options.ns;
    if (!callback) callback = function callback() {};
    this.services.backendConnector.reload(lngs, ns, callback);
  };

  I18n.prototype.use = function use(module) {
    if (module.type === 'backend') {
      this.modules.backend = module;
    }

    if (module.type === 'logger' || module.log && module.warn && module.error) {
      this.modules.logger = module;
    }

    if (module.type === 'languageDetector') {
      this.modules.languageDetector = module;
    }

    if (module.type === 'i18nFormat') {
      this.modules.i18nFormat = module;
    }

    if (module.type === 'postProcessor') {
      _postProcessor2.default.addPostProcessor(module);
    }

    if (module.type === '3rdParty') {
      this.modules.external.push(module);
    }

    return this;
  };

  I18n.prototype.changeLanguage = function changeLanguage(lng, callback) {
    var _this4 = this;

    var done = function done(err, l) {
      _this4.translator.changeLanguage(l);

      if (l) {
        _this4.emit('languageChanged', l);
        _this4.logger.log('languageChanged', l);
      }

      if (callback) callback(err, function () {
        return _this4.t.apply(_this4, arguments);
      });
    };

    var setLng = function setLng(l) {
      if (l) {
        _this4.language = l;
        _this4.languages = _this4.services.languageUtils.toResolveHierarchy(l);
        if (!_this4.translator.language) _this4.translator.changeLanguage(l);

        if (_this4.services.languageDetector) _this4.services.languageDetector.cacheUserLanguage(l);
      }

      _this4.loadResources(function (err) {
        done(err, l);
      });
    };

    if (!lng && this.services.languageDetector && !this.services.languageDetector.async) {
      setLng(this.services.languageDetector.detect());
    } else if (!lng && this.services.languageDetector && this.services.languageDetector.async) {
      this.services.languageDetector.detect(setLng);
    } else {
      setLng(lng);
    }
  };

  I18n.prototype.getFixedT = function getFixedT(lng, ns) {
    var _this5 = this;

    var fixedT = function fixedT(key, opts) {
      for (var _len3 = arguments.length, rest = Array(_len3 > 2 ? _len3 - 2 : 0), _key3 = 2; _key3 < _len3; _key3++) {
        rest[_key3 - 2] = arguments[_key3];
      }

      var options = _extends({}, opts);
      if ((typeof opts === 'undefined' ? 'undefined' : _typeof(opts)) !== 'object') {
        options = _this5.options.overloadTranslationOptionHandler([key, opts].concat(rest));
      }

      options.lng = options.lng || fixedT.lng;
      options.lngs = options.lngs || fixedT.lngs;
      options.ns = options.ns || fixedT.ns;
      return _this5.t(key, options);
    };
    if (typeof lng === 'string') {
      fixedT.lng = lng;
    } else {
      fixedT.lngs = lng;
    }
    fixedT.ns = ns;
    return fixedT;
  };

  I18n.prototype.t = function t() {
    var _translator;

    return this.translator && (_translator = this.translator).translate.apply(_translator, arguments);
  };

  I18n.prototype.exists = function exists() {
    var _translator2;

    return this.translator && (_translator2 = this.translator).exists.apply(_translator2, arguments);
  };

  I18n.prototype.setDefaultNamespace = function setDefaultNamespace(ns) {
    this.options.defaultNS = ns;
  };

  I18n.prototype.loadNamespaces = function loadNamespaces(ns, callback) {
    var _this6 = this;

    if (!this.options.ns) return callback && callback();
    if (typeof ns === 'string') ns = [ns];

    ns.forEach(function (n) {
      if (_this6.options.ns.indexOf(n) < 0) _this6.options.ns.push(n);
    });

    this.loadResources(callback);
  };

  I18n.prototype.loadLanguages = function loadLanguages(lngs, callback) {
    if (typeof lngs === 'string') lngs = [lngs];
    var preloaded = this.options.preload || [];

    var newLngs = lngs.filter(function (lng) {
      return preloaded.indexOf(lng) < 0;
    });
    // Exit early if all given languages are already preloaded
    if (!newLngs.length) return callback();

    this.options.preload = preloaded.concat(newLngs);
    this.loadResources(callback);
  };

  I18n.prototype.dir = function dir(lng) {
    if (!lng) lng = this.languages && this.languages.length > 0 ? this.languages[0] : this.language;
    if (!lng) return 'rtl';

    var rtlLngs = ['ar', 'shu', 'sqr', 'ssh', 'xaa', 'yhd', 'yud', 'aao', 'abh', 'abv', 'acm', 'acq', 'acw', 'acx', 'acy', 'adf', 'ads', 'aeb', 'aec', 'afb', 'ajp', 'apc', 'apd', 'arb', 'arq', 'ars', 'ary', 'arz', 'auz', 'avl', 'ayh', 'ayl', 'ayn', 'ayp', 'bbz', 'pga', 'he', 'iw', 'ps', 'pbt', 'pbu', 'pst', 'prp', 'prd', 'ur', 'ydd', 'yds', 'yih', 'ji', 'yi', 'hbo', 'men', 'xmn', 'fa', 'jpr', 'peo', 'pes', 'prs', 'dv', 'sam'];

    return rtlLngs.indexOf(this.services.languageUtils.getLanguagePartFromCode(lng)) >= 0 ? 'rtl' : 'ltr';
  };

  /* eslint class-methods-use-this: 0 */


  I18n.prototype.createInstance = function createInstance() {
    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var callback = arguments[1];

    return new I18n(options, callback);
  };

  I18n.prototype.cloneInstance = function cloneInstance() {
    var _this7 = this;

    var options = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : {};
    var callback = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : noop;

    var mergedOptions = _extends({}, this.options, options, { isClone: true });
    var clone = new I18n(mergedOptions);
    var membersToCopy = ['store', 'services', 'language'];
    membersToCopy.forEach(function (m) {
      clone[m] = _this7[m];
    });
    clone.translator = new _Translator2.default(clone.services, clone.options);
    clone.translator.on('*', function (event) {
      for (var _len4 = arguments.length, args = Array(_len4 > 1 ? _len4 - 1 : 0), _key4 = 1; _key4 < _len4; _key4++) {
        args[_key4 - 1] = arguments[_key4];
      }

      clone.emit.apply(clone, [event].concat(args));
    });
    clone.init(mergedOptions, callback);
    clone.translator.options = clone.options; // sync options

    return clone;
  };

  return I18n;
}(_EventEmitter3.default);

exports.default = new I18n();
},{"./BackendConnector.js":34,"./EventEmitter.js":35,"./Interpolator.js":36,"./LanguageUtils.js":37,"./PluralResolver.js":38,"./ResourceStore.js":39,"./Translator.js":40,"./defaults.js":41,"./logger.js":44,"./postProcessor.js":45}],43:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.use = exports.t = exports.setDefaultNamespace = exports.on = exports.off = exports.loadResources = exports.loadNamespaces = exports.loadLanguages = exports.init = exports.getFixedT = exports.exists = exports.dir = exports.createInstance = exports.cloneInstance = exports.changeLanguage = undefined;

var _i18next = require('./i18next.js');

var _i18next2 = _interopRequireDefault(_i18next);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = _i18next2.default;
var changeLanguage = exports.changeLanguage = _i18next2.default.changeLanguage.bind(_i18next2.default);
var cloneInstance = exports.cloneInstance = _i18next2.default.cloneInstance.bind(_i18next2.default);
var createInstance = exports.createInstance = _i18next2.default.createInstance.bind(_i18next2.default);
var dir = exports.dir = _i18next2.default.dir.bind(_i18next2.default);
var exists = exports.exists = _i18next2.default.exists.bind(_i18next2.default);
var getFixedT = exports.getFixedT = _i18next2.default.getFixedT.bind(_i18next2.default);
var init = exports.init = _i18next2.default.init.bind(_i18next2.default);
var loadLanguages = exports.loadLanguages = _i18next2.default.loadLanguages.bind(_i18next2.default);
var loadNamespaces = exports.loadNamespaces = _i18next2.default.loadNamespaces.bind(_i18next2.default);
var loadResources = exports.loadResources = _i18next2.default.loadResources.bind(_i18next2.default);
var off = exports.off = _i18next2.default.off.bind(_i18next2.default);
var on = exports.on = _i18next2.default.on.bind(_i18next2.default);
var setDefaultNamespace = exports.setDefaultNamespace = _i18next2.default.setDefaultNamespace.bind(_i18next2.default);
var t = exports.t = _i18next2.default.t.bind(_i18next2.default);
var use = exports.use = _i18next2.default.use.bind(_i18next2.default);
},{"./i18next.js":42}],44:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _toConsumableArray(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } else { return Array.from(arr); } }

var consoleLogger = {
  type: 'logger',

  log: function log(args) {
    this.output('log', args);
  },
  warn: function warn(args) {
    this.output('warn', args);
  },
  error: function error(args) {
    this.output('error', args);
  },
  output: function output(type, args) {
    var _console;

    /* eslint no-console: 0 */
    if (console && console[type]) (_console = console)[type].apply(_console, _toConsumableArray(args));
  }
};

var Logger = function () {
  function Logger(concreteLogger) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    _classCallCheck(this, Logger);

    this.init(concreteLogger, options);
  }

  Logger.prototype.init = function init(concreteLogger) {
    var options = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};

    this.prefix = options.prefix || 'i18next:';
    this.logger = concreteLogger || consoleLogger;
    this.options = options;
    this.debug = options.debug;
  };

  Logger.prototype.setDebug = function setDebug(bool) {
    this.debug = bool;
  };

  Logger.prototype.log = function log() {
    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return this.forward(args, 'log', '', true);
  };

  Logger.prototype.warn = function warn() {
    for (var _len2 = arguments.length, args = Array(_len2), _key2 = 0; _key2 < _len2; _key2++) {
      args[_key2] = arguments[_key2];
    }

    return this.forward(args, 'warn', '', true);
  };

  Logger.prototype.error = function error() {
    for (var _len3 = arguments.length, args = Array(_len3), _key3 = 0; _key3 < _len3; _key3++) {
      args[_key3] = arguments[_key3];
    }

    return this.forward(args, 'error', '');
  };

  Logger.prototype.deprecate = function deprecate() {
    for (var _len4 = arguments.length, args = Array(_len4), _key4 = 0; _key4 < _len4; _key4++) {
      args[_key4] = arguments[_key4];
    }

    return this.forward(args, 'warn', 'WARNING DEPRECATED: ', true);
  };

  Logger.prototype.forward = function forward(args, lvl, prefix, debugOnly) {
    if (debugOnly && !this.debug) return null;
    if (typeof args[0] === 'string') args[0] = '' + prefix + this.prefix + ' ' + args[0];
    return this.logger[lvl](args);
  };

  Logger.prototype.create = function create(moduleName) {
    return new Logger(this.logger, _extends({ prefix: this.prefix + ':' + moduleName + ':' }, this.options));
  };

  return Logger;
}();

exports.default = new Logger();
},{}],45:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = {

  processors: {},

  addPostProcessor: function addPostProcessor(module) {
    this.processors[module.name] = module;
  },
  handle: function handle(processors, value, key, options, translator) {
    var _this = this;

    processors.forEach(function (processor) {
      if (_this.processors[processor]) value = _this.processors[processor].process(value, key, options, translator);
    });

    return value;
  }
};
},{}],46:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.makeString = makeString;
exports.copy = copy;
exports.setPath = setPath;
exports.pushPath = pushPath;
exports.getPath = getPath;
exports.deepExtend = deepExtend;
exports.regexEscape = regexEscape;
exports.escape = escape;
function makeString(object) {
  if (object == null) return '';
  /* eslint prefer-template: 0 */
  return '' + object;
}

function copy(a, s, t) {
  a.forEach(function (m) {
    if (s[m]) t[m] = s[m];
  });
}

function getLastOfPath(object, path, Empty) {
  function cleanKey(key) {
    return key && key.indexOf('###') > -1 ? key.replace(/###/g, '.') : key;
  }

  function canNotTraverseDeeper() {
    return !object || typeof object === 'string';
  }

  var stack = typeof path !== 'string' ? [].concat(path) : path.split('.');
  while (stack.length > 1) {
    if (canNotTraverseDeeper()) return {};

    var key = cleanKey(stack.shift());
    if (!object[key] && Empty) object[key] = new Empty();
    object = object[key];
  }

  if (canNotTraverseDeeper()) return {};
  return {
    obj: object,
    k: cleanKey(stack.shift())
  };
}

function setPath(object, path, newValue) {
  var _getLastOfPath = getLastOfPath(object, path, Object),
      obj = _getLastOfPath.obj,
      k = _getLastOfPath.k;

  obj[k] = newValue;
}

function pushPath(object, path, newValue, concat) {
  var _getLastOfPath2 = getLastOfPath(object, path, Object),
      obj = _getLastOfPath2.obj,
      k = _getLastOfPath2.k;

  obj[k] = obj[k] || [];
  if (concat) obj[k] = obj[k].concat(newValue);
  if (!concat) obj[k].push(newValue);
}

function getPath(object, path) {
  var _getLastOfPath3 = getLastOfPath(object, path),
      obj = _getLastOfPath3.obj,
      k = _getLastOfPath3.k;

  if (!obj) return undefined;
  return obj[k];
}

function deepExtend(target, source, overwrite) {
  /* eslint no-restricted-syntax: 0 */
  for (var prop in source) {
    if (prop in target) {
      // If we reached a leaf string in target or source then replace with source or skip depending on the 'overwrite' switch
      if (typeof target[prop] === 'string' || target[prop] instanceof String || typeof source[prop] === 'string' || source[prop] instanceof String) {
        if (overwrite) target[prop] = source[prop];
      } else {
        deepExtend(target[prop], source[prop], overwrite);
      }
    } else {
      target[prop] = source[prop];
    }
  }
  return target;
}

function regexEscape(str) {
  /* eslint no-useless-escape: 0 */
  return str.replace(/[\-\[\]\/\{\}\(\)\*\+\?\.\\\^\$\|]/g, '\\$&');
}

/* eslint-disable */
var _entityMap = {
  "&": "&amp;",
  "<": "&lt;",
  ">": "&gt;",
  '"': '&quot;',
  "'": '&#39;',
  "/": '&#x2F;'
};
/* eslint-enable */

function escape(data) {
  if (typeof data === 'string') {
    return data.replace(/[&<>"'\/]/g, function (s) {
      return _entityMap[s];
    });
  }

  return data;
}
},{}],47:[function(require,module,exports){
module.exports = require('./dist/commonjs/index.js').default;

},{"./dist/commonjs/index.js":43}],48:[function(require,module,exports){
/*!
 * Determine if an object is a Buffer
 *
 * @author   Feross Aboukhadijeh <https://feross.org>
 * @license  MIT
 */

module.exports = function isBuffer (obj) {
  return obj != null && obj.constructor != null &&
    typeof obj.constructor.isBuffer === 'function' && obj.constructor.isBuffer(obj)
}

},{}],49:[function(require,module,exports){
(function (global){(function (){
"use strict";

// ref: https://github.com/tc39/proposal-global
var getGlobal = function () {
	// the only reliable means to get the global object is
	// `Function('return this')()`
	// However, this causes CSP violations in Chrome apps.
	if (typeof self !== 'undefined') { return self; }
	if (typeof window !== 'undefined') { return window; }
	if (typeof global !== 'undefined') { return global; }
	throw new Error('unable to locate global object');
}

var global = getGlobal();

module.exports = exports = global.fetch;

// Needed for TypeScript and Webpack.
if (global.fetch) {
	exports.default = global.fetch.bind(global);
}

exports.Headers = global.Headers;
exports.Request = global.Request;
exports.Response = global.Response;
}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],50:[function(require,module,exports){
var hasMap = typeof Map === 'function' && Map.prototype;
var mapSizeDescriptor = Object.getOwnPropertyDescriptor && hasMap ? Object.getOwnPropertyDescriptor(Map.prototype, 'size') : null;
var mapSize = hasMap && mapSizeDescriptor && typeof mapSizeDescriptor.get === 'function' ? mapSizeDescriptor.get : null;
var mapForEach = hasMap && Map.prototype.forEach;
var hasSet = typeof Set === 'function' && Set.prototype;
var setSizeDescriptor = Object.getOwnPropertyDescriptor && hasSet ? Object.getOwnPropertyDescriptor(Set.prototype, 'size') : null;
var setSize = hasSet && setSizeDescriptor && typeof setSizeDescriptor.get === 'function' ? setSizeDescriptor.get : null;
var setForEach = hasSet && Set.prototype.forEach;
var hasWeakMap = typeof WeakMap === 'function' && WeakMap.prototype;
var weakMapHas = hasWeakMap ? WeakMap.prototype.has : null;
var hasWeakSet = typeof WeakSet === 'function' && WeakSet.prototype;
var weakSetHas = hasWeakSet ? WeakSet.prototype.has : null;
var hasWeakRef = typeof WeakRef === 'function' && WeakRef.prototype;
var weakRefDeref = hasWeakRef ? WeakRef.prototype.deref : null;
var booleanValueOf = Boolean.prototype.valueOf;
var objectToString = Object.prototype.toString;
var functionToString = Function.prototype.toString;
var match = String.prototype.match;
var bigIntValueOf = typeof BigInt === 'function' ? BigInt.prototype.valueOf : null;
var gOPS = Object.getOwnPropertySymbols;
var symToString = typeof Symbol === 'function' && typeof Symbol.iterator === 'symbol' ? Symbol.prototype.toString : null;
var hasShammedSymbols = typeof Symbol === 'function' && typeof Symbol.iterator === 'object';
var isEnumerable = Object.prototype.propertyIsEnumerable;

var gPO = (typeof Reflect === 'function' ? Reflect.getPrototypeOf : Object.getPrototypeOf) || (
    [].__proto__ === Array.prototype // eslint-disable-line no-proto
        ? function (O) {
            return O.__proto__; // eslint-disable-line no-proto
        }
        : null
);

var inspectCustom = require('./util.inspect').custom;
var inspectSymbol = inspectCustom && isSymbol(inspectCustom) ? inspectCustom : null;
var toStringTag = typeof Symbol === 'function' && typeof Symbol.toStringTag !== 'undefined' ? Symbol.toStringTag : null;

module.exports = function inspect_(obj, options, depth, seen) {
    var opts = options || {};

    if (has(opts, 'quoteStyle') && (opts.quoteStyle !== 'single' && opts.quoteStyle !== 'double')) {
        throw new TypeError('option "quoteStyle" must be "single" or "double"');
    }
    if (
        has(opts, 'maxStringLength') && (typeof opts.maxStringLength === 'number'
            ? opts.maxStringLength < 0 && opts.maxStringLength !== Infinity
            : opts.maxStringLength !== null
        )
    ) {
        throw new TypeError('option "maxStringLength", if provided, must be a positive integer, Infinity, or `null`');
    }
    var customInspect = has(opts, 'customInspect') ? opts.customInspect : true;
    if (typeof customInspect !== 'boolean' && customInspect !== 'symbol') {
        throw new TypeError('option "customInspect", if provided, must be `true`, `false`, or `\'symbol\'`');
    }

    if (
        has(opts, 'indent')
        && opts.indent !== null
        && opts.indent !== '\t'
        && !(parseInt(opts.indent, 10) === opts.indent && opts.indent > 0)
    ) {
        throw new TypeError('options "indent" must be "\\t", an integer > 0, or `null`');
    }

    if (typeof obj === 'undefined') {
        return 'undefined';
    }
    if (obj === null) {
        return 'null';
    }
    if (typeof obj === 'boolean') {
        return obj ? 'true' : 'false';
    }

    if (typeof obj === 'string') {
        return inspectString(obj, opts);
    }
    if (typeof obj === 'number') {
        if (obj === 0) {
            return Infinity / obj > 0 ? '0' : '-0';
        }
        return String(obj);
    }
    if (typeof obj === 'bigint') {
        return String(obj) + 'n';
    }

    var maxDepth = typeof opts.depth === 'undefined' ? 5 : opts.depth;
    if (typeof depth === 'undefined') { depth = 0; }
    if (depth >= maxDepth && maxDepth > 0 && typeof obj === 'object') {
        return isArray(obj) ? '[Array]' : '[Object]';
    }

    var indent = getIndent(opts, depth);

    if (typeof seen === 'undefined') {
        seen = [];
    } else if (indexOf(seen, obj) >= 0) {
        return '[Circular]';
    }

    function inspect(value, from, noIndent) {
        if (from) {
            seen = seen.slice();
            seen.push(from);
        }
        if (noIndent) {
            var newOpts = {
                depth: opts.depth
            };
            if (has(opts, 'quoteStyle')) {
                newOpts.quoteStyle = opts.quoteStyle;
            }
            return inspect_(value, newOpts, depth + 1, seen);
        }
        return inspect_(value, opts, depth + 1, seen);
    }

    if (typeof obj === 'function') {
        var name = nameOf(obj);
        var keys = arrObjKeys(obj, inspect);
        return '[Function' + (name ? ': ' + name : ' (anonymous)') + ']' + (keys.length > 0 ? ' { ' + keys.join(', ') + ' }' : '');
    }
    if (isSymbol(obj)) {
        var symString = hasShammedSymbols ? String(obj).replace(/^(Symbol\(.*\))_[^)]*$/, '$1') : symToString.call(obj);
        return typeof obj === 'object' && !hasShammedSymbols ? markBoxed(symString) : symString;
    }
    if (isElement(obj)) {
        var s = '<' + String(obj.nodeName).toLowerCase();
        var attrs = obj.attributes || [];
        for (var i = 0; i < attrs.length; i++) {
            s += ' ' + attrs[i].name + '=' + wrapQuotes(quote(attrs[i].value), 'double', opts);
        }
        s += '>';
        if (obj.childNodes && obj.childNodes.length) { s += '...'; }
        s += '</' + String(obj.nodeName).toLowerCase() + '>';
        return s;
    }
    if (isArray(obj)) {
        if (obj.length === 0) { return '[]'; }
        var xs = arrObjKeys(obj, inspect);
        if (indent && !singleLineValues(xs)) {
            return '[' + indentedJoin(xs, indent) + ']';
        }
        return '[ ' + xs.join(', ') + ' ]';
    }
    if (isError(obj)) {
        var parts = arrObjKeys(obj, inspect);
        if (parts.length === 0) { return '[' + String(obj) + ']'; }
        return '{ [' + String(obj) + '] ' + parts.join(', ') + ' }';
    }
    if (typeof obj === 'object' && customInspect) {
        if (inspectSymbol && typeof obj[inspectSymbol] === 'function') {
            return obj[inspectSymbol]();
        } else if (customInspect !== 'symbol' && typeof obj.inspect === 'function') {
            return obj.inspect();
        }
    }
    if (isMap(obj)) {
        var mapParts = [];
        mapForEach.call(obj, function (value, key) {
            mapParts.push(inspect(key, obj, true) + ' => ' + inspect(value, obj));
        });
        return collectionOf('Map', mapSize.call(obj), mapParts, indent);
    }
    if (isSet(obj)) {
        var setParts = [];
        setForEach.call(obj, function (value) {
            setParts.push(inspect(value, obj));
        });
        return collectionOf('Set', setSize.call(obj), setParts, indent);
    }
    if (isWeakMap(obj)) {
        return weakCollectionOf('WeakMap');
    }
    if (isWeakSet(obj)) {
        return weakCollectionOf('WeakSet');
    }
    if (isWeakRef(obj)) {
        return weakCollectionOf('WeakRef');
    }
    if (isNumber(obj)) {
        return markBoxed(inspect(Number(obj)));
    }
    if (isBigInt(obj)) {
        return markBoxed(inspect(bigIntValueOf.call(obj)));
    }
    if (isBoolean(obj)) {
        return markBoxed(booleanValueOf.call(obj));
    }
    if (isString(obj)) {
        return markBoxed(inspect(String(obj)));
    }
    if (!isDate(obj) && !isRegExp(obj)) {
        var ys = arrObjKeys(obj, inspect);
        var isPlainObject = gPO ? gPO(obj) === Object.prototype : obj instanceof Object || obj.constructor === Object;
        var protoTag = obj instanceof Object ? '' : 'null prototype';
        var stringTag = !isPlainObject && toStringTag && Object(obj) === obj && toStringTag in obj ? toStr(obj).slice(8, -1) : protoTag ? 'Object' : '';
        var constructorTag = isPlainObject || typeof obj.constructor !== 'function' ? '' : obj.constructor.name ? obj.constructor.name + ' ' : '';
        var tag = constructorTag + (stringTag || protoTag ? '[' + [].concat(stringTag || [], protoTag || []).join(': ') + '] ' : '');
        if (ys.length === 0) { return tag + '{}'; }
        if (indent) {
            return tag + '{' + indentedJoin(ys, indent) + '}';
        }
        return tag + '{ ' + ys.join(', ') + ' }';
    }
    return String(obj);
};

function wrapQuotes(s, defaultStyle, opts) {
    var quoteChar = (opts.quoteStyle || defaultStyle) === 'double' ? '"' : "'";
    return quoteChar + s + quoteChar;
}

function quote(s) {
    return String(s).replace(/"/g, '&quot;');
}

function isArray(obj) { return toStr(obj) === '[object Array]' && (!toStringTag || !(typeof obj === 'object' && toStringTag in obj)); }
function isDate(obj) { return toStr(obj) === '[object Date]' && (!toStringTag || !(typeof obj === 'object' && toStringTag in obj)); }
function isRegExp(obj) { return toStr(obj) === '[object RegExp]' && (!toStringTag || !(typeof obj === 'object' && toStringTag in obj)); }
function isError(obj) { return toStr(obj) === '[object Error]' && (!toStringTag || !(typeof obj === 'object' && toStringTag in obj)); }
function isString(obj) { return toStr(obj) === '[object String]' && (!toStringTag || !(typeof obj === 'object' && toStringTag in obj)); }
function isNumber(obj) { return toStr(obj) === '[object Number]' && (!toStringTag || !(typeof obj === 'object' && toStringTag in obj)); }
function isBoolean(obj) { return toStr(obj) === '[object Boolean]' && (!toStringTag || !(typeof obj === 'object' && toStringTag in obj)); }

// Symbol and BigInt do have Symbol.toStringTag by spec, so that can't be used to eliminate false positives
function isSymbol(obj) {
    if (hasShammedSymbols) {
        return obj && typeof obj === 'object' && obj instanceof Symbol;
    }
    if (typeof obj === 'symbol') {
        return true;
    }
    if (!obj || typeof obj !== 'object' || !symToString) {
        return false;
    }
    try {
        symToString.call(obj);
        return true;
    } catch (e) {}
    return false;
}

function isBigInt(obj) {
    if (!obj || typeof obj !== 'object' || !bigIntValueOf) {
        return false;
    }
    try {
        bigIntValueOf.call(obj);
        return true;
    } catch (e) {}
    return false;
}

var hasOwn = Object.prototype.hasOwnProperty || function (key) { return key in this; };
function has(obj, key) {
    return hasOwn.call(obj, key);
}

function toStr(obj) {
    return objectToString.call(obj);
}

function nameOf(f) {
    if (f.name) { return f.name; }
    var m = match.call(functionToString.call(f), /^function\s*([\w$]+)/);
    if (m) { return m[1]; }
    return null;
}

function indexOf(xs, x) {
    if (xs.indexOf) { return xs.indexOf(x); }
    for (var i = 0, l = xs.length; i < l; i++) {
        if (xs[i] === x) { return i; }
    }
    return -1;
}

function isMap(x) {
    if (!mapSize || !x || typeof x !== 'object') {
        return false;
    }
    try {
        mapSize.call(x);
        try {
            setSize.call(x);
        } catch (s) {
            return true;
        }
        return x instanceof Map; // core-js workaround, pre-v2.5.0
    } catch (e) {}
    return false;
}

function isWeakMap(x) {
    if (!weakMapHas || !x || typeof x !== 'object') {
        return false;
    }
    try {
        weakMapHas.call(x, weakMapHas);
        try {
            weakSetHas.call(x, weakSetHas);
        } catch (s) {
            return true;
        }
        return x instanceof WeakMap; // core-js workaround, pre-v2.5.0
    } catch (e) {}
    return false;
}

function isWeakRef(x) {
    if (!weakRefDeref || !x || typeof x !== 'object') {
        return false;
    }
    try {
        weakRefDeref.call(x);
        return true;
    } catch (e) {}
    return false;
}

function isSet(x) {
    if (!setSize || !x || typeof x !== 'object') {
        return false;
    }
    try {
        setSize.call(x);
        try {
            mapSize.call(x);
        } catch (m) {
            return true;
        }
        return x instanceof Set; // core-js workaround, pre-v2.5.0
    } catch (e) {}
    return false;
}

function isWeakSet(x) {
    if (!weakSetHas || !x || typeof x !== 'object') {
        return false;
    }
    try {
        weakSetHas.call(x, weakSetHas);
        try {
            weakMapHas.call(x, weakMapHas);
        } catch (s) {
            return true;
        }
        return x instanceof WeakSet; // core-js workaround, pre-v2.5.0
    } catch (e) {}
    return false;
}

function isElement(x) {
    if (!x || typeof x !== 'object') { return false; }
    if (typeof HTMLElement !== 'undefined' && x instanceof HTMLElement) {
        return true;
    }
    return typeof x.nodeName === 'string' && typeof x.getAttribute === 'function';
}

function inspectString(str, opts) {
    if (str.length > opts.maxStringLength) {
        var remaining = str.length - opts.maxStringLength;
        var trailer = '... ' + remaining + ' more character' + (remaining > 1 ? 's' : '');
        return inspectString(str.slice(0, opts.maxStringLength), opts) + trailer;
    }
    // eslint-disable-next-line no-control-regex
    var s = str.replace(/(['\\])/g, '\\$1').replace(/[\x00-\x1f]/g, lowbyte);
    return wrapQuotes(s, 'single', opts);
}

function lowbyte(c) {
    var n = c.charCodeAt(0);
    var x = {
        8: 'b',
        9: 't',
        10: 'n',
        12: 'f',
        13: 'r'
    }[n];
    if (x) { return '\\' + x; }
    return '\\x' + (n < 0x10 ? '0' : '') + n.toString(16).toUpperCase();
}

function markBoxed(str) {
    return 'Object(' + str + ')';
}

function weakCollectionOf(type) {
    return type + ' { ? }';
}

function collectionOf(type, size, entries, indent) {
    var joinedEntries = indent ? indentedJoin(entries, indent) : entries.join(', ');
    return type + ' (' + size + ') {' + joinedEntries + '}';
}

function singleLineValues(xs) {
    for (var i = 0; i < xs.length; i++) {
        if (indexOf(xs[i], '\n') >= 0) {
            return false;
        }
    }
    return true;
}

function getIndent(opts, depth) {
    var baseIndent;
    if (opts.indent === '\t') {
        baseIndent = '\t';
    } else if (typeof opts.indent === 'number' && opts.indent > 0) {
        baseIndent = Array(opts.indent + 1).join(' ');
    } else {
        return null;
    }
    return {
        base: baseIndent,
        prev: Array(depth + 1).join(baseIndent)
    };
}

function indentedJoin(xs, indent) {
    if (xs.length === 0) { return ''; }
    var lineJoiner = '\n' + indent.prev + indent.base;
    return lineJoiner + xs.join(',' + lineJoiner) + '\n' + indent.prev;
}

function arrObjKeys(obj, inspect) {
    var isArr = isArray(obj);
    var xs = [];
    if (isArr) {
        xs.length = obj.length;
        for (var i = 0; i < obj.length; i++) {
            xs[i] = has(obj, i) ? inspect(obj[i], obj) : '';
        }
    }
    var syms = typeof gOPS === 'function' ? gOPS(obj) : [];
    var symMap;
    if (hasShammedSymbols) {
        symMap = {};
        for (var k = 0; k < syms.length; k++) {
            symMap['$' + syms[k]] = syms[k];
        }
    }

    for (var key in obj) { // eslint-disable-line no-restricted-syntax
        if (!has(obj, key)) { continue; } // eslint-disable-line no-restricted-syntax, no-continue
        if (isArr && String(Number(key)) === key && key < obj.length) { continue; } // eslint-disable-line no-restricted-syntax, no-continue
        if (hasShammedSymbols && symMap['$' + key] instanceof Symbol) {
            // this is to prevent shammed Symbols, which are stored as strings, from being included in the string key section
            continue; // eslint-disable-line no-restricted-syntax, no-continue
        } else if ((/[^\w$]/).test(key)) {
            xs.push(inspect(key, obj) + ': ' + inspect(obj[key], obj));
        } else {
            xs.push(key + ': ' + inspect(obj[key], obj));
        }
    }
    if (typeof gOPS === 'function') {
        for (var j = 0; j < syms.length; j++) {
            if (isEnumerable.call(obj, syms[j])) {
                xs.push('[' + inspect(syms[j]) + ']: ' + inspect(obj[syms[j]], obj));
            }
        }
    }
    return xs;
}

},{"./util.inspect":25}],51:[function(require,module,exports){
(function (global){(function (){
/**!
 * @fileOverview Kickass library to create and place poppers near their reference elements.
 * @version 1.16.1
 * @license
 * Copyright (c) 2016 Federico Zivolo and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory() :
	typeof define === 'function' && define.amd ? define(factory) :
	(global.Popper = factory());
}(this, (function () { 'use strict';

var isBrowser = typeof window !== 'undefined' && typeof document !== 'undefined' && typeof navigator !== 'undefined';

var timeoutDuration = function () {
  var longerTimeoutBrowsers = ['Edge', 'Trident', 'Firefox'];
  for (var i = 0; i < longerTimeoutBrowsers.length; i += 1) {
    if (isBrowser && navigator.userAgent.indexOf(longerTimeoutBrowsers[i]) >= 0) {
      return 1;
    }
  }
  return 0;
}();

function microtaskDebounce(fn) {
  var called = false;
  return function () {
    if (called) {
      return;
    }
    called = true;
    window.Promise.resolve().then(function () {
      called = false;
      fn();
    });
  };
}

function taskDebounce(fn) {
  var scheduled = false;
  return function () {
    if (!scheduled) {
      scheduled = true;
      setTimeout(function () {
        scheduled = false;
        fn();
      }, timeoutDuration);
    }
  };
}

var supportsMicroTasks = isBrowser && window.Promise;

/**
* Create a debounced version of a method, that's asynchronously deferred
* but called in the minimum time possible.
*
* @method
* @memberof Popper.Utils
* @argument {Function} fn
* @returns {Function}
*/
var debounce = supportsMicroTasks ? microtaskDebounce : taskDebounce;

/**
 * Check if the given variable is a function
 * @method
 * @memberof Popper.Utils
 * @argument {Any} functionToCheck - variable to check
 * @returns {Boolean} answer to: is a function?
 */
function isFunction(functionToCheck) {
  var getType = {};
  return functionToCheck && getType.toString.call(functionToCheck) === '[object Function]';
}

/**
 * Get CSS computed property of the given element
 * @method
 * @memberof Popper.Utils
 * @argument {Eement} element
 * @argument {String} property
 */
function getStyleComputedProperty(element, property) {
  if (element.nodeType !== 1) {
    return [];
  }
  // NOTE: 1 DOM access here
  var window = element.ownerDocument.defaultView;
  var css = window.getComputedStyle(element, null);
  return property ? css[property] : css;
}

/**
 * Returns the parentNode or the host of the element
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element
 * @returns {Element} parent
 */
function getParentNode(element) {
  if (element.nodeName === 'HTML') {
    return element;
  }
  return element.parentNode || element.host;
}

/**
 * Returns the scrolling parent of the given element
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element
 * @returns {Element} scroll parent
 */
function getScrollParent(element) {
  // Return body, `getScroll` will take care to get the correct `scrollTop` from it
  if (!element) {
    return document.body;
  }

  switch (element.nodeName) {
    case 'HTML':
    case 'BODY':
      return element.ownerDocument.body;
    case '#document':
      return element.body;
  }

  // Firefox want us to check `-x` and `-y` variations as well

  var _getStyleComputedProp = getStyleComputedProperty(element),
      overflow = _getStyleComputedProp.overflow,
      overflowX = _getStyleComputedProp.overflowX,
      overflowY = _getStyleComputedProp.overflowY;

  if (/(auto|scroll|overlay)/.test(overflow + overflowY + overflowX)) {
    return element;
  }

  return getScrollParent(getParentNode(element));
}

/**
 * Returns the reference node of the reference object, or the reference object itself.
 * @method
 * @memberof Popper.Utils
 * @param {Element|Object} reference - the reference element (the popper will be relative to this)
 * @returns {Element} parent
 */
function getReferenceNode(reference) {
  return reference && reference.referenceNode ? reference.referenceNode : reference;
}

var isIE11 = isBrowser && !!(window.MSInputMethodContext && document.documentMode);
var isIE10 = isBrowser && /MSIE 10/.test(navigator.userAgent);

/**
 * Determines if the browser is Internet Explorer
 * @method
 * @memberof Popper.Utils
 * @param {Number} version to check
 * @returns {Boolean} isIE
 */
function isIE(version) {
  if (version === 11) {
    return isIE11;
  }
  if (version === 10) {
    return isIE10;
  }
  return isIE11 || isIE10;
}

/**
 * Returns the offset parent of the given element
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element
 * @returns {Element} offset parent
 */
function getOffsetParent(element) {
  if (!element) {
    return document.documentElement;
  }

  var noOffsetParent = isIE(10) ? document.body : null;

  // NOTE: 1 DOM access here
  var offsetParent = element.offsetParent || null;
  // Skip hidden elements which don't have an offsetParent
  while (offsetParent === noOffsetParent && element.nextElementSibling) {
    offsetParent = (element = element.nextElementSibling).offsetParent;
  }

  var nodeName = offsetParent && offsetParent.nodeName;

  if (!nodeName || nodeName === 'BODY' || nodeName === 'HTML') {
    return element ? element.ownerDocument.documentElement : document.documentElement;
  }

  // .offsetParent will return the closest TH, TD or TABLE in case
  // no offsetParent is present, I hate this job...
  if (['TH', 'TD', 'TABLE'].indexOf(offsetParent.nodeName) !== -1 && getStyleComputedProperty(offsetParent, 'position') === 'static') {
    return getOffsetParent(offsetParent);
  }

  return offsetParent;
}

function isOffsetContainer(element) {
  var nodeName = element.nodeName;

  if (nodeName === 'BODY') {
    return false;
  }
  return nodeName === 'HTML' || getOffsetParent(element.firstElementChild) === element;
}

/**
 * Finds the root node (document, shadowDOM root) of the given element
 * @method
 * @memberof Popper.Utils
 * @argument {Element} node
 * @returns {Element} root node
 */
function getRoot(node) {
  if (node.parentNode !== null) {
    return getRoot(node.parentNode);
  }

  return node;
}

/**
 * Finds the offset parent common to the two provided nodes
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element1
 * @argument {Element} element2
 * @returns {Element} common offset parent
 */
function findCommonOffsetParent(element1, element2) {
  // This check is needed to avoid errors in case one of the elements isn't defined for any reason
  if (!element1 || !element1.nodeType || !element2 || !element2.nodeType) {
    return document.documentElement;
  }

  // Here we make sure to give as "start" the element that comes first in the DOM
  var order = element1.compareDocumentPosition(element2) & Node.DOCUMENT_POSITION_FOLLOWING;
  var start = order ? element1 : element2;
  var end = order ? element2 : element1;

  // Get common ancestor container
  var range = document.createRange();
  range.setStart(start, 0);
  range.setEnd(end, 0);
  var commonAncestorContainer = range.commonAncestorContainer;

  // Both nodes are inside #document

  if (element1 !== commonAncestorContainer && element2 !== commonAncestorContainer || start.contains(end)) {
    if (isOffsetContainer(commonAncestorContainer)) {
      return commonAncestorContainer;
    }

    return getOffsetParent(commonAncestorContainer);
  }

  // one of the nodes is inside shadowDOM, find which one
  var element1root = getRoot(element1);
  if (element1root.host) {
    return findCommonOffsetParent(element1root.host, element2);
  } else {
    return findCommonOffsetParent(element1, getRoot(element2).host);
  }
}

/**
 * Gets the scroll value of the given element in the given side (top and left)
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element
 * @argument {String} side `top` or `left`
 * @returns {number} amount of scrolled pixels
 */
function getScroll(element) {
  var side = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 'top';

  var upperSide = side === 'top' ? 'scrollTop' : 'scrollLeft';
  var nodeName = element.nodeName;

  if (nodeName === 'BODY' || nodeName === 'HTML') {
    var html = element.ownerDocument.documentElement;
    var scrollingElement = element.ownerDocument.scrollingElement || html;
    return scrollingElement[upperSide];
  }

  return element[upperSide];
}

/*
 * Sum or subtract the element scroll values (left and top) from a given rect object
 * @method
 * @memberof Popper.Utils
 * @param {Object} rect - Rect object you want to change
 * @param {HTMLElement} element - The element from the function reads the scroll values
 * @param {Boolean} subtract - set to true if you want to subtract the scroll values
 * @return {Object} rect - The modifier rect object
 */
function includeScroll(rect, element) {
  var subtract = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var scrollTop = getScroll(element, 'top');
  var scrollLeft = getScroll(element, 'left');
  var modifier = subtract ? -1 : 1;
  rect.top += scrollTop * modifier;
  rect.bottom += scrollTop * modifier;
  rect.left += scrollLeft * modifier;
  rect.right += scrollLeft * modifier;
  return rect;
}

/*
 * Helper to detect borders of a given element
 * @method
 * @memberof Popper.Utils
 * @param {CSSStyleDeclaration} styles
 * Result of `getStyleComputedProperty` on the given element
 * @param {String} axis - `x` or `y`
 * @return {number} borders - The borders size of the given axis
 */

function getBordersSize(styles, axis) {
  var sideA = axis === 'x' ? 'Left' : 'Top';
  var sideB = sideA === 'Left' ? 'Right' : 'Bottom';

  return parseFloat(styles['border' + sideA + 'Width']) + parseFloat(styles['border' + sideB + 'Width']);
}

function getSize(axis, body, html, computedStyle) {
  return Math.max(body['offset' + axis], body['scroll' + axis], html['client' + axis], html['offset' + axis], html['scroll' + axis], isIE(10) ? parseInt(html['offset' + axis]) + parseInt(computedStyle['margin' + (axis === 'Height' ? 'Top' : 'Left')]) + parseInt(computedStyle['margin' + (axis === 'Height' ? 'Bottom' : 'Right')]) : 0);
}

function getWindowSizes(document) {
  var body = document.body;
  var html = document.documentElement;
  var computedStyle = isIE(10) && getComputedStyle(html);

  return {
    height: getSize('Height', body, html, computedStyle),
    width: getSize('Width', body, html, computedStyle)
  };
}

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();





var defineProperty = function (obj, key, value) {
  if (key in obj) {
    Object.defineProperty(obj, key, {
      value: value,
      enumerable: true,
      configurable: true,
      writable: true
    });
  } else {
    obj[key] = value;
  }

  return obj;
};

var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

/**
 * Given element offsets, generate an output similar to getBoundingClientRect
 * @method
 * @memberof Popper.Utils
 * @argument {Object} offsets
 * @returns {Object} ClientRect like output
 */
function getClientRect(offsets) {
  return _extends({}, offsets, {
    right: offsets.left + offsets.width,
    bottom: offsets.top + offsets.height
  });
}

/**
 * Get bounding client rect of given element
 * @method
 * @memberof Popper.Utils
 * @param {HTMLElement} element
 * @return {Object} client rect
 */
function getBoundingClientRect(element) {
  var rect = {};

  // IE10 10 FIX: Please, don't ask, the element isn't
  // considered in DOM in some circumstances...
  // This isn't reproducible in IE10 compatibility mode of IE11
  try {
    if (isIE(10)) {
      rect = element.getBoundingClientRect();
      var scrollTop = getScroll(element, 'top');
      var scrollLeft = getScroll(element, 'left');
      rect.top += scrollTop;
      rect.left += scrollLeft;
      rect.bottom += scrollTop;
      rect.right += scrollLeft;
    } else {
      rect = element.getBoundingClientRect();
    }
  } catch (e) {}

  var result = {
    left: rect.left,
    top: rect.top,
    width: rect.right - rect.left,
    height: rect.bottom - rect.top
  };

  // subtract scrollbar size from sizes
  var sizes = element.nodeName === 'HTML' ? getWindowSizes(element.ownerDocument) : {};
  var width = sizes.width || element.clientWidth || result.width;
  var height = sizes.height || element.clientHeight || result.height;

  var horizScrollbar = element.offsetWidth - width;
  var vertScrollbar = element.offsetHeight - height;

  // if an hypothetical scrollbar is detected, we must be sure it's not a `border`
  // we make this check conditional for performance reasons
  if (horizScrollbar || vertScrollbar) {
    var styles = getStyleComputedProperty(element);
    horizScrollbar -= getBordersSize(styles, 'x');
    vertScrollbar -= getBordersSize(styles, 'y');

    result.width -= horizScrollbar;
    result.height -= vertScrollbar;
  }

  return getClientRect(result);
}

function getOffsetRectRelativeToArbitraryNode(children, parent) {
  var fixedPosition = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

  var isIE10 = isIE(10);
  var isHTML = parent.nodeName === 'HTML';
  var childrenRect = getBoundingClientRect(children);
  var parentRect = getBoundingClientRect(parent);
  var scrollParent = getScrollParent(children);

  var styles = getStyleComputedProperty(parent);
  var borderTopWidth = parseFloat(styles.borderTopWidth);
  var borderLeftWidth = parseFloat(styles.borderLeftWidth);

  // In cases where the parent is fixed, we must ignore negative scroll in offset calc
  if (fixedPosition && isHTML) {
    parentRect.top = Math.max(parentRect.top, 0);
    parentRect.left = Math.max(parentRect.left, 0);
  }
  var offsets = getClientRect({
    top: childrenRect.top - parentRect.top - borderTopWidth,
    left: childrenRect.left - parentRect.left - borderLeftWidth,
    width: childrenRect.width,
    height: childrenRect.height
  });
  offsets.marginTop = 0;
  offsets.marginLeft = 0;

  // Subtract margins of documentElement in case it's being used as parent
  // we do this only on HTML because it's the only element that behaves
  // differently when margins are applied to it. The margins are included in
  // the box of the documentElement, in the other cases not.
  if (!isIE10 && isHTML) {
    var marginTop = parseFloat(styles.marginTop);
    var marginLeft = parseFloat(styles.marginLeft);

    offsets.top -= borderTopWidth - marginTop;
    offsets.bottom -= borderTopWidth - marginTop;
    offsets.left -= borderLeftWidth - marginLeft;
    offsets.right -= borderLeftWidth - marginLeft;

    // Attach marginTop and marginLeft because in some circumstances we may need them
    offsets.marginTop = marginTop;
    offsets.marginLeft = marginLeft;
  }

  if (isIE10 && !fixedPosition ? parent.contains(scrollParent) : parent === scrollParent && scrollParent.nodeName !== 'BODY') {
    offsets = includeScroll(offsets, parent);
  }

  return offsets;
}

function getViewportOffsetRectRelativeToArtbitraryNode(element) {
  var excludeScroll = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  var html = element.ownerDocument.documentElement;
  var relativeOffset = getOffsetRectRelativeToArbitraryNode(element, html);
  var width = Math.max(html.clientWidth, window.innerWidth || 0);
  var height = Math.max(html.clientHeight, window.innerHeight || 0);

  var scrollTop = !excludeScroll ? getScroll(html) : 0;
  var scrollLeft = !excludeScroll ? getScroll(html, 'left') : 0;

  var offset = {
    top: scrollTop - relativeOffset.top + relativeOffset.marginTop,
    left: scrollLeft - relativeOffset.left + relativeOffset.marginLeft,
    width: width,
    height: height
  };

  return getClientRect(offset);
}

/**
 * Check if the given element is fixed or is inside a fixed parent
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element
 * @argument {Element} customContainer
 * @returns {Boolean} answer to "isFixed?"
 */
function isFixed(element) {
  var nodeName = element.nodeName;
  if (nodeName === 'BODY' || nodeName === 'HTML') {
    return false;
  }
  if (getStyleComputedProperty(element, 'position') === 'fixed') {
    return true;
  }
  var parentNode = getParentNode(element);
  if (!parentNode) {
    return false;
  }
  return isFixed(parentNode);
}

/**
 * Finds the first parent of an element that has a transformed property defined
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element
 * @returns {Element} first transformed parent or documentElement
 */

function getFixedPositionOffsetParent(element) {
  // This check is needed to avoid errors in case one of the elements isn't defined for any reason
  if (!element || !element.parentElement || isIE()) {
    return document.documentElement;
  }
  var el = element.parentElement;
  while (el && getStyleComputedProperty(el, 'transform') === 'none') {
    el = el.parentElement;
  }
  return el || document.documentElement;
}

/**
 * Computed the boundaries limits and return them
 * @method
 * @memberof Popper.Utils
 * @param {HTMLElement} popper
 * @param {HTMLElement} reference
 * @param {number} padding
 * @param {HTMLElement} boundariesElement - Element used to define the boundaries
 * @param {Boolean} fixedPosition - Is in fixed position mode
 * @returns {Object} Coordinates of the boundaries
 */
function getBoundaries(popper, reference, padding, boundariesElement) {
  var fixedPosition = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;

  // NOTE: 1 DOM access here

  var boundaries = { top: 0, left: 0 };
  var offsetParent = fixedPosition ? getFixedPositionOffsetParent(popper) : findCommonOffsetParent(popper, getReferenceNode(reference));

  // Handle viewport case
  if (boundariesElement === 'viewport') {
    boundaries = getViewportOffsetRectRelativeToArtbitraryNode(offsetParent, fixedPosition);
  } else {
    // Handle other cases based on DOM element used as boundaries
    var boundariesNode = void 0;
    if (boundariesElement === 'scrollParent') {
      boundariesNode = getScrollParent(getParentNode(reference));
      if (boundariesNode.nodeName === 'BODY') {
        boundariesNode = popper.ownerDocument.documentElement;
      }
    } else if (boundariesElement === 'window') {
      boundariesNode = popper.ownerDocument.documentElement;
    } else {
      boundariesNode = boundariesElement;
    }

    var offsets = getOffsetRectRelativeToArbitraryNode(boundariesNode, offsetParent, fixedPosition);

    // In case of HTML, we need a different computation
    if (boundariesNode.nodeName === 'HTML' && !isFixed(offsetParent)) {
      var _getWindowSizes = getWindowSizes(popper.ownerDocument),
          height = _getWindowSizes.height,
          width = _getWindowSizes.width;

      boundaries.top += offsets.top - offsets.marginTop;
      boundaries.bottom = height + offsets.top;
      boundaries.left += offsets.left - offsets.marginLeft;
      boundaries.right = width + offsets.left;
    } else {
      // for all the other DOM elements, this one is good
      boundaries = offsets;
    }
  }

  // Add paddings
  padding = padding || 0;
  var isPaddingNumber = typeof padding === 'number';
  boundaries.left += isPaddingNumber ? padding : padding.left || 0;
  boundaries.top += isPaddingNumber ? padding : padding.top || 0;
  boundaries.right -= isPaddingNumber ? padding : padding.right || 0;
  boundaries.bottom -= isPaddingNumber ? padding : padding.bottom || 0;

  return boundaries;
}

function getArea(_ref) {
  var width = _ref.width,
      height = _ref.height;

  return width * height;
}

/**
 * Utility used to transform the `auto` placement to the placement with more
 * available space.
 * @method
 * @memberof Popper.Utils
 * @argument {Object} data - The data object generated by update method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function computeAutoPlacement(placement, refRect, popper, reference, boundariesElement) {
  var padding = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : 0;

  if (placement.indexOf('auto') === -1) {
    return placement;
  }

  var boundaries = getBoundaries(popper, reference, padding, boundariesElement);

  var rects = {
    top: {
      width: boundaries.width,
      height: refRect.top - boundaries.top
    },
    right: {
      width: boundaries.right - refRect.right,
      height: boundaries.height
    },
    bottom: {
      width: boundaries.width,
      height: boundaries.bottom - refRect.bottom
    },
    left: {
      width: refRect.left - boundaries.left,
      height: boundaries.height
    }
  };

  var sortedAreas = Object.keys(rects).map(function (key) {
    return _extends({
      key: key
    }, rects[key], {
      area: getArea(rects[key])
    });
  }).sort(function (a, b) {
    return b.area - a.area;
  });

  var filteredAreas = sortedAreas.filter(function (_ref2) {
    var width = _ref2.width,
        height = _ref2.height;
    return width >= popper.clientWidth && height >= popper.clientHeight;
  });

  var computedPlacement = filteredAreas.length > 0 ? filteredAreas[0].key : sortedAreas[0].key;

  var variation = placement.split('-')[1];

  return computedPlacement + (variation ? '-' + variation : '');
}

/**
 * Get offsets to the reference element
 * @method
 * @memberof Popper.Utils
 * @param {Object} state
 * @param {Element} popper - the popper element
 * @param {Element} reference - the reference element (the popper will be relative to this)
 * @param {Element} fixedPosition - is in fixed position mode
 * @returns {Object} An object containing the offsets which will be applied to the popper
 */
function getReferenceOffsets(state, popper, reference) {
  var fixedPosition = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;

  var commonOffsetParent = fixedPosition ? getFixedPositionOffsetParent(popper) : findCommonOffsetParent(popper, getReferenceNode(reference));
  return getOffsetRectRelativeToArbitraryNode(reference, commonOffsetParent, fixedPosition);
}

/**
 * Get the outer sizes of the given element (offset size + margins)
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element
 * @returns {Object} object containing width and height properties
 */
function getOuterSizes(element) {
  var window = element.ownerDocument.defaultView;
  var styles = window.getComputedStyle(element);
  var x = parseFloat(styles.marginTop || 0) + parseFloat(styles.marginBottom || 0);
  var y = parseFloat(styles.marginLeft || 0) + parseFloat(styles.marginRight || 0);
  var result = {
    width: element.offsetWidth + y,
    height: element.offsetHeight + x
  };
  return result;
}

/**
 * Get the opposite placement of the given one
 * @method
 * @memberof Popper.Utils
 * @argument {String} placement
 * @returns {String} flipped placement
 */
function getOppositePlacement(placement) {
  var hash = { left: 'right', right: 'left', bottom: 'top', top: 'bottom' };
  return placement.replace(/left|right|bottom|top/g, function (matched) {
    return hash[matched];
  });
}

/**
 * Get offsets to the popper
 * @method
 * @memberof Popper.Utils
 * @param {Object} position - CSS position the Popper will get applied
 * @param {HTMLElement} popper - the popper element
 * @param {Object} referenceOffsets - the reference offsets (the popper will be relative to this)
 * @param {String} placement - one of the valid placement options
 * @returns {Object} popperOffsets - An object containing the offsets which will be applied to the popper
 */
function getPopperOffsets(popper, referenceOffsets, placement) {
  placement = placement.split('-')[0];

  // Get popper node sizes
  var popperRect = getOuterSizes(popper);

  // Add position, width and height to our offsets object
  var popperOffsets = {
    width: popperRect.width,
    height: popperRect.height
  };

  // depending by the popper placement we have to compute its offsets slightly differently
  var isHoriz = ['right', 'left'].indexOf(placement) !== -1;
  var mainSide = isHoriz ? 'top' : 'left';
  var secondarySide = isHoriz ? 'left' : 'top';
  var measurement = isHoriz ? 'height' : 'width';
  var secondaryMeasurement = !isHoriz ? 'height' : 'width';

  popperOffsets[mainSide] = referenceOffsets[mainSide] + referenceOffsets[measurement] / 2 - popperRect[measurement] / 2;
  if (placement === secondarySide) {
    popperOffsets[secondarySide] = referenceOffsets[secondarySide] - popperRect[secondaryMeasurement];
  } else {
    popperOffsets[secondarySide] = referenceOffsets[getOppositePlacement(secondarySide)];
  }

  return popperOffsets;
}

/**
 * Mimics the `find` method of Array
 * @method
 * @memberof Popper.Utils
 * @argument {Array} arr
 * @argument prop
 * @argument value
 * @returns index or -1
 */
function find(arr, check) {
  // use native find if supported
  if (Array.prototype.find) {
    return arr.find(check);
  }

  // use `filter` to obtain the same behavior of `find`
  return arr.filter(check)[0];
}

/**
 * Return the index of the matching object
 * @method
 * @memberof Popper.Utils
 * @argument {Array} arr
 * @argument prop
 * @argument value
 * @returns index or -1
 */
function findIndex(arr, prop, value) {
  // use native findIndex if supported
  if (Array.prototype.findIndex) {
    return arr.findIndex(function (cur) {
      return cur[prop] === value;
    });
  }

  // use `find` + `indexOf` if `findIndex` isn't supported
  var match = find(arr, function (obj) {
    return obj[prop] === value;
  });
  return arr.indexOf(match);
}

/**
 * Loop trough the list of modifiers and run them in order,
 * each of them will then edit the data object.
 * @method
 * @memberof Popper.Utils
 * @param {dataObject} data
 * @param {Array} modifiers
 * @param {String} ends - Optional modifier name used as stopper
 * @returns {dataObject}
 */
function runModifiers(modifiers, data, ends) {
  var modifiersToRun = ends === undefined ? modifiers : modifiers.slice(0, findIndex(modifiers, 'name', ends));

  modifiersToRun.forEach(function (modifier) {
    if (modifier['function']) {
      // eslint-disable-line dot-notation
      console.warn('`modifier.function` is deprecated, use `modifier.fn`!');
    }
    var fn = modifier['function'] || modifier.fn; // eslint-disable-line dot-notation
    if (modifier.enabled && isFunction(fn)) {
      // Add properties to offsets to make them a complete clientRect object
      // we do this before each modifier to make sure the previous one doesn't
      // mess with these values
      data.offsets.popper = getClientRect(data.offsets.popper);
      data.offsets.reference = getClientRect(data.offsets.reference);

      data = fn(data, modifier);
    }
  });

  return data;
}

/**
 * Updates the position of the popper, computing the new offsets and applying
 * the new style.<br />
 * Prefer `scheduleUpdate` over `update` because of performance reasons.
 * @method
 * @memberof Popper
 */
function update() {
  // if popper is destroyed, don't perform any further update
  if (this.state.isDestroyed) {
    return;
  }

  var data = {
    instance: this,
    styles: {},
    arrowStyles: {},
    attributes: {},
    flipped: false,
    offsets: {}
  };

  // compute reference element offsets
  data.offsets.reference = getReferenceOffsets(this.state, this.popper, this.reference, this.options.positionFixed);

  // compute auto placement, store placement inside the data object,
  // modifiers will be able to edit `placement` if needed
  // and refer to originalPlacement to know the original value
  data.placement = computeAutoPlacement(this.options.placement, data.offsets.reference, this.popper, this.reference, this.options.modifiers.flip.boundariesElement, this.options.modifiers.flip.padding);

  // store the computed placement inside `originalPlacement`
  data.originalPlacement = data.placement;

  data.positionFixed = this.options.positionFixed;

  // compute the popper offsets
  data.offsets.popper = getPopperOffsets(this.popper, data.offsets.reference, data.placement);

  data.offsets.popper.position = this.options.positionFixed ? 'fixed' : 'absolute';

  // run the modifiers
  data = runModifiers(this.modifiers, data);

  // the first `update` will call `onCreate` callback
  // the other ones will call `onUpdate` callback
  if (!this.state.isCreated) {
    this.state.isCreated = true;
    this.options.onCreate(data);
  } else {
    this.options.onUpdate(data);
  }
}

/**
 * Helper used to know if the given modifier is enabled.
 * @method
 * @memberof Popper.Utils
 * @returns {Boolean}
 */
function isModifierEnabled(modifiers, modifierName) {
  return modifiers.some(function (_ref) {
    var name = _ref.name,
        enabled = _ref.enabled;
    return enabled && name === modifierName;
  });
}

/**
 * Get the prefixed supported property name
 * @method
 * @memberof Popper.Utils
 * @argument {String} property (camelCase)
 * @returns {String} prefixed property (camelCase or PascalCase, depending on the vendor prefix)
 */
function getSupportedPropertyName(property) {
  var prefixes = [false, 'ms', 'Webkit', 'Moz', 'O'];
  var upperProp = property.charAt(0).toUpperCase() + property.slice(1);

  for (var i = 0; i < prefixes.length; i++) {
    var prefix = prefixes[i];
    var toCheck = prefix ? '' + prefix + upperProp : property;
    if (typeof document.body.style[toCheck] !== 'undefined') {
      return toCheck;
    }
  }
  return null;
}

/**
 * Destroys the popper.
 * @method
 * @memberof Popper
 */
function destroy() {
  this.state.isDestroyed = true;

  // touch DOM only if `applyStyle` modifier is enabled
  if (isModifierEnabled(this.modifiers, 'applyStyle')) {
    this.popper.removeAttribute('x-placement');
    this.popper.style.position = '';
    this.popper.style.top = '';
    this.popper.style.left = '';
    this.popper.style.right = '';
    this.popper.style.bottom = '';
    this.popper.style.willChange = '';
    this.popper.style[getSupportedPropertyName('transform')] = '';
  }

  this.disableEventListeners();

  // remove the popper if user explicitly asked for the deletion on destroy
  // do not use `remove` because IE11 doesn't support it
  if (this.options.removeOnDestroy) {
    this.popper.parentNode.removeChild(this.popper);
  }
  return this;
}

/**
 * Get the window associated with the element
 * @argument {Element} element
 * @returns {Window}
 */
function getWindow(element) {
  var ownerDocument = element.ownerDocument;
  return ownerDocument ? ownerDocument.defaultView : window;
}

function attachToScrollParents(scrollParent, event, callback, scrollParents) {
  var isBody = scrollParent.nodeName === 'BODY';
  var target = isBody ? scrollParent.ownerDocument.defaultView : scrollParent;
  target.addEventListener(event, callback, { passive: true });

  if (!isBody) {
    attachToScrollParents(getScrollParent(target.parentNode), event, callback, scrollParents);
  }
  scrollParents.push(target);
}

/**
 * Setup needed event listeners used to update the popper position
 * @method
 * @memberof Popper.Utils
 * @private
 */
function setupEventListeners(reference, options, state, updateBound) {
  // Resize event listener on window
  state.updateBound = updateBound;
  getWindow(reference).addEventListener('resize', state.updateBound, { passive: true });

  // Scroll event listener on scroll parents
  var scrollElement = getScrollParent(reference);
  attachToScrollParents(scrollElement, 'scroll', state.updateBound, state.scrollParents);
  state.scrollElement = scrollElement;
  state.eventsEnabled = true;

  return state;
}

/**
 * It will add resize/scroll events and start recalculating
 * position of the popper element when they are triggered.
 * @method
 * @memberof Popper
 */
function enableEventListeners() {
  if (!this.state.eventsEnabled) {
    this.state = setupEventListeners(this.reference, this.options, this.state, this.scheduleUpdate);
  }
}

/**
 * Remove event listeners used to update the popper position
 * @method
 * @memberof Popper.Utils
 * @private
 */
function removeEventListeners(reference, state) {
  // Remove resize event listener on window
  getWindow(reference).removeEventListener('resize', state.updateBound);

  // Remove scroll event listener on scroll parents
  state.scrollParents.forEach(function (target) {
    target.removeEventListener('scroll', state.updateBound);
  });

  // Reset state
  state.updateBound = null;
  state.scrollParents = [];
  state.scrollElement = null;
  state.eventsEnabled = false;
  return state;
}

/**
 * It will remove resize/scroll events and won't recalculate popper position
 * when they are triggered. It also won't trigger `onUpdate` callback anymore,
 * unless you call `update` method manually.
 * @method
 * @memberof Popper
 */
function disableEventListeners() {
  if (this.state.eventsEnabled) {
    cancelAnimationFrame(this.scheduleUpdate);
    this.state = removeEventListeners(this.reference, this.state);
  }
}

/**
 * Tells if a given input is a number
 * @method
 * @memberof Popper.Utils
 * @param {*} input to check
 * @return {Boolean}
 */
function isNumeric(n) {
  return n !== '' && !isNaN(parseFloat(n)) && isFinite(n);
}

/**
 * Set the style to the given popper
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element - Element to apply the style to
 * @argument {Object} styles
 * Object with a list of properties and values which will be applied to the element
 */
function setStyles(element, styles) {
  Object.keys(styles).forEach(function (prop) {
    var unit = '';
    // add unit if the value is numeric and is one of the following
    if (['width', 'height', 'top', 'right', 'bottom', 'left'].indexOf(prop) !== -1 && isNumeric(styles[prop])) {
      unit = 'px';
    }
    element.style[prop] = styles[prop] + unit;
  });
}

/**
 * Set the attributes to the given popper
 * @method
 * @memberof Popper.Utils
 * @argument {Element} element - Element to apply the attributes to
 * @argument {Object} styles
 * Object with a list of properties and values which will be applied to the element
 */
function setAttributes(element, attributes) {
  Object.keys(attributes).forEach(function (prop) {
    var value = attributes[prop];
    if (value !== false) {
      element.setAttribute(prop, attributes[prop]);
    } else {
      element.removeAttribute(prop);
    }
  });
}

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by `update` method
 * @argument {Object} data.styles - List of style properties - values to apply to popper element
 * @argument {Object} data.attributes - List of attribute properties - values to apply to popper element
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The same data object
 */
function applyStyle(data) {
  // any property present in `data.styles` will be applied to the popper,
  // in this way we can make the 3rd party modifiers add custom styles to it
  // Be aware, modifiers could override the properties defined in the previous
  // lines of this modifier!
  setStyles(data.instance.popper, data.styles);

  // any property present in `data.attributes` will be applied to the popper,
  // they will be set as HTML attributes of the element
  setAttributes(data.instance.popper, data.attributes);

  // if arrowElement is defined and arrowStyles has some properties
  if (data.arrowElement && Object.keys(data.arrowStyles).length) {
    setStyles(data.arrowElement, data.arrowStyles);
  }

  return data;
}

/**
 * Set the x-placement attribute before everything else because it could be used
 * to add margins to the popper margins needs to be calculated to get the
 * correct popper offsets.
 * @method
 * @memberof Popper.modifiers
 * @param {HTMLElement} reference - The reference element used to position the popper
 * @param {HTMLElement} popper - The HTML element used as popper
 * @param {Object} options - Popper.js options
 */
function applyStyleOnLoad(reference, popper, options, modifierOptions, state) {
  // compute reference element offsets
  var referenceOffsets = getReferenceOffsets(state, popper, reference, options.positionFixed);

  // compute auto placement, store placement inside the data object,
  // modifiers will be able to edit `placement` if needed
  // and refer to originalPlacement to know the original value
  var placement = computeAutoPlacement(options.placement, referenceOffsets, popper, reference, options.modifiers.flip.boundariesElement, options.modifiers.flip.padding);

  popper.setAttribute('x-placement', placement);

  // Apply `position` to popper before anything else because
  // without the position applied we can't guarantee correct computations
  setStyles(popper, { position: options.positionFixed ? 'fixed' : 'absolute' });

  return options;
}

/**
 * @function
 * @memberof Popper.Utils
 * @argument {Object} data - The data object generated by `update` method
 * @argument {Boolean} shouldRound - If the offsets should be rounded at all
 * @returns {Object} The popper's position offsets rounded
 *
 * The tale of pixel-perfect positioning. It's still not 100% perfect, but as
 * good as it can be within reason.
 * Discussion here: https://github.com/FezVrasta/popper.js/pull/715
 *
 * Low DPI screens cause a popper to be blurry if not using full pixels (Safari
 * as well on High DPI screens).
 *
 * Firefox prefers no rounding for positioning and does not have blurriness on
 * high DPI screens.
 *
 * Only horizontal placement and left/right values need to be considered.
 */
function getRoundedOffsets(data, shouldRound) {
  var _data$offsets = data.offsets,
      popper = _data$offsets.popper,
      reference = _data$offsets.reference;
  var round = Math.round,
      floor = Math.floor;

  var noRound = function noRound(v) {
    return v;
  };

  var referenceWidth = round(reference.width);
  var popperWidth = round(popper.width);

  var isVertical = ['left', 'right'].indexOf(data.placement) !== -1;
  var isVariation = data.placement.indexOf('-') !== -1;
  var sameWidthParity = referenceWidth % 2 === popperWidth % 2;
  var bothOddWidth = referenceWidth % 2 === 1 && popperWidth % 2 === 1;

  var horizontalToInteger = !shouldRound ? noRound : isVertical || isVariation || sameWidthParity ? round : floor;
  var verticalToInteger = !shouldRound ? noRound : round;

  return {
    left: horizontalToInteger(bothOddWidth && !isVariation && shouldRound ? popper.left - 1 : popper.left),
    top: verticalToInteger(popper.top),
    bottom: verticalToInteger(popper.bottom),
    right: horizontalToInteger(popper.right)
  };
}

var isFirefox = isBrowser && /Firefox/i.test(navigator.userAgent);

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by `update` method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function computeStyle(data, options) {
  var x = options.x,
      y = options.y;
  var popper = data.offsets.popper;

  // Remove this legacy support in Popper.js v2

  var legacyGpuAccelerationOption = find(data.instance.modifiers, function (modifier) {
    return modifier.name === 'applyStyle';
  }).gpuAcceleration;
  if (legacyGpuAccelerationOption !== undefined) {
    console.warn('WARNING: `gpuAcceleration` option moved to `computeStyle` modifier and will not be supported in future versions of Popper.js!');
  }
  var gpuAcceleration = legacyGpuAccelerationOption !== undefined ? legacyGpuAccelerationOption : options.gpuAcceleration;

  var offsetParent = getOffsetParent(data.instance.popper);
  var offsetParentRect = getBoundingClientRect(offsetParent);

  // Styles
  var styles = {
    position: popper.position
  };

  var offsets = getRoundedOffsets(data, window.devicePixelRatio < 2 || !isFirefox);

  var sideA = x === 'bottom' ? 'top' : 'bottom';
  var sideB = y === 'right' ? 'left' : 'right';

  // if gpuAcceleration is set to `true` and transform is supported,
  //  we use `translate3d` to apply the position to the popper we
  // automatically use the supported prefixed version if needed
  var prefixedProperty = getSupportedPropertyName('transform');

  // now, let's make a step back and look at this code closely (wtf?)
  // If the content of the popper grows once it's been positioned, it
  // may happen that the popper gets misplaced because of the new content
  // overflowing its reference element
  // To avoid this problem, we provide two options (x and y), which allow
  // the consumer to define the offset origin.
  // If we position a popper on top of a reference element, we can set
  // `x` to `top` to make the popper grow towards its top instead of
  // its bottom.
  var left = void 0,
      top = void 0;
  if (sideA === 'bottom') {
    // when offsetParent is <html> the positioning is relative to the bottom of the screen (excluding the scrollbar)
    // and not the bottom of the html element
    if (offsetParent.nodeName === 'HTML') {
      top = -offsetParent.clientHeight + offsets.bottom;
    } else {
      top = -offsetParentRect.height + offsets.bottom;
    }
  } else {
    top = offsets.top;
  }
  if (sideB === 'right') {
    if (offsetParent.nodeName === 'HTML') {
      left = -offsetParent.clientWidth + offsets.right;
    } else {
      left = -offsetParentRect.width + offsets.right;
    }
  } else {
    left = offsets.left;
  }
  if (gpuAcceleration && prefixedProperty) {
    styles[prefixedProperty] = 'translate3d(' + left + 'px, ' + top + 'px, 0)';
    styles[sideA] = 0;
    styles[sideB] = 0;
    styles.willChange = 'transform';
  } else {
    // othwerise, we use the standard `top`, `left`, `bottom` and `right` properties
    var invertTop = sideA === 'bottom' ? -1 : 1;
    var invertLeft = sideB === 'right' ? -1 : 1;
    styles[sideA] = top * invertTop;
    styles[sideB] = left * invertLeft;
    styles.willChange = sideA + ', ' + sideB;
  }

  // Attributes
  var attributes = {
    'x-placement': data.placement
  };

  // Update `data` attributes, styles and arrowStyles
  data.attributes = _extends({}, attributes, data.attributes);
  data.styles = _extends({}, styles, data.styles);
  data.arrowStyles = _extends({}, data.offsets.arrow, data.arrowStyles);

  return data;
}

/**
 * Helper used to know if the given modifier depends from another one.<br />
 * It checks if the needed modifier is listed and enabled.
 * @method
 * @memberof Popper.Utils
 * @param {Array} modifiers - list of modifiers
 * @param {String} requestingName - name of requesting modifier
 * @param {String} requestedName - name of requested modifier
 * @returns {Boolean}
 */
function isModifierRequired(modifiers, requestingName, requestedName) {
  var requesting = find(modifiers, function (_ref) {
    var name = _ref.name;
    return name === requestingName;
  });

  var isRequired = !!requesting && modifiers.some(function (modifier) {
    return modifier.name === requestedName && modifier.enabled && modifier.order < requesting.order;
  });

  if (!isRequired) {
    var _requesting = '`' + requestingName + '`';
    var requested = '`' + requestedName + '`';
    console.warn(requested + ' modifier is required by ' + _requesting + ' modifier in order to work, be sure to include it before ' + _requesting + '!');
  }
  return isRequired;
}

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by update method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function arrow(data, options) {
  var _data$offsets$arrow;

  // arrow depends on keepTogether in order to work
  if (!isModifierRequired(data.instance.modifiers, 'arrow', 'keepTogether')) {
    return data;
  }

  var arrowElement = options.element;

  // if arrowElement is a string, suppose it's a CSS selector
  if (typeof arrowElement === 'string') {
    arrowElement = data.instance.popper.querySelector(arrowElement);

    // if arrowElement is not found, don't run the modifier
    if (!arrowElement) {
      return data;
    }
  } else {
    // if the arrowElement isn't a query selector we must check that the
    // provided DOM node is child of its popper node
    if (!data.instance.popper.contains(arrowElement)) {
      console.warn('WARNING: `arrow.element` must be child of its popper element!');
      return data;
    }
  }

  var placement = data.placement.split('-')[0];
  var _data$offsets = data.offsets,
      popper = _data$offsets.popper,
      reference = _data$offsets.reference;

  var isVertical = ['left', 'right'].indexOf(placement) !== -1;

  var len = isVertical ? 'height' : 'width';
  var sideCapitalized = isVertical ? 'Top' : 'Left';
  var side = sideCapitalized.toLowerCase();
  var altSide = isVertical ? 'left' : 'top';
  var opSide = isVertical ? 'bottom' : 'right';
  var arrowElementSize = getOuterSizes(arrowElement)[len];

  //
  // extends keepTogether behavior making sure the popper and its
  // reference have enough pixels in conjunction
  //

  // top/left side
  if (reference[opSide] - arrowElementSize < popper[side]) {
    data.offsets.popper[side] -= popper[side] - (reference[opSide] - arrowElementSize);
  }
  // bottom/right side
  if (reference[side] + arrowElementSize > popper[opSide]) {
    data.offsets.popper[side] += reference[side] + arrowElementSize - popper[opSide];
  }
  data.offsets.popper = getClientRect(data.offsets.popper);

  // compute center of the popper
  var center = reference[side] + reference[len] / 2 - arrowElementSize / 2;

  // Compute the sideValue using the updated popper offsets
  // take popper margin in account because we don't have this info available
  var css = getStyleComputedProperty(data.instance.popper);
  var popperMarginSide = parseFloat(css['margin' + sideCapitalized]);
  var popperBorderSide = parseFloat(css['border' + sideCapitalized + 'Width']);
  var sideValue = center - data.offsets.popper[side] - popperMarginSide - popperBorderSide;

  // prevent arrowElement from being placed not contiguously to its popper
  sideValue = Math.max(Math.min(popper[len] - arrowElementSize, sideValue), 0);

  data.arrowElement = arrowElement;
  data.offsets.arrow = (_data$offsets$arrow = {}, defineProperty(_data$offsets$arrow, side, Math.round(sideValue)), defineProperty(_data$offsets$arrow, altSide, ''), _data$offsets$arrow);

  return data;
}

/**
 * Get the opposite placement variation of the given one
 * @method
 * @memberof Popper.Utils
 * @argument {String} placement variation
 * @returns {String} flipped placement variation
 */
function getOppositeVariation(variation) {
  if (variation === 'end') {
    return 'start';
  } else if (variation === 'start') {
    return 'end';
  }
  return variation;
}

/**
 * List of accepted placements to use as values of the `placement` option.<br />
 * Valid placements are:
 * - `auto`
 * - `top`
 * - `right`
 * - `bottom`
 * - `left`
 *
 * Each placement can have a variation from this list:
 * - `-start`
 * - `-end`
 *
 * Variations are interpreted easily if you think of them as the left to right
 * written languages. Horizontally (`top` and `bottom`), `start` is left and `end`
 * is right.<br />
 * Vertically (`left` and `right`), `start` is top and `end` is bottom.
 *
 * Some valid examples are:
 * - `top-end` (on top of reference, right aligned)
 * - `right-start` (on right of reference, top aligned)
 * - `bottom` (on bottom, centered)
 * - `auto-end` (on the side with more space available, alignment depends by placement)
 *
 * @static
 * @type {Array}
 * @enum {String}
 * @readonly
 * @method placements
 * @memberof Popper
 */
var placements = ['auto-start', 'auto', 'auto-end', 'top-start', 'top', 'top-end', 'right-start', 'right', 'right-end', 'bottom-end', 'bottom', 'bottom-start', 'left-end', 'left', 'left-start'];

// Get rid of `auto` `auto-start` and `auto-end`
var validPlacements = placements.slice(3);

/**
 * Given an initial placement, returns all the subsequent placements
 * clockwise (or counter-clockwise).
 *
 * @method
 * @memberof Popper.Utils
 * @argument {String} placement - A valid placement (it accepts variations)
 * @argument {Boolean} counter - Set to true to walk the placements counterclockwise
 * @returns {Array} placements including their variations
 */
function clockwise(placement) {
  var counter = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

  var index = validPlacements.indexOf(placement);
  var arr = validPlacements.slice(index + 1).concat(validPlacements.slice(0, index));
  return counter ? arr.reverse() : arr;
}

var BEHAVIORS = {
  FLIP: 'flip',
  CLOCKWISE: 'clockwise',
  COUNTERCLOCKWISE: 'counterclockwise'
};

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by update method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function flip(data, options) {
  // if `inner` modifier is enabled, we can't use the `flip` modifier
  if (isModifierEnabled(data.instance.modifiers, 'inner')) {
    return data;
  }

  if (data.flipped && data.placement === data.originalPlacement) {
    // seems like flip is trying to loop, probably there's not enough space on any of the flippable sides
    return data;
  }

  var boundaries = getBoundaries(data.instance.popper, data.instance.reference, options.padding, options.boundariesElement, data.positionFixed);

  var placement = data.placement.split('-')[0];
  var placementOpposite = getOppositePlacement(placement);
  var variation = data.placement.split('-')[1] || '';

  var flipOrder = [];

  switch (options.behavior) {
    case BEHAVIORS.FLIP:
      flipOrder = [placement, placementOpposite];
      break;
    case BEHAVIORS.CLOCKWISE:
      flipOrder = clockwise(placement);
      break;
    case BEHAVIORS.COUNTERCLOCKWISE:
      flipOrder = clockwise(placement, true);
      break;
    default:
      flipOrder = options.behavior;
  }

  flipOrder.forEach(function (step, index) {
    if (placement !== step || flipOrder.length === index + 1) {
      return data;
    }

    placement = data.placement.split('-')[0];
    placementOpposite = getOppositePlacement(placement);

    var popperOffsets = data.offsets.popper;
    var refOffsets = data.offsets.reference;

    // using floor because the reference offsets may contain decimals we are not going to consider here
    var floor = Math.floor;
    var overlapsRef = placement === 'left' && floor(popperOffsets.right) > floor(refOffsets.left) || placement === 'right' && floor(popperOffsets.left) < floor(refOffsets.right) || placement === 'top' && floor(popperOffsets.bottom) > floor(refOffsets.top) || placement === 'bottom' && floor(popperOffsets.top) < floor(refOffsets.bottom);

    var overflowsLeft = floor(popperOffsets.left) < floor(boundaries.left);
    var overflowsRight = floor(popperOffsets.right) > floor(boundaries.right);
    var overflowsTop = floor(popperOffsets.top) < floor(boundaries.top);
    var overflowsBottom = floor(popperOffsets.bottom) > floor(boundaries.bottom);

    var overflowsBoundaries = placement === 'left' && overflowsLeft || placement === 'right' && overflowsRight || placement === 'top' && overflowsTop || placement === 'bottom' && overflowsBottom;

    // flip the variation if required
    var isVertical = ['top', 'bottom'].indexOf(placement) !== -1;

    // flips variation if reference element overflows boundaries
    var flippedVariationByRef = !!options.flipVariations && (isVertical && variation === 'start' && overflowsLeft || isVertical && variation === 'end' && overflowsRight || !isVertical && variation === 'start' && overflowsTop || !isVertical && variation === 'end' && overflowsBottom);

    // flips variation if popper content overflows boundaries
    var flippedVariationByContent = !!options.flipVariationsByContent && (isVertical && variation === 'start' && overflowsRight || isVertical && variation === 'end' && overflowsLeft || !isVertical && variation === 'start' && overflowsBottom || !isVertical && variation === 'end' && overflowsTop);

    var flippedVariation = flippedVariationByRef || flippedVariationByContent;

    if (overlapsRef || overflowsBoundaries || flippedVariation) {
      // this boolean to detect any flip loop
      data.flipped = true;

      if (overlapsRef || overflowsBoundaries) {
        placement = flipOrder[index + 1];
      }

      if (flippedVariation) {
        variation = getOppositeVariation(variation);
      }

      data.placement = placement + (variation ? '-' + variation : '');

      // this object contains `position`, we want to preserve it along with
      // any additional property we may add in the future
      data.offsets.popper = _extends({}, data.offsets.popper, getPopperOffsets(data.instance.popper, data.offsets.reference, data.placement));

      data = runModifiers(data.instance.modifiers, data, 'flip');
    }
  });
  return data;
}

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by update method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function keepTogether(data) {
  var _data$offsets = data.offsets,
      popper = _data$offsets.popper,
      reference = _data$offsets.reference;

  var placement = data.placement.split('-')[0];
  var floor = Math.floor;
  var isVertical = ['top', 'bottom'].indexOf(placement) !== -1;
  var side = isVertical ? 'right' : 'bottom';
  var opSide = isVertical ? 'left' : 'top';
  var measurement = isVertical ? 'width' : 'height';

  if (popper[side] < floor(reference[opSide])) {
    data.offsets.popper[opSide] = floor(reference[opSide]) - popper[measurement];
  }
  if (popper[opSide] > floor(reference[side])) {
    data.offsets.popper[opSide] = floor(reference[side]);
  }

  return data;
}

/**
 * Converts a string containing value + unit into a px value number
 * @function
 * @memberof {modifiers~offset}
 * @private
 * @argument {String} str - Value + unit string
 * @argument {String} measurement - `height` or `width`
 * @argument {Object} popperOffsets
 * @argument {Object} referenceOffsets
 * @returns {Number|String}
 * Value in pixels, or original string if no values were extracted
 */
function toValue(str, measurement, popperOffsets, referenceOffsets) {
  // separate value from unit
  var split = str.match(/((?:\-|\+)?\d*\.?\d*)(.*)/);
  var value = +split[1];
  var unit = split[2];

  // If it's not a number it's an operator, I guess
  if (!value) {
    return str;
  }

  if (unit.indexOf('%') === 0) {
    var element = void 0;
    switch (unit) {
      case '%p':
        element = popperOffsets;
        break;
      case '%':
      case '%r':
      default:
        element = referenceOffsets;
    }

    var rect = getClientRect(element);
    return rect[measurement] / 100 * value;
  } else if (unit === 'vh' || unit === 'vw') {
    // if is a vh or vw, we calculate the size based on the viewport
    var size = void 0;
    if (unit === 'vh') {
      size = Math.max(document.documentElement.clientHeight, window.innerHeight || 0);
    } else {
      size = Math.max(document.documentElement.clientWidth, window.innerWidth || 0);
    }
    return size / 100 * value;
  } else {
    // if is an explicit pixel unit, we get rid of the unit and keep the value
    // if is an implicit unit, it's px, and we return just the value
    return value;
  }
}

/**
 * Parse an `offset` string to extrapolate `x` and `y` numeric offsets.
 * @function
 * @memberof {modifiers~offset}
 * @private
 * @argument {String} offset
 * @argument {Object} popperOffsets
 * @argument {Object} referenceOffsets
 * @argument {String} basePlacement
 * @returns {Array} a two cells array with x and y offsets in numbers
 */
function parseOffset(offset, popperOffsets, referenceOffsets, basePlacement) {
  var offsets = [0, 0];

  // Use height if placement is left or right and index is 0 otherwise use width
  // in this way the first offset will use an axis and the second one
  // will use the other one
  var useHeight = ['right', 'left'].indexOf(basePlacement) !== -1;

  // Split the offset string to obtain a list of values and operands
  // The regex addresses values with the plus or minus sign in front (+10, -20, etc)
  var fragments = offset.split(/(\+|\-)/).map(function (frag) {
    return frag.trim();
  });

  // Detect if the offset string contains a pair of values or a single one
  // they could be separated by comma or space
  var divider = fragments.indexOf(find(fragments, function (frag) {
    return frag.search(/,|\s/) !== -1;
  }));

  if (fragments[divider] && fragments[divider].indexOf(',') === -1) {
    console.warn('Offsets separated by white space(s) are deprecated, use a comma (,) instead.');
  }

  // If divider is found, we divide the list of values and operands to divide
  // them by ofset X and Y.
  var splitRegex = /\s*,\s*|\s+/;
  var ops = divider !== -1 ? [fragments.slice(0, divider).concat([fragments[divider].split(splitRegex)[0]]), [fragments[divider].split(splitRegex)[1]].concat(fragments.slice(divider + 1))] : [fragments];

  // Convert the values with units to absolute pixels to allow our computations
  ops = ops.map(function (op, index) {
    // Most of the units rely on the orientation of the popper
    var measurement = (index === 1 ? !useHeight : useHeight) ? 'height' : 'width';
    var mergeWithPrevious = false;
    return op
    // This aggregates any `+` or `-` sign that aren't considered operators
    // e.g.: 10 + +5 => [10, +, +5]
    .reduce(function (a, b) {
      if (a[a.length - 1] === '' && ['+', '-'].indexOf(b) !== -1) {
        a[a.length - 1] = b;
        mergeWithPrevious = true;
        return a;
      } else if (mergeWithPrevious) {
        a[a.length - 1] += b;
        mergeWithPrevious = false;
        return a;
      } else {
        return a.concat(b);
      }
    }, [])
    // Here we convert the string values into number values (in px)
    .map(function (str) {
      return toValue(str, measurement, popperOffsets, referenceOffsets);
    });
  });

  // Loop trough the offsets arrays and execute the operations
  ops.forEach(function (op, index) {
    op.forEach(function (frag, index2) {
      if (isNumeric(frag)) {
        offsets[index] += frag * (op[index2 - 1] === '-' ? -1 : 1);
      }
    });
  });
  return offsets;
}

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by update method
 * @argument {Object} options - Modifiers configuration and options
 * @argument {Number|String} options.offset=0
 * The offset value as described in the modifier description
 * @returns {Object} The data object, properly modified
 */
function offset(data, _ref) {
  var offset = _ref.offset;
  var placement = data.placement,
      _data$offsets = data.offsets,
      popper = _data$offsets.popper,
      reference = _data$offsets.reference;

  var basePlacement = placement.split('-')[0];

  var offsets = void 0;
  if (isNumeric(+offset)) {
    offsets = [+offset, 0];
  } else {
    offsets = parseOffset(offset, popper, reference, basePlacement);
  }

  if (basePlacement === 'left') {
    popper.top += offsets[0];
    popper.left -= offsets[1];
  } else if (basePlacement === 'right') {
    popper.top += offsets[0];
    popper.left += offsets[1];
  } else if (basePlacement === 'top') {
    popper.left += offsets[0];
    popper.top -= offsets[1];
  } else if (basePlacement === 'bottom') {
    popper.left += offsets[0];
    popper.top += offsets[1];
  }

  data.popper = popper;
  return data;
}

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by `update` method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function preventOverflow(data, options) {
  var boundariesElement = options.boundariesElement || getOffsetParent(data.instance.popper);

  // If offsetParent is the reference element, we really want to
  // go one step up and use the next offsetParent as reference to
  // avoid to make this modifier completely useless and look like broken
  if (data.instance.reference === boundariesElement) {
    boundariesElement = getOffsetParent(boundariesElement);
  }

  // NOTE: DOM access here
  // resets the popper's position so that the document size can be calculated excluding
  // the size of the popper element itself
  var transformProp = getSupportedPropertyName('transform');
  var popperStyles = data.instance.popper.style; // assignment to help minification
  var top = popperStyles.top,
      left = popperStyles.left,
      transform = popperStyles[transformProp];

  popperStyles.top = '';
  popperStyles.left = '';
  popperStyles[transformProp] = '';

  var boundaries = getBoundaries(data.instance.popper, data.instance.reference, options.padding, boundariesElement, data.positionFixed);

  // NOTE: DOM access here
  // restores the original style properties after the offsets have been computed
  popperStyles.top = top;
  popperStyles.left = left;
  popperStyles[transformProp] = transform;

  options.boundaries = boundaries;

  var order = options.priority;
  var popper = data.offsets.popper;

  var check = {
    primary: function primary(placement) {
      var value = popper[placement];
      if (popper[placement] < boundaries[placement] && !options.escapeWithReference) {
        value = Math.max(popper[placement], boundaries[placement]);
      }
      return defineProperty({}, placement, value);
    },
    secondary: function secondary(placement) {
      var mainSide = placement === 'right' ? 'left' : 'top';
      var value = popper[mainSide];
      if (popper[placement] > boundaries[placement] && !options.escapeWithReference) {
        value = Math.min(popper[mainSide], boundaries[placement] - (placement === 'right' ? popper.width : popper.height));
      }
      return defineProperty({}, mainSide, value);
    }
  };

  order.forEach(function (placement) {
    var side = ['left', 'top'].indexOf(placement) !== -1 ? 'primary' : 'secondary';
    popper = _extends({}, popper, check[side](placement));
  });

  data.offsets.popper = popper;

  return data;
}

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by `update` method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function shift(data) {
  var placement = data.placement;
  var basePlacement = placement.split('-')[0];
  var shiftvariation = placement.split('-')[1];

  // if shift shiftvariation is specified, run the modifier
  if (shiftvariation) {
    var _data$offsets = data.offsets,
        reference = _data$offsets.reference,
        popper = _data$offsets.popper;

    var isVertical = ['bottom', 'top'].indexOf(basePlacement) !== -1;
    var side = isVertical ? 'left' : 'top';
    var measurement = isVertical ? 'width' : 'height';

    var shiftOffsets = {
      start: defineProperty({}, side, reference[side]),
      end: defineProperty({}, side, reference[side] + reference[measurement] - popper[measurement])
    };

    data.offsets.popper = _extends({}, popper, shiftOffsets[shiftvariation]);
  }

  return data;
}

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by update method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function hide(data) {
  if (!isModifierRequired(data.instance.modifiers, 'hide', 'preventOverflow')) {
    return data;
  }

  var refRect = data.offsets.reference;
  var bound = find(data.instance.modifiers, function (modifier) {
    return modifier.name === 'preventOverflow';
  }).boundaries;

  if (refRect.bottom < bound.top || refRect.left > bound.right || refRect.top > bound.bottom || refRect.right < bound.left) {
    // Avoid unnecessary DOM access if visibility hasn't changed
    if (data.hide === true) {
      return data;
    }

    data.hide = true;
    data.attributes['x-out-of-boundaries'] = '';
  } else {
    // Avoid unnecessary DOM access if visibility hasn't changed
    if (data.hide === false) {
      return data;
    }

    data.hide = false;
    data.attributes['x-out-of-boundaries'] = false;
  }

  return data;
}

/**
 * @function
 * @memberof Modifiers
 * @argument {Object} data - The data object generated by `update` method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {Object} The data object, properly modified
 */
function inner(data) {
  var placement = data.placement;
  var basePlacement = placement.split('-')[0];
  var _data$offsets = data.offsets,
      popper = _data$offsets.popper,
      reference = _data$offsets.reference;

  var isHoriz = ['left', 'right'].indexOf(basePlacement) !== -1;

  var subtractLength = ['top', 'left'].indexOf(basePlacement) === -1;

  popper[isHoriz ? 'left' : 'top'] = reference[basePlacement] - (subtractLength ? popper[isHoriz ? 'width' : 'height'] : 0);

  data.placement = getOppositePlacement(placement);
  data.offsets.popper = getClientRect(popper);

  return data;
}

/**
 * Modifier function, each modifier can have a function of this type assigned
 * to its `fn` property.<br />
 * These functions will be called on each update, this means that you must
 * make sure they are performant enough to avoid performance bottlenecks.
 *
 * @function ModifierFn
 * @argument {dataObject} data - The data object generated by `update` method
 * @argument {Object} options - Modifiers configuration and options
 * @returns {dataObject} The data object, properly modified
 */

/**
 * Modifiers are plugins used to alter the behavior of your poppers.<br />
 * Popper.js uses a set of 9 modifiers to provide all the basic functionalities
 * needed by the library.
 *
 * Usually you don't want to override the `order`, `fn` and `onLoad` props.
 * All the other properties are configurations that could be tweaked.
 * @namespace modifiers
 */
var modifiers = {
  /**
   * Modifier used to shift the popper on the start or end of its reference
   * element.<br />
   * It will read the variation of the `placement` property.<br />
   * It can be one either `-end` or `-start`.
   * @memberof modifiers
   * @inner
   */
  shift: {
    /** @prop {number} order=100 - Index used to define the order of execution */
    order: 100,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: shift
  },

  /**
   * The `offset` modifier can shift your popper on both its axis.
   *
   * It accepts the following units:
   * - `px` or unit-less, interpreted as pixels
   * - `%` or `%r`, percentage relative to the length of the reference element
   * - `%p`, percentage relative to the length of the popper element
   * - `vw`, CSS viewport width unit
   * - `vh`, CSS viewport height unit
   *
   * For length is intended the main axis relative to the placement of the popper.<br />
   * This means that if the placement is `top` or `bottom`, the length will be the
   * `width`. In case of `left` or `right`, it will be the `height`.
   *
   * You can provide a single value (as `Number` or `String`), or a pair of values
   * as `String` divided by a comma or one (or more) white spaces.<br />
   * The latter is a deprecated method because it leads to confusion and will be
   * removed in v2.<br />
   * Additionally, it accepts additions and subtractions between different units.
   * Note that multiplications and divisions aren't supported.
   *
   * Valid examples are:
   * ```
   * 10
   * '10%'
   * '10, 10'
   * '10%, 10'
   * '10 + 10%'
   * '10 - 5vh + 3%'
   * '-10px + 5vh, 5px - 6%'
   * ```
   * > **NB**: If you desire to apply offsets to your poppers in a way that may make them overlap
   * > with their reference element, unfortunately, you will have to disable the `flip` modifier.
   * > You can read more on this at this [issue](https://github.com/FezVrasta/popper.js/issues/373).
   *
   * @memberof modifiers
   * @inner
   */
  offset: {
    /** @prop {number} order=200 - Index used to define the order of execution */
    order: 200,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: offset,
    /** @prop {Number|String} offset=0
     * The offset value as described in the modifier description
     */
    offset: 0
  },

  /**
   * Modifier used to prevent the popper from being positioned outside the boundary.
   *
   * A scenario exists where the reference itself is not within the boundaries.<br />
   * We can say it has "escaped the boundaries" — or just "escaped".<br />
   * In this case we need to decide whether the popper should either:
   *
   * - detach from the reference and remain "trapped" in the boundaries, or
   * - if it should ignore the boundary and "escape with its reference"
   *
   * When `escapeWithReference` is set to`true` and reference is completely
   * outside its boundaries, the popper will overflow (or completely leave)
   * the boundaries in order to remain attached to the edge of the reference.
   *
   * @memberof modifiers
   * @inner
   */
  preventOverflow: {
    /** @prop {number} order=300 - Index used to define the order of execution */
    order: 300,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: preventOverflow,
    /**
     * @prop {Array} [priority=['left','right','top','bottom']]
     * Popper will try to prevent overflow following these priorities by default,
     * then, it could overflow on the left and on top of the `boundariesElement`
     */
    priority: ['left', 'right', 'top', 'bottom'],
    /**
     * @prop {number} padding=5
     * Amount of pixel used to define a minimum distance between the boundaries
     * and the popper. This makes sure the popper always has a little padding
     * between the edges of its container
     */
    padding: 5,
    /**
     * @prop {String|HTMLElement} boundariesElement='scrollParent'
     * Boundaries used by the modifier. Can be `scrollParent`, `window`,
     * `viewport` or any DOM element.
     */
    boundariesElement: 'scrollParent'
  },

  /**
   * Modifier used to make sure the reference and its popper stay near each other
   * without leaving any gap between the two. Especially useful when the arrow is
   * enabled and you want to ensure that it points to its reference element.
   * It cares only about the first axis. You can still have poppers with margin
   * between the popper and its reference element.
   * @memberof modifiers
   * @inner
   */
  keepTogether: {
    /** @prop {number} order=400 - Index used to define the order of execution */
    order: 400,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: keepTogether
  },

  /**
   * This modifier is used to move the `arrowElement` of the popper to make
   * sure it is positioned between the reference element and its popper element.
   * It will read the outer size of the `arrowElement` node to detect how many
   * pixels of conjunction are needed.
   *
   * It has no effect if no `arrowElement` is provided.
   * @memberof modifiers
   * @inner
   */
  arrow: {
    /** @prop {number} order=500 - Index used to define the order of execution */
    order: 500,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: arrow,
    /** @prop {String|HTMLElement} element='[x-arrow]' - Selector or node used as arrow */
    element: '[x-arrow]'
  },

  /**
   * Modifier used to flip the popper's placement when it starts to overlap its
   * reference element.
   *
   * Requires the `preventOverflow` modifier before it in order to work.
   *
   * **NOTE:** this modifier will interrupt the current update cycle and will
   * restart it if it detects the need to flip the placement.
   * @memberof modifiers
   * @inner
   */
  flip: {
    /** @prop {number} order=600 - Index used to define the order of execution */
    order: 600,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: flip,
    /**
     * @prop {String|Array} behavior='flip'
     * The behavior used to change the popper's placement. It can be one of
     * `flip`, `clockwise`, `counterclockwise` or an array with a list of valid
     * placements (with optional variations)
     */
    behavior: 'flip',
    /**
     * @prop {number} padding=5
     * The popper will flip if it hits the edges of the `boundariesElement`
     */
    padding: 5,
    /**
     * @prop {String|HTMLElement} boundariesElement='viewport'
     * The element which will define the boundaries of the popper position.
     * The popper will never be placed outside of the defined boundaries
     * (except if `keepTogether` is enabled)
     */
    boundariesElement: 'viewport',
    /**
     * @prop {Boolean} flipVariations=false
     * The popper will switch placement variation between `-start` and `-end` when
     * the reference element overlaps its boundaries.
     *
     * The original placement should have a set variation.
     */
    flipVariations: false,
    /**
     * @prop {Boolean} flipVariationsByContent=false
     * The popper will switch placement variation between `-start` and `-end` when
     * the popper element overlaps its reference boundaries.
     *
     * The original placement should have a set variation.
     */
    flipVariationsByContent: false
  },

  /**
   * Modifier used to make the popper flow toward the inner of the reference element.
   * By default, when this modifier is disabled, the popper will be placed outside
   * the reference element.
   * @memberof modifiers
   * @inner
   */
  inner: {
    /** @prop {number} order=700 - Index used to define the order of execution */
    order: 700,
    /** @prop {Boolean} enabled=false - Whether the modifier is enabled or not */
    enabled: false,
    /** @prop {ModifierFn} */
    fn: inner
  },

  /**
   * Modifier used to hide the popper when its reference element is outside of the
   * popper boundaries. It will set a `x-out-of-boundaries` attribute which can
   * be used to hide with a CSS selector the popper when its reference is
   * out of boundaries.
   *
   * Requires the `preventOverflow` modifier before it in order to work.
   * @memberof modifiers
   * @inner
   */
  hide: {
    /** @prop {number} order=800 - Index used to define the order of execution */
    order: 800,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: hide
  },

  /**
   * Computes the style that will be applied to the popper element to gets
   * properly positioned.
   *
   * Note that this modifier will not touch the DOM, it just prepares the styles
   * so that `applyStyle` modifier can apply it. This separation is useful
   * in case you need to replace `applyStyle` with a custom implementation.
   *
   * This modifier has `850` as `order` value to maintain backward compatibility
   * with previous versions of Popper.js. Expect the modifiers ordering method
   * to change in future major versions of the library.
   *
   * @memberof modifiers
   * @inner
   */
  computeStyle: {
    /** @prop {number} order=850 - Index used to define the order of execution */
    order: 850,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: computeStyle,
    /**
     * @prop {Boolean} gpuAcceleration=true
     * If true, it uses the CSS 3D transformation to position the popper.
     * Otherwise, it will use the `top` and `left` properties
     */
    gpuAcceleration: true,
    /**
     * @prop {string} [x='bottom']
     * Where to anchor the X axis (`bottom` or `top`). AKA X offset origin.
     * Change this if your popper should grow in a direction different from `bottom`
     */
    x: 'bottom',
    /**
     * @prop {string} [x='left']
     * Where to anchor the Y axis (`left` or `right`). AKA Y offset origin.
     * Change this if your popper should grow in a direction different from `right`
     */
    y: 'right'
  },

  /**
   * Applies the computed styles to the popper element.
   *
   * All the DOM manipulations are limited to this modifier. This is useful in case
   * you want to integrate Popper.js inside a framework or view library and you
   * want to delegate all the DOM manipulations to it.
   *
   * Note that if you disable this modifier, you must make sure the popper element
   * has its position set to `absolute` before Popper.js can do its work!
   *
   * Just disable this modifier and define your own to achieve the desired effect.
   *
   * @memberof modifiers
   * @inner
   */
  applyStyle: {
    /** @prop {number} order=900 - Index used to define the order of execution */
    order: 900,
    /** @prop {Boolean} enabled=true - Whether the modifier is enabled or not */
    enabled: true,
    /** @prop {ModifierFn} */
    fn: applyStyle,
    /** @prop {Function} */
    onLoad: applyStyleOnLoad,
    /**
     * @deprecated since version 1.10.0, the property moved to `computeStyle` modifier
     * @prop {Boolean} gpuAcceleration=true
     * If true, it uses the CSS 3D transformation to position the popper.
     * Otherwise, it will use the `top` and `left` properties
     */
    gpuAcceleration: undefined
  }
};

/**
 * The `dataObject` is an object containing all the information used by Popper.js.
 * This object is passed to modifiers and to the `onCreate` and `onUpdate` callbacks.
 * @name dataObject
 * @property {Object} data.instance The Popper.js instance
 * @property {String} data.placement Placement applied to popper
 * @property {String} data.originalPlacement Placement originally defined on init
 * @property {Boolean} data.flipped True if popper has been flipped by flip modifier
 * @property {Boolean} data.hide True if the reference element is out of boundaries, useful to know when to hide the popper
 * @property {HTMLElement} data.arrowElement Node used as arrow by arrow modifier
 * @property {Object} data.styles Any CSS property defined here will be applied to the popper. It expects the JavaScript nomenclature (eg. `marginBottom`)
 * @property {Object} data.arrowStyles Any CSS property defined here will be applied to the popper arrow. It expects the JavaScript nomenclature (eg. `marginBottom`)
 * @property {Object} data.boundaries Offsets of the popper boundaries
 * @property {Object} data.offsets The measurements of popper, reference and arrow elements
 * @property {Object} data.offsets.popper `top`, `left`, `width`, `height` values
 * @property {Object} data.offsets.reference `top`, `left`, `width`, `height` values
 * @property {Object} data.offsets.arrow] `top` and `left` offsets, only one of them will be different from 0
 */

/**
 * Default options provided to Popper.js constructor.<br />
 * These can be overridden using the `options` argument of Popper.js.<br />
 * To override an option, simply pass an object with the same
 * structure of the `options` object, as the 3rd argument. For example:
 * ```
 * new Popper(ref, pop, {
 *   modifiers: {
 *     preventOverflow: { enabled: false }
 *   }
 * })
 * ```
 * @type {Object}
 * @static
 * @memberof Popper
 */
var Defaults = {
  /**
   * Popper's placement.
   * @prop {Popper.placements} placement='bottom'
   */
  placement: 'bottom',

  /**
   * Set this to true if you want popper to position it self in 'fixed' mode
   * @prop {Boolean} positionFixed=false
   */
  positionFixed: false,

  /**
   * Whether events (resize, scroll) are initially enabled.
   * @prop {Boolean} eventsEnabled=true
   */
  eventsEnabled: true,

  /**
   * Set to true if you want to automatically remove the popper when
   * you call the `destroy` method.
   * @prop {Boolean} removeOnDestroy=false
   */
  removeOnDestroy: false,

  /**
   * Callback called when the popper is created.<br />
   * By default, it is set to no-op.<br />
   * Access Popper.js instance with `data.instance`.
   * @prop {onCreate}
   */
  onCreate: function onCreate() {},

  /**
   * Callback called when the popper is updated. This callback is not called
   * on the initialization/creation of the popper, but only on subsequent
   * updates.<br />
   * By default, it is set to no-op.<br />
   * Access Popper.js instance with `data.instance`.
   * @prop {onUpdate}
   */
  onUpdate: function onUpdate() {},

  /**
   * List of modifiers used to modify the offsets before they are applied to the popper.
   * They provide most of the functionalities of Popper.js.
   * @prop {modifiers}
   */
  modifiers: modifiers
};

/**
 * @callback onCreate
 * @param {dataObject} data
 */

/**
 * @callback onUpdate
 * @param {dataObject} data
 */

// Utils
// Methods
var Popper = function () {
  /**
   * Creates a new Popper.js instance.
   * @class Popper
   * @param {Element|referenceObject} reference - The reference element used to position the popper
   * @param {Element} popper - The HTML / XML element used as the popper
   * @param {Object} options - Your custom options to override the ones defined in [Defaults](#defaults)
   * @return {Object} instance - The generated Popper.js instance
   */
  function Popper(reference, popper) {
    var _this = this;

    var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
    classCallCheck(this, Popper);

    this.scheduleUpdate = function () {
      return requestAnimationFrame(_this.update);
    };

    // make update() debounced, so that it only runs at most once-per-tick
    this.update = debounce(this.update.bind(this));

    // with {} we create a new object with the options inside it
    this.options = _extends({}, Popper.Defaults, options);

    // init state
    this.state = {
      isDestroyed: false,
      isCreated: false,
      scrollParents: []
    };

    // get reference and popper elements (allow jQuery wrappers)
    this.reference = reference && reference.jquery ? reference[0] : reference;
    this.popper = popper && popper.jquery ? popper[0] : popper;

    // Deep merge modifiers options
    this.options.modifiers = {};
    Object.keys(_extends({}, Popper.Defaults.modifiers, options.modifiers)).forEach(function (name) {
      _this.options.modifiers[name] = _extends({}, Popper.Defaults.modifiers[name] || {}, options.modifiers ? options.modifiers[name] : {});
    });

    // Refactoring modifiers' list (Object => Array)
    this.modifiers = Object.keys(this.options.modifiers).map(function (name) {
      return _extends({
        name: name
      }, _this.options.modifiers[name]);
    })
    // sort the modifiers by order
    .sort(function (a, b) {
      return a.order - b.order;
    });

    // modifiers have the ability to execute arbitrary code when Popper.js get inited
    // such code is executed in the same order of its modifier
    // they could add new properties to their options configuration
    // BE AWARE: don't add options to `options.modifiers.name` but to `modifierOptions`!
    this.modifiers.forEach(function (modifierOptions) {
      if (modifierOptions.enabled && isFunction(modifierOptions.onLoad)) {
        modifierOptions.onLoad(_this.reference, _this.popper, _this.options, modifierOptions, _this.state);
      }
    });

    // fire the first update to position the popper in the right place
    this.update();

    var eventsEnabled = this.options.eventsEnabled;
    if (eventsEnabled) {
      // setup event listeners, they will take care of update the position in specific situations
      this.enableEventListeners();
    }

    this.state.eventsEnabled = eventsEnabled;
  }

  // We can't use class properties because they don't get listed in the
  // class prototype and break stuff like Sinon stubs


  createClass(Popper, [{
    key: 'update',
    value: function update$$1() {
      return update.call(this);
    }
  }, {
    key: 'destroy',
    value: function destroy$$1() {
      return destroy.call(this);
    }
  }, {
    key: 'enableEventListeners',
    value: function enableEventListeners$$1() {
      return enableEventListeners.call(this);
    }
  }, {
    key: 'disableEventListeners',
    value: function disableEventListeners$$1() {
      return disableEventListeners.call(this);
    }

    /**
     * Schedules an update. It will run on the next UI update available.
     * @method scheduleUpdate
     * @memberof Popper
     */


    /**
     * Collection of utilities useful when writing custom modifiers.
     * Starting from version 1.7, this method is available only if you
     * include `popper-utils.js` before `popper.js`.
     *
     * **DEPRECATION**: This way to access PopperUtils is deprecated
     * and will be removed in v2! Use the PopperUtils module directly instead.
     * Due to the high instability of the methods contained in Utils, we can't
     * guarantee them to follow semver. Use them at your own risk!
     * @static
     * @private
     * @type {Object}
     * @deprecated since version 1.8
     * @member Utils
     * @memberof Popper
     */

  }]);
  return Popper;
}();

/**
 * The `referenceObject` is an object that provides an interface compatible with Popper.js
 * and lets you use it as replacement of a real DOM node.<br />
 * You can use this method to position a popper relatively to a set of coordinates
 * in case you don't have a DOM node to use as reference.
 *
 * ```
 * new Popper(referenceObject, popperNode);
 * ```
 *
 * NB: This feature isn't supported in Internet Explorer 10.
 * @name referenceObject
 * @property {Function} data.getBoundingClientRect
 * A function that returns a set of coordinates compatible with the native `getBoundingClientRect` method.
 * @property {number} data.clientWidth
 * An ES6 getter that will return the width of the virtual reference element.
 * @property {number} data.clientHeight
 * An ES6 getter that will return the height of the virtual reference element.
 */


Popper.Utils = (typeof window !== 'undefined' ? window : global).PopperUtils;
Popper.placements = placements;
Popper.Defaults = Defaults;

return Popper;

})));


}).call(this)}).call(this,typeof global !== "undefined" ? global : typeof self !== "undefined" ? self : typeof window !== "undefined" ? window : {})
},{}],52:[function(require,module,exports){
// shim for using process in browser
var process = module.exports = {};

// cached from whatever global is present so that test runners that stub it
// don't break things.  But we need to wrap it in a try catch in case it is
// wrapped in strict mode code which doesn't define any globals.  It's inside a
// function because try/catches deoptimize in certain engines.

var cachedSetTimeout;
var cachedClearTimeout;

function defaultSetTimout() {
    throw new Error('setTimeout has not been defined');
}
function defaultClearTimeout () {
    throw new Error('clearTimeout has not been defined');
}
(function () {
    try {
        if (typeof setTimeout === 'function') {
            cachedSetTimeout = setTimeout;
        } else {
            cachedSetTimeout = defaultSetTimout;
        }
    } catch (e) {
        cachedSetTimeout = defaultSetTimout;
    }
    try {
        if (typeof clearTimeout === 'function') {
            cachedClearTimeout = clearTimeout;
        } else {
            cachedClearTimeout = defaultClearTimeout;
        }
    } catch (e) {
        cachedClearTimeout = defaultClearTimeout;
    }
} ())
function runTimeout(fun) {
    if (cachedSetTimeout === setTimeout) {
        //normal enviroments in sane situations
        return setTimeout(fun, 0);
    }
    // if setTimeout wasn't available but was latter defined
    if ((cachedSetTimeout === defaultSetTimout || !cachedSetTimeout) && setTimeout) {
        cachedSetTimeout = setTimeout;
        return setTimeout(fun, 0);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedSetTimeout(fun, 0);
    } catch(e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't trust the global object when called normally
            return cachedSetTimeout.call(null, fun, 0);
        } catch(e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error
            return cachedSetTimeout.call(this, fun, 0);
        }
    }


}
function runClearTimeout(marker) {
    if (cachedClearTimeout === clearTimeout) {
        //normal enviroments in sane situations
        return clearTimeout(marker);
    }
    // if clearTimeout wasn't available but was latter defined
    if ((cachedClearTimeout === defaultClearTimeout || !cachedClearTimeout) && clearTimeout) {
        cachedClearTimeout = clearTimeout;
        return clearTimeout(marker);
    }
    try {
        // when when somebody has screwed with setTimeout but no I.E. maddness
        return cachedClearTimeout(marker);
    } catch (e){
        try {
            // When we are in I.E. but the script has been evaled so I.E. doesn't  trust the global object when called normally
            return cachedClearTimeout.call(null, marker);
        } catch (e){
            // same as above but when it's a version of I.E. that must have the global object for 'this', hopfully our context correct otherwise it will throw a global error.
            // Some versions of I.E. have different rules for clearTimeout vs setTimeout
            return cachedClearTimeout.call(this, marker);
        }
    }



}
var queue = [];
var draining = false;
var currentQueue;
var queueIndex = -1;

function cleanUpNextTick() {
    if (!draining || !currentQueue) {
        return;
    }
    draining = false;
    if (currentQueue.length) {
        queue = currentQueue.concat(queue);
    } else {
        queueIndex = -1;
    }
    if (queue.length) {
        drainQueue();
    }
}

function drainQueue() {
    if (draining) {
        return;
    }
    var timeout = runTimeout(cleanUpNextTick);
    draining = true;

    var len = queue.length;
    while(len) {
        currentQueue = queue;
        queue = [];
        while (++queueIndex < len) {
            if (currentQueue) {
                currentQueue[queueIndex].run();
            }
        }
        queueIndex = -1;
        len = queue.length;
    }
    currentQueue = null;
    draining = false;
    runClearTimeout(timeout);
}

process.nextTick = function (fun) {
    var args = new Array(arguments.length - 1);
    if (arguments.length > 1) {
        for (var i = 1; i < arguments.length; i++) {
            args[i - 1] = arguments[i];
        }
    }
    queue.push(new Item(fun, args));
    if (queue.length === 1 && !draining) {
        runTimeout(drainQueue);
    }
};

// v8 likes predictible objects
function Item(fun, array) {
    this.fun = fun;
    this.array = array;
}
Item.prototype.run = function () {
    this.fun.apply(null, this.array);
};
process.title = 'browser';
process.browser = true;
process.env = {};
process.argv = [];
process.version = ''; // empty string to avoid regexp issues
process.versions = {};

function noop() {}

process.on = noop;
process.addListener = noop;
process.once = noop;
process.off = noop;
process.removeListener = noop;
process.removeAllListeners = noop;
process.emit = noop;
process.prependListener = noop;
process.prependOnceListener = noop;

process.listeners = function (name) { return [] }

process.binding = function (name) {
    throw new Error('process.binding is not supported');
};

process.cwd = function () { return '/' };
process.chdir = function (dir) {
    throw new Error('process.chdir is not supported');
};
process.umask = function() { return 0; };

},{}],53:[function(require,module,exports){
'use strict';

var replace = String.prototype.replace;
var percentTwenties = /%20/g;

var Format = {
    RFC1738: 'RFC1738',
    RFC3986: 'RFC3986'
};

module.exports = {
    'default': Format.RFC3986,
    formatters: {
        RFC1738: function (value) {
            return replace.call(value, percentTwenties, '+');
        },
        RFC3986: function (value) {
            return String(value);
        }
    },
    RFC1738: Format.RFC1738,
    RFC3986: Format.RFC3986
};

},{}],54:[function(require,module,exports){
'use strict';

var stringify = require('./stringify');
var parse = require('./parse');
var formats = require('./formats');

module.exports = {
    formats: formats,
    parse: parse,
    stringify: stringify
};

},{"./formats":53,"./parse":55,"./stringify":56}],55:[function(require,module,exports){
'use strict';

var utils = require('./utils');

var has = Object.prototype.hasOwnProperty;
var isArray = Array.isArray;

var defaults = {
    allowDots: false,
    allowPrototypes: false,
    allowSparse: false,
    arrayLimit: 20,
    charset: 'utf-8',
    charsetSentinel: false,
    comma: false,
    decoder: utils.decode,
    delimiter: '&',
    depth: 5,
    ignoreQueryPrefix: false,
    interpretNumericEntities: false,
    parameterLimit: 1000,
    parseArrays: true,
    plainObjects: false,
    strictNullHandling: false
};

var interpretNumericEntities = function (str) {
    return str.replace(/&#(\d+);/g, function ($0, numberStr) {
        return String.fromCharCode(parseInt(numberStr, 10));
    });
};

var parseArrayValue = function (val, options) {
    if (val && typeof val === 'string' && options.comma && val.indexOf(',') > -1) {
        return val.split(',');
    }

    return val;
};

// This is what browsers will submit when the ✓ character occurs in an
// application/x-www-form-urlencoded body and the encoding of the page containing
// the form is iso-8859-1, or when the submitted form has an accept-charset
// attribute of iso-8859-1. Presumably also with other charsets that do not contain
// the ✓ character, such as us-ascii.
var isoSentinel = 'utf8=%26%2310003%3B'; // encodeURIComponent('&#10003;')

// These are the percent-encoded utf-8 octets representing a checkmark, indicating that the request actually is utf-8 encoded.
var charsetSentinel = 'utf8=%E2%9C%93'; // encodeURIComponent('✓')

var parseValues = function parseQueryStringValues(str, options) {
    var obj = {};
    var cleanStr = options.ignoreQueryPrefix ? str.replace(/^\?/, '') : str;
    var limit = options.parameterLimit === Infinity ? undefined : options.parameterLimit;
    var parts = cleanStr.split(options.delimiter, limit);
    var skipIndex = -1; // Keep track of where the utf8 sentinel was found
    var i;

    var charset = options.charset;
    if (options.charsetSentinel) {
        for (i = 0; i < parts.length; ++i) {
            if (parts[i].indexOf('utf8=') === 0) {
                if (parts[i] === charsetSentinel) {
                    charset = 'utf-8';
                } else if (parts[i] === isoSentinel) {
                    charset = 'iso-8859-1';
                }
                skipIndex = i;
                i = parts.length; // The eslint settings do not allow break;
            }
        }
    }

    for (i = 0; i < parts.length; ++i) {
        if (i === skipIndex) {
            continue;
        }
        var part = parts[i];

        var bracketEqualsPos = part.indexOf(']=');
        var pos = bracketEqualsPos === -1 ? part.indexOf('=') : bracketEqualsPos + 1;

        var key, val;
        if (pos === -1) {
            key = options.decoder(part, defaults.decoder, charset, 'key');
            val = options.strictNullHandling ? null : '';
        } else {
            key = options.decoder(part.slice(0, pos), defaults.decoder, charset, 'key');
            val = utils.maybeMap(
                parseArrayValue(part.slice(pos + 1), options),
                function (encodedVal) {
                    return options.decoder(encodedVal, defaults.decoder, charset, 'value');
                }
            );
        }

        if (val && options.interpretNumericEntities && charset === 'iso-8859-1') {
            val = interpretNumericEntities(val);
        }

        if (part.indexOf('[]=') > -1) {
            val = isArray(val) ? [val] : val;
        }

        if (has.call(obj, key)) {
            obj[key] = utils.combine(obj[key], val);
        } else {
            obj[key] = val;
        }
    }

    return obj;
};

var parseObject = function (chain, val, options, valuesParsed) {
    var leaf = valuesParsed ? val : parseArrayValue(val, options);

    for (var i = chain.length - 1; i >= 0; --i) {
        var obj;
        var root = chain[i];

        if (root === '[]' && options.parseArrays) {
            obj = [].concat(leaf);
        } else {
            obj = options.plainObjects ? Object.create(null) : {};
            var cleanRoot = root.charAt(0) === '[' && root.charAt(root.length - 1) === ']' ? root.slice(1, -1) : root;
            var index = parseInt(cleanRoot, 10);
            if (!options.parseArrays && cleanRoot === '') {
                obj = { 0: leaf };
            } else if (
                !isNaN(index)
                && root !== cleanRoot
                && String(index) === cleanRoot
                && index >= 0
                && (options.parseArrays && index <= options.arrayLimit)
            ) {
                obj = [];
                obj[index] = leaf;
            } else {
                obj[cleanRoot] = leaf;
            }
        }

        leaf = obj;
    }

    return leaf;
};

var parseKeys = function parseQueryStringKeys(givenKey, val, options, valuesParsed) {
    if (!givenKey) {
        return;
    }

    // Transform dot notation to bracket notation
    var key = options.allowDots ? givenKey.replace(/\.([^.[]+)/g, '[$1]') : givenKey;

    // The regex chunks

    var brackets = /(\[[^[\]]*])/;
    var child = /(\[[^[\]]*])/g;

    // Get the parent

    var segment = options.depth > 0 && brackets.exec(key);
    var parent = segment ? key.slice(0, segment.index) : key;

    // Stash the parent if it exists

    var keys = [];
    if (parent) {
        // If we aren't using plain objects, optionally prefix keys that would overwrite object prototype properties
        if (!options.plainObjects && has.call(Object.prototype, parent)) {
            if (!options.allowPrototypes) {
                return;
            }
        }

        keys.push(parent);
    }

    // Loop through children appending to the array until we hit depth

    var i = 0;
    while (options.depth > 0 && (segment = child.exec(key)) !== null && i < options.depth) {
        i += 1;
        if (!options.plainObjects && has.call(Object.prototype, segment[1].slice(1, -1))) {
            if (!options.allowPrototypes) {
                return;
            }
        }
        keys.push(segment[1]);
    }

    // If there's a remainder, just add whatever is left

    if (segment) {
        keys.push('[' + key.slice(segment.index) + ']');
    }

    return parseObject(keys, val, options, valuesParsed);
};

var normalizeParseOptions = function normalizeParseOptions(opts) {
    if (!opts) {
        return defaults;
    }

    if (opts.decoder !== null && opts.decoder !== undefined && typeof opts.decoder !== 'function') {
        throw new TypeError('Decoder has to be a function.');
    }

    if (typeof opts.charset !== 'undefined' && opts.charset !== 'utf-8' && opts.charset !== 'iso-8859-1') {
        throw new TypeError('The charset option must be either utf-8, iso-8859-1, or undefined');
    }
    var charset = typeof opts.charset === 'undefined' ? defaults.charset : opts.charset;

    return {
        allowDots: typeof opts.allowDots === 'undefined' ? defaults.allowDots : !!opts.allowDots,
        allowPrototypes: typeof opts.allowPrototypes === 'boolean' ? opts.allowPrototypes : defaults.allowPrototypes,
        allowSparse: typeof opts.allowSparse === 'boolean' ? opts.allowSparse : defaults.allowSparse,
        arrayLimit: typeof opts.arrayLimit === 'number' ? opts.arrayLimit : defaults.arrayLimit,
        charset: charset,
        charsetSentinel: typeof opts.charsetSentinel === 'boolean' ? opts.charsetSentinel : defaults.charsetSentinel,
        comma: typeof opts.comma === 'boolean' ? opts.comma : defaults.comma,
        decoder: typeof opts.decoder === 'function' ? opts.decoder : defaults.decoder,
        delimiter: typeof opts.delimiter === 'string' || utils.isRegExp(opts.delimiter) ? opts.delimiter : defaults.delimiter,
        // eslint-disable-next-line no-implicit-coercion, no-extra-parens
        depth: (typeof opts.depth === 'number' || opts.depth === false) ? +opts.depth : defaults.depth,
        ignoreQueryPrefix: opts.ignoreQueryPrefix === true,
        interpretNumericEntities: typeof opts.interpretNumericEntities === 'boolean' ? opts.interpretNumericEntities : defaults.interpretNumericEntities,
        parameterLimit: typeof opts.parameterLimit === 'number' ? opts.parameterLimit : defaults.parameterLimit,
        parseArrays: opts.parseArrays !== false,
        plainObjects: typeof opts.plainObjects === 'boolean' ? opts.plainObjects : defaults.plainObjects,
        strictNullHandling: typeof opts.strictNullHandling === 'boolean' ? opts.strictNullHandling : defaults.strictNullHandling
    };
};

module.exports = function (str, opts) {
    var options = normalizeParseOptions(opts);

    if (str === '' || str === null || typeof str === 'undefined') {
        return options.plainObjects ? Object.create(null) : {};
    }

    var tempObj = typeof str === 'string' ? parseValues(str, options) : str;
    var obj = options.plainObjects ? Object.create(null) : {};

    // Iterate over the keys and setup the new object

    var keys = Object.keys(tempObj);
    for (var i = 0; i < keys.length; ++i) {
        var key = keys[i];
        var newObj = parseKeys(key, tempObj[key], options, typeof str === 'string');
        obj = utils.merge(obj, newObj, options);
    }

    if (options.allowSparse === true) {
        return obj;
    }

    return utils.compact(obj);
};

},{"./utils":57}],56:[function(require,module,exports){
'use strict';

var getSideChannel = require('side-channel');
var utils = require('./utils');
var formats = require('./formats');
var has = Object.prototype.hasOwnProperty;

var arrayPrefixGenerators = {
    brackets: function brackets(prefix) {
        return prefix + '[]';
    },
    comma: 'comma',
    indices: function indices(prefix, key) {
        return prefix + '[' + key + ']';
    },
    repeat: function repeat(prefix) {
        return prefix;
    }
};

var isArray = Array.isArray;
var push = Array.prototype.push;
var pushToArray = function (arr, valueOrArray) {
    push.apply(arr, isArray(valueOrArray) ? valueOrArray : [valueOrArray]);
};

var toISO = Date.prototype.toISOString;

var defaultFormat = formats['default'];
var defaults = {
    addQueryPrefix: false,
    allowDots: false,
    charset: 'utf-8',
    charsetSentinel: false,
    delimiter: '&',
    encode: true,
    encoder: utils.encode,
    encodeValuesOnly: false,
    format: defaultFormat,
    formatter: formats.formatters[defaultFormat],
    // deprecated
    indices: false,
    serializeDate: function serializeDate(date) {
        return toISO.call(date);
    },
    skipNulls: false,
    strictNullHandling: false
};

var isNonNullishPrimitive = function isNonNullishPrimitive(v) {
    return typeof v === 'string'
        || typeof v === 'number'
        || typeof v === 'boolean'
        || typeof v === 'symbol'
        || typeof v === 'bigint';
};

var stringify = function stringify(
    object,
    prefix,
    generateArrayPrefix,
    strictNullHandling,
    skipNulls,
    encoder,
    filter,
    sort,
    allowDots,
    serializeDate,
    format,
    formatter,
    encodeValuesOnly,
    charset,
    sideChannel
) {
    var obj = object;

    if (sideChannel.has(object)) {
        throw new RangeError('Cyclic object value');
    }

    if (typeof filter === 'function') {
        obj = filter(prefix, obj);
    } else if (obj instanceof Date) {
        obj = serializeDate(obj);
    } else if (generateArrayPrefix === 'comma' && isArray(obj)) {
        obj = utils.maybeMap(obj, function (value) {
            if (value instanceof Date) {
                return serializeDate(value);
            }
            return value;
        });
    }

    if (obj === null) {
        if (strictNullHandling) {
            return encoder && !encodeValuesOnly ? encoder(prefix, defaults.encoder, charset, 'key', format) : prefix;
        }

        obj = '';
    }

    if (isNonNullishPrimitive(obj) || utils.isBuffer(obj)) {
        if (encoder) {
            var keyValue = encodeValuesOnly ? prefix : encoder(prefix, defaults.encoder, charset, 'key', format);
            return [formatter(keyValue) + '=' + formatter(encoder(obj, defaults.encoder, charset, 'value', format))];
        }
        return [formatter(prefix) + '=' + formatter(String(obj))];
    }

    var values = [];

    if (typeof obj === 'undefined') {
        return values;
    }

    var objKeys;
    if (generateArrayPrefix === 'comma' && isArray(obj)) {
        // we need to join elements in
        objKeys = [{ value: obj.length > 0 ? obj.join(',') || null : undefined }];
    } else if (isArray(filter)) {
        objKeys = filter;
    } else {
        var keys = Object.keys(obj);
        objKeys = sort ? keys.sort(sort) : keys;
    }

    for (var i = 0; i < objKeys.length; ++i) {
        var key = objKeys[i];
        var value = typeof key === 'object' && key.value !== undefined ? key.value : obj[key];

        if (skipNulls && value === null) {
            continue;
        }

        var keyPrefix = isArray(obj)
            ? typeof generateArrayPrefix === 'function' ? generateArrayPrefix(prefix, key) : prefix
            : prefix + (allowDots ? '.' + key : '[' + key + ']');

        sideChannel.set(object, true);
        var valueSideChannel = getSideChannel();
        pushToArray(values, stringify(
            value,
            keyPrefix,
            generateArrayPrefix,
            strictNullHandling,
            skipNulls,
            encoder,
            filter,
            sort,
            allowDots,
            serializeDate,
            format,
            formatter,
            encodeValuesOnly,
            charset,
            valueSideChannel
        ));
    }

    return values;
};

var normalizeStringifyOptions = function normalizeStringifyOptions(opts) {
    if (!opts) {
        return defaults;
    }

    if (opts.encoder !== null && opts.encoder !== undefined && typeof opts.encoder !== 'function') {
        throw new TypeError('Encoder has to be a function.');
    }

    var charset = opts.charset || defaults.charset;
    if (typeof opts.charset !== 'undefined' && opts.charset !== 'utf-8' && opts.charset !== 'iso-8859-1') {
        throw new TypeError('The charset option must be either utf-8, iso-8859-1, or undefined');
    }

    var format = formats['default'];
    if (typeof opts.format !== 'undefined') {
        if (!has.call(formats.formatters, opts.format)) {
            throw new TypeError('Unknown format option provided.');
        }
        format = opts.format;
    }
    var formatter = formats.formatters[format];

    var filter = defaults.filter;
    if (typeof opts.filter === 'function' || isArray(opts.filter)) {
        filter = opts.filter;
    }

    return {
        addQueryPrefix: typeof opts.addQueryPrefix === 'boolean' ? opts.addQueryPrefix : defaults.addQueryPrefix,
        allowDots: typeof opts.allowDots === 'undefined' ? defaults.allowDots : !!opts.allowDots,
        charset: charset,
        charsetSentinel: typeof opts.charsetSentinel === 'boolean' ? opts.charsetSentinel : defaults.charsetSentinel,
        delimiter: typeof opts.delimiter === 'undefined' ? defaults.delimiter : opts.delimiter,
        encode: typeof opts.encode === 'boolean' ? opts.encode : defaults.encode,
        encoder: typeof opts.encoder === 'function' ? opts.encoder : defaults.encoder,
        encodeValuesOnly: typeof opts.encodeValuesOnly === 'boolean' ? opts.encodeValuesOnly : defaults.encodeValuesOnly,
        filter: filter,
        format: format,
        formatter: formatter,
        serializeDate: typeof opts.serializeDate === 'function' ? opts.serializeDate : defaults.serializeDate,
        skipNulls: typeof opts.skipNulls === 'boolean' ? opts.skipNulls : defaults.skipNulls,
        sort: typeof opts.sort === 'function' ? opts.sort : null,
        strictNullHandling: typeof opts.strictNullHandling === 'boolean' ? opts.strictNullHandling : defaults.strictNullHandling
    };
};

module.exports = function (object, opts) {
    var obj = object;
    var options = normalizeStringifyOptions(opts);

    var objKeys;
    var filter;

    if (typeof options.filter === 'function') {
        filter = options.filter;
        obj = filter('', obj);
    } else if (isArray(options.filter)) {
        filter = options.filter;
        objKeys = filter;
    }

    var keys = [];

    if (typeof obj !== 'object' || obj === null) {
        return '';
    }

    var arrayFormat;
    if (opts && opts.arrayFormat in arrayPrefixGenerators) {
        arrayFormat = opts.arrayFormat;
    } else if (opts && 'indices' in opts) {
        arrayFormat = opts.indices ? 'indices' : 'repeat';
    } else {
        arrayFormat = 'indices';
    }

    var generateArrayPrefix = arrayPrefixGenerators[arrayFormat];

    if (!objKeys) {
        objKeys = Object.keys(obj);
    }

    if (options.sort) {
        objKeys.sort(options.sort);
    }

    var sideChannel = getSideChannel();
    for (var i = 0; i < objKeys.length; ++i) {
        var key = objKeys[i];

        if (options.skipNulls && obj[key] === null) {
            continue;
        }
        pushToArray(keys, stringify(
            obj[key],
            key,
            generateArrayPrefix,
            options.strictNullHandling,
            options.skipNulls,
            options.encode ? options.encoder : null,
            options.filter,
            options.sort,
            options.allowDots,
            options.serializeDate,
            options.format,
            options.formatter,
            options.encodeValuesOnly,
            options.charset,
            sideChannel
        ));
    }

    var joined = keys.join(options.delimiter);
    var prefix = options.addQueryPrefix === true ? '?' : '';

    if (options.charsetSentinel) {
        if (options.charset === 'iso-8859-1') {
            // encodeURIComponent('&#10003;'), the "numeric entity" representation of a checkmark
            prefix += 'utf8=%26%2310003%3B&';
        } else {
            // encodeURIComponent('✓')
            prefix += 'utf8=%E2%9C%93&';
        }
    }

    return joined.length > 0 ? prefix + joined : '';
};

},{"./formats":53,"./utils":57,"side-channel":58}],57:[function(require,module,exports){
'use strict';

var formats = require('./formats');

var has = Object.prototype.hasOwnProperty;
var isArray = Array.isArray;

var hexTable = (function () {
    var array = [];
    for (var i = 0; i < 256; ++i) {
        array.push('%' + ((i < 16 ? '0' : '') + i.toString(16)).toUpperCase());
    }

    return array;
}());

var compactQueue = function compactQueue(queue) {
    while (queue.length > 1) {
        var item = queue.pop();
        var obj = item.obj[item.prop];

        if (isArray(obj)) {
            var compacted = [];

            for (var j = 0; j < obj.length; ++j) {
                if (typeof obj[j] !== 'undefined') {
                    compacted.push(obj[j]);
                }
            }

            item.obj[item.prop] = compacted;
        }
    }
};

var arrayToObject = function arrayToObject(source, options) {
    var obj = options && options.plainObjects ? Object.create(null) : {};
    for (var i = 0; i < source.length; ++i) {
        if (typeof source[i] !== 'undefined') {
            obj[i] = source[i];
        }
    }

    return obj;
};

var merge = function merge(target, source, options) {
    /* eslint no-param-reassign: 0 */
    if (!source) {
        return target;
    }

    if (typeof source !== 'object') {
        if (isArray(target)) {
            target.push(source);
        } else if (target && typeof target === 'object') {
            if ((options && (options.plainObjects || options.allowPrototypes)) || !has.call(Object.prototype, source)) {
                target[source] = true;
            }
        } else {
            return [target, source];
        }

        return target;
    }

    if (!target || typeof target !== 'object') {
        return [target].concat(source);
    }

    var mergeTarget = target;
    if (isArray(target) && !isArray(source)) {
        mergeTarget = arrayToObject(target, options);
    }

    if (isArray(target) && isArray(source)) {
        source.forEach(function (item, i) {
            if (has.call(target, i)) {
                var targetItem = target[i];
                if (targetItem && typeof targetItem === 'object' && item && typeof item === 'object') {
                    target[i] = merge(targetItem, item, options);
                } else {
                    target.push(item);
                }
            } else {
                target[i] = item;
            }
        });
        return target;
    }

    return Object.keys(source).reduce(function (acc, key) {
        var value = source[key];

        if (has.call(acc, key)) {
            acc[key] = merge(acc[key], value, options);
        } else {
            acc[key] = value;
        }
        return acc;
    }, mergeTarget);
};

var assign = function assignSingleSource(target, source) {
    return Object.keys(source).reduce(function (acc, key) {
        acc[key] = source[key];
        return acc;
    }, target);
};

var decode = function (str, decoder, charset) {
    var strWithoutPlus = str.replace(/\+/g, ' ');
    if (charset === 'iso-8859-1') {
        // unescape never throws, no try...catch needed:
        return strWithoutPlus.replace(/%[0-9a-f]{2}/gi, unescape);
    }
    // utf-8
    try {
        return decodeURIComponent(strWithoutPlus);
    } catch (e) {
        return strWithoutPlus;
    }
};

var encode = function encode(str, defaultEncoder, charset, kind, format) {
    // This code was originally written by Brian White (mscdex) for the io.js core querystring library.
    // It has been adapted here for stricter adherence to RFC 3986
    if (str.length === 0) {
        return str;
    }

    var string = str;
    if (typeof str === 'symbol') {
        string = Symbol.prototype.toString.call(str);
    } else if (typeof str !== 'string') {
        string = String(str);
    }

    if (charset === 'iso-8859-1') {
        return escape(string).replace(/%u[0-9a-f]{4}/gi, function ($0) {
            return '%26%23' + parseInt($0.slice(2), 16) + '%3B';
        });
    }

    var out = '';
    for (var i = 0; i < string.length; ++i) {
        var c = string.charCodeAt(i);

        if (
            c === 0x2D // -
            || c === 0x2E // .
            || c === 0x5F // _
            || c === 0x7E // ~
            || (c >= 0x30 && c <= 0x39) // 0-9
            || (c >= 0x41 && c <= 0x5A) // a-z
            || (c >= 0x61 && c <= 0x7A) // A-Z
            || (format === formats.RFC1738 && (c === 0x28 || c === 0x29)) // ( )
        ) {
            out += string.charAt(i);
            continue;
        }

        if (c < 0x80) {
            out = out + hexTable[c];
            continue;
        }

        if (c < 0x800) {
            out = out + (hexTable[0xC0 | (c >> 6)] + hexTable[0x80 | (c & 0x3F)]);
            continue;
        }

        if (c < 0xD800 || c >= 0xE000) {
            out = out + (hexTable[0xE0 | (c >> 12)] + hexTable[0x80 | ((c >> 6) & 0x3F)] + hexTable[0x80 | (c & 0x3F)]);
            continue;
        }

        i += 1;
        c = 0x10000 + (((c & 0x3FF) << 10) | (string.charCodeAt(i) & 0x3FF));
        out += hexTable[0xF0 | (c >> 18)]
            + hexTable[0x80 | ((c >> 12) & 0x3F)]
            + hexTable[0x80 | ((c >> 6) & 0x3F)]
            + hexTable[0x80 | (c & 0x3F)];
    }

    return out;
};

var compact = function compact(value) {
    var queue = [{ obj: { o: value }, prop: 'o' }];
    var refs = [];

    for (var i = 0; i < queue.length; ++i) {
        var item = queue[i];
        var obj = item.obj[item.prop];

        var keys = Object.keys(obj);
        for (var j = 0; j < keys.length; ++j) {
            var key = keys[j];
            var val = obj[key];
            if (typeof val === 'object' && val !== null && refs.indexOf(val) === -1) {
                queue.push({ obj: obj, prop: key });
                refs.push(val);
            }
        }
    }

    compactQueue(queue);

    return value;
};

var isRegExp = function isRegExp(obj) {
    return Object.prototype.toString.call(obj) === '[object RegExp]';
};

var isBuffer = function isBuffer(obj) {
    if (!obj || typeof obj !== 'object') {
        return false;
    }

    return !!(obj.constructor && obj.constructor.isBuffer && obj.constructor.isBuffer(obj));
};

var combine = function combine(a, b) {
    return [].concat(a, b);
};

var maybeMap = function maybeMap(val, fn) {
    if (isArray(val)) {
        var mapped = [];
        for (var i = 0; i < val.length; i += 1) {
            mapped.push(fn(val[i]));
        }
        return mapped;
    }
    return fn(val);
};

module.exports = {
    arrayToObject: arrayToObject,
    assign: assign,
    combine: combine,
    compact: compact,
    decode: decode,
    encode: encode,
    isBuffer: isBuffer,
    isRegExp: isRegExp,
    maybeMap: maybeMap,
    merge: merge
};

},{"./formats":53}],58:[function(require,module,exports){
'use strict';

var GetIntrinsic = require('get-intrinsic');
var callBound = require('call-bind/callBound');
var inspect = require('object-inspect');

var $TypeError = GetIntrinsic('%TypeError%');
var $WeakMap = GetIntrinsic('%WeakMap%', true);
var $Map = GetIntrinsic('%Map%', true);

var $weakMapGet = callBound('WeakMap.prototype.get', true);
var $weakMapSet = callBound('WeakMap.prototype.set', true);
var $weakMapHas = callBound('WeakMap.prototype.has', true);
var $mapGet = callBound('Map.prototype.get', true);
var $mapSet = callBound('Map.prototype.set', true);
var $mapHas = callBound('Map.prototype.has', true);

/*
 * This function traverses the list returning the node corresponding to the
 * given key.
 *
 * That node is also moved to the head of the list, so that if it's accessed
 * again we don't need to traverse the whole list. By doing so, all the recently
 * used nodes can be accessed relatively quickly.
 */
var listGetNode = function (list, key) { // eslint-disable-line consistent-return
	for (var prev = list, curr; (curr = prev.next) !== null; prev = curr) {
		if (curr.key === key) {
			prev.next = curr.next;
			curr.next = list.next;
			list.next = curr; // eslint-disable-line no-param-reassign
			return curr;
		}
	}
};

var listGet = function (objects, key) {
	var node = listGetNode(objects, key);
	return node && node.value;
};
var listSet = function (objects, key, value) {
	var node = listGetNode(objects, key);
	if (node) {
		node.value = value;
	} else {
		// Prepend the new node to the beginning of the list
		objects.next = { // eslint-disable-line no-param-reassign
			key: key,
			next: objects.next,
			value: value
		};
	}
};
var listHas = function (objects, key) {
	return !!listGetNode(objects, key);
};

module.exports = function getSideChannel() {
	var $wm;
	var $m;
	var $o;
	var channel = {
		assert: function (key) {
			if (!channel.has(key)) {
				throw new $TypeError('Side channel does not contain ' + inspect(key));
			}
		},
		get: function (key) { // eslint-disable-line consistent-return
			if ($WeakMap && key && (typeof key === 'object' || typeof key === 'function')) {
				if ($wm) {
					return $weakMapGet($wm, key);
				}
			} else if ($Map) {
				if ($m) {
					return $mapGet($m, key);
				}
			} else {
				if ($o) { // eslint-disable-line no-lonely-if
					return listGet($o, key);
				}
			}
		},
		has: function (key) {
			if ($WeakMap && key && (typeof key === 'object' || typeof key === 'function')) {
				if ($wm) {
					return $weakMapHas($wm, key);
				}
			} else if ($Map) {
				if ($m) {
					return $mapHas($m, key);
				}
			} else {
				if ($o) { // eslint-disable-line no-lonely-if
					return listHas($o, key);
				}
			}
			return false;
		},
		set: function (key, value) {
			if ($WeakMap && key && (typeof key === 'object' || typeof key === 'function')) {
				if (!$wm) {
					$wm = new $WeakMap();
				}
				$weakMapSet($wm, key, value);
			} else if ($Map) {
				if (!$m) {
					$m = new $Map();
				}
				$mapSet($m, key, value);
			} else {
				if (!$o) {
					/*
					 * Initialize the linked list as an empty node, so that we don't have
					 * to special-case handling of the first node: we can always refer to
					 * it as (previous node).next, instead of something like (list).head
					 */
					$o = { key: {}, next: null };
				}
				listSet($o, key, value);
			}
		}
	};
	return channel;
};

},{"call-bind/callBound":26,"get-intrinsic":30,"object-inspect":50}],59:[function(require,module,exports){
/**!
 * @fileOverview Kickass library to create and place poppers near their reference elements.
 * @version 1.3.3
 * @license
 * Copyright (c) 2016 Federico Zivolo and contributors
 *
 * Permission is hereby granted, free of charge, to any person obtaining a copy
 * of this software and associated documentation files (the "Software"), to deal
 * in the Software without restriction, including without limitation the rights
 * to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the Software is
 * furnished to do so, subject to the following conditions:
 *
 * The above copyright notice and this permission notice shall be included in all
 * copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
 * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
 * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
 * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
 * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
 * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE
 * SOFTWARE.
 */
(function (global, factory) {
	typeof exports === 'object' && typeof module !== 'undefined' ? module.exports = factory(require('popper.js')) :
	typeof define === 'function' && define.amd ? define(['popper.js'], factory) :
	(global.Tooltip = factory(global.Popper));
}(this, (function (Popper) { 'use strict';

Popper = Popper && Popper.hasOwnProperty('default') ? Popper['default'] : Popper;

/**
 * Check if the given variable is a function
 * @method
 * @memberof Popper.Utils
 * @argument {Any} functionToCheck - variable to check
 * @returns {Boolean} answer to: is a function?
 */
function isFunction(functionToCheck) {
  var getType = {};
  return functionToCheck && getType.toString.call(functionToCheck) === '[object Function]';
}

var classCallCheck = function (instance, Constructor) {
  if (!(instance instanceof Constructor)) {
    throw new TypeError("Cannot call a class as a function");
  }
};

var createClass = function () {
  function defineProperties(target, props) {
    for (var i = 0; i < props.length; i++) {
      var descriptor = props[i];
      descriptor.enumerable = descriptor.enumerable || false;
      descriptor.configurable = true;
      if ("value" in descriptor) descriptor.writable = true;
      Object.defineProperty(target, descriptor.key, descriptor);
    }
  }

  return function (Constructor, protoProps, staticProps) {
    if (protoProps) defineProperties(Constructor.prototype, protoProps);
    if (staticProps) defineProperties(Constructor, staticProps);
    return Constructor;
  };
}();







var _extends = Object.assign || function (target) {
  for (var i = 1; i < arguments.length; i++) {
    var source = arguments[i];

    for (var key in source) {
      if (Object.prototype.hasOwnProperty.call(source, key)) {
        target[key] = source[key];
      }
    }
  }

  return target;
};

var DEFAULT_OPTIONS = {
  container: false,
  delay: 0,
  html: false,
  placement: 'top',
  title: '',
  template: '<div class="tooltip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>',
  trigger: 'hover focus',
  offset: 0,
  arrowSelector: '.tooltip-arrow, .tooltip__arrow',
  innerSelector: '.tooltip-inner, .tooltip__inner'
};

var Tooltip = function () {
  /**
   * Create a new Tooltip.js instance
   * @class Tooltip
   * @param {HTMLElement} reference - The DOM node used as reference of the tooltip (it can be a jQuery element).
   * @param {Object} options
   * @param {String} options.placement='top'
   *      Placement of the popper accepted values: `top(-start, -end), right(-start, -end), bottom(-start, -end),
   *      left(-start, -end)`
   * @param {String} [options.arrowSelector='.tooltip-arrow, .tooltip__arrow'] - className used to locate the DOM arrow element in the tooltip.
   * @param {String} [options.innerSelector='.tooltip-inner, .tooltip__inner'] - className used to locate the DOM inner element in the tooltip.
   * @param {HTMLElement|String|false} options.container=false - Append the tooltip to a specific element.
   * @param {Number|Object} options.delay=0
   *      Delay showing and hiding the tooltip (ms) - does not apply to manual trigger type.
   *      If a number is supplied, delay is applied to both hide/show.
   *      Object structure is: `{ show: 500, hide: 100 }`
   * @param {Boolean} options.html=false - Insert HTML into the tooltip. If false, the content will inserted with `textContent`.
   * @param {String} [options.template='<div class="tooltip" role="tooltip"><div class="tooltip-arrow"></div><div class="tooltip-inner"></div></div>']
   *      Base HTML to used when creating the tooltip.
   *      The tooltip's `title` will be injected into the `.tooltip-inner` or `.tooltip__inner`.
   *      `.tooltip-arrow` or `.tooltip__arrow` will become the tooltip's arrow.
   *      The outermost wrapper element should have the `.tooltip` class.
   * @param {String|HTMLElement|TitleFunction} options.title='' - Default title value if `title` attribute isn't present.
   * @param {String} [options.trigger='hover focus']
   *      How tooltip is triggered - click, hover, focus, manual.
   *      You may pass multiple triggers; separate them with a space. `manual` cannot be combined with any other trigger.
   * @param {Boolean} options.closeOnClickOutside=false - Close a popper on click outside of the popper and reference element. This has effect only when options.trigger is 'click'.
   * @param {String|HTMLElement} options.boundariesElement
   *      The element used as boundaries for the tooltip. For more information refer to Popper.js'
   *      [boundariesElement docs](https://popper.js.org/popper-documentation.html)
   * @param {Number|String} options.offset=0 - Offset of the tooltip relative to its reference. For more information refer to Popper.js'
   *      [offset docs](https://popper.js.org/popper-documentation.html)
   * @param {Object} options.popperOptions={} - Popper options, will be passed directly to popper instance. For more information refer to Popper.js'
   *      [options docs](https://popper.js.org/popper-documentation.html)
   * @return {Object} instance - The generated tooltip instance
   */
  function Tooltip(reference, options) {
    classCallCheck(this, Tooltip);

    _initialiseProps.call(this);

    // apply user options over default ones
    options = _extends({}, DEFAULT_OPTIONS, options);

    reference.jquery && (reference = reference[0]);

    // cache reference and options
    this.reference = reference;
    this.options = options;

    // get events list
    var events = typeof options.trigger === 'string' ? options.trigger.split(' ').filter(function (trigger) {
      return ['click', 'hover', 'focus'].indexOf(trigger) !== -1;
    }) : [];

    // set initial state
    this._isOpen = false;
    this._popperOptions = {};

    // set event listeners
    this._setEventListeners(reference, events, options);
  }

  //
  // Public methods
  //

  /**
   * Reveals an element's tooltip. This is considered a "manual" triggering of the tooltip.
   * Tooltips with zero-length titles are never displayed.
   * @method Tooltip#show
   * @memberof Tooltip
   */


  /**
   * Hides an element’s tooltip. This is considered a “manual” triggering of the tooltip.
   * @method Tooltip#hide
   * @memberof Tooltip
   */


  /**
   * Hides and destroys an element’s tooltip.
   * @method Tooltip#dispose
   * @memberof Tooltip
   */


  /**
   * Toggles an element’s tooltip. This is considered a “manual” triggering of the tooltip.
   * @method Tooltip#toggle
   * @memberof Tooltip
   */


  /**
   * Updates the tooltip's title content
   * @method Tooltip#updateTitleContent
   * @memberof Tooltip
   * @param {String|HTMLElement} title - The new content to use for the title
   */


  //
  // Private methods
  //

  createClass(Tooltip, [{
    key: '_create',


    /**
     * Creates a new tooltip node
     * @memberof Tooltip
     * @private
     * @param {HTMLElement} reference
     * @param {String} template
     * @param {String|HTMLElement|TitleFunction} title
     * @param {Boolean} allowHtml
     * @return {HTMLElement} tooltipNode
     */
    value: function _create(reference, template, title, allowHtml) {
      // create tooltip element
      var tooltipGenerator = window.document.createElement('div');
      tooltipGenerator.innerHTML = template.trim();
      var tooltipNode = tooltipGenerator.childNodes[0];

      // add unique ID to our tooltip (needed for accessibility reasons)
      tooltipNode.id = 'tooltip_' + Math.random().toString(36).substr(2, 10);

      // set initial `aria-hidden` state to `false` (it's visible!)
      tooltipNode.setAttribute('aria-hidden', 'false');

      // add title to tooltip
      var titleNode = tooltipGenerator.querySelector(this.options.innerSelector);
      this._addTitleContent(reference, title, allowHtml, titleNode);

      // return the generated tooltip node
      return tooltipNode;
    }
  }, {
    key: '_addTitleContent',
    value: function _addTitleContent(reference, title, allowHtml, titleNode) {
      if (title.nodeType === 1 || title.nodeType === 11) {
        // if title is a element node or document fragment, append it only if allowHtml is true
        allowHtml && titleNode.appendChild(title);
      } else if (isFunction(title)) {
        // Recursively call ourself so that the return value of the function gets handled appropriately - either
        // as a dom node, a string, or even as another function.
        this._addTitleContent(reference, title.call(reference), allowHtml, titleNode);
      } else {
        // if it's just a simple text, set textContent or innerHtml depending by `allowHtml` value
        allowHtml ? titleNode.innerHTML = title : titleNode.textContent = title;
      }
    }
  }, {
    key: '_show',
    value: function _show(reference, options) {
      // don't show if it's already visible
      // or if it's not being showed
      if (this._isOpen && !this._isOpening) {
        return this;
      }
      this._isOpen = true;

      // if the tooltipNode already exists, just show it
      if (this._tooltipNode) {
        this._tooltipNode.style.visibility = 'visible';
        this._tooltipNode.setAttribute('aria-hidden', 'false');
        this.popperInstance.update();
        return this;
      }

      // get title
      var title = reference.getAttribute('title') || options.title;

      // don't show tooltip if no title is defined
      if (!title) {
        return this;
      }

      // create tooltip node
      var tooltipNode = this._create(reference, options.template, title, options.html);

      // Add `aria-describedby` to our reference element for accessibility reasons
      reference.setAttribute('aria-describedby', tooltipNode.id);

      // append tooltip to container
      var container = this._findContainer(options.container, reference);

      this._append(tooltipNode, container);

      this._popperOptions = _extends({}, options.popperOptions, {
        placement: options.placement
      });

      this._popperOptions.modifiers = _extends({}, this._popperOptions.modifiers, {
        arrow: _extends({}, this._popperOptions.modifiers && this._popperOptions.modifiers.arrow, {
          element: options.arrowSelector
        }),
        offset: _extends({}, this._popperOptions.modifiers && this._popperOptions.modifiers.offset, {
          offset: options.offset || this._popperOptions.modifiers && this._popperOptions.modifiers.offset && this._popperOptions.modifiers.offset.offset || options.offset
        })
      });

      if (options.boundariesElement) {
        this._popperOptions.modifiers.preventOverflow = {
          boundariesElement: options.boundariesElement
        };
      }

      this.popperInstance = new Popper(reference, tooltipNode, this._popperOptions);

      this._tooltipNode = tooltipNode;

      return this;
    }
  }, {
    key: '_hide',
    value: function _hide() /*reference, options*/{
      // don't hide if it's already hidden
      if (!this._isOpen) {
        return this;
      }

      this._isOpen = false;

      // hide tooltipNode
      this._tooltipNode.style.visibility = 'hidden';
      this._tooltipNode.setAttribute('aria-hidden', 'true');

      return this;
    }
  }, {
    key: '_dispose',
    value: function _dispose() {
      var _this = this;

      // remove event listeners first to prevent any unexpected behaviour
      this._events.forEach(function (_ref) {
        var func = _ref.func,
            event = _ref.event;

        _this.reference.removeEventListener(event, func);
      });
      this._events = [];

      if (this._tooltipNode) {
        this._hide();

        // destroy instance
        this.popperInstance.destroy();

        // destroy tooltipNode if removeOnDestroy is not set, as popperInstance.destroy() already removes the element
        if (!this.popperInstance.options.removeOnDestroy) {
          this._tooltipNode.parentNode.removeChild(this._tooltipNode);
          this._tooltipNode = null;
        }
      }
      return this;
    }
  }, {
    key: '_findContainer',
    value: function _findContainer(container, reference) {
      // if container is a query, get the relative element
      if (typeof container === 'string') {
        container = window.document.querySelector(container);
      } else if (container === false) {
        // if container is `false`, set it to reference parent
        container = reference.parentNode;
      }
      return container;
    }

    /**
     * Append tooltip to container
     * @memberof Tooltip
     * @private
     * @param {HTMLElement} tooltipNode
     * @param {HTMLElement|String|false} container
     */

  }, {
    key: '_append',
    value: function _append(tooltipNode, container) {
      container.appendChild(tooltipNode);
    }
  }, {
    key: '_setEventListeners',
    value: function _setEventListeners(reference, events, options) {
      var _this2 = this;

      var directEvents = [];
      var oppositeEvents = [];

      events.forEach(function (event) {
        switch (event) {
          case 'hover':
            directEvents.push('mouseenter');
            oppositeEvents.push('mouseleave');
            break;
          case 'focus':
            directEvents.push('focus');
            oppositeEvents.push('blur');
            break;
          case 'click':
            directEvents.push('click');
            oppositeEvents.push('click');
            break;
        }
      });

      // schedule show tooltip
      directEvents.forEach(function (event) {
        var func = function func(evt) {
          if (_this2._isOpening === true) {
            return;
          }
          evt.usedByTooltip = true;
          _this2._scheduleShow(reference, options.delay, options, evt);
        };
        _this2._events.push({ event: event, func: func });
        reference.addEventListener(event, func);
      });

      // schedule hide tooltip
      oppositeEvents.forEach(function (event) {
        var func = function func(evt) {
          if (evt.usedByTooltip === true) {
            return;
          }
          _this2._scheduleHide(reference, options.delay, options, evt);
        };
        _this2._events.push({ event: event, func: func });
        reference.addEventListener(event, func);
        if (event === 'click' && options.closeOnClickOutside) {
          document.addEventListener('mousedown', function (e) {
            if (!_this2._isOpening) {
              return;
            }
            var popper = _this2.popperInstance.popper;
            if (reference.contains(e.target) || popper.contains(e.target)) {
              return;
            }
            func(e);
          }, true);
        }
      });
    }
  }, {
    key: '_scheduleShow',
    value: function _scheduleShow(reference, delay, options /*, evt */) {
      var _this3 = this;

      this._isOpening = true;
      // defaults to 0
      var computedDelay = delay && delay.show || delay || 0;
      this._showTimeout = window.setTimeout(function () {
        return _this3._show(reference, options);
      }, computedDelay);
    }
  }, {
    key: '_scheduleHide',
    value: function _scheduleHide(reference, delay, options, evt) {
      var _this4 = this;

      this._isOpening = false;
      // defaults to 0
      var computedDelay = delay && delay.hide || delay || 0;
      window.clearTimeout(this._showTimeout);
      window.setTimeout(function () {
        if (_this4._isOpen === false) {
          return;
        }
        if (!document.body.contains(_this4._tooltipNode)) {
          return;
        }

        // if we are hiding because of a mouseleave, we must check that the new
        // reference isn't the tooltip, because in this case we don't want to hide it
        if (evt.type === 'mouseleave') {
          var isSet = _this4._setTooltipNodeEvent(evt, reference, delay, options);

          // if we set the new event, don't hide the tooltip yet
          // the new event will take care to hide it if necessary
          if (isSet) {
            return;
          }
        }

        _this4._hide(reference, options);
      }, computedDelay);
    }
  }, {
    key: '_updateTitleContent',
    value: function _updateTitleContent(title) {
      if (typeof this._tooltipNode === 'undefined') {
        if (typeof this.options.title !== 'undefined') {
          this.options.title = title;
        }
        return;
      }
      var titleNode = this._tooltipNode.querySelector(this.options.innerSelector);
      this._clearTitleContent(titleNode, this.options.html, this.reference.getAttribute('title') || this.options.title);
      this._addTitleContent(this.reference, title, this.options.html, titleNode);
      this.options.title = title;
      this.popperInstance.update();
    }
  }, {
    key: '_clearTitleContent',
    value: function _clearTitleContent(titleNode, allowHtml, lastTitle) {
      if (lastTitle.nodeType === 1 || lastTitle.nodeType === 11) {
        allowHtml && titleNode.removeChild(lastTitle);
      } else {
        allowHtml ? titleNode.innerHTML = '' : titleNode.textContent = '';
      }
    }
  }]);
  return Tooltip;
}();

/**
 * Title function, its context is the Tooltip instance.
 * @memberof Tooltip
 * @callback TitleFunction
 * @return {String} placement - The desired title.
 */


var _initialiseProps = function _initialiseProps() {
  var _this5 = this;

  this.show = function () {
    return _this5._show(_this5.reference, _this5.options);
  };

  this.hide = function () {
    return _this5._hide();
  };

  this.dispose = function () {
    return _this5._dispose();
  };

  this.toggle = function () {
    if (_this5._isOpen) {
      return _this5.hide();
    } else {
      return _this5.show();
    }
  };

  this.updateTitleContent = function (title) {
    return _this5._updateTitleContent(title);
  };

  this._events = [];

  this._setTooltipNodeEvent = function (evt, reference, delay, options) {
    var relatedreference = evt.relatedreference || evt.toElement || evt.relatedTarget;

    var callback = function callback(evt2) {
      var relatedreference2 = evt2.relatedreference || evt2.toElement || evt2.relatedTarget;

      // Remove event listener after call
      _this5._tooltipNode.removeEventListener(evt.type, callback);

      // If the new reference is not the reference element
      if (!reference.contains(relatedreference2)) {
        // Schedule to hide tooltip
        _this5._scheduleHide(reference, options.delay, options, evt2);
      }
    };

    if (_this5._tooltipNode.contains(relatedreference)) {
      // listen to mouseleave on the tooltip element to be able to hide the tooltip
      _this5._tooltipNode.addEventListener(evt.type, callback);
      return true;
    }

    return false;
  };
};

return Tooltip;

})));


},{"popper.js":51}],60:[function(require,module,exports){
(function (global, factory) {
  if (typeof define === "function" && define.amd) {
    define("webextension-polyfill", ["module"], factory);
  } else if (typeof exports !== "undefined") {
    factory(module);
  } else {
    var mod = {
      exports: {}
    };
    factory(mod);
    global.browser = mod.exports;
  }
})(typeof globalThis !== "undefined" ? globalThis : typeof self !== "undefined" ? self : this, function (module) {
  /* webextension-polyfill - v0.6.0 - Mon Dec 23 2019 12:32:53 */

  /* -*- Mode: indent-tabs-mode: nil; js-indent-level: 2 -*- */

  /* vim: set sts=2 sw=2 et tw=80: */

  /* This Source Code Form is subject to the terms of the Mozilla Public
   * License, v. 2.0. If a copy of the MPL was not distributed with this
   * file, You can obtain one at http://mozilla.org/MPL/2.0/. */
  "use strict";

  if (typeof browser === "undefined" || Object.getPrototypeOf(browser) !== Object.prototype) {
    const CHROME_SEND_MESSAGE_CALLBACK_NO_RESPONSE_MESSAGE = "The message port closed before a response was received.";
    const SEND_RESPONSE_DEPRECATION_WARNING = "Returning a Promise is the preferred way to send a reply from an onMessage/onMessageExternal listener, as the sendResponse will be removed from the specs (See https://developer.mozilla.org/docs/Mozilla/Add-ons/WebExtensions/API/runtime/onMessage)"; // Wrapping the bulk of this polyfill in a one-time-use function is a minor
    // optimization for Firefox. Since Spidermonkey does not fully parse the
    // contents of a function until the first time it's called, and since it will
    // never actually need to be called, this allows the polyfill to be included
    // in Firefox nearly for free.

    const wrapAPIs = extensionAPIs => {
      // NOTE: apiMetadata is associated to the content of the api-metadata.json file
      // at build time by replacing the following "include" with the content of the
      // JSON file.
      const apiMetadata = {
        "alarms": {
          "clear": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "clearAll": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "get": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "getAll": {
            "minArgs": 0,
            "maxArgs": 0
          }
        },
        "bookmarks": {
          "create": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "get": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getChildren": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getRecent": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getSubTree": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getTree": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "move": {
            "minArgs": 2,
            "maxArgs": 2
          },
          "remove": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeTree": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "search": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "update": {
            "minArgs": 2,
            "maxArgs": 2
          }
        },
        "browserAction": {
          "disable": {
            "minArgs": 0,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "enable": {
            "minArgs": 0,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "getBadgeBackgroundColor": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getBadgeText": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getPopup": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getTitle": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "openPopup": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "setBadgeBackgroundColor": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "setBadgeText": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "setIcon": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "setPopup": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "setTitle": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          }
        },
        "browsingData": {
          "remove": {
            "minArgs": 2,
            "maxArgs": 2
          },
          "removeCache": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeCookies": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeDownloads": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeFormData": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeHistory": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeLocalStorage": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removePasswords": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removePluginData": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "settings": {
            "minArgs": 0,
            "maxArgs": 0
          }
        },
        "commands": {
          "getAll": {
            "minArgs": 0,
            "maxArgs": 0
          }
        },
        "contextMenus": {
          "remove": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeAll": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "update": {
            "minArgs": 2,
            "maxArgs": 2
          }
        },
        "cookies": {
          "get": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getAll": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getAllCookieStores": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "remove": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "set": {
            "minArgs": 1,
            "maxArgs": 1
          }
        },
        "devtools": {
          "inspectedWindow": {
            "eval": {
              "minArgs": 1,
              "maxArgs": 2,
              "singleCallbackArg": false
            }
          },
          "panels": {
            "create": {
              "minArgs": 3,
              "maxArgs": 3,
              "singleCallbackArg": true
            }
          }
        },
        "downloads": {
          "cancel": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "download": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "erase": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getFileIcon": {
            "minArgs": 1,
            "maxArgs": 2
          },
          "open": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "pause": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeFile": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "resume": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "search": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "show": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          }
        },
        "extension": {
          "isAllowedFileSchemeAccess": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "isAllowedIncognitoAccess": {
            "minArgs": 0,
            "maxArgs": 0
          }
        },
        "history": {
          "addUrl": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "deleteAll": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "deleteRange": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "deleteUrl": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getVisits": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "search": {
            "minArgs": 1,
            "maxArgs": 1
          }
        },
        "i18n": {
          "detectLanguage": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getAcceptLanguages": {
            "minArgs": 0,
            "maxArgs": 0
          }
        },
        "identity": {
          "launchWebAuthFlow": {
            "minArgs": 1,
            "maxArgs": 1
          }
        },
        "idle": {
          "queryState": {
            "minArgs": 1,
            "maxArgs": 1
          }
        },
        "management": {
          "get": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getAll": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "getSelf": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "setEnabled": {
            "minArgs": 2,
            "maxArgs": 2
          },
          "uninstallSelf": {
            "minArgs": 0,
            "maxArgs": 1
          }
        },
        "notifications": {
          "clear": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "create": {
            "minArgs": 1,
            "maxArgs": 2
          },
          "getAll": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "getPermissionLevel": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "update": {
            "minArgs": 2,
            "maxArgs": 2
          }
        },
        "pageAction": {
          "getPopup": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getTitle": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "hide": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "setIcon": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "setPopup": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "setTitle": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          },
          "show": {
            "minArgs": 1,
            "maxArgs": 1,
            "fallbackToNoCallback": true
          }
        },
        "permissions": {
          "contains": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getAll": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "remove": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "request": {
            "minArgs": 1,
            "maxArgs": 1
          }
        },
        "runtime": {
          "getBackgroundPage": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "getPlatformInfo": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "openOptionsPage": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "requestUpdateCheck": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "sendMessage": {
            "minArgs": 1,
            "maxArgs": 3
          },
          "sendNativeMessage": {
            "minArgs": 2,
            "maxArgs": 2
          },
          "setUninstallURL": {
            "minArgs": 1,
            "maxArgs": 1
          }
        },
        "sessions": {
          "getDevices": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "getRecentlyClosed": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "restore": {
            "minArgs": 0,
            "maxArgs": 1
          }
        },
        "storage": {
          "local": {
            "clear": {
              "minArgs": 0,
              "maxArgs": 0
            },
            "get": {
              "minArgs": 0,
              "maxArgs": 1
            },
            "getBytesInUse": {
              "minArgs": 0,
              "maxArgs": 1
            },
            "remove": {
              "minArgs": 1,
              "maxArgs": 1
            },
            "set": {
              "minArgs": 1,
              "maxArgs": 1
            }
          },
          "managed": {
            "get": {
              "minArgs": 0,
              "maxArgs": 1
            },
            "getBytesInUse": {
              "minArgs": 0,
              "maxArgs": 1
            }
          },
          "sync": {
            "clear": {
              "minArgs": 0,
              "maxArgs": 0
            },
            "get": {
              "minArgs": 0,
              "maxArgs": 1
            },
            "getBytesInUse": {
              "minArgs": 0,
              "maxArgs": 1
            },
            "remove": {
              "minArgs": 1,
              "maxArgs": 1
            },
            "set": {
              "minArgs": 1,
              "maxArgs": 1
            }
          }
        },
        "tabs": {
          "captureVisibleTab": {
            "minArgs": 0,
            "maxArgs": 2
          },
          "create": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "detectLanguage": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "discard": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "duplicate": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "executeScript": {
            "minArgs": 1,
            "maxArgs": 2
          },
          "get": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getCurrent": {
            "minArgs": 0,
            "maxArgs": 0
          },
          "getZoom": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "getZoomSettings": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "highlight": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "insertCSS": {
            "minArgs": 1,
            "maxArgs": 2
          },
          "move": {
            "minArgs": 2,
            "maxArgs": 2
          },
          "query": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "reload": {
            "minArgs": 0,
            "maxArgs": 2
          },
          "remove": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "removeCSS": {
            "minArgs": 1,
            "maxArgs": 2
          },
          "sendMessage": {
            "minArgs": 2,
            "maxArgs": 3
          },
          "setZoom": {
            "minArgs": 1,
            "maxArgs": 2
          },
          "setZoomSettings": {
            "minArgs": 1,
            "maxArgs": 2
          },
          "update": {
            "minArgs": 1,
            "maxArgs": 2
          }
        },
        "topSites": {
          "get": {
            "minArgs": 0,
            "maxArgs": 0
          }
        },
        "webNavigation": {
          "getAllFrames": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "getFrame": {
            "minArgs": 1,
            "maxArgs": 1
          }
        },
        "webRequest": {
          "handlerBehaviorChanged": {
            "minArgs": 0,
            "maxArgs": 0
          }
        },
        "windows": {
          "create": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "get": {
            "minArgs": 1,
            "maxArgs": 2
          },
          "getAll": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "getCurrent": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "getLastFocused": {
            "minArgs": 0,
            "maxArgs": 1
          },
          "remove": {
            "minArgs": 1,
            "maxArgs": 1
          },
          "update": {
            "minArgs": 2,
            "maxArgs": 2
          }
        }
      };

      if (Object.keys(apiMetadata).length === 0) {
        throw new Error("api-metadata.json has not been included in browser-polyfill");
      }
      /**
       * A WeakMap subclass which creates and stores a value for any key which does
       * not exist when accessed, but behaves exactly as an ordinary WeakMap
       * otherwise.
       *
       * @param {function} createItem
       *        A function which will be called in order to create the value for any
       *        key which does not exist, the first time it is accessed. The
       *        function receives, as its only argument, the key being created.
       */


      class DefaultWeakMap extends WeakMap {
        constructor(createItem, items = undefined) {
          super(items);
          this.createItem = createItem;
        }

        get(key) {
          if (!this.has(key)) {
            this.set(key, this.createItem(key));
          }

          return super.get(key);
        }

      }
      /**
       * Returns true if the given object is an object with a `then` method, and can
       * therefore be assumed to behave as a Promise.
       *
       * @param {*} value The value to test.
       * @returns {boolean} True if the value is thenable.
       */


      const isThenable = value => {
        return value && typeof value === "object" && typeof value.then === "function";
      };
      /**
       * Creates and returns a function which, when called, will resolve or reject
       * the given promise based on how it is called:
       *
       * - If, when called, `chrome.runtime.lastError` contains a non-null object,
       *   the promise is rejected with that value.
       * - If the function is called with exactly one argument, the promise is
       *   resolved to that value.
       * - Otherwise, the promise is resolved to an array containing all of the
       *   function's arguments.
       *
       * @param {object} promise
       *        An object containing the resolution and rejection functions of a
       *        promise.
       * @param {function} promise.resolve
       *        The promise's resolution function.
       * @param {function} promise.rejection
       *        The promise's rejection function.
       * @param {object} metadata
       *        Metadata about the wrapped method which has created the callback.
       * @param {integer} metadata.maxResolvedArgs
       *        The maximum number of arguments which may be passed to the
       *        callback created by the wrapped async function.
       *
       * @returns {function}
       *        The generated callback function.
       */


      const makeCallback = (promise, metadata) => {
        return (...callbackArgs) => {
          if (extensionAPIs.runtime.lastError) {
            promise.reject(extensionAPIs.runtime.lastError);
          } else if (metadata.singleCallbackArg || callbackArgs.length <= 1 && metadata.singleCallbackArg !== false) {
            promise.resolve(callbackArgs[0]);
          } else {
            promise.resolve(callbackArgs);
          }
        };
      };

      const pluralizeArguments = numArgs => numArgs == 1 ? "argument" : "arguments";
      /**
       * Creates a wrapper function for a method with the given name and metadata.
       *
       * @param {string} name
       *        The name of the method which is being wrapped.
       * @param {object} metadata
       *        Metadata about the method being wrapped.
       * @param {integer} metadata.minArgs
       *        The minimum number of arguments which must be passed to the
       *        function. If called with fewer than this number of arguments, the
       *        wrapper will raise an exception.
       * @param {integer} metadata.maxArgs
       *        The maximum number of arguments which may be passed to the
       *        function. If called with more than this number of arguments, the
       *        wrapper will raise an exception.
       * @param {integer} metadata.maxResolvedArgs
       *        The maximum number of arguments which may be passed to the
       *        callback created by the wrapped async function.
       *
       * @returns {function(object, ...*)}
       *       The generated wrapper function.
       */


      const wrapAsyncFunction = (name, metadata) => {
        return function asyncFunctionWrapper(target, ...args) {
          if (args.length < metadata.minArgs) {
            throw new Error(`Expected at least ${metadata.minArgs} ${pluralizeArguments(metadata.minArgs)} for ${name}(), got ${args.length}`);
          }

          if (args.length > metadata.maxArgs) {
            throw new Error(`Expected at most ${metadata.maxArgs} ${pluralizeArguments(metadata.maxArgs)} for ${name}(), got ${args.length}`);
          }

          return new Promise((resolve, reject) => {
            if (metadata.fallbackToNoCallback) {
              // This API method has currently no callback on Chrome, but it return a promise on Firefox,
              // and so the polyfill will try to call it with a callback first, and it will fallback
              // to not passing the callback if the first call fails.
              try {
                target[name](...args, makeCallback({
                  resolve,
                  reject
                }, metadata));
              } catch (cbError) {
                console.warn(`${name} API method doesn't seem to support the callback parameter, ` + "falling back to call it without a callback: ", cbError);
                target[name](...args); // Update the API method metadata, so that the next API calls will not try to
                // use the unsupported callback anymore.

                metadata.fallbackToNoCallback = false;
                metadata.noCallback = true;
                resolve();
              }
            } else if (metadata.noCallback) {
              target[name](...args);
              resolve();
            } else {
              target[name](...args, makeCallback({
                resolve,
                reject
              }, metadata));
            }
          });
        };
      };
      /**
       * Wraps an existing method of the target object, so that calls to it are
       * intercepted by the given wrapper function. The wrapper function receives,
       * as its first argument, the original `target` object, followed by each of
       * the arguments passed to the original method.
       *
       * @param {object} target
       *        The original target object that the wrapped method belongs to.
       * @param {function} method
       *        The method being wrapped. This is used as the target of the Proxy
       *        object which is created to wrap the method.
       * @param {function} wrapper
       *        The wrapper function which is called in place of a direct invocation
       *        of the wrapped method.
       *
       * @returns {Proxy<function>}
       *        A Proxy object for the given method, which invokes the given wrapper
       *        method in its place.
       */


      const wrapMethod = (target, method, wrapper) => {
        return new Proxy(method, {
          apply(targetMethod, thisObj, args) {
            return wrapper.call(thisObj, target, ...args);
          }

        });
      };

      let hasOwnProperty = Function.call.bind(Object.prototype.hasOwnProperty);
      /**
       * Wraps an object in a Proxy which intercepts and wraps certain methods
       * based on the given `wrappers` and `metadata` objects.
       *
       * @param {object} target
       *        The target object to wrap.
       *
       * @param {object} [wrappers = {}]
       *        An object tree containing wrapper functions for special cases. Any
       *        function present in this object tree is called in place of the
       *        method in the same location in the `target` object tree. These
       *        wrapper methods are invoked as described in {@see wrapMethod}.
       *
       * @param {object} [metadata = {}]
       *        An object tree containing metadata used to automatically generate
       *        Promise-based wrapper functions for asynchronous. Any function in
       *        the `target` object tree which has a corresponding metadata object
       *        in the same location in the `metadata` tree is replaced with an
       *        automatically-generated wrapper function, as described in
       *        {@see wrapAsyncFunction}
       *
       * @returns {Proxy<object>}
       */

      const wrapObject = (target, wrappers = {}, metadata = {}) => {
        let cache = Object.create(null);
        let handlers = {
          has(proxyTarget, prop) {
            return prop in target || prop in cache;
          },

          get(proxyTarget, prop, receiver) {
            if (prop in cache) {
              return cache[prop];
            }

            if (!(prop in target)) {
              return undefined;
            }

            let value = target[prop];

            if (typeof value === "function") {
              // This is a method on the underlying object. Check if we need to do
              // any wrapping.
              if (typeof wrappers[prop] === "function") {
                // We have a special-case wrapper for this method.
                value = wrapMethod(target, target[prop], wrappers[prop]);
              } else if (hasOwnProperty(metadata, prop)) {
                // This is an async method that we have metadata for. Create a
                // Promise wrapper for it.
                let wrapper = wrapAsyncFunction(prop, metadata[prop]);
                value = wrapMethod(target, target[prop], wrapper);
              } else {
                // This is a method that we don't know or care about. Return the
                // original method, bound to the underlying object.
                value = value.bind(target);
              }
            } else if (typeof value === "object" && value !== null && (hasOwnProperty(wrappers, prop) || hasOwnProperty(metadata, prop))) {
              // This is an object that we need to do some wrapping for the children
              // of. Create a sub-object wrapper for it with the appropriate child
              // metadata.
              value = wrapObject(value, wrappers[prop], metadata[prop]);
            } else if (hasOwnProperty(metadata, "*")) {
              // Wrap all properties in * namespace.
              value = wrapObject(value, wrappers[prop], metadata["*"]);
            } else {
              // We don't need to do any wrapping for this property,
              // so just forward all access to the underlying object.
              Object.defineProperty(cache, prop, {
                configurable: true,
                enumerable: true,

                get() {
                  return target[prop];
                },

                set(value) {
                  target[prop] = value;
                }

              });
              return value;
            }

            cache[prop] = value;
            return value;
          },

          set(proxyTarget, prop, value, receiver) {
            if (prop in cache) {
              cache[prop] = value;
            } else {
              target[prop] = value;
            }

            return true;
          },

          defineProperty(proxyTarget, prop, desc) {
            return Reflect.defineProperty(cache, prop, desc);
          },

          deleteProperty(proxyTarget, prop) {
            return Reflect.deleteProperty(cache, prop);
          }

        }; // Per contract of the Proxy API, the "get" proxy handler must return the
        // original value of the target if that value is declared read-only and
        // non-configurable. For this reason, we create an object with the
        // prototype set to `target` instead of using `target` directly.
        // Otherwise we cannot return a custom object for APIs that
        // are declared read-only and non-configurable, such as `chrome.devtools`.
        //
        // The proxy handlers themselves will still use the original `target`
        // instead of the `proxyTarget`, so that the methods and properties are
        // dereferenced via the original targets.

        let proxyTarget = Object.create(target);
        return new Proxy(proxyTarget, handlers);
      };
      /**
       * Creates a set of wrapper functions for an event object, which handles
       * wrapping of listener functions that those messages are passed.
       *
       * A single wrapper is created for each listener function, and stored in a
       * map. Subsequent calls to `addListener`, `hasListener`, or `removeListener`
       * retrieve the original wrapper, so that  attempts to remove a
       * previously-added listener work as expected.
       *
       * @param {DefaultWeakMap<function, function>} wrapperMap
       *        A DefaultWeakMap object which will create the appropriate wrapper
       *        for a given listener function when one does not exist, and retrieve
       *        an existing one when it does.
       *
       * @returns {object}
       */


      const wrapEvent = wrapperMap => ({
        addListener(target, listener, ...args) {
          target.addListener(wrapperMap.get(listener), ...args);
        },

        hasListener(target, listener) {
          return target.hasListener(wrapperMap.get(listener));
        },

        removeListener(target, listener) {
          target.removeListener(wrapperMap.get(listener));
        }

      }); // Keep track if the deprecation warning has been logged at least once.


      let loggedSendResponseDeprecationWarning = false;
      const onMessageWrappers = new DefaultWeakMap(listener => {
        if (typeof listener !== "function") {
          return listener;
        }
        /**
         * Wraps a message listener function so that it may send responses based on
         * its return value, rather than by returning a sentinel value and calling a
         * callback. If the listener function returns a Promise, the response is
         * sent when the promise either resolves or rejects.
         *
         * @param {*} message
         *        The message sent by the other end of the channel.
         * @param {object} sender
         *        Details about the sender of the message.
         * @param {function(*)} sendResponse
         *        A callback which, when called with an arbitrary argument, sends
         *        that value as a response.
         * @returns {boolean}
         *        True if the wrapped listener returned a Promise, which will later
         *        yield a response. False otherwise.
         */


        return function onMessage(message, sender, sendResponse) {
          let didCallSendResponse = false;
          let wrappedSendResponse;
          let sendResponsePromise = new Promise(resolve => {
            wrappedSendResponse = function (response) {
              if (!loggedSendResponseDeprecationWarning) {
                console.warn(SEND_RESPONSE_DEPRECATION_WARNING, new Error().stack);
                loggedSendResponseDeprecationWarning = true;
              }

              didCallSendResponse = true;
              resolve(response);
            };
          });
          let result;

          try {
            result = listener(message, sender, wrappedSendResponse);
          } catch (err) {
            result = Promise.reject(err);
          }

          const isResultThenable = result !== true && isThenable(result); // If the listener didn't returned true or a Promise, or called
          // wrappedSendResponse synchronously, we can exit earlier
          // because there will be no response sent from this listener.

          if (result !== true && !isResultThenable && !didCallSendResponse) {
            return false;
          } // A small helper to send the message if the promise resolves
          // and an error if the promise rejects (a wrapped sendMessage has
          // to translate the message into a resolved promise or a rejected
          // promise).


          const sendPromisedResult = promise => {
            promise.then(msg => {
              // send the message value.
              sendResponse(msg);
            }, error => {
              // Send a JSON representation of the error if the rejected value
              // is an instance of error, or the object itself otherwise.
              let message;

              if (error && (error instanceof Error || typeof error.message === "string")) {
                message = error.message;
              } else {
                message = "An unexpected error occurred";
              }

              sendResponse({
                __mozWebExtensionPolyfillReject__: true,
                message
              });
            }).catch(err => {
              // Print an error on the console if unable to send the response.
              console.error("Failed to send onMessage rejected reply", err);
            });
          }; // If the listener returned a Promise, send the resolved value as a
          // result, otherwise wait the promise related to the wrappedSendResponse
          // callback to resolve and send it as a response.


          if (isResultThenable) {
            sendPromisedResult(result);
          } else {
            sendPromisedResult(sendResponsePromise);
          } // Let Chrome know that the listener is replying.


          return true;
        };
      });

      const wrappedSendMessageCallback = ({
        reject,
        resolve
      }, reply) => {
        if (extensionAPIs.runtime.lastError) {
          // Detect when none of the listeners replied to the sendMessage call and resolve
          // the promise to undefined as in Firefox.
          // See https://github.com/mozilla/webextension-polyfill/issues/130
          if (extensionAPIs.runtime.lastError.message === CHROME_SEND_MESSAGE_CALLBACK_NO_RESPONSE_MESSAGE) {
            resolve();
          } else {
            reject(extensionAPIs.runtime.lastError);
          }
        } else if (reply && reply.__mozWebExtensionPolyfillReject__) {
          // Convert back the JSON representation of the error into
          // an Error instance.
          reject(new Error(reply.message));
        } else {
          resolve(reply);
        }
      };

      const wrappedSendMessage = (name, metadata, apiNamespaceObj, ...args) => {
        if (args.length < metadata.minArgs) {
          throw new Error(`Expected at least ${metadata.minArgs} ${pluralizeArguments(metadata.minArgs)} for ${name}(), got ${args.length}`);
        }

        if (args.length > metadata.maxArgs) {
          throw new Error(`Expected at most ${metadata.maxArgs} ${pluralizeArguments(metadata.maxArgs)} for ${name}(), got ${args.length}`);
        }

        return new Promise((resolve, reject) => {
          const wrappedCb = wrappedSendMessageCallback.bind(null, {
            resolve,
            reject
          });
          args.push(wrappedCb);
          apiNamespaceObj.sendMessage(...args);
        });
      };

      const staticWrappers = {
        runtime: {
          onMessage: wrapEvent(onMessageWrappers),
          onMessageExternal: wrapEvent(onMessageWrappers),
          sendMessage: wrappedSendMessage.bind(null, "sendMessage", {
            minArgs: 1,
            maxArgs: 3
          })
        },
        tabs: {
          sendMessage: wrappedSendMessage.bind(null, "sendMessage", {
            minArgs: 2,
            maxArgs: 3
          })
        }
      };
      const settingMetadata = {
        clear: {
          minArgs: 1,
          maxArgs: 1
        },
        get: {
          minArgs: 1,
          maxArgs: 1
        },
        set: {
          minArgs: 1,
          maxArgs: 1
        }
      };
      apiMetadata.privacy = {
        network: {
          "*": settingMetadata
        },
        services: {
          "*": settingMetadata
        },
        websites: {
          "*": settingMetadata
        }
      };
      return wrapObject(extensionAPIs, staticWrappers, apiMetadata);
    };

    if (typeof chrome != "object" || !chrome || !chrome.runtime || !chrome.runtime.id) {
      throw new Error("This script should only be loaded in a browser extension.");
    } // The build process adds a UMD wrapper around this file, which makes the
    // `module` variable available.


    module.exports = wrapAPIs(chrome);
  } else {
    module.exports = browser;
  }
});


},{}],61:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.APILogic = void 0;
const axios_1 = require("axios");
const qs = require("qs");
const log_wrapper_1 = require("./helpers/log-wrapper");
const logging_1 = require("./logging/logging");
const browserPolyfill = require("webextension-polyfill");
axios_1.default.defaults.headers.post['Content-Type'] = 'application/x-www-form-urlencoded';
class APILogic {
    constructor() {
        this.version = require('./version').version;
        this.constants = require('./constants');
        this.config = require('./config');
        this.keys = require('./keys').keys;
        this.api = (typeof browser === 'object') ? browser : chrome;
        this.apiPolyfill = browserPolyfill;
        this.CLOSING_POPUP_DELAY = this.constants.timer.CLOSING_POPUP_DELAY;
        this.platform = this.constants.platform;
        this.os = this.constants.os;
        this.openedWindowId = 0;
        this.extensionName = this.constants.extension.name + this.currentPlatform;
        this.getImage = (pathToImage) => {
            return this.getFilePath(pathToImage);
        };
        this.getPlatform = () => {
            const browserAgentInfo = this.getBrowserAgentInfo().toLowerCase();
            const isANeededBrowser = (testString) => {
                return testString.test(browserAgentInfo);
            };
            const browserVendor = window.navigator.vendor.toLowerCase();
            const isChrome = isANeededBrowser(/chrome/) && (/google inc/).test(browserVendor);
            const isIE = isANeededBrowser(/msie /) || isANeededBrowser(/trident/);
            const isEDGE = isANeededBrowser(/edge/);
            const isChromiumEDGE = isANeededBrowser(/edg/) && (/google inc/).test(browserVendor);
            const isSafari = !isChrome && (isANeededBrowser(/safari/));
            const isFirefox = isANeededBrowser(/firefox/);
            if (isEDGE || isChromiumEDGE) {
                return this.platform.EDGE;
            }
            if (isChrome) {
                return this.platform.CHROME;
            }
            if (isFirefox) {
                return this.platform.FIREFOX;
            }
            if (isSafari) {
                return this.platform.SAFARI;
            }
            if (isIE) {
                return this.platform.IE;
            }
            return this.platform.DEFAULT;
        };
        this.getFilePath = (filePath) => {
            return this.api.extension.getURL(filePath);
        };
        this.getExtensionManifest = () => {
            if (this.api && this.api.runtime) {
                return this.api.runtime.getManifest();
            }
            else {
                return '';
            }
        };
        this.getBrowserAgentInfo = () => {
            return window.navigator.userAgent;
        };
        this.formTabQueryInfo = (url, isDomainUrl) => {
            const formUrlMatchPattern = () => {
                let urlMatchPattern = '';
                if (url) {
                    urlMatchPattern = url.split('?')[0].split('#')[0];
                    if (isDomainUrl && (urlMatchPattern[urlMatchPattern.length - 1] !== '/')) {
                        urlMatchPattern += '/';
                    }
                    urlMatchPattern += '*';
                }
                return urlMatchPattern;
            };
            return {
                url: formUrlMatchPattern(),
                windowType: 'popup',
            };
        };
        this.getBrowserVersionNumber = () => {
            const browserAgentInfo = this.getBrowserAgentInfo();
            let platform = this.getPlatform();
            // check for Chromium based Edge
            if (platform.toLowerCase() === 'edge' && !browserAgentInfo.includes(platform)) {
                platform = 'Edg';
            }
            // regExp for getting browser version number
            const browserVersionRegExp = new RegExp(platform + '/([0-9.]+)');
            return browserVersionRegExp.exec(browserAgentInfo)[1];
        };
        this.getUrlWithReplacedToken = (url) => {
            const urlParts = url.split('token=');
            if (urlParts.length > 1) {
                const parameters = urlParts[1].split('&');
                const token = parameters[0];
                let result = urlParts[0] + 'token=token_replaced_length_' + token.length;
                for (let i = 1; i < parameters.length; i++) {
                    result += '&' + parameters[i];
                }
                return result;
            }
            return url;
        };
        this.createRequestInfo = (methodName, url, headers) => {
            let transactionInfo = '';
            if (headers && headers['FZ-TransactionId']) {
                const FzTransactionId = headers['FZ-TransactionId'];
                transactionInfo = `FZ-TransactionId header is ${FzTransactionId}`;
            }
            return `${methodName} ${this.getUrlWithReplacedToken(url)} ${transactionInfo}`;
        };
        this.clearTimeout = (id) => {
            clearTimeout(id);
        };
        this.getDataFromChromeSyncStorage = (key, callback) => {
            const callbackWrapper = (data) => {
                const gettingData = (data) ? (data[key]) : undefined;
                callback(gettingData);
            };
            try {
                const getter = this.api.storage.sync.get(key, callbackWrapper);
                // Since Firefox 52 getter is Promise and has no callback parameter
                // See also https://developer.mozilla.org/en-US/Add-ons/WebExtensions/API/Storage/StorageArea/get
                if (getter instanceof Promise) {
                    getter.then(callbackWrapper);
                }
            }
            catch (e) {
                this.logging.showErrorLog('Failed getting data from storage', e);
            }
        };
        this.getExtensionFilePath = (filePath) => {
            return this.getFilePath(filePath);
        };
        this.getVersion = () => {
            return this.version;
        };
        this.guid = () => {
            // See also https://github.com/thinkingphones/web-commons/src/scripts/tpn/commons/shared/util/GUID
            function g() {
                return Math.floor((1 + Math.random()) * 0x10000)
                    .toString(16)
                    .substring(1);
            }
            return g() + g() + '-' + g() + '-' + g() + '-' +
                g() + '-' + g() + g() + g();
        };
        this.setTimeout = (callback, delay) => {
            return window.setTimeout(callback, delay);
        };
        this.removeDataFromDB = (keys) => {
            this.apiPolyfill.storage.local.remove(keys);
        };
        this.addMessageListener = (callback) => {
            try {
                this.api.runtime.onMessage.addListener(callback);
            }
            catch (error) {
                if (this.api.runtime.lastError) {
                    this.logging.showErrorLog('api.addMessageListener ', this.api.runtime.lastError);
                }
                else {
                    this.logging.showErrorLog('api.addMessageListener ', error);
                }
            }
        };
        this.addOnInstalledEventMessageListener = (callback) => {
            try {
                this.api.runtime.onInstalled.addListener(callback);
            }
            catch (error) {
                if (this.api.runtime.lastError) {
                    this.logging.showErrorLog('api.addOnInstalledMessageListener ', this.api.runtime.lastError);
                }
                else {
                    this.logging.showErrorLog('api.addOnInstalledMessageListener ', error);
                }
            }
        };
        this.removeMessageListener = (callback) => {
            try {
                this.api.runtime.onMessage.removeListener(callback);
            }
            catch (error) {
                if (this.api.runtime.lastError) {
                    this.logging.showErrorLog('api.removeMessageListener ', this.api.runtime.lastError);
                }
                else {
                    this.logging.showErrorLog('api.removeMessageListener ', error);
                }
            }
        };
        this.sendMessageToActiveTab = (options) => {
            this.api.tabs.query({ active: true, currentWindow: true }, (tabs) => {
                if (tabs[0]) {
                    this.api.tabs.sendMessage(tabs[0].id, options, (response) => {
                        try {
                            // catching lastError: The message port closed before a response was received
                            // need to return promise in order to keep console clean
                            // see https://jira.tpn.thinkingphones.net/browse/BROW-964
                            if (this.api.runtime.lastError) {
                                return Promise.resolve();
                            }
                            if (response !== undefined) {
                                this.logging.showInfoLog('sendMessageToActiveTab response: ', response.result);
                            }
                        }
                        catch (e) {
                            this.logging.showErrorLog('Failed sending message to active tab: ', e);
                        }
                    });
                }
            });
        };
        this.sendMessageToDifferentExtensionPart = (options) => {
            try {
                this.api.runtime.sendMessage(options);
            }
            catch (e) {
                if (!document.querySelector('#fuze_reload_required')) {
                    if (window.location.href.match("^https://(www|calendar|mail).google.com/")) {
                        this.browserReloadRequired();
                    }
                }
            }
        };
        this.getActiveTab = (callback) => {
            this.api.tabs.query({ active: true, currentWindow: true }, callback);
        };
        this.closeAuthorisationTab = (finalLoginPage) => {
            let finalLoginPageTab = null;
            const closeTabsArray = (tabsArray) => {
                tabsArray.forEach((tab) => {
                    const openedWindowTabId = tab.windowId;
                    this.api.windows.remove(openedWindowTabId, () => {
                        this.logging.showInfoLog('Closed authentication dialog. Window id', openedWindowTabId);
                    });
                });
            };
            if (typeof finalLoginPage === 'string') {
                finalLoginPageTab = this.formTabQueryInfo(finalLoginPage, false);
            }
            else {
                finalLoginPageTab = finalLoginPage;
            }
            this.api.tabs.query(finalLoginPageTab, (tabsArray) => {
                this.openedWindowId = 0;
                if (tabsArray && tabsArray[0]) {
                    closeTabsArray(tabsArray);
                }
            });
        };
        this.openURLInTab = (loginPageUrl) => {
            const loginPageForPlatform = this.constants.loginPage[this.currentPlatform];
            const loginPageDefault = this.constants.loginPage.default;
            let loginPageSizes = loginPageDefault.sizes;
            if (loginPageForPlatform && loginPageForPlatform.sizes) {
                loginPageSizes = loginPageForPlatform.sizes;
            }
            const loginPageType = this.constants.loginPage.type;
            const loginPageWidth = Math.round(loginPageSizes.width);
            const loginPageHeight = Math.round(loginPageSizes.height);
            // Math.round() is used here to cast "number" to "integer", according to Extensions API
            // for browser.windows.create and issue BROW-910
            let loginPageTop = (window.screen.height - loginPageHeight) / 2;
            let loginPageLeft = (window.screen.width - loginPageWidth) / 2;
            loginPageTop = Math.round((!isNaN(loginPageTop) && (loginPageTop > 0)) ? loginPageTop : 0);
            loginPageLeft = Math.round((!isNaN(loginPageLeft) && (loginPageLeft > 0)) ? loginPageLeft : 0);
            const chromeWindowsCreateNewPopup = () => {
                this.api.windows.create({
                    height: loginPageHeight,
                    left: loginPageLeft,
                    top: loginPageTop,
                    type: loginPageType,
                    url: [loginPageUrl],
                    width: loginPageWidth,
                }, (createdWindow) => {
                    if (createdWindow) {
                        this.logging.showInfoLog('Opened authentication dialog. Window id', createdWindow.id);
                        this.openedWindowId = createdWindow.id;
                        this.api.windows.onRemoved.addListener((removedId) => {
                            if (removedId === this.openedWindowId) {
                                this.openedWindowId = 0;
                            }
                        });
                    }
                });
            };
            if (this.openedWindowId) {
                this.api.windows.update(this.openedWindowId, { focused: true });
            }
            else if (loginPageUrl) {
                const loginPageTab = this.formTabQueryInfo(loginPageUrl, true);
                this.api.tabs.query(loginPageTab, (tabsArray) => {
                    if (tabsArray && tabsArray[0]) {
                        tabsArray.forEach((tab) => {
                            this.api.windows.remove(tab.windowId, () => {
                                return;
                            });
                        });
                    }
                    chromeWindowsCreateNewPopup();
                });
            }
        };
        this.openLinkInNewTab = (url) => {
            this.api.tabs.create({
                url,
            });
        };
        this.setResourceIconOnBrowserAction = (iconPath) => {
            this.api.browserAction.setIcon({ path: '../' + iconPath });
        };
        this.reactOnBrowserActionClick = (callback) => {
            this.api.browserAction.onClicked.addListener(callback);
        };
        this.setPopupOnBrowserAction = (popupPath) => {
            if (popupPath && this.getPlatform() === this.constants.platform.FIREFOX) {
                popupPath = this.getFilePath(popupPath);
            }
            this.api.browserAction.setPopup({ popup: popupPath });
        };
        this.closePopupOnBrowserAction = () => {
            setTimeout(window.close, this.CLOSING_POPUP_DELAY);
            return true;
        };
        this.executeFileScript = (filePath) => {
            this.api.tabs.executeScript({ file: filePath });
        };
        this.sendCloseWindowMessageAfterSuccessfulLogin = (page) => {
            window.postMessage('closeWindow', page);
        };
        this.getCookie = (options, callback) => {
            const getCookie = this.api.cookies.get(options, callback);
            if (getCookie instanceof Promise) {
                return this.api.cookies.get(options);
            }
        };
        this.setCookie = (options, callback) => {
            this.api.cookies.set(options, callback);
        };
        this.webNavigationAddListenerOnCommitted = (callback) => {
            this.api.webNavigation.onCommitted.addListener(callback);
        };
        this.getUILanguage = () => {
            return this.api.i18n.getUILanguage();
        };
        this.logging = logging_1.Logging.getInstance(this);
        const gettingExtensionNameResult = require('./get-the-extension-name').getExtensionName({
            defaultExtensionName: this.constants.extension.name + this.getPlatform(),
            getExtensionManifest: this.getExtensionManifest,
            getFilePath: this.getFilePath,
        });
        if (typeof gettingExtensionNameResult === 'string' && gettingExtensionNameResult) {
            this.extensionName = gettingExtensionNameResult;
        }
        else {
            gettingExtensionNameResult.then((gettingExtensionName) => {
                if (gettingExtensionName) {
                    this.extensionName = gettingExtensionName;
                }
            });
        }
        this.currentPlatform = this.getPlatform();
        this.logWrapper = log_wrapper_1.LogWrapper.getInstance(this, {
            extensionName: this.extensionName,
            maxBufferSize: this.constants.logger.MAX_BUFFER_SIZE,
            version: this.version,
        });
    }
    getOS() {
        const appVersionInfo = this.getBrowserAgentInfo().toLowerCase();
        const isANeededOs = (testString) => {
            return testString.test(appVersionInfo);
        };
        const isWindows = isANeededOs(/win/);
        const isMac = isANeededOs(/mac/);
        const isUnix = isANeededOs(/x11/);
        const isLinux = isANeededOs(/linux/);
        if (isWindows) {
            return this.os.WINDOWS;
        }
        if (isMac) {
            return this.os.MAC;
        }
        if (isUnix) {
            return this.os.UNIX;
        }
        if (isLinux) {
            return this.os.LINUX;
        }
        return this.os.DEFAULT;
    }
    getDataFromDBPolyfill(key) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const data = yield this.apiPolyfill.storage.local.get(key);
                if (typeof key === 'object') {
                    return data;
                }
                else {
                    return data ? data[key] : undefined;
                }
            }
            catch (e) {
                // condition to skip DB request when extension is not installed, or after
                // extension gets updated
                // see https://jira.tpn.thinkingphones.net/browse/BROW-964
                if (this.apiPolyfill.app === undefined) {
                    return;
                }
                this.logging.showErrorLog('Error: Failed getting data from storage: ', e);
            }
        });
    }
    ;
    setDataIntoDBPolyfill(data) {
        try {
            return this.apiPolyfill.storage.local.set(data);
        }
        catch (error) {
            if (this.apiPolyfill.runtime.lastError) {
                this.logging.showErrorLog('Failed setting data into storage', this.apiPolyfill.runtime.lastError);
            }
            else {
                this.logging.showErrorLog('Failed setting data into storage', error);
            }
        }
    }
    ;
    setPatchDatIntoDB(object) {
        return this.apiPolyfill.storage.local.set(object);
    }
    ;
    sendRequest(options) {
        return __awaiter(this, void 0, void 0, function* () {
            const httpMethod = options.method ? options.method.toUpperCase() : 'GET';
            const requestInfo = this.createRequestInfo(httpMethod, options.url, options.headers);
            try {
                if (httpMethod === 'GET' && options.data) {
                    options.params = options.data;
                }
                if (options.headers['Content-Type'] !== 'application/json' &&
                    !(options.data instanceof FormData) &&
                    (httpMethod === 'POST' || httpMethod === 'PATCH')) {
                    options.data = qs.stringify(options.data);
                }
                const { data: responseData } = yield axios_1.default.request(options);
                if (!responseData.hasOwnProperty('data')) {
                    this.logging.showInfoLog('api.sendRequest ', { requestInfo, responseData }, options.skipLogStreaming);
                    return responseData;
                }
                // response with user from Contactive may contain fields that can be big enough, but not necessary
                // remove them to save space in logging
                const valueForRemovedProperties = 'removed';
                if (responseData.data.hasOwnProperty('sources')) {
                    responseData.data.sources = valueForRemovedProperties;
                }
                if (responseData.data.hasOwnProperty('capabilities')) {
                    responseData.data.capabilities = valueForRemovedProperties;
                }
                if (responseData.data.hasOwnProperty('user')) {
                    if (responseData.data.user.hasOwnProperty('devices')) {
                        responseData.data.user.devices = valueForRemovedProperties;
                    }
                    if (responseData.data.user.hasOwnProperty('asyncTasks')) {
                        responseData.data.user.asyncTasks = valueForRemovedProperties;
                    }
                }
                this.logging.showInfoLog('api.sendRequest ', { requestInfo, responseData }, options.skipLogStreaming);
                return responseData;
            }
            catch (errorResponse) {
                const error = errorResponse.response || errorResponse.message;
                this.logging.showErrorLog('api.sendRequest ', { requestInfo, error });
                return Promise.reject(error);
            }
        });
    }
    browserReloadRequired() {
        const html = '<div id="fuze_reload_required" ' +
            'style="display:block; position: fixed; top: 0; left: 0; z-index: 999; width: 100%; height: 60px;' +
            ' background-color:white; text-align:center; color:red">' +
            '<br><b>Fuze extension updated.</b><br>Please refresh page.' +
            '</div>';
        document.body.innerHTML += html;
    }
}
exports.APILogic = APILogic;

},{"./config":69,"./constants":70,"./get-the-extension-name":84,"./helpers/log-wrapper":96,"./keys":102,"./logging/logging":108,"./version":150,"axios":1,"qs":54,"webextension-polyfill":60}],62:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LoginPageManager = void 0;
const environment_1 = require("../repository/environment");
const extensionSettings_1 = require("../repository/extensionSettings");
const api_1 = require("../api");
class LoginPageManager {
    constructor(settings) {
        this.settings = settings;
        this.apiLogic = new api_1.APILogic();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(this.apiLogic);
        this.environment = new environment_1.Environment(this.extensionSettings);
    }
    getLoginPageUrl() {
        return __awaiter(this, void 0, void 0, function* () {
            const wardenLogInPageUrl = yield this.getWardenLogInPageUrl();
            const applicationToken = yield this.getApplicationToken();
            const encodedWardenRedirectPageUrl = yield this.getEncodedWardenRedirectPageUrl();
            return `${wardenLogInPageUrl}?accessToken=${applicationToken}&redirectUri=${encodedWardenRedirectPageUrl}`;
        });
    }
    getEncodedWardenRedirectPageUrl() {
        return __awaiter(this, void 0, void 0, function* () {
            const currentEnvironment = (yield this.environment.get()) || this.settings.defaultEnvironment;
            const currentLoginRedirectUrl = this.settings.loginRedirectUrl[currentEnvironment];
            return encodeURIComponent(currentLoginRedirectUrl);
        });
    }
    getApplicationToken() {
        return __awaiter(this, void 0, void 0, function* () {
            const currentEnvironment = (yield this.environment.get()) || this.settings.defaultEnvironment;
            return this.settings.applicationToken[currentEnvironment];
        });
    }
    getWardenLogInPageUrl() {
        return __awaiter(this, void 0, void 0, function* () {
            const currentEnvironment = (yield this.environment.get()) || this.settings.defaultEnvironment;
            return this.settings.wardenLogInPageUrl[currentEnvironment];
        });
    }
}
exports.LoginPageManager = LoginPageManager;

},{"../api":61,"../repository/environment":135,"../repository/extensionSettings":136}],63:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-for-browser-extension-calendar-dropdown-tooltip__text">\n    <span data-i18next="FUZELOC_calendar_vanityInfo">\n        Pick the meeting ID your guests will use to join this meeting. Create a new one or use an existing vanity link.*\n    </span>\n  <br><br>\n  <span class="fuze-for-browser-extension-text__notes" data-i18next="FUZELOC_calendar_vanityNotes">\n        *Notes and shared content associated with your vanity link will be available to all guests.\n        Add, edit, or learn more at\n        <span class="fuze-for-browser-extension-text__bold">Fuze>Settings>Meetings</span>\n    </span>\n</div>\n';

},{}],64:[function(require,module,exports){
module.exports={
  "selectors": [
    ".current-xmpp-contact",
    ".tg-avt",
    ".tg-avt-status",
    ".tg-ct.open-chat",
    ".dt.roster-group",
    ".readonly",
    ".fuze__number-wrapper",
    "[readonly]",
    "style",
    "textarea",
    "svg",
    "path",
    ".fuze-for-browser-extension-injected-tooltip__tooltip",
    ".fuze-for-browser-extension-dial-modal__preferred-device-name",
    ".fuze-for-browser-extension-dial-modal__phone-number",
    "script",
    // Fuze GSuite addon phone number elements
    ".brC-brG-bvJ-Jz-Jw span",
    // Fuze GSuite addon dialing popup phone number
    ".gnbHmc span"
  ]
}

},{}],65:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClickToCallManager = void 0;
const html_helper_1 = require("../helpers/html-helper");
const iframe_helper_1 = require("../helpers/iframe-helper");
const logging_1 = require("../logging/logging");
const extension_initializer_class_1 = require("../extension-initializer-class");
class ClickToCallManager {
    constructor(settings, apiLogic, extensionSettings, preferredDevice, message, callerIdMasking) {
        this.settings = settings;
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.preferredDevice = preferredDevice;
        this.message = message;
        this.callerIdMasking = callerIdMasking;
        this.isContentScriptEnabledForCurrentDomain = false;
        this.phoneNumberParseAndEmailObserver = null;
        this.isLocalDomainInTheList = false;
        this.preferredDeviceSettings = null;
        // Identifier to 3rd parties
        this.third_party_tpn_identifier = 'TPN_THINKINGCONNECTOR_INSTALLED';
        // Timer object for parsing. Need to keep duplicate timers from ocurring.
        this.scanningIntervalId = null;
        // Interval between node processing
        this.parseIntervalValue = 2000;
        // Nodes to be evaluated will be stored here and then removed for processing
        this.nodesToParse = [];
        this.isUnresponsivePageNotificationWasShowed = false;
        this.homeCountry = '';
        this.refreshing = false;
        this.username = '';
        this.password = '';
        this.wardenToken = '';
        this.isClickToCallEnabled = true;
        this.domains = [];
        this.callStarted = false;
        this.logging = logging_1.Logging.getInstance();
        this.hasSFPlugin = false;
        this.attemps = 0;
        this.phoneUtil = settings.googleLibphonenumber.PhoneNumberUtil.getInstance();
        this.PhoneNumberFormat = settings.googleLibphonenumber.PhoneNumberFormat;
        this.phoneNumberRE = settings.phoneNumberRegularExpression;
        this.phoneNumberParsingManager = new settings.PhoneNumberParsingManager({
            closest: (el, selector) => {
                this.closest(el, selector);
            },
            isChrome: settings.browserManager.isChrome,
            phoneUtil: this.phoneUtil,
            PhoneNumberFormat: this.PhoneNumberFormat,
        });
        this.ensureOldChromeCredentials = () => {
            const isChrome = settings.browserManager.isChrome;
            const OldChromeCredentialsManager = settings.OldChromeCredentialsManager;
            if (isChrome) {
                const oldChromeCredentialsManager = new OldChromeCredentialsManager({
                    credentialsRepository: settings.credentialsRepository,
                    getOldCredentials: settings.getOldCredentials,
                    keyUsername: settings.keys.USER_NAME,
                    keyPassword: settings.keys.PASSWORD,
                    keyDomains: settings.keys.DOMAINS,
                    keyWardenToken: settings.keys.WARDEN_TOKEN,
                    wasChromeCredentialsCopied: settings.keys.WAS_CHROME_CREDENTIALS_COPIED,
                });
                oldChromeCredentialsManager.initialize();
            }
        };
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.settings.checkIframeRestriction()) {
                return;
            }
            this.parsed = false;
            this.ensureOldChromeCredentials();
            this.getHomeCountryAndReinitializeIfHomeCountryWasChanged();
            const isUserLoggedIn = yield this.extensionSettings.getIsUserLoggedIn();
            if (isUserLoggedIn) {
                this.getPreferredDeviceSettings();
            }
            yield this.load();
            this.domContentLoadedHandler();
            this.addMessageListeners();
        });
    }
    closest(node, selector) {
        if (node.parentElement === null) {
            return;
        }
        return node.parentElement.closest(selector);
    }
    getTrimmedProbableIpAddress(probableIpAddress) {
        const indexOfFirstDigit = probableIpAddress.search(/\d/);
        probableIpAddress = probableIpAddress.substring(indexOfFirstDigit);
        const digitRegExp = /\d/g;
        let lastDigitIndex = probableIpAddress.length - 1;
        let match;
        while ((match = digitRegExp.exec(probableIpAddress)) !== null) {
            lastDigitIndex = match.index;
        }
        probableIpAddress = probableIpAddress.substring(0, lastDigitIndex + 1);
        return probableIpAddress;
    }
    isIpAddress(probableIpAddress) {
        probableIpAddress = this.getTrimmedProbableIpAddress(probableIpAddress);
        const arrayOfPartsBetweenDots = probableIpAddress.split('.');
        if (arrayOfPartsBetweenDots.length === 4) {
            let isIpAddress = true;
            const isPartsBetweenDotsOfProbableIpAddressValid = (partsBetweenDots) => {
                partsBetweenDots = parseInt(partsBetweenDots);
                return (!isNaN(partsBetweenDots) && (partsBetweenDots >= 0 && partsBetweenDots < 256));
            };
            for (let i = 0; i < arrayOfPartsBetweenDots.length; i++) {
                const partsBetweenDots = arrayOfPartsBetweenDots[i];
                isIpAddress = isIpAddress && isPartsBetweenDotsOfProbableIpAddressValid(partsBetweenDots);
            }
            return isIpAddress;
        }
        return false;
    }
    isPhoneNumberLengthGreaterThanMinimum(phoneNumber) {
        return phoneNumber.replace(/[^0-9]/g, '').length >= this.settings.minimumPossiblePhoneNumberLength;
    }
    reinitialize() {
        this.refreshing = false;
        this.parsed = false;
        this.loadExtensionEnabledConfiguration();
        this.injectTooltip();
        this.runParsing();
    }
    openLoginPage() {
        this.message.sendMessageToBackground({ action: 'openLoginPage' });
    }
    doLogout() {
        this.message.sendMessageToBackground({ action: 'doLogout' });
    }
    removePhoneNumberWrapper(wrapperNode) {
        const text = wrapperNode.innerText;
        wrapperNode.parentNode.replaceChild(document.createTextNode(text), wrapperNode);
    }
    deleteClickToCallButtons() {
        const fuzePhoneNumberElements = document.getElementsByClassName('fuze__number-wrapper');
        for (let i = fuzePhoneNumberElements.length - 1; i >= 0; i--) {
            try {
                this.removePhoneNumberWrapper(fuzePhoneNumberElements[i]);
            }
            catch (error) {
            }
        }
        document.querySelectorAll('#fuze__injected-image').forEach((logoElement) => logoElement.remove());
        $('.fuze__number-wrapper').removeClass('fuze__number-wrapper');
    }
    getHomeCountryAndReinitializeIfHomeCountryWasChanged() {
        return __awaiter(this, void 0, void 0, function* () {
            const homeCountry = yield this.extensionSettings.getHomeCountryFromStorage();
            if (homeCountry && this.homeCountry !== homeCountry.toUpperCase()) {
                this.homeCountry = (homeCountry) ? (homeCountry.toUpperCase()) : (this.homeCountry);
                this.deleteClickToCallButtons();
            }
            else {
                this.ensureVisibilityOfHomeCountryMessageIsCorrect();
            }
        });
    }
    ensureVisibilityOfHomeCountryMessageIsCorrect() {
        return __awaiter(this, void 0, void 0, function* () {
            const isHomeCountryUpdatedSuccessful = yield this.extensionSettings.getIsHomeCountryUpdatedSuccessful();
            if (isHomeCountryUpdatedSuccessful !== false) {
                return;
            }
            const isErrorMessageWasShowedOnceOnThePage = yield this.extensionSettings.getIsErrorMessageWasShowedOnceOnThePageFromStorage();
            if (!isErrorMessageWasShowedOnceOnThePage && this.isContentScriptEnabledForCurrentDomain) {
                yield this.extensionSettings.setIsErrorMessageWasShowedOnceOnThePageToStorage(true);
                this.showErrorMessageAboutHomeCountryFailedUpdate();
            }
        });
    }
    isContentScriptEnabledForDomain(activeTabUrl) {
        if (activeTabUrl) {
            for (let i = 0; i < this.settings.disabledDomains.length; i++) {
                if (activeTabUrl.indexOf(this.settings.disabledDomains[i]) > -1) {
                    this.isContentScriptEnabledForCurrentDomain = false;
                }
            }
        }
        this.isContentScriptEnabledForCurrentDomain = true;
    }
    showErrorMessageAboutHomeCountryFailedUpdate() {
        if (iframe_helper_1.isIframeRuntime()) {
            return;
        }
        this.message.sendMessageToPopup({ action: 'closePopup' });
        this.settings.homeCountryNotificationManager.show();
    }
    setCurrentCredentials() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.initializeWardenToken();
            yield this.initializeUserName();
        });
    }
    getFormattedPhoneNumber(message) {
        const numberProto = this.parsePhoneUsedLocale({
            originalNumber: message.numberToDial,
            locale: this.homeCountry,
        });
        const numberToDial = this.phoneNumberParsingManager.getPhonenumberInTheInternationalForm(numberProto) ||
            this.phoneNumberParsingManager.getPhonenumberInTheE164Form(numberProto) ||
            message.numberToDial;
        if (numberProto && numberProto.values_ && (typeof numberProto.values_[1] !== 'undefined')) {
            this.logging.showInfoLog('Used country code for current phone number ' + numberToDial + ' is ' + numberProto.values_[1]);
        }
        this.logging.showInfoLog('User country code is ' + this.homeCountry);
        return numberToDial;
    }
    addMessageListeners() {
        return __awaiter(this, void 0, void 0, function* () {
            this.message.addMessageListener((message) => __awaiter(this, void 0, void 0, function* () {
                switch (message.action) {
                    case 'activeTabUrlResponse':
                        const activeTabUrl = message.url;
                        this.isContentScriptEnabledForDomain(activeTabUrl);
                        break;
                    case 'manageLoginInfo':
                        const isUserLoggedIn = yield this.extensionSettings.getIsUserLoggedIn();
                        if (!isUserLoggedIn) {
                            return this.openLoginPage();
                        }
                        this.doLogout();
                        yield this.loadCredentials();
                        break;
                    case 'callNumber':
                        yield this.callNumberHandler(message);
                        break;
                    case 'getFormattedPhoneNumber':
                        const phoneNumberFullFormat = this.getFormattedPhoneNumber(message);
                        this.message.sendMessageToPopup({
                            action: 'receivedFormattedPhoneNumber',
                            phoneNumberFullFormat,
                        });
                        break;
                    case 'changeClickToCallState':
                        this.setExtensionEnabledState((message.extensionState === 'enabled'), true);
                        break;
                    case 'checkExtensionStateOnTheCurrentPage':
                        this.checkExtensionStateOnTheCurrentPage(message.isClickToCallEnabled);
                        break;
                    case 'successfulLogin':
                        yield this.setCurrentCredentials();
                        const homeCountry = yield this.extensionSettings.getHomeCountryFromStorage();
                        this.homeCountry = (homeCountry) ? (homeCountry.toUpperCase().trim()) : (this.homeCountry);
                        yield this.updatePreferredDeviceSettings();
                        this.reinitialize();
                        this.clickToCall();
                        break;
                    case 'homeCountryUpdated':
                        this.getHomeCountryAndReinitializeIfHomeCountryWasChanged();
                        break;
                    case 'homeCountryUpdateFailed':
                        const isErrorMessageWasShowedOnceOnThePage = yield this.extensionSettings.getIsErrorMessageWasShowedOnceOnThePageFromStorage();
                        if (!isErrorMessageWasShowedOnceOnThePage && this.isContentScriptEnabledForCurrentDomain) {
                            yield this.extensionSettings.setIsErrorMessageWasShowedOnceOnThePageToStorage(true);
                            this.showErrorMessageAboutHomeCountryFailedUpdate();
                        }
                        break;
                    case 'closeFinalLoginPage':
                        this.settings.windowRepository.closeAuthorisationTab(message.page);
                        break;
                    case 'logging':
                        this.logging.showInfoLog(message.message);
                        break;
                    case 'addDomainToIgnoreList':
                        this.addDomainToIgnoreList();
                        break;
                    case 'preferredDeviceUpdated':
                        this.updatePreferredDeviceSettings();
                        break;
                    case 'localizationLanguageChanged':
                        this.updatePreferredDeviceSettings();
                        break;
                    default:
                        break;
                }
            }));
        });
    }
    callNumberHandler(message) {
        return __awaiter(this, void 0, void 0, function* () {
            if (iframe_helper_1.isIframeRuntime()) {
                return true;
            }
            yield this.logging.showInfoLog('Received "callNumber" action');
            try {
                if (!this.callStarted) {
                    this.callStarted = true;
                    const numberToDial = this.getFormattedPhoneNumber(message);
                    let res = yield this.placeCall(numberToDial, null);
                    if (!res)
                        throw new Error('There as a problem with the call.');
                    this.callStarted = false;
                }
                ;
                return true;
            }
            catch (error) {
                this.callStarted = false;
                yield this.logging.showErrorLog('Failed calling number');
                return true;
            }
        });
    }
    updatePreferredDeviceSettings() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.getPreferredDeviceSettings();
            const numbers = document.querySelectorAll('#fuze__injected-image');
            if (numbers && numbers.length !== 0) {
                numbers.forEach((phoneNumber) => this.initializeTooltip(phoneNumber));
            }
        });
    }
    parsePhoneUsedLocale(options) {
        let phoneNumber = null;
        const originalNumber = options.originalNumber;
        const locale = options.locale;
        try {
            phoneNumber = this.phoneUtil.parse(originalNumber, locale);
            if (!this.phoneUtil.isPossibleNumber(phoneNumber, locale)) {
                phoneNumber = null;
            }
        }
        catch (err) {
            phoneNumber = null;
        }
        return phoneNumber;
    }
    // ---------------------------------------------------
    // adds clickable tpn logo to trigger click to call
    // ---------------------------------------------------
    makePhoneNumbersClickableOrUnClicable(theDocument, node, regex) {
        // Flags this at least one number was found on this node
        try {
            let numberFound = false;
            let phoneNumber = null;
            let match = null;
            let fragment = null;
            let remaining = node.nodeValue;
            let chunk = '';
            let possiblePhoneNumberWithoutDate = null;
            let options = {
                originalNumber: null,
                regionCode: this.homeCountry,
                websiteLang: this.phoneNumberParsingManager.getWebsiteLocale(theDocument, node),
            };
            const isNotSymbolTheDigit = (symbol) => {
                const isNotTheDigit = isNaN(parseInt(symbol));
                return isNotTheDigit;
            };
            const isNotSymbolTheLetterOrSlash = (symbol) => {
                const isNotTheLetter = !(/[a-zA-Z\/\\]/.test(symbol));
                return isNotTheLetter;
            };
            if (this.closest(node, this.settings.diallingModal.parentSelector)) {
                // Ignore the dial popup
                return;
            }
            let doesContainDate = this.settings.dateFinderInPhoneNumberHelper.isPhoneNumberContainedDate(remaining);
            // If there is a numbers in the string, we will stop the next string parsing
            if (remaining && !doesContainDate && !this.isIpAddress(remaining)) {
                options.originalNumber = remaining;
                phoneNumber = this.phoneNumberParsingManager.getFormattedPhoneNumber(options);
                if (phoneNumber !== null) {
                    fragment = this.addClickToCallButtonIntoDocumentFragment(theDocument, fragment || theDocument.createDocumentFragment(), remaining, this.createClickToCallButton(phoneNumber, this.phoneNumberParsingManager.getPhonenumberInTheInternationalForm(phoneNumber) || remaining, this.phoneNumberParsingManager.getPhonenumberInTheE164Form(phoneNumber) || remaining));
                    this.appendFuzeElement(theDocument, node, fragment);
                    return;
                }
            }
            // If there are multiple numbers in the string, we will
            // pick them all, add a link at the end, as well as put back
            // any other text this is not a number
            while ((match = regex.exec(remaining)) != null) {
                const regExpResult = match;
                let possiblePhoneNumber = regExpResult[1].trim();
                let isCorrectPhoneNumberWithoutDateLength = true;
                const matchIndex = regExpResult.input.indexOf(possiblePhoneNumber);
                doesContainDate = this.settings.dateFinderInPhoneNumberHelper.isPhoneNumberContainedDateInRemaining(remaining.substring(matchIndex));
                if (doesContainDate) {
                    possiblePhoneNumberWithoutDate = this.settings.dateFinderInPhoneNumberHelper.getPhoneNumberWithoutDate(remaining.substring(matchIndex), possiblePhoneNumber);
                    isCorrectPhoneNumberWithoutDateLength = this.isPhoneNumberLengthGreaterThanMinimum(possiblePhoneNumberWithoutDate);
                    if (isCorrectPhoneNumberWithoutDateLength) {
                        possiblePhoneNumber = possiblePhoneNumberWithoutDate;
                    }
                }
                chunk += remaining.substring(0, matchIndex);
                remaining = remaining.substring(matchIndex + possiblePhoneNumber.length);
                // if the next symbol in the string is digit or previous symbol is a letterthe next symbol in the string is digit
                // the extension make a conclusion this current fragment is not a phone number,
                const previousSymbol = chunk[chunk.length - 1];
                // if the next symbol is not the digit and previous symbol is not a letter it is a possible phone number
                const nextSymbol = remaining.substring(0, 1);
                const isPossiblePhoneNumber = isNotSymbolTheLetterOrSlash(previousSymbol) && isNotSymbolTheDigit(nextSymbol)
                    && isNotSymbolTheLetterOrSlash(nextSymbol);
                if (isPossiblePhoneNumber && isCorrectPhoneNumberWithoutDateLength && !this.isIpAddress(possiblePhoneNumber)) {
                    options.originalNumber = possiblePhoneNumber;
                    phoneNumber = this.phoneNumberParsingManager.getFormattedPhoneNumber(options);
                    if (phoneNumber !== null) {
                        fragment = this.addTextIntoDocumentFragment(theDocument, fragment || theDocument.createDocumentFragment(), chunk);
                        chunk = '';
                        fragment = this.addClickToCallButtonIntoDocumentFragment(theDocument, fragment, possiblePhoneNumber, this.createClickToCallButton(phoneNumber, this.phoneNumberParsingManager.getPhonenumberInTheInternationalForm(phoneNumber) || possiblePhoneNumber, this.phoneNumberParsingManager.getPhonenumberInTheE164Form(phoneNumber) || possiblePhoneNumber));
                        numberFound = true;
                    }
                    else {
                        chunk += possiblePhoneNumber;
                    }
                }
                else {
                    chunk += possiblePhoneNumber;
                }
            }
            // If number found, attach all the text after the last number
            if (numberFound) {
                if (chunk) {
                    remaining = remaining ? chunk + remaining : chunk;
                }
                if (remaining) {
                    fragment = this.addTextIntoDocumentFragment(theDocument, fragment, remaining);
                }
                this.appendFuzeElement(theDocument, node, fragment);
            }
            fragment = null;
            numberFound = null;
            phoneNumber = null;
            match = null;
            remaining = null;
            chunk = null;
            options = null;
        }
        catch (error) {
            this.logging.showErrorLog('Failed parsing phone number', error);
        }
    }
    appendFuzeElement(theDocument, node, fragment) {
        // searching for the tel: protocol to remove it in order to override standard browser behavior fot this protocol
        if (node.parentElement) {
            const possibleTelProtocolHref = node.parentElement.getAttribute('href');
            if (possibleTelProtocolHref && possibleTelProtocolHref.includes('tel:')) {
                node.parentElement.removeAttribute('href');
            }
        }
        if (node.parentElement && (node.parentElement.className !== 'fuze__number-wrapper') &&
            (node.parentElement.className !== 'fuze__number-wrapper--off')) {
            node.parentElement.replaceChild(fragment, node);
        }
        if (node.parentElement && (node.parentElement.className === 'fuze__number-wrapper--off')) {
            if (node.parentElement.parentElement) {
                (node.parentElement.parentElement).replaceChild(fragment, node.parentElement);
            }
            else {
                (node.parentElement).replaceChild(fragment, node);
            }
        }
    }
    addClickToCallButtonIntoDocumentFragment(theDocument, fragment, phoneNumber, clickToCallButton) {
        const isExtensionEnabledForCurrentDomain = this.isClickToCallEnabled && !this.isLocalDomainInTheList;
        let numberWrapper = null;
        if (isExtensionEnabledForCurrentDomain) {
            numberWrapper = theDocument.createElement('span');
            numberWrapper.className = 'fuze__number-wrapper';
            numberWrapper.appendChild(theDocument.createTextNode(phoneNumber));
            fragment.appendChild(numberWrapper);
            fragment.appendChild(clickToCallButton);
        }
        else {
            fragment.appendChild(theDocument.createTextNode(phoneNumber));
        }
        return fragment;
    }
    addTextIntoDocumentFragment(theDocument, fragment, text) {
        fragment.appendChild(theDocument.createTextNode(text));
        return fragment;
    }
    // ---------------------------------------------------
    // goes through all the textNodes and checks if they are visible on the screen and if they aren't on a text input.
    // ---------------------------------------------------
    getNodesthisNeededToBeUpdate(nodesToParse) {
        const nodesToUpdate = [];
        for (let i = 0; i < nodesToParse.length; i++) {
            if (!(nodesToParse[i].style && nodesToParse[i].style.display === 'none' ||
                this.closest(nodesToParse[i], '[contenteditable], .kix-appview-editor'))) {
                if (this.phoneNumberRE.test(nodesToParse[i].nodeValue)) {
                    nodesToUpdate.push(nodesToParse[i]);
                }
            }
        }
        return nodesToUpdate;
    }
    // ---------------------------------------------------
    // scans dom and adds click handler to phone numbers
    // ---------------------------------------------------
    getCurrentDomain() {
        return this.settings.URLHelper.getDomainPartOfURL(window.location.href);
    }
    addDomainToIgnoreList() {
        return __awaiter(this, void 0, void 0, function* () {
            this.domains = (yield this.extensionSettings.getUserDomains()) || [];
            const currentDomain = this.getCurrentDomain();
            if (currentDomain && !this.settings.domainsManager.isDomainRestricted(currentDomain)) {
                this.domains.unshift(currentDomain);
                this.settings.domainsManager.saveIgnoredDomainsList(this.domains, () => {
                    this.message.sendMessageToBackground({
                        action: 'checkExtensionStateOnTheCurrentPage',
                        isExtensionEnabled: false,
                    });
                });
            }
            this.settings.unresponsivePageNotification.hide();
        });
    }
    countTotalNumberOfCharacters(nodesToUpdate) {
        let totalNumberOfCharacters = 0;
        for (let j = 0; j < nodesToUpdate.length; j++) {
            totalNumberOfCharacters += nodesToUpdate[j].nodeValue !== null ? nodesToUpdate[j].nodeValue.length : 0;
        }
        return totalNumberOfCharacters;
    }
    hasSalesForcePluginInstalled() {
        const pluginSf = $("div[data-component-id='opencti_softPhone']");
        if (pluginSf.length && !this.hasSFPlugin) {
            this.hasSFPlugin = true;
        }
        return pluginSf.length;
    }
    clickToCall() {
        return __awaiter(this, void 0, void 0, function* () {
            const extension = new extension_initializer_class_1.default();
            const isUserLoggedIn = yield this.extensionSettings.getIsUserLoggedIn();
            if (this.settings.URLHelper.isFuzeAppDomain() || this.settings.URLHelper.isTeamsIntegrationsAppDomain() || extension.isDisabledC2CFunction()) {
                this.deleteClickToCallButtons();
                return;
            }
            if (!isUserLoggedIn && this.isUserLogedIn) {
                this.isUserLogedIn = isUserLoggedIn;
                this.deleteClickToCallButtons();
                return;
            }
            this.hasSalesForcePluginInstalled();
            if (!this.hasSFPlugin) {
                this.c2c(isUserLoggedIn);
                return;
            }
            if (this.settings.URLHelper.isSalesForceDomain() && this.attemps !== -1) {
                this.attemps = this.attemps + 1;
                console.log('this.attemps', this.attemps);
                setTimeout(() => {
                    const clickToCallAhref = $('lightning-click-to-dial > a');
                    if (clickToCallAhref[0] || this.attemps > 6) {
                        this.c2c(isUserLoggedIn);
                        this.attemps = -1;
                    }
                }, 1000);
            }
        });
    }
    c2c(isUserLoggedIn) {
        return __awaiter(this, void 0, void 0, function* () {
            this.isUserLogedIn = isUserLoggedIn;
            if (this.isUserLogedIn) {
                const entitlementForClickToCall = yield this.extensionSettings.getEntitlementForClickToCallFromStorage();
                if (this.entitlementForClickToCall && !entitlementForClickToCall) {
                    this.entitlementForClickToCall = entitlementForClickToCall;
                    this.deleteClickToCallButtons();
                    return;
                }
                this.entitlementForClickToCall = entitlementForClickToCall;
                if (entitlementForClickToCall) {
                    let isClickToCallEnabled = yield this.extensionSettings.getClickToCallState();
                    if (typeof isClickToCallEnabled === 'undefined') {
                        isClickToCallEnabled = true;
                        yield this.extensionSettings.setClickToCallState(isClickToCallEnabled);
                    }
                    if (this.isClickToCallEnabled !== isClickToCallEnabled) {
                        this.setExtensionEnabledState(isClickToCallEnabled, true);
                        return;
                    }
                    if (this.isClickToCallEnabled) {
                        this.checkIsLocalDomainInTheList((isLocalDomainInTheList) => {
                            if (this.isLocalDomainInTheList !== isLocalDomainInTheList) {
                                if (isLocalDomainInTheList) {
                                    this.logging.showInfoLog(this.settings.extensionName + ' is disabled for this domain.');
                                }
                                else {
                                    this.logging.showInfoLog(this.settings.extensionName + ' is enabled for this domain. ');
                                }
                                this.setIsLocalDomainInTheListState((isLocalDomainInTheList), true);
                            }
                            if (!this.isLocalDomainInTheList) {
                                this.startObservePage();
                                this.getHomeCountryAndReinitializeIfHomeCountryWasChanged();
                            }
                            else {
                                this.stopObservePage();
                                this.isUnresponsivePageNotificationWasShowed = true;
                            }
                            if (!this.parsed) {
                                this.runParsing();
                            }
                            // Second -- check if parsing.
                            if (this.refreshing) {
                                this.logging.showInfoLog('Already parsing, wait for next cicle');
                                return;
                            }
                            // Third -- check if there are elements to parse
                            if (!this.nodesToParse || this.nodesToParse.length === 0) {
                                return;
                            }
                            this.ensureVisibilityOfHomeCountryMessageIsCorrect();
                            this.refreshing = true;
                            const nodesToUpdate = this.getNodesthisNeededToBeUpdate(this.nodesToParse);
                            this.nodesToParse = [];
                            const totalCharacterCount = this.countTotalNumberOfCharacters(nodesToUpdate);
                            if (totalCharacterCount > this.settings.maxCharacterCountForParsing) {
                                if (!this.isUnresponsivePageNotificationWasShowed) {
                                    this.settings.unresponsivePageNotification.show();
                                    this.isUnresponsivePageNotificationWasShowed = true;
                                }
                                this.refreshing = false;
                                return;
                            }
                            for (let i = 0; i < nodesToUpdate.length; i++) {
                                this.makePhoneNumbersClickableOrUnClicable(nodesToUpdate[i].ownerDocument, nodesToUpdate[i], this.phoneNumberRE);
                            }
                            this.refreshing = false;
                            return;
                        });
                    }
                    else {
                        this.stopObservePage();
                    }
                }
                else {
                    this.stopObservePage();
                }
            }
            else {
                this.stopObservePage();
            }
        });
    }
    /**
     * Recursive method to return all descendants of a node
     *
     * @param el
     * @param descendants
     */
    getChildNodes(el, descendants) {
        const children = el.childNodes;
        if (children.length > 0) {
            for (let i = 0; i < children.length; i++) {
                if (this.nodeIsValid(children[i])) {
                    this.addNodeForParsing(children[i]);
                    if (children[i].nodeType === 1) {
                        this.getChildNodes(children[i], descendants);
                    }
                }
            }
        }
    }
    /**
     * Checks if node matches an element in the ignore list
     *
     * @param node
     * @returns {*|jQuery}
     */
    nodeIsValid(node) {
        const isValidNode = !$(node).is(this.settings.clickToCallIgnoredList.join((',')));
        return isValidNode;
    }
    /**
     * Runs validations on node and adds it to parse queue if it is valid
     *
     * @param node
     */
    addNodeForParsing(node) {
        if (node.parentNode) {
            if (this.nodesToParse) {
                this.nodesToParse.push(node);
            }
            else {
                this.nodesToParse = [node];
            }
        }
    }
    /**
     * Let's parse the page as soon as it's loaded to catch elements not flagged by mutation observer
     */
    runParsing() {
        this.parsed = true;
        this.nodesToParse = null;
        const parents = ['a', 'abbr', 'acronym', 'address', 'applet', 'b', 'bdo', 'big',
            'blockquote', 'body', 'caption', 'center', 'cite', 'code', 'dd', 'del', 'div',
            'dfn', 'dt', 'em', 'fieldset', 'font', 'form', 'h1', 'h2', 'h3', 'h4', 'h5',
            'h6', 'i', 'iframe', 'ins', 'kdb', 'li', 'nobr', 'noscript', 'object', 'pre',
            'p', 'q', 'samp', 'small', 'span', 'strike', 's', 'strong', 'sub', 'sup',
            'table', 'tbody', 'td', 'tr', 'th', 'tt', 'u', 'var'];
        const search = '//text()[(parent::' + parents.join('[not(@readonly) and not(contains(@class,\'readonly\'))] or parent::') + ')]';
        const textNodes = document.evaluate(search, document, null, XPathResult.UNORDERED_NODE_SNAPSHOT_TYPE, null);
        const shouldTextBeParsed = (text) => {
            if (text && (typeof text === 'string')) {
                // trick for reducing the number of nodes to parse
                text = text.trim().split('&nbsp;').join('').split(new RegExp('\\W')).join('');
                return ((text.length > 4) && (new RegExp('\\d\\d\\d\\d')).test(text));
            }
            return false;
        };
        for (let i = 0; i < textNodes.snapshotLength; i++) {
            if (textNodes.snapshotItem(i) &&
                (shouldTextBeParsed(textNodes.snapshotItem(i).textContent) ||
                    (!textNodes.snapshotItem(i).textContent && shouldTextBeParsed(textNodes.snapshotItem(i)))) &&
                this.nodeIsValid(textNodes.snapshotItem(i))) {
                this.addNodeForParsing(textNodes.snapshotItem(i));
            }
        }
    }
    initializeTooltip(element) {
        this.tooltipManagerForPhones.initialize({
            elementToAction: element,
            setTooltipText: () => {
                let tooltipText = this.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_callTooltip') + ' ';
                if (this.preferredDeviceSettings) {
                    if (this.preferredDeviceSettings.phoneNumberValue) {
                        tooltipText += this.preferredDeviceSettings.phoneNumberValue;
                    }
                    else {
                        tooltipText += this.preferredDeviceSettings.displayValue + ' ' + this.preferredDeviceSettings.lineExtension;
                    }
                }
                else {
                    tooltipText += this.settings.localizationLanguageManager.getTranslate('FUZELOC_prefPhone_prefferedPhone');
                }
                return tooltipText;
            },
        });
    }
    // ----------------------------------------------------------
    // This will create a image link for Click-to-Call and
    // wire up all the events
    // and return completed element back to the calling function
    // -----------------------------------------------------------
    addHandlersToClickTOCall(element, phoneNumber, number, internationalPhone) {
        element.addEventListener('click', (event) => {
            event.stopPropagation();
            if (phoneNumber && phoneNumber.values_ && (typeof phoneNumber.values_[1] !== 'undefined')) {
                this.logging.showInfoLog('Used country code for current phone number is ' + phoneNumber.values_[1]);
            }
            this.logging.showInfoLog('User country code is ' + this.homeCountry);
            if (iframe_helper_1.isIframeRuntime()) {
                return this.placeCallFromIframe(number);
            }
            return this.placeCall(number, internationalPhone);
        }, false);
        this.initializeTooltip(element);
    }
    placeCallFromIframe(number) {
        // sending message to active tab from iframe script in order to redirect it to top-level script
        this.message.sendMessageToBackground({ action: 'callNumber', numberToDial: number });
    }
    createClickToCallButton(phoneNumber, number, internationalPhone) {
        // create image logo
        const imageLink = document.createElement('img');
        imageLink.setAttribute('src', this.settings.resourcesRepository.getIcon());
        imageLink.id = 'fuze__injected-image';
        this.addHandlersToClickTOCall(imageLink, phoneNumber, number, internationalPhone);
        return imageLink;
    }
    injectTooltip() {
        this.tooltipManagerForPhones = new this.settings.TooltipManager({
            $placeToInject: $('body'),
            tooltipClass: 'fuze-for-browser-extension-injected-tooltip',
        });
    }
    getPreferredDevice() {
        return __awaiter(this, void 0, void 0, function* () {
            const savedDeviceAddress = yield this.extensionSettings.getPreferredDeviceAddress();
            if (savedDeviceAddress) {
                return savedDeviceAddress;
            }
            const newDevice = yield this.preferredDevice.getPreferredDevice();
            if (newDevice.ucapiAddress) {
                this.extensionSettings.savePreferredDeviceAddress(newDevice.ucapiAddress);
                return newDevice.ucapiAddress;
            }
            this.logging.showErrorLog('No preferred device from Synapse');
        });
    }
    getPreferredDeviceSettings() {
        return __awaiter(this, void 0, void 0, function* () {
            const c2cEntitlement = yield this.extensionSettings.getEntitlementForClickToCallFromStorage();
            if (!c2cEntitlement) {
                return;
            }
            const availableDevices = yield this.preferredDevice.getDevices();
            const preferredDeviceUcapiAddress = yield this.getPreferredDevice();
            this.preferredDeviceSettings = this.settings.preferredDeviceHelper.getDisplayingNameDeviceForGettingUcapiAddress(availableDevices, preferredDeviceUcapiAddress);
        });
    }
    load() {
        return __awaiter(this, void 0, void 0, function* () {
            this.refreshRequired = true;
            this.injectDialingWindowHTML();
            yield this.loadCredentials();
            this.injectScriptIntoHTML();
        });
    }
    // -------------------------------------------------------------
    // Add event handlers
    // Some events or handlers are browser-specific
    // -------------------------------------------------------------
    loadCredentials() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.initializeWardenToken();
            this.getAutoAnswerState();
            yield this.initializeUserName();
            this.userPassword = yield this.extensionSettings.getUserPasswordFromLocalDatabase();
        });
    }
    initializeWardenToken() {
        return __awaiter(this, void 0, void 0, function* () {
            this.wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
        });
    }
    initializeUserName() {
        return __awaiter(this, void 0, void 0, function* () {
            this.username = yield this.extensionSettings.getUserNameFromLocalDatabase();
        });
    }
    // -----------------------------------------------------------------------
    // Entry point to pre-process the number to be dialed
    // It will do a basic validation of the creds (if applicable).
    // Then it will call a browser-specific function to send an HTTP request
    // -----------------------------------------------------------------------
    placeCall(number, internationalPhone) {
        return __awaiter(this, void 0, void 0, function* () {
            if (!internationalPhone) {
                internationalPhone = number;
            }
            if (!this.wardenToken && (!this.username && !this.userPassword)) {
                // There is no point of continuing. Log the error and display a warning to the user
                this.openLoginPage();
                return false;
            }
            // The dialog will close after preset time elapses
            this.showDiallingModal(number);
            const thatAutoAnswerState = yield this.getAutoAnswerState();
            let res = yield this.startCall(internationalPhone);
            return res;
        });
    }
    loadCredentialsAndPlaceCall() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.username) {
                yield this.setCurrentCredentials();
            }
        });
    }
    getAutoAnswerState() {
        return __awaiter(this, void 0, void 0, function* () {
            const autoAnswerState = yield this.extensionSettings.getAutoAnswerFromStorage();
            this.autoAnswerState = (typeof autoAnswerState === 'undefined') ? true : autoAnswerState;
            return autoAnswerState;
        });
    }
    getUserOptions(userNameOrEmail, callback) {
        this.settings.credentialsRepository.getUserOptions(userNameOrEmail, callback, (httpCode) => {
            this.logging.showInfoLog(`Unexpected error trying to get user options. (HTTP Code: ${JSON.stringify(httpCode)})`);
            this.showErrorIntoDiallingModal(null);
        });
    }
    getWardenToken(userNameOrEmail, userPassword, userOptionId, callback) {
        this.settings.credentialsRepository.getWardenToken(userNameOrEmail, userPassword, userOptionId, callback, (httpCode) => {
            this.logging.showInfoLog(`Unexpected error getting Warden token by user options.. (HTTP Code: ${JSON.stringify(httpCode)})`);
            this.showErrorIntoDiallingModal(null);
        });
    }
    ClickToCall(callRestURL, internationalPhone, userId, wardenToken, autoAnswer, outboundCallerIdNumber = null) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                callRestURL = `${callRestURL}calls/preferredCall`;
                const encodedPhone = encodeURIComponent(internationalPhone);
                yield this.logging.showInfoLog(`User ${userId} calls the number ${internationalPhone}`, null);
                this.logging.showInfoLog(`User ${userId} calls the number ${internationalPhone} with outboundCallerIdNumber ${outboundCallerIdNumber}`, null);
                const url = outboundCallerIdNumber ?
                    `${callRestURL}?userId=${userId}&autoAnswer=${autoAnswer}&extension=${encodedPhone}&outboundCallerIdNumber=${encodeURIComponent(outboundCallerIdNumber)}` :
                    `${callRestURL}?userId=${userId}&autoAnswer=${autoAnswer}&extension=${encodedPhone}`;
                let res = yield this.apiLogic.sendRequest({
                    headers: {
                        Authorization: `Bearer ${wardenToken}`,
                    },
                    method: 'post',
                    url: url,
                });
                return res;
            }
            catch (e) {
                return e;
            }
        });
    }
    ;
    // ---------------------------------------
    // Initiate the call
    // ---------------------------------------
    startCall(internationalPhone) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const callRestURL = yield this.settings.getCallRestURL();
                yield this.setCurrentCredentials();
                const callerIdMaskingEnabled = yield this.extensionSettings.getCallerIdMaskingEnablingState();
                const outboundCallerIdNumber = callerIdMaskingEnabled ? yield this.callerIdMasking.getCallerIdMaskForOutboundCallerId(internationalPhone) : null;
                let responseMessage = yield this.ClickToCall(callRestURL, internationalPhone, this.username, this.wardenToken, this.autoAnswerState, outboundCallerIdNumber);
                if (responseMessage !== 'OK') {
                    yield this.logging.showInfoLog('Initiating a call. Replied with error', responseMessage);
                    this.showErrorIntoDiallingModal(null);
                    return false;
                }
                else {
                    yield this.logging.showInfoLog('Call OK', responseMessage);
                    this.settings.timerRepository.setTimeout(() => {
                        this.settings.diallingModal.hideDiallingModal();
                    }, 4000);
                    return responseMessage;
                }
            }
            catch (e) {
                yield this.logging.showInfoLog('Unexpected error trying to initiate a call. Error code: ', e);
                if (e && e.status === 401) {
                    this.message.sendMessageToBackground({ action: 'authError', errorCode: 401 });
                    return false;
                }
                this.showErrorIntoDiallingModal(e);
            }
            ;
        });
    }
    // ---------------------------------------------------
    // Event Handlers
    // ---------------------------------------------------
    // ----------------------------------------------------
    // Event handler triggered by DOM loaded event
    // ----------------------------------------------------
    domContentLoadedHandler() {
        this.loadExtensionEnabledConfiguration();
        this.checkIsLocalDomainInTheList((isDomainInTheList) => {
            if (isDomainInTheList) {
                this.logging.showInfoLog(`${this.settings.extensionName} is disabled for this domain.`);
            }
        });
        if (this.scanningIntervalId) {
            this.settings.timerRepository.clearInterval(this.scanningIntervalId);
        }
        this.scanningIntervalId = window.setInterval(this.clickToCall.bind(this), this.parseIntervalValue);
    }
    startObservePage() {
        if (!this.phoneNumberParseAndEmailObserver) {
            this.phoneNumberParseAndEmailObserver = new this.settings.PhoneNumberParseAndEmailObserver({
                addNodeForParsing: (node) => {
                    this.addNodeForParsing(node);
                },
                classToIgnore: 'fuze__number-wrapper',
                nodeIsValid: (node) => {
                    return this.nodeIsValid(node);
                },
                getChildNodes: (el, descendants) => {
                    this.getChildNodes(el, descendants);
                },
                MutationObserverBase: this.settings.MutationObserverBase,
                removePhoneNumberWrapper: this.removePhoneNumberWrapper,
                windowRepository: this.settings.windowRepository,
                calendarDomElementCharacteristics: this.settings.calendarDomElementCharacteristics,
                TooltipManager: this.settings.TooltipManager,
                clickToCallManager: this,
                gmailIntegrationTooltipView: this.settings.gmailIntegrationTooltipView,
                gmailTooltipTemplate: this.settings.gmailTooltipTemplate,
            }, this.apiLogic, this.extensionSettings);
            this.phoneNumberParseAndEmailObserver.observe();
        }
    }
    stopObservePage() {
        if (this.phoneNumberParseAndEmailObserver) {
            this.phoneNumberParseAndEmailObserver.disconnect();
            this.phoneNumberParseAndEmailObserver = null;
        }
    }
    loadExtensionEnabledConfiguration() {
        return __awaiter(this, void 0, void 0, function* () {
            const isClickToCallEnabled = yield this.extensionSettings.getClickToCallState();
            this.setExtensionEnabledState(isClickToCallEnabled, false);
            // load blocked domains
            this.settings.domainsManager.getIgnoredDomainsList((ignoredDomainsList) => {
                if (!this.ignoredDomainsList) {
                    this.ignoredDomainsList = ignoredDomainsList;
                }
                this.checkExtensionStateAndIsLocalDomainInTheList();
            });
        });
    }
    checkIsLocalDomainInTheList(callback) {
        this.settings.domainsManager.getIgnoredDomainsList()
            .then(data => {
            const currentDomain = this.getCurrentDomain();
            const isLocalDomainInTheList = this.settings.domainsManager.isDomainRestricted(currentDomain);
            if (callback) {
                return callback(isLocalDomainInTheList);
            }
        })
            .catch(error => console.log(error));
    }
    checkExtensionStateAndIsLocalDomainInTheList() {
        // This should be called after we have loaded extensionEnabled setting and
        // the list of domains to ignore
        // we only care about domains to ignore if the connector is not disabled
        if (this.isClickToCallEnabled) {
            this.checkIsLocalDomainInTheList((isLocalDomainInTheList) => {
                this.isLocalDomainInTheList = isLocalDomainInTheList;
            });
        }
    }
    checkExtensionStateOnTheCurrentPage(isClickToCallEnabled) {
        this.onChangeExtensionEnabledState(isClickToCallEnabled, null);
    }
    setExtensionEnabledState(isClickToCallEnabled, isReloadRequired) {
        if (this.isClickToCallEnabled !== isClickToCallEnabled) {
            if (isClickToCallEnabled === false) {
                this.logging.showInfoLog(this.settings.extensionName + ' is disabled. Exiting...');
            }
            else {
                this.logging.showInfoLog(this.settings.extensionName + ' is enabled. ');
            }
        }
        this.isClickToCallEnabled = isClickToCallEnabled;
        this.onChangeExtensionEnabledState(isClickToCallEnabled, isReloadRequired);
    }
    setIsLocalDomainInTheListState(isLocalDomainInTheList, isReloadRequired) {
        this.isLocalDomainInTheList = isLocalDomainInTheList;
        this.onChangeExtensionEnabledState(!isLocalDomainInTheList, isReloadRequired);
    }
    onChangeExtensionEnabledState(isClickToCallEnabled, isNeedInReinitialize) {
        if (!isClickToCallEnabled) {
            document.querySelectorAll('#fuze__injected-image').forEach((logoElement) => logoElement.remove());
            if (this.tooltipManagerForPhones[0]) {
                this.tooltipManagerForPhones.destroy();
            }
            $('.fuze__number-wrapper').addClass('fuze__number-wrapper--off').removeClass('fuze__number-wrapper');
        }
        if (!isClickToCallEnabled && !isNeedInReinitialize) {
            this.runParsing();
        }
        if (isNeedInReinitialize) {
            this.reinitialize();
        }
    }
    // --------------------------------------------
    // Inject HTML
    // --------------------------------------------
    injectScriptIntoHTML() {
        this.injectTooltip();
        this.injectIdentifierDiv();
    }
    // ----------------------------------------------
    // Inject DIV for identifications purposes
    // The purpose for this DIV is to provide a way to
    // detect our extension for 3rd parties
    // -----------------------------------------------
    injectIdentifierDiv() {
        // We are just injecting an empty div
        html_helper_1.addDivToDocument('', this.third_party_tpn_identifier);
    }
    // -------------------------------------------------------
    // DIV this is displayed when we attempt to dial a number
    // -------------------------------------------------------
    injectDialingWindowHTML() {
        const diallingModalHtml = this.settings.diallingModal.getHtmlLayout();
        html_helper_1.addDivToDocument(diallingModalHtml, 'fuze-for-browser-extension-dial-number__container_div');
    }
    // -------------------------------------------------------
    // Function to show/hide special dialogs
    // -------------------------------------------------------
    showDiallingModal(number) {
        const preferredDeviceListName = this.settings.localizationLanguageManager.getTranslate('FUZELOC_prefPhone_dropdownNamesList');
        let preferredDeviceType = Object.keys(preferredDeviceListName).filter((key) => {
            return preferredDeviceListName[key] === this.preferredDeviceSettings.displayValue;
        })[0];
        if (!preferredDeviceType) {
            preferredDeviceType = this.preferredDeviceSettings.displayValue;
        }
        const lineExtension = this.preferredDeviceSettings.phoneNumberValue ? this.preferredDeviceSettings.phoneNumberValue : this.preferredDeviceSettings.lineExtension;
        this.settings.diallingModal.showDiallingModal(number, preferredDeviceType, lineExtension);
    }
    // -----------------------------------------------------
    // Make Error pop-up visible
    // -----------------------------------------------------
    showErrorIntoDiallingModal(httpCode) {
        let status = 0;
        if (httpCode && httpCode.status) {
            status = httpCode.status;
        }
        this.settings.diallingModal.showErrorIntoDiallingModal(status);
    }
}
exports.ClickToCallManager = ClickToCallManager;

},{"../extension-initializer-class":80,"../helpers/html-helper":93,"../helpers/iframe-helper":94,"../logging/logging":108}],66:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PhoneNumberParseAndEmailObserver = void 0;
const resources_1 = require("../repository/resources");
const Tooltip = require("tooltip.js");
const gmail_tooltip_manager_1 = require("../gmail-integration/gmail-tooltip-manager");
const message_1 = require("../repository/message");
class PhoneNumberParseAndEmailObserver {
    constructor(settings, apiLogic, extensionSettings) {
        this.settings = settings;
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.node = document.body;
        this.config = { subtree: true, childList: true, characterData: true, attributeFilter: ['style'] };
        this.observer = null;
        this.resourcesRepository = new resources_1.Resources({
            clickToCallButton: this.apiLogic.constants.images.clickToCallButton,
        }, this.apiLogic);
        this.message = new message_1.Message(apiLogic);
        this.addMessageListener();
    }
    disconnect() {
        if (this.observer) {
            this.observer.disconnect();
            this.observer = null;
        }
    }
    observe() {
        if (!this.observer) {
            this.observer = new this.settings.MutationObserverBase(this.callback.bind(this), this.node, this.config);
            this.observer.observe();
        }
    }
    /**
     * Triggered by mutationObserver when dom is changed
     * Goes through list of mutations and gets all nodes to parse
     *
     * @param mutations
     */
    callback(mutations) {
        this.setGmailIntegration();
        for (let i = 0; i < mutations.length; i++) {
            if (this.settings.nodeIsValid(mutations[i].target)) {
                // If characterData, target is changed object
                if (mutations[i].type === 'characterData') {
                    this.settings.addNodeForParsing(mutations[i].target);
                }
                else if (mutations[i].type === 'childList' && this.settings.nodeIsValid(mutations[i].target)) {
                    for (let j = 0; j < mutations[i].addedNodes.length; j++) {
                        if (this.settings.nodeIsValid(mutations[i].addedNodes[j]) &&
                            mutations[i].addedNodes[j].className !== this.settings.classToIgnore) {
                            this.settings.addNodeForParsing(mutations[i].addedNodes[j]);
                            this.settings.getChildNodes(mutations[i].addedNodes[j], []);
                        }
                    }
                }
            }
            // Jira editing fields trick
            if (mutations[i].target.nodeName.toLowerCase() === 'textarea' && mutations[i].addedNodes.length) {
                for (let j = 0; j < mutations[i].addedNodes.length; j++) {
                    if (!this.settings.nodeIsValid(mutations[i].addedNodes[j])) {
                        this.settings.removePhoneNumberWrapper(mutations[i].addedNodes[j]);
                    }
                }
            }
        }
        return;
    }
    setGmailIntegration() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.settings.windowRepository.getCurrentURL().includes(this.settings.calendarDomElementCharacteristics.gmailInboxUrl)) {
                return;
            }
            const c2cEntitlement = yield this.extensionSettings.getEntitlementForClickToCallFromStorage();
            const fuzeContactsState = yield this.extensionSettings.getFuzeContactsState();
            if (!c2cEntitlement || (typeof c2cEntitlement === 'undefined') || !fuzeContactsState || (typeof fuzeContactsState === 'undefined')) {
                return;
            }
            const gmailMainLetterContainer = document.querySelector(this.settings.calendarDomElementCharacteristics.gmailMainLetterContainerSelector);
            if (!gmailMainLetterContainer) {
                return;
            }
            if (document.querySelector(`.${this.settings.calendarDomElementCharacteristics.gmailFuzeContactsButtonClass}`)) {
                return;
            }
            const gmailReplyButton = document.querySelector(this.settings.calendarDomElementCharacteristics.gmailReplyButtonSelector);
            if (!gmailReplyButton) {
                return;
            }
            const gmailTooltipManager = new gmail_tooltip_manager_1.GmailTooltipManager(this.apiLogic, this.settings.clickToCallManager, this.resourcesRepository);
            gmailTooltipManager.currentIdentifier = Date.now();
            const fuzeActionsButton = document.createElement('span');
            fuzeActionsButton.textContent = 'Fuze';
            fuzeActionsButton.className = gmailReplyButton.className;
            fuzeActionsButton.classList.add(this.settings.calendarDomElementCharacteristics.gmailFuzeContactsButtonClass);
            // setting unique identifier for contacts data to avoid wrong contacts from showing in popup
            fuzeActionsButton.setAttribute(gmailTooltipManager.contactsIdentifierAttribute, gmailTooltipManager.currentIdentifier.toString());
            const fuzeIcon = document.createElement('img');
            fuzeIcon.setAttribute('src', this.resourcesRepository.getIcon());
            fuzeIcon.id = 'fuze-contacts-c2c-icon';
            fuzeActionsButton.prepend(fuzeIcon);
            gmailReplyButton.parentElement.appendChild(fuzeActionsButton);
            const updatedViewForTooltip = gmailTooltipManager.injectImagesToTheHTML(this.settings.gmailIntegrationTooltipView);
            // @ts-ignore
            new Tooltip(fuzeActionsButton, {
                placement: 'top',
                title: updatedViewForTooltip,
                trigger: 'click',
                closeOnClickOutside: true,
                html: true,
                template: this.settings.gmailTooltipTemplate,
            });
            gmailTooltipManager.startEmailParsing(this.settings.calendarDomElementCharacteristics.gmailMainLetterContainerSelectorPreviewMode, this.settings.calendarDomElementCharacteristics.gmailMainLetterContainerSelector, this.settings.calendarDomElementCharacteristics.gmailUserEmailElementSelector, this.settings.calendarDomElementCharacteristics.gmailFuzeContactsButtonClass);
            if (this.gmailIntegrationIntervalId) {
                // Forces to recreate the loop to use the proper gmailTooltipManager variable
                clearInterval(this.gmailIntegrationIntervalId);
                this.gmailIntegrationIntervalId = 0;
            }
            this.gmailIntegrationIntervalId = window.setInterval(() => {
                const tooltipBody = document.querySelector(`.${gmailTooltipManager.mainTooltipClass}`);
                const tooltipBtn = document.querySelector(`.${this.settings.calendarDomElementCharacteristics.gmailFuzeContactsButtonClass}`);
                if (tooltipBody) {
                    if (!tooltipBtn) {
                        return;
                    }
                    const dataIdentifier = tooltipBtn.getAttribute(gmailTooltipManager.contactsIdentifierAttribute);
                    if (dataIdentifier !== gmailTooltipManager.currentIdentifier.toString()) {
                        clearInterval(this.gmailIntegrationIntervalId);
                        return this.gmailIntegrationIntervalId = 0;
                    }
                    const contactsStatus = !!tooltipBtn.getAttribute(gmailTooltipManager.contactsStatusAttribute);
                    if (contactsStatus) {
                        gmailTooltipManager.initializeContactsList(tooltipBtn, tooltipBody);
                        clearInterval(this.gmailIntegrationIntervalId);
                        this.gmailIntegrationIntervalId = 0;
                    }
                }
            }, 1500);
        });
    }
    addMessageListener() {
        this.message.addMessageListener((message) => {
            switch (message.action) {
                case 'changeGmailIntegrationState':
                    this.onChangeGmailIntegrationState(message.state);
                    break;
                case 'changeTeamsState':
                    break;
                case 'successfulLogout':
                    this.onChangeGmailIntegrationState(false);
                    break;
            }
        });
    }
    onChangeGmailIntegrationState(state) {
        const gmailIntegrationButton = document.querySelector(`.${this.settings.calendarDomElementCharacteristics.gmailFuzeContactsButtonClass}`);
        if (gmailIntegrationButton) {
            gmailIntegrationButton.remove();
        }
        if (state) {
            this.setGmailIntegration();
        }
    }
}
exports.PhoneNumberParseAndEmailObserver = PhoneNumberParseAndEmailObserver;

},{"../gmail-integration/gmail-tooltip-manager":86,"../repository/message":138,"../repository/resources":142,"tooltip.js":59}],67:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PhoneNumberParsingManager = void 0;
class PhoneNumberParsingManager {
    constructor(settings) {
        this.settings = settings;
    }
    getWebsiteLocale(theDocument, node) {
        // extract website lang
        const extractLocale = (lang) => {
            if (lang !== null && lang.indexOf('-') !== -1) {
                return lang.split('-')[1];
            }
            return '';
        };
        let websiteLang = theDocument.documentElement.lang;
        const websiteLangClosest = this.settings.closest(node, '[lang]');
        websiteLang = (extractLocale((websiteLangClosest && websiteLangClosest.lang) ?
            websiteLangClosest.lang : websiteLang)).toUpperCase();
        return websiteLang || '';
    }
    getFormattedPhoneNumber(options) {
        const originalNumber = options.originalNumber;
        const regionCode = options.regionCode;
        const websiteLang = options.websiteLang.toUpperCase();
        /* The current algorithm is:
         * 1) try use phone as it is
         * 2) try to parse phone by using locale which getting from homeCountry (regionCode)
         * 3) try to parse phone by using locale from html page (head)
         * 4) try to parse phone by using locale from html page (websiteLang)
        */
        // 1) try use phone as it is
        let phoneNumber = this.parsePhoneUsedLocale({
            phoneUtil: this.settings.phoneUtil,
            originalNumber,
            locale: 'ZZ',
        });
        // 2) try to parse phone by using locale which getting from homeCountry (regionCode)
        if (phoneNumber == null && regionCode) {
            phoneNumber = this.parsePhoneUsedLocale({
                phoneUtil: this.settings.phoneUtil,
                originalNumber,
                locale: regionCode,
            });
        }
        else if (phoneNumber) {
            return phoneNumber;
        }
        // 3) try to parse phone by using locale from html page (head)
        if (phoneNumber == null && this.getLocaleFromHead()) {
            phoneNumber = this.parsePhoneUsedLocale({
                phoneUtil: this.settings.phoneUtil,
                originalNumber,
                locale: this.getLocaleFromHead(),
            });
        }
        else if (phoneNumber) {
            return phoneNumber;
        }
        // 4) try to parse phone by using locale from html page (websiteLang)
        if (phoneNumber == null && websiteLang) {
            phoneNumber = this.parsePhoneUsedLocale({
                phoneUtil: this.settings.phoneUtil,
                originalNumber,
                locale: websiteLang,
            });
        }
        return phoneNumber;
    }
    getPhonenumberInTheInternationalForm(phoneProto) {
        let phoneNumber = '';
        try {
            phoneNumber = this.settings.phoneUtil.format(phoneProto, this.settings.PhoneNumberFormat.INTERNATIONAL);
        }
        catch (e) {
            phoneNumber = '';
        }
        return phoneNumber;
    }
    getPhonenumberInTheE164Form(phoneProto) {
        let phoneNumber = '';
        try {
            phoneNumber = this.settings.phoneUtil.format(phoneProto, this.settings.PhoneNumberFormat.E164);
        }
        catch (e) {
            phoneNumber = '';
        }
        return phoneNumber;
    }
    parsePhoneUsedLocale(options) {
        let phoneNumber = null;
        const originalNumber = options.originalNumber;
        const locale = options.locale;
        try {
            phoneNumber = this.settings.phoneUtil.parse(originalNumber, locale);
            if (!this.settings.phoneUtil.isPossibleNumber(phoneNumber) || this.doesPhoneNumberContainLetters(originalNumber)) {
                phoneNumber = null;
            }
        }
        catch (err) {
            phoneNumber = null;
        }
        return phoneNumber;
    }
    getLocaleFromHead() {
        try {
            let locale = document.head.querySelector('[property=\'og:locale\']').textContent;
            if (locale.indexOf('_') !== -1) {
                locale = locale.split('_')[locale.split('_').length - 1];
            }
            return locale;
        }
        catch (e) {
            return '';
        }
    }
    doesPhoneNumberContainLetters(phoneNumber) {
        const lettersRegExp = new RegExp('[A-Z]', 'i');
        return lettersRegExp.test(phoneNumber);
    }
}
exports.PhoneNumberParsingManager = PhoneNumberParsingManager;

},{}],68:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamsClickToCallManager = void 0;
const click_to_call_manager_1 = require("./click-to-call-manager");
const environment_1 = require("../repository/environment");
class TeamsClickToCallManager extends click_to_call_manager_1.ClickToCallManager {
    constructor(settings, apiLogic, extensionSettings, preferredDevice, message) {
        super(settings, apiLogic, extensionSettings, preferredDevice, message);
        this.environment = new environment_1.Environment(this.extensionSettings);
    }
    //lets override this function so the constructor dont duplicate event listeners
    addMessageListeners() {
        return __awaiter(this, void 0, void 0, function* () {
        });
    }
    ;
    //Lets make a phone call
    placeCallTeams(number, internationalPhone) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (!internationalPhone) {
                    internationalPhone = number;
                }
                if (internationalPhone) {
                    yield this.loadCredentialsAndPlaceCall();
                    if (!this.wardenToken && (!this.username && !this.userPassword)) {
                        // There is no point of continuing. Log the error and display a warning to the user
                        return;
                    }
                    // The dialog will close after preset time elapses
                    this.showDiallingModal(number);
                    if (this.wardenToken) {
                        yield this.getAutoAnswerState();
                        this.startCall(internationalPhone);
                    }
                    else {
                        this.getUserOptions(this.username, (userOptions) => {
                            this.getWardenToken(this.username, this.userPassword, userOptions.data.options[0].optionId, (wardenTokenResponse) => __awaiter(this, void 0, void 0, function* () {
                                this.wardenToken = wardenTokenResponse.data.grant.token;
                                yield this.extensionSettings.setWardenTokenToLocalDatabase(wardenTokenResponse.data.grant.token);
                                yield this.extensionSettings.setUserNameToLocalDatabase(wardenTokenResponse.data.entity.origin.id);
                                yield this.getAutoAnswerState();
                                this.startCall(internationalPhone);
                            }));
                        });
                    }
                }
                yield this.logging.showInfoLog('Placed call for number: ' + number);
            }
            catch (error) {
                yield this.logging.showErrorLog('Failed placeCallTeams for number: ' + number, error);
            }
        });
    }
    // ---------------------------------------
    // Get contact info from Rolodex
    // ---------------------------------------
    getContactPhonesList(contact) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.setCurrentCredentials();
            const currentEnvironment = yield this.environment.get(true);
            const rolodexApiEndpoint = this.apiLogic.config.rolodexApiEndpoint[currentEnvironment];
            try {
                if (this.wardenToken) {
                    const contactFromRolodex = yield this.getContactsFromRolodex(`${rolodexApiEndpoint}`, contact, this.wardenToken);
                    return contactFromRolodex;
                }
                else {
                    this.getUserOptions(this.username, (userOptions) => {
                        this.getWardenToken(this.username, this.userPassword, userOptions.data.options[0].optionId, (wardenTokenResponse) => __awaiter(this, void 0, void 0, function* () {
                            this.wardenToken = wardenTokenResponse.data.grant.token;
                            yield this.extensionSettings.setWardenTokenToLocalDatabase(wardenTokenResponse.data.grant.token);
                            yield this.extensionSettings.setUserNameToLocalDatabase(wardenTokenResponse.data.entity.origin.id);
                            const contactFromRolodex = yield this.getContactsFromRolodex(`${rolodexApiEndpoint}`, contact, this.wardenToken);
                            return contactFromRolodex;
                        }));
                    });
                }
                yield this.logging.showInfoLog('Got ' + contact + ' information from Rolodex');
            }
            catch (error) {
                yield this.logging.showErrorLog('Failed getting ' + contact + ' information from Rolodex', error);
            }
        });
    }
    getContactsFromRolodex(callRestURL, contact, wardenToken) {
        return __awaiter(this, void 0, void 0, function* () {
            callRestURL = `${callRestURL}`;
            const req = yield this.apiLogic.sendRequest({
                headers: {
                    Authorization: `Bearer ${wardenToken}`,
                },
                method: 'get',
                url: `${callRestURL}/resolution/contacts/emails/${contact}`,
            });
            return req;
        });
    }
    ;
}
exports.TeamsClickToCallManager = TeamsClickToCallManager;

},{"../repository/environment":135,"./click-to-call-manager":65}],69:[function(require,module,exports){
module.exports={
  "wardenExchangeTokenServiceUrl": {
    "production": "https://warden.thinkingphones.com/api/v1/tokens/current/exchange",
    "staging": "https://warden-stage.thinkingphones.com/api/v1/tokens/current/exchange"
  },
  "wardenValidateServiceUrl": {
    "production": "https://warden.thinkingphones.com/api/v1/tokens/",
    "staging": "https://warden-stage.thinkingphones.com/api/v1/tokens/"
  },
  "wardenLogInPageUrl": {
    "production": "https://auth.thinkingphones.com",
    "staging": "https://auth-stage.thinkingphones.com",
    "developing": "https://auth-dev.thinkingphones.com"
  },
  "applicationToken": {
    "production": "MTphcHBsaWNhdGlvbjoxOTY2NzE4NDQ3Nzk3NDgwMjE6OTIyMzM3MjAzNjg1NDc3NTgwNzpiUTh2VE5lZnNxaFZyMFNFTWw5VDVrOFYvZ3dHU05nQ1JDYzZoNGEvS0lZPQ==",
    "staging": "MTphcHBsaWNhdGlvbjoyODU2NzA3MTQ3MTcxMDMyODU6OTIyMzM3MjAzNjg1NDc3NTgwNzpUR1NKTldoc1lHVm9RenhsNlRFMUdkUWpGZ0dqYUZxUWxLRmc5eU8zWWdZPQ=="
  },
  "callRestURL": {
    "production": "https://synapse.thinkingphones.com/tpn-webapi-broker/services/",
    "staging": "https://synapse.qa.thinkingphones.com/tpn-webapi-broker/services/"
  },
  "wardenRestServiceUrl": {
    "production": "https://warden.thinkingphones.com/api/v1",
    "staging": "https://warden-stage.thinkingphones.com/api/v1"
  },
  "validURLsForMeetingComponent": [
    "http://fuzemeeting.com",
    "https://fuzemeeting.com",
    "https://calendar.google.com",
    "https://www.google.com/calendar"
  ],
  "fuzemeetingApiEndpoint": {
    "production": "https://api.fuzemeeting.com",
    "staging": "https://intgapi.fuzemeeting.com",

    "aplhaChannel": "https://api-canary.fuzemeeting.com",
    "aplhaChannelStaging": "https://intgapi-canary.fuzemeeting.com",
    "aplhaChannelDev": "https://mainapi-canary.fuzemeeting.com",

    "primaryChannel": "https://api-primary.fuzemeeting.com",
    "primaryChannelStaging": "https://intgapi-primary.fuzemeeting.com",
    "primaryChannelDev": "https://mainapi-primary.fuzemeeting.com/"
  },
  "loginRedirectUrl": {
    "production": "https://static.fuzemeeting.com/browserextension/index.html",
    "staging": "https://intgstatic.fuzemeeting.com/browserextension/index.html"
  },
  "logoutRedirectUrl": {
    "production": "https://static.fuzemeeting.com/browserextension/logout.html",
    "staging": "https://intgstatic.fuzemeeting.com/browserextension/logout.html"
  },
  "listOfPossibleOptionsForTheFinalLoginUrl": {
    "production": [
      "https://static.fuzemeeting.com/browserextension/index.html"
    ],
    "staging": [
      "https://intgstatic.fuzemeeting.com/browserextension/index.html"
    ]
  },
  "listOfPossibleOptionsForTheFinalLogoutUrl": {
    "production": [
      "https://static.fuzemeeting.com/browserextension/logout.html"
    ],
    "staging": [
      "https://intgstatic.fuzemeeting.com/browserextension/logout.html"
    ]
  },
  "launchMeetingUrlForepart": {
    "production": "fuze://fuzemeeting.com/fuze/",
    "staging": "https://intgapi.fuzemeeting.com/fuze/"
  },
  "citadelApiEndpoint": {
    "production": "https://citadel.thinkingphones.com",
    "staging": "https://citadel-stage.thinkingphones.com"
  },
  "contactiveApiEndpoint": {
    "production": "https://api.fuze.com",
    "staging": "https://api-stage.fuze.com",
    "developing": "https://api-dev.fuze.com"
  },
  "c2cMaskingApiEndpoint": {
    "production": "https://c2c-api.gts.fuze.com"
  },
  "rolodexApiEndpoint": {
    "production": "https://api.fuze.com/rolodex/v1",
    "staging": "https://api-stage.fuze.com/rolodex/v1",
    "developing": "https://api-dev.fuze.com/rolodex/v1"
  }
}

},{}],70:[function(require,module,exports){
module.exports={
  "logger": {
    "MAX_BUFFER_SIZE": 500
  },
  "allDayEventTime": {
    "allDayEventStartTime": "00:00",
    "allDayEventEndTime": "23:59"
  },
  "clickToCall": {
    "minimumPossiblePhoneNumberLength": 8,
    "maximumPossiblePhoneNumberLength": 15
  },
  "error": {
    "default": "Error..."
  },
  "loginPage": {
    "Firefox": {
      "sizes": {
        "width": 700,
        "height": 650
      }
    },
    "default": {
      "sizes": {
        "width": 550,
        "height": 500
      }
    },
    "type": "popup"
  },
  "images": {
    "icon": {
      "enabled": "images/logo/logo-image-color-16.png",
      "disabled": "images/logo/logo-image-color-disabled.png"
    },
    "arrowImagePath": "images/popup/arrow-down.svg",
    "activeArrowImagePath": "images/popup/arrow-up-active.svg",
    "grayArrowImagePath": "images/popup/gray-arrow-down.svg",
    "blueActiveArrowImagePath": "images/popup/blue-arrow-up-active.svg",
    "clickToCallButton": "images/logo/logo-image-color.svg",
    "logoWithTextImage": "images/logo/logo-with-text.svg",
    "gmailC2CButtonImage": "images/popup/gmail-c2c.svg",
    "noContactsImage": "images/modals/no-contacts-icon.svg",
    "fuzeLoadingGif": "images/logo/fuze-loading.gif",
    "defaultAvatar": "images/modals/default-avatar.svg"
  },
  "disabledDomains": [
    "about:newtab",
    "about:home",
    "about:preferences",
    "about:addons",
    "chrome://",
    "edge://",
    "//chrome.google.com/webstore",
    "about:Tabs",
    "about:blank",
    "about:debugging"
  ],
  "pagesFolderPath": "html/",
  "extension": {
    "name": "Fuze for ",
    "conflictingExtensions": [
      {
        "8x8 Web Dialer": "a.clicktocall"
      },
      {
        "RingCentral": ".rc-c2d-link.rc-c2d-dark"
      }
    ]
  },
  "homeCountry": {
    "default": "US"
  },
  "onInstalled": {
    "reason": {
      "UPDATE": "update",
      "INSTALL": "install"
    }
  },
  "environment": {
    "default": "production",
    "developing": "developing",
    "production": "production",
    "staging": "staging"
  },
  "platform": {
    "CHROME": "Chrome",
    "FIREFOX": "Firefox",
    "SAFARI": "Safari",
    "IE": "Internet Explorer",
    "EDGE": "Edge",
    "DEFAULT": "browser"
  },
  "os": {
    "WINDOWS": "Windows",
    "MAC": "MacOS",
    "UNIX": "UNIX",
    "LINUX": "Linux",
    "DEFAULT": "Unknown OS"
  },
  "joinMeetingsOptions": {
    "DESKTOP": "Fuze Desktop",
    "WEB": "Fuze Web",
    "WEB_ONLY": "OS doesn't support Fuze Desktop"
  },
  "browserPlatform": {
    "Chrome": "chrome-browser",
    "Firefox": "firefox-browser",
    "Edge": "edge-browser"
  },
  "timer": {
    "MESSAGE_HIDING_DELAY": 5000,
    "CLOSING_POPUP_DELAY": 100,
    "MESSAGE_HIDING_DURATION": 500,
    "MIN_DELAY": 1,
    "SIGN_STATUS_NOTIFICATION_DELAY": 3000
  },
  "zipHelper": {
    "WORKER_SCRIPTS_PATH": "../javascript/vendor/zip/"
  },
  "preferredDeviceTypesList": {
    "softphone": "DESKTOP",
    "mobile": "MOBILE",
    "handset": "POLYCOM",
    "other": "OTHER"
  },
  "localizationDataAttr": "data-i18next",
  "defaultLanguage": "en",
  "maxCharacterCountForParsing": 400000,
  "createdViaGoogleCalProperty": "googlecal",
  "clientId": "click2call-for-chrome",
  "pickCallerIdMaskRandomly": true
}

},{}],71:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const domainsToIgnore = ['https://webarc.legalmonkeys.com'];
exports.default = domainsToIgnore;

},{}],72:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CountryManager = void 0;
const previousCustomSettings_1 = require("./repository/previousCustomSettings");
const logging_1 = require("./logging/logging");
const api_1 = require("./api");
class CountryManager {
    constructor(settings, extensionSettings, contactive, message) {
        this.settings = settings;
        this.extensionSettings = extensionSettings;
        this.contactive = contactive;
        this.message = message;
        this.countriesList = null;
        this.logging = logging_1.Logging.getInstance();
        this.apiLogic = new api_1.APILogic();
        this.previousCustomSettings = new previousCustomSettings_1.PreviousCustomSettings(extensionSettings);
    }
    sendMessagesWithHomeCountryAndUpdateStatus(homeCountryUpdateStatus, userCountryCode) {
        this.message.sendMessageToAllExtensionParts({
            action: homeCountryUpdateStatus,
            homeCountry: userCountryCode,
        });
    }
    updateHomeCountryIntoStorage(userCountryCode) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.extensionSettings.setContactiveUserCountryCodeToStorage(userCountryCode);
            yield this.extensionSettings.setHomeCountryToStorage(userCountryCode);
            yield this.logging.showInfoLog('Updated saved user country code to ' + userCountryCode);
            this.sendMessagesWithHomeCountryAndUpdateStatus('homeCountryUpdated', userCountryCode);
        });
    }
    getCountryCodeList() {
        const countryCodeListArray = ($ && $.fn && $.fn.intlTelInput) ?
            ($.fn.intlTelInput.getCountryData() || null) : (null);
        let countryCodeList = [];
        const translatedCountryNames = this.settings.localizationLanguageManager.getTranslate('FUZELOC_homeCountry_countries');
        if (countryCodeListArray) {
            for (let i = 0; i < countryCodeListArray.length; i++) {
                const countryData = countryCodeListArray[i];
                const dialCode = countryData.dialCode.trim();
                const countryCode = countryData.iso2.trim().toUpperCase();
                const countryName = translatedCountryNames[countryCode];
                countryCodeList.push({
                    countryCode,
                    countryName,
                    dialCode,
                    label: countryName + ' (+' + dialCode + ')',
                    value: countryName + ' (+' + dialCode + ')',
                });
            }
        }
        else {
            countryCodeList = null;
        }
        this.countriesList = countryCodeList;
        return countryCodeList;
    }
    getCountryValueByCode(countryCode) {
        if (!this.countriesList) {
            this.countriesList = this.getCountryCodeList();
        }
        if (this.countriesList) {
            for (let i = 0; i < this.countriesList.length; i++) {
                if (this.countriesList[i].countryCode === countryCode) {
                    return this.countriesList[i];
                }
            }
        }
        return null;
    }
    isHomeCountryValid(homeCountry) {
        if (!this.countriesList) {
            this.countriesList = this.getCountryCodeList();
        }
        return this.getCountryValueByCode(homeCountry);
    }
    getHomeCountry() {
        return __awaiter(this, void 0, void 0, function* () {
            const homeCountryFromStorage = yield this.extensionSettings.getHomeCountryFromStorage();
            const contactiveUserCountryCode = yield this.extensionSettings.getContactiveUserCountryCodeFromStorage();
            const isHomeCountryUpdatedSuccessful = true;
            let homeCountryCode = homeCountryFromStorage;
            if (homeCountryCode) {
                return homeCountryCode;
            }
            const isContactiveCountryCodeValid = contactiveUserCountryCode && this.isHomeCountryValid(contactiveUserCountryCode);
            const userCountryValueFromContactive = yield this.contactive.getUserCountryFromContactiveAPI();
            homeCountryCode = isContactiveCountryCodeValid ? contactiveUserCountryCode : userCountryValueFromContactive;
            yield this.extensionSettings.setHomeCountryToStorage(homeCountryCode);
            yield this.extensionSettings.setIsHomeCountryUpdatedSuccessful(isHomeCountryUpdatedSuccessful);
            yield this.logging.showInfoLog('Saved user country code is ' + contactiveUserCountryCode);
            return homeCountryCode;
        });
    }
    updateHomeCountryAfterLogin() {
        let isHomeCountryUpdatedSuccessfully = true;
        this.contactive.getUserCountryCode().then((userCountryCode) => __awaiter(this, void 0, void 0, function* () {
            const savedBeforeContactiveUserCountryCode = yield this.extensionSettings.getContactiveUserCountryCodeFromStorage();
            if (!userCountryCode && !savedBeforeContactiveUserCountryCode || !this.isHomeCountryValid(userCountryCode)) {
                isHomeCountryUpdatedSuccessfully = false;
                userCountryCode = this.settings.defaultHomeCountryISO;
            }
            if ((userCountryCode !== savedBeforeContactiveUserCountryCode)) {
                yield this.updateHomeCountryIntoStorage(userCountryCode);
            }
            yield this.extensionSettings.setIsHomeCountryUpdatedSuccessful(isHomeCountryUpdatedSuccessfully);
            if (isHomeCountryUpdatedSuccessfully) {
                this.sendMessagesWithHomeCountryAndUpdateStatus('homeCountryUpdated', userCountryCode);
            }
            else {
                this.sendMessagesWithHomeCountryAndUpdateStatus('homeCountryUpdateFailed', userCountryCode);
            }
        })).catch((e) => {
            return this.homeCountryFallback(e);
        });
    }
    homeCountryFallback(error) {
        return __awaiter(this, void 0, void 0, function* () {
            let isHomeCountryUpdatedSuccessfully = true;
            let userCountryCode = this.settings.defaultHomeCountryISO;
            const currentCountry = yield this.extensionSettings.getHomeCountryFromStorage();
            if (currentCountry) {
                userCountryCode = currentCountry;
                this.logging.showInfoLog('Home country setting from storage was used');
            }
            else {
                try {
                    const wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
                    const currentEnvironment = yield this.extensionSettings.getPolyfill('tpn_currentEnvironment');
                    const contactiveEnd = this.apiLogic.config.contactiveApiEndpoint[currentEnvironment] + '/contactive/v1.0/users/me';
                    const userDetails = yield this.getContactInfo(contactiveEnd, wardenToken);
                    const countryCodeExists = !!userDetails && !!userDetails.data && !!userDetails.data.user && !!userDetails.data.user.currentCountry;
                    userCountryCode = countryCodeExists ? userDetails.data.user.currentCountry : 'US';
                }
                catch (e) {
                    isHomeCountryUpdatedSuccessfully = false;
                    this.logging.showErrorLog('Failed getting user currentCountry', error);
                }
            }
            this.extensionSettings.setIsHomeCountryUpdatedSuccessful(isHomeCountryUpdatedSuccessfully);
            this.updateHomeCountryIntoStorage(userCountryCode);
            if (isHomeCountryUpdatedSuccessfully) {
                this.sendMessagesWithHomeCountryAndUpdateStatus('homeCountryUpdated', userCountryCode);
            }
            else {
                this.sendMessagesWithHomeCountryAndUpdateStatus('homeCountryUpdateFailed', userCountryCode);
            }
        });
    }
    getContactInfo(callRestURL, wardenToken) {
        return __awaiter(this, void 0, void 0, function* () {
            const req = yield this.apiLogic.sendRequest({
                headers: {
                    Authorization: `Bearer ${wardenToken}`,
                },
                method: 'get',
                url: callRestURL,
            });
            return req;
        });
    }
    ;
}
exports.CountryManager = CountryManager;

},{"./api":61,"./logging/logging":108,"./repository/previousCustomSettings":140}],73:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-for-browser-extension-calendar-dropdown-tooltip__text">\n  <div class="fuze-for-browser-extension-text__italic" data-i18next="FUZELOC_calendar_didYouKnow">Did you know...</div>\n  <div class="fuze-for-browser-extension-tooltip__text" data-i18next="FUZELOC_calendar_didYouKnowInfo">\n    You can create your own personal meeting link.\n    “<span class="fuze-for-browser-extension-text__bold">Vanity links</span>”\n    are customizable so they are easy to remember and quick to share and reuse.\n    <br>\n    Go to <span class="fuze-for-browser-extension-text__bold">Fuze>Settings>Meetings</span> to create one.\n  </div>\n</div>\n';

},{}],74:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.DetectExtensionsConflict = void 0;
const logging_1 = require("./logging/logging");
class DetectExtensionsConflict {
    constructor(settings, extensionSettings, message) {
        this.settings = settings;
        this.extensionSettings = extensionSettings;
        this.message = message;
        this.conflictingExtensions = {
            '8x8 Web Dialer': 'a.clicktocall',
            'RingCentral': '.rc-c2d-link.rc-c2d-dark',
        };
        this.notificationTitleKey = 'FUZELOC_notification_conflictingExtension';
        this.uniqueNotificationClass = 'fuze-for-browser-extension-detect-extension-conflicts-notification';
        this.logging = logging_1.Logging.getInstance();
        this.cookieRepository = settings.cookieRepository || {};
        this.messageManager = settings.messageManager || null;
        this.clickToCallEnablingStateManager = settings.clickToCallEnablingStateManager || null;
    }
    // ========================================================
    // external page
    // ========================================================
    activePageInitializer() {
        const that = this;
        const updateConflictsStatusOnThePage = () => __awaiter(this, void 0, void 0, function* () {
            const isUserLoggedIn = yield that.extensionSettings.getIsUserLoggedIn();
            if (!isUserLoggedIn) {
                that.hideBannerOnThePageAndStopObservingPage();
            }
            const c2cEntitlement = yield that.extensionSettings.getEntitlementForClickToCallFromStorage();
            if (!c2cEntitlement && (typeof c2cEntitlement !== 'undefined')) {
                clearInterval(checkingConflictsInterval);
                checkingConflictsInterval = 0;
                return that.hideBannerOnThePageAndStopObservingPage();
            }
            const isDisabledExtension = yield this.extensionSettings.getIsExtensionDisabledStatus();
            if (isDisabledExtension) {
                return that.hideBannerOnThePageAndStopObservingPage();
            }
            const isClickToCallEnabled = yield that.clickToCallEnablingStateManager.getEnablingState();
            if (!isClickToCallEnabled) {
                return that.hideBannerOnThePageAndStopObservingPage();
            }
            that.didUserAcceptConflictOnThePageBefore = yield that.getUserStatusOfAcceptingConflict('Page');
            if (that.didUserAcceptConflictOnThePageBefore === 'true') {
                return that.hideBannerOnThePageAndStopObservingPage();
            }
            const detectedExtensions = that.getConflictExtensions();
            if (detectedExtensions || (that.savedDetectedConflictExtensionsList !== detectedExtensions)) {
                that.savedDetectedConflictExtensionsList = detectedExtensions;
                this.message.sendMessageToBackground({
                    action: 'conflictingExtensionsListToBackground',
                    conflictingExtensionsListToBackground: detectedExtensions,
                });
            }
            if (detectedExtensions) {
                that.setBannerOnThePage(!that.isBannerExist());
            }
            else {
                that.hideBannerOnThePageAndStopObservingPage();
            }
            that.startObserveExternalPage(() => {
                const detectedExtensions = that.getConflictExtensions();
                if (detectedExtensions && (that.savedDetectedConflictExtensionsList !== detectedExtensions)) {
                    that.savedDetectedConflictExtensionsList = detectedExtensions;
                    this.message.sendMessageToBackground({
                        action: 'conflictingExtensionsListToBackground',
                        conflictingExtensionsListToBackground: detectedExtensions,
                    });
                }
            });
        });
        let checkingConflictsInterval = that.startTrackingConflicts(() => {
            return updateConflictsStatusOnThePage();
        });
        this.message.addMessageListener((message) => {
            if (!message) {
                return;
            }
            switch (message.action) {
                case 'successfulLogout':
                    that.setInitialStateOfDetectingConflict();
                    break;
                case 'changeDisabledState':
                    if (message.isDisabledExtension) {
                        that.hideBannerOnThePageAndStopObservingPage();
                        clearInterval(checkingConflictsInterval);
                        checkingConflictsInterval = 0;
                    }
                    else {
                        checkingConflictsInterval = that.startTrackingConflicts(() => {
                            return updateConflictsStatusOnThePage();
                        });
                    }
                    break;
                default:
                    break;
            }
        });
    }
    hideBannerOnThePageAndStopObservingPage() {
        if (this.notification) {
            this.notification.hide();
        }
        this.stopObservePage();
    }
    getExtensionName() {
        return this.settings.localizationLanguageManager.getTranslate(`FUZELOC_generic_extensionName.${this.settings.currentPlatform}`);
    }
    setBannerOnThePage(conditionToUpdateBanner) {
        const that = this;
        if (conditionToUpdateBanner) {
            const extensionsListText = that.getExtensionsListText(that.savedDetectedConflictExtensionsList);
            const extensionName = that.getExtensionName();
            let notificationDescription = ' ' + extensionName + that.settings.localizationLanguageManager.getTranslate('FUZELOC_notification_conflictingExtensionInfo');
            notificationDescription = notificationDescription.replace(/{extensionsListText}/g, extensionsListText);
            this.notification = new this.settings.NotificationManager({
                localizationLanguageManager: that.settings.localizationLanguageManager,
                resourcesRepository: that.settings.resourcesRepository,
                notificationView: that.settings.notificationView,
                onCloseHandler: () => {
                    that.messageManager.removeErrorMessage();
                    this.message.sendMessageToBackground({
                        action: 'userAcceptedExtensionConflictOnTheActivePage',
                        userAcceptedExtensionConflictOnTheActivePage: 'true',
                    });
                    that.hideBannerOnThePageAndStopObservingPage();
                },
                notificationTitleKey: that.notificationTitleKey,
                notificationDescription,
                uniqueNotificationClass: that.uniqueNotificationClass,
            });
            this.notification.show();
        }
    }
    startObserveExternalPage(handler) {
        if (!this.observer) {
            this.observer = new MutationObserver(handler);
            this.observer.observe(document.body, { subtree: true, childList: true });
        }
    }
    stopObservePage() {
        if (this.observer) {
            this.observer.disconnect();
        }
        this.observer = null;
    }
    backgroundInitializer() {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            yield this.extensionSettings.setClickToCallDisabledByConflicts(false);
            that.getDataFromCookie('savedDetectedConflictExtensionsList')
                .then((cookie) => {
                const savedDetectedConflictExtensionsList = (cookie) ? cookie : '';
                that.setConflictingExtension(savedDetectedConflictExtensionsList);
            });
            that.getDataFromCookie('didUserAcceptConflictOnThePageBefore')
                .then((cookie) => {
                const didUserAcceptConflictOnThePopupBefore = (cookie) ? cookie : '';
                that.setUserStatusOfAcceptingConflict('Page', didUserAcceptConflictOnThePopupBefore);
            });
            that.getDataFromCookie('didUserAcceptConflictOnThePopupBefore')
                .then((cookie) => {
                const didUserAcceptConflictOnThePopupBefore = (cookie) ? cookie : '';
                that.setUserStatusOfAcceptingConflict('Popup', didUserAcceptConflictOnThePopupBefore);
            });
            this.message.addMessageListener((message) => {
                if (message) {
                    switch (message.action) {
                        case 'userAcceptedExtensionConflictOnTheActivePage':
                            that.setUserStatusOfAcceptingConflict('Page', message.userAcceptedExtensionConflictOnTheActivePage);
                            this.message.sendMessageToPopup({
                                updatedDetectedConflictState: message.userAcceptedExtensionConflictOnTheActivePage,
                            });
                            break;
                        case 'changeState':
                            that.setUserStatusOfAcceptingConflict('Page', 'false');
                            that.setUserStatusOfAcceptingConflict('Popup', 'false');
                            that.setCookie('didUserAcceptConflictOnThePageBefore', 'false');
                            that.setCookie('didUserAcceptConflictOnThePopupBefore', 'false');
                            break;
                        case 'conflictingExtensionsListToBackground':
                            const conflictingExtensions = message.conflictingExtensionsListToBackground;
                            that.getDataFromCookie('savedDetectedConflictExtensionsList')
                                .then((cookie) => {
                                const savedDetectedConflictExtensionsList = (cookie) ? cookie : '';
                                if (savedDetectedConflictExtensionsList !== conflictingExtensions) {
                                    const joining = (a, b) => {
                                        if (!a || !b) {
                                            return a || b || '';
                                        }
                                        const uniqueList = {};
                                        const unitedList = (a + ', ' + b).split(', ');
                                        for (let i = 0; i < unitedList.length; i++) {
                                            uniqueList[unitedList[i]] = i;
                                        }
                                        return Object.keys(uniqueList).join(', ');
                                    };
                                    const updatedDetectedConflictExtensionsList = joining(savedDetectedConflictExtensionsList, conflictingExtensions);
                                    that.setCookie('savedDetectedConflictExtensionsList', updatedDetectedConflictExtensionsList);
                                    that.setConflictingExtension(updatedDetectedConflictExtensionsList);
                                    if (updatedDetectedConflictExtensionsList !==
                                        savedDetectedConflictExtensionsList) {
                                        that.setUserStatusOfAcceptingConflict('Page', 'false');
                                        that.setCookie('didUserAcceptConflictOnThePageBefore', 'false');
                                        that.setCookie('didUserAcceptConflictOnThePopupBefore', 'false');
                                    }
                                }
                            })
                                .catch((error) => {
                                if (error && !error.catcher) {
                                    error.catcher = 'DetectExtensionsConflict: backgroundInitializer: getDataFromCookie';
                                    that.logging.showErrorLog(error.catcher + ' Failed getting coolie', error);
                                }
                            });
                            break;
                        default:
                            break;
                    }
                }
            });
        });
    }
    isBannerOnThePopupExists() {
        if (this.messageManager && this.messageManager.getErrorMessage()) {
            return (this.messageManager.getErrorMessage().length > 0);
        }
        return false;
    }
    setBannerOnThePopup() {
        const that = this;
        that.messageManager.setErrorMessage({
            interior: that.getBannerInteriorForPopup(that.getExtensionsListText(that.savedDetectedConflictExtensionsList)),
            isTemporary: false,
            displayCloseButton: true,
            onCloseHandler: () => {
                that.setInitialStateOfDetectingConflict();
                that.clickToCallEnablingStateManager.getEnablingState().then((isClickToCallEnabled) => {
                    if (!isClickToCallEnabled) {
                        that.clickToCallEnablingStateManager.setEnablingState(!isClickToCallEnabled);
                    }
                });
            },
        });
    }
    popupInitializer() {
        const that = this;
        let checkingConflictsInterval = 0;
        const updateBannerStatusOnThePopup = () => __awaiter(this, void 0, void 0, function* () {
            const c2cEntitlement = yield that.extensionSettings.getEntitlementForClickToCallFromStorage();
            if (!c2cEntitlement) {
                return;
            }
            const isDisabledExtension = yield this.extensionSettings.getIsExtensionDisabledStatus();
            if (isDisabledExtension) {
                return;
            }
            if ((yield that.getUserStatusOfAcceptingConflict('Page')) !== 'true') {
                return;
            }
            if ((yield that.getUserStatusOfAcceptingConflict('Popup')) === 'true') {
                that.messageManager.removeErrorMessage();
                const isClickToCallEnabled = yield that.clickToCallEnablingStateManager.getEnablingState();
                if (isClickToCallEnabled) {
                    return;
                }
                yield this.extensionSettings.setClickToCallDisabledByConflicts(false);
                return that.clickToCallEnablingStateManager.setEnablingState(isClickToCallEnabled);
            }
            const conflictingExtensions = yield that.getConflictingExtension();
            if (!conflictingExtensions) {
                clearInterval(checkingConflictsInterval);
                return checkingConflictsInterval = 0;
            }
            that.savedDetectedConflictExtensionsList = conflictingExtensions;
            if (!that.isBannerOnThePopupExists()) {
                that.setBannerOnThePopup();
            }
            const isClickToCallEnabled = yield that.clickToCallEnablingStateManager.getEnablingState();
            if (isClickToCallEnabled) {
                yield this.extensionSettings.setClickToCallDisabledByConflicts(false);
                return that.clickToCallEnablingStateManager.setEnablingState(!isClickToCallEnabled);
            }
        });
        this.settings.addMessageListenerOnChangeTabToKnowActiveTabUrl.call(this, (activeTabUrl) => {
            const isContentScriptEnabledForDomain = that.settings.isContentScriptEnabledForDomain(that.settings.popupDisabledDomains, activeTabUrl);
            if (isContentScriptEnabledForDomain) {
                checkingConflictsInterval = that.startTrackingConflicts(() => {
                    return updateBannerStatusOnThePopup();
                });
            }
        });
        this.message.addMessageListener((message) => {
            if (!message) {
                return;
            }
            if (message.action === 'changeDisabledState' && message.isDisabledExtension) {
                clearInterval(checkingConflictsInterval);
                checkingConflictsInterval = 0;
            }
            else {
                return updateBannerStatusOnThePopup();
            }
        });
    }
    ;
    startTrackingConflicts(track) {
        return window.setInterval(track, 12000);
    }
    getDataFromCookie(cookieName) {
        const that = this;
        return (new Promise((resolve, reject) => {
            try {
                that.cookieRepository.getCookie({
                    url: 'http://*/*',
                    name: cookieName,
                }, (data) => {
                    const cookieValue = (data) ? (data.value) : ('');
                    resolve(cookieValue);
                });
            }
            catch (e) {
                reject(e);
            }
        }));
    }
    getConflictExtensions() {
        const that = this;
        const clickToCallExtensionsNames = Object.keys(that.conflictingExtensions);
        let detectedExtensions = '';
        for (let i = 0; i < clickToCallExtensionsNames.length; i++) {
            const conflictingExtensionSelector = that.conflictingExtensions[clickToCallExtensionsNames[i]];
            if ($(conflictingExtensionSelector).length > 0) {
                detectedExtensions += (detectedExtensions) ? (', ') : ('');
                detectedExtensions += clickToCallExtensionsNames[i];
            }
        }
        return detectedExtensions;
    }
    isBannerExist() {
        const $notificationElement = $('.' + this.uniqueNotificationClass);
        return ($notificationElement && ($notificationElement.length > 0));
    }
    getBannerInteriorForPopup(extensionsListText) {
        const extensionName = this.getExtensionName();
        let text = ` ${extensionName}${this.settings.localizationLanguageManager.getTranslate('FUZELOC_notification_conflictingExtensionInfo')}`;
        text = text.replace(/{extensionsListText}/g, extensionsListText);
        return text;
    }
    getExtensionsListText(extensionsList) {
        if (extensionsList) {
            extensionsList += ' extension';
            if (extensionsList.indexOf(',') > 0) {
                extensionsList += 's';
            }
        }
        return extensionsList;
    }
    setInitialStateOfDetectingConflict() {
        this.message.sendMessageToBackground({
            action: 'userAcceptedExtensionConflictOnThePage',
            userAcceptedExtensionConflictOnThePage: 'false',
        });
        this.setUserStatusOfAcceptingConflict('Popup', 'false');
        this.setUserStatusOfAcceptingConflict('Page', 'false');
        this.message.sendMessageToBackground({
            action: 'userAcceptedExtensionConflictOnThePage',
            userAcceptedExtensionConflictOnThePage: 'false',
        });
    }
    setCookie(key, value) {
        this.cookieRepository.setCookie({
            url: 'http://*/*',
            name: key,
            value,
            path: '/',
        });
    }
    getUserStatusOfAcceptingConflict(placeWhereUserAcceptedConflict) {
        return __awaiter(this, void 0, void 0, function* () {
            const key = `tpn_didUserAcceptConflictOnThe${placeWhereUserAcceptedConflict}`;
            return this.extensionSettings.getPolyfill(key);
        });
    }
    setUserStatusOfAcceptingConflict(placeWhereUserAcceptedConflict, data) {
        return __awaiter(this, void 0, void 0, function* () {
            const sendingData = {};
            sendingData[`tpn_didUserAcceptConflictOnThe${placeWhereUserAcceptedConflict}`] = data;
            return this.extensionSettings.setPolyfill(sendingData);
        });
    }
    getConflictingExtension() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.extensionSettings.getPolyfill('tpn_conflictingExtension');
        });
    }
    setConflictingExtension(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.extensionSettings.setPolyfill({ tpn_conflictingExtension: data });
        });
    }
}
exports.DetectExtensionsConflict = DetectExtensionsConflict;

},{"./logging/logging":108}],75:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DiallingModal = void 0;
const logging_1 = require("./logging/logging");
class DiallingModal {
    constructor(settings, message) {
        this.settings = settings;
        this.message = message;
        this.closeButtonCssClass = 'fuze-for-browser-extension-dial-modal__close-sign';
        this.dialingModalCssId = 'fuze-for-browser-extension-dial-modal';
        this.confirmButtonClass = 'fuze-for-browser-extension-notification__confirm-button';
        this.phoneNumberCssId = 'fuze-for-browser-extension-dial-modal__phone-number';
        this.dialingModalInfoCssClass = 'fuze-for-browser-extension-dial-modal__info';
        this.cancelButtonClass = 'fuze-for-browser-extension-notification__cancel-button';
        this.dialingModalPreferredDeviceIconClass = 'fuze-for-browser-extension-dial-modal__preferred-device-icon';
        this.errorDialogClass = 'fuze-for-browser-extension-dial-modal__error';
        this.errorInfoDialogClass = 'fuze-for-browser-extension-dial-modal-error__info';
        this.preferredDeviceNameClass = 'fuze-for-browser-extension-dial-modal__preferred-device-name';
        this.currentPreferredDeviceIconClass = '';
        this.logging = logging_1.Logging.getInstance();
    }
    hideDiallingModal() {
        const that = this;
        const currentDate = new Date();
        const $dialingModal = $('#' + that.dialingModalCssId);
        const $confirmButton = $('.' + that.confirmButtonClass);
        const $dialingModalPreferredDeviceIcon = $('.' + that.dialingModalPreferredDeviceIconClass);
        $dialingModalPreferredDeviceIcon.removeClass(this.currentPreferredDeviceIconClass);
        this.settings.domHelper.elements.hide($dialingModal);
        this.settings.domHelper.elements.removeHandlers($confirmButton);
        that.logging.showInfoLog('Hidden dialing modal: ' + currentDate.getTime());
    }
    showErrorIntoDiallingModal(errorStatus) {
        const that = this;
        const $errorDialog = $('.' + that.errorDialogClass);
        const $closeButton = $('.' + that.closeButtonCssClass);
        const $cancelButton = $('.' + that.cancelButtonClass);
        const $confirmButton = $('.' + that.confirmButtonClass);
        const $errorInfoDialog = $('.' + that.errorInfoDialogClass);
        const closeErrorDialog = () => {
            $errorDialog.hide();
        };
        this.hideDiallingModal();
        this.settings.domHelper.elements.addHandlers($closeButton, 'click', closeErrorDialog);
        this.settings.domHelper.elements.addHandlers($cancelButton, 'click', closeErrorDialog);
        if (errorStatus === 401) {
            $errorInfoDialog.text(that.settings.localizationLanguageManager.getTranslate('FUZELOC_callScreen_sessionHasExpired'));
            $confirmButton.text(that.settings.localizationLanguageManager.getTranslate('FUZELOC_welcome_signIn'));
            $confirmButton.off().on('click', () => {
                closeErrorDialog();
                this.message.sendMessageToBackground({ action: 'openLoginPage' });
            });
        }
        else {
            $confirmButton.off().on('click', () => {
                closeErrorDialog();
                that.callNumber(that.diallingPhoneNumber);
            });
        }
        $errorDialog.show();
        that.logging.showInfoLog('Showed error in the dialing modal.');
    }
    callNumber(diallingPhoneNumber) {
        this.message.sendMessageToBackground({ action: 'callNumber', numberToDial: diallingPhoneNumber });
    }
    // --------------------------------------------------------
    // Display a little pop-up letting the user know that the number is being dialed
    // --------------------------------------------------------
    showDiallingModal(diallingPhoneNumber, preferredDeviceType, lineExtension) {
        const that = this;
        this.diallingPhoneNumber = diallingPhoneNumber || this.diallingPhoneNumber;
        const currentDate = new Date();
        const $dialingModal = $('#' + that.dialingModalCssId);
        const $phoneNumber = $('#' + that.phoneNumberCssId);
        const $confirmButton = $('.' + that.confirmButtonClass);
        const $preferredDevice = $('.' + that.preferredDeviceNameClass);
        const $dialingModalPreferredDeviceIcon = $('.' + that.dialingModalPreferredDeviceIconClass);
        const isSpecificPreferredDeviceType = preferredDeviceType !== that.settings.preferreDeviceTypeForOthers;
        const formPreferredDeviceNameClass = (preferredDeviceType) => {
            preferredDeviceType = isSpecificPreferredDeviceType ? preferredDeviceType : that.settings.preferreDeviceTypeForOthers;
            const currentPreferredDeviceClass = 'fuze-for-browser-extension-dial-modal-preferred-device__' +
                preferredDeviceType.toLowerCase();
            return currentPreferredDeviceClass;
        };
        let preferredDeviceInfo = that.settings.localizationLanguageManager.getTranslate('FUZELOC_callScreen_using') + ' ';
        let translatedPrefDeviceType;
        if (isSpecificPreferredDeviceType) {
            translatedPrefDeviceType = that.settings.localizationLanguageManager.getTranslate('FUZELOC_prefPhone_dropdownNamesList')[preferredDeviceType];
            if (!translatedPrefDeviceType) {
                translatedPrefDeviceType = preferredDeviceType;
            }
        }
        const translatedPrefDeviceTypeMessage = translatedPrefDeviceType !== undefined ? translatedPrefDeviceType : '';
        preferredDeviceInfo += translatedPrefDeviceTypeMessage + lineExtension;
        this.settings.domHelper.elements.removeHandlers($confirmButton);
        this.settings.domHelper.elements.addHandlers($confirmButton, 'click', () => {
            that.logging.showInfoLog('"Retry" button in dialing modal clicked');
            that.callNumber(that.diallingPhoneNumber);
        });
        this.settings.domHelper.elements.setDataInside($phoneNumber, diallingPhoneNumber);
        this.settings.domHelper.elements.setDataInside($preferredDevice, preferredDeviceInfo);
        this.currentPreferredDeviceIconClass = formPreferredDeviceNameClass(preferredDeviceType);
        $dialingModalPreferredDeviceIcon.addClass(this.currentPreferredDeviceIconClass);
        this.settings.domHelper.elements.show($dialingModal);
        that.logging.showInfoLog('Showed dialing modal: ' + currentDate.getTime());
    }
    getHtmlLayout() {
        const that = this;
        const localizationDataAttrPart = ' ' + that.settings.localizationLanguageManager.settings.dataAttr + '=';
        const html = '<div class=\'' + that.dialingModalCssId + '\' id=\'' + that.dialingModalCssId + '\'>' +
            '<div class=\'fuze-for-browser-extension-dial-modal__title\'>Fuze</div>' +
            '<p class=\'' + that.dialingModalInfoCssClass + '\'' + localizationDataAttrPart + '\'FUZELOC_callScreen_calling\'>calling...</p>' +
            '<p id=\'' + that.phoneNumberCssId + '\' class=\'' + that.phoneNumberCssId + '\'></p>' +
            '<div class=\'fuze-for-browser-extension-dial-modal__person-icon\'></div>' +
            '<div class=\'fuze-for-browser-extension-dial-modal__line\'></div>' +
            '<div class=\'' + that.dialingModalPreferredDeviceIconClass + '\'></div>' +
            '<div class=\'' + that.preferredDeviceNameClass + '\'></div>' +
            '</div>' +
            '<div class=\'' + that.errorDialogClass + '\'>' +
            '<span class=\'' + that.closeButtonCssClass + '\'></span>' +
            '<div class=\'fuze-for-browser-extension-dial-modal-error__title\'' + localizationDataAttrPart +
            '\'FUZELOC_callScreen_canNotCompleteCall\'>' + that.settings.localizationLanguageManager.getTranslate('FUZELOC_callScreen_canNotCompleteCall') + '</div>' +
            '<div class=\'' + that.errorInfoDialogClass + '\'><span' + localizationDataAttrPart + '\'FUZELOC_callScreen_errorInfo_firstPart\'>' +
            that.settings.localizationLanguageManager.getTranslate('FUZELOC_callScreen_errorInfo_firstPart') +
            '</span><a class=\'fuze-for-browser-extension-message__link\' href=\'https://www.fuze.com/support\' target=\'_blank\'' +
            localizationDataAttrPart + '\'FUZELOC_callScreen_contactSupport\'' + '>' +
            that.settings.localizationLanguageManager.getTranslate('FUZELOC_callScreen_contactSupport') + '</a> ' +
            '<span' + localizationDataAttrPart + '\'FUZELOC_callScreen_errorInfo_endPart\'>' +
            that.settings.localizationLanguageManager.getTranslate('FUZELOC_callScreen_errorInfo_endPart') + '</span></div>' +
            '<div class=\'fuze-for-browser-extension-dial-modal-error__button-wrapper\'>' +
            '<button class=\'' + that.cancelButtonClass + '\'' + localizationDataAttrPart + '\'FUZELOC_generic_cancel\'>' +
            that.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_cancel') + '</button>' +
            '<button class=\'' + that.confirmButtonClass + '\'' + localizationDataAttrPart + '\'FUZELOC_generic_retry\'>' +
            that.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_retry') + '</button>' +
            '</div>' +
            '</div>';
        return html;
    }
}
exports.DiallingModal = DiallingModal;

},{"./logging/logging":108}],76:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DropdownManager = void 0;
class DropdownManager {
    constructor(settings) {
        this.settings = settings;
        this.selectedItemClass = 'selected';
        this.currentValueClass = 'current-value';
        this.disabledStateClass = 'fuze-for-browser-extension-dropdown-wrapper__disabled-state';
        this.isDropdownOpened = false;
        this.showScroll = settings.showScroll || false;
        this.onDropdownOpenHandler = settings.onDropdownOpenHandler || function () {
        };
        this.onDropdownCloseHandler = settings.onDropdownCloseHandler || function () {
        };
        this.dropdownWrapperClass = settings.dropdownWrapperClass || 'fuze-for-browser-extension-dropdown-wrapper';
        this.inputClass = settings.inputClass || 'fuze-for-browser-extension-dropdown__current-input-value';
        this.itemClassIfSomeValueIsSelected = settings.itemClassIfSomeValueIsSelected || 'fuze-for-browser-extension-dropdown__menu-item--some-value-is-selected';
    }
    initialize() {
        const that = this;
        this.addArrowImageAsBackgroundImage();
        that.settings.$inputForAutoComplete.autocomplete({
            autoFocus: false,
            minLength: 0,
            source: that.settings.dataSource,
            select: (event, ui) => {
                that.settings.onItemSelected(event, ui);
                that.isDropdownOpened = !that.isDropdownOpened;
            },
            response: (event, ui) => {
                const isUndefined = (value) => {
                    return (typeof value === 'undefined');
                };
                if (ui.content.length <= 1 &&
                    (isUndefined(ui.content[0]) || (that.settings.$inputForAutoComplete.val() === ui.content[0].value))) {
                    for (let i = 0; i < that.settings.dataSource.length; i++) {
                        if (isUndefined(ui.content[0]) ||
                            ((ui.content[0].value !== that.settings.dataSource[i].value))) {
                            ui.content.push(that.settings.dataSource[i]);
                        }
                    }
                }
            },
            close: () => {
                that.isDropdownOpened = false;
                that.makeDropdownPassive();
                that.onDropdownCloseHandler();
            },
            open: () => {
                that.isDropdownOpened = true;
                that.makeDropdownActive();
                that.onDropdownOpenHandler();
            },
            appendTo: that.settings.dropdownListContainerSelector,
        }).data('ui-autocomplete')._renderItem = (ul, item) => {
            // trick for adding unique attribute
            const dataFuze = that.formFuzeData(item.label);
            return $('<li class="ui-menu-item" role="presentation" data-fuze="' + dataFuze +
                '"><a class="ui-corner-all" tabindex="-1">' + item.label + '</a></li>').appendTo(ul);
        };
        if (this.showScroll) {
            const listElement = $(that.settings.dropdownListContainerSelector + ' ul');
            // to avoid delay after reinitialization of country dropdown list
            listElement.enscroll('destroy');
            listElement.enscroll({ verticalScrolling: true });
        }
        this.addOnClickHandler();
        $(document).on('click', (e) => {
            const $dropDownItemsElement = $(that.settings.dropdownListContainerSelector);
            const $dropDownInputElement = $('.' + that.inputClass);
            if ((!$dropDownItemsElement.is(e.target)) && ($dropDownItemsElement.has(e.target).length === 0) &&
                (!$dropDownInputElement.is(e.target)) && ($dropDownItemsElement.length) && ($dropDownInputElement.length)) {
                that.closeDropdown();
            }
        });
    }
    formFuzeData(data) {
        const textArray = data.split(new RegExp('\\W'));
        const dataFuze = textArray.join('');
        return dataFuze ? dataFuze : data;
    }
    closeDropdown() {
        this.settings.$inputForAutoComplete.autocomplete('close');
        this.makeDropdownPassive();
    }
    searchCurrentValue() {
        const that = this;
        that.settings.$inputForAutoComplete.autocomplete('search', that.settings.$inputForAutoComplete.val());
    }
    addArrowImageAsBackgroundImage() {
        $('body').prepend('<style>' +
            '.' + this.dropdownWrapperClass + '.' + this.dropdownWrapperClass + '--active  ' +
            '{background: url(\'' + this.settings.activeArrowImagePath + '\') 175px center no-repeat !important;} ' +
            '.' + this.dropdownWrapperClass + ' {background: url(\'' + this.settings.arrowImagePath + '\')  175px center no-repeat !important;}' +
            '</style>');
    }
    makeDropdownActive() {
        $(`.${this.dropdownWrapperClass}`).addClass(`${this.dropdownWrapperClass}--active`);
        this.settings.$inputForAutoComplete.addClass(this.inputClass + '--active');
    }
    makeDropdownPassive() {
        $(`.${this.dropdownWrapperClass}`).removeClass(`${this.dropdownWrapperClass}--active`);
        this.settings.$inputForAutoComplete.removeClass(`${this.inputClass}--active`);
    }
    setCurrentValueItem(data) {
        const dataFuze = this.formFuzeData(data);
        const item = $(this.settings.dropdownListContainerSelector).find(`li[data-fuze='${dataFuze}']`);
        if ($(item)[0]) {
            const items = $(this.settings.dropdownListContainerSelector).find('li');
            $(item).addClass(`${this.currentValueClass} ${this.selectedItemClass} ${this.itemClassIfSomeValueIsSelected}`);
            $(items).addClass(this.itemClassIfSomeValueIsSelected);
        }
    }
    changeVisibility() {
        if (this.isDropdownOpened) {
            this.makeDropdownActive();
        }
        else {
            this.makeDropdownPassive();
        }
    }
    addOnClickHandler() {
        const that = this;
        that.settings.$inputForAutoComplete.off().on('click', () => {
            that.isDropdownOpened = !that.isDropdownOpened;
            if (that.isDropdownOpened) {
                that.searchCurrentValue();
            }
            else {
                that.closeDropdown();
            }
        }).on('paste input', () => {
            that.searchCurrentValue();
        }).on('mouseleave', () => {
            $(`.${that.currentValueClass}`).removeClass(that.selectedItemClass);
        }).on('mouseover', () => {
            $(`.${that.currentValueClass}`).addClass(that.selectedItemClass);
        });
    }
    setDisableState(isDisabledState) {
        this.settings.$inputForAutoComplete.prop('disabled', isDisabledState);
        const dropdownWrapper = $(`.${this.dropdownWrapperClass}`);
        if (isDisabledState) {
            dropdownWrapper.addClass(this.disabledStateClass);
        }
        else {
            dropdownWrapper.removeClass(this.disabledStateClass);
        }
    }
}
exports.DropdownManager = DropdownManager;

},{}],77:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ClickToCallEnablingStateManager = void 0;
const logging_1 = require("../logging/logging");
const mixpanel_service_1 = require("../mixpanel/mixpanel-service");
const api_1 = require("../api");
class ClickToCallEnablingStateManager {
    constructor(settings, extensionSettings, message, apiLogic) {
        this.settings = settings;
        this.extensionSettings = extensionSettings;
        this.message = message;
        this.apiLogic = apiLogic;
        this.logging = logging_1.Logging.getInstance();
        this.apiLogic = new api_1.APILogic();
    }
    onChangeEnablingState(callback) {
        this.message.addMessageListener((message) => {
            if (message && message.action === 'changeClickToCallState') {
                const clickToCallState = message.extensionState;
                callback(clickToCallState);
            }
        });
    }
    getEnablingState() {
        return __awaiter(this, void 0, void 0, function* () {
            let isEnabledState = yield this.extensionSettings.getClickToCallState();
            return (typeof isEnabledState === 'undefined') || isEnabledState;
        });
    }
    ;
    setEnablingState(isEnabledState) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                yield this.extensionSettings.setClickToCallState(isEnabledState);
                if (!isEnabledState) {
                    yield this.extensionSettings.setCallerIdMaskingEnablingState(isEnabledState);
                }
                const statusUpdated = true;
                this.logging.showInfoLog(`ClickToCallEnablingStateManager: setEnablingState: setClickToCalState: Click-To-Call is enabled now: ${isEnabledState}`);
                this.message.sendMessageToAllExtensionParts({
                    action: 'changeClickToCallState',
                    extensionState: isEnabledState,
                });
                const object = `click2call_${isEnabledState ? 'on' : 'off'}`;
                const browserVersion = window.navigator.userAgent;
                mixpanel_service_1.MixPanelService.sendEvent({
                    browserVersion,
                    action: 'select',
                    object,
                    place: 'settings_tab',
                    owner: 'brow_integration',
                    platform: 'browserextension'
                }, 'Settings Options');
                return statusUpdated;
            }
            catch (error) {
                let updatedError = error;
                if (!this.settings.errorHelper.isExceptionHandled(error)) {
                    updatedError = this.settings.errorHelper.updateCatcherInTheError(error, 'ClickToCallEnablingStateManager: setEnablingState: setClickToCallState');
                    this.logging.showErrorLog('Failed updating the enabled state for click-to-call functionality', error);
                }
                throw updatedError;
            }
        });
    }
}
exports.ClickToCallEnablingStateManager = ClickToCallEnablingStateManager;

},{"../api":61,"../logging/logging":108,"../mixpanel/mixpanel-service":120}],78:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnvironmentManager = void 0;
class EnvironmentManager {
    constructor() {
        this.commands = ['takemetoprod', 'takemetostage'];
        this.takemetoprod = 'production';
        this.takemetostage = 'staging';
        this.getEnvironment = function (command) {
            return this[command];
        };
        this.getCommands = function () {
            return this.commands;
        };
    }
}
exports.EnvironmentManager = EnvironmentManager;

},{}],79:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.EnvironmentInitializer = void 0;
const environment_1 = require("./repository/environment");
const extensionSettings_1 = require("./repository/extensionSettings");
const api_1 = require("./api");
class EnvironmentInitializer {
    constructor(settings) {
        this.settings = settings;
        this.apiLogic = new api_1.APILogic();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(this.apiLogic);
        this.environment = new environment_1.Environment(this.extensionSettings);
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            const currentDomain = this.settings.URLHelper.getDomainPartOfURL(location.href);
            const currentLoginPageUrl = yield this.settings.getLoginPageUrl();
            const loginPageDomain = this.settings.URLHelper.getDomainPartOfURL(currentLoginPageUrl);
            if (loginPageDomain === currentDomain) {
                setTimeout(() => {
                    const userKeyInput = document.getElementById('userKeyInput');
                    userKeyInput.addEventListener('input', (event) => {
                        const value = event.target.value;
                        this.checkEnvironment(value);
                    });
                }, 500);
            }
        });
    }
    isCommand(text) {
        const commands = this.settings.environmentManager.getCommands();
        for (let i = 0; i < commands.length; i++) {
            if ((text.length === commands[i].length) &&
                (text === commands[i])) {
                return true;
            }
        }
        return false;
    }
    checkEnvironment(possibleCommand) {
        return __awaiter(this, void 0, void 0, function* () {
            if (possibleCommand) {
                possibleCommand = possibleCommand.trim();
            }
            if (this.isCommand(possibleCommand)) {
                const environment = this.settings.environmentManager.getEnvironment(possibleCommand);
                yield this.environment.set(environment);
                const currentLoginPageUrl = yield this.settings.getLoginPageUrl();
                this.settings.changeCurrentPageUrl(currentLoginPageUrl);
            }
        });
    }
}
exports.EnvironmentInitializer = EnvironmentInitializer;

},{"./api":61,"./repository/environment":135,"./repository/extensionSettings":136}],80:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const extensionSettings_1 = require("./repository/extensionSettings");
const i18next = require("i18next");
const api_1 = require("./api");
const login_page_manager_1 = require("./authorisation/login-page-manager");
const click_to_call_manager_1 = require("./click-to-call/click-to-call-manager");
const phone_number_parse_and_email_observer_1 = require("./click-to-call/phone-number-parse-and-email-observer");
const phone_number_parsing_manager_1 = require("./click-to-call/phone-number-parsing-manager");
const country_manager_1 = require("./country-manager");
const detect_extensions_conflict_1 = require("./detect-extensions-conflict");
const dialling_modal_1 = require("./dialling-modal");
const dropdown_manager_1 = require("./dropdown-manager");
const click_to_call_enabling_state_1 = require("./enable-manager/click-to-call-enabling-state");
const environment_manager_1 = require("./environment-manager");
const environment_switcher_initializer_1 = require("./environment-switcher-initializer");
const date_finder_in_phone_number_helper_1 = require("./helpers/date-finder-in-phone-number-helper");
const date_helper_1 = require("./helpers/date-helper");
const iframe_helper_1 = require("./helpers/iframe-helper");
const preferred_device_helper_1 = require("./helpers/preferred-device-helper");
const simulate_user_changes_helper_1 = require("./helpers/simulate-user-changes-helper");
const localization_language_manager_1 = require("./localization-language-manager");
const action_on_meetings_manager_1 = require("./meeting/action-on-meetings-manager");
const calendar_component_manager_1 = require("./meeting/calendar-component-manager");
const calendar_observer_1 = require("./meeting/calendar-observer");
const google_calendar_tooltips_manager_1 = require("./meeting/google-calendar-tooltips-manager");
const launch_meeting_button_1 = require("./meeting/launch-meeting-button");
const launch_meeting_url_map_manager_1 = require("./meeting/launch-meeting-url-map-manager");
const meeting_details_manager_1 = require("./meeting/meeting-details-manager");
const meeting_time_parsing_manager_1 = require("./meeting/meeting-time-parsing-manager");
const visibility_meetings_manager_1 = require("./meeting/visibility-meetings-manager");
const message_manager_1 = require("./message-manager");
const mutation_observer_base_1 = require("./mutation-observer-base");
const home_country_notification_manager_1 = require("./notifications/home-country-notification-manager");
const notification_manager_1 = require("./notifications/notification-manager");
const sign_in_notifications_manager_1 = require("./notifications/sign-in-notifications-manager");
const signed_status_notification_1 = require("./notifications/signed-status-notification");
const old_chrome_credentials_manager_1 = require("./old-chrome-credentials-manager");
const popup_ignored_domains_1 = require("./popup/popup-ignored-domains");
const regexp_for_phone_numbers_1 = require("./regular-expressions/regexp-for-phone-numbers");
const regular_expressions_1 = require("./regular-expressions/regular-expressions");
const contactive_1 = require("./repository/contactive");
const credentials_1 = require("./repository/credentials");
const environment_1 = require("./repository/environment");
const meeting_1 = require("./repository/meeting");
const message_1 = require("./repository/message");
const preferredDevice_1 = require("./repository/preferredDevice");
const repository_1 = require("./repository/repository");
const resources_1 = require("./repository/resources");
const content_script_on_installed_manager_1 = require("./the-first-sign-in/content-script-on-installed-manager");
const tooltip_manager_1 = require("./tooltip-manager");
const logging_1 = require("./logging/logging");
const callerIdMasking_1 = require("./repository/callerIdMasking");
class ExtensionInitializer {
    constructor() {
        this.constants = require('./constants');
        this.config = require('./config');
        this.keys = require('./keys').keys;
        this.locales = require('./locales');
        this.calendarDomElementCharacteristics = require('./google-calendar-dom-element-characteristics');
        this.clickToCallIgnoredList = require('./click-to-call-ignored-list');
        this.googleLibphonenumber = require('./google-libphonenumber-dependency').googleLibphonenumber;
        this.messageHidingDelayTime = this.constants.timer.MESSAGE_HIDING_DELAY;
        this.messageHidingDurationTime = this.constants.timer.MESSAGE_HIDING_DURATION;
        this.minDelayTime = this.constants.timer.MIN_DELAY;
        this.signStatusNotificationDelay = this.constants.timer.SIGN_STATUS_NOTIFICATION_DELAY;
        this.regularExpressions = new regular_expressions_1.RegularExpressions();
        this.regexpManager = new regexp_for_phone_numbers_1.RegexpManager();
        this.signInNotificationView = require('./the-first-sign-in-notification.html');
        this.signInView = require('./sign-in-menu.html');
        this.signInIsPossiblelaterNotificationView = require('./the-sign-in-is-possible-being-later-notification.html');
        this.statusNotificationView = require('./status-notification.html');
        this.homeCountryView = require('./home-country-notification-manager.html');
        this.notificationExtensionView = require('./notification-manager.html');
        this.defaultCalendarDropdownTooltipView = require('./default-calendar-dropdown-tooltip.html');
        this.calendarDropdownTooltipForVanityView = require('./calendar-dropdown-tooltip-for-vanity.html');
        this.gcalTooltipTemplate = require('./gcal-tooltip-template.html');
        this.notificationView = require('./notification-manager.html');
        this.gmailIntegrationTooltipView = require('./gmail-integration-tooltip.html');
        this.gmailTooltipTemplate = require('./gmail-tooltip-template.html');
        this.environmentManager = new environment_manager_1.EnvironmentManager();
        this.apiLogic = new api_1.APILogic();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(this.apiLogic);
        this.meeting = new meeting_1.Meeting(this.apiLogic, this.extensionSettings);
        this.message = new message_1.Message();
        this.logging = logging_1.Logging.getInstance();
        this.repository = new repository_1.Repository(this.apiLogic, this.extensionSettings);
        this.domHelper = this.repository.domHelper;
        this.initialEnvironment = this.constants.environment.default;
        this.environment = new environment_1.Environment(this.extensionSettings);
        this.callerIdMasking = new callerIdMasking_1.CallerIdMasking({
            constants: this.constants,
            apiLogic: this.apiLogic,
            extensionSettings: this.extensionSettings,
            environment: this.environment,
            config: this.config,
            googleLibphonenumber: this.googleLibphonenumber,
        });
        this.localizationLanguageManager = new localization_language_manager_1.LocalizationLanguageManager({
            dataAttr: this.constants.localizationDataAttr,
            defaultLanguage: this.constants.defaultLanguage,
            getUILanguage: this.repository.getUILanguage,
            i18next,
            locales: this.locales,
        });
        this.messageManager = new message_manager_1.MessageManager({
            containerSelector: 'body',
            localizationLanguageManager: this.localizationLanguageManager,
            messageHidingDelayTime: this.messageHidingDelayTime,
            messageHidingDurationTime: this.messageHidingDurationTime,
            minDelayTime: this.minDelayTime,
        });
        this.loginPageManager = new login_page_manager_1.LoginPageManager({
            applicationToken: this.config.applicationToken,
            defaultEnvironment: this.constants.environment.default,
            loginRedirectUrl: this.config.loginRedirectUrl,
            wardenLogInPageUrl: this.config.wardenLogInPageUrl,
        });
        this.environmentSwitcherInitializer = new environment_switcher_initializer_1.EnvironmentInitializer({
            URLHelper: this.repository.URLHelper,
            changeCurrentPageUrl: (pageUrl) => {
                this.repository.windowRepository.changeCurrentPageUrl(pageUrl);
            },
            environmentManager: this.environmentManager,
            getLoginPageUrl: () => {
                return this.loginPageManager.getLoginPageUrl();
            },
        });
        this.URLHelper = this.repository.URLHelper;
        this.windowRepository = this.repository.windowRepository;
        this.validURLsForMeetingComponent = this.config.validURLsForMeetingComponent;
        this.resourcesRepository = new resources_1.Resources({
            clickToCallButton: this.constants.images.clickToCallButton,
        }, this.apiLogic);
        this.preferredDeviceHelper = new preferred_device_helper_1.PreferredDeviceHelper({
            localizationLanguageManager: this.localizationLanguageManager,
            preferredDeviceTypesList: this.constants.preferredDeviceTypesList,
        });
        this.detectExtensionConflict = new detect_extensions_conflict_1.DetectExtensionsConflict({
            localizationLanguageManager: this.localizationLanguageManager,
            currentPlatform: this.repository.currentPlatform,
            messageManager: this.messageManager,
            clickToCallEnablingStateManager: new click_to_call_enabling_state_1.ClickToCallEnablingStateManager({}, this.extensionSettings, this.message),
            notificationView: this.notificationView,
            resourcesRepository: this.resourcesRepository,
            NotificationManager: notification_manager_1.NotificationManager,
        }, this.extensionSettings, this.message);
        this.countryManager = new country_manager_1.CountryManager({
            localizationLanguageManager: this.localizationLanguageManager,
            defaultHomeCountryISO: this.constants.homeCountry.default,
        }, this.extensionSettings, new contactive_1.Contactive(this.apiLogic), this.message);
        this.isDisabledC2CFunction = () => {
            const fuzePluginC2CMetaTagSelector = 'meta[name=\'fuze-plugin-c2c\']';
            const metaElement = $(fuzePluginC2CMetaTagSelector);
            return metaElement && metaElement.length;
        };
        this.domainsManager = new popup_ignored_domains_1.PopupIgnoredDomains({
            browserActionRepository: this.repository.browserActionRepository,
            domHelper: this.domHelper,
            showCurrentMenu: () => {
            },
            openLinkInNewTab: () => {
            },
            TooltipManager: tooltip_manager_1.TooltipManager,
            URLHelper: this.URLHelper,
        }, this.message);
        this.localizationLanguageManager.initialize();
    }
    startExtension() {
        return __awaiter(this, void 0, void 0, function* () {
            const browserRepository = this.repository.browserRepository;
            const phoneNumberRegularExpression = this.regexpManager.generateRegex(this.constants.clickToCall.minimumPossiblePhoneNumberLength, this.constants.clickToCall.maximumPossiblePhoneNumberLength);
            const formSignInViewNotification = () => {
                const view = $(this.signInNotificationView).prepend(this.signInView);
                return view[0].outerHTML;
            };
            const flipAnimation = (uniqueNotificationClass) => {
                $(uniqueNotificationClass).addClass('fuze-for-browser-extension-flip-animation');
            };
            this.environmentSwitcherInitializer.initialize();
            this.contentScriptExtensionInstallationManager = new content_script_on_installed_manager_1.ContentScriptExtensionInstallationManager({
                getTheFirstInstallationStatus: () => {
                    return this.extensionSettings.getTheFirstInstallationStatus();
                },
                getIsUserLoggedIn: () => {
                    return this.extensionSettings.getIsUserLoggedIn();
                },
                extensionName: this.repository.extensionName,
                setTheFirstInstallationStatus: (isFirstInstallation) => {
                    return this.extensionSettings.setTheFirstInstallationStatus(isFirstInstallation);
                },
                destroy: () => {
                    this.contentScriptExtensionInstallationManager = null;
                },
                notification: new sign_in_notifications_manager_1.SignInStatusNotification({
                    localizationLanguageManager: this.localizationLanguageManager,
                    doesExistCloseButton: true,
                    doesExistConfirmButton: true,
                    currentPlatform: this.repository.currentPlatform,
                    notificationView: formSignInViewNotification(),
                    TooltipManager: tooltip_manager_1.TooltipManager,
                    resourcesRepository: this.resourcesRepository,
                    applyDisplayEffects: flipAnimation,
                    onCloseHandler: () => {
                        let signInIsPossiblelaterNotificationManager = new sign_in_notifications_manager_1.SignInStatusNotification({
                            localizationLanguageManager: this.localizationLanguageManager,
                            doesExistCloseButton: true,
                            doesExistConfirmButton: false,
                            iconPath: '/images/notifications/sign-in-is-possible-be-late.png',
                            notificationView: this.signInIsPossiblelaterNotificationView,
                            resourcesRepository: this.resourcesRepository,
                            onConfirmHandler: () => {
                                signInIsPossiblelaterNotificationManager.hide();
                                this.contentScriptExtensionInstallationManager = null;
                                signInIsPossiblelaterNotificationManager = null;
                            },
                            uniqueNotificationClass: '.fuze-for-browser-extension__sign-in-is-possible-be-later',
                            signStatusNotificationDelay: this.signStatusNotificationDelay,
                            applyDisplayEffects: flipAnimation,
                        });
                        signInIsPossiblelaterNotificationManager.show();
                    },
                    onConfirmHandler: () => {
                        this.message.sendMessageToBackground({ action: 'openLoginPage' });
                        this.contentScriptExtensionInstallationManager = null;
                    },
                    uniqueNotificationClass: '.fuze-for-browser-extension-sign-in-menu',
                }),
            }, this.message);
            const signedStatusNotification = new signed_status_notification_1.SignedStatusNotification({
                localizationLanguageManager: this.localizationLanguageManager,
                SignInStatusNotification: sign_in_notifications_manager_1.SignInStatusNotification,
                currentPlatform: this.repository.currentPlatform,
                notificationView: this.statusNotificationView,
                resourcesRepository: this.resourcesRepository,
                signStatusNotificationDelay: this.signStatusNotificationDelay,
            }, this.extensionSettings, this.message);
            this.homeCountryNotificationManager = new home_country_notification_manager_1.HomeCountryNotificationManager({
                localizationLanguageManager: this.localizationLanguageManager,
                arrowImagePath: this.constants.images.arrowImagePath,
                activeArrowImagePath: this.constants.images.activeArrowImagePath,
                defaultHomeCountryISO: this.constants.homeCountry.default,
                countryManager: this.countryManager,
                notificationView: this.homeCountryView,
                resourcesRepository: this.resourcesRepository,
                DropdownManager: dropdown_manager_1.DropdownManager,
            }, this.extensionSettings, this.message);
            const expiredSessionNotification = new notification_manager_1.NotificationManager({
                localizationLanguageManager: this.localizationLanguageManager,
                notificationView: this.notificationExtensionView,
                resourcesRepository: this.resourcesRepository,
                onConfirmHandler: () => {
                    this.message.sendMessageToBackground({ action: 'openLoginPage' });
                },
                confirmButtonTextKey: 'FUZELOC_welcome_signIn',
                notificationTitleKey: 'FUZELOC_notification_sessionExpired',
                notificationDescriptionKey: 'FUZELOC_notification_sessionExpiredInfo',
                onCloseHandler: () => {
                },
                doesExistConfirmButton: true,
                doesExistCancelButton: true,
                uniqueNotificationClass: 'fuze-for-browser-extension-expired-seession-notification-wrapper',
            });
            const unresponsivePageNotification = new notification_manager_1.NotificationManager({
                localizationLanguageManager: this.localizationLanguageManager,
                notificationView: this.notificationExtensionView,
                resourcesRepository: this.resourcesRepository,
                onConfirmHandler: () => {
                    this.message.sendMessageToBackground({ action: 'addDomainToIgnoreList' });
                },
                confirmButtonTextKey: 'FUZELOC_generic_disableFuze',
                notificationTitleKey: 'FUZELOC_notification_disableFuzeOnPage',
                notificationDescriptionKey: 'FUZELOC_notification_disableFuzeInfo',
                doesExistConfirmButton: true,
                doesExistCancelButton: true,
                uniqueNotificationClass: 'fuze-for-browser-extension-unresponsive-page-notification-wrapper',
            });
            this.detectExtensionConflict.activePageInitializer();
            const currentEnvironment = yield this.initializeAndGetCurrentEnvironment();
            const preferredDevice = new preferredDevice_1.PreferredDevice(this.apiLogic, this.extensionSettings);
            const extension = new click_to_call_manager_1.ClickToCallManager({
                MutationObserverBase: mutation_observer_base_1.MutationObserverBase,
                homeCountryNotificationManager: this.homeCountryNotificationManager,
                localizationLanguageManager: this.localizationLanguageManager,
                credentialsRepository: new credentials_1.Credentials('Bearer ' + this.config.applicationToken[currentEnvironment], this.config.wardenRestServiceUrl[currentEnvironment], this.apiLogic),
                browserManager: this.repository.browserRepository,
                extensionName: this.repository.extensionName,
                getCallRestURL: () => {
                    return this.getApiEndpoint('callRestURL');
                },
                diallingModal: new dialling_modal_1.DiallingModal({
                    localizationLanguageManager: this.localizationLanguageManager,
                    domHelper: this.domHelper,
                    MessageManager: message_manager_1.MessageManager,
                    messageHidingDelayTime: this.messageHidingDelayTime,
                    messageHidingDurationTime: this.messageHidingDurationTime,
                    minDelayTime: this.minDelayTime,
                    timerRepository: this.repository.timerRepository,
                    resourcesRepository: this.resourcesRepository,
                    dialingDialogTimeout: 4000,
                    preferreDeviceTypeForOthers: this.constants.preferredDeviceTypesList.other,
                }, this.message),
                domainsManager: this.domainsManager,
                disabledDomains: this.constants.disabledDomains,
                getOldCredentials: this.repository.getOldCredentials,
                isChrome: browserRepository.isChrome(),
                messageManager: this.messageManager,
                PhoneNumberParseAndEmailObserver: phone_number_parse_and_email_observer_1.PhoneNumberParseAndEmailObserver,
                PhoneNumberParsingManager: phone_number_parsing_manager_1.PhoneNumberParsingManager,
                googleLibphonenumber: this.googleLibphonenumber,
                phoneNumberRegularExpression,
                timerRepository: this.repository.timerRepository,
                resourcesRepository: this.resourcesRepository,
                OldChromeCredentialsManager: old_chrome_credentials_manager_1.OldChromeCredentialsManager,
                TooltipManager: tooltip_manager_1.TooltipManager,
                URLHelper: this.URLHelper,
                windowRepository: this.windowRepository,
                dateFinderInPhoneNumberHelper: new date_finder_in_phone_number_helper_1.DateFinderInPhoneNumberHelper({
                    dateRegexList: this.regularExpressions.dateRegexList,
                    phoneNumberRE: phoneNumberRegularExpression,
                }),
                minimumPossiblePhoneNumberLength: this.constants.clickToCall.minimumPossiblePhoneNumberLength,
                unresponsivePageNotification,
                maxCharacterCountForParsing: this.constants.maxCharacterCountForParsing,
                preferredDeviceHelper: this.preferredDeviceHelper,
                clickToCallIgnoredList: this.clickToCallIgnoredList.selectors,
                keys: this.keys,
                calendarDomElementCharacteristics: this.calendarDomElementCharacteristics,
                gmailIntegrationTooltipView: this.gmailIntegrationTooltipView,
                gmailTooltipTemplate: this.gmailTooltipTemplate,
                checkIframeRestriction: this.checkIframeRestriction.bind(this),
            }, this.apiLogic, this.extensionSettings, preferredDevice, this.message, this.callerIdMasking);
            this.sendMessageToBackgroundIfTheCurrentPageIsFinalLoginPage();
            for (let i = 0; i < this.validURLsForMeetingComponent.length; i++) {
                if (this.URLHelper.isSubdomainOfTheDomain(this.URLHelper.getDomainPartOfURL(this.windowRepository.getCurrentURL()), this.validURLsForMeetingComponent[i])) {
                    const actionOnMeetingsManager = new action_on_meetings_manager_1.ActionOnMeetingsManager(this.apiLogic, this.meeting);
                    const meetingDetailsManager = new meeting_details_manager_1.MeetingDetailsManager({
                        calendarDomElementCharacteristics: this.calendarDomElementCharacteristics,
                        createdViaGoogleCalProperty: this.constants.createdViaGoogleCalProperty,
                        meetingTimeParsingManager: new meeting_time_parsing_manager_1.MeetingTimeParsingManager({
                            dateHelper: new date_helper_1.DateHelper(),
                            allDayEventStartTime: this.constants.allDayEventTime.allDayEventStartTime,
                            allDayEventEndTime: this.constants.allDayEventTime.allDayEventEndTime,
                        }),
                    });
                    const visibilityMeetingsManager = new visibility_meetings_manager_1.VisibilityMeetingsManager({
                        localizationLanguageManager: this.localizationLanguageManager,
                        actionOnMeetingsManager,
                        expiredSessionNotification,
                        GoogleCalendarTooltipsManager: google_calendar_tooltips_manager_1.GoogleCalendarTooltipsManager,
                        meetingDetailsManager,
                        LaunchMeetingButton: launch_meeting_button_1.LaunchMeetingButton,
                        CalendarObserver: calendar_observer_1.CalendarObserver,
                        createdViaGoogleCalProperty: this.constants.createdViaGoogleCalProperty,
                        launchMeetingUrlMap: new launch_meeting_url_map_manager_1.LaunchMeetingUrlMapManager(actionOnMeetingsManager, this.apiLogic, this.extensionSettings),
                        MutationObserverBase: mutation_observer_base_1.MutationObserverBase,
                        resourcesRepository: this.resourcesRepository,
                        windowRepository: this.windowRepository,
                        calendarDomElementCharacteristics: this.calendarDomElementCharacteristics,
                        SimulateUserChangesHelper: simulate_user_changes_helper_1.SimulateUserChangesHelper,
                        CalendarComponentManager: calendar_component_manager_1.CalendarComponentManager,
                        defaultCalendarDropdownTooltipView: this.defaultCalendarDropdownTooltipView,
                        calendarDropdownTooltipForVanityView: this.calendarDropdownTooltipForVanityView,
                        gcalTooltipTemplate: this.gcalTooltipTemplate,
                    }, this.apiLogic, this.extensionSettings, this.message, this.localizationLanguageManager);
                    visibilityMeetingsManager.initialize();
                }
            }
            if (!this.isDisabledC2CFunction() || !this.URLHelper.isFuzeAppDomain() || !this.URLHelper.isTeamsIntegrationsAppDomain()) {
                extension.initialize();
            }
        });
    }
    getEntitlementForExtension() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (!(yield this.extensionSettings.getUserNameFromLocalDatabase())) {
                    return { entitlementForMeeting: false };
                }
                let entitlementForMeeting = yield this.extensionSettings.getEntitlementForMeetingFromStorage();
                if (typeof entitlementForMeeting !== 'undefined') {
                    entitlementForMeeting = (entitlementForMeeting.toString() === 'true');
                    return { entitlementForMeeting };
                }
                else {
                    this.message.sendMessageToBackground({ action: 'getEntitlementForClickToCall' });
                    return { entitlementForMeeting: false };
                }
            }
            catch (e) {
                Promise.reject(e);
            }
        });
    }
    initialize(settings) {
        if (!this.windowRepository.get('tpn_thinkingconnector_installed')) {
            if (document.readyState !== 'complete') {
                this.windowRepository.addEventListener('load', settings.startExtension);
                this.windowRepository.addEventListener('unload', settings.startExtension, false);
            }
            else {
                settings.startExtension();
            }
            this.windowRepository.set('tpn_thinkingconnector_installed', 'complete');
        }
        if (!this.checkIframeRestriction()) {
            this.injectStylesheetIntoTheDocument(this.domHelper);
        }
        this.message.sendMessageToBackground({ action: 'activeTabUrlRequest' });
        this.addMessageListenerOnLocalizationLanguageChange();
    }
    checkIframeRestriction() {
        // This is a check for script running in iframe, due to the fact that each iframe is handled as page we can't skip
        // script execution without affecting top-level c2c
        if (this.domainsManager.isDomainRestrictedForIframeParsing(this.getCurrentDomain())) {
            return iframe_helper_1.isIframeRuntime();
        }
        return false;
    }
    getCurrentDomain() {
        return this.URLHelper.getDomainPartOfURL(window.location.href);
    }
    injectStylesheetIntoTheDocument(domHelper) {
        document.addEventListener('DOMContentLoaded', () => {
            domHelper.injectStylesheetIntoTheDocument('styles/roboto.css', 'fuze__fonts-for-external-page');
            domHelper.injectStylesheetIntoTheDocument('styles/styles.css', 'fuze__stylesheet-for-external-page');
        });
    }
    initializeAndGetCurrentEnvironment() {
        return this.environment.initialize(this.initialEnvironment);
    }
    getApiEndpoint(parameter) {
        return (new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            try {
                const currentEnvironment = yield this.environment.get();
                const apiEndpointURL = this.config[parameter][currentEnvironment];
                resolve(apiEndpointURL);
            }
            catch (error) {
                this.logging.showErrorLog(`Error in loading ${parameter}`, error);
            }
        })));
    }
    sendMessageToBackgroundIfTheCurrentPageIsFinalLoginPage() {
        return __awaiter(this, void 0, void 0, function* () {
            let currentFinalLoginPageUrl = '';
            const currentEnvironment = yield this.environment.get();
            const isTheCurrentPageIsFinalLoginPage = (listOfPossibleOptionsForTheFinalLoginUrl) => {
                let isFinalLoginPageUrl = false;
                for (let i = 0; i < listOfPossibleOptionsForTheFinalLoginUrl.length; i++) {
                    const finalLoginPageUrl = listOfPossibleOptionsForTheFinalLoginUrl[i];
                    const regExpBasedOnFinalLoginPageUrl = new RegExp(finalLoginPageUrl);
                    isFinalLoginPageUrl = regExpBasedOnFinalLoginPageUrl.test(this.windowRepository.getCurrentURL());
                    if (isFinalLoginPageUrl) {
                        currentFinalLoginPageUrl = finalLoginPageUrl;
                        return isFinalLoginPageUrl;
                    }
                }
                return isFinalLoginPageUrl;
            };
            const sendFinalPageLoadedStatusWithPage = () => {
                this.message.sendMessageToBackground({
                    action: 'finalLoginPageLoaded',
                    currentFinalLoginPageUrl,
                });
            };
            if (isTheCurrentPageIsFinalLoginPage(this.config.listOfPossibleOptionsForTheFinalLoginUrl[currentEnvironment])) {
                sendFinalPageLoadedStatusWithPage();
            }
        });
    }
    addMessageListenerOnLocalizationLanguageChange() {
        this.message.addMessageListener((message) => {
            switch (message.action) {
                case 'localizationLanguageChanged':
                    this.localizationLanguageManager.reinitialize();
                    this.message.sendMessageToPopup({ action: 'localizationLanguageChanged' });
                    break;
                default:
                    break;
            }
        });
    }
}
exports.default = ExtensionInitializer;

},{"./api":61,"./authorisation/login-page-manager":62,"./calendar-dropdown-tooltip-for-vanity.html":63,"./click-to-call-ignored-list":64,"./click-to-call/click-to-call-manager":65,"./click-to-call/phone-number-parse-and-email-observer":66,"./click-to-call/phone-number-parsing-manager":67,"./config":69,"./constants":70,"./country-manager":72,"./default-calendar-dropdown-tooltip.html":73,"./detect-extensions-conflict":74,"./dialling-modal":75,"./dropdown-manager":76,"./enable-manager/click-to-call-enabling-state":77,"./environment-manager":78,"./environment-switcher-initializer":79,"./gcal-tooltip-template.html":83,"./gmail-integration-tooltip.html":85,"./gmail-tooltip-template.html":87,"./google-calendar-dom-element-characteristics":88,"./google-libphonenumber-dependency":89,"./helpers/date-finder-in-phone-number-helper":90,"./helpers/date-helper":91,"./helpers/iframe-helper":94,"./helpers/preferred-device-helper":97,"./helpers/simulate-user-changes-helper":99,"./home-country-notification-manager.html":101,"./keys":102,"./locales":103,"./localization-language-manager":104,"./logging/logging":108,"./meeting/action-on-meetings-manager":109,"./meeting/calendar-component-manager":110,"./meeting/calendar-observer":111,"./meeting/google-calendar-tooltips-manager":112,"./meeting/launch-meeting-button":113,"./meeting/launch-meeting-url-map-manager":114,"./meeting/meeting-details-manager":115,"./meeting/meeting-time-parsing-manager":116,"./meeting/visibility-meetings-manager":118,"./message-manager":119,"./mutation-observer-base":122,"./notification-manager.html":123,"./notifications/home-country-notification-manager":124,"./notifications/notification-manager":125,"./notifications/sign-in-notifications-manager":126,"./notifications/signed-status-notification":127,"./old-chrome-credentials-manager":128,"./popup/popup-ignored-domains":129,"./regular-expressions/regexp-for-phone-numbers":130,"./regular-expressions/regular-expressions":131,"./repository/callerIdMasking":132,"./repository/contactive":133,"./repository/credentials":134,"./repository/environment":135,"./repository/extensionSettings":136,"./repository/meeting":137,"./repository/message":138,"./repository/preferredDevice":139,"./repository/repository":141,"./repository/resources":142,"./sign-in-menu.html":143,"./status-notification.html":144,"./the-first-sign-in-notification.html":146,"./the-first-sign-in/content-script-on-installed-manager":147,"./the-sign-in-is-possible-being-later-notification.html":148,"./tooltip-manager":149,"i18next":47}],81:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const extension_initializer_class_1 = require("./extension-initializer-class");
const teams_observer_1 = require("./meeting/teams-observer");
(function () {
    const extensionInitializer = new extension_initializer_class_1.default();
    const teamsObserver = new teams_observer_1.TeamsObserver();
    function startExtension() {
        const isBodyHasContent = $('body').html();
        // to prevent the issue when the script was injected twice on the Calendar edit page in Firefox
        if (isBodyHasContent) {
            extensionInitializer.startExtension();
        }
    }
    extensionInitializer.initialize({
        startExtension: () => {
            startExtension();
        },
        getEntitlementForExtension: (callback) => {
            extensionInitializer.getEntitlementForExtension().then(callback);
        },
    });
    window.addEventListener('load', function () {
        teamsObserver.startMutationObserver();
    });
})();

},{"./extension-initializer-class":80,"./meeting/teams-observer":117}],82:[function(require,module,exports){
'use strict';
module.exports = '<div class="modal-gray-zone"></div>\n\n<div class="first-time-join-meeting-modal__container">\n  <div class="first-time-join-meeting-modal__close-button-container">\n    <button class="first-time-join-meeting-modal__button first-time-join-meeting-modal__close-button"></button>\n  </div>\n\n  <h2 class="first-time-join-meeting-modal__heading" data-i18next="FUZELOC_modal_joinMeetings_title">\n    Join your Fuze meeting using…\n  </h2>\n\n  <div class="first-time-join-meeting-modal__option" data-joinOption="Fuze Desktop">\n    <img class="join-desktop-logo" width="80" height="80" alt="Join Fuze Desktop">\n    <div class="first-time-join-meeting-modal__option-info">\n      <h3 class="first-time-join-meeting-modal__option-info-title">Fuze Desktop</h3>\n      <p class="first-time-join-meeting-modal__option-info-description"\n         data-i18next="FUZELOC_modal_joinMeetings_desktop_description">\n        Join your meeting in the Fuze Desktop app.\n      </p>\n    </div>\n  </div>\n  <div class="first-time-join-meeting-modal__option" data-joinOption="Fuze Web">\n    <img class="join-web-logo" width="80" height="80" alt="Join Fuze Web">\n    <div class="first-time-join-meeting-modal__option-info">\n      <h3 class="first-time-join-meeting-modal__option-info-title">Fuze Web</h3>\n      <p class="first-time-join-meeting-modal__option-info-description"\n         data-i18next="FUZELOC_modal_joinMeetings_web_description">\n        Join your meeting in your browser with Fuze Web.\n      </p>\n    </div>\n  </div>\n\n  <p class="first-time-join-meeting-modal__hint" data-i18next="FUZELOC_modal_joinMeetings_changeHint">\n    You can change this later under “settings” in the Fuze extension\n  </p>\n\n  <button class="first-time-join-meeting-modal__button first-time-join-meeting-modal__join-meeting-button"\n          data-i18next="FUZELOC_generic_joinFuzeMeeting">\n    Join fuze meeting\n  </button>\n</div>';

},{}],83:[function(require,module,exports){
'use strict';
module.exports = '<div class="tooltip fuze-gcal-tooltip" role="tooltip">\n  <div class="tooltip-arrow"></div>\n  <div class="tooltip-inner"></div>\n</div>\n';

},{}],84:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getExtensionName = void 0;
function getExtensionName(settings) {
    return settings.defaultExtensionName;
}
exports.getExtensionName = getExtensionName;

},{}],85:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-contacts-gmail-tooltip__container">\n  <div class="fuze-contacts-gmail-tooltip__contacts-view fuze-contacts-gmail-tooltip__contacts-view_hidden">\n    <header class="fuze-contacts-gmail-tooltip__header">\n      <img class="fuze-contacts-gmail-tooltip__header-logo"\n           src=""\n           alt="fuze logo with text"\n           width="86"\n           height="25">\n    </header>\n\n    <section class="fuze-contacts-gmail-tooltip__no-contacts-view fuze-contacts-gmail-tooltip__no-contacts-view_hidden">\n      <img src="" alt="No contacts image" class="fuze-contacts-gmail-tooltip__no-contacts-view-image">\n\n      <p class="fuze-contacts-gmail-tooltip__no-contacts-label">There are no Fuze contacts in this email</p>\n    </section>\n\n    <section class="fuze-contacts-gmail-tooltip__contacts-exist fuze-contacts-gmail-tooltip__contacts-exist_hidden">\n      <p class="fuze-contacts-gmail-tooltip__contact-list-label">Contacts in this email</p>\n\n      <ul class="fuze-contacts-gmail-tooltip__contact-list">\n        <li class="fuze-contacts-gmail-tooltip__contact fuze-contacts-gmail-tooltip__contact_template">\n          <div class="fuze-contacts-gmail-tooltip__contact-picture"></div>\n\n          <span class="fuze-contacts-gmail-tooltip__contact-name">\n          Name\n        </span>\n\n          <button class="fuze-contacts-gmail-tooltip__contact-button">\n            <img class="fuze-contacts-gmail-tooltip__c2c-button-image" src="" alt="phone icon">\n          </button>\n        </li>\n      </ul>\n    </section>\n  </div>\n\n  <div class="fuze-contacts-gmail-tooltip__tooltip-loading">\n    <img src="" alt="Fuze loading gif" class="fuze-contacts-gmail-tooltip__tooltip-loading-gif">\n\n    <span class="fuze-contacts-gmail-tooltip__tooltip-loading-text">Loading Fuze</span>\n  </div>\n</div>\n';

},{}],86:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GmailTooltipManager = void 0;
const contactive_1 = require("../repository/contactive");
const extensionSettings_1 = require("../repository/extensionSettings");
const logging_1 = require("../logging/logging");
class GmailTooltipManager {
    constructor(APILogic, clickToCallManager, resourcesRepository) {
        this.APILogic = APILogic;
        this.clickToCallManager = clickToCallManager;
        this.resourcesRepository = resourcesRepository;
        this.mainTooltipClass = 'fuze-contacts-gmail-tooltip';
        this.contactsStatusAttribute = 'are-contacts-ready';
        this.contactsDataAttribute = 'contacts-data';
        this.contactsIdentifierAttribute = 'contacts-data-identifier';
        this.logging = logging_1.Logging.getInstance();
        this.contactive = new contactive_1.Contactive(APILogic);
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(APILogic);
    }
    performEmailCheckFromGmailTooltip(userEmails) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const rawUsersInfo = yield this.contactive.getContactiveDirectoryInfoByEmail(userEmails);
                return rawUsersInfo.map(user => {
                    if (!user.origins || !user.origins[0]) {
                        return;
                    }
                    let phone = null;
                    let name = null;
                    let pictureUrl = null;
                    user.origins.forEach((origin) => {
                        if (origin.origins[0] && origin.origins[0].originName === 'tpn') {
                            if (origin.phone.length > 0) {
                                phone = origin.phone[0].original;
                                name = `${origin.name.firstName} ${origin.name.lastName}`;
                                if (origin.picture[0]) {
                                    pictureUrl = origin.picture[0].smallUrl;
                                }
                            }
                        }
                    });
                    return { phone, name, pictureUrl } || null;
                });
            }
            catch (error) {
                this.logging.showErrorLog('Failed to check email for Fuze Contacts', error);
            }
        });
    }
    placeCall(userPhone) {
        return __awaiter(this, void 0, void 0, function* () {
            this.logging.showInfoLog('Starting call from Fuze Contacts card');
            yield this.clickToCallManager.placeCall(userPhone, null);
        });
    }
    injectImagesToTheHTML(view) {
        const domparser = new DOMParser();
        const tooltipDocument = domparser.parseFromString(view, 'text/html');
        const gmailTooltipHeaderLogo = tooltipDocument.querySelector(`.${this.mainTooltipClass}__header-logo`);
        gmailTooltipHeaderLogo.src = this.resourcesRepository.getExtensionFilePath(this.APILogic.constants.images.logoWithTextImage);
        const gmailTooltipLoadingGif = tooltipDocument.querySelector(`.${this.mainTooltipClass}__tooltip-loading-gif`);
        gmailTooltipLoadingGif.src = this.resourcesRepository.getExtensionFilePath(this.APILogic.constants.images.fuzeLoadingGif);
        const gmailTooltipC2CButtonImage = tooltipDocument.querySelector(`.${this.mainTooltipClass}__c2c-button-image`);
        gmailTooltipC2CButtonImage.src = this.resourcesRepository.getExtensionFilePath(this.APILogic.constants.images.gmailC2CButtonImage);
        const gmailTooltipNoContactsImage = tooltipDocument.querySelector(`.${this.mainTooltipClass}__no-contacts-view-image`);
        gmailTooltipNoContactsImage.src = this.resourcesRepository.getExtensionFilePath(this.APILogic.constants.images.noContactsImage);
        return tooltipDocument.querySelector(`.${this.mainTooltipClass}__container`);
    }
    startEmailParsing(emailSelectorPreviewMode, emailBodySelector, userEmailElementSelector, btnSelector) {
        return __awaiter(this, void 0, void 0, function* () {
            const emailBody = document.querySelector(emailSelectorPreviewMode) || document.querySelector(emailBodySelector);
            if (!emailBody) {
                return;
            }
            const emailElements = emailBody.querySelectorAll(userEmailElementSelector);
            if (!emailElements || emailElements.length <= 0) {
                return;
            }
            let parsedEmails = [];
            emailElements.forEach((emailElement) => parsedEmails.push(emailElement.getAttribute('email')));
            parsedEmails = yield this.filterOutUserEmail(parsedEmails);
            const uniqueEmails = new Set(parsedEmails);
            let emailsForLogging = [];
            uniqueEmails.forEach((email) => emailsForLogging.push(email));
            this.logging.showInfoLog('Parsed emails for Fuze Contacts', emailsForLogging);
            const contacts = yield this.performEmailCheckFromGmailTooltip([...uniqueEmails]);
            const tooltipBtn = document.querySelector(`.${btnSelector}`);
            if (!tooltipBtn) {
                return;
            }
            const dataIdentifier = tooltipBtn.getAttribute(this.contactsIdentifierAttribute);
            if (dataIdentifier !== this.currentIdentifier.toString()) {
                return;
            }
            const filteredContacts = contacts.filter((contact) => {
                if (contact && contact.phone) {
                    return contact;
                }
            });
            tooltipBtn.setAttribute(this.contactsStatusAttribute, 'true');
            tooltipBtn.setAttribute(this.contactsDataAttribute, JSON.stringify(filteredContacts));
        });
    }
    initializeContactsList(tooltipBtn, tooltipBody) {
        const contactsData = JSON.parse(tooltipBtn.getAttribute(this.contactsDataAttribute));
        this.logging.showInfoLog('Formed Fuze Contacts data for Tooltip', contactsData);
        const loadingScreen = tooltipBody.querySelector(`.${this.mainTooltipClass}__tooltip-loading`);
        loadingScreen.classList.add(`${this.mainTooltipClass}__tooltip-loading_hidden`);
        const contactsView = tooltipBody.querySelector(`.${this.mainTooltipClass}__contacts-view`);
        contactsView.classList.remove(`${this.mainTooltipClass}__contacts-view_hidden`);
        if (!contactsData || contactsData.length <= 0) {
            const noContactsView = tooltipBody.querySelector(`.${this.mainTooltipClass}__no-contacts-view`);
            return noContactsView.classList.remove(`${this.mainTooltipClass}__no-contacts-view_hidden`);
        }
        const contactsExistView = tooltipBody.querySelector(`.${this.mainTooltipClass}__contacts-exist`);
        contactsExistView.classList.remove(`${this.mainTooltipClass}__contacts-exist_hidden`);
        const templateContactClass = `${this.mainTooltipClass}__contact_template`;
        const templateContactElement = contactsView.querySelector(`.${templateContactClass}`);
        const contactList = tooltipBody.querySelector(`.${this.mainTooltipClass}__contact-list`);
        if (!templateContactElement) {
            return;
        }
        contactsData.sort((firstContact, secondContact) => {
            if (firstContact.name > secondContact.name) {
                return 1;
            }
            if (firstContact.name < secondContact.name) {
                return -1;
            }
            return 0;
        });
        contactsData.forEach((contact) => {
            let newContactNode = templateContactElement.cloneNode(true);
            contactList.appendChild(newContactNode);
            let newContactElement = contactList.lastElementChild;
            newContactElement.classList.remove(templateContactClass);
            const contactNameElement = newContactElement.querySelector(`.${this.mainTooltipClass}__contact-name`);
            contactNameElement.innerText = contact.name;
            const contactPictureElement = newContactElement.querySelector(`.${this.mainTooltipClass}__contact-picture`);
            if (contact.pictureUrl) {
                contactPictureElement.style.backgroundImage = `url("${contact.pictureUrl}")`;
            }
            else {
                contactPictureElement.style.backgroundImage = `url("${this.resourcesRepository.getExtensionFilePath(this.APILogic.constants.images.defaultAvatar)}")`;
            }
            const contactC2CButton = newContactElement.querySelector(`.${this.mainTooltipClass}__contact-button`);
            contactC2CButton.addEventListener('click', () => {
                return this.placeCall(contact.phone);
            });
            this.clickToCallManager.initializeTooltip(contactC2CButton);
        });
    }
    filterOutUserEmail(emails) {
        return __awaiter(this, void 0, void 0, function* () {
            const userEmail = yield this.extensionSettings.getUserEmail();
            if (!userEmail) {
                return emails;
            }
            return emails.filter((email) => email !== userEmail);
        });
    }
}
exports.GmailTooltipManager = GmailTooltipManager;

},{"../logging/logging":108,"../repository/contactive":133,"../repository/extensionSettings":136}],87:[function(require,module,exports){
'use strict';
module.exports = '<div class="tooltip fuze-contacts-gmail-tooltip" role="tooltip">\n  <div class="tooltip-inner"></div>\n  <div class="tooltip-arrow fuze-gcal-tooltip-arrow"></div>\n</div>\n';

},{}],88:[function(require,module,exports){
module.exports={
  "tooltipMoreOptionButton": "div[jsname='rhPddf']",
  "tooltipIdentificationElementSelector": "#tabEvent",
  "tooltipSelector": "[data-loggingid]",
  "popupButtonsBar": ".BTotkb",
  "popupTablist": ".mrslJ[role='tablist']",
  "popupCreateFuzeMeetingBtn": "fuze-for-browser-extension--meeting-button",
  "locationTooltipSelector": "#xDetDlgLoc",
  "locationEventFormSelector": "#xLocIn input[role=combobox]",
  "descriptionRowSelector": "#tabEventDetails > :last-child",
  "tableInfoSelector": "#tabEventDetails",
  "locationSelector": "#xLocIn input[role=combobox]",
  "descriptionTextSelector": "#xDescIn [jsaction]",
  "firstRowInTableSelector": "div:first",
  "joinFuzeMeetingRowClass": "fuze-for-browser-extension-join-meeting-row",
  "joinFuzeMeetingRowClassSidebarFlexColumn": "fuze-for-browser-extension-join-meeting-row_column",
  "descriptionSelector": "#xDesc",
  "locationEventFormForAttendeeSelector": "#xOnCal",
  "startDateSelector": "#xStDaIn",
  "endDateSelector": "#xEnDaIn",
  "startTimeSelector": "#xStTiIn",
  "endTimeSelector": "#xEnTiIn",
  "eventFormIdentificationElementSelector": "#xOrgEmail",
  "externalIdAttr": "jslog",
  "subjectSelector": "#xTiIn",
  "fuzeLaunchLinkSelector": "[id$=fuze-for-browser-extension-launch-meeting]",
  "allDayEventParameterSelector": "#xAlDaCbx",
  "meetingLinkForAttendeeSelector": "#xOnCal",
  "parentMeetingLinkSelector": "#xLocIn",
  "meetingLinkSelector": "input",
  "controlSelectors": "div[role='button'], div[role='listbox'], input",
  "htmlEditorToolboxButtonSelector": "[data-tooltip]",
  "backToCalendarButtonSelector": "#xCancelBu",
  "buttonsToReplace": [
    "xCancelBu",
    "xSaveBu"
  ],
  "joinFuzeWrapperSelector": ".fuze-for-browser-extension-link-button",
  "endPartOfIdButtonName": "Bu",
  "periodContainerSelector": "rSoRzd",
  //class of the element that contains the displayed period of time on the google calendar
  "availableWhereElementSelector": ".JClzi",
  //selector of the element that contains the link to the created fuze meeting on the google calendar
  "timeZoneSelector": "#xTmZn",
  "eventOrganaizerSelector": "#xDtlDlgOrg",
  "googleCalendarUserEmailSelector": "#xUserEmail",
  "addConferencingSelector": "#xAddRtcSel",
  "dropdownSelectedValueSelector": " div[aria-selected='true']",
  "fuzeAdditionalSettingsId": "fuze-for-browser-extension-additional-settings",
  "fuzeDropdownId": "fuze-for-browser-extension-custom-dropdown",
  "dropdownLabelClass": "fuze-for-browser-extension-label-dropdown",
  "meetingTooltipClass": "fuze-for-browser-extension-meeting-tooltip",
  "tooltipTextSelector": "#BZ9OCc",
  "tooltipSignSelector": "#xBusySel > :nth-child(3)",
  "tooltipInfoSelector": "#egeNub",
  "dropdownSelector": "#xNtList > :first-child",
  "listboxSelector": "#xBusySel > :first-child",
  "separatorSelector": "[role='separator']",
  "checkboxSelector": "#xAlDaCbx",
  "fuzeCreateMeetingButtonId": "fuze-for-browser-extension-create",
  "checkboxClass": "fuze-for-browser-extension-calendar-checkbox",
  "busySpinnerClass": "fuze-for-browser-extension-busy-spinner",
  "addFuzeMeetingButtonClass": "fuze-for-browser-extension-add-fuze-meeting",
  "gmailSidebarSelector": "[data-2]",
  "calendarEventEditUrl": "^https://(www|calendar).google.com/calendar/(([a-z])/(\\d)/r/eventedit|r/eventedit)",
  "gmailInboxUrl": "mail.google.com/mail",
  "gmailMainLetterContainerSelector": "div[role=\"main\"]",
  "gmailMainLetterContainerSelectorPreviewMode": "div.adn.ads",
  "gmailSidebarIFrameSelector": "body#yDmH0d",
  "gmailReplyButtonSelector": ".amn .ams",
  "gmailFuzeContactsButtonClass": "fuze-contacts-gmail-button",
  "fuzeVanityTooltipSelector": "#fuzeVanityTooltip",
  "gmailUserEmailElementSelector": "span[email]",
  "gmailSideBarFooterClass": "footer.cehZCe",
  "gmailSideBarJavascriptDiv": "div[aria-label='Edit in Calendar'][role='button']"
}

},{}],89:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.googleLibphonenumber = void 0;
let googleLibphonenumber = window["googleLibphonenumber"];
exports.googleLibphonenumber = googleLibphonenumber;

},{}],90:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateFinderInPhoneNumberHelper = void 0;
class DateFinderInPhoneNumberHelper {
    constructor(settings) {
        this.settings = settings;
        this.currentDateRegex = '';
        this.date = '';
    }
    getPhoneNumberWithoutDate(remaining, possiblePhoneNumber) {
        const isStartDatePositionInsidePossiblePhoneNumber = this.isStartDatePositionInsidePhoneNumber(remaining, possiblePhoneNumber.length);
        if (isStartDatePositionInsidePossiblePhoneNumber) {
            const possiblePhoneNumberWithoutDate = remaining.substring(0, this.date.index - 1);
            return possiblePhoneNumberWithoutDate;
        }
        return possiblePhoneNumber;
    }
    isPhoneNumberContainedDateInRemaining(text) {
        let isDateFound = false;
        let firstDateIndexInTheText = text.length;
        for (let i = 0; i < this.settings.dateRegexList.length; i++) {
            this.date = this.settings.dateRegexList[i].exec(text);
            if (this.date && (this.date.index < firstDateIndexInTheText)) {
                firstDateIndexInTheText = this.date.index;
                this.currentDateRegex = this.settings.dateRegexList[i];
                isDateFound = true;
            }
        }
        return isDateFound;
    }
    isPhoneNumberContainedDate(text) {
        for (let i = 0; i < this.settings.dateRegexList.length; i++) {
            this.date = this.settings.dateRegexList[i].exec(text);
            if (this.date) {
                return true;
            }
        }
        return false;
    }
    isStartDatePositionInsidePhoneNumber(remaining, possiblePhoneNumberLength) {
        const match = this.settings.phoneNumberRE.exec(remaining);
        if (this.currentDateRegex) {
            this.date = this.currentDateRegex.exec(remaining);
        }
        const doesDateExistInThePossiblePhoneNumber = (match.index + possiblePhoneNumberLength) >= this.date.index;
        return doesDateExistInThePossiblePhoneNumber;
    }
}
exports.DateFinderInPhoneNumberHelper = DateFinderInPhoneNumberHelper;

},{}],91:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.DateHelper = void 0;
class DateHelper {
    constructor() {
        this.monthDictionary = [
            { 1: 'Jan' },
            { 2: 'Feb' },
            { 3: 'Mar' },
            { 4: 'Apr' },
            { 5: 'May' },
            { 6: 'Jun' },
            { 7: 'Jul' },
            { 8: 'Aug' },
            { 9: 'Sep' },
            { 10: 'Oct' },
            { 11: 'Nov' },
            { 12: 'Dec' },
        ];
    }
    isMonthNumberValid(monthNumber) {
        return ((monthNumber <= 12) && (monthNumber > 0));
    }
    isYearValid(year) {
        return (year && ((year.toString()).length === 4));
    }
    getMonthNameByMonthNumber(monthNumber) {
        if (monthNumber && (monthNumber === monthNumber) && this.isMonthNumberValid(monthNumber)) {
            for (let i = 0; i < this.monthDictionary.length; i++) {
                if (this.monthDictionary[i][monthNumber]) {
                    return this.monthDictionary[i][monthNumber];
                }
            }
        }
        return;
    }
    getDateOfTheFirstDayOfTheMonthByMonthNumberAndYear(monthNumber, year) {
        const monthName = this.getMonthNameByMonthNumber(monthNumber);
        if (monthName && year) {
            const date = monthName + ' ' + year;
            try {
                return (new Date(date));
            }
            catch (error) {
                return;
            }
        }
        return;
    }
}
exports.DateHelper = DateHelper;

},{}],92:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.ErrorHelper = void 0;
const message_1 = require("../repository/message");
const api_1 = require("../api");
class ErrorHelper {
    constructor(apiLogic) {
        this.apiLogic = apiLogic || new api_1.APILogic();
        this.message = new message_1.Message(this.apiLogic);
    }
    updateCatcherInTheError(error, catcher) {
        error = (error) ? (error) : this.apiLogic.constants.error.default;
        if (typeof error === 'string') {
            error = { message: error };
        }
        error.catcher = catcher;
        return error;
    }
    isExceptionHandled(error) {
        return (error && error.catcher);
    }
    checkForAuthError(error) {
        if (error && error.status === 401) {
            this.message.sendMessageToBackground({ action: 'authError', errorCode: 401 });
        }
    }
}
exports.ErrorHelper = ErrorHelper;

},{"../api":61,"../repository/message":138}],93:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.addDivToDocument = exports.showCurrentMenu = void 0;
const $fuzePopupMenu = $('.fuze-for-browser-extension-popup-menu');
function showCurrentMenu(currentMenu) {
    $fuzePopupMenu.hide();
    $(`.fuze-for-browser-extension-${currentMenu}-menu`).show();
}
exports.showCurrentMenu = showCurrentMenu;
function addDivToDocument(html, id) {
    if (window.location !== window.parent.location) {
        return;
    }
    const divHtml = `<div id='${id}'>${html}</div>`;
    if (document.getElementById(id)) {
        return;
    }
    $(`#${id}`).remove();
    $('body').append(divHtml);
}
exports.addDivToDocument = addDivToDocument;

},{}],94:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.isIframeRuntime = void 0;
// returns true if script executes in iframe
function isIframeRuntime() {
    return window.self !== window.top;
}
exports.isIframeRuntime = isIframeRuntime;

},{}],95:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogHelper = void 0;
const logEntry_1 = require("../logging/logEntry");
const meeting_1 = require("../repository/meeting");
const message_1 = require("../repository/message");
const logging_1 = require("../logging/logging");
class LogHelper {
    constructor(apiLogic, extensionSettings) {
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        // 20 minutes
        this.SPLUNK_BUFFER_CHECK_INTERVAL = 20 * 60 * 1000;
        // 5 seconds
        this.CONSOLE_BUFFER_CHECK_INTERVAL = 5 * 1000;
        this.MAXIMUM_BUFFER_SIZE = 500;
        this.splunkBuffer = [];
        this.consoleBuffer = [];
        this.logsLengthInStorage = 0;
        this.meeting = new meeting_1.Meeting(apiLogic, extensionSettings);
        this.message = new message_1.Message(apiLogic);
        if (!logging_1.Logging.ifBackgroundScript()) {
            return;
        }
        this.initializeMessageListeners();
        this.checkSplunkBuffer();
        this.checkConsoleBuffer();
    }
    // updates logs array and sends if logs amount exceeds defined amount
    bufferLog(level, message) {
        const logEntry = new logEntry_1.LogEntry(new Date(), level, message);
        if (!this.splunkBuffer || !this.splunkBuffer.length) {
            return this.splunkBuffer = [logEntry];
        }
        this.splunkBuffer.push(logEntry);
        if (this.splunkBuffer.length >= this.MAXIMUM_BUFFER_SIZE) {
            this.meeting.sendLogs(this.splunkBuffer);
            this.splunkBuffer = [];
        }
    }
    bufferConsoleLog(logString) {
        if (!this.consoleBuffer || !this.consoleBuffer.length) {
            return this.consoleBuffer = [logString];
        }
        this.consoleBuffer.push(logString);
    }
    // checks splunkBuffer every defined interval for logs and sends them
    checkSplunkBuffer() {
        window.setInterval(() => {
            if (this.splunkBuffer && this.splunkBuffer.length) {
                this.meeting.sendLogs(this.splunkBuffer);
                this.splunkBuffer = [];
            }
        }, this.SPLUNK_BUFFER_CHECK_INTERVAL);
    }
    checkConsoleBuffer() {
        const setTimeoutFunction = this.setConsoleLogsToTheStorage.bind(this);
        window.setTimeout(setTimeoutFunction, this.CONSOLE_BUFFER_CHECK_INTERVAL);
    }
    setConsoleLogsToTheStorage() {
        return __awaiter(this, void 0, void 0, function* () {
            if (this.consoleBuffer && this.consoleBuffer.length) {
                let logs = (yield this.extensionSettings.getLogs()) || [];
                logs = logs.concat(this.consoleBuffer);
                if (logs && logs.length > this.MAXIMUM_BUFFER_SIZE) {
                    const sizeDif = logs.length - this.MAXIMUM_BUFFER_SIZE;
                    logs.splice(0, sizeDif);
                }
                if (logs && (this.logsLengthInStorage <= logs.length)) {
                    yield this.extensionSettings.setLogs(logs);
                    this.logsLengthInStorage = logs.length;
                    this.consoleBuffer = [];
                }
            }
            window.setTimeout(this.setConsoleLogsToTheStorage.bind(this), this.CONSOLE_BUFFER_CHECK_INTERVAL);
        });
    }
    initializeMessageListeners() {
        this.message.addMessageListener((message) => {
            if (!message || message.action) {
                return;
            }
            switch (message.action) {
                case 'sendSplunkLog':
                    this.bufferLog(message.level, message.message);
                    break;
                case 'sendConsoleLog':
                    this.bufferConsoleLog(message.message);
                    break;
            }
        });
    }
}
exports.LogHelper = LogHelper;

},{"../logging/logEntry":106,"../logging/logging":108,"../repository/meeting":137,"../repository/message":138}],96:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogWrapper = void 0;
const message_1 = require("../repository/message");
const extensionSettings_1 = require("../repository/extensionSettings");
const logging_1 = require("../logging/logging");
const log_helper_1 = require("./log-helper");
class LogWrapper {
    constructor(apiLogic, settings) {
        this.apiLogic = apiLogic;
        this.settings = settings;
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(apiLogic);
        this.message = new message_1.Message(apiLogic);
        this.logHelper = new log_helper_1.LogHelper(apiLogic, this.extensionSettings);
        Log.MAX_BUFFER_SIZE = settings.maxBufferSize || 500;
        Log.appVersion = settings.version;
        Log.prefix = `[${settings.extensionName}]`;
        Log.log = (level, args) => __awaiter(this, void 0, void 0, function* () {
            const consoleLoggingState = yield this.extensionSettings.getConsoleLoggingState();
            Log._log(level, args, consoleLoggingState);
            this._getLogsFromLocalStorage();
        });
    }
    static getInstance(apiLogic, settings) {
        if (!LogWrapper.instance) {
            LogWrapper.instance = new LogWrapper(apiLogic, settings);
        }
        return LogWrapper.instance;
    }
    showErrorLog(args) {
        Log.log(LogLevel.ERROR, args);
    }
    showInfoLog(args) {
        Log.log(LogLevel.INFO, args);
    }
    _getLogsFromLocalStorage() {
        const lastLog = Log.messageBuffer[Log.messageBuffer.length - 1];
        if (!lastLog) {
            return;
        }
        if (logging_1.Logging.ifBackgroundScript()) {
            this.logHelper.bufferConsoleLog(lastLog);
        }
        else {
            this.message.sendMessageToBackground({ action: 'sendConsoleLog', message: lastLog });
        }
    }
}
exports.LogWrapper = LogWrapper;

},{"../logging/logging":108,"../repository/extensionSettings":136,"../repository/message":138,"./log-helper":95}],97:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreferredDeviceHelper = void 0;
class PreferredDeviceHelper {
    constructor(settings) {
        this.settings = settings;
    }
    getDisplayingNameDeviceForGettingUcapiAddress(availableDevices, ucapiAddress) {
        for (let i = 0; i < availableDevices.length; i++) {
            for (let j = 0; j < availableDevices[i].lines.length; j++) {
                if (availableDevices[i].lines[j].ucapiAddress === ucapiAddress) {
                    const key = this.settings.preferredDeviceTypesList[availableDevices[i].deviceType];
                    const preferredDeviceDropdownNamesList = this.settings.localizationLanguageManager.getTranslate('FUZELOC_prefPhone_dropdownNamesList');
                    const displayValue = key ? preferredDeviceDropdownNamesList[key] : availableDevices[i].deviceDescription;
                    const lineExtension = ' X' + availableDevices[i].lines[j].extension;
                    return {
                        displayValue,
                        lineExtension,
                    };
                }
            }
        }
        const phoneNumberValue = ucapiAddress.split(':')[1];
        return {
            displayValue: this.settings.localizationLanguageManager.getTranslate('FUZELOC_prefPhone_dropdownNamesList').OTHER,
            lineExtension: '',
            phoneNumberValue,
        };
    }
}
exports.PreferredDeviceHelper = PreferredDeviceHelper;

},{}],98:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExtensionSettingsPromisifier = void 0;
class ExtensionSettingsPromisifier {
    constructor(extensionSettings) {
        this.extensionSettings = extensionSettings;
    }
    getWardenTokenFromLocalDatabase() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.extensionSettings.getWardenTokenFromLocalDatabase();
        });
    }
    getUserOrganization() {
        return this.extensionSettings.getUserOrganization();
    }
    setCustomerMaskExtensions(maskExtensions) {
        return this.extensionSettings.setCustomerMaskExtensions(maskExtensions);
    }
    getCustomerMaskExtensions() {
        return this.extensionSettings.getCustomerMaskExtensions();
    }
    setPreviousClidMask(previousClidMask) {
        return this.extensionSettings.setPreviousClidMask(previousClidMask);
    }
    getPreviousClidMask() {
        return this.extensionSettings.getPreviousClidMask();
    }
}
exports.ExtensionSettingsPromisifier = ExtensionSettingsPromisifier;

},{}],99:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SimulateUserChangesHelper = void 0;
class SimulateUserChangesHelper {
    constructor(settings) {
        this.settings = settings;
    }
    simulateInputForLocationField() {
        const $locationInput = $(this.settings.calendarDomElementCharacteristics.locationEventFormSelector);
        const $firstLocationInput = $locationInput[0];
        const locationValue = $locationInput.val();
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Event'), 'mouseenter', $firstLocationInput);
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Event'), 'focus', $firstLocationInput);
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Event'), 'clickonly', $firstLocationInput);
        $locationInput.val('').val(locationValue);
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Event'), 'input', $firstLocationInput);
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Event'), 'blur', $firstLocationInput);
    }
    simulateInputForDescriptionField() {
        const $descriptionElement = $(this.settings.calendarDomElementCharacteristics.descriptionTextSelector);
        const $firstDescriptionElement = $descriptionElement[0];
        const descriptionValue = $descriptionElement.html();
        const toolboxBoldButtonElement = $(this.settings.calendarDomElementCharacteristics.descriptionSelector + ' ' +
            this.settings.calendarDomElementCharacteristics.htmlEditorToolboxButtonSelector)[1];
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Events'), 'focus', $firstDescriptionElement);
        $descriptionElement.html(descriptionValue);
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Events'), 'keyup', $firstDescriptionElement);
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Events'), 'click', toolboxBoldButtonElement);
        // click once again to return initial button state after some time to process correctly both clicks
        setTimeout(() => {
            this.settings.dispatchDomEventAtTheElement(document.createEvent('Events'), 'click', toolboxBoldButtonElement);
        }, 500);
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Events'), 'blur', $firstDescriptionElement);
    }
    simulateChangesForDescriptionField() {
        const $firstEditableDescription = $(this.settings.calendarDomElementCharacteristics.editableDescriptionEventSelector)[0];
        this.settings.dispatchDomEventAtTheElement(document.createEvent('Event'), 'change', $firstEditableDescription);
    }
}
exports.SimulateUserChangesHelper = SimulateUserChangesHelper;

},{}],100:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SourceWrapper = void 0;
class SourceWrapper {
    constructor(settings) {
        this.settings = settings;
        this.data = {};
    }
    set(key, value) {
        return (new Promise((resolve, reject) => {
            this.data[key] = value;
            try {
                this.settings.source.set(key, value).then(() => {
                    resolve(value);
                }, reject).catch(reject);
            }
            catch (error) {
                reject(error);
            }
        }));
    }
    get(key) {
        return (new Promise((resolve, reject) => {
            if (this.data && (this.data[key] !== undefined)) {
                resolve(this.data[key]);
            }
            else {
                try {
                    this.settings.source.get(key).then((value) => {
                        this.data[key] = value;
                        resolve(value);
                    }, reject).catch(reject);
                }
                catch (error) {
                    reject(error);
                }
            }
        }));
    }
    clear() {
        this.data = {};
        return (new Promise((resolve, reject) => {
            try {
                this.settings.source.clear().then(() => {
                    resolve();
                }, reject).catch(reject);
            }
            catch (error) {
                reject(error);
            }
        }));
    }
}
exports.SourceWrapper = SourceWrapper;

},{}],101:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-for-browser-extension-notification-wrapper">\n  <div class="fuze-for-browser-extension-notification fuze-for-browser-extension-home-country-notification">\n    <div class="fuze-for-browser-extension-home-country-notification__1-column">\n      <img class="fuze-for-browser-extension-home-country-notification-1-column__logo fuze-for-browser-extension-home-country-notification__image"/>\n    </div>\n    <div class="fuze-for-browser-extension-home-country-notification__2-column">\n      <h1 class="fuze-for-browser-extension-home-country-notification-2-column__title fuze-for-browser-extension-home-country-notification__title"\n          data-i18next="FUZELOC_notification_verifyCountry">\n        Verify Home Country</h1>\n\n      <p class="fuze-for-browser-extension-home-country-notification-2-column__description fuze-for-browser-extension-home-country-notification__description"\n         data-i18next="FUZELOC_notification_verifyCountryInfo">\n        We had some difficulty verifying your home country. For now, we set it to:</p>\n\n      <div class="fuze-for-browser-extension-dropdown-actions-wrapper">\n        <div class="fuze-for-browser-extension-dropdown-wrapper">\n          <input class="fuze-for-browser-extension-home-country-notification-2-column__home-country\n                    fuze-for-browser-extension-home-country-notification__home-country fuze-for-browser-extension-dropdown__current-input-value"/>\n\n          <div class="fuze-for-browser-extension-home-country-notification-2-column__country-dropdown\n                    fuze-for-browser-extension-home-country-notification__country-dropdown fuze-for-browser-extension-dropdown__dropdown"></div>\n        </div>\n        <button class="fuze-for-browser-extension-home-country-notification-2-column__confirm-button\n                fuze-for-browser-extension-home-country-notification__confirm-button">\n          Ok\n        </button>\n      </div>\n    </div>\n    <div class="fuze-for-browser-extension-home-country-notification__3-column fuze-for-browser-extension-notification__3-column">\n      <div class="fuze-for-browser-extension-home-country-notification-3-column__close-button\n            fuze-for-browser-extension-notification-3-column__close-button"></div>\n    </div>\n  </div>\n</div>\n';

},{}],102:[function(require,module,exports){
module.exports={
  "keys": {
    "USER_NAME": "tpn_username",
    "FULL_NAME": "tpn_fullName",
    "USER_EMAIL": "tpn_userEmail",
    "ENTITLEMENT_FOR_MEETING": "tpn_entitlementForMeeting",
    "ENTITLEMENT_FOR_TEAMS": "tpn_entitlementForTeams",
    "ENTITLEMENT_FOR_CLICK_TO_CALL": "tpn_entitlementForClickToCall",
    "PREVIOUS_LOGIN_DATA": "tpn_previousLoginData",
    "AUTO_ANSWER": "tpn_autoAnswer",
    "HOME_COUNTRY": "tpn_homeCountry",
    "HOME_COUNTRY_DATA": "tpn_homeCountryData",
    "DOMAINS": "tpn_domains",
    "USER_FEATURES": "tpn_userFeatures",
    "CITADEL_OPTIONS": "tpn_citadelOptions",
    "CLICK_TO_CALL_ENABLING_STATE": "tpn_clickToCallEnablingState",
    "MEETINGS_ENABLING_STATE": "tpn_meetingsEnablingState",
    "CONTACTIVE_USER_COUNTRY_CODE": "tpn_contactiveUserCountryCode",
    "HOME_COUNTRY_UPDATED_STATUS": "tpn_homeCountryUpdatedStatus",
    "USER_TENANT": "tpn_userTenant",
    "PASSWORD": "tpn_password",
    "FUZE_TOKEN": "tpn_fuzeToken",
    "WARDEN_TOKEN": "tpn_wardenToken",
    "STATUS_OF_THE_FIRST_INSTALLATION": "tpn_statusOfTheFirstInstallation",
    "CURRENT_ENVIRONMENT": "tpn_currentEnvironment",
    "CITADEL_ENVIRONMENT": "tpn_citadelEnvironment",
    "CLICK_TO_CALL_DISABLED_BY_CONFLICTS": "tpn_clickToCallDisabledByConflicts",
    "WAS_ERROR_MESSAGE_SHOWED_ONCE_ON_THE_PAGE": "tpn_isErrorMessageWasShowedOnceOnThePage",
    "NOTIFICATION_SHOWED_ONCE": "tpn_notificationWasShowedOnce",
    "IS_USER_LOGGED_IN": "tpn_isUserLoggedIn",
    "IS_EXTENSION_DISABLED": "tpn_isDisabledExtension",
    "PREFERRED_DEVICE": "tpn_preferred",
    "PREFERRED_DEVICE_ADDRESS": "tpn_preferredAddress",
    "AVAILABLE_DEVICES": "tpn_availableDevices",
    "IS_ACCOUNT_CONFIGURATION_ERROR": "tpn_isAccountConfigurationError",
    "CONSOLE_LOGGING_STATE": "tpn_consoleLoggingState",
    "STREAM_LOGGING_STATE": "tpn_streamLoggingState",
    "FUZE_TEAMS_STATE": "tpn_teamsState",
    "FUZE_CONTACTS_STATE": "tpn_fuzeContactsState",
    "JOIN_MEETINGS_OPTION": "tpn_joinMeetingsOption",
    "FIRST_TIME_JOIN_MEETING": "tpn_firstTimeJoinMeeting",
    "EXTENSION_LOGS": "tpn_logs",
    "DEFAULT_USED_LINK": "tpn_defaultUsedLink",
    "DOES_EXPECT_TO_CREATE_A_MEETING": "tpn_doesExpectToCreateAMeeting",
    "WAS_CHROME_CREDENTIALS_COPIED": "tpn_wasChromeChredentialsCopied",
    "LOCALIZATION_LANGUAGE": "tpn_localizationLanguage",
    "DEVICE_HINT": "tpn_deviceHint",
    "USER_ORGANIZATION": "tpn_organization",
    "CUSTOMER_MASK_EXTENSIONS": "tpn_customerMaskExtensions",
    "PREVIOUS_CLID_MASK": "tpn_previousClidMask",
    "ENTITLEMENT_FOR_CALLER_ID_MASKING": "tpn_entitlementForCallerIdMasking",
    "CALLER_ID_MASKING_ENABLING_STATE": "tpn_callerIdMaskingEnablingState"
  }
}

},{}],103:[function(require,module,exports){
module.exports={
	"de": {
		"translation": {
			"FUZELOC_generic_extensionName": {
				"Chrome": "Fuze für Chrome",
				"Firefox": "Fuze für Firefox",
				"Edge": "Fuze für Edge"
			},
			"FUZELOC_generic_welcome": "Willkommen",
			"FUZELOC_generic_clickToCallDescription": "Durchführen von Fuze Anrufen von Web Seiten die Sie besuchen sowie planen & beitreten von Fuze Meetings aus dem Google Kalender",
			"FUZELOC_generic_meetingDescription": "Erstellen und beitreten von Fuze Meetings direkt aus dem Google Kalender",
			"FUZELOC_generic_makeCall": "Einen Anruf tätigen",
			"FUZELOC_generic_settings": "Einstellungen",
			"FUZELOC_generic_sendFeedback": "Feedback senden",
			"FUZELOC_generic_aboutFuze": "Über Fuze",
			"FUZELOC_generic_extensionIsDisabled": "Ihre Durchwahl ist deaktiviert.",
			"FUZELOC_generic_restore": "Wiederherstellen",
			"FUZELOC_generic_loading": "Wird geladen...",
			"FUZELOC_generic_callTooltip": "Anruf unter Nutzung von",
			"FUZELOC_generic_addFuzeMeeting": "Fuze-Meeting hinzufügen",
			"FUZELOC_generic_signOut": "Abmelden",
			"FUZELOC_generic_enterNumber": "Geben Sie eine Nummer ein",
			"FUZELOC_generic_cancel": "Abbrechen",
			"FUZELOC_generic_retry": "Erneut versuchen",
			"FUZELOC_generic_close": "Schließen",
			"FUZELOC_generic_save": "Speichern",
			"FUZELOC_generic_ignore": "Ignorieren",
			"FUZELOC_generic_logIn": "Anmelden",
			"FUZELOC_generic_disableFuze": "Fuze deaktivieren",
			"FUZELOC_generic_joinFuzeMeeting": "Einem Fuze-Meeting beitreten",
			"FUZELOC_generic_change": "Ändern",
			"FUZELOC_generic_use": "Verwenden",
			"FUZELOC_generic_setType": "Typ festlegen",
			"FUZELOC_generic_default": "(vorgabewert)",
			"FUZELOC_generic_systemPageMessage": "Die Durchwahl ist auf neuen Registerkarten oder Systemseiten nicht verfügbar.",
			"FUZELOC_generic_systemPageInfo": "(Zu Ihrer Beruhigung: Sie wird auf anderen Webseiten weiterhin funktionieren)",
			"FUZELOC_generic_undo": "Rückgängig",
			"FUZELOC_dialPad_dialNumber": "Nummer wählen",
			"FUZELOC_settings_moreSettings": "Weitere Einstellungen",
			"FUZELOC_settings_clickToCall": "CLICK-TO-CALL (ZUM ANRUF KLICKEN)",
			"FUZELOC_settings_clickToCallDescription": "Das Fuze-Logo wird auf den von Ihnen besuchten Webseiten neben Telefonnummern angezeigt. Klicken Sie darauf, um einen Anruf zu tätigen.",
			"FUZELOC_settings_myPrefPhone": "Mein bevorzugtes Telefon",
			"FUZELOC_settings_homeCountry": "Heimatland",
			"FUZELOC_settings_disabledDomains": "Deaktivierte Domänen",
			"FUZELOC_settings_fuzeMeeting": "GOOGLE KALENDER",
			"FUZELOC_settings_dateFormat": "Datumsformat",
			"FUZELOC_prefPhone_prefferedPhone": "bevorzugtes Telefon",
			"FUZELOC_prefPhone_description": "Dies ist das Telefon, das zum Tätigen Ihrer Anrufe verwendet wird.",
			"FUZELOC_prefPhone_selectPhone": "Wählen Sie ein Telefon aus",
			"FUZELOC_prefPhone_selectNumber": "Eine Nummer auswählen",
			"FUZELOC_prefPhone_genericHint": "Dieses Telefon wird überall dort verwendet, wo Sie Click-to-Call nutzen. Dies beinhaltet (falls zutreffend)",
			"FUZELOC_prefPhone_fuzeForSalesforce": "Fuze für Salesforce",
			"FUZELOC_prefPhone_fuzeDesktopIfEnabled": "Fuze Desktop (soweit aktiviert)",
			"FUZELOC_prefPhone_phoneHint": "Ein Hinweis zu dem von Ihnen ausgewählten Telefon:",
			"FUZELOC_prefPhone_phoneHintInfo": "Wenn Sie einen Anruf tätigen, klingelt zuerst das von Ihnen ausgewählte Telefon (als ob Sie einen eingehenden Anruf von dem Teilnehmer erhielten, den Sie anzuwählen versuchen). Sobald Sie den Anruf annehmen, wird Ihre Zielrufnummer gewählt.",
			"FUZELOC_prefPhone_unsavedChanges": "Ungespeicherte Änderungen",
			"FUZELOC_prefPhone_unsavedChangesInfo": "Sie haben Ihre Änderungen nicht gespeichert. Wollen Sie diese Seite wirklich verlassen?",
			"FUZELOC_prefPhone_tooltip_onlyAvailableNumber": "Dies ist die einzige verfügbare Nummer für dieses Telefon.",
			"FUZELOC_prefPhone_tooltip_invalidNumber": "*Geben Sie eine gültige Nummer ein, um Ihre Auswahl zu speichern.",
			"FUZELOC_prefPhone_tooltip_pleaseEnterValidNumber": "Geben Sie bitte eine gültige Nummer ein, um Ihre Auswahl zu speichern.",
			"FUZELOC_prefPhone_notification": "Ihr bevorzugtes Telefon ist jetzt {preferredPhone}.",
			"FUZELOC_prefPhone_tooltip_numberChanged": "Nummer geändert! {numberValue} war nicht verfügbar für {device}.",
			"FUZELOC_prefPhone_dropdownNamesList": {
				"DESKTOP": "Fuze Desktop ",
				"MOBILE": "Fuze Mobile ",
				"POLYCOM": "Polycom",
				"OTHER": "Anderes Telefon "
			},
			"FUZELOC_disabledDomains_disableThisDomain": "Diese Domäne deaktivieren",
			"FUZELOC_disabledDomains_description": "Das Fuze-Logo wird auf dieser Webseite nicht mehr angezeigt und das Wählen per Einzelklick ist nicht länger verfügbar.",
			"FUZELOC_disabledDomains_info": "Falls Sie Ihre Auswahl später ändern möchten, können Sie die von Ihnen ignorierten Domänen unten verwalten.",
			"FUZELOC_disabledDomains_disable": "deaktivieren",
			"FUZELOC_disabledDomains_manageDisabledDomains": "Deaktivierte domänen verwalten",
			"FUZELOC_disabledDomains_notification": " ist ab jetzt eine ignorierte Domäne. ",
			"FUZELOC_disabledDomains_tooltip_goTo": "Gehe zu ",
			"FUZELOC_disabledDomains_tooltip_removeFromList": "Aus der Liste entfernen",
			"FUZELOC_disabledDomains_domainHasBeenRemoved": " wurde aus der Liste der ignorierten Domänen entfernt.",
			"FUZELOC_disabledDomains_withoutDisabledDomains": "Sie haben noch keine Domänen deaktiviert.",
			"FUZELOC_dateFormat_setDate": "Ihr bevorzugtes Datumsformat einstellen",
			"FUZELOC_dateFormat_description": "Fuze muss das von Ihnen in Google Kalender verwendete Datumsformat kennen, um korrekt funktionieren zu können.",
			"FUZELOC_dateFormat_pleaseSelect": "Wählen Sie es bitte unten in der Dropdown-Liste aus.",
			"FUZELOC_dateFormat_notification": "Ihr Datumsformat ist jetzt {dateFormat}.",
			"FUZELOC_moreSettings_selectLanguage": "Wählen Sie Ihre Sprache aus.",
			"FUZELOC_moreSettings_advancedLogging": "Erweiterte Anmeldung",
			"FUZELOC_moreSettings_advancedLoggingInfo": "Das Aktivieren dieser Option hilft dem Fuze-Team beim Verfolgen aller Probleme, mit denen Sie möglicherweise konfrontiert werden.",
			"FUZELOC_moreSettings_streamLogging": "Helfen Sie uns beim Verbessern",
			"FUZELOC_moreSettings_streamLoggingInfo": "Senden Sie automatisch Fehlerbehebungsprotokolle an Fuze, um die Nutzererfahrung zu verbessern",
			"FUZELOC_moreSettings_fuzeContactsInfo": "Anrufen von Fuze Kontakten direkt aus Ihren Gmail EMails",
			"FUZELOC_moreSettings_selectLanguageList": [
				{
					"name": "Englisch",
					"code": "en"
				},
				{
					"name": "Französisch",
					"code": "fr"
				},
				{
					"name": "Deutsch",
					"code": "de"
				},
				{
					"name": "Italienisch",
					"code": "it"
				},
				{
					"name": "Spanisch",
					"code": "es"
				}
			],
			"FUZELOC_feedback_enterEmail": "Geben Sie Ihre E-Mail-Adresse ein",
			"FUZELOC_feedback_howCanWeHelp": "Wie können wir Ihnen helfen?",
			"FUZELOC_feedback_pickCategory": "Wählen Sie eine Kategorie aus.",
			"FUZELOC_feedback_send": "SENDEN",
			"FUZELOC_feedback_giveMoreDetails": "Teilen Sie uns weitere Details mit.",
			"FUZELOC_feedback_placeholder": "Je genauer Ihre Angaben sind, umso besser können wir dieses Problem lösen.",
			"FUZELOC_feedback_unableToSendReport": "Bericht kann nicht gesendet werden.",
			"FUZELOC_feedback_reportSent": "Bericht gesendet!",
			"FUZELOC_feedback_errorInfo": "Bitte warten Sie einen Moment und versuchen Sie es erneut. Falls das Problem weiter besteht, kontaktieren Sie bitte direkt Ihre IT-Abteilung.",
			"FUZELOC_feedback_reportSentInfo": "Für Soforthilfe bitte Ihre IT-Abteilung direkt kontaktieren.",
			"FUZELOC_feedback_typesList": [
				"Click-to-Call",
				"Fuze-Meetings",
				"Anmelden",
				"Andere"
			],
			"FUZELOC_about_version": "Version",
			"FUZELOC_about_acknowledgements": "Bestätigungen",
			"FUZELOC_callScreen_calling": "Anrufen...",
			"FUZELOC_callScreen_canNotCompleteCall": "Anruf kann nicht abgeschlossen werden",
			"FUZELOC_callScreen_errorInfo_firstPart": "Wir bitten um Entschuldigung. Bitte versuchen Sie es erneut oder ",
			"FUZELOC_callScreen_contactSupport": "kontaktieren Sie den Support,",
			"FUZELOC_callScreen_errorInfo_endPart": "falls Sie weiterhin Probleme haben.",
			"FUZELOC_callScreen_using": "Unter Verwendung von",
			"FUZELOC_callScreen_sessionHasExpired": "Hoppla, wir konnten Ihren Anruf nicht abschließen! Ihre Sitzung ist abgelaufen.",
			"FUZELOC_welcome_welcomeTo": "Willkommen bei",
			"FUZELOC_welcome_pleaseSignIn": "Melden Sie sich bitte an, um zu beginnen.",
			"FUZELOC_welcome_signIn": "anmelden",
			"FUZELOC_welcome_signInLater": "Um sich später anzumelden, ",
			"FUZELOC_welcome_clickFuzeLogo": "klicken Sie auf das Fuze-Logo.",
			"FUZELOC_notification_signIn": "Sie sind angemeldet bei ",
			"FUZELOC_notification_signOut": "Sie sind abgemeldet von ",
			"FUZELOC_notification_verifyCountry": "Heimatland verifizieren",
			"FUZELOC_notification_verifyCountryInfo": "Wir hatten Probleme, Ihr Heimatland zu verifizieren. Wir haben es vorläufig eingestellt auf:",
			"FUZELOC_notification_sessionExpired": "Ihre Sitzung ist abgelaufen.",
			"FUZELOC_notification_sessionExpiredInfo": "Bitte melden Sie sich erneut an, um fortzufahren.",
			"FUZELOC_notification_disableFuzeOnPage": "Fuze auf dieser Seite deaktivieren?",
			"FUZELOC_notification_disableFuzeInfo": "Es tut uns leid, aber Fuze reagiert nicht. Möchten Sie es auf dieser Seite wirklich deaktivieren?",
			"FUZELOC_notification_conflictingExtension": "Probleme mit der Durchwahl",
			"FUZELOC_notification_conflictingExtensionInfo": " hat Probleme, da die {extensionsListText}-Durchwahl aktiviert ist. Deaktivieren Sie bitte die {extensionsListText}-Durchwahl und starten Sie Ihren Browser neu.",
			"FUZELOC_calendar_didYouKnow": "Wussten Sie bereits...?",
			"FUZELOC_calendar_didYouKnowInfo": "Sie können Ihr eigenen persönlichen Meeting-Link erstellen. „Vanity-Links“ sind benutzerdefinierbar, so dass sie leicht im Gedächtnis behalten und schnell geteilt und wiederverwendet werden können. Besuchen Sie Fuze>Settings>Meetings, um ein Vanity-Link zu erstellen.",
			"FUZELOC_calendar_vanityInfo": "Wählen Sie die Meeting-ID für Ihre teilnehmenden Gäste aus. Erstellen Sie einen neuen Vanity-Link oder nutzen sie einen vorhandenen.*",
			"FUZELOC_calendar_alwaysDefault": "immer als Standardeinstellung verwenden ",
			"FUZELOC_calendar_vanityNotes": "*Die mit Ihrem Vanity-Link verknüpften Nachrichten und geteilten Inhalte werden für all Ihre Gäste verfügbar sein. Hinzufügen, bearbeiten oder sich näher informieren unter Fuze>Settings>Meetings",
			"FUZELOC_calendar_dropdownValues_initial": [
				{
					"customValue": true,
					"name": "neue Meeting-ID"
				}
			],
			"FUZELOC_calendar_dropdownValues_meetingTypes": [
				{
					"customValue": "O",
					"name": "Open meeting",
					"descriptionValue": "Dieses Meeting wird beginnen, sobald Sie oder irgendjemand aus Ihrem Unternehmen teilnimmt, weitere Teilnehmer können sich anschließen, ohne akzeptiert werden zu müssen. Hervorragend für kleinere informelle Meetings."
				},
				{
					"customValue": "R",
					"name": "Private meeting",
					"descriptionValue": "Sie müssen dieses Meeting selbst starten und weitere Teilnehmer werden nur zugelassen, wenn Sie sie akzeptieren. Hervorragend für Meetings, die Sie in hohem Maße kontrollieren möchten."
				},
				{
					"customValue": "W",
					"name": "Large meeting",
					"descriptionValue": "Sie müssen das Meeting selbst starten. Weitere Gäste werden bei ihrer Teilnahme automatisch stummgeschaltet. Hervorragend für alle großen formellen Meetings oder Präsentationen."
				}
			],
			"FUZELOC_homeCountry_selectCountry": "Wählen Sie die Ländervorwahl für Ihr Land aus.",
			"FUZELOC_homeCountry_description": "Mit dieser Information können wir Ihre Anrufe auf Webseiten verbinden, die keine Ländervorwahl angeben.",
			"FUZELOC_homeCountry_callingInternationally": "Internationaler Anruf?",
			"FUZELOC_homeCountry_callingInternationallyInfo": "Nutzen Sie – wie für alle anderen Nummern – einfach „Click-to-Call“! Falls ein Verbindungsproblem auftritt, enthält die Nummer möglicherweise nicht die Ländervorwahl. Kopieren Sie in diesem Fall die Nummer und fügen Sie sie in diesem Menü in die Wählhilfe ein, ergänzen Sie die korrekte Vorwahl und tätigen Sie Ihren Anruf von dort.",
			"FUZELOC_homeCountry_notification": "Ihr Heimatland ist ",
			"FUZELOC_homeCountry_countries": {
				"AF": "Afghanistan",
				"AL": "Albanien",
				"DZ": "Algerien",
				"AS": "Amerikanisch-Samoa",
				"AD": "Andorra",
				"AO": "Angola",
				"AI": "Anguilla",
				"AQ": "Antarktis",
				"AG": "Antigua und Barbuda",
				"AR": "Argentinien",
				"AM": "Armenien",
				"AW": "Aruba",
				"AU": "Australien",
				"AT": "Österreich",
				"AZ": "Aserbaidschan",
				"BS": "Bahamas",
				"BH": "Bahrain",
				"BD": "Bangladesch",
				"BB": "Barbados",
				"BY": "Weißrussland",
				"BE": "Belgien",
				"BZ": "Belize",
				"BJ": "Benin",
				"BM": "Bermuda",
				"BT": "Bhutan",
				"BO": "Bolivien",
				"BA": "Bosnien und Herzegowina",
				"BW": "Botswana",
				"BV": "Bouvetinsel",
				"BR": "Brasilien",
				"IO": "Britisches Territorium im Indischen Ozean",
				"BN": "Brunei Darussalam",
				"BG": "Bulgarien",
				"BF": "Burkina Faso",
				"BI": "Burundi",
				"KH": "Kambodscha",
				"CM": "Kamerun",
				"CA": "Kanada",
				"CV": "Kapverden",
				"KY": "Kaimaninseln",
				"CF": "Zentralafrikanische Republik",
				"TD": "Tschad",
				"CL": "Chile",
				"CN": "China",
				"CX": "Weihnachtsinseln",
				"CC": "Cocosinseln",
				"CO": "Kolumbien",
				"KM": "Komoren",
				"CG": "Kongo",
				"CD": "Demokratische Republik Kongo",
				"CK": "Cookinseln",
				"CR": "Costa Rica",
				"CI": "Elfenbeinküste",
				"HR": "Kroatien",
				"CU": "Kuba",
				"CY": "Zypern",
				"CZ": "Tschechische Republik",
				"DK": "Dänemark",
				"DJ": "Dschibuti",
				"DM": "Dominica",
				"DO": "Dominikanische Republik",
				"TP": "Osttimor",
				"EC": "Ecuador",
				"EG": "Ägypten",
				"SV": "El Salvador",
				"GQ": "Äquatorialguinea",
				"ER": "Eritrea",
				"EE": "Estland",
				"ET": "Äthiopien",
				"FK": "Falklandinseln",
				"FO": "Färöer Inseln",
				"FJ": "Fidschi",
				"FI": "Finnland",
				"FR": "Frankreich",
				"FX": "Frankreich, Mutterland",
				"GF": "Französisch-Guinea",
				"PF": "Französisch-Polynesien",
				"TF": "Französische Südpolar-Territorien",
				"GA": "Gabun",
				"GM": "Gambia",
				"GE": "Georgien",
				"DE": "Deutschland",
				"GH": "Ghana",
				"GI": "Gibraltar",
				"GR": "Griechenland",
				"GL": "Grönland",
				"GD": "Grenada",
				"GP": "Guadeloupe",
				"GU": "Guam",
				"GT": "Guatemala",
				"GN": "Guinea",
				"GW": "Guinea-Bissau",
				"GY": "Guyana",
				"HT": "Haiti",
				"HM": "Heard und Mc Donald-Inseln",
				"VA": "Heiliger Stuhl (Vatikanstadt)",
				"HN": "Honduras",
				"HK": "Hongkong",
				"HU": "Ungarn",
				"IS": "Island",
				"IN": "Indien",
				"ID": "Indonesien",
				"IR": "Iran",
				"IQ": "Irak",
				"IE": "Irland",
				"IL": "Israel",
				"IT": "Italien",
				"JM": "Jamaika",
				"JP": "Japan",
				"JO": "Jordanien",
				"KZ": "Kasachstan",
				"KE": "Kenia",
				"KI": "Kiribati",
				"KP": "Volksrepublik Korea",
				"KR": "Republik Korea",
				"KW": "Kuwait",
				"KG": "Kirgisistan",
				"LA": "Volksrepublik Laos",
				"LV": "Lettland",
				"LB": "Libanon",
				"LS": "Lesotho",
				"LR": "Liberia",
				"LY": "Libysch-Arabische Dschamahirija",
				"LI": "Liechtenstein",
				"LT": "Litauen",
				"LU": "Luxemburg",
				"MO": "Macao",
				"MK": "Republik Mazedonien",
				"MG": "Madagaskar",
				"MW": "Malawi",
				"MY": "Malaysia",
				"MV": "Malediven",
				"ML": "Mali",
				"MT": "Malta",
				"MH": "Marshallinseln",
				"MQ": "Martinique",
				"MR": "Mauretanien",
				"MU": "Mauritius",
				"YT": "Mayotte",
				"MX": "Mexiko",
				"FM": "Mikronesien",
				"MD": "Republik Moldawien",
				"MC": "Monaco",
				"MN": "Mongolei",
				"MS": "Montserrat",
				"MA": "Marokko",
				"MZ": "Mosambik",
				"MM": "Myanmar",
				"NA": "Namibia",
				"NR": "Nauru",
				"NP": "Nepal",
				"NL": "Niederlande",
				"AN": "Niederländische Antillen",
				"NC": "Neukaledonien",
				"NZ": "Neuseeland",
				"NI": "Nicaragua",
				"NE": "Niger",
				"NG": "Nigeria",
				"NU": "Niue",
				"NF": "Norfolkinseln",
				"MP": "Nördliche Marianen",
				"NO": "Norwegen",
				"OM": "Oman",
				"PK": "Pakistan",
				"PW": "Palau",
				"PA": "Panama",
				"PG": "Papua-Neuguinea",
				"PY": "Paraguay",
				"PE": "Peru",
				"PH": "Philippinen",
				"PN": "Pitcairninseln",
				"PL": "Polen",
				"PT": "Portugal",
				"PR": "Puerto Rico",
				"QA": "Katar",
				"RE": "Réunion",
				"RO": "Rumänien",
				"RU": "Russische Föderation",
				"RW": "Ruanda",
				"KN": "St. Kitts und Nevis",
				"LC": "St. Lucia",
				"VC": "St. Vincent / Grenadinen",
				"WS": "Samoa",
				"SM": "San Marino",
				"ST": "São Tomé und Príncipe",
				"SA": "Saudi-Arabien",
				"SN": "Senegal",
				"SC": "Seychellen",
				"SL": "Sierra Leone",
				"SG": "Singapur",
				"SK": "Slowakei (Slowakische Republik)",
				"SI": "Slowenien",
				"SB": "Salomoninseln",
				"SO": "Somalia",
				"ZA": "Südafrika",
				"GS": "Südgeorgische Sandwichinseln",
				"ES": "Spanien",
				"LK": "Sri Lanka",
				"SH": "St. Helena",
				"PM": "St. Pierre und Miquelon",
				"SD": "Sudan",
				"SR": "Surinam",
				"SJ": "Svalbard und Jan Mayen Inseln",
				"SZ": "Swasiland",
				"SE": "Schweden",
				"CH": "Schweiz",
				"SY": "Syrische Arabische Republik",
				"TW": "Taiwan, chinesische Provinz",
				"TJ": "Tadschikistan",
				"TZ": "Vereinigte Republik Tansania",
				"TH": "Thailand",
				"TG": "Togo",
				"TK": "Tokelau",
				"TO": "Tonga",
				"TT": "Trinidad und Tobago",
				"TN": "Tunesien",
				"TR": "Türkei",
				"TM": "Turkmenistan",
				"TC": "Turks- und Caicosinseln",
				"TV": "Tuvalu",
				"UG": "Uganda",
				"UA": "Ukraine",
				"AE": "Vereinigte Arabische Emirate",
				"GB": "Vereinigtes Königreich",
				"US": "Vereinigte Staaten von Amerika",
				"UM": "Amerikanisch-Ozeanien",
				"UY": "Uruguay",
				"UZ": "Usbekistan",
				"VU": "Vanuatu",
				"VE": "Venezuela",
				"VN": "Vietnam",
				"VG": "Britische Jungferninseln",
				"VI": "US-Jungferninseln",
				"WF": "Wallis und Futuna Inseln",
				"EH": "Westsahara",
				"YE": "Jemen",
				"YU": "Jugoslawien",
				"ZM": "Sambia",
				"ZW": "Zimbabwe",
				"AX": "Åland Islands"
			}
		}
	},
	"en": {
		"translation": {
			"FUZELOC_generic_extensionName": {
				"Chrome": "Fuze for Chrome",
				"Firefox": "Fuze for Firefox",
				"Edge": "Fuze for Edge"
			},
			"FUZELOC_generic_welcome": "Welcome",
			"FUZELOC_generic_clickToCallDescription": "Place Fuze calls from websites you visit and schedule & join Fuze meetings from Google calendar",
			"FUZELOC_generic_meetingDescription": "Create and join Fuze meetings straight from Google Calendar.",
			"FUZELOC_generic_makeCall": "Make a call",
			"FUZELOC_generic_settings": "Settings",
			"FUZELOC_generic_sendFeedback": "Send feedback",
			"FUZELOC_generic_aboutFuze": "About Fuze",
			"FUZELOC_generic_extensionIsDisabled": "Your extension is disabled.",
			"FUZELOC_generic_restore": "Restore",
			"FUZELOC_generic_loading": "Loading...",
			"FUZELOC_generic_callTooltip": "Call using",
			"FUZELOC_generic_addFuzeMeeting": "Add Fuze Meeting",
			"FUZELOC_generic_signOut": "Sign out",
			"FUZELOC_generic_enterNumber": "Enter a number",
			"FUZELOC_generic_cancel": "Cancel",
			"FUZELOC_generic_retry": "Retry",
			"FUZELOC_generic_close": "Close",
			"FUZELOC_generic_save": "Save",
			"FUZELOC_generic_ignore": "Ignore",
			"FUZELOC_generic_logIn": "Log in",
			"FUZELOC_generic_disableFuze": "Disable Fuze",
			"FUZELOC_generic_joinFuzeMeeting": "Join Fuze Meeting",
			"FUZELOC_generic_change": "Change",
			"FUZELOC_generic_use": "Use",
			"FUZELOC_generic_setType": "set type",
			"FUZELOC_generic_default": "(default)",
			"FUZELOC_generic_systemPageMessage": "The extension is not available on new tabs or system pages.",
			"FUZELOC_generic_systemPageInfo": "(Don’t worry, it will still work on other web pages)",
			"FUZELOC_generic_undo": "Undo",
			"FUZELOC_dialPad_dialNumber": "Dial a number",
			"FUZELOC_settings_moreSettings": "More Settings",
			"FUZELOC_settings_clickToCall": "CLICK TO CALL",
			"FUZELOC_settings_clickToCallDescription": "The Fuze logo will appear next to phone numbers on web pages you visit. Click it to place a call.",
			"FUZELOC_settings_callerIdMasking": "Caller ID Masking",
			"FUZELOC_settings_callerIdMaskingDescription": "The placed call will be masked with a area/country code based Caller ID Masking.",
			"FUZELOC_settings_myPrefPhone": "My preferred phone",
			"FUZELOC_settings_homeCountry": "Home Country",
			"FUZELOC_settings_disabledDomains": "Disabled Domains",
			"FUZELOC_settings_joinMeetings": "Fuze meetings",
			"FUZELOC_settings_fuzeMeeting": "GOOGLE CALENDAR",
			"FUZELOC_settings_dateFormat": "Date Format",
			"FUZELOC_prefPhone_prefferedPhone": "preferred phone",
			"FUZELOC_prefPhone_description": "This is the phone that will be used to place your calls.",
			"FUZELOC_prefPhone_selectPhone": "Select a phone",
			"FUZELOC_prefPhone_selectNumber": "Select a number",
			"FUZELOC_prefPhone_genericHint": "This phone will be used to place calls anywhere else you use click-to-call. This includes (if applicable)",
			"FUZELOC_prefPhone_fuzeForSalesforce": "Fuze for Salesforce",
			"FUZELOC_prefPhone_fuzeDesktopIfEnabled": "Fuze Desktop (if enabled)",
			"FUZELOC_prefPhone_phoneHint": "A note about the phone you selected:",
			"FUZELOC_prefPhone_phoneHintInfo": "When you place a call, your selected phone will ring first (it will look like an incoming call from the party you are trying to dial). Once you answer your phone, your party will be dialed.",
			"FUZELOC_prefPhone_unsavedChanges": "Unsaved changes",
			"FUZELOC_prefPhone_unsavedChangesInfo": "You haven't saved your changes. Are you sure you want to leave this page?",
			"FUZELOC_prefPhone_tooltip_onlyAvailableNumber": "This is the only available number for this phone.",
			"FUZELOC_prefPhone_tooltip_invalidNumber": "*Enter a valid number to save this selection.",
			"FUZELOC_prefPhone_tooltip_pleaseEnterValidNumber": "Please enter a valid number to save this selection.",
			"FUZELOC_prefPhone_notification": "Your preferred phone is {preferredPhone} now.",
			"FUZELOC_prefPhone_tooltip_numberChanged": "Number changed! {numberValue} was unavailable for {device}.",
			"FUZELOC_prefPhone_dropdownNamesList": {
				"DESKTOP": "Fuze Desktop ",
				"MOBILE": "Fuze Mobile ",
				"POLYCOM": "Polycom",
				"OTHER": "Other phone "
			},
			"FUZELOC_disabledDomains_disableThisDomain": "Disable this domain",
			"FUZELOC_disabledDomains_description": "The Fuze logo will no longer appear by phone numbers on this web page and single click dialing will be unavailable.",
			"FUZELOC_disabledDomains_info": "If you change your mind later, you can manage your ignored domains below.",
			"FUZELOC_disabledDomains_disable": "disable",
			"FUZELOC_disabledDomains_manageDisabledDomains": "Manage disabled domains",
			"FUZELOC_disabledDomains_notification": " is now an ignored domain. ",
			"FUZELOC_disabledDomains_tooltip_goTo": "Go to ",
			"FUZELOC_disabledDomains_tooltip_removeFromList": "Remove from list",
			"FUZELOC_disabledDomains_domainHasBeenRemoved": " has been removed from the ignored domains list.",
			"FUZELOC_disabledDomains_withoutDisabledDomains": "You haven't disabled any domains yet.",
			"FUZELOC_dateFormat_setDate": "Set your preferred date format",
			"FUZELOC_dateFormat_description": "Fuze needs to know what date format you use in Google Calendar to work properly.",
			"FUZELOC_dateFormat_pleaseSelect": "Please select it in the dropdown below.",
			"FUZELOC_dateFormat_notification": "Your date format is {dateFormat} now.",
			"FUZELOC_moreSettings_selectLanguage": "Select your language",
			"FUZELOC_moreSettings_advancedLogging": "Advanced logging",
			"FUZELOC_moreSettings_advancedLoggingInfo": "Enabling this helps the Fuze team track down any issues you are experiencing",
			"FUZELOC_moreSettings_streamLogging": "Help us improve",
			"FUZELOC_moreSettings_streamLoggingInfo": "Automatically send troubleshooting logs to Fuze to help improve the experience",
			"FUZELOC_teams": "TEAMS",
			"FUZELOC_moreSettings_teams": "Make calls with Fuze on Teams Chat!",
			"FUZELOC_moreSettings_fuzeContacts": "GMAIL",
			"FUZELOC_moreSettings_fuzeContactsInfo": "Call Fuze contacts straight from your gmail emails",
			"FUZELOC_joinMeetings_title": "Join meetings using...",
			"FUZELOC_joinMeetings_description": "When joining a Fuze meeting from Google calendar, launch either Fuze Web or Fuze Desktop.",
			"FUZELOC_modal_joinMeetings_title": "Join your Fuze meeting using...",
			"FUZELOC_modal_joinMeetings_desktop_description": "Join your meeting in the Fuze Desktop app. ",
			"FUZELOC_modal_joinMeetings_web_description": "Join your meeting in your browser with Fuze Web.",
			"FUZELOC_modal_joinMeetings_changeHint": "You can change this later under “settings” in the Fuze extension",
			"FUZELOC_moreSettings_selectLanguageList": [
				{
					"name": "English",
					"code": "en"
				},
				{
					"name": "French",
					"code": "fr"
				},
				{
					"name": "German",
					"code": "de"
				},
				{
					"name": "Italian",
					"code": "it"
				},
				{
					"name": "Spanish",
					"code": "es"
				}
			],
			"FUZELOC_feedback_enterEmail": "Enter your email",
			"FUZELOC_feedback_howCanWeHelp": "How can we help?",
			"FUZELOC_feedback_pickCategory": "Pick a category",
			"FUZELOC_feedback_send": "SEND",
			"FUZELOC_feedback_giveMoreDetails": "Give us more details",
			"FUZELOC_feedback_placeholder": "The more specific you are, the better we can address this issue.",
			"FUZELOC_feedback_unableToSendReport": "Unable to send report",
			"FUZELOC_feedback_reportSent": "Report Sent!",
			"FUZELOC_feedback_errorInfo": "Please wait a few moments and try again. If the problem persists, please contact your IT department directly.",
			"FUZELOC_feedback_reportSentInfo": "For immediate assistance, please contact your IT department directly.",
			"FUZELOC_feedback_typesList": [
				"Click to Call",
				"Fuze Meetings",
				"Sign-in",
				"Other"
			],
			"FUZELOC_about_version": "Version",
			"FUZELOC_about_acknowledgements": "Acknowledgements",
			"FUZELOC_callScreen_calling": "calling...",
			"FUZELOC_callScreen_canNotCompleteCall": "Can't complete call",
			"FUZELOC_callScreen_errorInfo_firstPart": "We're sorry about that. Please try again or ",
			"FUZELOC_callScreen_contactSupport": "contact support",
			"FUZELOC_callScreen_errorInfo_endPart": "if you continue to have issues.",
			"FUZELOC_callScreen_using": "Using",
			"FUZELOC_callScreen_sessionHasExpired": "Oops, we could not complete your call. Your session has expired.",
			"FUZELOC_welcome_welcomeTo": "Welcome to",
			"FUZELOC_welcome_pleaseSignIn": "Please sign-in to get started",
			"FUZELOC_welcome_signIn": "sign in",
			"FUZELOC_welcome_signInLater": "To sign in later, ",
			"FUZELOC_welcome_clickFuzeLogo": "click the Fuze logo",
			"FUZELOC_notification_signIn": "You're signed into ",
			"FUZELOC_notification_signOut": "You signed out of ",
			"FUZELOC_notification_verifyCountry": "Verify Home Country",
			"FUZELOC_notification_verifyCountryInfo": "We had some difficulty verifying your home country. For now,we set it to:",
			"FUZELOC_notification_sessionExpired": "Your session has expired",
			"FUZELOC_notification_sessionExpiredInfo": "Please sign-in again to continue",
			"FUZELOC_notification_disableFuzeOnPage": "Disable Fuze on this page?",
			"FUZELOC_notification_disableFuzeInfo": "We're sorry but Fuze isn't responding. Do you want to disable it on this page?",
			"FUZELOC_notification_conflictingExtension": "Conflicting Extension",
			"FUZELOC_notification_conflictingExtensionInfo": " is experiencing problems because {extensionsListText} extension is enabled.  Please disable {extensionsListText} extension and restart your browser.",
			"FUZELOC_calendar_didYouKnow": "Did you know...",
			"FUZELOC_calendar_didYouKnowInfo": "You can create your own personal meeting link. “Vanity links” are customizable so they are easy to remember and quick to share and reuse.  Go to Fuze>Settings>Meetings to create one.",
			"FUZELOC_calendar_vanityInfo": "Pick the meeting ID your guests will use to join this meeting. Create a new one or use an existing vanity link.*",
			"FUZELOC_calendar_alwaysDefault": "always default to ",
			"FUZELOC_calendar_vanityNotes": "*Notes and shared content associated with your vanity link will be available to all guests. Add, edit, or learn more at ",
			"FUZELOC_calendar_dropdownValues_initial": [
				{
					"customValue": true,
					"name": "new meeting ID"
				}
			],
			"FUZELOC_calendar_dropdownValues_meetingTypes": [
				{
					"customValue": "O",
					"name": "Open meeting",
					"descriptionValue": "This meeting will start as soon as you or anyone from your company joins, and others can join without being accepted. Great for smaller, informal meetings."
				},
				{
					"customValue": "R",
					"name": "Private meeting",
					"descriptionValue": "You need to start this meeting yourself and attendees won't be able to join until you accept them. Great for meetings you want a high degree of control over."
				},
				{
					"customValue": "W",
					"name": "Large meeting",
					"descriptionValue": "You will need to start this yourself. Others will be muted automatically when they join. Great for any large, formal meeting or presentation."
				}
			],
			"FUZELOC_homeCountry_selectCountry": "Select your home country code",
			"FUZELOC_homeCountry_description": "This allows us to connect your calls on web pages that don’t specify a country code.",
			"FUZELOC_homeCountry_callingInternationally": "Calling internationally?",
			"FUZELOC_homeCountry_callingInternationallyInfo": "Just 'click to call', like with any number! If there is a problem connecting,the number may not include the country code. In that case, copy and paste the number into the dialer in this menu, add the right code, and call from there.",
			"FUZELOC_homeCountry_notification": "Your home country is ",
			"FUZELOC_homeCountry_countries": {
				"AF": "Afghanistan",
				"AL": "Albania",
				"DZ": "Algeria",
				"AS": "American Samoa",
				"AD": "Andorra",
				"AO": "Angola",
				"AI": "Anguilla",
				"AG": "Antigua and Barbuda",
				"AR": "Argentina",
				"AM": "Armenia",
				"AW": "Aruba",
				"AU": "Australia",
				"AT": "Austria",
				"AZ": "Azerbaijan",
				"BS": "Bahamas",
				"BH": "Bahrain",
				"BD": "Bangladesh",
				"BB": "Barbados",
				"BY": "Belarus",
				"BE": "Belgium",
				"BZ": "Belize",
				"BJ": "Benin",
				"BM": "Bermuda",
				"BT": "Bhutan",
				"BO": "Bolivia",
				"BA": "Bosnia and Herzegovina",
				"BW": "Botswana",
				"BR": "Brazil",
				"IO": "British Indian Ocean Territory",
				"VG": "British Virgin Islands",
				"BN": "Brunei",
				"BG": "Bulgaria",
				"BF": "Burkina Faso",
				"BI": "Burundi",
				"KH": "Cambodia",
				"CM": "Cameroon",
				"CA": "Canada",
				"CV": "Cape Verde",
				"BQ": "Caribbean Netherlands",
				"KY": "Cayman Islands",
				"CF": "Central African Republic",
				"TD": "Chad",
				"CL": "Chile",
				"CN": "China",
				"CX": "Christmas Island",
				"CC": "Cocos",
				"CO": "Colombia",
				"KM": "Comoros",
				"CD": "Congo",
				"CG": "Congo",
				"CK": "Cook Islands",
				"CR": "Costa Rica",
				"CI": "Côte d’Ivoire",
				"HR": "Croatia",
				"CU": "Cuba",
				"CW": "Curaçao",
				"CY": "Cyprus",
				"CZ": "Czech Republic",
				"DK": "Denmark",
				"DJ": "Djibouti",
				"DM": "Dominica",
				"DO": "Dominican Republic",
				"EC": "Ecuador",
				"EG": "Egypt",
				"SV": "El Salvador",
				"GQ": "Equatorial Guinea",
				"ER": "Eritrea",
				"EE": "Estonia",
				"ET": "Ethiopia",
				"FK": "Falkland Islands",
				"FO": "Faroe Islands",
				"FJ": "Fiji",
				"FI": "Finland",
				"FR": "France",
				"GF": "French Guiana",
				"PF": "French Polynesia",
				"GA": "Gabon",
				"GM": "Gambia",
				"GE": "Georgia",
				"DE": "Germany",
				"GH": "Ghana",
				"GI": "Gibraltar",
				"GR": "Greece",
				"GL": "Greenland",
				"GD": "Grenada",
				"GP": "Guadeloupe",
				"GU": "Guam",
				"GT": "Guatemala",
				"GG": "Guernsey",
				"GN": "Guinea",
				"GW": "Guinea-Bissau",
				"GY": "Guyana",
				"HT": "Haiti",
				"HN": "Honduras",
				"HK": "Hong Kong",
				"HU": "Hungary",
				"IS": "Iceland",
				"IN": "India",
				"ID": "Indonesia",
				"IR": "Iran",
				"IQ": "Iraq",
				"IE": "Ireland",
				"IM": "Isle of Man",
				"IL": "Israel",
				"IT": "Italy",
				"JM": "Jamaica",
				"JP": "Japan",
				"JE": "Jersey",
				"JO": "Jordan",
				"KZ": "Kazakhstan",
				"KE": "Kenya",
				"KI": "Kiribati",
				"XK": "Kosovo",
				"KW": "Kuwait",
				"KG": "Kyrgyzstan",
				"LA": "Laos",
				"LV": "Latvia",
				"LB": "Lebanon",
				"LS": "Lesotho",
				"LR": "Liberia",
				"LY": "Libya",
				"LI": "Liechtenstein",
				"LT": "Lithuania",
				"LU": "Luxembourg",
				"MO": "Macau",
				"MK": "Macedonia",
				"MG": "Madagascar",
				"MW": "Malawi",
				"MY": "Malaysia",
				"MV": "Maldives",
				"ML": "Mali",
				"MT": "Malta",
				"MH": "Marshall Islands",
				"MQ": "Martinique",
				"MR": "Mauritania",
				"MU": "Mauritius",
				"YT": "Mayotte",
				"MX": "Mexico",
				"FM": "Micronesia",
				"MD": "Moldova",
				"MC": "Monaco",
				"MN": "Mongolia",
				"ME": "Montenegro",
				"MS": "Montserrat",
				"MA": "Morocco",
				"MZ": "Mozambique",
				"MM": "Myanmar",
				"NA": "Namibia",
				"NR": "Nauru",
				"NP": "Nepal",
				"NL": "Netherlands",
				"NC": "New Caledonia",
				"NZ": "New Zealand",
				"NI": "Nicaragua",
				"NE": "Niger",
				"NG": "Nigeria",
				"NU": "Niue",
				"NF": "Norfolk Island",
				"KP": "North Korea",
				"MP": "Northern Mariana Islands",
				"NO": "Norway",
				"OM": "Oman",
				"PK": "Pakistan",
				"PW": "Palau",
				"PS": "Palestine",
				"PA": "Panama",
				"PG": "Papua New Guinea",
				"PY": "Paraguay",
				"PE": "Peru",
				"PH": "Philippines",
				"PL": "Poland",
				"PT": "Portugal",
				"PR": "Puerto Rico",
				"QA": "Qatar",
				"RE": "Réunion",
				"RO": "Romania",
				"RU": "Russia",
				"RW": "Rwanda",
				"BL": "Saint Barthélemy",
				"SH": "Saint Helena",
				"KN": "Saint Kitts and Nevis",
				"LC": "Saint Lucia",
				"MF": "Saint Martin",
				"PM": "Saint Pierre and Miquelon",
				"VC": "Saint Vincent and the Grenadines",
				"WS": "Samoa",
				"SM": "San Marino",
				"ST": "São Tomé and Príncipe",
				"SA": "Saudi Arabia",
				"SN": "Senegal",
				"RS": "Serbia",
				"SC": "Seychelles",
				"SL": "Sierra Leone",
				"SG": "Singapore",
				"SX": "Sint Maarten",
				"SK": "Slovakia",
				"SI": "Slovenia",
				"SB": "Solomon Islands",
				"SO": "Somalia",
				"ZA": "South Africa",
				"KR": "South Korea",
				"SS": "South Sudan",
				"ES": "Spain",
				"LK": "Sri Lanka",
				"SD": "Sudan",
				"SR": "Suriname",
				"SJ": "Svalbard and Jan Mayen",
				"SZ": "Swaziland",
				"SE": "Sweden",
				"CH": "Switzerland",
				"SY": "Syria",
				"TW": "Taiwan",
				"TJ": "Tajikistan",
				"TZ": "Tanzania",
				"TH": "Thailand",
				"TL": "Timor-Leste",
				"TG": "Togo",
				"TK": "Tokelau",
				"TO": "Tonga",
				"TT": "Trinidad and Tobago",
				"TN": "Tunisia",
				"TR": "Turkey",
				"TM": "Turkmenistan",
				"TC": "Turks and Caicos Islands",
				"TV": "Tuvalu",
				"VI": "U.S. Virgin Islands",
				"UG": "Uganda",
				"UA": "Ukraine",
				"AE": "United Arab Emirates",
				"GB": "United Kingdom",
				"US": "United States",
				"UY": "Uruguay",
				"UZ": "Uzbekistan",
				"VU": "Vanuatu",
				"VA": "Vatican City",
				"VE": "Venezuela",
				"VN": "Vietnam",
				"WF": "Wallis and Futuna",
				"EH": "Western Sahara",
				"YE": "Yemen",
				"ZM": "Zambia",
				"ZW": "Zimbabwe",
				"AX": "Åland Islands"
			}
		}
	},
	"es": {
		"translation": {
			"FUZELOC_generic_extensionName": {
				"Chrome": "Fuze para Chrome",
				"Firefox": "Fuze para Firefox",
				"Edge": "Fuze para Edge"
			},
			"FUZELOC_generic_welcome": "¡Bienvenido a",
			"FUZELOC_generic_clickToCallDescription": "Realice llamadas desde los sitios web que visita, programe y únase a reuniones de Fuze desde su Google Calendar",
			"FUZELOC_generic_meetingDescription": "Programe y únase a reuniones de Fuze directamente desde su Google Calendar.",
			"FUZELOC_generic_makeCall": "Realizar una llamada",
			"FUZELOC_generic_settings": "Configuración",
			"FUZELOC_generic_sendFeedback": "Enviar comentarios",
			"FUZELOC_generic_aboutFuze": "Acerca de Fuze",
			"FUZELOC_generic_extensionIsDisabled": "Su extensión está deshabilitada.",
			"FUZELOC_generic_restore": "Restablecer",
			"FUZELOC_generic_loading": "Cargando...",
			"FUZELOC_generic_callTooltip": "Llamar con",
			"FUZELOC_generic_addFuzeMeeting": "Añadir reunión de Fuze",
			"FUZELOC_generic_signOut": "Cerrar sesión",
			"FUZELOC_generic_enterNumber": "Introducir un número",
			"FUZELOC_generic_cancel": "Cancelar",
			"FUZELOC_generic_retry": "Volver a intentarlo",
			"FUZELOC_generic_close": "Cerrar",
			"FUZELOC_generic_save": "Guardar",
			"FUZELOC_generic_ignore": "Ignorar",
			"FUZELOC_generic_logIn": "Iniciar sesión",
			"FUZELOC_generic_disableFuze": "Deshabilitar Fuze",
			"FUZELOC_generic_joinFuzeMeeting": "Unirse a reunión de Fuze",
			"FUZELOC_generic_change": "Cambiar",
			"FUZELOC_generic_use": "Usar",
			"FUZELOC_generic_setType": "establecer tipo",
			"FUZELOC_generic_default": "(predeterminado)",
			"FUZELOC_generic_systemPageMessage": "La extensión no está disponible en nuevas pestañas o páginas del sistema.",
			"FUZELOC_generic_systemPageInfo": "(No se preocupe, todavía funcionará en otras páginas web)",
			"FUZELOC_generic_undo": "Deshacer",
			"FUZELOC_dialPad_dialNumber": "Marcar un número",
			"FUZELOC_settings_moreSettings": "Más ajustes",
			"FUZELOC_settings_clickToCall": "HAGA CLIC PARA LLAMAR",
			"FUZELOC_settings_clickToCallDescription": "El logotipo de Fuze aparecerá al lado de los números de teléfono en las páginas web que visite. Haga clic para realizar una llamada.",
			"FUZELOC_settings_myPrefPhone": "Mi teléfono preferido",
			"FUZELOC_settings_homeCountry": "País de origen",
			"FUZELOC_settings_disabledDomains": "Dominios deshabilitados",
			"FUZELOC_settings_fuzeMeeting": "GOOGLE CALENDAR",
			"FUZELOC_settings_dateFormat": "Formato de fecha",
			"FUZELOC_prefPhone_prefferedPhone": "teléfono preferido",
			"FUZELOC_prefPhone_description": "Este es el teléfono que se usará para realizar sus llamadas.",
			"FUZELOC_prefPhone_selectPhone": "Seleccionar un teléfono",
			"FUZELOC_prefPhone_selectNumber": "Seleccione un número",
			"FUZELOC_prefPhone_genericHint": "Este teléfono se usará para realizar llamadas siempre que use “clic para llamar”. Se incluye (si procede)",
			"FUZELOC_prefPhone_fuzeForSalesforce": "Fuze para Salesforce",
			"FUZELOC_prefPhone_fuzeDesktopIfEnabled": "Fuze Desktop (si está habilitado)",
			"FUZELOC_prefPhone_phoneHint": "Una observación sobre el teléfono que ha seleccionado:",
			"FUZELOC_prefPhone_phoneHintInfo": "Cuando realice una llamada, su teléfono seleccionado sonará primero (será como si estuviese recibiendo una llamada entrante del número al que quiera llamar). Una vez que responda al teléfono se marcará el número al que quiera llamar.",
			"FUZELOC_prefPhone_unsavedChanges": "Cambios sin guardar",
			"FUZELOC_prefPhone_unsavedChangesInfo": "No ha guardado sus cambios. ¿Está seguro de que quiere abandonar esta página?",
			"FUZELOC_prefPhone_tooltip_onlyAvailableNumber": "Este es el único número disponible para este teléfono.",
			"FUZELOC_prefPhone_tooltip_invalidNumber": "*Introduzca un número válido para guardar esta selección.",
			"FUZELOC_prefPhone_tooltip_pleaseEnterValidNumber": "Introduzca un número válido para guardar esta selección.",
			"FUZELOC_prefPhone_notification": "Ahora su número preferido es {preferredPhone}.",
			"FUZELOC_prefPhone_tooltip_numberChanged": "El número ha cambiado. {numberValue} no estaba disponible para {device}.",
			"FUZELOC_prefPhone_dropdownNamesList": {
				"DESKTOP": "Fuze Desktop ",
				"MOBILE": "Fuze Mobile ",
				"POLYCOM": "Polycom",
				"OTHER": "Otro teléfono "
			},
			"FUZELOC_disabledDomains_disableThisDomain": "Deshabilitar este dominio",
			"FUZELOC_disabledDomains_description": "El logotipo de Fuze ya no aparecerá al lado de los números de teléfono de esta página web y la marcación con un clic no estará disponible.",
			"FUZELOC_disabledDomains_info": "Si cambia de opinión más tarde, puede gestionar sus dominios ignorados a continuación.",
			"FUZELOC_disabledDomains_disable": "deshabilitar",
			"FUZELOC_disabledDomains_manageDisabledDomains": "Gestionar dominios ignorados",
			"FUZELOC_disabledDomains_notification": " es ahora un dominio ignorado. ",
			"FUZELOC_disabledDomains_tooltip_goTo": "Ir a ",
			"FUZELOC_disabledDomains_tooltip_removeFromList": "Retirar de la lista",
			"FUZELOC_disabledDomains_domainHasBeenRemoved": " se ha retirado de la lista de dominios ignorados.",
			"FUZELOC_disabledDomains_withoutDisabledDomains": "Todavía no ha deshabilitado ningún dominio.",
			"FUZELOC_dateFormat_setDate": "Configure su formato de fecha preferido",
			"FUZELOC_dateFormat_description": "Fuze necesita saber qué formato de fecha usa en Google Calendar para funcionar correctamente.",
			"FUZELOC_dateFormat_pleaseSelect": "Selecciónelo en el siguiente menú desplegable.",
			"FUZELOC_dateFormat_notification": "Ahora su formato de fecha es {dateFormat}.",
			"FUZELOC_moreSettings_selectLanguage": "Seleccione su idioma",
			"FUZELOC_moreSettings_advancedLogging": "Inicio de sesión avanzado",
			"FUZELOC_moreSettings_advancedLoggingInfo": "Habilitar esto ayuda al equipo de Fuze a controlar cualquier problema que esté experimentando",
			"FUZELOC_moreSettings_streamLogging": "Ayúdenos a mejorar",
			"FUZELOC_moreSettings_streamLoggingInfo": "Enviar automáticamente los registros de resolución de problemas a Fuze para mejorar la experiencia",
			"FUZELOC_moreSettings_fuzeContactsInfo": "Llame a sus contactos de Fuze directamente desde sus correos de Gmail",
			"FUZELOC_moreSettings_selectLanguageList": [
				{
					"name": "Inglés",
					"code": "en"
				},
				{
					"name": "Francés",
					"code": "fr"
				},
				{
					"name": "Alemán",
					"code": "de"
				},
				{
					"name": "Italiano",
					"code": "it"
				},
				{
					"name": "Español",
					"code": "es"
				}
			],
			"FUZELOC_feedback_enterEmail": "Introducir el correo electrónico",
			"FUZELOC_feedback_howCanWeHelp": "¿Cómo podemos ayudarle?",
			"FUZELOC_feedback_pickCategory": "Escoja una categoría",
			"FUZELOC_feedback_send": "ENVIAR",
			"FUZELOC_feedback_giveMoreDetails": "Denos más detalles",
			"FUZELOC_feedback_placeholder": "Cuanto más específico sea, más nos ayudará a poder abordar este problema.",
			"FUZELOC_feedback_unableToSendReport": "No se pudo enviar el informe",
			"FUZELOC_feedback_reportSent": "¡Informe enviado!",
			"FUZELOC_feedback_errorInfo": "Espere unos segundos e inténtelo de nuevo. Si el problema persiste, póngase en contacto directamente con el departamento informático.",
			"FUZELOC_feedback_reportSentInfo": "Para obtener asistencia inmediata, póngase en contacto con nuestro departamento informático directamente.",
			"FUZELOC_feedback_typesList": [
				"Haga clic para llamar",
				"Reuniones de Fuze",
				"Iniciar sesión",
				"Otro"
			],
			"FUZELOC_about_version": "Versión",
			"FUZELOC_about_acknowledgements": "Reconocimientos",
			"FUZELOC_callScreen_calling": "llamando...",
			"FUZELOC_callScreen_canNotCompleteCall": "No se puede realizar la llamada",
			"FUZELOC_callScreen_errorInfo_firstPart": "Lo sentimos. Vuelva a intentarlo o ",
			"FUZELOC_callScreen_contactSupport": "póngase en contacto con el servicio de asistencia",
			"FUZELOC_callScreen_errorInfo_endPart": "en caso de que continúe experimentando problemas.",
			"FUZELOC_callScreen_using": "Usando",
			"FUZELOC_callScreen_sessionHasExpired": "Vaya, no hemos podido realizar su llamada. Su sesión ha expirado.",
			"FUZELOC_welcome_welcomeTo": "Bienvenido a",
			"FUZELOC_welcome_pleaseSignIn": "Inicie sesión para comenzar",
			"FUZELOC_welcome_signIn": "sesión iniciada",
			"FUZELOC_welcome_signInLater": "Para iniciar sesión más tarde, ",
			"FUZELOC_welcome_clickFuzeLogo": "haga clic en el logotipo de Fuze",
			"FUZELOC_notification_signIn": "Ha iniciado sesión ",
			"FUZELOC_notification_signOut": "Ha cerrado sesión ",
			"FUZELOC_notification_verifyCountry": "Verificar país de origen",
			"FUZELOC_notification_verifyCountryInfo": "Hemos tenida algunas dificultades para verificar su país de origen. Por ahora lo estableceremos en:",
			"FUZELOC_notification_sessionExpired": "Su sesión ha expirado",
			"FUZELOC_notification_sessionExpiredInfo": "Vuelva a iniciar sesión para continuar",
			"FUZELOC_notification_disableFuzeOnPage": "¿Quiere deshabilitar Fuze en esta página?",
			"FUZELOC_notification_disableFuzeInfo": "Lo sentimos, pero Fuze no está respondiendo. ¿Quiere deshabilitarlo en esta página?",
			"FUZELOC_notification_conflictingExtension": "Extensión conflictiva",
			"FUZELOC_notification_conflictingExtensionInfo": " está experimentando problemas porque la extensión {extensionsListText} está habilitada. Deshabilite la extensión {extensionsListText} y reinicie su navegador.",
			"FUZELOC_calendar_didYouKnow": "¿Sabía qué?",
			"FUZELOC_calendar_didYouKnowInfo": "Puede crear su propio enlace de reunión personal. Los “enlaces personalizados” se pueden personalizar para que sean fáciles de recordar y se puedan compartir y reutilizar rápidamente. Vaya a Fuze>Ajustes>Reuniones para crear uno.",
			"FUZELOC_calendar_vanityInfo": "Seleccione el ID de reunión que usarán sus invitados para unirse a esta reunión. Cree un nuevo enlace personalizado o use uno existente*.",
			"FUZELOC_calendar_alwaysDefault": "siempre predeterminado como ",
			"FUZELOC_calendar_vanityNotes": "* Sus invitados podrán acceder a las notas y a todo el contenido compartido asociado con su enlace personalizado. Añada, edite u obtenga más información en Fuze>Ajustes>Reuniones",
			"FUZELOC_calendar_dropdownValues_initial": [
				{
					"customValue": true,
					"name": "nuevo ID de reunión"
				}
			],
			"FUZELOC_calendar_dropdownValues_meetingTypes": [
				{
					"customValue": "O",
					"name": "Reunión abierta",
					"descriptionValue": "Esta reunión comenzará en cuanto usted o cualquiera de su empresa se una y los demás pueden unirse sin tener que ser aceptados. Ideal para reuniones informales más pequeñas."
				},
				{
					"customValue": "R",
					"name": "Reunión privada",
					"descriptionValue": "Necesita iniciar esta reunión usted mismo y los asistentes no podrán unirse hasta que los acepte. Ideal para reuniones sobre las que quiera tener un alto grado de control."
				},
				{
					"customValue": "W",
					"name": "Gran reunión",
					"descriptionValue": "Necesitará iniciarla usted mismo. Se silenciará automáticamente a los demás cuando se unan. Ideal para cualquier reunión o presentación grande y formal."
				}
			],
			"FUZELOC_homeCountry_selectCountry": "Seleccione el código de su país de origen",
			"FUZELOC_homeCountry_description": "Esto nos permitirá conectar sus llamadas en páginas web que no especifiquen un código de país.",
			"FUZELOC_homeCountry_callingInternationally": "¿Quiere realizar llamadas internacionales?",
			"FUZELOC_homeCountry_callingInternationallyInfo": "Simplemente “haga clic para llamar”, ¡como con cualquier número! Si hubiese un problema con la conexión, puede que el número no incluya el código del país. En ese caso, copie y pegue el número en el marcador en este menú, añada el código adecuado y llame.",
			"FUZELOC_homeCountry_notification": "Su país de origen es ",
			"FUZELOC_homeCountry_countries": {
				"AF": "Afghanistan",
				"AL": "Albania",
				"DZ": "Argelia",
				"AS": "Samoa Americana",
				"AD": "Andorra",
				"AO": "Angola",
				"AI": "Anguila",
				"AQ": "Antártida",
				"AG": "Antigua y Barbuda",
				"AR": "Argentina",
				"AM": "Armenia",
				"AW": "Aruba",
				"AU": "Australia",
				"AT": "Austria",
				"AZ": "Azerbayán",
				"BS": "Bahamas",
				"BH": "Baréin",
				"BD": "Bangladés",
				"BB": "Barbados",
				"BY": "Bielorrusia",
				"BE": "Bélgica",
				"BZ": "Belice",
				"BJ": "Benín",
				"BM": "Islas Bermudas",
				"BT": "Bután",
				"BO": "Bolivia",
				"BA": "Bosnia-Herzegovina",
				"BW": "Botsuana",
				"BV": "Isla Buvet",
				"BR": "Brasil",
				"IO": "Territorio Británico del Océano Índico",
				"BN": "Brunéi Darussalam",
				"BG": "Bulgaria",
				"BF": "Burkina Faso",
				"BI": "Burundi",
				"KH": "Camboya",
				"CM": "Camerún",
				"CA": "Canadá",
				"CV": "Cabo Verde",
				"KY": "Islas Caimán",
				"CF": "República Centroafricana",
				"TD": "Chad",
				"CL": "Chile",
				"CN": "China",
				"CX": "Isla Christmas",
				"CC": "Islas Cocos",
				"CO": "Colombia",
				"KM": "Islas Comoras",
				"CG": "Congo",
				"CD": "República Democrática del Congo",
				"CK": "Islas Cook",
				"CR": "Costa Rica",
				"CI": "Costa de Marfil",
				"HR": "Croacia",
				"CU": "Cuba",
				"CY": "Chipre",
				"CZ": "República Checa",
				"DK": "Dinamarca",
				"DJ": "Yibuti",
				"DM": "Dominica",
				"DO": "República Dominicana",
				"TP": "Timor Oriental",
				"EC": "Ecuador",
				"EG": "Egipto",
				"SV": "El Salvador",
				"GQ": "Guinea Ecuatorial",
				"ER": "Eritrea",
				"EE": "Estonia",
				"ET": "Etiopía",
				"FK": "Islas Malvinas",
				"FO": "Islas Feroe",
				"FJ": "Fiyi",
				"FI": "Finlandia",
				"FR": "Francia",
				"FX": "Francia metropolitana",
				"GF": "Guayana Francesa",
				"PF": "Polinesia Francesa",
				"TF": "Territorios Australes Franceses",
				"GA": "Gabón",
				"GM": "Gambia",
				"GE": "Georgia",
				"DE": "Alemania",
				"GH": "Ghana",
				"GI": "Gibraltar",
				"GR": "Grecia",
				"GL": "Groenlandia",
				"GD": "Granada",
				"GP": "Guadalupe",
				"GU": "Guam",
				"GT": "Guatemala",
				"GN": "Guinea",
				"GW": "Guinea-Bisáu",
				"GY": "Guayana",
				"HT": "Haití",
				"HM": "Islas Heard y McDonald",
				"VA": "Santa Sede (ciudad estado del Vaticano)",
				"HN": "Honduras",
				"HK": "Hong Kong",
				"HU": "Hungría",
				"IS": "Islandia",
				"IN": "India",
				"ID": "Indonesia",
				"IR": "Irán",
				"IQ": "Iraq",
				"IE": "Irlanda",
				"IL": "Israel",
				"IT": "Italia",
				"JM": "Jamaica",
				"JP": "Japón",
				"JO": "Jordania",
				"KZ": "Kazajistán",
				"KE": "Kenia",
				"KI": "Kiribati",
				"KP": "República Popular de Corea",
				"KR": "República de Corea",
				"KW": "Kuwait",
				"KG": "Kirguistán",
				"LA": "República Popular de Laos",
				"LV": "Letonia",
				"LB": "Líbano",
				"LS": "Lesoto",
				"LR": "Liberia",
				"LY": "Libia",
				"LI": "Liechtenstein",
				"LT": "Lituania",
				"LU": "Luxemburgo",
				"MO": "Macao",
				"MK": "Antigua República Yugoslava de Macedonia",
				"MG": "Madagascar",
				"MW": "Malaui",
				"MY": "Malasia",
				"MV": "Maldivas",
				"ML": "Mali",
				"MT": "Malta",
				"MH": "Islas Marshall",
				"MQ": "Martinica",
				"MR": "Mauritania",
				"MU": "Mauricio",
				"YT": "Mayotte",
				"MX": "México",
				"FM": "Micronesia",
				"MD": "Moldavia",
				"MC": "Mónaco",
				"MN": "Mongolia",
				"MS": "Montserrat",
				"MA": "Marruecos",
				"MZ": "Mozambique",
				"MM": "Myanmar/Birmania",
				"NA": "Namibia",
				"NR": "Nauru",
				"NP": "Nepal",
				"NL": "Países Bajos",
				"AN": "Antillas Neerlandesas",
				"NC": "Nueva Caledonia",
				"NZ": "Nueva Zelanda",
				"NI": "Nicaragua",
				"NE": "Níger",
				"NG": "Nigeria",
				"NU": "Niue",
				"NF": "Islas Norfolk",
				"MP": "Islas Marianas",
				"NO": "Noruega",
				"OM": "Omán",
				"PK": "Pakistán",
				"PW": "Palaos",
				"PA": "Panamá",
				"PG": "Papúa Nueva Guinea",
				"PY": "Paraguay",
				"PE": "Perú",
				"PH": "Filipinas",
				"PN": "Pitcairn",
				"PL": "Polonia",
				"PT": "Portugal",
				"PR": "Puerto Rico",
				"QA": "Catar",
				"RE": "Reunión",
				"RO": "Rumanía",
				"RU": "Federación Rusa",
				"RW": "Ruanda",
				"KN": "San Cristóbal y Nieves",
				"LC": "Santa Lucía",
				"VC": "San Vicente y las Granadinas",
				"WS": "Samoa",
				"SM": "San Marino",
				"ST": "Santo Tomé y Príncipe",
				"SA": "Arabia Saudí",
				"SN": "Senegal",
				"SC": "Seychelles",
				"SL": "Sierra Leona",
				"SG": "Singapur",
				"SK": "Eslovaquia",
				"SI": "Eslovenia",
				"SB": "Islas Salomón",
				"SO": "Somalia",
				"ZA": "Sudáfrica",
				"GS": "Islas Georgias del Sur y Sándwich del Sur",
				"ES": "España",
				"LK": "Sri Lanka",
				"SH": "Santa Elena",
				"PM": "San Pedro y Miquelón",
				"SD": "Sudán",
				"SR": "Surinam",
				"SJ": "Islas Svalbard y Jan Mayen",
				"SZ": "Suazilandia",
				"SE": "Suecia",
				"CH": "Suiza",
				"SY": "República Árabe de Siria",
				"TW": "Taiwán, provincia de China",
				"TJ": "Tayikistán",
				"TZ": "Tanzania",
				"TH": "Tailandia",
				"TG": "Togo",
				"TK": "Tokelau",
				"TO": "Tonga",
				"TT": "Trinidad y Tobago",
				"TN": "Túnez",
				"TR": "Turquía",
				"TM": "Turkmenistán",
				"TC": "Islas Turcas y Caicos",
				"TV": "Tuvalu",
				"UG": "Uganda",
				"UA": "Ucrania",
				"AE": "Emiratos Árabes Unidos",
				"GB": "Reino Unido",
				"US": "Estados Unidos",
				"UM": "Islas Ultramarinas Menores de Estados Unidos",
				"UY": "Uruguay",
				"UZ": "Uzbekistán",
				"VU": "Vanuatu",
				"VE": "Venezuela",
				"VN": "Vietnam",
				"VG": "Islas Vírgenes británicas",
				"VI": "Islas Vírgenes de Estados Unidos",
				"WF": "Islas Wallis y Futuna",
				"EH": "Sáhara Occidental",
				"YE": "Yemen",
				"YU": "Yugoslavia",
				"ZM": "Zambia",
				"ZW": "Zimbabwe",
				"AX": "Åland Islands"
			}
		}
	},
	"fr": {
		"translation": {
			"FUZELOC_generic_extensionName": {
				"Chrome": "Fuze pour Chrome",
				"Firefox": "Fuze pour Firefox",
				"Edge": "Fuze pour Edge"
			},
			"FUZELOC_generic_welcome": "Bienvenue",
			"FUZELOC_generic_clickToCallDescription": "Faire des appels Fuze sur les sites web visités, et planifier et rejoindre des réunions Fuze à partir de Google Agenda",
			"FUZELOC_generic_meetingDescription": "Créer et rejoindre les réunions Fuze directement à partir de Google Agenda.",
			"FUZELOC_generic_makeCall": "Faire un appel",
			"FUZELOC_generic_settings": "Paramètres",
			"FUZELOC_generic_sendFeedback": "Envoyer un commentaire",
			"FUZELOC_generic_aboutFuze": "À propos de Fuze",
			"FUZELOC_generic_extensionIsDisabled": "Votre poste est désactivé.",
			"FUZELOC_generic_restore": "Restaurer",
			"FUZELOC_generic_loading": "Chargement...",
			"FUZELOC_generic_callTooltip": "Appeler via",
			"FUZELOC_generic_addFuzeMeeting": "Ajouter réunion Fuze",
			"FUZELOC_generic_signOut": "Fermer la session",
			"FUZELOC_generic_enterNumber": "Saisir un numéro",
			"FUZELOC_generic_cancel": "Annuler",
			"FUZELOC_generic_retry": "Réessayer",
			"FUZELOC_generic_close": "Fermer",
			"FUZELOC_generic_save": "Enregistrer",
			"FUZELOC_generic_ignore": "Ignorer",
			"FUZELOC_generic_logIn": "S'identifier",
			"FUZELOC_generic_disableFuze": "Désactiver Fuze",
			"FUZELOC_generic_joinFuzeMeeting": "Se joindre à une réunion Fuze",
			"FUZELOC_generic_change": "Modifier",
			"FUZELOC_generic_use": "Utiliser",
			"FUZELOC_generic_setType": "définir le type",
			"FUZELOC_generic_default": "(défaut)",
			"FUZELOC_generic_systemPageMessage": "Le poste n'est pas disponible dans les nouveaux onglets ou les pages du système.",
			"FUZELOC_generic_systemPageInfo": "(Ne vous inquiétez pas, il fonctionnera sur d'autres pages web)",
			"FUZELOC_generic_undo": "Annuler",
			"FUZELOC_dialPad_dialNumber": "Composer un numéro",
			"FUZELOC_settings_moreSettings": "Autres paramètres",
			"FUZELOC_settings_clickToCall": "CLICK TO CALL",
			"FUZELOC_settings_clickToCallDescription": "Le logo de Fuze apparaîtra à côté des numéros de téléphone sur les pages web que vous visitez. Cliquez sur lui pour faire un appel.",
			"FUZELOC_settings_myPrefPhone": "Mon téléphone préféré",
			"FUZELOC_settings_homeCountry": "Pays d'origine",
			"FUZELOC_settings_disabledDomains": "Domaines désactivés",
			"FUZELOC_settings_fuzeMeeting": "GOOGLE AGENDA",
			"FUZELOC_settings_dateFormat": "Format de date",
			"FUZELOC_prefPhone_prefferedPhone": "téléphone préféré",
			"FUZELOC_prefPhone_description": "C'est le téléphone qui sera utilisé pour faire vos appels.",
			"FUZELOC_prefPhone_selectPhone": "Choisir un téléphone",
			"FUZELOC_prefPhone_selectNumber": "Choisir un numéro",
			"FUZELOC_prefPhone_genericHint": "Ce téléphone sera utilisé pour faire des appels partout quand vous utiliserez Click-to-call. Cela inclut (le cas échéant)",
			"FUZELOC_prefPhone_fuzeForSalesforce": "Fuze for Salesforce",
			"FUZELOC_prefPhone_fuzeDesktopIfEnabled": "Fuze Desktop (si activé)",
			"FUZELOC_prefPhone_phoneHint": "Une note au sujet du téléphone que vous avez choisi :",
			"FUZELOC_prefPhone_phoneHintInfo": "Quand vous faites un appel, le téléphone choisi commencera par sonner (cela ressemblera à un appel entrant de la personne que vous essayez d'appeler). Quand vous aurez décroché votre téléphone, votre correspondant sera appelé.",
			"FUZELOC_prefPhone_unsavedChanges": "Modifications non enregistrées",
			"FUZELOC_prefPhone_unsavedChangesInfo": "Vous n'avez pas sauvé vos modifications. Voulez-vous vraiment quitter cette page ?",
			"FUZELOC_prefPhone_tooltip_onlyAvailableNumber": "C'est le seul numéro disponible pour ce téléphone.",
			"FUZELOC_prefPhone_tooltip_invalidNumber": "*Saisir un numéro valide pour enregistrer ce choix.",
			"FUZELOC_prefPhone_tooltip_pleaseEnterValidNumber": "Veuillez saisir un numéro valide pour enregistrer ce choix.",
			"FUZELOC_prefPhone_notification": "Votre téléphone préféré est maintenant {preferredPhone}.",
			"FUZELOC_prefPhone_tooltip_numberChanged": "Le numéro a changé ! {numberValue} était indisponible pour {device}.",
			"FUZELOC_prefPhone_dropdownNamesList": {
				"DESKTOP": "Fuze Desktop ",
				"MOBILE": "Fuze Mobile ",
				"POLYCOM": "Polycom",
				"OTHER": "Autre téléphone "
			},
			"FUZELOC_disabledDomains_disableThisDomain": "Désactiver ce domaine",
			"FUZELOC_disabledDomains_description": "Le logo de Fuze n'apparaîtra plus près des numéros de téléphone sur cette page web, et l'appel en un clic sera indisponible.",
			"FUZELOC_disabledDomains_info": "Si vous changez d'avis plus tard, vous pouvez gérer ci-dessous les domaines ignorés.",
			"FUZELOC_disabledDomains_disable": "désactiver",
			"FUZELOC_disabledDomains_manageDisabledDomains": "Gérer les domaines désactivés",
			"FUZELOC_disabledDomains_notification": " est maintenant un domaine ignoré. ",
			"FUZELOC_disabledDomains_tooltip_goTo": "Allez à ",
			"FUZELOC_disabledDomains_tooltip_removeFromList": "Enlever de la liste",
			"FUZELOC_disabledDomains_domainHasBeenRemoved": " a été enlevé de la liste des domaines ignorés.",
			"FUZELOC_disabledDomains_withoutDisabledDomains": "Vous n'avez jusqu'à présent désactivé aucun domaine.",
			"FUZELOC_dateFormat_setDate": "Définir votre format de date préféré",
			"FUZELOC_dateFormat_description": "Fuze a besoin de savoir quel format de date vous utilisez dans Google Agenda pour fonctionner correctement.",
			"FUZELOC_dateFormat_pleaseSelect": "Veuillez le sélectionner dans le menu déroulant ci-dessous.",
			"FUZELOC_dateFormat_notification": "Votre format de date est maintenant {dateFormat}.",
			"FUZELOC_moreSettings_selectLanguage": "Choisir votre langue",
			"FUZELOC_moreSettings_advancedLogging": "Journal avancé",
			"FUZELOC_moreSettings_advancedLoggingInfo": "L'activation du journal avancé permet à l'équipe de Fuze de suivre les problèmes que vous pouvez rencontrer",
			"FUZELOC_moreSettings_streamLogging": "Aidez-nous à nous améliorer",
			"FUZELOC_moreSettings_streamLoggingInfo": "Envoyez automatiquement des journaux de dépannage à Fuze pour nous aider à améliorer votre expérience",
			"FUZELOC_moreSettings_fuzeContactsInfo": "Appeler les contacts Fuze directement à partir de vos e-mails dans Gmail",
			"FUZELOC_moreSettings_selectLanguageList": [
				{
					"name": "Anglais",
					"code": "en"
				},
				{
					"name": "Français",
					"code": "fr"
				},
				{
					"name": "Allemand",
					"code": "de"
				},
				{
					"name": "Italien",
					"code": "it"
				},
				{
					"name": "Espagnol",
					"code": "es"
				}
			],
			"FUZELOC_feedback_enterEmail": "Courriel",
			"FUZELOC_feedback_howCanWeHelp": "Comment pouvons-nous vous aider ?",
			"FUZELOC_feedback_pickCategory": "Sélectionner une catégorie",
			"FUZELOC_feedback_send": "ENVOYER",
			"FUZELOC_feedback_giveMoreDetails": "Donnez-nous plus de détails",
			"FUZELOC_feedback_placeholder": "Plus vous êtes précis, mieux nous pouvons traiter ce problème.",
			"FUZELOC_feedback_unableToSendReport": "Impossible d'envoyer le rapport",
			"FUZELOC_feedback_reportSent": "Rapport envoyé !",
			"FUZELOC_feedback_errorInfo": "Veuillez attendre un moment et essayer de nouveau. Si le problème persiste, veuillez contacter votre service informatique.",
			"FUZELOC_feedback_reportSentInfo": "Pour une assistance immédiate, veuillez contacter votre service informatique directement.",
			"FUZELOC_feedback_typesList": [
				"Click to Call",
				"Réunions Fuze",
				"S'identifier",
				"Autre"
			],
			"FUZELOC_about_version": "Version",
			"FUZELOC_about_acknowledgements": "Remerciements",
			"FUZELOC_callScreen_calling": "appel...",
			"FUZELOC_callScreen_canNotCompleteCall": "Impossible de mener à bien l'appel",
			"FUZELOC_callScreen_errorInfo_firstPart": "Nous sommes désolés à ce sujet. Veuillez réessayer ou ",
			"FUZELOC_callScreen_contactSupport": "contacter l’assistance",
			"FUZELOC_callScreen_errorInfo_endPart": "si vous continuez à avoir des problèmes.",
			"FUZELOC_callScreen_using": "Via",
			"FUZELOC_callScreen_sessionHasExpired": "Oups, nous n'avons pas pu mener à bien votre appel. Votre session a expiré.",
			"FUZELOC_welcome_welcomeTo": "Bienvenue à",
			"FUZELOC_welcome_pleaseSignIn": "Veuillez vous identifier pour commencer",
			"FUZELOC_welcome_signIn": "s'identifier",
			"FUZELOC_welcome_signInLater": "Pour vous identifier ultérieurement, ",
			"FUZELOC_welcome_clickFuzeLogo": "cliquez sur le logo de Fuze",
			"FUZELOC_notification_signIn": "Vous êtes identifié dans ",
			"FUZELOC_notification_signOut": "Vous avez fermé la session de ",
			"FUZELOC_notification_verifyCountry": "Vérifier le pays d'origine",
			"FUZELOC_notification_verifyCountryInfo": "Nous avons eu des difficultés pour vérifier votre pays d'origine. Pour le moment, nous l'avons défini comme :",
			"FUZELOC_notification_sessionExpired": "Votre session a expiré",
			"FUZELOC_notification_sessionExpiredInfo": "Veuillez vous identifier à nouveau pour continuer",
			"FUZELOC_notification_disableFuzeOnPage": "Désactiver Fuze sur cette page ?",
			"FUZELOC_notification_disableFuzeInfo": "Nous sommes désolés mais Fuze ne répond pas. Voulez-vous le désactiver sur cette page ?",
			"FUZELOC_notification_conflictingExtension": "Conflit de postes",
			"FUZELOC_notification_conflictingExtensionInfo": " rencontre des problèmes parce que l'extension {extensionsListText} est activée. Veuillez désactiver l'extension {extensionsListText} et redémarrer votre navigateur.",
			"FUZELOC_calendar_didYouKnow": "Saviez-vous...",
			"FUZELOC_calendar_didYouKnowInfo": "Vous pouvez créer votre propre lien personnel de réunion. Les « vanity links » sont personnalisables de sorte qu'ils sont faciles à mémoriser et rapides à partager et à réutiliser. Aller à Fuze>Paramètres>Réunions pour en créer un.",
			"FUZELOC_calendar_vanityInfo": "Choisir l'ID de réunion que vos invités utiliseront pour se joindre à cette réunion. Créer un nouveau vanity link (lien personnalisable), ou utiliser un vanity link existant.*",
			"FUZELOC_calendar_alwaysDefault": "par défaut, toujours ",
			"FUZELOC_calendar_vanityNotes": "*Les notes et le contenu partagé qui sont associés à votre vanity link seront à la disposition de tous les invités. Ajouter, modifier, ou sachez-en plus dans Fuze>Paramètres>Réunions",
			"FUZELOC_calendar_dropdownValues_initial": [
				{
					"customValue": true,
					"name": "nouvelle ID de réunion"
				}
			],
			"FUZELOC_calendar_dropdownValues_meetingTypes": [
				{
					"customValue": "O",
					"name": "Open meeting",
					"descriptionValue": "Cette réunion commencera dès que vous ou un d'autre membre de votre société s'y joindra, et les autres peuvent se joindre sans passer par l'acceptation. Excellent pour les petites réunions informelles."
				},
				{
					"customValue": "R",
					"name": "Private meeting",
					"descriptionValue": "Vous devez démarrer vous-même cette réunion et les participants ne pourront s'y joindre que lorsque vous les aurez acceptés. Excellent pour des réunions pour lesquelles vous voulez avoir un degré de contrôle important."
				},
				{
					"customValue": "W",
					"name": "Large meeting",
					"descriptionValue": "Vous devrez la démarrer vous-même. Les autres seront automatiquement mis sur silence quand ils se joindront. Excellent pour une grande réunion ou une présentation formelle."
				}
			],
			"FUZELOC_homeCountry_selectCountry": "Sélectionner votre code de pays d'origine",
			"FUZELOC_homeCountry_description": "Cela nous permet d'associer vos appels à des pages web qui ne spécifient pas un code pays.",
			"FUZELOC_homeCountry_callingInternationally": "Appel à l'international ?",
			"FUZELOC_homeCountry_callingInternationallyInfo": "Simplement « Click to call », comme pour n'importe quel numéro ! S'il y a un problème de connexion, il se peut que le code pays ne soit pas inclus dans le numéro. Dans ce cas, copier-coller le numéro dans le numéroteur de ce menu, ajouter le bon code, et appeler ensuite.",
			"FUZELOC_homeCountry_notification": "Votre pays d'origine est ",
			"FUZELOC_homeCountry_countries": {
				"AF": "Afghanistan",
				"AL": "Albanie",
				"DZ": "Algérie",
				"AS": "Samoa américaines",
				"AD": "Andorre",
				"AO": "Angola",
				"AI": "Anguilla",
				"AQ": "Antarctique",
				"AG": "Antigua-et-Barbuda",
				"AR": "Argentine",
				"AM": "Arménie",
				"AW": "Aruba",
				"AU": "Australie",
				"AT": "Autriche",
				"AZ": "Azerbaïdjan",
				"BS": "Bahamas",
				"BH": "Bahreïn",
				"BD": "Bangladesh",
				"BB": "Barbade",
				"BY": "Biélorussie",
				"BE": "Belgique",
				"BZ": "Belize",
				"BJ": "Bénin",
				"BM": "Bermudes",
				"BT": "Bhoutan",
				"BO": "Bolivie",
				"BA": "Bosnie-Bosnie-Herzégovine",
				"BW": "Botswana",
				"BV": "Île Bouvet",
				"BR": "Brésil",
				"IO": "Territoire britannique de l’océan Indien",
				"BN": "Brunei Darussalam",
				"BG": "Bulgarie",
				"BF": "Burkina Faso",
				"BI": "Burundi",
				"KH": "Cambodge",
				"CM": "Cameroun",
				"CA": "Canada",
				"CV": "Cap-Vert",
				"KY": "Îles Caïmans",
				"CF": "République centrafricaine",
				"TD": "Tchad",
				"CL": "Chili",
				"CN": "Chine",
				"CX": "Île Christmas",
				"CC": "Îles Cocos",
				"CO": "Colombie",
				"KM": "Comores",
				"CG": "Congo",
				"CD": "République démocratique du Congo",
				"CK": "Îles Cook",
				"CR": "Costa Rica",
				"CI": "Côte d’Ivoire",
				"HR": "Croatie",
				"CU": "Cuba",
				"CY": "Chypre",
				"CZ": "République tchèque",
				"DK": "Danemark",
				"DJ": "Djibouti",
				"DM": "Dominique",
				"DO": "République dominicaine",
				"TP": "Timor oriental",
				"EC": "Équateur",
				"EG": "Égypte",
				"SV": "Salvador",
				"GQ": "Guinée équatoriale",
				"ER": "Érythrée",
				"EE": "Estonie",
				"ET": "Éthiopie",
				"FK": "Îles Falkland",
				"FO": "Îles Féroé",
				"FJ": "Fidji",
				"FI": "Finlande",
				"FR": "France",
				"FX": "France métropolitaine",
				"GF": "Guinée française",
				"PF": "Polynésie française",
				"TF": "Territoires français du sud",
				"GA": "Gabon",
				"GM": "Gambie",
				"GE": "Géorgie",
				"DE": "Allemagne",
				"GH": "Ghana",
				"GI": "Gibraltar",
				"GR": "Grèce",
				"GL": "Groenland",
				"GD": "Grenade",
				"GP": "Guadeloupe",
				"GU": "Guam",
				"GT": "Guatemala",
				"GN": "Guinée",
				"GW": "Guinée-Bissau",
				"GY": "Guyane",
				"HT": "Haïti",
				"HM": "Îles Heard-et-McDonald",
				"VA": "Saint-Siège (ville de l’état du Vatican)",
				"HN": "Honduras",
				"HK": "Hong Kong",
				"HU": "Hongrie",
				"IS": "Islande",
				"IN": "Inde",
				"ID": "Indonésie",
				"IR": "Iran",
				"IQ": "Irak",
				"IE": "Irlande",
				"IL": "Israël",
				"IT": "Italie",
				"JM": "Jamaïque",
				"JP": "Japon",
				"JO": "Jordanie",
				"KZ": "Kazakhstan",
				"KE": "Kenya",
				"KI": "Kiribati",
				"KP": "République populaire de Corée",
				"KR": "République de Corée",
				"KW": "Koweït",
				"KG": "Kirghizstan",
				"LA": "République populaire lao",
				"LV": "Lettonie",
				"LB": "Liban",
				"LS": "Lesotho",
				"LR": "Liberia",
				"LY": "Jamahiriya arabe libyenne",
				"LI": "Liechtenstein",
				"LT": "Lituanie",
				"LU": "Luxembourg",
				"MO": "Macao",
				"MK": "République de Macédoine",
				"MG": "Madagascar",
				"MW": "Malawi",
				"MY": "Malaisie",
				"MV": "Maldives",
				"ML": "Mali",
				"MT": "Malte",
				"MH": "Îles Marshall",
				"MQ": "Martinique",
				"MR": "Mauritanie",
				"MU": "Maurice",
				"YT": "Mayotte",
				"MX": "Mexique",
				"FM": "Micronésie",
				"MD": "République de Moldavie",
				"MC": "Monaco",
				"MN": "Mongolie",
				"MS": "Montserrat",
				"MA": "Maroc",
				"MZ": "Mozambique",
				"MM": "Birmanie",
				"NA": "Namibie",
				"NR": "Nauru",
				"NP": "Népal",
				"NL": "Pays-Bas",
				"AN": "Antilles néerlandaises",
				"NC": "Nouvelle Calédonie",
				"NZ": "Nouvelle Zélande",
				"NI": "Nicaragua",
				"NE": "Niger",
				"NG": "Nigeria",
				"NU": "Nioué",
				"NF": "Île Norfolk",
				"MP": "Îles Mariannes du Nord",
				"NO": "Norvège",
				"OM": "Oman",
				"PK": "Pakistan",
				"PW": "Palau",
				"PA": "Panama",
				"PG": "Papouasie-Nouvelle-Guinée",
				"PY": "Paraguay",
				"PE": "Pérou",
				"PH": "Philippines",
				"PN": "Pitcairn",
				"PL": "Pologne",
				"PT": "Portugal",
				"PR": "Porto Rico",
				"QA": "Qatar",
				"RE": "Réunion",
				"RO": "Roumanie",
				"RU": "Fédération de Russie",
				"RW": "Rwanda",
				"KN": "Saint-Christophe-et-Niévès",
				"LC": "Sainte-Lucie",
				"VC": "Saint-Vincent-et-les Grenadines",
				"WS": "Samoa",
				"SM": "Saint-Martin",
				"ST": "Sao Tomé-et-Principe",
				"SA": "Arabie Saoudite",
				"SN": "Sénégal",
				"SC": "Seychelles",
				"SL": "Sierra Leone",
				"SG": "Singapour",
				"SK": "Slovaquie (République slovaque)",
				"SI": "Slovénie",
				"SB": "Îles Salomon",
				"SO": "Somalie",
				"ZA": "Afrique du Sud",
				"GS": "Îles Sandwich de la Géorgie du Sud",
				"ES": "Espagne",
				"LK": "Sri Lanka",
				"SH": "Sainte Hélène",
				"PM": "Saint-Pierre et Miquelon",
				"SD": "Soudan",
				"SR": "Surinam",
				"SJ": "Svalbard et îles Jan Mayen",
				"SZ": "Swaziland",
				"SE": "Suède",
				"CH": "Suisse",
				"SY": "République arabe syrienne",
				"TW": "Taïwan, Province de Chine",
				"TJ": "Tadjikistan",
				"TZ": "République unie de Tanzanie",
				"TH": "Thaïlande",
				"TG": "Togo",
				"TK": "Tokélaou",
				"TO": "Tonga",
				"TT": "Trinité-et-Tobago",
				"TN": "Tunisie",
				"TR": "Turquie",
				"TM": "Turkménistan",
				"TC": "Îles Turques-et-Caïques",
				"TV": "Tuvalu",
				"UG": "Ouganda",
				"UA": "Ukraine",
				"AE": "Émirats arabes unis",
				"GB": "Royaume-Uni",
				"US": "États-Unis",
				"UM": "Îles éloignées des États-Unis",
				"UY": "Uruguay",
				"UZ": "Ouzbékistan",
				"VU": "Vanuatu",
				"VE": "Venezuela",
				"VN": "Vietnam",
				"VG": "Îles vierges (britanniques)",
				"VI": "Îles vierges (américaines)",
				"WF": "Îles Wallis et Futuna",
				"EH": "Sahara occidental",
				"YE": "Yémen",
				"YU": "Yougoslavie",
				"ZM": "Zambie",
				"ZW": "Zimbabwe",
				"AX": "Åland Islands"
			}
		}
	},
	"it": {
		"translation": {
			"FUZELOC_generic_extensionName": {
				"Chrome": "Fuze per Chrome",
				"Firefox": "Fuze per Firefox",
				"Edge": "Fuze per Edge"
			},
			"FUZELOC_generic_welcome": "Benvenuto",
			"FUZELOC_generic_clickToCallDescription": "Effettua chiamate Fuze dai siti Web visitati, e pianifica e partecipa alle riunioni Fuze da Google Calendar",
			"FUZELOC_generic_meetingDescription": "Crea e partecipa alle riunioni Fuze direttamente da Google Calendar.",
			"FUZELOC_generic_makeCall": "Effettua una chiamata",
			"FUZELOC_generic_settings": "Impostazioni",
			"FUZELOC_generic_sendFeedback": "Invia feedback",
			"FUZELOC_generic_aboutFuze": "Informazioni su Fuze",
			"FUZELOC_generic_extensionIsDisabled": "Il tuo interno è disattivato.",
			"FUZELOC_generic_restore": "Ripristina",
			"FUZELOC_generic_loading": "Caricamento in corso...",
			"FUZELOC_generic_callTooltip": "Chiama con",
			"FUZELOC_generic_addFuzeMeeting": "Aggiungi riunione Fuze",
			"FUZELOC_generic_signOut": "Disconnessione",
			"FUZELOC_generic_enterNumber": "Immetti un numero",
			"FUZELOC_generic_cancel": "Annulla",
			"FUZELOC_generic_retry": "Riprova",
			"FUZELOC_generic_close": "Chiudi",
			"FUZELOC_generic_save": "Salva",
			"FUZELOC_generic_ignore": "Ignora",
			"FUZELOC_generic_logIn": "Accesso",
			"FUZELOC_generic_disableFuze": "Disattiva Fuze",
			"FUZELOC_generic_joinFuzeMeeting": "Partecipa a una riunione Fuze",
			"FUZELOC_generic_change": "Modifica",
			"FUZELOC_generic_use": "Usa",
			"FUZELOC_generic_setType": "tipo set",
			"FUZELOC_generic_default": "(predefinito)",
			"FUZELOC_generic_systemPageMessage": "L'interno non è disponibile su nuove schede o pagine di sistema.",
			"FUZELOC_generic_systemPageInfo": "(Non preoccuparsi, funzionerà su altre pagine Web)",
			"FUZELOC_generic_undo": "Annulla",
			"FUZELOC_dialPad_dialNumber": "Componi numero",
			"FUZELOC_settings_moreSettings": "Altre impostazioni",
			"FUZELOC_settings_clickToCall": "FAI CLIC PER CHIAMARE",
			"FUZELOC_settings_clickToCallDescription": "Il logo Fuze apparirà accanto ai numeri di telefono sulle pagine Web visitate. Fai clic su di esso per effettuare una chiamata.",
			"FUZELOC_settings_myPrefPhone": "Il mio telefono preferito",
			"FUZELOC_settings_homeCountry": "Paese d'origine",
			"FUZELOC_settings_disabledDomains": "Domini disabilitati",
			"FUZELOC_settings_fuzeMeeting": "GOOGLE CALENDAR",
			"FUZELOC_settings_dateFormat": "Formato data",
			"FUZELOC_prefPhone_prefferedPhone": "telefono preferito",
			"FUZELOC_prefPhone_description": "Questo è il telefono che verrà utilizzato per effettuare le chiamate.",
			"FUZELOC_prefPhone_selectPhone": "Selezionare un telefono",
			"FUZELOC_prefPhone_selectNumber": "Selezionare un numero",
			"FUZELOC_prefPhone_genericHint": "Questo telefono verrà utilizzato anche ovunque sia in uso la funzione di chiamata con un clic. Ciò comprende (se pertinente):",
			"FUZELOC_prefPhone_fuzeForSalesforce": "Fuze for Salesforce",
			"FUZELOC_prefPhone_fuzeDesktopIfEnabled": "Fuze Desktop (se abilitato)",
			"FUZELOC_prefPhone_phoneHint": "Una nota sul telefono selezionato:",
			"FUZELOC_prefPhone_phoneHintInfo": "Quando si effettua una chiamata, il tuo telefono selezionato squilla (assomiglierà a una chiamata in arrivo dall'utente che si sta tentando di chiamare). Una volta risposto al telefono, si effettuerà la chiamata all'interlocutore.",
			"FUZELOC_prefPhone_unsavedChanges": "Modifiche non salvate",
			"FUZELOC_prefPhone_unsavedChangesInfo": "Le modifiche non sono state salvate. Abbandonare la pagina?",
			"FUZELOC_prefPhone_tooltip_onlyAvailableNumber": "Questo è l'unico numero disponibile per questo telefono.",
			"FUZELOC_prefPhone_tooltip_invalidNumber": "*Inserisci un numero valido per salvare questa selezione.",
			"FUZELOC_prefPhone_tooltip_pleaseEnterValidNumber": "Inserire un numero valido per salvare questa selezione.",
			"FUZELOC_prefPhone_notification": "Il telefono preferito ora è {preferredPhone}.",
			"FUZELOC_prefPhone_tooltip_numberChanged": "Il numero è cambiato. {numberValue} non era disponibile per {device}.",
			"FUZELOC_prefPhone_dropdownNamesList": {
				"DESKTOP": "Desktop di Fuze ",
				"MOBILE": "Fuze Mobile ",
				"POLYCOM": "Polycom",
				"OTHER": "Altro telefono "
			},
			"FUZELOC_disabledDomains_disableThisDomain": "Disattiva questo dominio",
			"FUZELOC_disabledDomains_description": "Il logo Fuze non apparirà più con i numeri di telefono su questa pagina Web e la composizione con un solo clic non sarà più disponibile.",
			"FUZELOC_disabledDomains_info": "Se si cambia idea in seguito, è possibile gestire i domini ignorati qui sotto.",
			"FUZELOC_disabledDomains_disable": "disabilita",
			"FUZELOC_disabledDomains_manageDisabledDomains": "Gestisci i domini disattivati",
			"FUZELOC_disabledDomains_notification": " è ora un dominio ignorato. ",
			"FUZELOC_disabledDomains_tooltip_goTo": "Vai a ",
			"FUZELOC_disabledDomains_tooltip_removeFromList": "Rimuovi dall'elenco",
			"FUZELOC_disabledDomains_domainHasBeenRemoved": " è stato rimosso dall'elenco dei domini ignorati.",
			"FUZELOC_disabledDomains_withoutDisabledDomains": "Non hai ancora disattivato alcun dominio.",
			"FUZELOC_dateFormat_setDate": "Impostare il formato data preferito",
			"FUZELOC_dateFormat_description": "Per funzionare correttamente, Fuze ha bisogno di sapere che formato data si utilizza nel Calendario di Google.",
			"FUZELOC_dateFormat_pleaseSelect": "Selezionarlo nel menu a tendina qui sotto.",
			"FUZELOC_dateFormat_notification": "Il formato della data è ora {dateFormat}.",
			"FUZELOC_moreSettings_selectLanguage": "Seleziona la lingua",
			"FUZELOC_moreSettings_advancedLogging": "Registrazione avanzata",
			"FUZELOC_moreSettings_advancedLoggingInfo": "Attivare questa opzione aiuta il team Fuze a rintracciare tutti i problemi che si verificano",
			"FUZELOC_moreSettings_streamLogging": "Aiutaci a migliorare",
			"FUZELOC_moreSettings_streamLoggingInfo": "Invia automaticamente a Fuze i registri di identificazione dei problemi per aiutarci a offrire un’esperienza migliore",
			"FUZELOC_moreSettings_fuzeContactsInfo": "Chiama i contatti Fuze direttamente dalle tue email di Gmail",
			"FUZELOC_moreSettings_selectLanguageList": [
				{
					"name": "Inglese",
					"code": "en"
				},
				{
					"name": "Francese",
					"code": "fr"
				},
				{
					"name": "Tedesco",
					"code": "de"
				},
				{
					"name": "Italiano",
					"code": "it"
				},
				{
					"name": "Spagnolo",
					"code": "es"
				}
			],
			"FUZELOC_feedback_enterEmail": "Immettere l’indirizzo e-mail",
			"FUZELOC_feedback_howCanWeHelp": "Come possiamo essere d'aiuto?",
			"FUZELOC_feedback_pickCategory": "Scegli una categoria",
			"FUZELOC_feedback_send": "Invia",
			"FUZELOC_feedback_giveMoreDetails": "Forniscici ulteriori dettagli",
			"FUZELOC_feedback_placeholder": "Più dettagli abbiamo, meglio riusciremo ad affrontare la questione.",
			"FUZELOC_feedback_unableToSendReport": "Impossibile inviare il rapporto.",
			"FUZELOC_feedback_reportSent": "Rapporto inviato!",
			"FUZELOC_feedback_errorInfo": "Attendere qualche istante e riprovare. Se il problema persiste, contattare direttamente il reparto IT.",
			"FUZELOC_feedback_reportSentInfo": "Per un'assistenza immediata, contattare direttamente il reparto IT.",
			"FUZELOC_feedback_typesList": [
				"Fai clic per chiamare",
				"Riunioni di Fuze",
				"Accedere",
				"Altre"
			],
			"FUZELOC_about_version": "Versione ",
			"FUZELOC_about_acknowledgements": "Riconoscimenti",
			"FUZELOC_callScreen_calling": "chiamata in corso...",
			"FUZELOC_callScreen_canNotCompleteCall": "Impossibile completare la chiamata",
			"FUZELOC_callScreen_errorInfo_firstPart": "Spiacenti. Riprovare o ",
			"FUZELOC_callScreen_contactSupport": "contattare l'assistenza",
			"FUZELOC_callScreen_errorInfo_endPart": "se si continua ad avere problemi.",
			"FUZELOC_callScreen_using": "Usando",
			"FUZELOC_callScreen_sessionHasExpired": "Ops, non siamo riusciti a completare la chiamata. La sessione è scaduta.",
			"FUZELOC_welcome_welcomeTo": "Benvenuto a",
			"FUZELOC_welcome_pleaseSignIn": "Accedere per iniziare",
			"FUZELOC_welcome_signIn": "accedi",
			"FUZELOC_welcome_signInLater": "Per accedere in seguito, ",
			"FUZELOC_welcome_clickFuzeLogo": "clicca sul logo Fuze",
			"FUZELOC_notification_signIn": "Hai effettuato l’accesso a ",
			"FUZELOC_notification_signOut": "Sei uscito da ",
			"FUZELOC_notification_verifyCountry": "Verifica il paese d'origine",
			"FUZELOC_notification_verifyCountryInfo": "Abbiamo avuto qualche difficoltà a verificare il paese d'origine. Per ora, lo abbiamo impostato a:",
			"FUZELOC_notification_sessionExpired": "La sessione è scaduta",
			"FUZELOC_notification_sessionExpiredInfo": "Effettua nuovamente l’accesso per continuare",
			"FUZELOC_notification_disableFuzeOnPage": "Disattivare Fuze in questa pagina?",
			"FUZELOC_notification_disableFuzeInfo": "Spiacenti, ma Fuze non risponde. Disattivarlo in questa pagina?",
			"FUZELOC_notification_conflictingExtension": "Interno in conflitto",
			"FUZELOC_notification_conflictingExtensionInfo": " sta avendo un problema perché l'interno {extensionsListText} è abilitato. Disattivare {extensionsListText} e riavviare il browser.",
			"FUZELOC_calendar_didYouKnow": "Sapevi che...",
			"FUZELOC_calendar_didYouKnowInfo": "È possibile creare un collegamento personale per la riunione. I “collegamenti di reindirizzamento a microsito” sono personalizzabili in modo da essere facili da ricordare e veloci da condividere e riutilizzare. Andare a Fuze>Impostazioni>Riunioni per crearne uno.",
			"FUZELOC_calendar_vanityInfo": "Scegliere l'ID della riunione che gli ospiti utilizzeranno per partecipare a questa riunione. Crearne uno nuovo o utilizzare un collegamento di reindirizzamento a microsito esistente.*",
			"FUZELOC_calendar_alwaysDefault": "sempre predefinito a ",
			"FUZELOC_calendar_vanityNotes": "Le note e i contenuti condivisi associati al collegamento di reindirizzamento a microsito saranno disponibili per tutti gli ospiti. È possibile aggiungere, modificare o saperne di più in Fuze>Impostazioni>Riunioni",
			"FUZELOC_calendar_dropdownValues_initial": [
				{
					"customValue": true,
					"name": "ID nuova riunione"
				}
			],
			"FUZELOC_calendar_dropdownValues_meetingTypes": [
				{
					"customValue": "O",
					"name": "Open meeting",
					"descriptionValue": "Questa riunione avrà inizio non appena tu o una persona della tua azienda si unirà a noi, poi gli altri potranno partecipare senza essere accettati. Ideale per riunioni informali di piccole dimensioni."
				},
				{
					"customValue": "R",
					"name": "Private meeting",
					"descriptionValue": "Si deve iniziare questa riunione e i partecipanti non saranno in grado di partecipare fino a quando non li accetti. Ottimo per le riunioni che si desidera controllare strettamente."
				},
				{
					"customValue": "W",
					"name": "Large meeting",
					"descriptionValue": "Si deve iniziarla. Gli altri verranno automaticamente disattivati quando partecipano. Ottimo per qualsiasi riunione o presentazione formale di grandi dimensioni."
				}
			],
			"FUZELOC_homeCountry_selectCountry": "Seleziona il prefisso nazionale del paese d'origine",
			"FUZELOC_homeCountry_description": "Questo ci consente di collegare le chiamate su pagine Web che non specificano un prefisso nazionale.",
			"FUZELOC_homeCountry_callingInternationally": "Effettui una chiamata a livello internazionale?",
			"FUZELOC_homeCountry_callingInternationallyInfo": "Basta 'fare clic per chiamare', come con qualsiasi numero! Se si verifica un problema di connessione, il numero potrebbe non includere il prefisso nazionale. In questo caso, copiare e incollare il numero nel combinatore telefonico in questo menu, aggiungere il prefisso corretto e chiamare da lì.",
			"FUZELOC_homeCountry_notification": "Il tuo paese d'origine è ",
			"FUZELOC_homeCountry_countries": {
				"AF": "Afghanistan",
				"AL": "Albania",
				"DZ": "Algeria",
				"AS": "Samoa americane",
				"AD": "Andorra",
				"AO": "Angola",
				"AI": "Anguilla",
				"AQ": "Antartico",
				"AG": "Antigua e Barbuda",
				"AR": "Argentina",
				"AM": "Armenia",
				"AW": "Aruba",
				"AU": "Australia",
				"AT": "Austria",
				"AZ": "Azerbaigian",
				"BS": "Bahamas",
				"BH": "Bahrein",
				"BD": "Bangladesh",
				"BB": "Barbados",
				"BY": "Bielorussia",
				"BE": "Belgio",
				"BZ": "Belize",
				"BJ": "Benin",
				"BM": "Bermuda",
				"BT": "Bhutan",
				"BO": "Bolivia",
				"BA": "Bosnia ed Erzegovina",
				"BW": "Botswana",
				"BV": "Isola Bouvet",
				"BR": "Brasile",
				"IO": "Territorio britannico dell’Oceano Indiano",
				"BN": "Brunei Darussalam",
				"BG": "Bulgaria",
				"BF": "Burkina Faso",
				"BI": "Burundi",
				"KH": "Cambogia",
				"CM": "Camerun",
				"CA": "Canada",
				"CV": "Capo Verde",
				"KY": "Isole Cayman",
				"CF": "Repubblica Centrafricana",
				"TD": "Ciad",
				"CL": "Cile",
				"CN": "Cina",
				"CX": "Isola di Natale",
				"CC": "Isole Cocos",
				"CO": "Colombia",
				"KM": "Isole Comore",
				"CG": "Congo",
				"CD": "Repubblica democratica del Congo",
				"CK": "Isole Cook",
				"CR": "Costa Rica",
				"CI": "Costa d’Avorio",
				"HR": "Croazia",
				"CU": "Cuba",
				"CY": "Cipro",
				"CZ": "Repubblica Ceca",
				"DK": "Danimarca",
				"DJ": "Gibuti",
				"DM": "Dominica",
				"DO": "Repubblica Dominicana",
				"TP": "Timor Est",
				"EC": "Ecuador",
				"EG": "Egitto",
				"SV": "El Salvador",
				"GQ": "Guinea Equatoriale",
				"ER": "Eritrea",
				"EE": "Estonia",
				"ET": "Etiopia",
				"FK": "Isole Falkland",
				"FO": "Isole Faroe",
				"FJ": "Fiji",
				"FI": "Finlandia",
				"FR": "Francia",
				"FX": "Francia metropolitana",
				"GF": "Guiana francese",
				"PF": "Polinesia francese",
				"TF": "Terre australi francesi",
				"GA": "Gabon",
				"GM": "Gambia",
				"GE": "Georgia",
				"DE": "Germania",
				"GH": "Ghana",
				"GI": "Gibilterra",
				"GR": "Grecia",
				"GL": "Groenlandia",
				"GD": "Grenada",
				"GP": "Guadalupa",
				"GU": "Guam",
				"GT": "Guatemala",
				"GN": "Guinea",
				"GW": "Guinea-Bissau",
				"GY": "Guyana",
				"HT": "Haiti",
				"HM": "Heard e McDonald",
				"VA": "Santa Sede (Città del Vaticano)",
				"HN": "Honduras",
				"HK": "Hong Kong",
				"HU": "Ungheria",
				"IS": "Islanda",
				"IN": "India",
				"ID": "Indonesia",
				"IR": "Iran",
				"IQ": "Iraq",
				"IE": "Irlanda",
				"IL": "Israele",
				"IT": "Italia",
				"JM": "Giamaica",
				"JP": "Giappone",
				"JO": "Giordania",
				"KZ": "Kazakistan",
				"KE": "Kenya",
				"KI": "Kiribati",
				"KP": "Repubblica popolare di Corea",
				"KR": "Repubblica di Corea",
				"KW": "Kuwait",
				"KG": "Kirghizistan",
				"LA": "Repubblica popolare del Laos",
				"LV": "Lettonia",
				"LB": "Libano",
				"LS": "Lesotho",
				"LR": "Liberia",
				"LY": "Libia",
				"LI": "Liechtenstein",
				"LT": "Lituania",
				"LU": "Lussemburgo",
				"MO": "Macao",
				"MK": "Repubblica di Macedonia",
				"MG": "Madagascar",
				"MW": "Malawi",
				"MY": "Malaysia",
				"MV": "Maldive",
				"ML": "Mali",
				"MT": "Malta",
				"MH": "Isole Marshall",
				"MQ": "Martinica",
				"MR": "Mauritania",
				"MU": "Mauritius",
				"YT": "Mayotte",
				"MX": "Messico",
				"FM": "Micronesia",
				"MD": "Repubblica della Moldavia",
				"MC": "Monaco",
				"MN": "Mongolia",
				"MS": "Montserrat",
				"MA": "Marocco",
				"MZ": "Mozambico",
				"MM": "Myanmar",
				"NA": "Namibia",
				"NR": "Nauru",
				"NP": "Nepal",
				"NL": "Paesi Bassi",
				"AN": "Antille Olandesi",
				"NC": "Nuova Caledonia",
				"NZ": "Nuova Zelanda",
				"NI": "Nicaragua",
				"NE": "Niger",
				"NG": "Nigeria",
				"NU": "Niue",
				"NF": "Isola Norfolk",
				"MP": "Isole Marianne settentrionali",
				"NO": "Norvegia",
				"OM": "Oman",
				"PK": "Pakistan",
				"PW": "Palau",
				"PA": "Panama",
				"PG": "Papua Nuova Guinea",
				"PY": "Paraguay",
				"PE": "Perù",
				"PH": "Filippine",
				"PN": "Pitcairn",
				"PL": "Polonia",
				"PT": "Portogallo",
				"PR": "Porto Rico",
				"QA": "Qatar",
				"RE": "Reunion",
				"RO": "Romania",
				"RU": "Federazione Russa",
				"RW": "Ruanda",
				"KN": "Saint Kitts e Nevis",
				"LC": "Santa Lucia",
				"VC": "Saint Vincent/Grenadine",
				"WS": "Samoa",
				"SM": "San Marino",
				"ST": "São Tomé e Principe",
				"SA": "Arabia Saudita",
				"SN": "Senegal",
				"SC": "Seychelles",
				"SL": "Sierra Leone",
				"SG": "Singapore",
				"SK": "Slovacchia",
				"SI": "Slovenia",
				"SB": "Isole Salomone",
				"SO": "Somalia",
				"ZA": "Sud Africa",
				"GS": "Georgia del Sud e Sandwich australi",
				"ES": "Spagna",
				"LK": "Sri Lanka",
				"SH": "Sant’Elena",
				"PM": "St. Pierre e Miquelon",
				"SD": "Sudan",
				"SR": "Suriname",
				"SJ": "Isole Svalbard e Jan Mayen",
				"SZ": "Swaziland",
				"SE": "Svezia",
				"CH": "Svizzera",
				"SY": "Siria",
				"TW": "Taiwan, provincia della Cina",
				"TJ": "Tagikistan",
				"TZ": "Tanzania",
				"TH": "Thailandia",
				"TG": "Togo",
				"TK": "Tokelau",
				"TO": "Tonga",
				"TT": "Trinidad e Tobago",
				"TN": "Tunisia",
				"TR": "Turchia",
				"TM": "Turkmenistan",
				"TC": "Isole Turks e Caicos",
				"TV": "Tuvalu",
				"UG": "Uganda",
				"UA": "Ucraina",
				"AE": "Emirati Arabi Uniti",
				"GB": "Regno Unito",
				"US": "Stati Uniti",
				"UM": "Isole minori esterne degli Stati Uniti",
				"UY": "Uruguay",
				"UZ": "Uzbekistan",
				"VU": "Vanuatu",
				"VE": "Venezuela",
				"VN": "Vietnam",
				"VG": "Isole Vergini britanniche",
				"VI": "Isole Vergini americane",
				"WF": "Isole Wallis e Futuna",
				"EH": "Sahara Occidentale",
				"YE": "Yemen",
				"YU": "Iugoslavia",
				"ZM": "Zambia",
				"ZW": "Zimbabwe",
				"AX": "Åland Islands"
			}
		}
	}
}
},{}],104:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LocalizationLanguageManager = void 0;
const api_1 = require("./api");
const extensionSettings_1 = require("./repository/extensionSettings");
class LocalizationLanguageManager {
    constructor(settings) {
        this.settings = settings;
        this.placeholderAttr = 'placeholder';
        this.apiLogic = new api_1.APILogic();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(this.apiLogic);
    }
    getTranslate(key) {
        return this.settings.i18next.t(key, { returnObjects: true });
    }
    localize() {
        const that = this;
        const attrSelector = `[${that.settings.dataAttr}]`;
        document.querySelectorAll(attrSelector).forEach((element) => {
            const key = element.getAttribute(that.settings.dataAttr);
            const value = that.getTranslate(key);
            if (element.getAttribute(that.placeholderAttr)) {
                element.setAttribute(that.placeholderAttr, value);
            }
            else {
                if (element.children.length === 0) {
                    element.textContent = value;
                    return;
                }
                const newElement = element.cloneNode(false);
                newElement.textContent = value;
                while (element.children.length > 0) {
                    newElement.appendChild(element.children[0]);
                }
                element.replaceWith(newElement);
            }
        });
    }
    changeLanguage(language) {
        this.settings.i18next.init({
            fallbackLng: this.settings.defaultLanguage,
            lng: language,
            resources: this.settings.locales,
        }, () => {
            this.localize();
        });
    }
    reinitialize() {
        return __awaiter(this, void 0, void 0, function* () {
            const languageCode = yield this.extensionSettings.getLocalizationLanguage();
            if (languageCode && languageCode.length && this.settings.i18next.language !== languageCode) {
                this.changeLanguage(languageCode);
            }
        });
    }
    initialize() {
        let browserLanguage = this.settings.getUILanguage();
        if (!this.settings.locales[browserLanguage]) {
            browserLanguage = this.settings.defaultLanguage;
        }
        this.changeLanguage(browserLanguage);
        this.reinitialize();
    }
}
exports.LocalizationLanguageManager = LocalizationLanguageManager;

},{"./api":61,"./repository/extensionSettings":136}],105:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogContext = void 0;
class LogContext {
    constructor(version, platform, userName, gitBranch, gitCommit) {
        this.source = 'browser_connector';
        this.formatting = '%"time:events.time" [%"string:events.event.l"] %"string:events.event.s"';
        this.v = {
            p: version,
        };
        this.p = platform;
        if (gitBranch) {
            this.g = {
                b: gitBranch,
                c: gitCommit,
            };
        }
        if (userName) {
            this.u = userName;
        }
    }
}
exports.LogContext = LogContext;

},{}],106:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogEntry = void 0;
class LogEntry {
    // level: error, warning, info
    constructor(date, level, message) {
        this.time = date.getTime() / 1000;
        this.event = { l: level, s: message };
    }
}
exports.LogEntry = LogEntry;

},{}],107:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.LogRequest = void 0;
class LogRequest {
    constructor(context, events) {
        this.context = context;
        this.events = events;
    }
}
exports.LogRequest = LogRequest;

},{}],108:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Logging = void 0;
const extensionSettings_1 = require("../repository/extensionSettings");
const message_1 = require("../repository/message");
const log_helper_1 = require("../helpers/log-helper");
const api_1 = require("../api");
class Logging {
    constructor(apiLogicDep) {
        this.apiLogicDep = apiLogicDep;
        this.apiLogic = apiLogicDep || new api_1.APILogic();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(this.apiLogic);
        this.message = new message_1.Message(this.apiLogic);
        this.logHelper = new log_helper_1.LogHelper(this.apiLogic, this.extensionSettings);
    }
    static getInstance(apiLogicDep) {
        if (!Logging.instance) {
            Logging.instance = new Logging(apiLogicDep);
        }
        return Logging.instance;
    }
    showErrorLog(errorMessage, errorCode) {
        return __awaiter(this, void 0, void 0, function* () {
            const streamLoggingState = yield this.extensionSettings.getStreamLoggingState();
            if (errorCode && (typeof errorCode === 'object')) {
                errorCode = JSON.stringify(errorCode);
            }
            if (errorCode) {
                errorMessage = `${errorMessage}: ${errorCode}`;
            }
            this.apiLogic.logWrapper.showErrorLog([errorMessage]);
            if (streamLoggingState) {
                if (Logging.ifBackgroundScript()) {
                    this.logHelper.bufferLog('error', errorMessage);
                }
                else {
                    this.message.sendMessageToBackground({ action: 'sendSplunkLog', level: 'error', message: errorMessage });
                }
            }
        });
    }
    showInfoLog(logMessage, additionalInfo, skipLogStreaming) {
        return __awaiter(this, void 0, void 0, function* () {
            const streamLoggingState = yield this.extensionSettings.getStreamLoggingState();
            if (additionalInfo && (typeof additionalInfo === 'object')) {
                additionalInfo = JSON.stringify(additionalInfo);
            }
            if (additionalInfo) {
                logMessage = `${logMessage}: ${additionalInfo}`;
            }
            this.apiLogic.logWrapper.showInfoLog([logMessage]);
            if (streamLoggingState && !skipLogStreaming) {
                if (Logging.ifBackgroundScript()) {
                    this.logHelper.bufferLog('info', logMessage);
                }
                else {
                    this.message.sendMessageToBackground({ action: 'sendSplunkLog', level: 'info', message: logMessage });
                }
            }
            return true;
        });
    }
    static ifBackgroundScript() {
        if (window.location.protocol.includes('extension') &&
            window.location.href.includes('background.html')) {
            return true;
        }
    }
}
exports.Logging = Logging;

},{"../api":61,"../helpers/log-helper":95,"../repository/extensionSettings":136,"../repository/message":138}],109:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ActionOnMeetingsManager = void 0;
const error_helper_1 = require("../helpers/error-helper");
const environment_1 = require("../repository/environment");
const extensionSettings_1 = require("../repository/extensionSettings");
const logging_1 = require("../logging/logging");
class ActionOnMeetingsManager {
    constructor(apiLogic, meeting) {
        this.apiLogic = apiLogic;
        this.meeting = meeting;
        this.logging = logging_1.Logging.getInstance();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(apiLogic);
        this.environment = new environment_1.Environment(this.extensionSettings);
        this.errorHelper = new error_helper_1.ErrorHelper();
    }
    actionOnMeetings(url, type, data) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const apiEndpoint = yield this.getFuzemeetingsApiEndpoint();
                return this.meeting.sendMeetingsActions(apiEndpoint, `/v1/${url}`, type, data);
            }
            catch (error) {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    error = this.errorHelper.updateCatcherInTheError(error, 'ActionOnMeetingsManager: actionOnMeetings: getFuzemeetingsApiEndpoint: sendMeetingsActions');
                    this.logging.showErrorLog('Failed sending action', error);
                }
                this.errorHelper.checkForAuthError(error);
                return error;
            }
        });
    }
    getMeeting(parameters) {
        const url = (parameters.id) ? (`meetings/${parameters.id}`) : ('meetings/');
        return this.actionOnMeetings(url, 'get', parameters);
    }
    getVanity(parameters) {
        const url = (parameters.vanity) ? (`vanities/${parameters.vanity}`) : ('vanities/');
        return this.actionOnMeetings(url, 'get', parameters);
    }
    getVanities() {
        const url = 'vanities';
        return this.actionOnMeetings(url, 'get', {});
    }
    getMeetingsByFilter(filter) {
        let url = 'meetings?';
        if (filter.end_time && filter.start_time) {
            url += `start_time=lte:${filter.end_time}+and+gte:${filter.start_time}&`;
        }
        if (filter.limit) {
            url += `limit=${filter.limit}`;
        }
        return this.actionOnMeetings(url, 'get', {});
    }
    getMeetingInfo(id) {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            const url = `/v1/meetings/${id}/info`;
            try {
                const apiEndpoint = yield this.getFuzemeetingsApiEndpoint();
                return this.meeting.getMeetingInfo(apiEndpoint, url, id);
            }
            catch (error) {
                let updatedError = error;
                if (!that.errorHelper.isExceptionHandled(error)) {
                    updatedError = that.errorHelper.updateCatcherInTheError(error, 'Repository: contactiveRepository: sendQueryToGetMeetingInfo');
                    that.logging.showErrorLog(`Unable to get the meeting${id} info`, error);
                }
                this.errorHelper.checkForAuthError(error);
                return Promise.reject(updatedError);
            }
        });
    }
    createMeeting(parameters) {
        return __awaiter(this, void 0, void 0, function* () {
            const url = 'meetings';
            const meeting = yield this.actionOnMeetings(url, 'post', parameters);
            // get the meeting with formed invitation message
            return this.getMeetingWithInvitationTemplates(meeting.id);
        });
    }
    getMeetingWithInvitationTemplates(meetingId) {
        const meetingParametersInvitation = {
            format: 'text',
            getInvitationText: 1,
            id: meetingId,
            useTelLinks: 0,
        };
        return this.getMeeting(meetingParametersInvitation);
    }
    updateMeeting(parameters) {
        if (parameters.id) {
            const url = `meetings/${parameters.id}`;
            return this.actionOnMeetings(url, 'patch', parameters);
        }
        else {
            this.logging.showErrorLog('ActionOnMeetingsManager.updateMeeting: There is no meeting id', null);
        }
    }
    deleteMeeting(parameters) {
        if (parameters.id) {
            const url = `meetings/${parameters.id}`;
            return this.actionOnMeetings(url, 'delete', parameters);
        }
        else {
            const error = this.errorHelper.updateCatcherInTheError({ message: 'Could not perform the delete action. There is no meeting id' }, 'ActionOnMeetingsManager: deleteMeeting');
            this.logging.showErrorLog('Failed deleting the meeting', error);
            return error;
        }
    }
    getFuzemeetingsApiEndpoint() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const currentEnvironment = yield this.environment.get(true);
                return this.apiLogic.config.fuzemeetingApiEndpoint[currentEnvironment];
            }
            catch (error) {
                this.logging.showErrorLog('Error in loading fuzemeetingApiEndpoint parameter', error);
            }
        });
    }
}
exports.ActionOnMeetingsManager = ActionOnMeetingsManager;

},{"../helpers/error-helper":92,"../logging/logging":108,"../repository/environment":135,"../repository/extensionSettings":136}],110:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CalendarComponentManager = void 0;
const message_1 = require("../repository/message");
const Tooltip = require("tooltip.js");
const logging_1 = require("../logging/logging");
const extensionSettings_1 = require("../repository/extensionSettings");
class CalendarComponentManager {
    constructor(settings, apiLogic) {
        this.settings = settings;
        this.apiLogic = apiLogic;
        this.tabIndexAttribute = "tabindex";
        this.previousDropdownValue = "";
        this.changeLinkClass = "fuze-for-browser-extension-change-link";
        this.logging = logging_1.Logging.getInstance();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(apiLogic);
        this.fuzeIconHtml = `<img class='fuze-for-browser-extension-icon-event-form' src=${settings.fuzeIconPath}>`;
        this.baseElementSelectorForMainCalendar = `${settings.calendarDomElementCharacteristics.tableInfoSelector} > :nth-child(2)`;
        this.message = new message_1.Message();
        this.subscribeForBackgroundPageMessages();
    }
    createDropdown(dropdownValues, customAttributeName, localizationKey) {
        const listboxDisabledClass = "RDPZE";
        const optionActiveClass = "KKjvXb";
        // we clone existing google calendar html elements to make sure, that our custom elements looks the same
        const dropdownBlock = $(this.settings.calendarDomElementCharacteristics.dropdownSelector).clone();
        // also we remove some attributes to avoid triggering events which shouldn't be triggered for elements which custom elements were cloned from
        dropdownBlock.removeAttr("jscontroller").removeAttr("jsname");
        dropdownBlock.attr("id", this.settings.calendarDomElementCharacteristics.fuzeDropdownId);
        const listboxBlock = dropdownBlock.find("ul").clone(true);
        listboxBlock.html("");
        const listboxElement = $(this.settings.calendarDomElementCharacteristics.listboxSelector).clone();
        listboxElement
            .find("[role='listbox']")
            .removeAttr("jsname")
            .removeAttr("aria-disabled")
            .removeClass(listboxDisabledClass);
        listboxBlock.append(listboxElement);
        listboxBlock.removeAttr("jsaction");
        const optionElement = listboxBlock.find(`[${this.tabIndexAttribute}='-1']`);
        const optionParentElement = optionElement.parent();
        const baseOptionElement = optionElement.first().clone(true);
        optionParentElement.html("");
        const optionElements = [];
        for (let i = 0; i < dropdownValues.length; i++) {
            const tabIndexValue = i ? -1 : 0;
            const ariaSelectedValue = i === 0;
            const newOptionElement = baseOptionElement
                .clone(true)
                .attr(this.tabIndexAttribute, tabIndexValue)
                .attr("aria-selected", ariaSelectedValue.toString());
            const newOptionTextElement = newOptionElement
                .find("span")
                .text(dropdownValues[i].name);
            if (dropdownValues[i].customValue) {
                newOptionElement.attr(customAttributeName, dropdownValues[i].customValue);
                const key = `${localizationKey}.${i.toString()}.name`;
                newOptionTextElement.attr(this.settings.localizationLanguageManager.settings.dataAttr, key);
            }
            else {
                // remove class that makes dropdown option visible in auto created Gmail event
                newOptionElement.removeClass(optionActiveClass);
            }
            newOptionElement.append("<span class='fuze-for-browser-extension-default-dropdown-label'" +
                this.settings.localizationDataAttrPart +
                "'FUZELOC_generic_default'>" +
                this.settings.localizationLanguageManager.getTranslate("FUZELOC_generic_default") +
                "</span>");
            optionElements.push(newOptionElement);
            if (!i && dropdownValues.length > 1) {
                const separatorElement = $(this.settings.calendarDomElementCharacteristics.separatorSelector)
                    .first()
                    .clone();
                optionElements.push(separatorElement);
            }
        }
        optionParentElement.append(optionElements);
        dropdownBlock.append(listboxBlock);
        dropdownBlock.children().first().remove();
        return dropdownBlock;
    }
    isMainCalendar(table) {
        return table && table.length;
    }
    inject(eventFormIsFuzeMeeting) {
        this.logging.showInfoLog("calendarComponentManager.inject called");
        const table = $(this.settings.calendarDomElementCharacteristics.tableInfoSelector);
        if ($("." +
            this.settings.calendarDomElementCharacteristics
                .joinFuzeMeetingRowClass).length) {
            return;
        }
        const isMainCalendar = this.isMainCalendar(table);
        let tableRow = isMainCalendar
            ? table.find(this.settings.calendarDomElementCharacteristics
                .firstRowInTableSelector)
            : $(`${this.settings.calendarDomElementCharacteristics.gmailSidebarSelector} > :first-child`);
        // no need to continue injection when there is no core element
        if (tableRow.length === 0) {
            return;
        }
        const baseSelector = isMainCalendar ? tableRow.next() : "";
        if ($(baseSelector).attr("id")) {
            tableRow = tableRow.next();
        }
        const fuzeButton = this.createFuzeButton(baseSelector);
        if (isMainCalendar) {
            tableRow.after(fuzeButton);
            if (!eventFormIsFuzeMeeting) {
                this.eventFormIsFuzeMeeting = eventFormIsFuzeMeeting;
                this.message.sendMessageToBackground({ action: "getVanities" });
            }
            else {
                this.injectAdditionalElementsBlock(eventFormIsFuzeMeeting, {});
            }
        }
        else {
            $(this.settings.calendarDomElementCharacteristics.gmailSideBarFooterClass).before(fuzeButton);
            this.injectDefaultUsedLinkLabel();
        }
        this.settings.localizationLanguageManager.localize();
        this.logging.showInfoLog("calendarComponentManager.inject tableRow.length", tableRow.length);
    }
    createTooltip(tooltipView) {
        const tooltipElement = document
            .querySelector(this.settings.calendarDomElementCharacteristics.tooltipSignSelector)
            .cloneNode(true);
        tooltipElement.classList.add(this.settings.calendarDomElementCharacteristics.meetingTooltipClass);
        // Remove GCal tooltip logic from cloned element
        tooltipElement.attributes.removeNamedItem("style");
        tooltipElement.attributes.removeNamedItem("jsname");
        tooltipElement.children[0].attributes.removeNamedItem("jscontroller");
        tooltipElement.children[0].attributes.removeNamedItem("jsmodel");
        tooltipElement.children[0].attributes.removeNamedItem("jsaction");
        tooltipElement.querySelector("a").attributes.removeNamedItem("href");
        // @ts-ignore
        new Tooltip(tooltipElement.querySelector("[data-popup-corner]"), {
            placement: "bottom",
            title: tooltipView,
            html: true,
            template: this.settings.gcalTooltipTemplate,
        });
        const tooltipMainElement = $("<div class='fuze-for-browser-extension-meeting-tooltip-wrapper'></div>").append(tooltipElement);
        return tooltipMainElement;
    }
    createFuzeButton(selector) {
        let fuzeButton;
        if (selector) {
            fuzeButton = this.getBaseElement(selector, "");
            fuzeButton.addClass(this.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClass);
            fuzeButton.find("span").html(this.fuzeIconHtml);
            fuzeButton
                .children()
                .first()
                .next()
                .addClass("fuze-for-browser-extension-calendar-button-wrapper")
                .removeAttr("id")
                .html("<div class='fuze-for-browser-extension-link-button'>" +
                "<span id='" +
                this.settings.calendarDomElementCharacteristics
                    .fuzeCreateMeetingButtonId +
                "'" +
                this.settings.localizationDataAttrPart +
                "'FUZELOC_generic_addFuzeMeeting'>" +
                this.settings.localizationLanguageManager.getTranslate("FUZELOC_generic_addFuzeMeeting") +
                "</span>" +
                "<span id='fuze-for-browser-extension-join-meeting'></span>" +
                "</div>");
        }
        else {
            fuzeButton = $(`<div class='${this.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClass}'></div>`);
            fuzeButton.addClass(this.settings.calendarDomElementCharacteristics
                .joinFuzeMeetingRowClassSidebarFlexColumn);
            fuzeButton.html(this.fuzeIconHtml +
                "<span" +
                this.settings.localizationDataAttrPart +
                "'FUZELOC_generic_addFuzeMeeting'>" +
                this.settings.localizationLanguageManager.getTranslate("FUZELOC_generic_addFuzeMeeting") +
                "</span>");
            fuzeButton.wrapInner(`<div class='${this.settings.calendarDomElementCharacteristics.addFuzeMeetingButtonClass}'></div>`);
        }
        return fuzeButton;
    }
    createLabel(labelText, dropdownLabelClass) {
        const label = $(`<span class='${dropdownLabelClass}'${this.settings.localizationDataAttrPart}'FUZELOC_generic_use'>${labelText}</span>`);
        return label;
    }
    createCheckbox(joinFuzeMeetingRowClass, checkboxSelector, checkboxClass) {
        const baseElement = this.getBaseElement(this.baseElementSelectorForMainCalendar, joinFuzeMeetingRowClass);
        baseElement.addClass(checkboxClass);
        const checkbox = $(checkboxSelector).parent().clone();
        checkbox.children().first().removeAttr("jsname");
        checkbox.children().first().removeAttr("id");
        baseElement.children().first().replaceWith(checkbox);
        baseElement.children().first().next().remove();
        return baseElement;
    }
    getBaseElement(selector, joinFuzeMeetingRowClass) {
        // if an element has an "id" then the element can be injected with a third-party extension
        // and has its own styles most likely (for example Zoom Scheduler)
        // so we'lltake the next one as the base selector that belongs to the google calendar
        if ($(selector).attr("id")) {
            selector = $(selector).next();
        }
        const baseElement = $(selector);
        let clonedElement;
        if (baseElement.hasClass(joinFuzeMeetingRowClass)) {
            clonedElement = baseElement.next().clone(true);
        }
        else {
            clonedElement = baseElement.clone(true);
        }
        clonedElement
            .removeAttr("jsaction")
            .removeAttr("jscontroller")
            .removeAttr("jsname");
        return clonedElement;
    }
    addDropdownHandler() {
        const checkboxElement = $(`.${this.settings.calendarDomElementCharacteristics.checkboxClass}`);
        checkboxElement.removeAttr("jscontroller");
        const isChecked = () => {
            const result = checkboxElement
                .find(`[${this.tabIndexAttribute}]`)
                .attr("aria-checked")
                .toString();
            return result === "true";
        };
        const dropdownHandler = (event) => __awaiter(this, void 0, void 0, function* () {
            const usedLink = yield this.extensionSettings.getDefaultUsedLink();
            let selectedOption = event.target;
            // with this check we avoid case when target can be span with "(default)" string
            if (selectedOption.children.length <= 0) {
                selectedOption = selectedOption.parentElement;
            }
            let value = selectedOption.querySelector("span").innerText;
            const defaultValue = this.settings.localizationLanguageManager.getTranslate("FUZELOC_generic_default");
            if (value && value !== defaultValue) {
                if (value !== usedLink.replace(defaultValue, "")) {
                    const labelElement = checkboxElement.find("label");
                    labelElement.find("span").remove();
                    const alwaysDefaultElement = "<span" +
                        this.settings.localizationDataAttrPart +
                        "'FUZELOC_calendar_alwaysDefault'>" +
                        this.settings.localizationLanguageManager.getTranslate("FUZELOC_calendar_alwaysDefault") +
                        "</span>";
                    const selectedValueElement = $(`<span>${value}</span>`);
                    const dataAttr = this.settings.localizationLanguageManager.settings
                        .dataAttr;
                    if ($(event.target).attr(dataAttr) ||
                        $(event.target).find(`[${dataAttr}]`).attr(dataAttr)) {
                        const attrValue = "FUZELOC_calendar_dropdownValues_initial.0.name";
                        selectedValueElement.attr(dataAttr, attrValue);
                    }
                    labelElement
                        .contents()
                        .filter(function () {
                        return this.nodeType === Node.TEXT_NODE;
                    })
                        .each(function () {
                        this.textContent = "";
                        labelElement.append(alwaysDefaultElement);
                        labelElement.append(selectedValueElement);
                    });
                    if (isChecked() && this.previousDropdownValue !== value) {
                        checkboxElement.find(`[${this.tabIndexAttribute}]`).click();
                    }
                    checkboxElement.show();
                }
                else {
                    checkboxElement.hide();
                    if (isChecked()) {
                        checkboxElement.find(`[${this.tabIndexAttribute}]`).click();
                    }
                }
                this.previousDropdownValue = value;
            }
            else {
                checkboxElement.hide();
                if (isChecked()) {
                    checkboxElement.find(`[${this.tabIndexAttribute}]`).click();
                }
            }
        });
        const checkboxHandler = () => {
            const oppositeValue = !isChecked();
            const dropdownValue = document.querySelector(`#${this.settings.calendarDomElementCharacteristics.fuzeDropdownId} [${this.tabIndexAttribute}="0"] span`).innerText;
            const link = oppositeValue
                ? dropdownValue
                : this.settings.localizationLanguageManager.getTranslate("FUZELOC_calendar_dropdownValues_initial")[0].name;
            this.extensionSettings.setDefaultUsedLink(link);
            $("[default-value=true]").attr("default-value", "false");
            let newSelectedValue = $(`#${this.settings.calendarDomElementCharacteristics.fuzeDropdownId}`);
            newSelectedValue = oppositeValue
                ? newSelectedValue.find(`[${this.tabIndexAttribute}=0]`)
                : newSelectedValue.find(`[${this.tabIndexAttribute}]`).first();
            newSelectedValue.attr("default-value", "true");
        };
        const currentDropdownItem = document.querySelector(`#${this.settings.calendarDomElementCharacteristics.fuzeDropdownId} [role="listbox"] [${this.tabIndexAttribute}="0"]`);
        currentDropdownItem.addEventListener("click", () => {
            const dropdownItems = document.querySelector(`#${this.settings.calendarDomElementCharacteristics.fuzeDropdownId} [role="presentation"][jsaction]`);
            dropdownItems.addEventListener("click", dropdownHandler);
            $(`.${this.settings.calendarDomElementCharacteristics.checkboxClass} label`).on("mouseup", checkboxHandler);
        });
    }
    setUsedLinkInDropdown() {
        return __awaiter(this, void 0, void 0, function* () {
            const usedLink = yield this.extensionSettings.getDefaultUsedLink();
            const dropdownValues = $(`#${this.settings.calendarDomElementCharacteristics.fuzeDropdownId} [${this.tabIndexAttribute}]`);
            let selectedValue = dropdownValues.filter(function () {
                return this.querySelector("span").innerText === usedLink;
            });
            if (!selectedValue.length) {
                selectedValue = dropdownValues.first();
                this.extensionSettings.setDefaultUsedLink(selectedValue.find("span").text());
            }
            this.settings.actualizeAdditionalSettingsVisibility(true, selectedValue);
            $("[default-value=true]").attr("default-value", "false");
            $(`#${this.settings.calendarDomElementCharacteristics.fuzeDropdownId} [${this.tabIndexAttribute}=0]`).attr("default-value", "true");
            if (dropdownValues.length > 1) {
                const checkbox = this.createCheckbox(this.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClass, this.settings.calendarDomElementCharacteristics.checkboxSelector, this.settings.calendarDomElementCharacteristics.checkboxClass);
                $(`.${this.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClass}`).after(checkbox);
                this.addDropdownHandler();
            }
        });
    }
    injectAdditionalElementsBlock(eventFormIsFuzeMeeting, vanitiesData) {
        const additionalElementsBlock = this.getBaseElement(this.baseElementSelectorForMainCalendar, this.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClass);
        additionalElementsBlock.children().first().remove();
        additionalElementsBlock.children().first().children().first().remove();
        additionalElementsBlock.find("input").parent().remove();
        const label = this.createLabel(this.settings.localizationLanguageManager.getTranslate("FUZELOC_generic_use"), this.settings.calendarDomElementCharacteristics.dropdownLabelClass);
        additionalElementsBlock.prepend(label);
        let dropdownValues = this.settings.localizationLanguageManager.getTranslate("FUZELOC_calendar_dropdownValues_initial");
        const doesExistVanities = vanitiesData.vanities
            ? vanitiesData.vanities.length
            : false;
        if (doesExistVanities) {
            vanitiesData.vanities.forEach((vanity) => {
                vanity.name = `${vanitiesData.base_url.split("//")[1]}/${vanity.name}`;
            });
            dropdownValues = dropdownValues.concat(vanitiesData.vanities);
        }
        const customAttributeName = "default-value";
        const dropdown = this.createDropdown(dropdownValues, customAttributeName, "FUZELOC_calendar_dropdownValues_initial");
        const children = additionalElementsBlock.find("div:last-child");
        children.first().removeAttr("id").append(dropdown);
        const tooltipView = doesExistVanities
            ? this.settings.calendarDropdownTooltipForVanityView
            : this.settings.defaultCalendarDropdownTooltipView;
        const tooltip = this.createTooltip(tooltipView);
        additionalElementsBlock.append(tooltip);
        $("." +
            this.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClass).append(additionalElementsBlock);
        additionalElementsBlock.wrap(`<div id='${this.settings.calendarDomElementCharacteristics.fuzeAdditionalSettingsId}'></div>`);
        if (!eventFormIsFuzeMeeting &&
            !$(`.${this.settings.calendarDomElementCharacteristics.busySpinnerClass}`)
                .length) {
            this.setUsedLinkInDropdown();
        }
    }
    injectDefaultUsedLinkLabel() {
        return __awaiter(this, void 0, void 0, function* () {
            let usedLink = yield this.extensionSettings.getDefaultUsedLink();
            const isNewMeetingIdValue = usedLink ? usedLink.indexOf("/") < 0 : null;
            if (!usedLink || isNewMeetingIdValue) {
                usedLink = this.settings.localizationLanguageManager.getTranslate("FUZELOC_calendar_dropdownValues_initial")[0].name;
            }
            const usedLinkElement = $(`<span>${usedLink}</span>`);
            if (isNewMeetingIdValue) {
                usedLinkElement.attr(this.settings.localizationLanguageManager.settings.dataAttr, "FUZELOC_calendar_dropdownValues_initial.0.name");
            }
            const labelText = "<span" +
                this.settings.localizationDataAttrPart +
                "'FUZELOC_generic_use'>" +
                this.settings.localizationLanguageManager.getTranslate("FUZELOC_generic_use") +
                "</span> " +
                usedLinkElement[0].outerHTML +
                ".  ";
            const label = $(`<div class='fuze-for-browser-extension-sidebar-label'>${labelText}</div>`);
            label.append($(`<span class='${this.changeLinkClass}'>Change</span>`));
            $(`.${this.settings.calendarDomElementCharacteristics.addFuzeMeetingButtonClass}`).after(label);
            const injectedFuzeRow = document.querySelector(`.${this.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClassSidebarFlexColumn}`);
            if (!injectedFuzeRow) {
                return;
            }
            let editButton = document.querySelector(this.settings.calendarDomElementCharacteristics.gmailSideBarJavascriptDiv);
            $(`.${this.changeLinkClass}`).on("click", () => {
                editButton.click();
            });
        });
    }
    subscribeForBackgroundPageMessages() {
        this.message.addMessageListener((message) => {
            if (!message || !message.action) {
                return;
            }
            switch (message.action) {
                case "returnVanities":
                    if (message.error) {
                        return this.logging.showErrorLog("Unable get vanities", message.error);
                    }
                    this.injectAdditionalElementsBlock(this.eventFormIsFuzeMeeting, message.vanities);
                    break;
            }
        });
    }
}
exports.CalendarComponentManager = CalendarComponentManager;

},{"../logging/logging":108,"../repository/extensionSettings":136,"../repository/message":138,"tooltip.js":59}],111:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CalendarObserver = void 0;
const message_1 = require("../repository/message");
const logging_1 = require("../logging/logging");
class CalendarObserver {
    constructor(settings) {
        this.settings = settings;
        this.gSuiteLoaded = false;
        this.node = document.body;
        this.config = { subtree: true, childList: true, characterData: true };
        this.logging = logging_1.Logging.getInstance();
        this.doesElementExist = (elementSelector) => Boolean(document.querySelector(elementSelector));
        this.launchMeetingObserver = new this.settings.MutationObserverBase(() => this.callback(), this.node, this.config);
        this.message = new message_1.Message();
        this.subscribeForBackgroundPageMessages();
    }
    observe() {
        // BROW-1002, MutationObserver starts working after page loaded, sometimes there are no DOM events to trigger
        // MutationObserver that will initialize meeting edit form, due to this fact we make this explicitly
        this.callback();
        this.launchMeetingObserver.observe();
    }
    disconnect() {
        this.launchMeetingObserver.disconnect();
    }
    getFuzeMeetingId(whereSelector) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const whereData = this.settings.getWhereData(whereSelector);
                if (whereData) {
                    return yield this.settings.getMeetingIdFromWhere(whereData);
                }
            }
            catch (error) {
                this.logging.showInfoLog(`LaunchMeetingButton: initializeMeetingData: could not get meeting id`, error);
            }
        });
    }
    initializeMeetingData(whereSelector) {
        return __awaiter(this, void 0, void 0, function* () {
            const id = yield this.getFuzeMeetingId(whereSelector);
            this.message.sendMessageToBackground({ action: 'getMeetingDetails', id });
        });
    }
    initializeLaunchMeetingButton(whereSelector, containerSelector) {
        return __awaiter(this, void 0, void 0, function* () {
            const whereData = this.settings.getWhereData(whereSelector);
            if (whereData) {
                try {
                    const meetingId = yield this.settings.getMeetingIdFromWhere(whereData);
                    if (meetingId) {
                        this.message.sendMessageToBackground({
                            action: 'getLaunchMeetingUrl',
                            containerSelector,
                            meetingId,
                            whereData,
                            whereSelector,
                        });
                    }
                    else {
                        const launchMeetingUrl = this.settings.getMeetingUrlFromWhere(whereData);
                        if (launchMeetingUrl) {
                            this.settings.createLaunchMeetingButton(whereSelector, containerSelector, launchMeetingUrl);
                        }
                    }
                }
                catch (error) {
                    if (!this.settings.errorHelper.isExceptionHandled(error)) {
                        error = this.settings.errorHelper.updateCatcherInTheError(error, 'LaunchMeetingButton: initializeLaunchMeetingButton');
                        this.logging.showErrorLog('Could not get the current meeting id from whereData ' + whereData, error);
                    }
                    throw error;
                }
            }
            else {
                const selectedValueInDropdown = $(`#${this.settings.calendarDomElementCharacteristics.fuzeAdditionalSettingsId} [tabindex='0']`);
                this.settings.actualizeAdditionalSettingsVisibility(true, selectedValueInDropdown);
            }
        });
    }
    //function to check if the GSUITE is already loaded so we dont present duplicate buttons / ways
    // to perform the same actions. Will be commented out for now
    isGSuiteLoaded() {
        const CalendarEventDetailVideoConferencingSelect = document.querySelector('div .emaTS.yLISWd');
        //if (CalendarEventDetailVideoConferencingSelect.outerHTML.indexOf('Fuze')>-1) return true;
        return false;
    }
    loadEventForm() {
        return __awaiter(this, void 0, void 0, function* () {
            this.gSuiteLoaded = this.gSuiteLoaded || this.isGSuiteLoaded();
            if (this.gSuiteLoaded)
                return;
            if (!this.doesElementExist(`.${this.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClass}`)) {
                this.settings.initializeEventForm();
                if ((yield this.settings.getDoesExpectToCreateAMeeting()) && this.doesElementExist(this.settings.calendarDomElementCharacteristics.locationSelector)) {
                    this.settings.performTheDeferredCreationOfTheFuzeMeeting();
                }
                this.settings.setDoesExpectToCreateAMeeting(false);
                let whereSelector = '';
                const isOwnEventForm = this.doesElementExist(this.settings.calendarDomElementCharacteristics.locationEventFormSelector);
                const isAttendeeEventForm = this.doesElementExist(this.settings.calendarDomElementCharacteristics.locationEventFormForAttendeeSelector);
                if (isOwnEventForm) {
                    whereSelector = this.settings.calendarDomElementCharacteristics.locationEventFormSelector;
                }
                else if (isAttendeeEventForm) {
                    whereSelector = this.settings.calendarDomElementCharacteristics.locationEventFormForAttendeeSelector;
                }
                if (whereSelector) {
                    this.initializeLaunchMeetingButton(whereSelector, this.settings.calendarDomElementCharacteristics.joinFuzeWrapperSelector);
                    this.initializeMeetingData(whereSelector);
                }
            }
        });
    }
    callback() {
        // if opened new edit form on sidebar
        if (this.doesElementExist(this.settings.calendarDomElementCharacteristics.gmailSidebarSelector) &&
            this.doesElementExist(this.settings.calendarDomElementCharacteristics.descriptionTextSelector)) {
            this.loadEventForm();
        }
        else {
            // if opened edit form from main calendar
            if (this.settings.windowRepository.getCurrentURL().match(this.settings.calendarDomElementCharacteristics.calendarEventEditUrl)) {
                this.loadEventForm();
                return;
            }
            else {
                // if opened tooltip on main calendar or event edit form on sidebar
                if (this.doesElementExist(this.settings.calendarDomElementCharacteristics.locationTooltipSelector) ||
                    this.doesElementExist(this.settings.calendarDomElementCharacteristics.tooltipIdentificationElementSelector) ||
                    this.doesElementExist(this.settings.calendarDomElementCharacteristics.tooltipSelector)) { // calendar tooltip
                    this.settings.initializeCalendarTooltipsManager();
                    if (this.doesElementExist(this.settings.calendarDomElementCharacteristics.locationTooltipSelector)) {
                        this.initializeLaunchMeetingButton(this.settings.calendarDomElementCharacteristics.locationTooltipSelector, this.settings.calendarDomElementCharacteristics.locationTooltipSelector);
                        return;
                    }
                }
            }
        }
    }
    processMeetingDetails(meeting) {
        if (meeting.is_host) {
            let isOwnEvent = this.doesElementExist(this.settings.calendarDomElementCharacteristics.subjectSelector);
            const eventOrganizerEmail = $(this.settings.calendarDomElementCharacteristics.eventOrganaizerSelector).attr('key');
            if (eventOrganizerEmail) {
                const currentGoogleCalendarUserEmail = $(this.settings.calendarDomElementCharacteristics.googleCalendarUserEmailSelector).html();
                isOwnEvent = isOwnEvent && (eventOrganizerEmail.toString() === currentGoogleCalendarUserEmail);
            }
            if (isOwnEvent) {
                this.settings.setJoinFuzeMeetingState();
                this.settings.setMeetingDetails(meeting);
            }
        }
    }
    subscribeForBackgroundPageMessages() {
        this.message.addMessageListener((message) => {
            if (!message || !message.action) {
                return;
            }
            switch (message.action) {
                case 'returnMeetingDetails':
                    if (message.error) {
                        return this.logging.showErrorLog('Unable get meeting details', message.error);
                    }
                    this.processMeetingDetails(message.meeting);
                    break;
                case 'returnLaunchMeetingUrl':
                    if (message.error) {
                        return this.logging.showErrorLog(`Could not get the meeting url for the meeting ${message.meetingId}`, message.error);
                    }
                    let launchMeetingUrl = message.launchMeetingUrl;
                    if (message.launchMeetingUrl) {
                        this.settings.createLaunchMeetingButton(message.whereSelector, message.containerSelector, launchMeetingUrl, message.meetingId);
                    }
                    else {
                        launchMeetingUrl = this.settings.getMeetingUrlFromWhere(message.whereData);
                        if (launchMeetingUrl) {
                            this.settings.createLaunchMeetingButton(message.whereSelector, message.containerSelector, launchMeetingUrl, message.meetingId);
                        }
                    }
                    break;
            }
        });
    }
}
exports.CalendarObserver = CalendarObserver;

},{"../logging/logging":108,"../repository/message":138}],112:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.GoogleCalendarTooltipsManager = void 0;
class GoogleCalendarTooltipsManager {
    constructor(settings) {
        this.settings = settings;
        this.fuzeCreateButtonClassName = 'fuze-for-browser-extension-create-meeting';
        this.fuzeCreateButtonSelector = '.' + this.fuzeCreateButtonClassName;
        this.popupCreateFuzeMeetingBtnClass = settings.calendarDomElementCharacteristics.popupCreateFuzeMeetingBtn;
    }
    initialize() {
        if (this.settings.doesElementExist(this.settings.tooltipSelector)) {
            this.addCreateFuzeMettingsButton();
        }
    }
    addCreateFuzeMettingsButton() {
        // check if "Event" tab is active and hide "Add Fuze Meeting" btn if it exists
        const eventTabSelectedAttribute = document.querySelector(this.settings.popupTablist).firstElementChild.getAttribute('aria-selected');
        if (eventTabSelectedAttribute === 'false') {
            const addFuzeMeetingBtn = document.querySelector(this.fuzeCreateButtonSelector);
            if (addFuzeMeetingBtn) {
                return addFuzeMeetingBtn.style.display = 'none';
            }
        }
        const editLink = $(this.settings.moreOptionsButtonSelection);
        if (editLink && editLink.length) {
            if (editLink.css('display').toString() !== 'none') {
                if (!this.settings.doesElementExist(this.fuzeCreateButtonSelector) && this.settings.doesElementExist(this.settings.googleCreateButtonSelector)) {
                    this.injectFuzeCreateMeetingButton();
                    if (this.settings.doesElementExist(this.fuzeCreateButtonSelector)) {
                        $(this.fuzeCreateButtonSelector).on('click', () => __awaiter(this, void 0, void 0, function* () {
                            if (this.settings.doesElementExist(this.settings.googleEditButtonSelector)) {
                                yield this.settings.setDoesExpectToCreateAMeeting(true);
                                editLink[0].click();
                            }
                        }));
                    }
                }
                else {
                    document.querySelector(this.fuzeCreateButtonSelector).style.display = 'inline-block';
                }
            }
            else {
                if (this.settings.doesElementExist(this.fuzeCreateButtonSelector)) {
                    $(this.fuzeCreateButtonSelector).remove();
                }
            }
        }
    }
    injectFuzeCreateMeetingButton() {
        const googleCreateButtonToCopy = $(this.settings.googleCreateButtonSelector);
        const fuzeCreateMeetingButtonToAdd = $('<div>').html('');
        const fuzeCreateButtonFullClassName = `${googleCreateButtonToCopy.attr('class')} ${this.fuzeCreateButtonClassName} ${this.popupCreateFuzeMeetingBtnClass}`;
        const classesForNewButton = fuzeCreateButtonFullClassName.split(' ');
        classesForNewButton.forEach((className) => {
            fuzeCreateMeetingButtonToAdd.addClass(className);
        });
        fuzeCreateMeetingButtonToAdd.html('&nbsp;' + this.settings.createFuzeMeetingButtonOnGoogleCalendarTooltipInterior +
            '<span' + this.settings.localizationDataAttrPart + '\'FUZELOC_generic_addFuzeMeeting\'>' + this.settings.buttonName + '</span>');
        if (!this.settings.doesElementExist(this.settings.titleSelector)) {
            googleCreateButtonToCopy.after(fuzeCreateMeetingButtonToAdd);
        }
    }
}
exports.GoogleCalendarTooltipsManager = GoogleCalendarTooltipsManager;

},{}],113:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LaunchMeetingButton = void 0;
const first_time_join_meeting_1 = require("../modals/first-time-join-meeting");
const logging_1 = require("../logging/logging");
class LaunchMeetingButton {
    constructor(settings, apiLogic, extensionSettings, message, localizationLanguageManager) {
        this.settings = settings;
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.message = message;
        this.localizationLanguageManager = localizationLanguageManager;
        this.containerSelectorAdditionalClass = 'fuze-for-browser-extension-launch-button-added';
        this.launchMeetingButtonIdPart = 'fuze-for-browser-extension-launch-meeting';
        this.calendarDomElementSelectors = require('../google-calendar-dom-element-characteristics');
        this.logging = logging_1.Logging.getInstance();
        this.meetingId = settings.meetingId || '';
        this.inject();
    }
    /**
   * Return a object with all information about how extension will launch the Fuze App(Desktop and Ion).
   *
   * @returns A object with meetingId and Fuze Launch Protocol url.
   */
    getJoinMeetingParameters() {
        const url = `fuze://fuze.me/${this.meetingId}`;
        const joinMeetingParameters = {
            currentLaunchType: 'attendee',
            meetingId: this.meetingId,
            meetingNumber: this.meetingId,
            url,
        };
        this.logging.showInfoLog('LaunchMeetingButton.getJoinMeetingParameters: joinMeetingParameters', joinMeetingParameters);
        return joinMeetingParameters;
    }
    removeMeetingCreationState() {
        $(`.${this.settings.busySpinnerClass}`).remove();
        $(`.${this.settings.meetingCreationStateClass}`).removeClass(this.settings.meetingCreationStateClass);
        $(`#${this.settings.fuzeAdditionalSettingsId}`).show();
    }
    getButton() {
        const busySpinnerElement = $(`.${this.settings.busySpinnerClass}`);
        const isBusySpinnerExist = busySpinnerElement && busySpinnerElement.length;
        const iFrameSidebar = document.querySelector(this.calendarDomElementSelectors.gmailSidebarIFrameSelector);
        const fuzeMeetingButtonNameSpan = document.createElement('span');
        fuzeMeetingButtonNameSpan.setAttribute(this.settings.localizationDataAttrPart, 'FUZELOC_generic_joinFuzeMeeting');
        if (isBusySpinnerExist) {
            this.removeMeetingCreationState();
        }
        if (iFrameSidebar) {
            const fuzeMeetingButtonLink = document.createElement('a');
            fuzeMeetingButtonLink.id = `${this.meetingId}.${this.launchMeetingButtonIdPart}`;
            fuzeMeetingButtonLink.href = this.settings.meetingUrl;
            fuzeMeetingButtonLink.appendChild(this.settings.fuzeImage);
            fuzeMeetingButtonLink.appendChild(fuzeMeetingButtonNameSpan);
            return fuzeMeetingButtonLink;
        }
        else {
            const fuzeMeetingButton = document.createElement('button');
            fuzeMeetingButton.id = `${this.meetingId}.${this.launchMeetingButtonIdPart}`;
            fuzeMeetingButton.setAttribute('data-href', this.settings.meetingUrl);
            fuzeMeetingButton.appendChild(this.settings.fuzeImage);
            fuzeMeetingButton.appendChild(fuzeMeetingButtonNameSpan);
            return fuzeMeetingButton;
        }
    }
    startFuzeAppLauncher() {
        FuzeAppLauncher.JoinMeetingWithNativeApp(this.getJoinMeetingParameters());
    }
    launch() {
        return __awaiter(this, void 0, void 0, function* () {
            if (!this.meetingId) {
                return this.logging.showInfoLog('LaunchMeetingButton.launch could not find fuze meeting id', $(`[id$='${this.launchMeetingButtonIdPart}']`)[0]);
            }
            if (!this.settings.launchMeetingUrl) {
                return this.logging.showInfoLog(`LaunchMeetingButton.launch could not get launchMeetingUrl for meeting ${this.meetingId}`);
            }
            const joinMeetingsOption = yield this.extensionSettings.getJoinMeetingsOption();
            const firstTimeJoinMeetingsOption = yield this.extensionSettings.getFirstTimeJoinMeetingState();
            if (!firstTimeJoinMeetingsOption && joinMeetingsOption !== this.apiLogic.constants.joinMeetingsOptions.WEB_ONLY) {
                const firstTimeJoin = new first_time_join_meeting_1.FirstTimeJoinMeeting(joinMeetingsOption, this.apiLogic, this.extensionSettings);
                const boundJoinByDesktop = this.joinByDesktop.bind(this);
                const boundJoinByWeb = this.joinByWeb.bind(this);
                yield this.extensionSettings.setFirstTimeJoinMeetingState(true);
                firstTimeJoin.showModal(boundJoinByDesktop, boundJoinByWeb);
                return this.localizationLanguageManager.localize();
            }
            if (joinMeetingsOption !== this.apiLogic.constants.joinMeetingsOptions.DESKTOP) {
                return this.joinByWeb();
            }
            return this.joinByDesktop();
        });
    }
    joinByDesktop() {
        this.logging.showInfoLog('LaunchMeetingButton.launch: joined by Fuze Desktop', null);
        this.startFuzeAppLauncher();
    }
    joinByWeb() {
        this.logging.showInfoLog('LaunchMeetingButton.launch: opened meetingUrl in new tab', this.settings.meetingUrl);
        this.message.sendMessageToBackground({ action: 'openLinkInNewTab', url: this.settings.meetingUrl });
    }
    inject() {
        const whereContainer = document.querySelector(this.settings.containerSelector);
        if (whereContainer) {
            if (!whereContainer.classList.contains(this.containerSelectorAdditionalClass)) {
                // Clear container
                while (whereContainer.hasChildNodes()) {
                    whereContainer.removeChild(whereContainer.lastChild);
                }
                whereContainer.classList.add(this.containerSelectorAdditionalClass);
                whereContainer.appendChild(this.getButton());
                this.localizationLanguageManager.localize();
                const btn = document.getElementById(`${this.meetingId}.${this.launchMeetingButtonIdPart}`);
                btn.addEventListener('click', () => {
                    const boundLaunchHandler = this.launch.bind(this);
                    boundLaunchHandler();
                });
            }
        }
    }
}
exports.LaunchMeetingButton = LaunchMeetingButton;

},{"../google-calendar-dom-element-characteristics":88,"../logging/logging":108,"../modals/first-time-join-meeting":121}],114:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.LaunchMeetingUrlMapManager = void 0;
const error_helper_1 = require("../helpers/error-helper");
const source_wrapper_1 = require("../helpers/source-wrapper");
const environment_1 = require("../repository/environment");
const logging_1 = require("../logging/logging");
class LaunchMeetingUrlMapManager {
    constructor(actionOnMeetingsManager, apiLogic, extensionSettings) {
        this.actionOnMeetingsManager = actionOnMeetingsManager;
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.meetingUrlsKey = 'tpn_launchMeetingUrl';
        this.logging = logging_1.Logging.getInstance();
        this.errorHelper = new error_helper_1.ErrorHelper();
        this.environment = new environment_1.Environment(this.extensionSettings);
        const extensionSettingsRepositoryWrapper = {
            get: (id) => __awaiter(this, void 0, void 0, function* () {
                const data = yield this.extensionSettings.getPolyfill(this.meetingUrlsKey);
                return (data && data[id]) ? data[id] : undefined;
            }),
            set: (id, value) => __awaiter(this, void 0, void 0, function* () {
                const savedData = {};
                const data = (yield this.extensionSettings.getPolyfill(this.meetingUrlsKey)) || {};
                data[id] = value;
                savedData[this.meetingUrlsKey] = data;
                yield this.extensionSettings.setPolyfill(savedData);
                return value;
            }),
            clear: () => __awaiter(this, void 0, void 0, function* () {
                return this.extensionSettings.removeDataFromLocalDatabase(this.meetingUrlsKey);
            }),
        };
        const actionOnMeetingsManagerWrapper = {
            get: (id) => {
                return (new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
                    const launchMeetingUrlForepart = yield this.getLaunchMeetingUrlForepart();
                    return this.actionOnMeetingsManager.getMeetingInfo(id).then((meetingInfo) => {
                        resolve(`${launchMeetingUrlForepart + meetingInfo.stem}/${meetingInfo.id}`);
                    }).catch((error) => {
                        if (!this.errorHelper.isExceptionHandled(error)) {
                            error = this.errorHelper.updateCatcherInTheError(error, 'LaunchMeetingUrlMapManager: actionOnMeetingsManagerWrapper: getMeetingInfo');
                            this.logging.showErrorLog(`Failed get the info of the meeting ${id}`, error);
                        }
                        reject(error);
                    });
                })));
            },
        };
        const source = {
            get: (id) => __awaiter(this, void 0, void 0, function* () {
                return extensionSettingsRepositoryWrapper.get(id)
                    .then((value) => {
                    if (value === undefined) {
                        return actionOnMeetingsManagerWrapper.get(id)
                            .then((value) => {
                            return extensionSettingsRepositoryWrapper.set(id, value)
                                .then((value) => {
                                return value;
                            })
                                .catch((error) => {
                                if (!this.errorHelper.isExceptionHandled(error)) {
                                    error = this.errorHelper.updateCatcherInTheError(error, 'LaunchMeetingUrlMapManager: source: set');
                                    this.logging.showErrorLog(`Failed set the meeting info ${id}`, error);
                                }
                                return error;
                            });
                        }, (error) => {
                            if (error && error.status === 404) {
                                return extensionSettingsRepositoryWrapper.set(id, '');
                            }
                            if (!this.errorHelper.isExceptionHandled(error)) {
                                error = this.errorHelper.updateCatcherInTheError(error, 'LaunchMeetingUrlMapManager: actionOnMeetingsManagerWrapper: set');
                                this.logging.showErrorLog(`Failed getting the meeting ${id}`, error);
                            }
                        }).catch((error) => {
                            if (!this.errorHelper.isExceptionHandled(error)) {
                                error = this.errorHelper.updateCatcherInTheError(error, 'LaunchMeetingUrlMapManager: actionOnMeetingsManagerWrapper: set');
                                this.logging.showErrorLog(`Failed getting the meeting ${id}`, error);
                            }
                            return error;
                        });
                    }
                    else {
                        return value;
                    }
                })
                    .catch((error) => {
                    if (!this.errorHelper.isExceptionHandled(error)) {
                        error = this.errorHelper.updateCatcherInTheError(error, 'LaunchMeetingUrlMapManager: source: get');
                        this.logging.showErrorLog(`Failed getting the meeting ${id}`, error);
                    }
                    if (error && error.status === '404') {
                        extensionSettingsRepositoryWrapper.set(id, '');
                    }
                    return error;
                });
            }),
            set: (id, value) => {
                return extensionSettingsRepositoryWrapper.set(id, value)
                    .catch((error) => {
                    if (!this.errorHelper.isExceptionHandled(error)) {
                        error = this.errorHelper.updateCatcherInTheError(error, 'LaunchMeetingUrlMapManager: source: set');
                        this.logging.showErrorLog(`Failed set the meeting ${id}`, error);
                    }
                    return error;
                });
            },
            clear: () => {
                return extensionSettingsRepositoryWrapper.clear()
                    .catch((error) => {
                    if (!this.errorHelper.isExceptionHandled(error)) {
                        error = this.errorHelper.updateCatcherInTheError(error, 'LaunchMeetingUrlMapManager: source: clear');
                        this.logging.showErrorLog('Failed clearing meetings info ', error);
                    }
                    return error;
                });
            },
        };
        this.sourceWrapper = new source_wrapper_1.SourceWrapper({ source });
    }
    get(id) {
        return this.sourceWrapper.get(id);
    }
    set(id, value) {
        return this.sourceWrapper.set(id, value);
    }
    clear() {
        return this.sourceWrapper.clear();
    }
    getLaunchMeetingUrlForepart() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.apiLogic.config.launchMeetingUrlForepart[yield this.environment.get()];
        });
    }
}
exports.LaunchMeetingUrlMapManager = LaunchMeetingUrlMapManager;

},{"../helpers/error-helper":92,"../helpers/source-wrapper":100,"../logging/logging":108,"../repository/environment":135}],115:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeetingDetailsManager = void 0;
const logging_1 = require("../logging/logging");
class MeetingDetailsManager {
    constructor(settings) {
        this.settings = settings;
        this.minValueWithIdLength = 24;
        this.typeValueAttribute = 'type-value';
        this.ariaSelectedAttribute = 'aria-selected';
        this.tabIndexAttribute = 'tabindex';
        this.startPositionIdValue = 9;
        this.endPositionIdValue = 61;
        // Regexp to detect '**** Please do not edit the information below ****' phrase
        this.separatingPhraseRegEx = /\*\*\*\*.*\*\*\*\*/;
        this.logging = logging_1.Logging.getInstance();
        this.fuzeAdditionalSettingsSelector = '#' + this.settings.calendarDomElementCharacteristics.fuzeAdditionalSettingsId;
    }
    setMeeting(meeting) {
        this.setInvitationMessage(meeting);
        const meetingMode = meeting.mode;
        const subject = meeting.subject;
        if (meetingMode) {
            this.setMeetingMode(this.fuzeAdditionalSettingsSelector + this.settings.calendarDomElementCharacteristics.dropdownSelectedValueSelector, meetingMode);
        }
    }
    getMeetingId() {
        const gCalSelectors = this.settings.calendarDomElementCharacteristics;
        let meetingLink = $(gCalSelectors.fuzeLaunchLinkSelector).attr('data-href')
            || $(gCalSelectors.fuzeLaunchLinkSelector).attr('href');
        if (!meetingLink) {
            meetingLink = $(gCalSelectors.parentMeetingLinkSelector).find(gCalSelectors.meetingLinkSelector).val();
            meetingLink = meetingLink ? meetingLink : $(gCalSelectors.meetingLinkForAttendeeSelector).text();
        }
        const separatedMeetingLink = meetingLink.split('/');
        const meetingId = separatedMeetingLink ? separatedMeetingLink[separatedMeetingLink.length - 1] : 0;
        return meetingId;
    }
    getMeeting(doesContainSeparatingPhrase, id) {
        const savedMeeting = {
            created_via: this.settings.createdViaGoogleCalProperty,
            display_international_dial: true,
            display_toll_free: true,
            enable_chimes: false,
            end_time: this.settings.meetingTimeParsingManager.getMeetingTime(this.settings.calendarDomElementCharacteristics.timeZoneSelector, this.settings.calendarDomElementCharacteristics.endDateSelector, this.settings.calendarDomElementCharacteristics.endTimeSelector, this.settings.calendarDomElementCharacteristics.allDayEventParameterSelector),
            external_id: this.getExternalId(this.settings.calendarDomElementCharacteristics.eventFormIdentificationElementSelector, this.settings.calendarDomElementCharacteristics.externalIdAttr),
            id: '',
            invitation_message: '',
            mode: this.getMeetingMode(this.fuzeAdditionalSettingsSelector + this.settings.calendarDomElementCharacteristics.dropdownSelectedValueSelector, 'O'),
            send_invitation: false,
            start_time: this.settings.meetingTimeParsingManager.getMeetingTime(this.settings.calendarDomElementCharacteristics.timeZoneSelector, this.settings.calendarDomElementCharacteristics.startDateSelector, this.settings.calendarDomElementCharacteristics.startTimeSelector, this.settings.calendarDomElementCharacteristics.allDayEventParameterSelector),
            subject: '',
            viewable: true,
            auto_accept: true,
        };
        const subject = this.getValueOf(this.settings.calendarDomElementCharacteristics.subjectSelector, '');
        const invitationMessage = this.getValueOfDescriptionField(doesContainSeparatingPhrase, this.settings.calendarDomElementCharacteristics.descriptionTextSelector, '');
        if (subject) {
            savedMeeting.subject = subject;
        }
        if (invitationMessage) {
            savedMeeting.invitation_message = `${invitationMessage}<br><br>`;
        }
        savedMeeting.id = id ? id : this.getMeetingId();
        // if meeting type is "Private"
        if (savedMeeting.mode === 'R') {
            savedMeeting.auto_accept = false;
        }
        return savedMeeting;
    }
    setValueInto(selector, value) {
        if ($(selector)[0]) {
            const e = document.createEvent('Event');
            const $input = $(selector);
            $input.html(value);
            e.initEvent('keyup', true, true);
            $(this.settings.calendarDomElementCharacteristics.descriptionTextSelector)[0].dispatchEvent(e);
        }
        else {
            this.logging.showInfoLog('Object is empty, selector', selector);
        }
    }
    getTextInvitationTemplate(invitationTemplate) {
        return invitationTemplate['text/plain'];
    }
    getStartPositionOfSeparatingPhrase(text) {
        const match = this.separatingPhraseRegEx.exec(text);
        const position = match ? match.index : text.length;
        return position;
    }
    setInvitationMessage(meeting) {
        const emptyLinesToRemove = '<br><br>';
        let invitationMessage = this.getTextInvitationTemplate(meeting.invite_template);
        invitationMessage = invitationMessage.replace(/\n/g, '<br>');
        if (invitationMessage.indexOf(emptyLinesToRemove) === 0) {
            invitationMessage = invitationMessage.slice(emptyLinesToRemove.length).trim();
        }
        this.setValueInto(this.settings.calendarDomElementCharacteristics.descriptionTextSelector, invitationMessage);
    }
    setMeetingMode(selector, value) {
        let meetingTypeElement;
        const selectedItemClass = $('[role=\'option\'][tabindex=\'0\']').attr('class').split(' ').slice(-1)[0];
        $(selector).removeClass(selectedItemClass).attr(this.ariaSelectedAttribute, 'false').attr(this.tabIndexAttribute, -1);
        meetingTypeElement = $(this.fuzeAdditionalSettingsSelector + ' [' + this.typeValueAttribute + '*=\'' + value + '\']');
        meetingTypeElement.addClass(selectedItemClass).attr(this.ariaSelectedAttribute, true).attr(this.tabIndexAttribute, 0);
    }
    getExternalId(selector, attribute) {
        let valueWithId = '';
        let form = $(selector);
        if (form.parents().length) {
            const formClassName = form.parents()[1].className;
            form = $('[class=\'' + formClassName + '\']');
            valueWithId = form.attr(attribute);
            if (valueWithId.length < this.minValueWithIdLength) {
                valueWithId = $('#' + this.settings.calendarDomElementCharacteristics.buttonsToReplace[1]).attr(attribute) || '';
            }
            valueWithId = valueWithId.substring(this.startPositionIdValue, this.endPositionIdValue);
            const valueWithIdArray = valueWithId.split(',');
            valueWithId = valueWithIdArray[0];
        }
        return valueWithId;
    }
    getValueOf(selector, defaultValue) {
        return $(selector).val() || $(selector).text() || defaultValue || '';
    }
    getValueOfDescriptionField(doesContainSeparatingPhrase, selector, defaultValue) {
        let value = '';
        const descriptionFiled = $(this.settings.calendarDomElementCharacteristics.descriptionTextSelector);
        if (descriptionFiled && descriptionFiled.length) {
            value = descriptionFiled[0].innerText;
            if (doesContainSeparatingPhrase) {
                const position = this.getStartPositionOfSeparatingPhrase(value);
                value = value.slice(0, position);
            }
        }
        return value || defaultValue;
    }
    getMeetingMode(selector, defaultValue) {
        const value = $(selector).attr(this.typeValueAttribute);
        return value;
    }
}
exports.MeetingDetailsManager = MeetingDetailsManager;

},{"../logging/logging":108}],116:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MeetingTimeParsingManager = void 0;
const logging_1 = require("../logging/logging");
class MeetingTimeParsingManager {
    constructor(settings) {
        this.settings = settings;
        this.logging = logging_1.Logging.getInstance();
    }
    getMeetingTime(timeZoneSelector, dateSelector, timeSelector, allDayEventParameterSelector) {
        // If client uses separate start and end time zones,
        // the timezone will have similar format to "(GMT+02:00) Brussels"
        const timezone = $(timeZoneSelector).text();
        const date = this.parseMeetingDate(dateSelector);
        const time = this.parseMeetingTime(timeSelector, allDayEventParameterSelector);
        // /\((.*?)\)/i.exec(timezone) get the only timezone without a country name
        // If timezone is not empty value parsedTimezone will be "GMT+0200" for the example before
        // parsedTimezone value helps to parse time correctly
        // See also: https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/parse
        const parsedTimezone = timezone ? (/\((.*?)\)/i.exec(timezone) || ['']).pop().replace(/:/i, '') : '';
        const dateTimeString = [date, time, parsedTimezone].join(' ').trim();
        return this.getDateIsoString(dateTimeString);
    }
    getFormattedDate(day, month, year) {
        if (!this.settings.dateHelper.isYearValid(year)) {
            const dateChunk = year;
            if (this.settings.dateHelper.isYearValid(month)) {
                year = month;
                month = dateChunk;
            }
            if (this.settings.dateHelper.isYearValid(day)) {
                year = day;
                day = dateChunk;
            }
        }
        if (!this.settings.dateHelper.isMonthNumberValid(month)) {
            const possiblyMonth = day;
            const dayValue = month;
            if (this.settings.dateHelper.isMonthNumberValid(possiblyMonth)) {
                month = possiblyMonth;
                day = dayValue;
            }
        }
        // See also
        // https://developer.mozilla.org/en-US/docs/Web/JavaScript/Reference/Global_Objects/Date/parse#Differences_in_assumed_time_zone
        const monthName = this.settings.dateHelper.getMonthNameByMonthNumber(month) || month;
        return (monthName + ' ' + day + ', ' + year);
    }
    getTimeString(inputTime) {
        const dayTimePeriod = (inputTime.match(/am|pm/i) || ['']).pop();
        const numberRegExp = new RegExp('\\d+', 'gi');
        const time = inputTime.replace(dayTimePeriod, '');
        const timeStringBits = time.match(numberRegExp);
        let hour = timeStringBits[0];
        const minutes = timeStringBits[1];
        if (dayTimePeriod.toLowerCase() === 'pm' && hour !== '12') {
            hour = parseInt(hour) + 12;
        }
        if (dayTimePeriod.toLowerCase() === 'am' && hour === '12') {
            hour = '0';
        }
        const timeString = ([hour, minutes].join(':'));
        this.logging.showInfoLog('getTimeString: input value is ' + inputTime + ', output value is ' + timeString);
        return timeString;
    }
    getDateIsoString(dateTimeString) {
        let utcString = '';
        try {
            const parsedDate = Date.parse(dateTimeString);
            if (parsedDate && (parsedDate === parsedDate)) {
                utcString = (new Date(parsedDate)).toISOString();
            }
            this.logging.showInfoLog('getDateIsoString current utcString is ' + utcString);
        }
        catch (error) {
            this.logging.showInfoLog('getDateIsoString failed: ' + error);
        }
        return utcString;
    }
    getParsedDateString(date) {
        // In the current calendar the meeting date is stored in the format 'yyyymmdd' in the attribute of the element
        const regExpDate = /[12]\d{3}(0[1-9]|1[0-2])(0[1-9]|[12]\d|3[01])/;
        if (date.match(regExpDate)) {
            const year = date.substring(0, 4);
            const month = parseInt(date.substring(4, 6), 10);
            const day = date.substring(6, 8);
            const formattedDateString = this.getFormattedDate(day, month, year);
            this.logging.showInfoLog('getParsedDateString: input value is ' + date + ', output value is ' + formattedDateString);
            return formattedDateString;
        }
        this.logging.showInfoLog('Unexpected error trying to get meeting date');
        return '';
    }
    parseMeetingDate(dateSelector) {
        const date = $(dateSelector).attr('data-date');
        if (date) {
            return this.getParsedDateString(date);
        }
        this.logging.showInfoLog('Unexpected error trying to get meeting date');
        return '';
    }
    isAllDayEvent(allDayEventParameterSelector) {
        const allDayCheckbox = $(allDayEventParameterSelector);
        if (allDayCheckbox && allDayCheckbox.length) {
            const isAllDayEventFlag = allDayCheckbox.attr('aria-checked');
            if (isAllDayEventFlag.toString() === 'true') {
                this.logging.showInfoLog('MeetingModel.isAllDayEvent This meeting is all day event');
                return true;
            }
        }
        return false;
    }
    parseMeetingTime(timeSelector, allDayEventParameterSelector) {
        const isEventEndTime = (timeSelector.indexOf('En') > 0);
        const isAllDayEventFlag = this.isAllDayEvent(allDayEventParameterSelector);
        if (isAllDayEventFlag) {
            if (isEventEndTime) {
                return this.settings.allDayEventEndTime;
            }
            else {
                return this.settings.allDayEventStartTime;
            }
        }
        else {
            const time = $(timeSelector).val();
            if (time) {
                return this.getTimeString(time);
            }
        }
        this.logging.showInfoLog('Unexpected error trying to get meeting time');
        return '';
    }
}
exports.MeetingTimeParsingManager = MeetingTimeParsingManager;

},{"../logging/logging":108}],117:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.TeamsObserver = void 0;
const teams_call_1 = require("../teams-call");
const logging_1 = require("../logging/logging");
const extensionSettings_1 = require("../repository/extensionSettings");
const api_1 = require("../api");
const repository_1 = require("../repository/repository");
const message_1 = require("../repository/message");
class Contact {
    constructor(email, phone = "", type = "") {
        this.email = email;
        this.phone = phone;
        this.type = type;
    }
}
class TeamsObserver {
    constructor() {
        this.apiLogic = new api_1.APILogic();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(this.apiLogic);
        this.contactsList = [];
        this.message = new message_1.Message();
        this.repository = new repository_1.Repository(this.apiLogic, this.extensionSettings);
        this.URLHelper = this.repository.URLHelper;
        this.logging = logging_1.Logging.getInstance();
        this.config = {
            childList: true,
            subtree: true,
            attributes: false,
            characterData: false,
        };
        this.teamsCall = new teams_call_1.default();
        this.addMessageListeners();
        this.teamsPageEvents();
    }
    addListener(id, number, classT, that) {
        document.getElementById(id).addEventListener("click", () => {
            that.hidePhoneBox();
            classT.extension.placeCallTeams(number, number);
        }, false);
    }
    //Parse contacts and adds them to a session temporary cache => this.contactsList
    parseGetContacts(contactDOM, contactObj) {
        this.contactsList = this.contactsList.filter((item) => item.email !== contactDOM.Email);
        if (contactObj &&
            contactObj.data[0] &&
            contactObj.data[0].results &&
            contactObj.data[0].results.length > 0) {
            const phones = contactObj.data[0].results[0].contact.phone;
            for (let i = 0; i < phones.length; i++) {
                let contact = new Contact(contactDOM.Email);
                contact.phone = phones[i].original;
                contact.type = phones[i].type;
                this.contactsList.push(contact);
            }
        }
        else {
            let contact = new Contact(contactDOM.Email);
            this.contactsList.push(contact);
        }
        return this.contactsList;
    }
    //Checks is a given contact already exists in this.contactsList
    isContactInCache(cacheList, contact) {
        return __awaiter(this, void 0, void 0, function* () {
            const cachedContact = cacheList.filter((obj) => obj.email === contact.Email);
            if (!cachedContact.length) {
                return false;
            }
            return true;
        });
    }
    //Gets the phone numbers from this.contactsList for a given Email ordered 1st by the work numbers
    getContactNumbersFromCache(cacheList, contact) {
        return __awaiter(this, void 0, void 0, function* () {
            const cachedContactWork = cacheList.filter((obj) => obj.email === contact.Email && contact.phoneNumbers.type === "work");
            const cachedContactNonWork = cacheList.filter((obj) => obj.email === contact.Email && contact.phoneNumbers.type !== "work");
            let cachedContact = [...cachedContactNonWork, ...cachedContactWork];
            cachedContact = cachedContact.filter((obj) => obj.phone !== "");
            return cachedContact;
        });
    }
    //Deals with the DOM regarding if it should display the Fuze Call Button and its elements or not.
    modifyText() {
        return __awaiter(this, void 0, void 0, function* () {
            let contact = yield this.getChatContactInfo();
            if (contact === undefined && this.isExternalContact()) {
                const externalUserEmail = $("div.federation-chat-header > span")[0];
                if (externalUserEmail) {
                    contact = {
                        Email: "",
                        phoneNumbers: {
                            type: "",
                            number: "",
                        },
                    };
                    contact.Email = externalUserEmail.title;
                }
            }
            const isContactInCache = yield this.isContactInCache(this.contactsList, contact);
            if (!isContactInCache) {
                //Call API
                this.logging.showInfoLog("Getting " + contact.Email + " information from Rolodex");
                const bb = yield this.teamsCall.extension.getContactPhonesList(contact.Email); //'amasi@fuze.com returns 2 numbers'
                this.parseGetContacts(contact, bb);
            }
            const ContactNumbersFromCache = yield this.getContactNumbersFromCache(this.contactsList, contact);
            if (ContactNumbersFromCache.length == 0) {
                this.removeFuzeCallButton();
                return;
            }
            //We have contact and number(s) in cache so lets render in DOM
            this.addNumbersToCallContactHTMLElement(ContactNumbersFromCache);
        });
    }
    //Adds the numbers for a given Email in the Call List to be available to the user
    addNumbersToCallContactHTMLElement(ContactNumbersFromCache) {
        let phoneList = document.querySelector("#UL_phoneList");
        phoneList.querySelectorAll("*").forEach((n) => n.remove()); //lets start with a clean list
        let firstLi = document.createElement("li");
        firstLi.setAttribute("id", "fuze-for-browser-extension__dial");
        firstLi.setAttribute("class", "fuze-for-browser-extension-click-to-call-entitlement " +
            "fuze-for-browser-extension-popup-menu-list__item " +
            "fuze-for-browser-extension-main-menu-list__item " +
            "fuze-for-browser-extension-menu-item--main-menu " +
            "teams-c2c-li-text");
        firstLi.innerHTML +=
            '<span class="fuze-for-browser-extension-teams-popup-menu-list__link ' +
                'fuze-for-browser-extension-main-menu-list__link teams-c2c-li-header teams-c2c-li-text">' +
                "Choose a number to call..." +
                "</span>";
        phoneList.appendChild(firstLi);
        for (let i = 0; i < ContactNumbersFromCache.length; i++) {
            let li = document.createElement("li");
            li.setAttribute("id", "phone_id" + i);
            li.setAttribute("phone", ContactNumbersFromCache[i].phone);
            li.setAttribute("class", ".fuze-for-browser-extension-popup-menu-list__item.fuze-for-browser-extension-main-menu-list__item.fuze-for-browser-extension-menu-item--main-menu");
            li.innerHTML +=
                '<a class="fuze-for-browser-extension-teams-popup-menu-list__link ' +
                    "fuze-for-browser-extension-main-menu-list__link " +
                    'fuze-for-browser-extension-menu-item__text--main-menu teams-c2c-height teams-c2c-li-phone"' +
                    ' href="#" astyle="text-decoration:none">' +
                    '<span class="teams-c2c-li-phone-type">' +
                    ContactNumbersFromCache[i].type +
                    "</span><br>" +
                    ContactNumbersFromCache[i].phone +
                    "</a>";
            phoneList.appendChild(li);
            this.addListener("phone_id" + i, ContactNumbersFromCache[i].phone, this.teamsCall, this);
        }
    }
    //Get contact info from DOM
    getChatContactInfo() {
        return __awaiter(this, void 0, void 0, function* () {
            let chatParticipantDetails = {
                Email: "",
                phoneNumbers: {
                    type: "",
                    number: "",
                },
            };
            try {
                //Search for a Organization contact
                const profileData = $("img[profile-picture-img-event].media-object:first");
                if (!profileData.length) {
                    return;
                }
                let participantTitleNode = document.querySelector(".one-on-one.header-v2-title-container.lpc-hoverTarget");
                if (participantTitleNode) {
                    const email = profileData[0].getAttribute("upn");
                    chatParticipantDetails.Email = email;
                }
                else {
                    //Otherwise is an external contact
                    participantTitleNode = document.querySelector(".ts-chat-title.native-federation.person-card-hover");
                    chatParticipantDetails.Email = participantTitleNode.querySelector("span").title;
                }
                let str = chatParticipantDetails.Email;
                //Scrub email address from #EXT# markers that MS injects in email when its not a paying user
                let posEXT = str.search("#EXT#");
                if (posEXT > 0) {
                    str = str.substr(0, posEXT);
                    let arr = str.split("_");
                    let posAT = str.search(arr[arr.length - 1]);
                    str = str.substr(0, posAT - 1);
                    chatParticipantDetails.Email = str + "@" + arr[arr.length - 1];
                }
                return chatParticipantDetails;
            }
            catch (error) {
                yield this.logging.showErrorLog("Failed to getChatContactInfo from DOM.", error);
            }
        });
    }
    //Checks if we need to process this DOM change or not
    isMutationRelevant(mutationsList) {
        return __awaiter(this, void 0, void 0, function* () {
            let mutationRelevant = false;
            yield mutationsList.forEach((mutation) => {
                if (mutation.target.innerHTML.search(".one-on-one.header-v2-title-container.person-card-hover") > -1 ||
                    mutation.target.innerHTML.search(".ts-chat-title.native-federation.person-card-hover") > -1) {
                    mutationRelevant = true;
                }
            });
            return mutationRelevant;
        });
    }
    removeFuzeCallButton() {
        let FuzeCallButton = document.querySelector(".teams-c2c-button");
        if (FuzeCallButton) {
            FuzeCallButton.remove();
            let popover__wrapper = document.querySelector(".popover__wrapper");
            popover__wrapper.remove();
            let callBar = document.querySelector("div .start-call-buttons-wrapper-fuze");
            callBar.remove();
        }
    }
    getElementByXpath(path) {
        return __awaiter(this, void 0, void 0, function* () {
            return document.evaluate(path, document, null, XPathResult.FIRST_ORDERED_NODE_TYPE, null).singleNodeValue;
        });
    }
    isContactAHuman() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const audioCallButton = document.querySelectorAll("[data-tid='dropdown-audio-call-primary-btn']");
                if (audioCallButton === null) {
                    return false;
                }
                return true;
            }
            catch (error) {
                this.logging.showErrorLog("Failed to evaluate isContactAHuman from DOM.", error);
            }
        });
    }
    isExternalContact() {
        const federationTag = document.getElementsByClassName("federation-tag");
        if (federationTag[0] && federationTag[0].textContent === "External") {
            return true;
        }
        return false;
    }
    showOrHideFuzeCallButton() {
        return __awaiter(this, void 0, void 0, function* () {
            //check to see if the chat contact is a Human or a Bot so we can return and remove the Fuze Call Button
            const isContactHuman = yield this.isContactAHuman();
            if (!isContactHuman) {
                this.removeFuzeCallButton();
                return;
            }
            //Seems we're in a chat with a human. Searching now for contact email to try to get phone numbers
            //If there's no email info we will exit and remove the Fuze Call Button
            let contact = yield this.getChatContactInfo();
            console.log(contact, "contact");
            if (contact === undefined && this.isExternalContact()) {
                const externalUserEmail = $("div.federation-chat-header > span")[0];
                if (externalUserEmail) {
                    contact = {
                        Email: "",
                        phoneNumbers: {
                            type: "",
                            number: "",
                        },
                    };
                    contact.Email = externalUserEmail.title;
                }
            }
            if (contact.Email === undefined) {
                return;
            }
            if (!contact.Email.length) {
                this.removeFuzeCallButton();
                return;
            }
            //Try to get contact phone numbers from cache this.contactList.
            //If there's no entry will query the Rolodex REST API and send to cache
            //Finally will retrieve the numbers from cache
            const isContactInCache = yield this.isContactInCache(this.contactsList, contact);
            if (!isContactInCache) {
                let contactsFromAPI;
                try {
                    //prevent errors if Teams settings are changed mid request
                    contactsFromAPI = yield this.teamsCall.extension.getContactPhonesList(contact.Email); //'amasi@fuze.com'
                }
                catch (e) {
                    yield this.logging.showErrorLog("Error to getContactPhonesList.", e);
                    return;
                }
                this.parseGetContacts(contact, contactsFromAPI);
            }
            let ContactNumbersFromCache = yield this.getContactNumbersFromCache(this.contactsList, contact);
            //If there's no contact phone numbers we will exit and remove the Fuze Call Button
            if (ContactNumbersFromCache.length == 0) {
                this.removeFuzeCallButton();
                return;
            }
            //Everything seems ok. Will show the Fuze call button and add the click event
            const appMessageHeader = document.querySelector(".ts-title-bar-buttons.ts-title-bar-buttons-show");
            const callBar = appMessageHeader.querySelector("div .start-call-buttons-wrapper");
            this.injectFuzeButton(callBar);
            this.modifyText();
            let FuzeCallButton = appMessageHeader.querySelector(".teams-c2c-button");
            FuzeCallButton.addEventListener("click", (e) => {
                this.showPhoneBox();
            }, false);
        });
    }
    getCurrentDomain() {
        return this.URLHelper.getDomainPartOfURL(window.location.href);
    }
    //Checks for changes in Teams Settings (on /off). if the page is the Teams web app refreshes the DOM accordingly .
    teamsPageEvents() {
        return __awaiter(this, void 0, void 0, function* () {
            setInterval(() => __awaiter(this, void 0, void 0, function* () {
                const urlDomain = this.getCurrentDomain();
                if (urlDomain.indexOf("teams.microsoft") === -1) {
                    return;
                }
                const teamsSettingActive = yield this.areTeamsActiveInSettings();
                if (!teamsSettingActive) {
                    //Teams setting off: Lets hide the Fuze Call Button
                    this.hidePhoneBox();
                    this.removeFuzeCallButton();
                }
                const fuzeCallButton = document.querySelector("div .teams-c2c-button");
                if (teamsSettingActive && !fuzeCallButton) {
                    //Teams setting on: lets check Show or Hide Fuze Call Button
                    yield this.showOrHideFuzeCallButton();
                }
            }), 1500);
        });
    }
    //Process DOM Mutations. Do some work to decide if the Fuze Call Button should be displayed or not
    callbackObserver(mutationsList, mutationObs) {
        return __awaiter(this, void 0, void 0, function* () {
            const teamsActive = yield this.areTeamsActiveInSettings();
            if (!teamsActive)
                return;
            this.mutationObs.disconnect();
            //Check to see if its relevant. If its not discard the mutation.
            const mutationRelevant = yield this.isMutationRelevant(mutationsList);
            if (!mutationRelevant) {
                this.mutationObs.observe(this.target, this.config);
                return;
            }
            yield this.showOrHideFuzeCallButton();
            this.mutationObs.observe(this.target, this.config);
            return;
        });
    }
    showPhoneBox() {
        return __awaiter(this, void 0, void 0, function* () {
            let contact = yield this.getChatContactInfo();
            const bb = yield this.teamsCall.extension.getContactPhonesList(contact.Email); //'amasi@fuze.com returns 2 numbers'
            const contactsParsed = this.parseGetContacts(contact, bb);
            this.addNumbersToCallContactHTMLElement(contactsParsed);
            const box = document.querySelector(".fuze_popover__content");
            box.style.visibility = "visible";
            box.style.opacity = "1";
            box.style.zIndex = "10";
        });
    }
    hidePhoneBox() {
        const box = document.querySelector(".fuze_popover__content");
        if (box && box.style) {
            box.style.visibility = "hidden";
            box.style.opacity = "0";
            box.style.zIndex = "-1";
        }
    }
    //Inject in DOM the Fuze Call Button
    injectFuzeButton(callBar) {
        return __awaiter(this, void 0, void 0, function* () {
            const FuzeCallButton = document.querySelector(".teams-c2c-button");
            if (FuzeCallButton)
                return; //failsafe to prevent more than one Fuze Call Button
            let parentDiv = callBar.parentNode;
            let newFuzeCallButton = document.createElement("div");
            newFuzeCallButton.classList.add("start-call-buttons-wrapper-fuze");
            newFuzeCallButton.innerHTML =
                '<div class="popover__wrapper"> ' +
                    '<div class="teams-c2c-button">' +
                    '<?xml version="1.0" encoding="UTF-8"?>' +
                    '<svg width="18px" height="18px" viewBox="-3 -3 18 18" version="1.1" xmlns="http://www.w3.org/2000/svg" xmlns:xlink="http://www.w3.org/1999/xlink">' +
                    "    <title>5846D188-4AA4-4B8E-BC61-BBB5721E8E2A</title>" +
                    '    <g id="Page-1" stroke="none" stroke-width="1" fill="none" fill-rule="evenodd">' +
                    '        <g id="MSTeams_Integration-/-Chrome-Extension-Copy" transform="translate(-1123.000000, -196.000000)">' +
                    '            <g id="Browser" transform="translate(67.000000, 48.000000)">' +
                    '                <g id="Icon-/-call-/-teal" transform="translate(1050.000000, 142.000000)">' +
                    '                    <rect id="bounds" fill="#D8D8D8" opacity="0" x="0" y="0" width="30" height="30" class="teams-c2c-button-hover"></rect>' +
                    '                    <path d="M11.4135,14.193 C12.3735,16.08 13.92,17.619 15.807,18.5865 L17.274,17.1195 C17.454,16.9395 17.7195,16.8795 17.9535,16.959 C18.834,17.106 19.5,17.2005 20.334,17.34 C20.6955,17.4 21,17.64 21,18.006 L21,20.3325 C21,20.7 20.7,21 20.334,21 C14.073,21 9,15.927 9,9.666 C9,9.3 9.3,9 9.6675,9 L12,9 C12.3675,9 12.606,9.3045 12.6675,9.666 C12.7755,10.3095 12.8475,10.8585 13.047,12.0465 C13.1205,12.279 13.0665,12.54 12.8805,12.726 L11.4135,14.193 Z" id="call" fill="#FFFFFF"></path>' +
                    "                </g>" +
                    "            </g>" +
                    "        </g>" +
                    "    </g>" +
                    "</svg>" +
                    "&nbsp;&nbsp;&nbsp;CALL WITH FUZE</div>" +
                    "</div>" +
                    '<div class="fuze_popover__content" id ="DIV_UL_phoneList">    ' +
                    '<ul class="fuze-for-browser-extension-popup-menu-list" id="UL_phoneList">\n' +
                    "</div>" +
                    "</div>";
            parentDiv.insertBefore(newFuzeCallButton, callBar);
            //Some event handlers
            $(".teams-c2c-button").on("click", (e) => {
                e.stopPropagation();
                this.showPhoneBox();
            });
            $(".fuze_popover__content").on("click", (e) => {
                e.stopPropagation();
            });
            $(document).on("click", (e) => {
                e.stopPropagation();
                this.hidePhoneBox();
            });
        });
    }
    //Event listener from teams message from extension
    addMessageListeners() {
        return __awaiter(this, void 0, void 0, function* () {
            this.message.addMessageListener((message) => __awaiter(this, void 0, void 0, function* () {
                if (!message.origin || message.origin != "teams")
                    return true;
                switch (message.action) {
                    case "changeTeamsState":
                        if (message.extensionState) {
                            const fuzeCallButton = document.querySelector("div .teams-c2c-button");
                            if (!fuzeCallButton) {
                                //Lets try to show Fuze Call Button
                                yield this.showOrHideFuzeCallButton();
                            }
                        }
                        else {
                            this.hidePhoneBox();
                            this.removeFuzeCallButton();
                        }
                        break;
                    default:
                        break;
                }
            }));
        });
    }
    areTeamsActiveInSettings() {
        return __awaiter(this, void 0, void 0, function* () {
            const teamsState = yield this.extensionSettings.getTeamsFromStorage();
            return teamsState;
        });
    }
    startMutationObserver() {
        this.target = document.querySelector("body");
        if (this.target) {
            this.mutationObs = new MutationObserver((records, instance) => {
                this.callbackObserver(records, instance);
            });
            this.mutationObs.observe(this.target, this.config);
            this.teamsCall.startExtension();
        }
        else {
            setTimeout(() => {
                this.startMutationObserver();
            }, 500);
        }
    }
}
exports.TeamsObserver = TeamsObserver;

},{"../api":61,"../logging/logging":108,"../repository/extensionSettings":136,"../repository/message":138,"../repository/repository":141,"../teams-call":145}],118:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.VisibilityMeetingsManager = void 0;
const Tooltip = require("tooltip.js");
const logging_1 = require("../logging/logging");
class VisibilityMeetingsManager {
    constructor(settings, apiLogic, extensionSettings, message, localizationLanguageManager) {
        this.settings = settings;
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.message = message;
        this.localizationLanguageManager = localizationLanguageManager;
        this.eventForm = {
            buttonsAppended: () => {
                return ($('[id*=' + this.idPrefixOfTheReplacedButtons + ']').length > 0);
            },
            wait: (on, that) => {
                const waitClass = 'wait';
                let form = $(that.settings.calendarDomElementCharacteristics.eventFormIdentificationElementSelector);
                if (form.parents().length) {
                    const formClassName = form.parents()[1].className;
                    form = $('[class=\'' + formClassName + '\']');
                }
                const controls = form.find(that.settings.calendarDomElementCharacteristics.controlSelectors)
                    .removeClass(waitClass)
                    .removeAttr('disabled');
                if (on) {
                    controls.addClass(waitClass).attr('disabled', 'disabled');
                }
                if (that.settings.calendarDomElementCharacteristics.descriptionTextSelector) {
                    const upgradedControlDescription = $(that.settings.calendarDomElementCharacteristics.descriptionTextSelector);
                    upgradedControlDescription.attr('contenteditable', on ? 'false' : 'true');
                }
            },
            insertTextValue: (selector, value, that) => {
                const $textInput = $(selector);
                const $firstTextInput = $textInput[0];
                if ($firstTextInput) {
                    // for upgraded calendar
                    that.dispatchDomEventAtTheElement(document.createEvent('Event'), 'mouseover', $firstTextInput);
                    $textInput.val('').val(value);
                    that.dispatchDomEventAtTheElement(document.createEvent('Event'), 'change', $firstTextInput);
                }
            },
            setMeetingType: (meetingType, that) => {
                const selectedValueInDropdown = $(that.fuzeAdditionalSettingsSelector + ' [' + that.typeValueAttribute + '*=' + meetingType + ']');
                that.actualizeAdditionalSettingsVisibility(!that.isVanity, selectedValueInDropdown);
            },
        };
        this.buttons = {
            simulateClick: (googleButtonSelector) => {
                document.querySelectorAll(googleButtonSelector).forEach((btn) => btn.click());
            },
            attachEvents: (that) => {
                const addFuzeMeetingButton = $('span' + that.fuzeCreateMeetingButtonSelector);
                if (addFuzeMeetingButton && addFuzeMeetingButton.length) {
                    addFuzeMeetingButton.off('click').on('click', function (e) {
                        $(this).off('click');
                        if ($(this).hasClass('wait') === false) {
                            const isNeedVanityVerification = false;
                            const setLink = that.getWhereData('#' + that.settings.calendarDomElementCharacteristics.fuzeDropdownId +
                                ' [role=\'option\'][' + that.tabIndexAttribute + '=\'0\'] span');
                            that.createMeetingWithSetLink(setLink, isNeedVanityVerification);
                        }
                    });
                }
                else {
                    const injectedFuzeRow = document.querySelector(`.${that.settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClassSidebarFlexColumn}`);
                    if (!injectedFuzeRow) {
                        return;
                    }
                    let editButton = document.querySelector(that.settings.calendarDomElementCharacteristics.gmailSideBarJavascriptDiv);
                    $('.' + that.settings.calendarDomElementCharacteristics.addFuzeMeetingButtonClass).on('click', () => __awaiter(this, void 0, void 0, function* () {
                        yield this.extensionSettings.setDoesExpectToCreateAMeeting(true);
                        editButton.click();
                    }));
                }
            },
            injectButtonsIntoEventForm: (that) => {
                let lock;
                if (!lock && !that.buttons.eventFormButtons.isShowing(that.idPrefixOfTheReplacedButtons)) {
                    lock = true;
                    setTimeout(() => {
                        const container = $(that.settings.calendarDomElementCharacteristics.backToCalendarButtonSelector).parent();
                        const buttonsToReplace = that.settings.calendarDomElementCharacteristics.buttonsToReplace; // , "delete"
                        $.each(buttonsToReplace, (i, id) => {
                            const originalButton = container.find('[id$=' + id + ']');
                            if (id === 'xSaveBu') {
                                const btn = originalButton.hide().clone();
                                if (btn) {
                                    btn[0].removeAttribute('jsaction');
                                    btn[0].removeAttribute('jscontroller');
                                    btn[0].removeAttribute('jsshadow');
                                    btn[0].removeAttribute('jsname');
                                    let buttonFuzeId = btn.attr('id');
                                    buttonFuzeId = buttonFuzeId.replace((new RegExp(id, 'i')), that.idPrefixOfTheReplacedButtons + '__' + id);
                                    btn.attr('id', buttonFuzeId);
                                    btn.on('click', () => __awaiter(this, void 0, void 0, function* () {
                                        originalButton.click();
                                        const whereData = that.getWhereData(that.settings.calendarDomElementCharacteristics.locationEventFormSelector);
                                        const meetingId = yield that.getMeetingIdFromWhere(whereData);
                                        if (that.isHost && meetingId) {
                                            const meeting = that.settings.meetingDetailsManager.getMeeting(true, id);
                                            this.message.sendMessageToBackground({ action: 'updateMeeting', meeting });
                                        }
                                    }));
                                    originalButton.after(btn);
                                    btn.show();
                                    return;
                                }
                            }
                            if (originalButton && originalButton.length && id !== 'xSaveBu') {
                                const btn = originalButton.hide().clone();
                                if (that.settings.calendarDomElementCharacteristics.buttonsToReplace.includes(id)) {
                                    btn[0].removeAttribute('jsaction');
                                    btn[0].removeAttribute('jscontroller');
                                    btn[0].removeAttribute('jsshadow');
                                    btn[0].removeAttribute('jsname');
                                }
                                let buttonFuzeId = btn.attr('id');
                                buttonFuzeId = buttonFuzeId.replace((new RegExp(id, 'i')), that.idPrefixOfTheReplacedButtons + '__' + id);
                                btn.attr('id', buttonFuzeId);
                                const buttonClickHandler = function (event) {
                                    const $button = $(this);
                                    $button.off('click');
                                    that.buttons.eventFormButtons.buttonClickHandler(event, $button, that, () => {
                                        if ($button[0]) {
                                            $button.on('click', buttonClickHandler);
                                        }
                                    });
                                };
                                btn.on('click', buttonClickHandler);
                                originalButton.after(btn);
                                container.find('[id*=' + that.idPrefixOfTheReplacedButtons + '__' + id + ']').show();
                            }
                        });
                        setTimeout(() => {
                            lock = undefined;
                        }, 100);
                    }, 100);
                }
            },
            // TOP BUTTONS ON EVENT EDITION
            eventFormButtons: {
                isShowing: (id) => {
                    return ($('[id*=' + id + ']').length > 0);
                },
                buttonClickHandler: (e, $button, that, appendButtonHandlerIfTheButtonStillExists) => {
                    if (!$button.hasClass('wait')) {
                        let btnId = $button.attr('id');
                        const match = btnId.match(/(save|cancel|delete|btcb)/i); // |delete
                        let actionId = match.length > 0 ? match[1] : '';
                        btnId = actionId + that.settings.calendarDomElementCharacteristics.endPartOfIdButtonName;
                        actionId = actionId.toLowerCase();
                        if ((actionId === 'btcb') || (actionId === 'cancel')) {
                            that.buttons.simulateClick(`[id$=${btnId}]`);
                            appendButtonHandlerIfTheButtonStillExists();
                            return;
                        }
                        const whereData = that.getWhereData(that.settings.calendarDomElementCharacteristics.locationEventFormSelector);
                        that.getMeetingIdFromWhere(whereData).then((meetingId) => {
                            if (meetingId) {
                                if (that.isHost) {
                                    const doesContainSeparatingPhrase = true;
                                    const meeting = that.settings.meetingDetailsManager.getMeeting(doesContainSeparatingPhrase);
                                    if (actionId === 'save') {
                                        that.eventForm.wait(true, that);
                                        that.buttons.simulateClick(`[id$=${btnId}]`);
                                        if (that.createdViaProperty === that.settings.createdViaGoogleCalProperty && !that.isVanity) {
                                            this.message.sendMessageToBackground({ action: 'updateMeeting', meeting });
                                        }
                                        that.eventForm.wait(false, that);
                                    }
                                    else if (actionId === 'delete') {
                                        that.eventForm.wait(true, that);
                                        that.settings.actionOnMeetingsManager.deleteMeeting(meeting, (meeting) => {
                                            that.eventForm.wait(false, that);
                                            that.buttons.simulateClick(`[id$=${btnId}]`);
                                        });
                                        that.eventForm.wait(false, that);
                                        appendButtonHandlerIfTheButtonStillExists();
                                    }
                                    else {
                                        that.buttons.simulateClick(`[id$=${btnId}]`);
                                        appendButtonHandlerIfTheButtonStillExists();
                                    }
                                }
                                else {
                                    that.buttons.simulateClick(`[id$=${btnId}]`);
                                    appendButtonHandlerIfTheButtonStillExists();
                                }
                            }
                            else {
                                that.buttons.simulateClick(`[id$=${btnId}]`);
                                appendButtonHandlerIfTheButtonStillExists();
                            }
                        });
                    }
                },
            },
        };
        this.meetingUrlFusePart = 'fuze.me/';
        this.vanityMap = {}; // save only for current page
        this.isVanity = null;
        this.idPrefixOfTheReplacedButtons = 'fuze-for-browser-extension-custom-buttons';
        this.meetingCreationStateClass = 'fuze-for-browser-extension-meeting-creation__state';
        this.createdViaProperty = null;
        this.isHost = null;
        this.inInitialize = false;
        this.scanningIntervalId = 0;
        this.typeValueAttribute = 'type-value';
        this.ariaSelectedAttribute = 'aria-selected';
        this.tabIndexAttribute = 'tabindex';
        this.logging = logging_1.Logging.getInstance();
        this.localizationDataAttrPart = ` ${settings.localizationLanguageManager.settings.dataAttr}=`;
        this.fuzeCreateMeetingButtonSelector = `[id*='${settings.calendarDomElementCharacteristics.fuzeCreateMeetingButtonId}']`;
        this.joinFuzeMeetingRowSelector = '.' + settings.calendarDomElementCharacteristics.joinFuzeMeetingRowClass;
        this.popupCreateFuzeMeetingBtn = settings.calendarDomElementCharacteristics.popupCreateFuzeMeetingBtn;
        this.fuzeAdditionalSettingsSelector = '#' + settings.calendarDomElementCharacteristics.fuzeAdditionalSettingsId;
        this.fuzeIconPath = settings.resourcesRepository.getIcon();
        this.fuzeMeetingButtonSpanIcon = document.createElement('img');
        this.fuzeMeetingButtonSpanIcon.id = 'fuzef';
        this.fuzeMeetingButtonSpanIcon.addEventListener('error', () => {
            this.fuzeMeetingButtonSpanIcon.src = "https://web.fuze.com/src/assets/favicon-32x32.png";
            // this.fuzeMeetingButtonSpanIcon.removeListener('error');
        });
        this.fuzeMeetingButtonSpanIcon.innerText = '&nbsp';
        this.fuzeMeetingButtonSpanIcon.setAttribute('src', this.fuzeIconPath);
        this.createFuzeMeetingButtonOnGoogleCalendarTooltipInterior = '' +
            '<style>#fuzef{display: inline-block;width: 16px;height: 16px;' +
            'background-size: 16px 16px;' +
            'position: relative;' +
            'top: -1px;' +
            'vertical-align: middle;' +
            'margin-right: 2px;}</style><span id=\'fuzef\' style=\'background-image:url(' +
            this.fuzeIconPath + ')\'>&nbsp;</span>';
    }
    performTheDeferredCreationOfTheFuzeMeeting() {
        return __awaiter(this, void 0, void 0, function* () {
            const isNeedVanityVerification = true;
            const defaultLink = yield this.extensionSettings.getDefaultUsedLink();
            this.createMeetingWithSetLink(defaultLink, isNeedVanityVerification);
        });
    }
    initialize() {
        this.removedEventListener = true;
        this.addMessageListeners();
        this.initializeCalendarComponentManager();
        this.startScanningPage();
    }
    destroy() {
        const that = this;
        this.removedEventListener = true;
        if (this.settings.launchMeetingUrlMap) {
            this.settings.launchMeetingUrlMap.clear();
        }
        $(that.joinFuzeMeetingRowSelector).remove();
        $(`.${that.popupCreateFuzeMeetingBtn}`).remove();
        that.eventForm.wait(false, that);
        this.stopCalendarObserver();
    }
    initializeCalendarComponentManager() {
        const that = this;
        this.calendarComponentManager = new that.settings.CalendarComponentManager({
            localizationLanguageManager: that.settings.localizationLanguageManager,
            localizationDataAttrPart: that.localizationDataAttrPart,
            calendarDomElementCharacteristics: that.settings.calendarDomElementCharacteristics,
            fuzeIconPath: that.fuzeIconPath,
            calendarDropdownTooltipForVanityView: that.settings.calendarDropdownTooltipForVanityView,
            defaultCalendarDropdownTooltipView: that.settings.defaultCalendarDropdownTooltipView,
            gcalTooltipTemplate: that.settings.gcalTooltipTemplate,
            getDefaultUsedLink: this.extensionSettings.getDefaultUsedLink,
            setDefaultUsedLink: this.extensionSettings.setDefaultUsedLink,
            actualizeAdditionalSettingsVisibility: (isNeedDisplaying, selectedValue) => {
                that.actualizeAdditionalSettingsVisibility(isNeedDisplaying, selectedValue);
            },
            setDoesExpectToCreateAMeeting: this.extensionSettings.setDoesExpectToCreateAMeeting,
        }, this.apiLogic);
    }
    startScanningPage() {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            if (!that.scanningIntervalId) {
                if (that.settings.windowRepository.getCurrentURL().match(that.settings.calendarDomElementCharacteristics.calendarEventEditUrl)) {
                    if (yield this.extensionSettings.getDoesExpectToCreateAMeeting()) {
                        that.initializeEventForm();
                        that.performTheDeferredCreationOfTheFuzeMeeting();
                        this.extensionSettings.setDoesExpectToCreateAMeeting(false);
                    }
                }
                this.intervalScanToStartObserver();
                that.scanningIntervalId = window.setInterval(this.intervalScanToStartObserver.bind(this), 3000);
            }
        });
    }
    addMessageListeners() {
        const that = this;
        this.message.addMessageListener((message) => {
            if (message && message.action) {
                switch (message.action) {
                    case 'successfulLogin':
                        that.startScanningPage();
                        break;
                    case 'successfulLogout':
                        that.destroy();
                        break;
                    case 'showExpiredNotification':
                        that.settings.expiredSessionNotification.show();
                        break;
                    case 'meetingCreated':
                        if (message.error) {
                            this.logging.showErrorLog('Unable to create meeting', message.error);
                            that.eventForm.wait(false, that);
                            return that.buttons.attachEvents(that);
                        }
                        that.setMeetingInTheForm(message.createdMeeting, '');
                        break;
                    case 'returnLaunchMeetingUrlForVisibilityManager':
                        if (message.error) {
                            return this.logging.showErrorLog('Unable to get launch meeting URL for visibility manager', message.error);
                        }
                        if (!message.workToDo) {
                            return;
                        }
                        $(that.fuzeCreateMeetingButtonSelector).remove();
                        that.createLaunchMeetingButton(that.settings.calendarDomElementCharacteristics.locationEventFormSelector, '[id$="join-meeting"]', message.launchMeetingUrl, message.meetingId);
                        that.setJoinFuzeMeetingState();
                        that.eventForm.wait(false, that);
                        that.simulateUserChangesForEventForm();
                        break;
                    case 'meetingUpdated':
                        if (message.error) {
                            return this.logging.showErrorLog('Unable to update meeting', message.error);
                        }
                        that.eventForm.wait(false, that);
                        break;
                    case 'returnVanityMeeting':
                        this.returnVanityMeeting(message);
                        break;
                    case 'returnMeetingDetailsForVisibilityManager':
                        this.returnMeetingDetailsForVisibilityManager(message);
                        break;
                    default:
                        break;
                }
            }
        });
    }
    startCalendarObserver() {
        const that = this;
        if (!this.calendarObserver) {
            this.calendarObserver = new this.settings.CalendarObserver({
                errorHelper: that.settings.errorHelper,
                performTheDeferredCreationOfTheFuzeMeeting: () => {
                    that.performTheDeferredCreationOfTheFuzeMeeting();
                },
                getDoesExpectToCreateAMeeting: () => {
                    return this.extensionSettings.getDoesExpectToCreateAMeeting();
                },
                setDoesExpectToCreateAMeeting: (doesExpectToCreateAMeeting) => {
                    return this.extensionSettings.setDoesExpectToCreateAMeeting(doesExpectToCreateAMeeting);
                },
                MutationObserverBase: that.settings.MutationObserverBase,
                createLaunchMeetingButton: (whereSelector, containerSelector, launchMeetingUrl, meetingId) => {
                    that.createLaunchMeetingButton(whereSelector, containerSelector, launchMeetingUrl, meetingId);
                },
                getMeetingIdFromWhere: (whereData) => {
                    return that.getMeetingIdFromWhere(whereData);
                },
                getMeetingUrlFromWhere: (whereData) => {
                    return that.matchMeetingUrl(whereData);
                },
                setMeetingDetails: (meeting) => {
                    that.setMeetingDetails(meeting);
                },
                initializeEventForm: () => {
                    that.initializeEventForm();
                },
                initializeCalendarTooltipsManager: () => {
                    that.initializeCalendarTooltipsManager();
                },
                getWhereData: (whereSelector) => {
                    return that.getWhereData(whereSelector);
                },
                setJoinFuzeMeetingState: () => {
                    that.setJoinFuzeMeetingState();
                },
                actualizeAdditionalSettingsVisibility: (isNeedDisplaying, selectedValue) => {
                    that.actualizeAdditionalSettingsVisibility(isNeedDisplaying, selectedValue);
                },
                matchMeetingUrl: that.matchMeetingUrl,
                calendarDomElementCharacteristics: that.settings.calendarDomElementCharacteristics,
                windowRepository: that.settings.windowRepository,
            }, this.apiLogic);
            this.calendarObserver.observe();
        }
    }
    stopCalendarObserver() {
        if (this.calendarObserver) {
            this.calendarObserver.disconnect();
            this.calendarObserver = null;
        }
    }
    setMeetingDetails(meeting) {
        this.createdViaProperty = meeting.created_via;
        this.isHost = meeting.is_host;
        this.eventForm.setMeetingType(meeting.mode, this);
    }
    getMeetingsInfoFromEventsWhereData() {
        const that = this;
        const $availableWhereElements = $(that.settings.calendarDomElementCharacteristics.availableWhereElementSelector);
        if ($availableWhereElements && $availableWhereElements.length) {
            for (let i = 0; i < $availableWhereElements.length; i++) {
                const whereData = $($availableWhereElements[i]).text();
                this.getMeetingIdFromWhere(whereData).then((meetingId) => {
                    if (meetingId) {
                        this.message.sendMessageToBackground({ action: 'getLaunchMeetingUrlForVisibilityManager', meetingId });
                    }
                }).catch((error) => {
                    this.logging.showErrorLog('VisibilityMeetingsManager: ' +
                        'getMeetingsInfoFromEventsWhereData: could not get meeting id', error);
                });
            }
        }
    }
    getMeetingIdFromWhere(whereData) {
        const that = this;
        const meetingUrl = this.matchMeetingUrl(whereData);
        return (new Promise((resolve, reject) => {
            if (meetingUrl.indexOf(that.meetingUrlFusePart) > 0) {
                const possibleMeetingId = meetingUrl.split(that.meetingUrlFusePart)[1];
                return that.getMeetingId(possibleMeetingId).then((meetingId) => {
                    if (meetingId) {
                        resolve(meetingId);
                    }
                    else {
                        resolve();
                    }
                }).catch((error) => {
                    reject(error);
                });
            }
            else {
                resolve();
            }
        }));
    }
    createLaunchMeetingButton(whereSelector, containerSelector, launchMeetingUrl, meetingId) {
        const that = this;
        const meetingUrl = this.matchMeetingUrl(this.getWhereData(whereSelector));
        return (new that.settings.LaunchMeetingButton({
            containerSelector,
            fuzeImage: that.fuzeMeetingButtonSpanIcon,
            meetingId,
            launchMeetingUrl,
            meetingUrl,
            busySpinnerClass: that.settings.calendarDomElementCharacteristics.busySpinnerClass,
            meetingCreationStateClass: that.meetingCreationStateClass,
            fuzeAdditionalSettingsId: that.settings.calendarDomElementCharacteristics.fuzeAdditionalSettingsId,
            buttonName: that.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_joinFuzeMeeting'),
            localizationDataAttrPart: this.settings.localizationLanguageManager.settings.dataAttr,
        }, this.apiLogic, this.extensionSettings, this.message, this.localizationLanguageManager));
    }
    actualizeAdditionalSettingsVisibility(isNeedDisplaying, selectedValue) {
        if (selectedValue[0] && selectedValue.length) {
            const selectedItemClass = $('[role=\'option\'][' + this.tabIndexAttribute + '=\'0\']').last().attr('class').split(' ').slice(-1)[0];
            const initiallyInitializedItem = $(this.fuzeAdditionalSettingsSelector +
                this.settings.calendarDomElementCharacteristics.dropdownSelectedValueSelector);
            initiallyInitializedItem.attr(this.ariaSelectedAttribute, 'false')
                .attr(this.tabIndexAttribute, -1)
                .removeClass(selectedItemClass);
            selectedValue.attr(this.ariaSelectedAttribute, 'true')
                .attr(this.tabIndexAttribute, 0)
                .addClass(selectedItemClass);
        }
        if (isNeedDisplaying) {
            $(this.fuzeAdditionalSettingsSelector).show();
        }
        else {
            $(this.fuzeAdditionalSettingsSelector).hide();
        }
    }
    setJoinFuzeMeetingState() {
        const that = this;
        const customAttributeName = 'type-value';
        const meetingTooltip = document.querySelector(`.${that.settings.calendarDomElementCharacteristics.meetingTooltipClass}`);
        const dropdownLabelElement = $('.' + that.settings.calendarDomElementCharacteristics.dropdownLabelClass);
        const meetingTypesKey = 'FUZELOC_calendar_dropdownValues_meetingTypes';
        let meetingTypeTooltip;
        if (!document.querySelector(`#fuzeMeetingTypesTooltip`)) {
            // @ts-ignore
            meetingTypeTooltip = new Tooltip(meetingTooltip.querySelector('[data-popup-corner]'), {
                placement: 'bottom',
                title: '',
                html: true,
                template: this.settings.gcalTooltipTemplate
            });
        }
        const addHandlerForMeetingTooltip = () => {
            meetingTooltip.addEventListener('mouseover', () => {
                const typeKey = $(that.fuzeAdditionalSettingsSelector +
                    that.settings.calendarDomElementCharacteristics.dropdownSelectedValueSelector)
                    .attr(that.typeValueAttribute);
                const meetingOption = that.settings.localizationLanguageManager.getTranslate(meetingTypesKey)
                    .filter((option) => {
                    return option.customValue === typeKey;
                })[0];
                const textValue = '<div id="fuzeMeetingTypesTooltip" class=\'fuze-for-browser-extension-calendar-dropdown-tooltip fuze-for-browser-extension-calendar-dropdown-tooltip__name\'>' + meetingOption.name +
                    '</div>' + meetingOption.descriptionValue;
                meetingTypeTooltip.updateTitleContent(textValue);
            });
        };
        dropdownLabelElement.text(that.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_setType'))
            .attr(that.settings.localizationLanguageManager.settings.dataAttr, 'FUZELOC_generic_setType');
        dropdownLabelElement.next().children().first()
            .replaceWith(that.calendarComponentManager.createDropdown(that.settings.localizationLanguageManager.getTranslate(meetingTypesKey), customAttributeName, meetingTypesKey));
        addHandlerForMeetingTooltip();
        $(that.fuzeAdditionalSettingsSelector).attr('class', 'fuze-for-browser-extension-join-state');
        const selectedValueInDropdown = $(that.fuzeAdditionalSettingsSelector + ' [' + that.tabIndexAttribute + '=0]');
        that.actualizeAdditionalSettingsVisibility(!that.isVanity, selectedValueInDropdown);
    }
    simulateUserChangesForEventForm() {
        const that = this;
        if (!that.simulateUserChangesHelper) {
            that.simulateUserChangesHelper = new that.settings.SimulateUserChangesHelper({
                calendarDomElementCharacteristics: that.settings.calendarDomElementCharacteristics,
                dispatchDomEventAtTheElement: (event, type, element) => {
                    that.dispatchDomEventAtTheElement(event, type, element);
                },
            });
        }
        const isLocationFieldExist = that.doesElementExist(that.settings.calendarDomElementCharacteristics.locationEventFormSelector);
        if (isLocationFieldExist) {
            that.simulateUserChangesHelper.simulateInputForLocationField();
        }
        const isDescriptionFieldExist = that.doesElementExist(that.settings.calendarDomElementCharacteristics.descriptionTextSelector);
        if (isDescriptionFieldExist) {
            that.simulateUserChangesHelper.simulateInputForDescriptionField();
        }
    }
    showBusySpinner() {
        $(this.settings.calendarDomElementCharacteristics.joinFuzeWrapperSelector).addClass(this.meetingCreationStateClass);
        $(this.settings.calendarDomElementCharacteristics.joinFuzeWrapperSelector).after('<svg class="' + this.settings.calendarDomElementCharacteristics.busySpinnerClass + '" viewBox="0 0 100 100">' +
            '<circle class="path" cx="50" cy="50" r="20"></circle>' +
            '</svg>');
        $(this.fuzeAdditionalSettingsSelector).hide();
        $('.' + this.settings.calendarDomElementCharacteristics.checkboxClass).hide();
    }
    setMeetingInTheForm(createdMeeting, vanity_url) {
        const that = this;
        that.eventForm.wait(false, that);
        if (createdMeeting && createdMeeting.id) {
            that.settings.meetingDetailsManager.setMeeting(createdMeeting, that.settings.calendarDomElementCharacteristics);
            that.setMeetingLinkInForm(createdMeeting, vanity_url);
            that.buttons.injectButtonsIntoEventForm(that);
            that.createdViaProperty = that.settings.createdViaGoogleCalProperty;
            that.isHost = true;
            this.message.sendMessageToBackground({ action: 'getLaunchMeetingUrlForVisibilityManager', meetingId: createdMeeting.id, workToDo: true });
        }
        else {
            that.eventForm.wait(false, that);
            that.buttons.attachEvents(that);
        }
    }
    addFifteenMinutes(end_time) {
        const fifteenMinutes = 15 * 60000;
        return new Date(end_time.getTime() + fifteenMinutes).toISOString();
    }
    createMeeting(meeting) {
        const { start_time, end_time } = meeting;
        if (start_time === end_time) {
            meeting.end_time = this.addFifteenMinutes(new Date(end_time));
        }
        this.message.sendMessageToBackground({ action: 'createMeeting', meeting });
    }
    initializeCalendarTooltipsManager() {
        const that = this;
        if (!that.inInitialize && !that.removedEventListener) {
            that.inInitialize = true;
            that.locked = false;
            if (!that.locked) {
                that.locked = true;
                let createButtonClassName;
                let editButtonClassName;
                const tooltipElement = document.querySelector(this.settings.calendarDomElementCharacteristics.popupButtonsBar);
                if (tooltipElement) {
                    const createButtonElement = tooltipElement.lastElementChild;
                    createButtonClassName = `.${createButtonElement.classList.value.replace(/ /ig, '.')}`;
                    editButtonClassName = `.${createButtonElement.previousElementSibling.classList.value.replace(/ /ig, '.')}`;
                }
                this.googleCalendarTooltipsManager = new this.settings.GoogleCalendarTooltipsManager({
                    doesElementExist: (element) => {
                        return that.doesElementExist(element);
                    },
                    setDoesExpectToCreateAMeeting: (doesExpectToCreateAMeeting) => {
                        return this.extensionSettings.setDoesExpectToCreateAMeeting(doesExpectToCreateAMeeting);
                    },
                    createFuzeMeetingButtonOnGoogleCalendarTooltipInterior: that.createFuzeMeetingButtonOnGoogleCalendarTooltipInterior,
                    googleCreateButtonSelector: createButtonClassName,
                    googleEditButtonSelector: editButtonClassName,
                    popupTablist: this.settings.calendarDomElementCharacteristics.popupTablist,
                    tooltipSelector: this.settings.calendarDomElementCharacteristics.tooltipIdentificationElementSelector,
                    titleSelector: this.settings.calendarDomElementCharacteristics.subjectSelector,
                    buttonName: that.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_addFuzeMeeting'),
                    localizationDataAttrPart: that.localizationDataAttrPart,
                    calendarDomElementCharacteristics: this.settings.calendarDomElementCharacteristics,
                    moreOptionsButtonSelection: this.settings.calendarDomElementCharacteristics.tooltipMoreOptionButton,
                });
                this.googleCalendarTooltipsManager.initialize();
            }
            that.locked = false;
            that.inInitialize = false;
        }
    }
    eventFormIsFuzeMeeting() {
        let fuzeMeetingLinkFound = false;
        const table = $(this.settings.calendarDomElementCharacteristics.tableInfoSelector);
        if (table && table.length) {
            const location = $(this.settings.calendarDomElementCharacteristics.locationSelector).val();
            const description = table.find(this.settings.calendarDomElementCharacteristics.descriptionTextSelector).text();
            fuzeMeetingLinkFound = Boolean(this.matchMeetingUrl(location) || this.matchMeetingUrl(description));
        }
        return fuzeMeetingLinkFound;
    }
    initializeEventForm() {
        const that = this;
        that.isHost = false;
        that.isVanity = false;
        const isFuzeMeetingEventForm = that.eventFormIsFuzeMeeting();
        that.calendarComponentManager.inject(isFuzeMeetingEventForm);
        that.buttons.attachEvents(that);
        const description = $(that.settings.calendarDomElementCharacteristics.descriptionRowSelector);
        if (description && description.length > 0) {
            if (isFuzeMeetingEventForm) {
                if (!that.buttons.eventFormButtons.isShowing(that.idPrefixOfTheReplacedButtons)) {
                    that.buttons.injectButtonsIntoEventForm(that);
                }
            }
        }
    }
    setMeetingLinkInForm(meeting, vanity_url) {
        const that = this;
        let newMeetingLink;
        if (meeting && meeting.access_url) {
            newMeetingLink = meeting.access_url;
        }
        if (meeting && vanity_url) {
            newMeetingLink = vanity_url;
        }
        if (newMeetingLink) {
            let currentLocation = $(this.settings.calendarDomElementCharacteristics.locationSelector).val().trim();
            const currentMeetingLink = this.matchMeetingUrl(currentLocation);
            if (currentMeetingLink !== newMeetingLink) {
                if (currentMeetingLink) {
                    currentLocation = currentLocation.replace(' + ' + currentMeetingLink, '')
                        .replace(currentMeetingLink, '');
                }
                if (currentLocation) {
                    currentLocation += ' + ';
                }
                that.eventForm.insertTextValue(this.settings.calendarDomElementCharacteristics.locationSelector, currentLocation + newMeetingLink, this);
            }
        }
        $('[id*=' + that.idPrefixOfTheReplacedButtons + '__save]').select().focus();
    }
    createMeetingWithSetLink(setLink, isNeedVanityVerification) {
        const that = this;
        const doesContainSeparatingPhrase = false;
        let meeting;
        that.eventForm.wait(true, that);
        that.showBusySpinner();
        setLink = 'https://' + setLink;
        that.getMeetingIdFromWhere(setLink).then((meetingId) => __awaiter(this, void 0, void 0, function* () {
            if (meetingId && that.isVanity) {
                if (isNeedVanityVerification) {
                    this.message.sendMessageToBackground({ action: 'getVanityMeeting', vanity: that.isVanity, meetingId, setLink });
                }
                else {
                    return this.setVanityMeetingInTheForm(meetingId, setLink);
                }
            }
            else {
                meeting = that.settings.meetingDetailsManager.getMeeting(doesContainSeparatingPhrase);
                that.createMeeting(meeting);
            }
        }));
    }
    intervalScanToStartObserver() {
        return __awaiter(this, void 0, void 0, function* () {
            const isUserLoggedIn = yield this.extensionSettings.getIsUserLoggedIn();
            if (!isUserLoggedIn) {
                return this.destroy();
            }
            const entitlementForMeeting = yield this.extensionSettings.getEntitlementForMeetingFromStorage();
            if ((typeof entitlementForMeeting === 'undefined')) {
                return this.destroy();
            }
            if (!entitlementForMeeting) {
                clearInterval(this.scanningIntervalId);
                this.scanningIntervalId = 0;
            }
            else {
                if (this.settings.windowRepository.getCurrentURL().match('^https://(www|calendar).google.com/calendar/')) {
                    const isMeetingEnabled = yield this.extensionSettings.getMeetingsState();
                    if ((isMeetingEnabled || (typeof isMeetingEnabled === 'undefined'))) {
                        if (this.removedEventListener) {
                            this.removedEventListener = false;
                            this.getMeetingsInfoFromEventsWhereData();
                            this.startCalendarObserver();
                        }
                    }
                    else if (!this.removedEventListener) {
                        this.destroy();
                    }
                }
            }
        });
    }
    stripUnicodeChars(s) {
        return s.replace(/[^A-Za-z 0-9 \.,\?""!@#\$%\^&\*\(\)-_=\+;:<>\/\\\|\}\{\[\]`~]*/g, '');
    }
    matchMeetingUrl(text) {
        let meetingUrl = '';
        if (text) {
            const textParts = text.split(','); // if location text consist of a Fuze link and a room the extension will parse those parts apart
            for (let i = 0; i < textParts.length; i++) {
                let textPart = textParts[i];
                textPart = decodeURI(encodeURI(text).replace(/%e2%80%8b/ig, '')); // Unicode nothing
                const links = textPart.match(/((http:\/\/|https:\/\/)(.*)?)?((main|intg|pprd|www|fuzebox)\.*)?(fuzemeeting\.com\/fuze|fuze\.me)(\/)([a-zA-Z0-9\/#?=&]*)/img);
                if (links && links.length) {
                    meetingUrl = this.stripUnicodeChars(links[0]);
                    if (!meetingUrl.match(/https:\/\/|http:\/\//i)) {
                        meetingUrl = 'https://' + meetingUrl;
                    }
                }
            }
        }
        return meetingUrl;
    }
    getWhereData(whereSelector) {
        if ($(whereSelector) && $(whereSelector).prop('tagName') && $(whereSelector).prop('tagName').toLowerCase() === 'input') {
            return $(whereSelector).val();
        }
        if (this.doesElementExist(whereSelector) && $(whereSelector)[0].firstChild) {
            return $(whereSelector)[0].firstChild.textContent;
        }
        return $(whereSelector).text();
    }
    getMeetingId(possibleMeetingId) {
        const that = this;
        return (new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            if (possibleMeetingId) {
                possibleMeetingId = possibleMeetingId.toString();
                if ((new RegExp(',')).test(possibleMeetingId)) {
                    possibleMeetingId = possibleMeetingId.split(',')[0];
                }
                const isMeetingId = possibleMeetingId.match(/([0-9]*)/img) &&
                    (possibleMeetingId.match(/([0-9]*)/img)[0] === possibleMeetingId);
                that.isVanity = !isMeetingId && possibleMeetingId.match(/([a-zA-Z0-9]*)/img) &&
                    possibleMeetingId.match(/([a-zA-Z0-9]*)/img)[0];
                if (isMeetingId) {
                    resolve(possibleMeetingId);
                }
                else if (that.isVanity) {
                    if (that.vanityMap[possibleMeetingId]) {
                        resolve(that.vanityMap[possibleMeetingId]);
                    }
                    else {
                        try {
                            let vanityMeeting;
                            const currentPlatform = this.apiLogic.getPlatform().toLowerCase();
                            if (currentPlatform === 'chrome' || currentPlatform === 'edge') {
                                // BROW-984, due to the CORB changes for Chrome (see BROW-973), current case is browser specific
                                // later on this will be rewritten with webextension-polyfill lib as Promise-based messaging
                                vanityMeeting = yield this.sendChromeOnlyMessageToTheBackground(possibleMeetingId);
                            }
                            else {
                                vanityMeeting = yield that.settings.actionOnMeetingsManager.getVanity({ vanity: possibleMeetingId });
                            }
                            if (vanityMeeting && vanityMeeting.meeting_id) {
                                that.vanityMap[possibleMeetingId] = vanityMeeting.meeting_id;
                                resolve(vanityMeeting.meeting_id);
                            }
                            else {
                                resolve();
                            }
                        }
                        catch (error) {
                            reject(error);
                        }
                    }
                }
            }
            else {
                resolve();
            }
        })));
    }
    getFirstElement(selector) {
        return $(selector)[0];
    }
    dispatchDomEventAtTheElement(event, type, element) {
        event.initEvent(type, true, true);
        element.dispatchEvent(event);
    }
    doesElementExist(selector) {
        return Boolean(this.getFirstElement(selector));
    }
    setVanityMeetingInTheForm(meetingId, setLink) {
        return __awaiter(this, void 0, void 0, function* () {
            this.message.sendMessageToBackground({ action: 'getMeetingDetailsForVisibilityManager', meetingId, setLink });
        });
    }
    returnVanityMeeting(message) {
        if (message.error) {
            return this.logging.showErrorLog('Unable to get vanity meeting', message.error);
        }
        if (message.vanityMeeting && message.vanityMeeting.meeting_id) {
            return this.setVanityMeetingInTheForm(message.meetingId, message.setLink);
        }
        else {
            const meeting = this.settings.meetingDetailsManager.getMeeting(false);
            this.createMeeting(meeting);
        }
    }
    returnMeetingDetailsForVisibilityManager(message) {
        if (message.error) {
            this.logging.showErrorLog('Unable get meeting details', message.error);
        }
        this.setMeetingInTheForm(message.meetingDetails, message.setLink);
    }
    sendChromeOnlyMessageToTheBackground(possibleMeetingId) {
        return new Promise(((resolve, reject) => {
            this.apiLogic.api.runtime.sendMessage({
                action: 'getVanityMeetingForChrome',
                vanity: possibleMeetingId,
            }, (meeting) => {
                if (meeting.isError) {
                    return reject(meeting);
                }
                return resolve(meeting);
            });
        }));
    }
}
exports.VisibilityMeetingsManager = VisibilityMeetingsManager;

},{"../logging/logging":108,"tooltip.js":59}],119:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageManager = void 0;
class MessageManager {
    constructor(settings) {
        this.settings = settings;
    }
    getErrorMessage() {
        return this.getMessageElement(this.errorMessage);
    }
    getInfoMessage() {
        return this.getMessageElement(this.infoMessage);
    }
    showMessage(options) {
        const newMessage = this.createMessageInstance(options);
        this.message = this.setMessage(newMessage, this.message);
    }
    setErrorMessage(options) {
        options.isInfoMessage = false;
        const newErrorMessage = this.createMessageInstance(options);
        if (options.customContainerSelector) {
            return this.errorMessage = this.setMessage(newErrorMessage, this.errorMessage, options.customContainerSelector);
        }
        this.errorMessage = this.setMessage(newErrorMessage, this.errorMessage);
    }
    setInfoMessage(options) {
        options.isInfoMessage = true;
        const newInfoMessage = this.createMessageInstance(options);
        this.infoMessage = this.setMessage(newInfoMessage, this.infoMessage);
    }
    removeErrorMessage() {
        const that = this;
        if (this.errorMessage) {
            that.removeMessage(this.errorMessage);
        }
        this.errorMessage = null;
    }
    removeInfoMessage() {
        const that = this;
        if (this.infoMessage) {
            this.removeMessage(that.infoMessage);
        }
        this.infoMessage = null;
    }
    removeMessage(message) {
        const that = this;
        if (message) {
            const $message = this.getMessageElement(message);
            $message.remove();
            return true;
        }
        return null;
    }
    getMessageElement(message) {
        const that = this;
        if (message) {
            const messageClass = message.getMessageClass();
            return $(that.settings.containerSelector).find('.' + messageClass);
        }
        return null;
    }
    addAnimation($message, message) {
        if (message.isTemporary) {
            $message.delay(this.settings.messageHidingDelayTime)
                .animate({ opacity: '0' }, 'slow')
                .hide(this.settings.messageHidingDurationTime).delay(this.settings.minDelayTime);
        }
    }
    isMessageAlreadyExist(message) {
        return (message && this.getMessageElement(message));
    }
    setMessage(newMessage, oldMessage, containerSelector = this.settings.containerSelector) {
        const that = this;
        let $message = null;
        if (!this.isMessageAlreadyExist(oldMessage) || newMessage.isHavingHighestPriorityThenGettingMessage(oldMessage)) {
            this.removeMessage(oldMessage);
            $(containerSelector).prepend(newMessage.getMessageWrapper());
            $message = $(containerSelector).find('.' + newMessage.getMessageClass());
            this.addMessageInterior($message, newMessage);
            that.settings.localizationLanguageManager.localize();
            this.addAnimation($message, newMessage);
            this.addHandlers($message, newMessage);
            return newMessage;
        }
        return oldMessage;
    }
    addMessageInterior($message, message) {
        const messageInterior = message.getMessageInterior();
        $message.find('.' + message.getMessageWrapperClass()).append(messageInterior);
    }
    addHandlers($message, message) {
        $message.find('.' + message.getCloseButtonClass()).on('click', () => {
            $message.remove();
            message.onCloseHandler();
        });
    }
    createMessageInstance(settings) {
        const Message = class {
            constructor(settings) {
                this.messageWrapperClass = 'fuze-for-browser-extension-message__text-wrapper';
                this.closeButtonClass = 'fuze-for-browser-extension-show-message__close-button';
                this.interior = settings.interior;
                this.messageClass = (settings.isInfoMessage) ? ('fuze-for-browser-extension-info-message') : ('fuze-for-browser-extension-error-message');
                this.displayCloseButton = settings.displayCloseButton;
                this.onCloseHandler = settings.onCloseHandler || function () {
                };
                this.isTemporary = settings.isTemporary;
            }
            getMessageClass() {
                return this.messageClass;
            }
            getMessageWrapper() {
                let messageWrapper = '<div class="fuze-for-browser-extension-show-message ' + this.messageClass;
                if (this.displayCloseButton) {
                    messageWrapper += '"><div class="' + this.messageClass + '__close-button-wrapper">' +
                        '<span class="fuze-for-browser-extension-show-message__close-button"></span></div>';
                }
                else {
                    messageWrapper += ' fuze-for-browser-extension-show-message--without-close-button">';
                }
                messageWrapper += '<div class="' + this.messageWrapperClass + '"></div></div>';
                return messageWrapper;
            }
            getMessageWrapperClass() {
                return this.messageWrapperClass;
            }
            getMessageInterior() {
                return this.interior;
            }
            getDisplayCloseButton() {
                return this.displayCloseButton;
            }
            getCloseButtonClass() {
                return this.closeButtonClass;
            }
            getOnCloseHandler() {
                return this.onCloseHandler;
            }
            isHavingHighestPriorityThenGettingMessage(message) {
                if (!this.isTemporary && message.isTemporary) {
                    return true;
                }
                if ((this.isTemporary === message.isTemporary) &&
                    (!this.getDisplayCloseButton() && message.getDisplayCloseButton())) {
                    return true;
                }
                return ((this.isTemporary === message.isTemporary) &&
                    (this.getDisplayCloseButton() === message.getDisplayCloseButton()));
            }
        };
        return (new Message(settings));
    }
}
exports.MessageManager = MessageManager;

},{}],120:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MixPanelService = void 0;
const extensionSettings_1 = require("../repository/extensionSettings");
const fetch = require('node-fetch');
const api_1 = require("../api");
const environment_1 = require("../repository/environment");
class MixPanelService {
    static uuidv4() {
        return 'xxxxxxxx-xxxx-4xxx-yxxx-xxxxxxxxxxxx'.replace(/[xy]/g, function (c) {
            var r = Math.random() * 16 | 0, v = c == 'x' ? r : (r & 0x3 | 0x8);
            return v.toString(16);
        });
    }
    static getBrowserVersion(browserAgentVersion) {
        var ua = browserAgentVersion, tem, M = ua.match(/(opera|chrome|safari|firefox|msie|trident(?=\/))\/?\s*(\d+)/i) || [];
        if (/trident/i.test(M[1])) {
            tem = /\brv[ :]+(\d+)/g.exec(ua) || [];
            return { name: 'IE', version: (tem[1] || '') };
        }
        if (M[1] === 'Chrome') {
            tem = ua.match(/\bOPR|Edge\/(\d+)/);
            if (tem != null) {
                return { name: 'Opera', version: tem[1] };
            }
        }
        M = M[2] ? [M[1], M[2]] : [navigator.appName, navigator.appVersion, '-?'];
        if ((tem = ua.match(/version\/(\d+)/i)) != null) {
            M.splice(1, 1, tem[1]);
        }
        return {
            name: M[0],
            version: M[1]
        };
    }
    static sendEvent(request, eventName) {
        return __awaiter(this, void 0, void 0, function* () {
            const apiLogic = new api_1.APILogic();
            const versionExtension = apiLogic.getVersion();
            const extensionSettings = new extensionSettings_1.ExtensionSettings(apiLogic);
            const userTenant = yield extensionSettings.getUserTenant();
            const userName = yield extensionSettings.getUserNameFromLocalDatabase();
            let environment = yield new environment_1.Environment(extensionSettings).get();
            if (eventName === 'main') {
                return;
            }
            let token = environment === 'staging' ? '91b9a7911b4c28bfad32c8aaa669b8f2' : '64054fec511835569829ce2a84ba4914';
            const url = 'https://api.mixpanel.com/track';
            const distinct_id = this.uuidv4();
            const { action, object, place, platform, browserVersion } = request;
            if (this.lastMixPanelEvent === object) {
                return;
            }
            this.lastMixPanelEvent = object;
            let { name, version } = this.getBrowserVersion(browserVersion);
            let friendlyBrowserVersion = `${name} - ${version}`;
            environment = (environment === 'staging') ? 'stage' : environment;
            const bodyRequest = {
                event: eventName,
                properties: {
                    userName,
                    userTenant,
                    distinct_id,
                    token,
                    action,
                    object,
                    place,
                    owner: 'team_integrations',
                    platform,
                    environment,
                    version: versionExtension,
                    browserVersion: friendlyBrowserVersion,
                }
            };
            let data = 'data=';
            data += JSON.stringify(bodyRequest);
            const options = {
                method: 'POST',
                headers: {
                    Accept: 'text/plain',
                    'Content-Type': 'application/x-www-form-urlencoded;charset=UTF-8'
                },
                body: data
            };
            fetch(url, options)
                .then(res => res.json())
                .then(json => console.log(json))
                .catch(err => console.log('error:' + err));
        });
    }
}
exports.MixPanelService = MixPanelService;
MixPanelService.lastMixPanelEvent = '';

},{"../api":61,"../repository/environment":135,"../repository/extensionSettings":136,"node-fetch":49}],121:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FirstTimeJoinMeeting = void 0;
const resources_1 = require("../repository/resources");
const html_helper_1 = require("../helpers/html-helper");
class FirstTimeJoinMeeting {
    constructor(currentJoinOption, apiLogic, extensionSettings) {
        this.currentJoinOption = currentJoinOption;
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.modalHtml = require('../first-time-join-meeting-modal.html');
        this.modalGrayZoneClass = '.modal-gray-zone';
        this.modalId = 'first-time-join-meeting-modal';
        this.joinOptionSelector = '.first-time-join-meeting-modal__option';
        this.selectedOptionClass = 'first-time-join-meeting-modal__option_selected';
        this.joinMeetingButtonClass = '.first-time-join-meeting-modal__join-meeting-button';
        this.joinDesktopImageClass = '.join-desktop-logo';
        this.joinWebImageClass = '.join-web-logo';
        this.joinDesktopImagePath = 'images/modals/join-desktop-logo.svg';
        this.joinWebImagePath = 'images/modals/join-web-logo.svg';
        this.closeModalIconPath = 'images/modals/close-modal-icon.png';
        this.resources = new resources_1.Resources({}, this.apiLogic);
    }
    showModal(joinByDesktop, joinByWeb) {
        html_helper_1.addDivToDocument(this.modalHtml, this.modalId);
        this.initializeImages();
        this.initializeButtons(joinByDesktop, joinByWeb);
    }
    initializeImages() {
        const pathToDesktopImage = this.resources.getExtensionFilePath(this.joinDesktopImagePath);
        const pathToWebImage = this.resources.getExtensionFilePath(this.joinWebImagePath);
        document.querySelector(this.joinDesktopImageClass).setAttribute('src', pathToDesktopImage);
        document.querySelector(this.joinWebImageClass).setAttribute('src', pathToWebImage);
    }
    initializeButtons(joinByDesktop, joinByWeb) {
        const modal = document.querySelector(`#${this.modalId}`);
        const modalGrayZone = modal.querySelector(this.modalGrayZoneClass);
        const modalCloseButton = modal.querySelector('.first-time-join-meeting-modal__close-button');
        const modalJoinMeetingOptions = modal.querySelectorAll(this.joinOptionSelector);
        const pathToCloseModalImage = this.resources.getExtensionFilePath(this.closeModalIconPath);
        const joinMeetingButton = modal.querySelector(this.joinMeetingButtonClass);
        modalGrayZone.addEventListener('click', () => this.closeModal(modal));
        modalCloseButton.style.background = `url(${pathToCloseModalImage}) center no-repeat`;
        modalCloseButton.addEventListener('click', () => this.closeModal(modal));
        modalJoinMeetingOptions.forEach((optionElement) => {
            if (optionElement.getAttribute('data-joinOption') === this.currentJoinOption) {
                optionElement.classList.add((this.selectedOptionClass));
            }
            optionElement.addEventListener('click', (event) => {
                const newSelectedOption = event.currentTarget;
                if (!newSelectedOption.classList.contains(this.selectedOptionClass)) {
                    modalJoinMeetingOptions.forEach((optionElementToDeselect) => {
                        optionElementToDeselect.classList.remove(this.selectedOptionClass);
                    });
                    newSelectedOption.classList.add(this.selectedOptionClass);
                }
            });
        });
        joinMeetingButton.addEventListener('click', () => __awaiter(this, void 0, void 0, function* () {
            let selectedOptionValue;
            const desktopOption = this.apiLogic.constants.joinMeetingsOptions.DESKTOP;
            const selectedOption = document.querySelector(`.${this.selectedOptionClass}`);
            if (selectedOption) {
                selectedOptionValue = selectedOption.getAttribute('data-joinOption') || desktopOption;
            }
            yield this.extensionSettings.setJoinMeetingsOption(selectedOptionValue);
            this.closeModal(modal);
            if (selectedOptionValue === desktopOption) {
                return joinByDesktop();
            }
            else {
                return joinByWeb();
            }
        }));
    }
    closeModal(modal) {
        modal.parentNode.removeChild(modal);
    }
}
exports.FirstTimeJoinMeeting = FirstTimeJoinMeeting;

},{"../first-time-join-meeting-modal.html":82,"../helpers/html-helper":93,"../repository/resources":142}],122:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.MutationObserverBase = void 0;
class MutationObserverBase {
    constructor(callback, node, config) {
        this.node = node;
        this.config = config;
        this._observer = new MutationObserver(callback);
    }
    observe() {
        this._disconnect();
        this._observe();
    }
    disconnect() {
        this._disconnect();
    }
    _disconnect() {
        if (this._observer) {
            this._observer.disconnect();
        }
    }
    _observe() {
        this._observer.observe(this.node, this.config);
    }
}
exports.MutationObserverBase = MutationObserverBase;

},{}],123:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-for-browser-extension-notification-wrapper">\n    <div class="fuze-for-browser-extension-notification">\n        <div class="fuze-for-browser-extension-notification__1-column">\n            <img class="fuze-for-browser-extension-notification-1-column__logo fuze-for-browser-extension-notification__image"/>\n        </div>\n        <div class="fuze-for-browser-extension-notification__2-column">\n            <h1 class="fuze-for-browser-extension-notification-2-column__title fuze-for-browser-extension-notification__title"></h1>\n\n            <p class="fuze-for-browser-extension-notification-2-column__description fuze-for-browser-extension-notification__description"></p>\n\n            <div class="fuze-for-browser-extension-notification-2-column__button-wrapper">\n                <button class="fuze-for-browser-extension-notification-2-column-button-wrapper__button fuze-for-browser-extension-notification__cancel-button"\n                data-i18next="FUZELOC_generic_ignore">\n                    ignore\n                </button>\n                <button class="fuze-for-browser-extension-notification-2-column-button-wrapper__button fuze-for-browser-extension-notification__confirm-button">\n                    ok\n                </button>\n            </div>\n        </div>\n        <div class="fuze-for-browser-extension-notification__3-column">\n            <div class="fuze-for-browser-extension-notification-3-column__close-button"></div>\n        </div>\n    </div>\n</div>';

},{}],124:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.HomeCountryNotificationManager = void 0;
const logging_1 = require("../logging/logging");
class HomeCountryNotificationManager {
    constructor(settings, extensionSettings, message) {
        this.settings = settings;
        this.extensionSettings = extensionSettings;
        this.message = message;
        this.containerSelector = 'body';
        this.imageSelector = '.fuze-for-browser-extension-home-country-notification__image';
        this.notificationWrapperSelector = '.fuze-for-browser-extension-notification-wrapper';
        this.notificationSelector = '.fuze-for-browser-extension-home-country-notification';
        this.countryCodesInputSelector = '.fuze-for-browser-extension-home-country-notification__home-country';
        this.confirmButtonSelector = '.fuze-for-browser-extension-home-country-notification__confirm-button';
        this.countryDropdownSelector = '.fuze-for-browser-extension-home-country-notification__country-dropdown';
        this.identificationCountryCodeAttribute = 'data-fuze-for-browser-extension-identification-country-code';
        this.activeDropdownStateClass = 'fuze-for-browser-extension-home-country-notification__active-dropdown';
        this.isHomeCountryUpdatedSuccessful = false;
        this.dropdownManager = null;
        this.homeCountryShowingDesciption = '';
        this.logging = logging_1.Logging.getInstance();
        this.countriesList = settings.countryManager.getCountryCodeList();
        this.arrowImagePath = settings.resourcesRepository.getExtensionFilePath(settings.arrowImagePath);
        this.activeArrowImagePath = settings.resourcesRepository.getExtensionFilePath(settings.activeArrowImagePath);
    }
    show() {
        this.showNotification();
    }
    hide() {
        this.removeNotification();
    }
    removeNotification() {
        $(this.notificationSelector).remove();
    }
    initializeButtons() {
        $(this.confirmButtonSelector).on('click', () => __awaiter(this, void 0, void 0, function* () {
            this.isHomeCountryUpdatedSuccessful = true;
            yield this.extensionSettings.setIsHomeCountryUpdatedSuccessful(this.isHomeCountryUpdatedSuccessful);
            this.message.sendMessageToBackground({
                action: 'homeCountryUpdated',
                homeCountry: this.settings.currentHomeCountry,
            });
            yield this.extensionSettings.setHomeCountryToStorage(this.settings.currentHomeCountry);
            yield this.extensionSettings.setIsHomeCountryUpdatedSuccessful(this.isHomeCountryUpdatedSuccessful);
            this.logging.showInfoLog(`Saved user's home country code is ${this.settings.currentHomeCountry}`);
            this.removeNotification();
        }));
        $('.fuze-for-browser-extension-home-country-notification-3-column__close-button').on('click', () => {
            this.removeNotification();
        });
        return;
    }
    setActualHomeCountry(homeCountry) {
        homeCountry = homeCountry || this.settings.defaultHomeCountryISO;
        if (homeCountry) {
            const countryData = this.settings.countryManager.getCountryValueByCode(homeCountry);
            this.homeCountryShowingDesciption = countryData.value;
            this.settings.currentHomeCountry = countryData.countryCode;
            $(this.countryCodesInputSelector).val(this.homeCountryShowingDesciption)
                .attr(this.identificationCountryCodeAttribute, this.settings.currentHomeCountry);
        }
    }
    initializeCountryCodesDropdown() {
        this.dropdownManager = new this.settings.DropdownManager({
            arrowImagePath: this.arrowImagePath,
            activeArrowImagePath: this.activeArrowImagePath,
            $inputForAutoComplete: $(this.countryCodesInputSelector),
            dropdownListContainerSelector: this.countryDropdownSelector,
            dataSource: this.countriesList,
            onItemSelected: (event, ui) => {
                if (ui.item) {
                    this.settings.currentHomeCountry = ui.item.countryCode;
                    this.setActualHomeCountry(this.settings.currentHomeCountry);
                }
                else {
                    this.showNotification();
                }
            },
            showScroll: true,
            onDropdownOpenHandler: () => {
                $(this.notificationSelector).addClass(this.activeDropdownStateClass);
                this.dropdownManager.setCurrentValueItem(this.homeCountryShowingDesciption);
            },
            onDropdownCloseHandler: () => {
                $(this.notificationSelector).removeClass(this.activeDropdownStateClass);
                if (this.settings.currentHomeCountry) {
                    this.dropdownManager.setCurrentValueItem(this.settings.currentHomeCountry);
                }
                if ($(this.countryCodesInputSelector).val() !== this.homeCountryShowingDesciption) {
                    $(this.countryCodesInputSelector).val(this.homeCountryShowingDesciption);
                }
            },
        });
        this.dropdownManager.initialize();
    }
    showNotification() {
        this.settings.localizationLanguageManager.localize();
        $(this.containerSelector).find(this.notificationWrapperSelector).remove();
        $(this.containerSelector).prepend(this.settings.notificationView);
        $(this.imageSelector).attr('src', this.settings.resourcesRepository.getIcon());
        this.initializeCountryCodesDropdown();
        this.initializeButtons();
        this.setActualHomeCountry('');
        $(this.notificationSelector).show();
    }
}
exports.HomeCountryNotificationManager = HomeCountryNotificationManager;

},{"../logging/logging":108}],125:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationManager = void 0;
class NotificationManager {
    constructor(settings) {
        this.settings = settings;
        this.containerSelector = 'body';
        this.imageSelector = '.fuze-for-browser-extension-notification__image';
        this.notificationWrapperSelector = '.fuze-for-browser-extension-notification-wrapper';
        this.notificationSelector = '.fuze-for-browser-extension-notification';
        this.confirmButtonSelector = '.fuze-for-browser-extension-notification__confirm-button';
        this.cancelButtonSelector = '.fuze-for-browser-extension-notification__cancel-button';
        this.closeButtonSelector = '.fuze-for-browser-extension-notification-3-column__close-button';
        this.notificationTitleSelector = '.fuze-for-browser-extension-notification__title';
        this.notificationDescriptionSelector = '.fuze-for-browser-extension-notification__description';
        const emptyArrowFunction = () => {
            return;
        };
        this.onConfirmHandler = settings.onConfirmHandler || emptyArrowFunction;
        this.onCloseHandler = settings.onCloseHandler || emptyArrowFunction;
        this.doesExistConfirmButton = settings.doesExistConfirmButton || false;
        this.doesExistCancelButton = settings.doesExistCancelButton || false;
        this.confirmButtonTextKey = settings.confirmButtonTextKey || '';
    }
    show() {
        this.showNotification();
    }
    hide() {
        this.removeNotification();
    }
    removeNotification() {
        $(this.notificationSelector).remove();
    }
    initializeButtons() {
        if ($(this.confirmButtonSelector) && $(this.confirmButtonSelector).length) {
            $(this.confirmButtonSelector).on('click', () => {
                this.onConfirmHandler();
            });
        }
        if ($(this.cancelButtonSelector) && $(this.cancelButtonSelector).length) {
            $(this.cancelButtonSelector).on('click', () => {
                this.onCloseHandler();
                this.removeNotification();
            });
        }
        $(this.closeButtonSelector).on('click', () => {
            this.onCloseHandler();
            this.removeNotification();
        });
    }
    showNotification() {
        $(this.containerSelector).find(this.notificationWrapperSelector).remove();
        $(this.containerSelector).prepend(this.settings.notificationView);
        this.settings.localizationLanguageManager.localize();
        $(this.imageSelector).attr('src', this.settings.resourcesRepository.getIcon());
        if (this.settings.notificationTitleKey) {
            $(this.notificationTitleSelector)
                .text(this.settings.localizationLanguageManager.getTranslate(this.settings.notificationTitleKey));
        }
        if (this.confirmButtonTextKey) {
            $(this.containerSelector)
                .find(this.confirmButtonSelector)
                .text(this.settings.localizationLanguageManager.getTranslate(this.confirmButtonTextKey));
        }
        if (this.settings.notificationDescription) {
            $(this.notificationDescriptionSelector).html(this.settings.notificationDescription);
        }
        if (this.settings.notificationDescriptionKey) {
            $(this.notificationDescriptionSelector)
                .html(this.settings.localizationLanguageManager.getTranslate(this.settings.notificationDescriptionKey));
        }
        if (this.settings.uniqueNotificationClass) {
            $(this.notificationWrapperSelector).addClass(this.settings.uniqueNotificationClass);
        }
        if (!this.doesExistConfirmButton && !this.doesExistCancelButton) {
            $($(this.cancelButtonSelector).parent()).remove();
        }
        else if (!this.doesExistConfirmButton) {
            $(this.confirmButtonSelector).remove();
        }
        else if (!this.doesExistCancelButton) {
            $(this.cancelButtonSelector).remove();
        }
        this.initializeButtons();
        $(this.notificationSelector).show();
    }
}
exports.NotificationManager = NotificationManager;

},{}],126:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignInStatusNotification = void 0;
class SignInStatusNotification {
    constructor(settings) {
        this.settings = settings;
        this.containerSelector = 'body';
        this.notificationWrapperSelector = '.fuze-for-browser-extension-notification-wrapper';
        this.imageSelector = '.fuze-for-browser-extension-notification__image';
        this.signInButtonSelector = '.fuze-for-browser-extension-sign-in-menu__sign-in-button';
        this.closeButtonSelector = '.fuze-for-browser-extension-notification-0-column__close-button';
        this.notificationTitleSelector = '.fuze-for-browser-extension-notification__title';
        this.extensionNameSelector = '.fuze-for-browser-extension-extension-name';
        this.displayEffectsDelay = 10;
        this.defaultHandler = function () {
        };
        this.doesExistCloseButton = settings.doesExistCloseButton || false;
        this.doesExistConfirmButton = settings.doesExistConfirmButton || false;
        this.currentPlatform = settings.currentPlatform || '';
        this.iconPath = (settings.iconPath) ? this.settings.resourcesRepository.getExtensionFilePath(settings.iconPath) : '';
        this.onConfirmHandler = settings.onConfirmHandler || this.defaultHandler;
        this.onCloseHandler = settings.onCloseHandler || this.defaultHandler;
        this.notificationTitle = settings.notificationTitle || '';
    }
    removeNotification() {
        $(this.notificationWrapperSelector).remove();
    }
    initializeCloseButtonTooltip() {
        const tooltipManagerForCloseButton = new this.settings.TooltipManager({
            $placeToInject: $('.fuze-for-browser-extension-sign-in-menu'),
            tooltipClass: 'fuze-for-browser-extension-sign-in-menu-close-button',
        });
        tooltipManagerForCloseButton.initialize({
            $elementsToAction: $(this.closeButtonSelector),
            setTooltipText: () => {
                return this.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_ignore');
            },
        });
    }
    initializeButtons() {
        if (this.doesExistConfirmButton && $(this.signInButtonSelector) && $(this.signInButtonSelector).length) {
            $(this.notificationWrapperSelector).find(this.settings.uniqueNotificationClass).find(this.signInButtonSelector).on('click', () => {
                this.onConfirmHandler();
                this.removeNotification();
            });
        }
        if (this.doesExistCloseButton) {
            $(this.notificationWrapperSelector).find(this.settings.uniqueNotificationClass).find(this.closeButtonSelector).on('click', () => {
                if (this.doesExistConfirmButton) {
                    this.settings.applyDisplayEffects(this.settings.uniqueNotificationClass);
                }
                else {
                    this.removeNotification();
                }
                this.onCloseHandler();
            });
            const isNeedTooltip = Boolean(this.settings.TooltipManager);
            if (isNeedTooltip) {
                this.initializeCloseButtonTooltip();
            }
        }
        else {
            $(this.notificationWrapperSelector).find(this.settings.uniqueNotificationClass).find(this.closeButtonSelector).remove();
        }
    }
    showNotification() {
        $(this.containerSelector).prepend(this.settings.notificationView);
        this.settings.localizationLanguageManager.localize();
        $(this.notificationWrapperSelector).find(this.imageSelector).attr('src', this.iconPath || this.settings.resourcesRepository.getIcon());
        if (this.notificationTitle) {
            if (this.currentPlatform) {
                const extensionName = this.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_extensionName.' + this.currentPlatform);
                this.notificationTitle = this.notificationTitle + ' ' + extensionName + '!';
            }
            $(this.notificationTitleSelector).text(this.notificationTitle);
        }
        this.initializeButtons();
        if (!this.doesExistConfirmButton) {
            $(this.settings.uniqueNotificationClass).attr('style', 'display: block !important');
            setTimeout(() => {
                this.settings.applyDisplayEffects(this.settings.uniqueNotificationClass);
            }, this.displayEffectsDelay);
        }
        $(this.notificationWrapperSelector).find(this.settings.uniqueNotificationClass).show();
        if (this.settings.signStatusNotificationDelay) {
            setTimeout(() => {
                this.removeNotification();
            }, this.settings.signStatusNotificationDelay);
        }
    }
    show() {
        this.showNotification();
    }
    hide() {
        this.removeNotification();
    }
}
exports.SignInStatusNotification = SignInStatusNotification;

},{}],127:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.SignedStatusNotification = void 0;
const iframe_helper_1 = require("../helpers/iframe-helper");
class SignedStatusNotification {
    constructor(settings, extensionSettings, message) {
        this.settings = settings;
        this.extensionSettings = extensionSettings;
        this.message = message;
        this.SIGN_IN = 'signIn';
        this.SIGN_OUT = 'signOut';
        this.signStatusNotificationSelector = '.fuze-for-browser-extension__sign-in-status';
        this.displayEffectsClass = 'fuze-for-browser-extension-move-to-left';
        this.isUserLoggedInBefore = false;
        this.signInNotification = null;
        this.signOutNotification = null;
        this.initUserLoggedInState();
        if (iframe_helper_1.isIframeRuntime()) {
            return;
        }
        this.message.addMessageListener((messageInfo) => {
            if (messageInfo && messageInfo.action) {
                switch (messageInfo.action) {
                    case 'successfulLogin':
                        this.showSignInNotification();
                        break;
                    case 'successfulLogout':
                        this.showSignOutNotification();
                        break;
                    default:
                        break;
                }
            }
        });
        this.startDetectionChangingSignInStatus();
    }
    applyDisplayEffects() {
        $(this.signStatusNotificationSelector).addClass(this.displayEffectsClass);
    }
    initializeNotification(notificationTitle, onCloseHandler) {
        return (new this.settings.SignInStatusNotification({
            applyDisplayEffects: () => {
                this.applyDisplayEffects();
            },
            currentPlatform: this.settings.currentPlatform,
            doesExistCloseButton: true,
            doesExistConfirmButton: false,
            iconPath: '/images/popup/check-green.svg',
            localizationLanguageManager: this.settings.localizationLanguageManager,
            notificationTitle,
            notificationView: this.settings.notificationView,
            onCloseHandler,
            resourcesRepository: this.settings.resourcesRepository,
            signStatusNotificationDelay: this.settings.signStatusNotificationDelay,
            uniqueNotificationClass: this.signStatusNotificationSelector,
        }));
    }
    hideSignInNotification() {
        if (this.signInNotification) {
            this.signInNotification.hide();
        }
        this.signInNotification = null;
    }
    hideSignOutNotification() {
        if (this.signOutNotification) {
            this.signOutNotification.hide();
        }
        this.signOutNotification = null;
    }
    initializeSignInNotification() {
        this.signInNotification = this.initializeNotification(this.settings.localizationLanguageManager.getTranslate('FUZELOC_notification_signIn'), () => {
            this.hideSignInNotification();
        });
        this.signInNotification.show();
    }
    initializeSignOutNotification() {
        this.signOutNotification = this.initializeNotification(this.settings.localizationLanguageManager.getTranslate('FUZELOC_notification_signOut'), () => {
            this.hideSignOutNotification();
        });
        this.signOutNotification.show();
    }
    detectIsNotificationShowedBefore(currentNotificationType, initializeNotification, hideOtherwiseNotification) {
        return __awaiter(this, void 0, void 0, function* () {
            hideOtherwiseNotification();
            let isNotificationShowedOnce = (yield this.extensionSettings.getIsNotificationShowedOnce()) || {};
            if (!isNotificationShowedOnce[currentNotificationType]) {
                const otherwiseNotificationType = (currentNotificationType === this.SIGN_IN) ? this.SIGN_OUT : this.SIGN_IN;
                initializeNotification();
                isNotificationShowedOnce[currentNotificationType] = true;
                isNotificationShowedOnce[otherwiseNotificationType] = false;
                this.extensionSettings.setIsNotificationShowedOnce(isNotificationShowedOnce);
            }
        });
    }
    showSignInNotification() {
        this.detectIsNotificationShowedBefore(this.SIGN_IN, () => {
            this.initializeSignInNotification();
        }, () => {
            this.hideSignOutNotification();
        });
    }
    showSignOutNotification() {
        this.detectIsNotificationShowedBefore(this.SIGN_OUT, () => {
            this.initializeSignOutNotification();
        }, () => {
            this.hideSignInNotification();
        });
    }
    startDetectionChangingSignInStatus() {
        const that = this;
        setInterval(() => __awaiter(this, void 0, void 0, function* () {
            const isUserLoggedIn = yield this.extensionSettings.getIsUserLoggedIn();
            const isLoggedIn = (that.isUserLoggedInBefore !== isUserLoggedIn) && isUserLoggedIn;
            const isLoggedOut = (that.isUserLoggedInBefore !== isUserLoggedIn) && that.isUserLoggedInBefore;
            if (isLoggedIn) {
                that.showSignInNotification();
            }
            if (isLoggedOut) {
                this.message.sendMessageToPopup({ action: 'closePopup' });
                that.showSignOutNotification();
            }
            if (isLoggedOut || isLoggedIn) {
                that.isUserLoggedInBefore = isUserLoggedIn;
            }
        }), 300);
    }
    initUserLoggedInState() {
        return __awaiter(this, void 0, void 0, function* () {
            this.isUserLoggedInBefore = yield this.extensionSettings.getIsUserLoggedIn();
        });
    }
}
exports.SignedStatusNotification = SignedStatusNotification;

},{"../helpers/iframe-helper":94}],128:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.OldChromeCredentialsManager = void 0;
const logging_1 = require("./logging/logging");
const api_1 = require("./api");
const extensionSettings_1 = require("./repository/extensionSettings");
class OldChromeCredentialsManager {
    constructor(settings) {
        this.settings = settings;
        this.apiLogic = new api_1.APILogic();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(this.apiLogic);
        this.logging = logging_1.Logging.getInstance();
    }
    copyUserDataFromChromeStorageIfNeeded(key, callback) {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            if (!(yield this.extensionSettings.getPolyfill(key))) {
                that.settings.getOldCredentials(key, (value) => __awaiter(this, void 0, void 0, function* () {
                    const settingData = {};
                    settingData[key] = value;
                    if (value) {
                        yield that.extensionSettings.setPolyfill(settingData);
                        callback(value);
                    }
                    else {
                        callback();
                    }
                }));
            }
        });
    }
    getUsernameFromOldApplicationStorage(callback) {
        const that = this;
        this.copyUserDataFromChromeStorageIfNeeded(that.settings.keyUsername, (username) => {
            callback(username);
        });
    }
    getPasswordFromOldApplicationStorage(callback) {
        const that = this;
        this.copyUserDataFromChromeStorageIfNeeded(that.settings.keyPassword, (password) => {
            callback(password);
        });
    }
    copyIgnoredDomainsListToNewStorageIfNeeded() {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            if (yield this.extensionSettings.getUserDomains()) {
                that.settings.getOldCredentials(that.settings.keyDomains, (ignoredDomains) => {
                    if (ignoredDomains && ignoredDomains.tpn_domains) {
                        const ignoredDomainsList = JSON.parse(ignoredDomains.tpn_domains);
                        if (ignoredDomainsList.length) {
                            that.extensionSettings.setUserDomains(ignoredDomainsList);
                        }
                    }
                });
            }
        });
    }
    getWardenTokenFromOldApplicationStorage(callback) {
        const that = this;
        this.copyUserDataFromChromeStorageIfNeeded(that.settings.keyWardenToken, (wardenToken) => {
            callback(wardenToken);
        });
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            if ((yield this.extensionSettings.getPolyfill(that.settings.wasChromeCredentialsCopied)) !== true) {
                const settingData = {};
                settingData[that.settings.wasChromeCredentialsCopied] = true;
                this.extensionSettings.setPolyfill(settingData);
                that.copyIgnoredDomainsListToNewStorageIfNeeded();
                that.getUsernameFromOldApplicationStorage((userName) => {
                    that.getPasswordFromOldApplicationStorage((password) => {
                        that.getWardenTokenFromOldApplicationStorage((wardenToken) => {
                            if (!wardenToken) {
                                that.settings.credentialsRepository.getUserOptions(userName, (userOptions) => {
                                    that.userOptions = userOptions;
                                    if (userName && password && userOptions) {
                                        that.settings.credentialsRepository.getWardenToken(userName, password, userOptions.data.options[0].optionId, (generatedWardenToken) => __awaiter(this, void 0, void 0, function* () {
                                            const settingData = {};
                                            settingData[that.settings.keyWardenToken] = generatedWardenToken.data.grant.token;
                                            that.extensionSettings.setPolyfill(settingData);
                                        }));
                                    }
                                }, (error) => {
                                    that.logging.showErrorLog('Failed getting user options from the storage', error);
                                });
                            }
                        });
                    });
                });
            }
        });
    }
}
exports.OldChromeCredentialsManager = OldChromeCredentialsManager;

},{"./api":61,"./logging/logging":108,"./repository/extensionSettings":136}],129:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PopupIgnoredDomains = void 0;
const domains_to_ignore_1 = require("../constants/domains-to-ignore");
const logging_1 = require("../logging/logging");
const api_1 = require("../api");
const extensionSettings_1 = require("../repository/extensionSettings");
class PopupIgnoredDomains {
    constructor(settings, message) {
        this.settings = settings;
        this.message = message;
        this.$manageIgnoredDomainsMenu = $('.fuze-for-browser-extension-manage-ignored-domains-menu__interior');
        this.$goBack = $('.fuze-for-browser-extension-ignore-this-domain-menu--go-to-settings');
        this.$goToDisabledDomains = $('.fuze-for-browser-extension-manage-ignored-domains-menu--go-to-disabled-domains');
        this.$visualIgnoredDomainsList = $('.fuze-for-browser-extension-manage-ignored-domains-menu__list');
        this.$currentDomainToIgnore = $('.fuze-for-browser-extension-ignore-this-domain-menu__this-domain');
        this.$addDomainToIgnoreList = $('.fuze-for-browser-extension-ignore-this-domain-menu__add-this-domain-to-ignored');
        this.$cancelAddingDomainToIgnoreList = $('.fuze-for-browser-extension-ignore-this-domain-menu__cancel');
        this.$closeButtonOnShowingInfoMessage = $('.fuze-for-browser-extension-show-message__close-button');
        this.$addedIgnoreDomain = $('.fuze-for-browser-extension-message__link--added-domain-to-ignore');
        this.$interiorEmptyMessage = $('.fuze-for-browser-extension-manage-ignored-domains-menu__interior--empty');
        this.ignoreDomainTextCssClass = 'fuze-for-browser-extension-manage-ignored-domains-menu__link-text';
        this.ignoreDomainLinkCssClass = 'fuze-for-browser-extension-manage-ignored-domains-menu__link';
        this.removeIgnoredDomainsButtonCssClass = 'fuze-for-browser-extension-manage-ignored-domains-menu__remove-button--visibility-on-hover';
        this.domainsToremoveAttribute = 'data-fuze-for-browser-extension-domain-to-remove';
        this.showingMessage = $('.fuze-for-browser-extension-show-message.fuze-for-browser-extension-show-message--domain');
        this.domains = [];
        this.apiLogic = new api_1.APILogic();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(this.apiLogic);
        this.logging = logging_1.Logging.getInstance();
    }
    checkEmptynessOnInputEvents($input, $button) {
        const that = this;
        $input.on('keyup input cut mouseleave click', () => {
            const isEmpty = !Boolean($(this).val());
            that.settings.domHelper.buttons.setDisablingState($button, isEmpty);
            return true;
        });
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            yield that.getIgnoredDomainsList();
            that.setCustomScrollbar();
            that.checkEmptynessOnInputEvents(that.$currentDomainToIgnore, that.$addDomainToIgnoreList);
            that.$addDomainToIgnoreList.on('click', () => {
                const trimmedDomain = that.$currentDomainToIgnore.val();
                trimmedDomain.toLowerCase().trim();
                const currentDomain = that.settings.URLHelper.getDomainPartOfURL(trimmedDomain);
                that.addDomainToList(currentDomain);
                that.setCurrentDomainToIgnorePossibility();
                that.settings.showCurrentMenu('main');
            });
            that.$cancelAddingDomainToIgnoreList.on('click', () => {
                that.settings.browserActionRepository.closePopup();
            });
            that.$closeButtonOnShowingInfoMessage.on('click', () => {
                that.showingMessage.hide();
            });
            that.$goBack.on('click', () => {
                that.settings.showCurrentMenu('settings');
                that.setCurrentDomainToIgnorePossibility();
            });
            that.$goToDisabledDomains.on('click', () => {
                that.settings.showCurrentMenu('ignore-this-domain');
                that.setCurrentDomainToIgnorePossibility();
            });
            let setCurrentDomain = (activeTabUrl) => {
                const currentDomain = that.settings.URLHelper.getDomainPartOfURL(activeTabUrl);
                that.setCurrentDomainToIgnorePossibility(currentDomain);
                that.settings.addMessageListenerOnChangeTabToKnowActiveTabUrl = null;
                setCurrentDomain = null;
            };
            if (that.settings.activeTabUrl) {
                setCurrentDomain(that.settings.activeTabUrl);
            }
            else {
                that.settings.addMessageListenerOnChangeTabToKnowActiveTabUrl((activeTabUrl) => {
                    setCurrentDomain(activeTabUrl);
                });
            }
        });
    }
    setCustomScrollbar() {
        this.$visualIgnoredDomainsList.enscroll();
    }
    setCurrentDomainToIgnorePossibility(currentDomain) {
        if (currentDomain) {
            this.currentDomainToIgnore = currentDomain;
            this.$currentDomainToIgnore.val(currentDomain);
        }
        else if (this.currentDomainToIgnore) {
            this.$currentDomainToIgnore.val(this.currentDomainToIgnore);
        }
        this.settings.domHelper.buttons.setDisablingState(this.$addDomainToIgnoreList, false);
    }
    isDomainRestricted(domain) {
        if (this.domains.length) {
            for (let i = 0; i < this.domains.length; i++) {
                if (this.settings.URLHelper.isSubdomainOfTheDomain(domain, this.domains[i])) {
                    return true;
                }
            }
        }
        return false;
    }
    isDomainRestrictedForIframeParsing(domain) {
        if (domains_to_ignore_1.default.length) {
            for (let i = 0; i < domains_to_ignore_1.default.length; i++) {
                if (this.settings.URLHelper.isSubdomainOfTheDomain(domain, domains_to_ignore_1.default[i])) {
                    return true;
                }
            }
        }
        return false;
    }
    addDomainToList(currentDomain, previousIndexValue) {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            if (currentDomain && !that.isDomainRestricted(currentDomain)) {
                if (typeof previousIndexValue === 'number') {
                    that.logging.showInfoLog(previousIndexValue.toString());
                    that.domains.splice(previousIndexValue, 0, currentDomain);
                }
                else {
                    that.domains.unshift(currentDomain);
                    that.settings.showCurrentMenu('main');
                    that.showMessage(currentDomain, that.settings.localizationLanguageManager.getTranslate('FUZELOC_disabledDomains_notification'), true);
                }
                yield that.saveIgnoredDomainsList(that.domains);
                this.message.sendMessageToBackground({
                    action: 'checkExtensionStateOnTheCurrentPage',
                    isExtensionEnabled: false,
                });
                that.getIgnoredDomainsList();
            }
            else {
                that.settings.showCurrentMenu('main');
                that.showMessage(currentDomain, ' is already in the ignored domains list.', false);
                that.logging.showInfoLog(currentDomain + ' domain is already in the ignored domains list');
            }
        });
    }
    showMessageIntoIgnoredList($currentItem, currentDomain, previousIndexValue) {
        const that = this;
        const message = '<img class=\'fuze-for-browser-extension-popup-menu-list-removed-item__image\' src=\'../images/popup/checkmark.svg\' />' +
            '<a class=\'fuze-for-browser-extension-popup-menu-list__link fuze-for-browser-extension-manage-ignored-domains-menu-removed-item__link ' +
            that.ignoreDomainLinkCssClass + ' ' +
            'fuze-for-browser-extension-manage-ignored-domains-menu-list__link--with-icon\'>' +
            '<span class=\'fuze-for-browser-extension-popup-menu-list__link-text ' + that.ignoreDomainTextCssClass + '\'> ' + currentDomain +
            that.settings.localizationLanguageManager.getTranslate('FUZELOC_disabledDomains_domainHasBeenRemoved') +
            '</span><span class=\'fuze-for-browser-extension-popup-menu-list-removed-item__undo\'>' +
            that.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_undo') + '</span></a>';
        $currentItem.html(message).removeClass()
            .addClass('fuze-for-browser-extension-manage-ignored-domains-menu-list__link--with-icon ' +
            'fuze-for-browser-extension-manage-ignored-domains-menu-list__removed-item');
        $('.fuze-for-browser-extension-popup-menu-list-removed-item__undo').on('click', () => {
            that.addDomainToList(currentDomain, previousIndexValue);
        });
        setTimeout(() => {
            $currentItem.remove();
            that.showHideInteriorEmptyMessage();
        }, 5000);
    }
    removeDomainFromList(currentDomain, showMessageAboutRemovingElementIntoList) {
        return __awaiter(this, void 0, void 0, function* () {
            const that = this;
            yield this.getIgnoredDomainsList();
            if (currentDomain && that.isDomainRestricted(currentDomain)) {
                that.domains.splice(that.domains.indexOf(currentDomain), 1);
                that.saveIgnoredDomainsList(that.domains);
                this.message.sendMessageToBackground({
                    action: 'checkExtensionStateOnTheCurrentPage',
                    isExtensionEnabled: true,
                });
                if (showMessageAboutRemovingElementIntoList) {
                    const $currentItemsIntoList = $(`li[${that.domainsToremoveAttribute}]`);
                    const $currentItemToRemove = $(`li[${that.domainsToremoveAttribute}='${currentDomain}']`);
                    const previousIndexValue = $currentItemsIntoList.index($currentItemToRemove);
                    that.showMessageIntoIgnoredList($currentItemToRemove, currentDomain, previousIndexValue);
                }
                else {
                    that.getIgnoredDomainsList();
                    that.showMessage(currentDomain, that.settings.localizationLanguageManager.getTranslate('FUZELOC_disabledDomains_domainHasBeenRemoved'), false);
                }
                if (!that.domains[0]) {
                    that.tooltipManagerForLink.destroy();
                    that.tooltipManagerForCloseButton.destroy();
                }
                that.logging.showInfoLog(`${currentDomain} domain has been removed from the ignored domains list`);
            }
        });
    }
    showMessage(currentDomain, message, isShowingUndo) {
        const that = this;
        let messageInterior = '<p class="fuze-for-browser-extension-message__text-wrapper">' +
            '<a class="fuze-for-browser-extension-message--domain-info fuze-for-browser-extension-message__link fuze-for-browser-extension-message__link--added-domain-to-ignore">' +
            currentDomain + '</a>' +
            '<span class="fuze-for-browser-extension-message--domain-info fuze-for-browser-extension-message__text"> ' + message + ' </span>';
        if (isShowingUndo) {
            messageInterior += '<a class="fuze-for-browser-extension-message__link fuze-for-browser-extension-message__undo" href="#">' +
                that.settings.localizationLanguageManager.getTranslate('FUZELOC_generic_undo') + '</a>';
        }
        messageInterior += '</p>';
        this.settings.messageManager.setInfoMessage({
            interior: messageInterior,
            isTemporary: true,
            displayCloseButton: true,
        });
        this.settings.messageManager.getInfoMessage().find('.fuze-for-browser-extension-message__undo').on('click', () => {
            const ignoredDomain = that.settings.messageManager.getInfoMessage()
                .find('.fuze-for-browser-extension-message__link--added-domain-to-ignore').text().toLowerCase().trim();
            that.settings.showCurrentMenu('main');
            that.settings.messageManager.removeInfoMessage();
            that.removeDomainFromList(ignoredDomain);
        });
    }
    getIgnoredDomainsList() {
        return __awaiter(this, void 0, void 0, function* () {
            this.domains = (yield this.extensionSettings.getUserDomains()) || this.domains;
            this.setVisualIgnoredDomainsList();
            this.showHideInteriorEmptyMessage();
            return this.domains;
        });
    }
    showHideInteriorEmptyMessage() {
        if (this.domains[0]) {
            this.$interiorEmptyMessage.hide();
        }
        else {
            this.$interiorEmptyMessage.show();
        }
    }
    setVisualIgnoredDomainsList() {
        const that = this;
        let visualIgnoredDomainsList = '';
        for (let i = 0; i < that.domains.length; i++) {
            visualIgnoredDomainsList +=
                '<li class=\'fuze-for-browser-extension-popup-menu-list__item fuze-for-browser-extension-popup-menu-list__item_no-wrap fuze-for-browser-extension-manage-ignored-domains-menu-list__item ' +
                    'fuze-for-browser-extension-manage-ignored-domains-menu-list__link--with-icon\' ' + that.domainsToremoveAttribute + '=\'' +
                    that.domains[i] + '\' ' + '>' +
                    '<a class=\'fuze-for-browser-extension-popup-menu-list__link ' + that.ignoreDomainLinkCssClass + ' ' +
                    'fuze-for-browser-extension-manage-ignored-domains-menu-list__link--with-icon\'>' +
                    '<span class=\'fuze-for-browser-extension-popup-menu-list__left-icon--domain\'></span>' +
                    '<span class=\'fuze-for-browser-extension-popup-menu-list__link-text ' + that.ignoreDomainTextCssClass + '\'>' +
                    that.domains[i] + '' + '</span></a><span ' + that.domainsToremoveAttribute + '=\'' + that.domains[i] + '\' ' +
                    'class=\'fuze-for-browser-extension-popup-menu-list__close-button ' + that.removeIgnoredDomainsButtonCssClass +
                    '\'>&times;</span></li>';
        }
        this.$visualIgnoredDomainsList.html(visualIgnoredDomainsList);
        this.tooltipManagerForLink = new this.settings.TooltipManager({
            $placeToInject: that.$manageIgnoredDomainsMenu,
            tooltipClass: 'fuze-for-browser-extension-manage-ignored-domains-menu',
        });
        this.tooltipManagerForIgnoreThisDomain = new this.settings.TooltipManager({
            $placeToInject: that.$currentDomainToIgnore,
            tooltipClass: 'fuze-for-browser-extension-manage-this-domain',
        });
        this.tooltipManagerForCloseButton = new this.settings.TooltipManager({
            $placeToInject: that.$manageIgnoredDomainsMenu,
            tooltipClass: 'fuze-for-browser-extension-remove-ignored-domains-menu',
        });
        this.tooltipManagerForLink.initialize({
            $elementsToAction: $('.' + that.ignoreDomainTextCssClass),
            setTooltipText: () => {
                const thisIgnoreDomain = $(this).text();
                return that.settings.localizationLanguageManager.getTranslate('FUZELOC_disabledDomains_tooltip_goTo') + thisIgnoreDomain;
            },
        });
        this.tooltipManagerForIgnoreThisDomain.initialize({
            $elementsToAction: that.$manageIgnoredDomainsMenu,
            setTooltipText: () => {
                const thisIgnoreDomain = that.$manageIgnoredDomainsMenu.val();
                return 'Ignore ' + thisIgnoreDomain;
            },
        });
        const $removeIgnoredDomainsButtonCss = $('.' + that.removeIgnoredDomainsButtonCssClass);
        this.tooltipManagerForCloseButton.initialize({
            $elementsToAction: $removeIgnoredDomainsButtonCss,
            setTooltipText: () => {
                return that.settings.localizationLanguageManager.getTranslate('FUZELOC_disabledDomains_tooltip_removeFromList');
            },
        });
        $('.' + that.ignoreDomainLinkCssClass).on('click', function () {
            const openingIngoreDomain = $(this).text();
            that.settings.openLinkInNewTab(openingIngoreDomain);
        });
        $removeIgnoredDomainsButtonCss.on('click', function () {
            const showMessageAboutRemovingElementIntoList = true;
            const domainToRemove = $(this).attr(that.domainsToremoveAttribute);
            that.removeDomainFromList(domainToRemove, showMessageAboutRemovingElementIntoList);
            that.tooltipManagerForCloseButton.hide();
        });
    }
    saveIgnoredDomainsList(domains) {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.extensionSettings.setUserDomains(domains);
            this.logging.showInfoLog(`New ignored domains list: ${(yield this.extensionSettings.getUserDomains()) || ''}`);
        });
    }
}
exports.PopupIgnoredDomains = PopupIgnoredDomains;

},{"../api":61,"../constants/domains-to-ignore":71,"../logging/logging":108,"../repository/extensionSettings":136}],130:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegexpManager = void 0;
// ---------------------------------------------------
// functions to generate the phone number matching regex
// ---------------------------------------------------
class RegexpManager {
    constructor() {
    }
    generateRegex(minDigits, maxDigits) {
        const regex = `(\\+[\\d][\\d]?[\\d]?)?(${this.regexPhoneDigit(maxDigits, minDigits)})`;
        return new RegExp(`(${regex})`);
    }
    regexPhoneDigit(num, optionalAfter) {
        let regex = '';
        const separator = ' {0,2}[\\(\\)\\-\\._\\t]? {0,2}';
        for (let i = 0; i < num; i++) {
            regex += `${separator}[\\d]`;
            if (optionalAfter > 0 && i > optionalAfter) {
                regex += '?';
            }
        }
        return regex;
    }
}
exports.RegexpManager = RegexpManager;

},{}],131:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.RegularExpressions = void 0;
class RegularExpressions {
    constructor() {
        this.email = new RegExp('^[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,6}|.*<[A-Z0-9a-z._%+-]+@[A-Za-z0-9.-]+\\.[A-Za-z]{2,6}>\\s*$');
        // all of the regular expressions consider the right quantity of days in each month:
        // - should be 29 days in February of the given year,
        // - should be 31 days or 30 days in others months
        // the first expression detect the following formats: YYYY/MM/DD, YYYY-MM-DD, YYYY.MM.DD
        // the first expression detect the following formats: MM/DD/YYYY, MM-DD-YYYY, MM.DD.YYYY
        // the third expression detect the following formats: DD/MM/YYYY, DD-MM-YYYY, DD.MM.YYYY
        this.dateRegexList = [
            /((((19|2\d)\d{2})(\/|-|\.)(0[13578]|1[02])\5(0[1-9]|[12]\d|3[01]))|(((19|2\d)\d{2})(\/|-|\.)(0[13456789]|1[012])\11(0[1-9]|[12]\d|30))|(((19|2\d)\d{2})(\/|-|\.)02\17(0[1-9]|1\d|2[0-8]))|(((19|2\d)(0[48]|[2468][048]|[13579][26])|((16|[2468][048]|[3579][26])00))(\/|-|\.)02(\25)29))/,
            /(((0[13578]|1[02])(\/|-|\.)(0[1-9]|[12]\d|3[01])\4((19|[2]\d)\d{2}))|((0[13456789]|1[012])(\/|-|\.)(0[1-9]|[12]\d|30)\10((19|[2]\d)\d{2}))|(02(\/|-|\.)(0[1-9]|1\d|2[0-8])\15((19|[2]\d)\d{2}))|(02(\/|-|\.)29\20((19|2\d)(0[48]|[2468][048]|[13579][26])|((16|[2468][048]|[3579][26])00))))/,
            /(((0[1-9]|[12]\d|3[01])(\/|-|\.)(0[13578]|1[02])\4((19|[2]\d)\d{2}))|((0[1-9]|[12]\d|30)(\/|-|\.)(0[13456789]|1[012])\10((19|[2]\d)\d{2}))|((0[1-9]|1\d|2[0-8])(\/|-|\.)02\16((19|[2]\d)\d{2}))|(29(\/|-|\.)02\20((19|2\d)(0[48]|[2468][048]|[13579][26])|((16|[2468][048]|[3579][26])00))))/,
        ];
    }
}
exports.RegularExpressions = RegularExpressions;

},{}],132:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.CallerIdMasking = void 0;
const promisifier_1 = require("../helpers/promisifier");
class CallerIdMasking {
    constructor(settings) {
        this.constants = settings.constants;
        this.api = settings.api;
        this.extensionSettings = new promisifier_1.ExtensionSettingsPromisifier(settings.extensionSettings);
        this.environment = settings.environment;
        this.config = settings.config;
        this.googleLibphonenumber = settings.googleLibphonenumber;
    }
    getC2CMaskApiEndpoint() {
        return __awaiter(this, void 0, void 0, function* () {
            const currentEnvironment = yield this.environment.get();
            return this.config.c2cMaskingApiEndpoint[currentEnvironment];
        });
    }
    ;
    getCustomerMaskDIDs() {
        return __awaiter(this, void 0, void 0, function* () {
            const wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
            const organization = yield this.extensionSettings.getUserOrganization();
            const c2cMaskApiEndpoint = yield this.getC2CMaskApiEndpoint();
            let extensions;
            try {
                const headers = { Authorization: `Bearer ${wardenToken}` };
                const url = `${c2cMaskApiEndpoint}/customers/${organization}`;
                const method = 'get';
                extensions = yield this.api.sendRequest({
                    headers,
                    method,
                    url,
                });
            }
            catch (e) {
                throw e;
            }
            return extensions;
        });
    }
    saveCustomerMaskDIDs(extensions) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.extensionSettings.setCustomerMaskExtensions(extensions);
        });
    }
    loadAndSaveCallerIdMaskDIDs() {
        return __awaiter(this, void 0, void 0, function* () {
            const maskDIDs = yield this.getCustomerMaskDIDs();
            return this.saveCustomerMaskDIDs(maskDIDs);
        });
    }
    findCallerIDMaskForUSNumber(outboundCallerId, callerIdMaskExtensions) {
        const USPhoneNumberPattern = /\+1(\d\d\d)/;
        const parsedOutboundCallerId = this.googleLibphonenumber.PhoneNumberUtil.getInstance().parse(outboundCallerId, "ZZ");
        const outboundCallerId_E164 = this.googleLibphonenumber.PhoneNumberUtil.getInstance().format(parsedOutboundCallerId, this.googleLibphonenumber.PhoneNumberFormat.E164);
        const match3DigitsAfterPlusOne = outboundCallerId_E164.match(USPhoneNumberPattern);
        let areaCodeClidMasks;
        if (match3DigitsAfterPlusOne) {
            const areaCode = match3DigitsAfterPlusOne[1];
            if (callerIdMaskExtensions && callerIdMaskExtensions.areaCodes.length > 0) {
                const areaCodeEntries = callerIdMaskExtensions.areaCodes.filter((entry) => { return entry.areaCode.toString() === areaCode; });
                areaCodeClidMasks = areaCodeEntries.map(areaCode => areaCode.phoneNumber);
            }
        }
        return areaCodeClidMasks;
    }
    findCallerIdMasksForCountryCode(countryCode, countryCodesCallerIds) {
        const foundCountryCodeEntries = countryCodesCallerIds.filter((entry) => { return entry.countryCode.toString() === countryCode; });
        const countryCodeClIds = foundCountryCodeEntries.map(entry => entry.phoneNumber);
        return countryCodeClIds;
    }
    findCallerIdMaskForNonUSNumber(outboundCallerId, callerIdMaskExtensions) {
        let callerIds;
        const emea2regex = /\+(\d\d)/;
        const emea3regex = /\+(\d\d\d)/;
        const emea2digit = outboundCallerId.match(emea2regex);
        const emea3digit = outboundCallerId.match(emea3regex);
        callerIds = this.findCallerIdMasksForCountryCode(emea2digit[1], callerIdMaskExtensions ? callerIdMaskExtensions.countryCodes : []);
        if (!callerIds || callerIds.length === 0) {
            callerIds = this.findCallerIdMasksForCountryCode(emea3digit[1], callerIdMaskExtensions ? callerIdMaskExtensions.countryCodes : []);
        }
        return callerIds;
    }
    parseCallerIdIntoE164(callerId) {
        let parsedCallerId;
        if (callerId != null) {
            let phoneNumber = this.googleLibphonenumber.PhoneNumberUtil.getInstance().parse(callerId, "ZZ");
            parsedCallerId = this.googleLibphonenumber.PhoneNumberUtil.getInstance().format(phoneNumber, this.googleLibphonenumber.PhoneNumberFormat.E164);
        }
        return parsedCallerId;
    }
    testOutboundClidAndSelectClidsFromList(outboundCallerId, customerCallerIdMasks) {
        const USRegex = /\+1/;
        let callerIds;
        if (USRegex.test(outboundCallerId)) {
            callerIds = this.findCallerIDMaskForUSNumber(outboundCallerId, customerCallerIdMasks);
        }
        else {
            callerIds = this.findCallerIdMaskForNonUSNumber(outboundCallerId, customerCallerIdMasks);
        }
        return callerIds;
    }
    randomlySelectClidMask(callerIdMasks) {
        return __awaiter(this, void 0, void 0, function* () {
            let clIdMask;
            let previousClidMask;
            if (callerIdMasks.length === 1) {
                clIdMask = callerIdMasks[0];
            }
            else {
                do {
                    const randomIndex = Math.floor(Math.random() * (callerIdMasks.length - 0)) + 0;
                    clIdMask = callerIdMasks[randomIndex];
                    previousClidMask = yield this.extensionSettings.getPreviousClidMask();
                } while (clIdMask === previousClidMask);
            }
            this.extensionSettings.setPreviousClidMask(clIdMask);
            return clIdMask;
        });
    }
    getCallerIdMaskForOutboundCallerId(outboundCallerId) {
        return __awaiter(this, void 0, void 0, function* () {
            const customerCallerIdMasks = yield this.extensionSettings.getCustomerMaskExtensions();
            const callerIdMasks = this.testOutboundClidAndSelectClidsFromList(outboundCallerId, customerCallerIdMasks);
            let callerIdMask;
            if (this.constants.pickCallerIdMaskRandomly && (callerIdMasks && callerIdMasks.length > 0)) {
                callerIdMask = yield this.randomlySelectClidMask(callerIdMasks);
            }
            else if (!this.constants.pickCallerIdMaskRandomly && (callerIdMasks && callerIdMasks.length > 0)) {
                callerIdMask = callerIdMasks[0];
            }
            return this.parseCallerIdIntoE164(callerIdMask);
        });
    }
}
exports.CallerIdMasking = CallerIdMasking;

},{"../helpers/promisifier":98}],133:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Contactive = void 0;
const error_helper_1 = require("../helpers/error-helper");
const extensionSettings_1 = require("./extensionSettings");
const preferredDevice_1 = require("./preferredDevice");
const environment_1 = require("./environment");
const logging_1 = require("../logging/logging");
class Contactive {
    constructor(apiLogic) {
        this.apiLogic = apiLogic;
        this.logging = logging_1.Logging.getInstance();
        this.errorHelper = new error_helper_1.ErrorHelper();
        this.extensionSettings = new extensionSettings_1.ExtensionSettings(apiLogic);
        this.environment = new environment_1.Environment(this.extensionSettings);
        this.preferredDevice = new preferredDevice_1.PreferredDevice(apiLogic, this.extensionSettings);
    }
    getRequestOptions(config) {
        if (!config.wardenToken) {
            this.logging.showInfoLog('User isn\'t logged in', null);
            return null;
        }
        return {
            headers: {
                'Authorization': `Bearer ${config.wardenToken}`,
                'Cache-control': 'no-cache',
            },
            url: `${config.contactiveApiEndpoint}/contactive/v1.0/users/me`,
        };
    }
    getUserTenant(wardenToken) {
        return __awaiter(this, void 0, void 0, function* () {
            const currentEnvironment = yield this.environment.get();
            const wardenUrl = this.apiLogic.config.wardenValidateServiceUrl[currentEnvironment] + 'current';
            const response = yield this.apiLogic.sendRequest({
                headers: {
                    'Authorization': `Bearer ${wardenToken}`,
                    'Cache-control': 'no-cache',
                },
                url: wardenUrl,
            });
            const { tenantKey } = response.data.entity;
            this.extensionSettings.setUserTenant(tenantKey);
            return;
        });
    }
    getUserInfo() {
        return (new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            const config = yield this.getContactiveConfig();
            const requestOptions = this.getRequestOptions(config);
            if (!requestOptions) {
                return resolve();
            }
            this.apiLogic.sendRequest(requestOptions)
                .then((response) => {
                // response.data.devices can be a several hundred item array which is not used
                // remove it here to save space in logging
                if (!response.data) {
                    this.logging.showErrorLog('(getUserInfo)Failed getting user data from Contactive', response);
                    throw response;
                }
                this.logging.showInfoLog('getUserInfo response', response);
                const userInfo = response.data.user || null;
                if (userInfo.email) {
                    this.extensionSettings.setUserEmail(userInfo.email);
                }
                this.getUserTenant(config.wardenToken);
                return resolve(userInfo);
            })
                .catch((error) => {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    const catcherMessage = 'Repository: contactiveRepository: getUserInfo: sendRequest';
                    error = this.errorHelper.updateCatcherInTheError(error, catcherMessage);
                    this.logging.showErrorLog('Failed getting user data from Contactive', error);
                }
                return reject(error);
            });
        })));
    }
    getUserCountryFromContactiveAPI() {
        return (new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            const config = yield this.getContactiveConfig();
            const requestOptions = this.getRequestOptions(config);
            if (!requestOptions) {
                return resolve();
            }
            this.apiLogic.sendRequest(requestOptions)
                .then((response) => {
                if (!response.data) {
                    this.logging.showErrorLog('(getUserInfo)Failed getting user data from Contactive', response);
                    throw response;
                }
                this.logging.showInfoLog('getUserInfo response', response);
                const userInfo = response.data.user || null;
                return resolve(userInfo.currentCountry);
            })
                .catch((error) => {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    const catcherMessage = 'Repository: contactiveRepository: getUserInfo: sendRequest';
                    error = this.errorHelper.updateCatcherInTheError(error, catcherMessage);
                    this.logging.showErrorLog('Failed getting user data from Contactive', error);
                }
                return reject(error);
            });
        })));
    }
    getUserCountryCode() {
        return (new Promise((resolve, reject) => {
            return this.preferredDevice.getDevices()
                .then((devices) => {
                const countryCode = devices[0].lines[0].locale.toUpperCase();
                this.logging.showInfoLog('User locale getting from Synapse is ', countryCode);
                return resolve(countryCode);
            })
                .catch((error) => {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    const catcherMessage = 'Repository: contactiveRepository: getUserCountryCode';
                    error = this.errorHelper.updateCatcherInTheError(error, catcherMessage);
                    this.logging.showErrorLog('Failed to get user country code from Synapse', error);
                }
                return reject(error);
            });
        }));
    }
    getContactiveDirectoryInfoByEmail(emails) {
        return __awaiter(this, void 0, void 0, function* () {
            const config = yield this.getContactiveConfig();
            return this.apiLogic.sendRequest({
                headers: {
                    'Authorization': `Bearer ${config.wardenToken}`,
                },
                url: `${config.contactiveApiEndpoint}/contactive/v1.0/directory/contacts/emails/${emails.join()}/merged`,
            })
                .then((response) => {
                return response.data;
            })
                .catch((error) => {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    const catcherMessage = 'Repository: contactiveRepository: getContactiveDirectoryInfoByEmail: sendRequest';
                    error = this.errorHelper.updateCatcherInTheError(error, catcherMessage);
                    this.logging.showErrorLog('Failed getting user data by email from Contactive Directory', error);
                }
                return Promise.reject(error);
            });
        });
    }
    getWardenUrl() {
        return __awaiter(this, void 0, void 0, function* () {
            const currentEnvironment = yield this.environment.get();
            return this.apiLogic.config.wardenValidateServiceUrl[currentEnvironment] + 'current';
        });
    }
    getContactiveConfig() {
        return __awaiter(this, void 0, void 0, function* () {
            const contactiveApiEndpoint = yield this.getContactiveApiEndpoint();
            const wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
            return {
                contactiveApiEndpoint,
                wardenToken,
            };
        });
    }
    getContactiveApiEndpoint() {
        return __awaiter(this, void 0, void 0, function* () {
            const currentEnvironment = yield this.environment.get();
            return this.apiLogic.config.contactiveApiEndpoint[currentEnvironment];
        });
    }
}
exports.Contactive = Contactive;

},{"../helpers/error-helper":92,"../logging/logging":108,"./environment":135,"./extensionSettings":136,"./preferredDevice":139}],134:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Credentials = void 0;
class Credentials {
    constructor(applicationToken, wardenRestServiceUrl, apiLogic) {
        this.applicationToken = applicationToken;
        this.wardenRestServiceUrl = wardenRestServiceUrl;
        this.apiLogic = apiLogic;
        this.getUserOptions = (userNameOrEmail, onSuccessCallback, onFailureCallback) => {
            this.apiLogic.sendRequest({
                headers: {
                    Authorization: this.applicationToken,
                },
                url: `${this.wardenRestServiceUrl}/users/${userNameOrEmail}/auth/options`,
            })
                .then((userOptions) => {
                onSuccessCallback(userOptions);
            })
                .catch((error) => {
                onFailureCallback(error);
            });
        };
        this.getWardenToken = (userNameOrEmail, userPassword, userOptionId, onSuccessCallback, onFailureCallback) => {
            this.apiLogic.sendRequest({
                data: JSON.stringify({ userKey: userNameOrEmail, password: userPassword }),
                headers: {
                    'Authorization': this.applicationToken,
                    'Content-Type': 'application/json',
                },
                method: 'post',
                url: `${this.wardenRestServiceUrl}/users/${userNameOrEmail}/auth/options/${userOptionId}`,
            })
                .then((userOptions) => {
                onSuccessCallback(userOptions);
            })
                .catch((error) => {
                onFailureCallback(error);
            });
        };
    }
}
exports.Credentials = Credentials;

},{}],135:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Environment = void 0;
class Environment {
    constructor(extensionSettings) {
        this.extensionSettings = extensionSettings;
        this.environmentKey = 'tpn_currentEnvironment';
    }
    initialize(initialEnvironment) {
        return __awaiter(this, void 0, void 0, function* () {
            let currentEnvironment = yield this.get();
            if (currentEnvironment) {
                return currentEnvironment;
            }
            yield this.set(initialEnvironment);
            return initialEnvironment;
        });
    }
    get(isMeetingURL = false) {
        return __awaiter(this, void 0, void 0, function* () {
            if (isMeetingURL && (yield this.extensionSettings.getCitadelEnvironment())) {
                return this.extensionSettings.getCitadelEnvironment();
            }
            return this.extensionSettings.getPolyfill(this.environmentKey);
        });
    }
    set(currentEnvironment) {
        const receivedData = { [this.environmentKey]: currentEnvironment };
        return this.extensionSettings.setPolyfill(receivedData);
    }
}
exports.Environment = Environment;

},{}],136:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ExtensionSettings = void 0;
const previousCustomSettings_1 = require("./previousCustomSettings");
class ExtensionSettings {
    constructor(apiLogic) {
        this.apiLogic = apiLogic;
        // ===============================
        this.getUserOrganization = () => {
            return this.getPolyfill(this.keys.USER_ORGANIZATION);
        };
        this.setCustomerMaskExtensions = (value) => {
            return this.setPolyfill(this.keys.CUSTOMER_MASK_EXTENSIONS, value);
        };
        this.getCustomerMaskExtensions = () => {
            return this.getPolyfill(this.keys.CUSTOMER_MASK_EXTENSIONS);
        };
        this.setPreviousClidMask = (value) => {
            return this.setPolyfill(this.keys.PREVIOUS_CLID_MASK, value);
        };
        this.getPreviousClidMask = () => {
            return this.getPolyfill(this.keys.PREVIOUS_CLID_MASK);
        };
        this.keys = apiLogic.keys;
        this.previousCustomSettings = new previousCustomSettings_1.PreviousCustomSettings(this);
        this.savingDataKeysArray = [
            this.keys.USER_NAME, this.keys.FULL_NAME, this.keys.CLICK_TO_CALL_ENABLING_STATE, this.keys.STREAM_LOGGING_STATE,
            this.keys.MEETINGS_ENABLING_STATE, this.keys.JOIN_MEETINGS_OPTION, this.keys.FIRST_TIME_JOIN_MEETING,
            this.keys.FUZE_CONTACTS_STATE, this.keys.HOME_COUNTRY, this.keys.FUZE_TEAMS_STATE
        ];
        // after any of savingDataKeysArrayForUserSettings keys got changed, previous custom settings should be updated
        this.savingDataKeysArrayForUserSettings = [
            this.keys.CLICK_TO_CALL_ENABLING_STATE, this.keys.MEETINGS_ENABLING_STATE, this.keys.STREAM_LOGGING_STATE,
            this.keys.JOIN_MEETINGS_OPTION, this.keys.FIRST_TIME_JOIN_MEETING, this.keys.FUZE_CONTACTS_STATE, this.keys.FUZE_TEAMS_STATE
        ];
    }
    initializeJoinMeetingsOption() {
        return __awaiter(this, void 0, void 0, function* () {
            const userOS = this.apiLogic.getOS();
            const apiConstants = this.apiLogic.constants;
            const doesUserOSSupportsFuzeDesktop = userOS === apiConstants.os.WINDOWS || userOS === apiConstants.os.MAC;
            if (doesUserOSSupportsFuzeDesktop) {
                yield this.setJoinMeetingsOption(apiConstants.joinMeetingsOptions.DESKTOP);
            }
            else {
                yield this.setJoinMeetingsOption(apiConstants.joinMeetingsOptions.WEB_ONLY);
            }
            return doesUserOSSupportsFuzeDesktop;
        });
    }
    ;
    removeDataFromLocalDatabase(keys) {
        this.apiLogic.removeDataFromDB(keys);
    }
    removeObsoleteDataFromLocalDatabase() {
        return __awaiter(this, void 0, void 0, function* () {
            let removingKeysArray = [
                this.keys.WARDEN_TOKEN, this.keys.FUZE_TOKEN, this.keys.PASSWORD,
                this.keys.CLICK_TO_CALL_DISABLED_BY_CONFLICTS, this.keys.IS_EXTENSION_DISABLED, this.keys.CITADEL_OPTIONS,
                this.keys.ENTITLEMENT_FOR_MEETING, this.keys.ENTITLEMENT_FOR_TEAMS, this.keys.ENTITLEMENT_FOR_CLICK_TO_CALL,
                this.keys.AVAILABLE_DEVICES, this.keys.PREFERRED_DEVICE, this.keys.PREFERRED_DEVICE_ADDRESS,
                this.keys.USER_EMAIL, this.keys.IS_ACCOUNT_CONFIGURATION_ERROR, this.keys.CITADEL_ENVIRONMENT
            ];
            const removeObsoleteData = () => {
                removingKeysArray = removingKeysArray.concat(this.savingDataKeysArray);
                this.removeDataFromLocalDatabase(removingKeysArray);
            };
            yield this.previousCustomSettings.savePreviousCustomSettings(this.savingDataKeysArray);
            removeObsoleteData();
        });
    }
    getClickToCallState() {
        return this.getPolyfill(this.keys.CLICK_TO_CALL_ENABLING_STATE);
    }
    ;
    setClickToCallState(extensionState) {
        return this.setPolyfill(this.keys.CLICK_TO_CALL_ENABLING_STATE, extensionState);
    }
    getAvailableDevicesFromStorage() {
        return this.getPolyfill(this.keys.AVAILABLE_DEVICES);
    }
    ;
    setAvailableDevicesToStorage(data) {
        return this.setPolyfill(this.keys.AVAILABLE_DEVICES, data);
    }
    ;
    getConsoleLoggingState() {
        return this.getPolyfill(this.keys.CONSOLE_LOGGING_STATE);
    }
    ;
    setConsoleLoggingState(loggingState) {
        return this.setPolyfill(this.keys.CONSOLE_LOGGING_STATE, loggingState);
    }
    ;
    getStreamLoggingState() {
        return this.getPolyfill(this.keys.STREAM_LOGGING_STATE);
    }
    ;
    setStreamLoggingState(loggingState) {
        return this.setPolyfill(this.keys.STREAM_LOGGING_STATE, loggingState);
    }
    ;
    getTeamsState() {
        return this.getPolyfill(this.keys.FUZE_TEAMS_STATE);
    }
    ;
    setTeamsState(teamsState) {
        return this.setPolyfill(this.keys.FUZE_TEAMS_STATE, teamsState);
    }
    ;
    getFuzeContactsState() {
        return this.getPolyfill(this.keys.FUZE_CONTACTS_STATE);
    }
    ;
    setFuzeContactsState(state) {
        return this.setPolyfill(this.keys.FUZE_CONTACTS_STATE, state);
    }
    ;
    getMeetingsState() {
        return this.getPolyfill(this.keys.MEETINGS_ENABLING_STATE);
    }
    ;
    setMeetingsState(extensionState) {
        return this.setPolyfill(this.keys.MEETINGS_ENABLING_STATE, extensionState);
    }
    ;
    getJoinMeetingsOption() {
        return this.getPolyfill(this.keys.JOIN_MEETINGS_OPTION);
    }
    setJoinMeetingsOption(option) {
        return this.setPolyfill(this.keys.JOIN_MEETINGS_OPTION, option);
    }
    getFirstTimeJoinMeetingState() {
        return this.getPolyfill(this.keys.FIRST_TIME_JOIN_MEETING);
    }
    setFirstTimeJoinMeetingState(joinState) {
        return this.setPolyfill(this.keys.FIRST_TIME_JOIN_MEETING, joinState);
    }
    getPreviousClientCredentials(userName) {
        return __awaiter(this, void 0, void 0, function* () {
            let previousLoginData = yield this.previousCustomSettings.getPreviousCustomSetting();
            if (previousLoginData && (previousLoginData[this.keys.USER_NAME] === userName)) {
                return this.previousCustomSettings.applyPreviousCustomSettings();
            }
            else {
                yield this.setUserNameToLocalDatabase(userName);
            }
        });
    }
    ;
    getWardenTokenFromLocalDatabase() {
        return this.getPolyfill(this.keys.WARDEN_TOKEN);
    }
    ;
    setWardenTokenToLocalDatabase(wardenToken) {
        return this.setPolyfill(this.keys.WARDEN_TOKEN, wardenToken);
    }
    ;
    getFullNameFromLocalDatabase() {
        return this.getPolyfill(this.keys.FULL_NAME);
    }
    ;
    setFullNameToLocalDatabase(fullName) {
        return this.setPolyfill(this.keys.FULL_NAME, fullName);
    }
    ;
    getUserNameFromLocalDatabase() {
        return this.getPolyfill(this.keys.USER_NAME);
    }
    ;
    setUserNameToLocalDatabase(userName) {
        return this.setPolyfill(this.keys.USER_NAME, userName);
    }
    ;
    getUserPasswordFromLocalDatabase() {
        return this.getPolyfill(this.keys.PASSWORD);
    }
    ;
    setClickToCallDisabledByConflicts(data) {
        return this.setPolyfill(this.keys.CLICK_TO_CALL_DISABLED_BY_CONFLICTS, data);
    }
    ;
    getIsExtensionDisabledStatus() {
        return this.getPolyfill(this.keys.IS_EXTENSION_DISABLED);
    }
    ;
    setIsExtensionDisabledStatus(data) {
        return this.setPolyfill(this.keys.IS_EXTENSION_DISABLED, data);
    }
    ;
    // ===============================
    getPreferredDeviceFromStorage() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.PREFERRED_DEVICE);
        });
    }
    ;
    setPreferredDeviceToStorage(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.PREFERRED_DEVICE, data);
        });
    }
    ;
    getPreferredDeviceAddress() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.PREFERRED_DEVICE_ADDRESS);
        });
    }
    ;
    savePreferredDeviceAddress(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.PREFERRED_DEVICE_ADDRESS, data);
        });
    }
    ;
    getAutoAnswerFromStorage() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.AUTO_ANSWER);
        });
    }
    ;
    getHomeCountryFromStorage() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.HOME_COUNTRY);
        });
    }
    ;
    setHomeCountryToStorage(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.HOME_COUNTRY, data);
        });
    }
    ;
    getTeamsFromStorage() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.FUZE_TEAMS_STATE);
        });
    }
    ;
    setTeamsToStorage(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.FUZE_TEAMS_STATE, data);
        });
    }
    ;
    setContactiveUserCountryCodeToStorage(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.CONTACTIVE_USER_COUNTRY_CODE, data);
        });
    }
    ;
    getContactiveUserCountryCodeFromStorage() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.CONTACTIVE_USER_COUNTRY_CODE);
        });
    }
    ;
    setIsHomeCountryUpdatedSuccessful(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.HOME_COUNTRY_UPDATED_STATUS, data);
        });
    }
    ;
    getIsHomeCountryUpdatedSuccessful() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.HOME_COUNTRY_UPDATED_STATUS);
        });
    }
    ;
    setUserTenant(organizationKey) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.USER_TENANT, organizationKey);
        });
    }
    getUserTenant() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.USER_TENANT);
        });
    }
    ;
    setUserEmail(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.USER_EMAIL, data);
        });
    }
    ;
    getUserEmail() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.USER_EMAIL);
        });
    }
    ;
    setDefaultUsedLink(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.DEFAULT_USED_LINK, data);
        });
    }
    ;
    getDefaultUsedLink() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.DEFAULT_USED_LINK);
        });
    }
    ;
    setLocalizationLanguage(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.LOCALIZATION_LANGUAGE, data);
        });
    }
    ;
    getLocalizationLanguage() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.LOCALIZATION_LANGUAGE);
        });
    }
    ;
    getDeviceHintFromStorage() {
        return __awaiter(this, void 0, void 0, function* () {
            return this.getPolyfill(this.keys.DEVICE_HINT);
        });
    }
    ;
    setDeviceHintToStorage(data) {
        return __awaiter(this, void 0, void 0, function* () {
            return this.setPolyfill(this.keys.DEVICE_HINT, data);
        });
    }
    ;
    // ===============================
    // citadel datum
    // ===============================
    getCitadelOptionsFromStorage() {
        return this.getPolyfill(this.keys.CITADEL_OPTIONS);
    }
    ;
    setCitadelOptionsToStorage(data) {
        return this.setPolyfill(this.keys.CITADEL_OPTIONS, data);
    }
    ;
    getCitadelEnvironment() {
        return this.getPolyfill(this.keys.CITADEL_ENVIRONMENT);
    }
    ;
    setCitadelEnvironment(data) {
        return this.setPolyfill(this.keys.CITADEL_ENVIRONMENT, data);
    }
    ;
    getEntitlementForMeetingFromStorage() {
        return this.getPolyfill(this.keys.ENTITLEMENT_FOR_MEETING);
    }
    ;
    setEntitlementForMeetingToStorage(data) {
        return this.setPolyfill(this.keys.ENTITLEMENT_FOR_MEETING, data);
    }
    ;
    getEntitlementForTeamsFromStorage() {
        return this.getPolyfill(this.keys.ENTITLEMENT_FOR_TEAMS);
    }
    ;
    setEntitlementForTeamsToStorage(data) {
        return this.setPolyfill(this.keys.ENTITLEMENT_FOR_TEAMS, data);
    }
    ;
    getEntitlementForClickToCallFromStorage() {
        return this.getPolyfill(this.keys.ENTITLEMENT_FOR_CLICK_TO_CALL);
    }
    ;
    setEntitlementForClickToCallToStorage(data) {
        return this.setPolyfill(this.keys.ENTITLEMENT_FOR_CLICK_TO_CALL, data);
    }
    ;
    getIsErrorMessageWasShowedOnceOnThePageFromStorage() {
        return this.getPolyfill(this.keys.WAS_ERROR_MESSAGE_SHOWED_ONCE_ON_THE_PAGE);
    }
    ;
    setIsErrorMessageWasShowedOnceOnThePageToStorage(data) {
        return this.setPolyfill(this.keys.WAS_ERROR_MESSAGE_SHOWED_ONCE_ON_THE_PAGE, data);
    }
    ;
    getIsAccountConfigurationError() {
        return this.getPolyfill(this.keys.IS_ACCOUNT_CONFIGURATION_ERROR);
    }
    ;
    getIsUserLoggedIn() {
        return this.getPolyfill(this.keys.IS_USER_LOGGED_IN);
    }
    ;
    setIsUserLoggedIn(isUserLoggedIn) {
        return this.setPolyfill(this.keys.IS_USER_LOGGED_IN, isUserLoggedIn);
    }
    ;
    // ===============================
    getTheFirstInstallationStatus() {
        return this.getPolyfill(this.keys.STATUS_OF_THE_FIRST_INSTALLATION);
    }
    ;
    setTheFirstInstallationStatus(value) {
        return this.setPolyfill(this.keys.STATUS_OF_THE_FIRST_INSTALLATION, value);
    }
    ;
    getIsNotificationShowedOnce() {
        return this.getPolyfill(this.keys.NOTIFICATION_SHOWED_ONCE);
    }
    ;
    setIsNotificationShowedOnce(value) {
        return this.setPolyfill(this.keys.NOTIFICATION_SHOWED_ONCE, value);
    }
    ;
    getDoesExpectToCreateAMeeting() {
        return this.getPolyfill(this.keys.DOES_EXPECT_TO_CREATE_A_MEETING);
    }
    ;
    setDoesExpectToCreateAMeeting(value) {
        return this.setPolyfill(this.keys.DOES_EXPECT_TO_CREATE_A_MEETING, value);
    }
    ;
    getLogs() {
        return this.getPolyfill(this.keys.EXTENSION_LOGS);
    }
    ;
    setLogs(data) {
        return this.setPolyfill(this.keys.EXTENSION_LOGS, data);
    }
    ;
    // ===============================
    getUserDomains() {
        return this.getPolyfill(this.keys.DOMAINS);
    }
    ;
    setUserDomains(domainsList) {
        return this.setPolyfill(this.keys.DOMAINS, domainsList);
    }
    ;
    // ===============================
    getEntitlementForCallerIdMaskingFromStorage() {
        return this.getPolyfill(this.keys.ENTITLEMENT_FOR_CALLER_ID_MASKING);
    }
    ;
    setEntitlementForCallerIdMaskingToStorage(entitlement) {
        return this.setPolyfill(this.keys.ENTITLEMENT_FOR_CALLER_ID_MASKING, entitlement);
    }
    getCallerIdMaskingEnablingState() {
        return this.getPolyfill(this.keys.CALLER_ID_MASKING_ENABLING_STATE);
    }
    setCallerIdMaskingEnablingState(enablingState) {
        return this.setPolyfill(this.keys.CALLER_ID_MASKING_ENABLING_STATE, enablingState);
    }
    // ===============================
    setPatchDatIntoDB(object) {
        return this.apiLogic.setPatchDatIntoDB(object);
    }
    ;
    getPolyfill(key) {
        return this.apiLogic.getDataFromDBPolyfill(key);
    }
    setPolyfill(...args) {
        return __awaiter(this, void 0, void 0, function* () {
            // if arguments length is 2 and the first argument is string, the set method is called with (key, value)
            if (args.length === 2 && typeof args[0] === 'string') {
                let key = args[0];
                let value = args[1];
                yield this.apiLogic.setDataIntoDBPolyfill({ [key]: value });
                if (this.savingDataKeysArrayForUserSettings.includes(key)) {
                    return this.previousCustomSettings.savePreviousCustomSettings(this.savingDataKeysArray);
                }
            }
            else {
                // if arguments length is 1, the set method is called with ({key: value})
                // await this.apiLogic.setDataIntoDBPolyfill(args[0]);
                return this.apiLogic.setDataIntoDBPolyfill(args[0]);
            }
        });
    }
    ;
}
exports.ExtensionSettings = ExtensionSettings;

},{"./previousCustomSettings":140}],137:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Meeting = void 0;
const error_helper_1 = require("../helpers/error-helper");
const logContext_1 = require("../logging/logContext");
const logRequest_1 = require("../logging/logRequest");
const environment_1 = require("./environment");
class Meeting {
    constructor(apiLogic, extensionSettings) {
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.transactionSeed = Date.now();
        this.transactionId = 0;
        this.getNextTransactionId = () => {
            this.transactionId++;
            return `C${this.transactionSeed}X${this.transactionId}X`;
        };
        this.errorHelper = new error_helper_1.ErrorHelper(apiLogic);
        this.environment = new environment_1.Environment(extensionSettings);
    }
    getHeaders(apiEndpoint) {
        return (new Promise((resolve, reject) => __awaiter(this, void 0, void 0, function* () {
            const wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
            this.provideMeetingApi(apiEndpoint, wardenToken).then(() => {
                const headers = {
                    'Authorization': `Bearer ${wardenToken}`,
                    'FZ-TransactionId': this.getNextTransactionId(),
                };
                return resolve(headers);
            }, reject);
        })));
    }
    getHeadersWithoutTokenValidation() {
        return (new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            const wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
            const headers = {
                'Authorization': `Bearer ${wardenToken}`,
                'FZ-TransactionId': this.getNextTransactionId(),
            };
            return resolve(headers);
        })));
    }
    provideMeetingApi(apiEndpoint, wardenToken) {
        return (new Promise((resolve, reject) => {
            const provideMeetingUrl = apiEndpoint + '/v1/auth/warden/sessions';
            const fzTransactionIdHeader = this.getNextTransactionId();
            if (fzTransactionIdHeader) {
                const data = { FzTransactionIdHeader: fzTransactionIdHeader };
                this.apiLogic.logging.showInfoLog('provideMeetingApi sending header', data);
            }
            this.apiLogic.sendRequest({
                headers: {
                    'Authorization': `Bearer ${wardenToken}`,
                    'Content-Type': 'application/json',
                    'FZ-TransactionId': fzTransactionIdHeader,
                },
                method: 'post',
                url: `${provideMeetingUrl}?token=${wardenToken}`,
            })
                .then((data) => {
                this.extensionSettings.setPolyfill('fuzeUserId', data.user_id);
                return resolve(data);
            })
                .catch((error) => {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    const catcherMessage = 'Repository: Meeting: provideMeetingApi: sendRequest';
                    error = this.errorHelper.updateCatcherInTheError(error, catcherMessage);
                    this.apiLogic.logging.showErrorLog('Unable to make connect FuzeMeetingApi', error);
                }
                return reject(error);
            });
        }));
    }
    sendFeedback(apiEndpoint, wardenToken, feedbackData) {
        const convertData = (data) => {
            const formData = new FormData();
            for (const key of Object.keys(feedbackData)) {
                formData.append(key, data[key]);
            }
            return formData;
        };
        return (new Promise((resolve, reject) => {
            return this.getHeadersWithoutTokenValidation().then((headers) => {
                const fzTransactionIdHeader = this.getFzTransactionIdHeader(headers);
                if (fzTransactionIdHeader) {
                    const data = { FzTransactionIdHeader: fzTransactionIdHeader };
                    this.apiLogic.logging.showInfoLog('sendFeedback sending header', data);
                }
                this.apiLogic.logging.showInfoLog('sendFeedback feedback data', feedbackData);
                const formData = convertData(feedbackData);
                return this.apiLogic.sendRequest({
                    data: formData,
                    headers,
                    method: 'post',
                    url: `${apiEndpoint}/v2/feedback/report`,
                })
                    .then((data) => {
                    this.apiLogic.logging.showInfoLog('Success sending report to Fuze Support', data);
                    return resolve(data);
                });
            })
                .catch((error) => {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    const catcherMessage = 'Repository: Meeting: sendFeedback: getHeaders';
                    error = this.errorHelper.updateCatcherInTheError(error, catcherMessage);
                    this.apiLogic.logging.showErrorLog('Unable to make connect FuzeMeetingApi', error);
                }
                return reject(error);
            });
        }));
    }
    sendLogs(logs) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const headers = yield this.getHeadersWithoutTokenValidation();
                const platform = this.apiLogic.constants.browserPlatform[this.apiLogic.getPlatform()];
                const username = yield this.getUserName();
                const logContext = new logContext_1.LogContext(this.apiLogic.getVersion(), platform, username);
                const logRequest = new logRequest_1.LogRequest(logContext, logs);
                this.apiLogic.logging.showInfoLog('sendLogs data', logRequest, true);
                headers['Content-Type'] = 'application/json';
                // Set specific headers for v2/logs
                headers['X-Fuze-Platform'] = platform;
                headers['X-Fuze-ClientType'] = 'BrowserConnector';
                headers['X-Fuze-Hint'] = yield this.getDeviceHint();
                headers['X-Fuze-BrowserVersion'] = this.apiLogic.getBrowserVersionNumber();
                const currentEnvironment = yield this.environment.get(true);
                const fuzemeetingApiEndpoint = this.apiLogic.config.fuzemeetingApiEndpoint[currentEnvironment];
                return this.apiLogic.sendRequest({
                    data: JSON.stringify(logRequest),
                    headers,
                    method: 'post',
                    skipLogStreaming: true,
                    url: `${fuzemeetingApiEndpoint}/v2/logs`,
                }).then((data) => {
                    return this.apiLogic.logging.showInfoLog('Success sending logs to Fuze Support', data, true);
                });
            }
            catch (error) {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    const catcherMessage = 'Repository: Meeting: sendLogs: getHeaders';
                    error = this.errorHelper.updateCatcherInTheError(error, catcherMessage);
                    return this.apiLogic.logging.showErrorLog('Unable to make connect FuzeMeetingApi', error);
                }
            }
        });
    }
    sendMeetingsActions(apiEndpoint, url, method, data) {
        return (new Promise((resolve, reject) => {
            return this.getHeaders(apiEndpoint).then((headers) => {
                this.apiLogic.logging.showInfoLog('sendMeetingsActions sending data', data);
                this.apiLogic.sendRequest({ data, headers, method, url: apiEndpoint + url })
                    .then((responseData) => {
                    this.apiLogic.logging.showInfoLog('provideMeetingAPI response', responseData);
                    return resolve(responseData);
                })
                    .catch((error) => {
                    if (!this.errorHelper.isExceptionHandled(error)) {
                        error = this.errorHelper.updateCatcherInTheError(error, 'Repository: sendMeetingsActions: sendRequest');
                        this.apiLogic.logging.showErrorLog('Unable to make action ' + method, error);
                    }
                    return reject(error);
                });
            })
                .catch((error) => {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    error = this.errorHelper.updateCatcherInTheError(error, 'Repository: sendMeetingsActions: getHeaders');
                    this.apiLogic.logging.showErrorLog('Unable to make action ' + method, error);
                }
                return reject(error);
            });
        }));
    }
    getMeetingInfo(apiEndpoint, url, id) {
        return (new Promise((resolve, reject) => {
            return this.getHeaders(apiEndpoint).then((headers) => {
                const fzTransactionIdHeader = this.getFzTransactionIdHeader(headers);
                if (fzTransactionIdHeader) {
                    const data = { FzTransactionIdHeader: fzTransactionIdHeader, meetingId: id };
                    this.apiLogic.logging.showInfoLog('getMeetingInfo sending data', data);
                }
                this.apiLogic.sendRequest({ headers, url: apiEndpoint + url })
                    .then((data) => {
                    this.apiLogic.logging.showInfoLog('provideMeetingApi response', data);
                    return resolve(data);
                })
                    .catch((error) => {
                    if (!this.errorHelper.isExceptionHandled(error)) {
                        error = this.errorHelper.updateCatcherInTheError(error, 'Repository: getMeetingInfo: sendRequest');
                        this.apiLogic.logging.showErrorLog('Unable to get meeting info ', error);
                    }
                    return reject(error);
                });
            })
                .catch((error) => {
                if (!this.errorHelper.isExceptionHandled(error)) {
                    error = this.errorHelper.updateCatcherInTheError(error, 'Repository: getMeetingInfo: getHeaders');
                    this.apiLogic.logging.showErrorLog('Unable to get meeting info ', error);
                }
                return reject(error);
            });
        }));
    }
    generateGuid() {
        const s4 = () => Math.floor((1 + Math.random()) * 0x10000).toString(16).substring(1);
        // Example: 5b49b4e4-e424-ae62-5c9a-2419db8d60d7
        return `${s4() + s4()}-${s4()}-${s4()}-${s4()}-${s4()}${s4()}${s4()}`;
    }
    getDeviceHint() {
        return __awaiter(this, void 0, void 0, function* () {
            let deviceHint = yield this.extensionSettings.getDeviceHintFromStorage();
            if (!deviceHint) {
                deviceHint = this.generateGuid();
                this.extensionSettings.setDeviceHintToStorage(deviceHint);
            }
            return deviceHint;
        });
    }
    getUserName() {
        return __awaiter(this, void 0, void 0, function* () {
            const username = yield this.extensionSettings.getUserNameFromLocalDatabase();
            if (!username) {
                this.apiLogic.logging.showErrorLog('User doesn\'t have username');
                return '';
            }
            return username;
        });
    }
    getFzTransactionIdHeader(headers) {
        if (headers && headers['FZ-TransactionId']) {
            return headers['FZ-TransactionId'];
        }
        return '';
    }
}
exports.Meeting = Meeting;

},{"../helpers/error-helper":92,"../logging/logContext":105,"../logging/logRequest":107,"./environment":135}],138:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Message = void 0;
const api_1 = require("../api");
class Message {
    constructor(apiLogic) {
        this.apiLogic = apiLogic || new api_1.APILogic();
    }
    addMessageListener(onMessageReceivedCallback) {
        this.apiLogic.addMessageListener(onMessageReceivedCallback);
    }
    addMessageListenerThatCalledOnce(onMessageReceivedCallback) {
        const listener = (message) => {
            onMessageReceivedCallback(message);
            this.apiLogic.removeMessageListener(listener);
        };
        this.apiLogic.addMessageListener(onMessageReceivedCallback);
    }
    removeMessageListener(onMessageReceivedCallback) {
        this.apiLogic.removeMessageListener(onMessageReceivedCallback);
    }
    sendMessageToActiveTab(options) {
        this.apiLogic.sendMessageToActiveTab(options);
    }
    sendMessageToAllExtensionParts(options) {
        this.apiLogic.sendMessageToDifferentExtensionPart(options);
        this.apiLogic.sendMessageToActiveTab(options);
    }
    sendMessageToBackground(options) {
        this.apiLogic.sendMessageToDifferentExtensionPart(options);
    }
    sendMessageToPopup(options) {
        this.apiLogic.sendMessageToDifferentExtensionPart(options);
    }
}
exports.Message = Message;

},{"../api":61}],139:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreferredDevice = void 0;
const error_helper_1 = require("../helpers/error-helper");
const environment_1 = require("./environment");
const logging_1 = require("../logging/logging");
class PreferredDevice {
    constructor(apiLogic, extensionSettings) {
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.logging = logging_1.Logging.getInstance();
        this.environment = new environment_1.Environment(extensionSettings);
        this.errorHelper = new error_helper_1.ErrorHelper();
    }
    getDevices() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
                if (wardenToken === undefined) {
                    return;
                }
                const devicesFromStorage = yield this.extensionSettings.getAvailableDevicesFromStorage();
                if (devicesFromStorage) {
                    return devicesFromStorage;
                }
                const synapseURL = yield this.getCallRestURL();
                const username = yield this.extensionSettings.getUserNameFromLocalDatabase();
                const callRestURL = `${synapseURL}users/${username}/endpoints`;
                const devices = yield this.apiLogic.sendRequest({
                    headers: { Authorization: `Bearer ${wardenToken}` },
                    url: callRestURL,
                });
                yield this.extensionSettings.setAvailableDevicesToStorage(devices);
                return devices;
            }
            catch (error) {
                this.logging.showErrorLog('Failed to get user\'s devices', error);
                this.errorHelper.checkForAuthError(error);
                return Promise.reject(error);
            }
        });
    }
    getPreferredDevice() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
                const synapseURL = yield this.getCallRestURL();
                const username = yield this.extensionSettings.getUserNameFromLocalDatabase();
                const callRestURL = `${synapseURL}users/${username}/endpoints/preferredUcapiAddress`;
                return yield this.apiLogic.sendRequest({
                    headers: { Authorization: `Bearer ${wardenToken}` },
                    url: callRestURL,
                });
            }
            catch (error) {
                this.logging.showErrorLog('Failed to get user\'s preferred device', error);
                this.errorHelper.checkForAuthError(error);
                return Promise.reject(error);
            }
        });
    }
    setPreferredDevice(deviceData) {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                const synapseURL = yield this.getCallRestURL();
                const username = yield this.extensionSettings.getUserNameFromLocalDatabase();
                const wardenToken = yield this.extensionSettings.getWardenTokenFromLocalDatabase();
                const callRestURL = `${synapseURL}users/${username}/endpoints/preferredUcapiAddress`;
                return yield this.apiLogic.sendRequest({
                    data: JSON.stringify(deviceData),
                    headers: {
                        'Accept': 'application/json',
                        'Authorization': `Bearer ${wardenToken}`,
                        'Content-Type': 'application/json',
                    },
                    method: 'post',
                    url: callRestURL,
                });
            }
            catch (error) {
                this.logging.showErrorLog('Failed to set user\'s preferred device', error);
                return Promise.reject(error);
            }
        });
    }
    getCallRestURL() {
        return __awaiter(this, void 0, void 0, function* () {
            const currentEnvironment = yield this.environment.get();
            return this.apiLogic.config.callRestURL[currentEnvironment];
        });
    }
}
exports.PreferredDevice = PreferredDevice;

},{"../helpers/error-helper":92,"../logging/logging":108,"./environment":135}],140:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.PreviousCustomSettings = void 0;
class PreviousCustomSettings {
    constructor(extensionSettings) {
        this.extensionSettings = extensionSettings;
        this.keys = this.extensionSettings.keys;
    }
    applyPreviousCustomSettings() {
        return __awaiter(this, void 0, void 0, function* () {
            let previousLoginData = yield this.getPreviousCustomSetting();
            // home country setting shouldn't be set with other saved data, only as a fallback for missing Synapse setting
            delete previousLoginData[this.keys.HOME_COUNTRY];
            return this.extensionSettings.setPolyfill(previousLoginData);
        });
    }
    getPreviousCustomSetting() {
        return __awaiter(this, void 0, void 0, function* () {
            let previousLoginData = yield this.extensionSettings.getPolyfill(this.keys.PREVIOUS_LOGIN_DATA);
            if (previousLoginData) {
                try {
                    previousLoginData = JSON.parse(previousLoginData);
                }
                catch (error) {
                    previousLoginData = null;
                }
            }
            return previousLoginData;
        });
    }
    savePreviousCustomSettings(savingDataKeysArray) {
        return __awaiter(this, void 0, void 0, function* () {
            const savingData = yield this.extensionSettings.getPolyfill(savingDataKeysArray);
            if (!savingData) {
                return;
            }
            return this.extensionSettings.setPolyfill(this.keys.PREVIOUS_LOGIN_DATA, JSON.stringify(savingData));
        });
    }
    getPreviousHomeCountry() {
        return __awaiter(this, void 0, void 0, function* () {
            let previousLoginData = yield this.getPreviousCustomSetting();
            const username = yield this.extensionSettings.getUserNameFromLocalDatabase();
            if (previousLoginData && (previousLoginData[this.keys.USER_NAME] === username)) {
                return previousLoginData[this.keys.HOME_COUNTRY];
            }
            return;
        });
    }
}
exports.PreviousCustomSettings = PreviousCustomSettings;

},{}],141:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Repository = void 0;
const logging_1 = require("../logging/logging");
class Repository {
    constructor(apiLogic, extensionSettings) {
        this.apiLogic = apiLogic;
        this.extensionSettings = extensionSettings;
        this.clientId = require('../constants').clientId;
        this.keys = require('../keys').keys;
        this.logging = logging_1.Logging.getInstance();
        this.domHelper = {
            buttons: {
                disable: ($button) => {
                    $button.attr('disabled', true);
                },
                enable: ($button) => {
                    $button.attr('disabled', false);
                },
                setDisablingState: ($button, disablingState) => {
                    $button.attr('disabled', disablingState);
                },
            },
            elements: {
                addHandlers: ($elementToAddingHandlers, actionToReaction, callbackHandler) => {
                    $elementToAddingHandlers.on(actionToReaction, callbackHandler);
                },
                hide: ($elementToHide, animationDuration) => {
                    $elementToHide.hide(animationDuration)
                        .css('visibility', 'hidden');
                },
                remove: ($elementToClearing) => {
                    $elementToClearing.remove();
                },
                removeHandlers: ($elementToRemovingHandlers) => {
                    $elementToRemovingHandlers.off();
                },
                setDataInside: ($elementToAddData, settingData) => {
                    $elementToAddData.html(settingData);
                },
                show: ($elementToShow, animationDuration) => {
                    $elementToShow.show(animationDuration)
                        .css('visibility', 'visible');
                },
            },
            injectStylesheetIntoTheDocument: (cssPath, stylesContainerId) => {
                if ((stylesContainerId && !$('#' + stylesContainerId).length) || !stylesContainerId) {
                    stylesContainerId = stylesContainerId || '';
                    const cssLink = (this.URLHelper.getProtocolPartOfURL(cssPath)) ? (cssPath) :
                        (this.apiLogic.getExtensionFilePath(cssPath));
                    const stylesheetElement = document.createElement('link');
                    stylesheetElement.id = stylesContainerId;
                    stylesheetElement.setAttribute('rel', 'stylesheet');
                    stylesheetElement.setAttribute('type', 'text/css');
                    stylesheetElement.setAttribute('href', cssLink);
                    $('head').append(stylesheetElement);
                }
            },
        };
        this.browserRepository = {
            getBrowserName: () => {
                return this.apiLogic.getPlatform();
            },
            isChrome: () => {
                return (this.apiLogic.getPlatform() === 'Chrome');
            },
        };
        this.osRepository = {
            getCurrentOs: () => {
                return this.apiLogic.getOS();
            },
        };
        this.tabsRepository = {
            closeAuthorisationTab: (finalLoginPageUrl) => {
                this.apiLogic.closeAuthorisationTab(finalLoginPageUrl);
            },
            executeFileScript: this.apiLogic.executeFileScript,
            getActiveTab: this.apiLogic.getActiveTab,
            getActiveUrl: (callback) => {
                this.apiLogic.getActiveTab((tabInfo) => {
                    if (tabInfo && typeof tabInfo === 'object') {
                        if (Array.isArray(tabInfo)) {
                            if (tabInfo[0]) {
                                callback(tabInfo[0].url);
                            }
                            else {
                                callback();
                            }
                        }
                        else {
                            callback(tabInfo.tabUrl || tabInfo.tabURL);
                        }
                    }
                    else {
                        callback();
                    }
                });
            },
            openLinkInNewTab: (url) => {
                this.apiLogic.openLinkInNewTab(url);
            },
            openURLInPopup: (url) => {
                this.apiLogic.openURLInTab(url);
            },
        };
        this.timerRepository = {
            clearTimeout: (intervalId) => {
                this.apiLogic.clearTimeout(intervalId);
            },
            setTimeout: (callback, delay) => {
                this.apiLogic.setTimeout(callback, delay);
            },
        };
        this.browserActionRepository = {
            closePopup: () => {
                this.apiLogic.closePopupOnBrowserAction();
            },
            reactOnBrowserActionClick: (settings) => {
                const reactionOnBrowserActionClick = settings.reactionOnBrowserActionClick;
                this.apiLogic.reactOnBrowserActionClick(() => __awaiter(this, void 0, void 0, function* () {
                    if (typeof reactionOnBrowserActionClick === 'function') {
                        reactionOnBrowserActionClick();
                    }
                    this.apiLogic.setPopupOnBrowserAction('');
                    if (!(yield this.extensionSettings.getTheFirstInstallationStatus())) {
                        this.apiLogic.setPopupOnBrowserAction('html/popup.html');
                    }
                }));
            },
            setBrowserActionIcon: (iconPath) => {
                this.apiLogic.setResourceIconOnBrowserAction(iconPath);
            },
        };
        this.URLHelper = {
            isSalesForceDomain: () => {
                const regex = /(http|https):\/\/(.*).lightning.force.com/;
                const regexObj = RegExp(regex);
                let url = this.URLHelper.getDomainPartOfURL(this.windowRepository.getCurrentURL());
                return regexObj.test(url);
            },
            isFuzeAppDomain: () => {
                const regex = /(http|https):\/\/(.*)web.fuze.com/gm;
                const regexObj = RegExp(regex);
                let url = this.URLHelper.getDomainPartOfURL(this.windowRepository.getCurrentURL());
                return regexObj.test(url);
            },
            isTeamsIntegrationsAppDomain: () => {
                const regex = /(http|https):\/\/(.*)teamsbot(.*).fuze.com/;
                const regexObj = RegExp(regex);
                let url = this.URLHelper.getDomainPartOfURL(this.windowRepository.getCurrentURL());
                return regexObj.test(url);
            },
            getDomainPartOfURL: (url) => {
                return (this.URLHelper.getProtocolPartOfURL(url) +
                    this.URLHelper.getURLPartWithoutProtocol(url).split('/')[0].split('?')[0]);
            },
            getHashPartOfURL: (url) => {
                const urlParts = url.split('#');
                let hashPart = '';
                urlParts.shift();
                if (urlParts.length) {
                    hashPart = urlParts.join('#');
                }
                return hashPart;
            },
            getProtocolPartOfURL: (url) => {
                return (url && (url.split('//')[0] !== url)) ? (url.split('//')[0] + '//') : ('');
            },
            getSearchPartOfURL: (url) => {
                return (url.split('?')[1]);
            },
            getURLPartWithoutProtocol: (url) => {
                return (url) ? (url.split(this.URLHelper.getProtocolPartOfURL(url)).join('')) : ('');
            },
            isSubdomainOfTheDomain: (verifiableDomain, parentDomain) => {
                if (this.URLHelper.getProtocolPartOfURL(verifiableDomain) ===
                    this.URLHelper.getProtocolPartOfURL(parentDomain)) {
                    const verifiableDomainWithoutProtocol = this.URLHelper.getURLPartWithoutProtocol(verifiableDomain);
                    const parentDomainWithoutProtocol = this.URLHelper.getURLPartWithoutProtocol(parentDomain);
                    if (verifiableDomainWithoutProtocol === parentDomainWithoutProtocol) {
                        return true;
                    }
                    if ((new RegExp(parentDomainWithoutProtocol).test(verifiableDomainWithoutProtocol))) {
                        const subdomainPart = verifiableDomainWithoutProtocol.split(parentDomainWithoutProtocol).join('');
                        if (subdomainPart[subdomainPart.length - 1] === '.') {
                            return true;
                        }
                    }
                }
                return false;
            },
        };
        this.cookieRepository = {
            getCookie: (options, callback) => {
                const getCookie = this.apiLogic.getCookie(options, callback);
                if (getCookie instanceof Promise) {
                    return this.apiLogic.getCookie(options, null);
                }
            },
            setCookie: (options) => {
                this.apiLogic.setCookie(options, null);
            },
        };
        this.windowRepository = {
            addEventListener: (event, eventListener, optionalParams) => {
                window.addEventListener(event, eventListener, optionalParams);
            },
            changeCurrentPageUrl: (url) => {
                window.location.href = url;
            },
            closeAuthorisationTab: (page) => {
                this.apiLogic.sendCloseWindowMessageAfterSuccessfulLogin(page);
            },
            get: (key) => {
                return window[key];
            },
            getCurrentURL: () => {
                return window.location.href;
            },
            set: (key, value) => {
                window[key] = value;
            },
        };
        this.getUILanguage = () => {
            return this.apiLogic.getUILanguage().split('-')[0];
        };
        this.addOnInstalledEventMessageListener = (callback) => {
            this.apiLogic.addOnInstalledEventMessageListener(callback);
        };
        this.getOldCredentials = (key, callback) => {
            this.apiLogic.getDataFromChromeSyncStorage(key, callback);
        };
        this.version = apiLogic.getVersion();
        this.browserVersionNumber = apiLogic.getBrowserVersionNumber();
        this.extensionName = apiLogic.extensionName;
        this.currentPlatform = apiLogic.currentPlatform;
    }
}
exports.Repository = Repository;

},{"../constants":70,"../keys":102,"../logging/logging":108}],142:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Resources = void 0;
class Resources {
    constructor(settings, apiLogic) {
        this.apiLogic = apiLogic;
        this.clickToCallButton = settings.clickToCallButton || '';
    }
    getIcon() {
        return this.apiLogic.getImage(this.clickToCallButton);
    }
    getExtensionFilePath(pathToFile) {
        return this.apiLogic.getExtensionFilePath(pathToFile);
    }
}
exports.Resources = Resources;

},{}],143:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-for-browser-extension-sign-in-menu">\n    <div class="fuze-for-browser-extension-sign-in-menu__extension-name">\n        <div class="fuze-for-browser-extension-sign-in-menu__title fuze-for-browser-extension-popup-menu__extension-name">\n            Fuze for browser\n        </div>\n    </div>\n    <div class="fuze-for-browser-extension-sign-in-menu__send-feedback-button"></div>\n    <div class="fuze-for-browser-extension-notification-0-column__close-button"></div>\n    <div class="fuze-for-browser-extension-sign-in-menu__info">\n        <h2 class="fuze-for-browser-extension-sign-in-menu__welcome">\n            <span data-i18next="FUZELOC_welcome_welcomeTo">Welcome to </span><br/>\n            <span class="fuze-for-browser-extension-sign-in-menu__extension-name fuze-for-browser-extension-popup-menu__extension-name">Fuze for browser</span>\n        </h2>\n        <p class="fuze-for-browser-extension-sign-in-menu__description" data-i18next="FUZELOC_welcome_pleaseSignIn">\n            Please sign-in to get started\n        </p>\n        <div class="fuze-for-browser-extension-sign-in-menu__state">\n            <div class="fuze-for-browser-extension-sign-in-menu__spinner"></div>\n            <button class="fuze-for-browser-extension-sign-in-menu__sign-in-button" data-i18next="FUZELOC_welcome_signIn">Sign in\n            </button>\n        </div>\n    </div>\n</div>';

},{}],144:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-for-browser-extension-notification-wrapper">\n    <div class="fuze-for-browser-extension-notification fuze-for-browser-extension__sign-in-status">\n        <div class="fuze-for-browser-extension-notification__0-row">\n            <div class="fuze-for-browser-extension-notification-0-column__close-button"></div>\n        </div>\n        <div class="fuze-for-browser-extension-notification__content-wrapper">\n            <img class="fuze-for-browser-extension-notification__image"/>\n            <p class="fuze-for-browser-extension-notification-2-row__title fuze-for-browser-extension-notification__title">\n                Welcome to Fuze for Chrome</p>\n        </div>\n    </div>\n</div>';

},{}],145:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const extension_initializer_class_1 = require("./extension-initializer-class");
const teams_click_to_call_manager_1 = require("./click-to-call/teams-click-to-call-manager");
const mutation_observer_base_1 = require("./mutation-observer-base");
const credentials_1 = require("./repository/credentials");
const dialling_modal_1 = require("./dialling-modal");
const message_manager_1 = require("./message-manager");
const phone_number_parse_and_email_observer_1 = require("./click-to-call/phone-number-parse-and-email-observer");
const phone_number_parsing_manager_1 = require("./click-to-call/phone-number-parsing-manager");
const old_chrome_credentials_manager_1 = require("./old-chrome-credentials-manager");
const tooltip_manager_1 = require("./tooltip-manager");
const date_finder_in_phone_number_helper_1 = require("./helpers/date-finder-in-phone-number-helper");
const content_script_on_installed_manager_1 = require("./the-first-sign-in/content-script-on-installed-manager");
const sign_in_notifications_manager_1 = require("./notifications/sign-in-notifications-manager");
const home_country_notification_manager_1 = require("./notifications/home-country-notification-manager");
const dropdown_manager_1 = require("./dropdown-manager");
const notification_manager_1 = require("./notifications/notification-manager");
const preferredDevice_1 = require("./repository/preferredDevice");
class TeamsCall extends extension_initializer_class_1.default {
    constructor() {
        super();
    }
    startExtension() {
        return __awaiter(this, void 0, void 0, function* () {
            const browserRepository = this.repository.browserRepository;
            const phoneNumberRegularExpression = this.regexpManager.generateRegex(this.constants.clickToCall.minimumPossiblePhoneNumberLength, this.constants.clickToCall.maximumPossiblePhoneNumberLength);
            const formSignInViewNotification = () => {
                const view = $(this.signInNotificationView).prepend(this.signInView);
                return view[0].outerHTML;
            };
            this.contentScriptExtensionInstallationManager = new content_script_on_installed_manager_1.ContentScriptExtensionInstallationManager({
                getTheFirstInstallationStatus: () => {
                    return this.extensionSettings.getTheFirstInstallationStatus();
                },
                getIsUserLoggedIn: () => {
                    return this.extensionSettings.getIsUserLoggedIn();
                },
                extensionName: this.repository.extensionName,
                setTheFirstInstallationStatus: (isFirstInstallation) => {
                    return this.extensionSettings.setTheFirstInstallationStatus(isFirstInstallation);
                },
                destroy: () => {
                    this.contentScriptExtensionInstallationManager = null;
                },
                notification: new sign_in_notifications_manager_1.SignInStatusNotification({
                    localizationLanguageManager: this.localizationLanguageManager,
                    doesExistCloseButton: true,
                    doesExistConfirmButton: true,
                    currentPlatform: this.repository.currentPlatform,
                    notificationView: formSignInViewNotification(),
                    TooltipManager: tooltip_manager_1.TooltipManager,
                    resourcesRepository: this.resourcesRepository,
                    uniqueNotificationClass: '.fuze-for-browser-extension-sign-in-menu',
                }),
            }, this.message);
            this.homeCountryNotificationManager = new home_country_notification_manager_1.HomeCountryNotificationManager({
                localizationLanguageManager: this.localizationLanguageManager,
                arrowImagePath: this.constants.images.arrowImagePath,
                activeArrowImagePath: this.constants.images.activeArrowImagePath,
                defaultHomeCountryISO: this.constants.homeCountry.default,
                countryManager: this.countryManager,
                notificationView: this.homeCountryView,
                resourcesRepository: this.resourcesRepository,
                DropdownManager: dropdown_manager_1.DropdownManager,
            }, this.extensionSettings, this.message);
            const unresponsivePageNotification = new notification_manager_1.NotificationManager({
                localizationLanguageManager: this.localizationLanguageManager,
                notificationView: this.notificationExtensionView,
                resourcesRepository: this.resourcesRepository,
                onConfirmHandler: () => {
                    this.message.sendMessageToBackground({ action: 'addDomainToIgnoreList' });
                },
                confirmButtonTextKey: 'FUZELOC_generic_disableFuze',
                notificationTitleKey: 'FUZELOC_notification_disableFuzeOnPage',
                notificationDescriptionKey: 'FUZELOC_notification_disableFuzeInfo',
                doesExistConfirmButton: true,
                doesExistCancelButton: true,
                uniqueNotificationClass: 'fuze-for-browser-extension-unresponsive-page-notification-wrapper',
            });
            this.detectExtensionConflict.activePageInitializer();
            const currentEnvironment = yield this.initializeAndGetCurrentEnvironment();
            const preferredDevice = new preferredDevice_1.PreferredDevice(this.apiLogic, this.extensionSettings);
            this.extension = new teams_click_to_call_manager_1.TeamsClickToCallManager({
                MutationObserverBase: mutation_observer_base_1.MutationObserverBase,
                homeCountryNotificationManager: this.homeCountryNotificationManager,
                localizationLanguageManager: this.localizationLanguageManager,
                credentialsRepository: new credentials_1.Credentials('Bearer ' + this.config.applicationToken[currentEnvironment], this.config.wardenRestServiceUrl[currentEnvironment], this.apiLogic),
                browserManager: this.repository.browserRepository,
                extensionName: this.repository.extensionName,
                getCallRestURL: () => {
                    return this.getApiEndpoint('callRestURL');
                },
                diallingModal: new dialling_modal_1.DiallingModal({
                    localizationLanguageManager: this.localizationLanguageManager,
                    domHelper: this.domHelper,
                    MessageManager: message_manager_1.MessageManager,
                    messageHidingDelayTime: this.messageHidingDelayTime,
                    messageHidingDurationTime: this.messageHidingDurationTime,
                    minDelayTime: this.minDelayTime,
                    timerRepository: this.repository.timerRepository,
                    resourcesRepository: this.resourcesRepository,
                    dialingDialogTimeout: 4000,
                    preferreDeviceTypeForOthers: this.constants.preferredDeviceTypesList.other,
                }, this.message),
                domainsManager: this.domainsManager,
                disabledDomains: this.constants.disabledDomains,
                getOldCredentials: this.repository.getOldCredentials,
                isChrome: browserRepository.isChrome(),
                messageManager: this.messageManager,
                PhoneNumberParseAndEmailObserver: phone_number_parse_and_email_observer_1.PhoneNumberParseAndEmailObserver,
                PhoneNumberParsingManager: phone_number_parsing_manager_1.PhoneNumberParsingManager,
                googleLibphonenumber: this.googleLibphonenumber,
                phoneNumberRegularExpression,
                timerRepository: this.repository.timerRepository,
                resourcesRepository: this.resourcesRepository,
                OldChromeCredentialsManager: old_chrome_credentials_manager_1.OldChromeCredentialsManager,
                TooltipManager: tooltip_manager_1.TooltipManager,
                URLHelper: this.URLHelper,
                windowRepository: this.windowRepository,
                dateFinderInPhoneNumberHelper: new date_finder_in_phone_number_helper_1.DateFinderInPhoneNumberHelper({
                    dateRegexList: this.regularExpressions.dateRegexList,
                    phoneNumberRE: phoneNumberRegularExpression,
                }),
                minimumPossiblePhoneNumberLength: this.constants.clickToCall.minimumPossiblePhoneNumberLength,
                unresponsivePageNotification,
                maxCharacterCountForParsing: this.constants.maxCharacterCountForParsing,
                preferredDeviceHelper: this.preferredDeviceHelper,
                clickToCallIgnoredList: this.clickToCallIgnoredList.selectors,
                keys: this.keys,
                calendarDomElementCharacteristics: this.calendarDomElementCharacteristics,
                checkIframeRestriction: this.checkIframeRestriction.bind(this),
            }, this.apiLogic, this.extensionSettings, preferredDevice, this.message);
            this.extension.initialize();
        });
    }
    getEntitlementForExtension() {
        return __awaiter(this, void 0, void 0, function* () {
            try {
                if (!(yield this.extensionSettings.getUserNameFromLocalDatabase())) {
                    return { entitlementForMeeting: false };
                }
                let entitlementForMeeting = yield this.extensionSettings.getEntitlementForMeetingFromStorage();
                if (typeof entitlementForMeeting !== 'undefined') {
                    entitlementForMeeting = (entitlementForMeeting.toString() === 'true');
                    return { entitlementForMeeting };
                }
                else {
                    this.message.sendMessageToBackground({ action: 'getEntitlementForClickToCall' });
                    return { entitlementForMeeting: false };
                }
            }
            catch (e) {
                Promise.reject(e);
            }
        });
    }
    initialize(settings) {
        settings.startExtension();
    }
}
exports.default = TeamsCall;

},{"./click-to-call/phone-number-parse-and-email-observer":66,"./click-to-call/phone-number-parsing-manager":67,"./click-to-call/teams-click-to-call-manager":68,"./dialling-modal":75,"./dropdown-manager":76,"./extension-initializer-class":80,"./helpers/date-finder-in-phone-number-helper":90,"./message-manager":119,"./mutation-observer-base":122,"./notifications/home-country-notification-manager":124,"./notifications/notification-manager":125,"./notifications/sign-in-notifications-manager":126,"./old-chrome-credentials-manager":128,"./repository/credentials":134,"./repository/preferredDevice":139,"./the-first-sign-in/content-script-on-installed-manager":147,"./tooltip-manager":149}],146:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-for-browser-extension__the-first-sign-in fuze-for-browser-extension-notification-wrapper"></div>';

},{}],147:[function(require,module,exports){
"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.ContentScriptExtensionInstallationManager = void 0;
const iframe_helper_1 = require("../helpers/iframe-helper");
class ContentScriptExtensionInstallationManager {
    constructor(settings, message) {
        this.settings = settings;
        this.message = message;
        this.initialize();
    }
    addListenerForNotificationRemoving() {
        this.message.addMessageListenerThatCalledOnce((message) => {
            if (message) {
                switch (message.action) {
                    case 'removeSignInNotificationIfExist':
                        this.settings.notification.hide();
                        break;
                    default:
                        break;
                }
            }
        });
    }
    setBrowserName() {
        const that = this;
        const $extensionTitle = $('.fuze-for-browser-extension-popup-menu__extension-name');
        $extensionTitle.each(function () {
            $(this).text(that.settings.extensionName);
        });
    }
    initialize() {
        return __awaiter(this, void 0, void 0, function* () {
            if (iframe_helper_1.isIframeRuntime()) {
                return;
            }
            const isUserLoggedIn = yield this.settings.getIsUserLoggedIn();
            if (isUserLoggedIn) {
                // if a user signed in on the add-ons page
                this.settings.notification.hide();
                this.settings.notification = null;
                return this.settings.destroy();
            }
            if (yield this.settings.getTheFirstInstallationStatus()) {
                // set isTheFirstInstallation as expired and show notification
                yield this.settings.setTheFirstInstallationStatus(false);
                this.settings.notification.show();
                this.setBrowserName();
                this.addListenerForNotificationRemoving();
            }
            else {
                this.settings.notification.hide();
                this.settings.notification = null;
                this.settings.destroy();
            }
        });
    }
}
exports.ContentScriptExtensionInstallationManager = ContentScriptExtensionInstallationManager;

},{"../helpers/iframe-helper":94}],148:[function(require,module,exports){
'use strict';
module.exports = '<div class="fuze-for-browser-extension-notification-wrapper">\n    <div class="fuze-for-browser-extension-notification fuze-for-browser-extension__sign-in-is-possible-be-later">\n        <div class="fuze-for-browser-extension-notification__0-row">\n            <div class="fuze-for-browser-extension-notification-0-column__close-button"></div>\n        </div>\n        <div class="fuze-for-browser-extension-notification__content-wrapper">\n            <div class="fuze-for-browser-extension-sign-in-notification__2-row fuze-for-browser-extension__sign-in-later">\n                <p class="fuze-for-browser-extension-notification-2-row__title\n                fuze-for-browser-extension-notification__title" data-i18next="FUZELOC_welcome_signInLater">\n                    To <span\n                        class="fuze-for-browser-extension-notification-2-row__title\n                        fuze-for-browser-extension-notification__title">sign in</span> later, </p>\n\n                <div class="fuze-for-browser-extension-notification__1-row">\n                    <img class="fuze-for-browser-extension-notification-1-row__logo\n                    fuze-for-browser-extension-notification__image"/>\n                </div>\n\n                <p class="fuze-for-browser-extension-notification-2-row__description fuze-for-browser-extension-notification__description"\n                   data-i18next="FUZELOC_welcome_clickFuzeLogo">\n                    click the Fuze logo\n                </p>\n            </div>\n        </div>\n    </div>\n</div>';

},{}],149:[function(require,module,exports){
"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.TooltipManager = void 0;
class TooltipManager {
    constructor(settings) {
        this.settings = settings;
        this.injectedHTML = '<a class=\'' + settings.tooltipClass + '__tooltip\'></a>' +
            '<span class=\'' + settings.tooltipClass + '__tooltip-arrow\'></span>';
        if (this.settings.$placeToInject.find('.' + settings.tooltipClass).length !== 0) {
            const $tooltip = $('.' + this.settings.tooltipClass + '__tooltip');
            const $tooltipArrow = $('.' + this.settings.tooltipClass + '__tooltip-arrow');
            $tooltip.remove();
            $tooltipArrow.remove();
        }
        this.settings.$placeToInject.append(this.injectedHTML);
        this.$tooltip = $(`.${this.settings.tooltipClass}__tooltip`);
        this.$tooltipArrow = $(`.${this.settings.tooltipClass}__tooltip-arrow`);
    }
    initialize(settings) {
        // add handlers
        this.elementToAction = settings.elementToAction;
        this.setTooltipText = settings.setTooltipText;
        this.addHandlers();
    }
    destroy() {
        const that = this;
        that.$tooltip.remove();
        that.$tooltipArrow.remove();
    }
    setCss($element, settings) {
        $element.css(settings);
    }
    initializeValue(value) {
        return (!value) ? 0 : value;
    }
    getElementWidth(element) {
        return this.initializeValue(parseInt(element.css('width')));
    }
    getElementHeight(element) {
        return this.initializeValue(parseInt(element.css('height')));
    }
    onMouseMoveHandler(settings) {
        const that = this;
        if (typeof this.setTooltipText === 'function') {
            this.$tooltip.text(that.setTooltipText.call(settings.thisElementToAction));
        }
        const bodyWidth = this.getElementWidth($('body'));
        const tooltipHeight = this.getElementHeight(that.$tooltip);
        const tooltipWidth = this.getElementWidth(that.$tooltip);
        const elementWidth = this.getElementWidth($(settings.thisElementToAction));
        const tooltipArrowHeight = this.getElementHeight(that.$tooltipArrow);
        let offset = $(settings.thisElementToAction).offset();
        const pageX = this.initializeValue(parseInt(settings.mouseEvent.pageX));
        const clientY = this.initializeValue(parseInt(settings.mouseEvent.clientY));
        offset = (!offset) ? ({ top: 0, left: 0 }) : offset;
        const tooltipLeft = offset.left + (elementWidth - tooltipWidth) / 2;
        let tooltipTop = 0;
        let tooltipArrowTop = 0;
        if (2 * tooltipHeight > clientY) {
            tooltipTop = offset.top + tooltipHeight / 2;
            tooltipArrowTop = tooltipTop;
        }
        else {
            tooltipTop = offset.top - (tooltipHeight + tooltipArrowHeight);
            tooltipArrowTop = tooltipTop + tooltipHeight;
        }
        const tooltipsRules = { top: `${tooltipTop}px` };
        if ((tooltipLeft > 0) && ((tooltipLeft + tooltipWidth) < bodyWidth)) {
            tooltipsRules.left = `${tooltipLeft}px`;
        }
        else {
            tooltipsRules.right = `0px`;
        }
        const tooltipArrowRules = { left: pageX + 'px', top: tooltipArrowTop + 'px' };
        this.setCss(that.$tooltip, tooltipsRules);
        this.setCss(that.$tooltipArrow, tooltipArrowRules);
    }
    show() {
        this.$tooltip.show();
        this.$tooltipArrow.show();
    }
    hide() {
        this.$tooltip.hide();
        this.$tooltipArrow.hide();
    }
    addHandlers() {
        const that = this;
        if (that.elementToAction) {
            that.elementToAction.addEventListener('mousemove', (event) => {
                that.onMouseMoveHandler({
                    mouseEvent: event,
                    thisElementToAction: event.target,
                });
            });
            that.elementToAction.addEventListener('mouseover', () => {
                that.show();
            });
            that.elementToAction.addEventListener('mouseout', () => {
                that.hide();
            });
        }
    }
}
exports.TooltipManager = TooltipManager;

},{}],150:[function(require,module,exports){
module.exports={
  "version": "121.11102.11325.0"
}
},{}]},{},[81]);
